START TRANSACTION;

ALTER TABLE tevent_filter ADD private_filter_user text NULL;
ALTER TABLE `ttrap` ADD COLUMN `utimestamp` INT UNSIGNED NOT NULL DEFAULT 0;

UPDATE ttrap SET utimestamp=UNIX_TIMESTAMP(timestamp);

CREATE TABLE IF NOT EXISTS `tlog_alert` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` TEXT ,
  `description` MEDIUMTEXT,
  `order` INT UNSIGNED DEFAULT 0,
  `mode` ENUM('PASS','DROP'),
  `field1` TEXT ,
  `field2` TEXT ,
  `field3` TEXT ,
  `field4` TEXT ,
  `field5` TEXT ,
  `field6` TEXT ,
  `field7` TEXT ,
  `field8` TEXT ,
  `field9` TEXT ,
  `field10` TEXT ,
  `time_threshold` INT NOT NULL DEFAULT 86400,
  `max_alerts` INT UNSIGNED NOT NULL DEFAULT 1,
  `min_alerts` INT UNSIGNED NOT NULL DEFAULT 0,
  `time_from` time DEFAULT '00:00:00',
  `time_to` time DEFAULT '00:00:00',
  `monday` TINYINT DEFAULT 1,
  `tuesday` TINYINT DEFAULT 1,
  `wednesday` TINYINT DEFAULT 1,
  `thursday` TINYINT DEFAULT 1,
  `friday` TINYINT DEFAULT 1,
  `saturday` TINYINT DEFAULT 1,
  `sunday` TINYINT DEFAULT 1,
  `recovery_notify` TINYINT DEFAULT 0,
  `field1_recovery` TEXT,
  `field2_recovery` TEXT,
  `field3_recovery` TEXT,
  `field4_recovery` TEXT,
  `field5_recovery` TEXT,
  `field6_recovery` TEXT,
  `field7_recovery` TEXT,
  `field8_recovery` TEXT,
  `field9_recovery` TEXT,
  `field10_recovery` TEXT,
  `id_group` MEDIUMINT UNSIGNED NULL DEFAULT 0,
  `internal_counter` INT DEFAULT 0,
  `last_fired` BIGINT NOT NULL DEFAULT 0,
  `last_reference` BIGINT NOT NULL DEFAULT 0,
  `times_fired` INT NOT NULL DEFAULT 0,
  `disabled` TINYINT DEFAULT 0,
  `standby` TINYINT DEFAULT 0,
  `priority` TINYINT DEFAULT 0,
  `force_execution` TINYINT DEFAULT 0,
  `group_by` enum ('','id_agente','id_agentmodule','id_alert_am','id_grupo') DEFAULT '',
  `special_days` TINYINT DEFAULT 0,
  `disable_event` TINYINT DEFAULT 0,
  `id_template_conditions` INT UNSIGNED NOT NULL DEFAULT 0,
  `id_template_fields` INT UNSIGNED NOT NULL DEFAULT 0,
  `last_evaluation` BIGINT NOT NULL DEFAULT 0,
  `pool_occurrences` INT UNSIGNED NOT NULL DEFAULT 0,
  `schedule` TEXT,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=UTF8MB4;

CREATE TABLE IF NOT EXISTS `tlog_rule` (
  `id_log_rule` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_log_alert` INT UNSIGNED NOT NULL,
  `operation` ENUM('NOP', 'AND','OR','XOR','NAND','NOR','NXOR'),
  `order` INT UNSIGNED DEFAULT 0,
  `window` INT NOT NULL DEFAULT 0,
  `count` INT NOT NULL DEFAULT 1,
  `name` TEXT,
  `log_content` TEXT,
  `log_source` TEXT,
  `log_agent` TEXT,
  `operator_log_content` TEXT COMMENT 'Operator for log_content',
  `operator_log_source` TEXT COMMENT 'Operator for log_source',
  `operator_log_agent` TEXT COMMENT 'Operator for log_agent',
  PRIMARY KEY  (`id_log_rule`),
  KEY `idx_id_log_alert` (`id_log_alert`)
) ENGINE=InnoDB DEFAULT CHARSET=UTF8MB4;

CREATE TABLE IF NOT EXISTS `tlog_alert_action` (
  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_log_alert` INT UNSIGNED NOT NULL,
  `id_alert_action` INT UNSIGNED NOT NULL,
  `fires_min` INT UNSIGNED DEFAULT 0,
  `fires_max` INT UNSIGNED DEFAULT 0,
  `module_action_threshold` INT NOT NULL DEFAULT 0,
  `last_execution` BIGINT NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  FOREIGN KEY (`id_log_alert`) REFERENCES tlog_alert(`id`)
    ON DELETE CASCADE ON UPDATE CASCADE,
  FOREIGN KEY (`id_alert_action`) REFERENCES talert_actions(`id`)
    ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=UTF8MB4;

CREATE TABLE IF NOT EXISTS `tgraph_analytics_filter` (
`id` INT NOT NULL auto_increment,
`filter_name` VARCHAR(45) NULL,
`user_id` VARCHAR(255) NULL,
`graph_modules` TEXT NULL,
`interval` INT NULL,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=UTF8MB4;

CREATE TABLE IF NOT EXISTS `tconfig_os_version` (
  `id_os_version` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `product` TEXT,
  `version` TEXT,
  `end_of_support` VARCHAR(10) DEFAULT NULL,
  PRIMARY KEY  (`id_os_version`)
) ENGINE=InnoDB DEFAULT CHARSET=UTF8MB4;

ALTER TABLE `tusuario` MODIFY COLUMN `integria_user_level_pass` TEXT;

DROP TABLE `tincidencia`;
DROP TABLE `tnota`;
DROP TABLE `tattachment`;

ALTER TABLE `talert_commands` ADD CONSTRAINT UNIQUE (`name`);

ALTER TABLE `talert_actions` MODIFY COLUMN `name` VARCHAR(500);
ALTER TABLE `talert_actions` ADD CONSTRAINT UNIQUE (`name`);

SET @command_name = 'Pandora&#x20;ITSM&#x20;Ticket';
SET @command_description = 'Create&#x20;a&#x20;ticket&#x20;in&#x20;Pandora&#x20;ITSM';
SET @action_name = 'Create&#x20;Pandora&#x20;ITSM&#x20;ticket';

UPDATE `talert_commands` SET `name` = @command_name, `description` = @command_description WHERE `name` = 'Integria&#x20;IMS&#x20;Ticket' AND `internal` = 1;
INSERT IGNORE INTO `talert_commands` (`name`, `command`, `description`, `internal`, `fields_descriptions`, `fields_values`) VALUES (@command_name,'Internal&#x20;type',@command_description,1,'["Ticket&#x20;title","Ticket&#x20;group&#x20;ID","Ticket&#x20;priority","Ticket&#x20;owner","Ticket&#x20;type","Ticket&#x20;status","Ticket&#x20;description","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_"]','["", "_ITSM_groups_", "_ITSM_priorities_","_ITSM_users_","_ITSM_types_","_ITSM_status_","_html_editor_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_","_custom_field_ITSM_"]');

SELECT @id_alert_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
UPDATE `talert_actions` SET `name` = @action_name WHERE `name` = 'Create&#x20;Integria&#x20;IMS&#x20;ticket' AND `id_alert_command` = @id_alert_command;
INSERT IGNORE INTO `talert_actions` (`name`, `id_alert_command`) VALUES (@action_name,@id_alert_command);

SET @event_response_name = 'Create&#x20;ticket&#x20;in&#x20;Pandora&#x20;ITSM&#x20;from&#x20;event';
SET @event_response_description = 'Create&#x20;a&#x20;ticket&#x20;in&#x20;Pandora&#x20;ITSM&#x20;from&#x20;an&#x20;event';
SET @event_response_target = 'index.php?sec=manageTickets&amp;sec2=operation/ITSM/itsm&amp;operation=edit&amp;from_event=_event_id_';
SET @event_response_type = 'url';
SET @event_response_id_group = 0;
SET @event_response_modal_width = 0;
SET @event_response_modal_height = 0;
SET @event_response_new_window = 1;
SET @event_response_params = '';
SET @event_response_server_to_exec = 0;
SET @event_response_command_timeout = 90;
SET @event_response_display_command = 1;
UPDATE `tevent_response` SET `name` = @event_response_name, `description` = @event_response_description, `target` = @event_response_target, `display_command` = @event_response_display_command WHERE `name` = 'Create&#x20;ticket&#x20;in&#x20;IntegriaIMS&#x20;from&#x20;event';
INSERT IGNORE INTO `tevent_response` (`name`, `description`, `target`,`type`,`id_group`,`modal_width`,`modal_height`,`new_window`,`params`,`server_to_exec`,`command_timeout`,`display_command`) VALUES (@event_response_name, @event_response_description, @event_response_target, @event_response_type, @event_response_id_group, @event_response_modal_width, @event_response_modal_height, @event_response_new_window, @event_response_params, @event_response_server_to_exec, @event_response_command_timeout, @event_response_display_command);

UPDATE `twelcome_tip`
	SET title = 'Scheduled&#x20;downtimes',
         url = 'https://pandorafms.com/manual/en/documentation/04_using/11_managing_and_administration#scheduled_downtimes'
	WHERE title = 'planned&#x20;stops';

UPDATE tagente_modulo SET `tcp_send` = '2c' WHERE `tcp_send` = '2';
UPDATE tpolicy_modules SET `tcp_send` = '2c' WHERE `tcp_send` = '2';
UPDATE tnetwork_component SET `tcp_send` = '2c' WHERE `tcp_send` = '2';

ALTER TABLE tagente_modulo ADD COLUMN `made_enabled` TINYINT UNSIGNED DEFAULT 0;
ALTER TABLE tpolicy_modules ADD COLUMN `made_enabled` TINYINT UNSIGNED DEFAULT 0;

ALTER TABLE talert_templates
ADD COLUMN `time_window` ENUM ('thirty_days','this_month','seven_days','this_week','one_day','today'),
ADD COLUMN `math_function` ENUM ('avg', 'min', 'max', 'sum'),
ADD COLUMN `condition` ENUM ('lower', 'greater', 'equal'),
MODIFY COLUMN `type` ENUM ('regex', 'max_min', 'max', 'min', 'equal', 'not_equal', 'warning', 'critical', 'onchange', 'unknown', 'always', 'not_normal', 'complex');

ALTER TABLE `tsesion_filter_log_viewer`
CHANGE COLUMN `date_range` `custom_date` INT NULL DEFAULT NULL ,
CHANGE COLUMN `start_date_defined` `date` VARCHAR(45) NULL DEFAULT NULL ,
CHANGE COLUMN `start_date_time` `date_text` VARCHAR(45) NULL DEFAULT NULL ,
CHANGE COLUMN `start_date_date` `date_units` VARCHAR(45) NULL DEFAULT NULL ,
CHANGE COLUMN `start_date_date_range` `date_init` VARCHAR(45) NULL DEFAULT NULL ,
CHANGE COLUMN `start_date_time_range` `time_init` VARCHAR(45) NULL DEFAULT NULL ,
CHANGE COLUMN `end_date_date_range` `date_end` VARCHAR(45) NULL DEFAULT NULL ,
CHANGE COLUMN `end_date_time_range` `time_end` VARCHAR(45) NULL DEFAULT NULL ;

ALTER TABLE `tsesion_filter`
CHANGE COLUMN `period` `date_text` VARCHAR(45) NULL DEFAULT NULL AFTER `user`;

ALTER TABLE `tsesion_filter`
ADD COLUMN `custom_date` INT NULL AFTER `user`,
ADD COLUMN `date` VARCHAR(45) NULL AFTER `custom_date`,
ADD COLUMN `date_units` VARCHAR(45) NULL AFTER `date_text`,
ADD COLUMN `date_init` VARCHAR(45) NULL AFTER `date_units`,
ADD COLUMN `time_init` VARCHAR(45) NULL AFTER `date_init`,
ADD COLUMN `date_end` VARCHAR(45) NULL AFTER `time_init`,
ADD COLUMN `time_end` VARCHAR(45) NULL AFTER `date_end`;

INSERT INTO `tconfig_os_version` (`id_os_version`, `product`, `version`, `end_of_support`) VALUES (1,'Windows.*','7.*','2020/01/14');
INSERT INTO `tconfig_os_version` (`id_os_version`, `product`, `version`, `end_of_support`) VALUES (2,'Cisco.*','IOS 3.4.3','2017/05/12');
INSERT INTO `tconfig_os_version` (`id_os_version`, `product`, `version`, `end_of_support`) VALUES (3,'Linux.*','Centos 7.*','2022/01/01');

UPDATE `tdiscovery_apps` SET `version` = '1.1' WHERE `short_name` = 'pandorafms.vmware';

-- Insert new Proxmox APP
SET @short_name = 'pandorafms.proxmox';
SET @name = 'Proxmox';
SET @section = 'app';
SET @description = 'Monitor&#x20;Proxmox&#x20;VMs,&#x20;LXC,&#x20;backups&#x20;and&#x20;nodes&#x20;from&#x20;a&#x20;specific&#x20;host';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_proxmox');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;-g&#x20;&#039;__taskGroup__&#039;&#x20;--host&#x20;&#039;_host_&#039;&#x20;--port&#x20;&#039;_port_&#039;&#x20;--user&#x20;&#039;_user_&#039;&#x20;--password&#x20;&#039;_password_&#039;&#x20;--vm&#x20;&#039;_scanVM_&#039;&#x20;--lxc&#x20;&#039;_scanLXC_&#039;&#x20;--backups&#x20;&#039;_scanBackups_&#039;&#x20;--nodes&#x20;&#039;_scanNodes_&#039;&#x20;--transfer_mode&#x20;tentacle&#x20;--tentacle_address&#x20;&#039;_tentacleIP_&#039;&#x20;--tentacle_port&#x20;&#039;_tentaclePort_&#039;&#x20;--as_discovery_plugin&#x20;1');

-- Insert new SAP APP
SET @short_name = 'pandorafms.sap.deset';
SET @name = 'SAP&#x20;R3&#x20;-&#x20;Deset';
SET @section = 'app';
SET @description = 'Monitor&#x20;SAP&#x20;R3&#x20;environments';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_sap_deset');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_java_', 'bin/lib/jre/bin/java');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileConf_&#039;&#x20;--custom_modules&#x20;&#039;_tempfileCustomModules_&#039;');

-- Insert new EC2 APP
SET @short_name = 'pandorafms.aws.ec2';
SET @name = 'Amazon&#x20;EC2';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;AWS&#x20;EC2&#x20;instances';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_aws_ec2');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/aws_ec2');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileEC2_&#039;');

-- Insert new RDS APP
SET @short_name = 'pandorafms.aws.rds';
SET @name = 'Amazon&#x20;RDS';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;AWS&#x20;RDS&#x20;instances';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_aws_rds');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/aws_rds');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileRDS_&#039;');

-- Insert new S3 APP
SET @short_name = 'pandorafms.aws.s3';
SET @name = 'Amazon&#x20;S3';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;AWS&#x20;S3&#x20;buckets';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_aws_s3');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/aws_s3');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileS3_&#039;');

-- Insert new Azure APP
SET @short_name = 'pandorafms.azure.mc';
SET @name = 'Azure&#x20;Microsoft&#x20;Compute';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;Azure&#x20;Microsoft&#x20;Compute&#x20;VMs';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_azure_mc');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/azure_vm');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileAzureMC_&#039;');

-- Insert new Google APP
SET @short_name = 'pandorafms.gcp.ce';
SET @name = 'Google&#x20;Cloud&#x20;Compute&#x20;Engine';
SET @section = 'cloud';
SET @description = 'Monitor&#x20;Google&#x20;Cloud&#x20;Platform&#x20;Compute&#x20;Engine&#x20;VMs';
SET @version = '1.0';
INSERT IGNORE INTO `tdiscovery_apps` (`id_app`, `short_name`, `name`, `section`, `description`, `version`) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := `id_app` FROM `tdiscovery_apps` WHERE `short_name` = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec1_', 'bin/pandora_gcp_ce');
INSERT IGNORE INTO `tdiscovery_apps_scripts` (`id_app`, `macro`, `value`) VALUES (@id_app, '_exec2_', 'bin/google_instances');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO `tdiscovery_apps_executions` (`id`, `id_app`, `execution`) VALUES (1, @id_app, '&#039;_exec1_&#039;&#x20;--conf&#x20;&#039;_tempfileGoogleCE_&#039;');

-- Insert into treport_content
ALTER TABLE `treport_content`  ADD COLUMN `cat_security_hardening` INT NOT NULL DEFAULT 0;
ALTER TABLE `treport_content`  ADD COLUMN `ignore_skipped` INT NOT NULL DEFAULT 0;
ALTER TABLE `treport_content`  ADD COLUMN `status_of_check` TINYTEXT;

ALTER TABLE `tservice` ADD COLUMN `enable_horizontal_tree` TINYINT NOT NULL DEFAULT 0;

INSERT IGNORE INTO `tmodule_inventory` (`id_os`, `name`, `description`, `interpreter`, `data_format`, `code`, `block_mode`,`script_mode`) VALUES (1,'Vulnerabilities','Plugin&#x20;for&#x20;security&#x20;scan','','Package;Version;CVE','',0,2);

ALTER TABLE `tagente` ADD COLUMN `vul_scan_enabled` TINYINT NOT NULL DEFAULT 2;
ALTER TABLE `tmetaconsole_agent` ADD COLUMN  `vul_scan_enabled` TINYINT NOT NULL DEFAULT 2;

CREATE TABLE IF NOT EXISTS `tpandora_cve` (
    `cve_id` VARCHAR(20),
    `cvss_score` DOUBLE DEFAULT NULL,
    `cvss_vector` VARCHAR(255) DEFAULT NULL,
PRIMARY KEY (`cve_id`)
) ENGINE=InnoDB DEFAULT CHARSET=UTF8MB4;

INSERT INTO `tpandora_cve` VALUES
('CVE-2003-0002', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0003', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0001', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0004', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0002', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0005', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0006', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0007', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0007', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0001', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-0002', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0003', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0004', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0006', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0011', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0002', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0012', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0014', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0007', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0004', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0003', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0001', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0002', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0017', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0002', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0002', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0003', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0004', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0007', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2004-0007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0008', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0009', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0003', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2003-0021', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0022', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0018', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0005', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0020', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0024', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0006', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0007', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-0024', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0025', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0032', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0008', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0013', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0031', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0028', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0035', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0017', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0035', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0019', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0024', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0020', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0026', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0039', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0014', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0041', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0042', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0014', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0035', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0046', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0013', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0047', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0038', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0039', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0017', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0026', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-0046', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0056', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0046', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0065', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0021', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0049', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0068', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0069', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0071', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0034', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0066', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0055', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0068', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0067', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0069', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0057', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0036', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0037', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0085', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0059', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0086', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0076', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0088', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0047', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0089', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0079', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0046', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0101', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2003-0096', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2004-0068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0087', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0050', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0102', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0108', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0051', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-0074', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0108', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0064', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0052', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0006', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0004', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0007', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0002', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2003-0020', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0003', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0019', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0015', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-0017', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0004', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0008', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0022', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0021', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0022', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0023', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0014', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0025', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0030', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0013', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0028', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0029', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0009', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-0022', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-0029', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0010', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0033', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0034', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0030', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0035', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0036', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0014', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0028', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0038', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0029', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-0028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0015', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0053', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0067', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0111', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0117', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0058', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-0070', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0066', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0061', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0129', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-0076', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0097', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0117', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0082', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0127', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-0103', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0133', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0086', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-1999-0126', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0068', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0106', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0141', 4.9, 'AV:A/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-0074', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0095', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0140', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0102', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0154', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0146', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0115', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0156', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0166', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0115', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0162', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-0148', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0188', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0151', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0101', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0157', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0089', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0183', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0111', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0137', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0154', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0189', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-0185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0005', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-1999-0009', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0011', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0001', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0012', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0010', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0002', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0001', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0014', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0005', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0012', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0003', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0043', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0045', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0017', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0043', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0046', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0048', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0051', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0049', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0051', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-0020', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0047', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0048', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0054', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0055', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0056', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0031', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-0040', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0027', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0032', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2005-0049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0025', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0054', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0066', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0067', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0034', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0035', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0070', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0024', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0032', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0067', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0035', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0040', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0085', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0042', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-0060', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0091', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0042', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0144', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0124', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-0150', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0091', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-0223', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0264', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0148', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0180', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-1999-0316', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0167', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0184', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0203', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0137', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0163', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-0244', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-0167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0395', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0184', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0213', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0191', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0255', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0240', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0273', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0277', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0217', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2006-0253', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0463', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0277', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0282', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0287', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0313', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0276', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0299', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-1999-0468', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-0198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0319', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0325', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0327', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0184', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0290', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0048', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0048', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0048', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0099', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0083', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0054', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0052', 6.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2015-0109', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-0104', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0094', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2005-0097', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0112', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2003-0110', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0115', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-0116', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-0118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0120', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-0082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0105', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0123', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0114', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0096', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0130', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0081', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0118', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0119', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0090', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0140', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0131', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0131', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0133', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0069', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0144', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-0008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0018', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0023', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0006', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0023', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0020', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0021', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0008', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0023', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0009', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0008', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2003-0033', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0009', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0016', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0036', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0018', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0025', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0145', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-0165', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0082', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-0122', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0112', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0117', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0114', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2003-0202', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0135', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0174', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-0136', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0207', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0178', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0191', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0118', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0217', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0125', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0101', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0193', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-0092', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0200', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0205', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0138', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0207', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0210', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-0151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0157', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-0216', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0380', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0179', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0212', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-1999-0402', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0246', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0226', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0420', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0259', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0238', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0121', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0222', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0340', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0344', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2003-0297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0349', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0356', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0494', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0367', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0293', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0296', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0526', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0304', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0111', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0227', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0626', 0.0, 'AV:N/AC:L/Au:N/C:N/I:N/A:N'),
('CVE-2006-0363', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0366', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0126', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0409', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0281', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0449', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-0294', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0296', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0307', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0317', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0199', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0095', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0321', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0313', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-0212', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-0202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0295', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0110', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0318', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0324', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0339', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0116', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0609', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0387', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0118', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-0220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0215', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0219', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0123', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0414', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0196', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0690', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0234', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-1999-0734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0422', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2003-0343', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0770', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0244', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0153', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0245', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0494', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0212', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-0507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0264', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2005-0356', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0039', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0013', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0008', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0038', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0009', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-0017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0022', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0010', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0029', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0013', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0043', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-0045', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0012', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0036', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0048', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0014', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0018', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0050', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0039', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0040', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0042', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-1999-0759', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0355', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0771', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0774', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0135', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0785', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0155', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-0473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0481', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0801', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0240', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0365', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0244', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-0509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0278', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-0250', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0865', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0256', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0259', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-0263', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0434', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0437', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0225', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-0913', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0924', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0451', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0250', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0258', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0381', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0457', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0375', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0465', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0152', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0218', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0958', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0480', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0310', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0496', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0409', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0414', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0505', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0981', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0846', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0286', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-0854', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0258', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0373', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0226', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0238', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0148', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0267', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-1999-0930', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0532', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0459', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0385', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0951', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0263', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0478', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2004-0484', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-0225', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0266', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0412', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0417', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0272', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0561', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0507', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0273', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1005', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-0246', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0412', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0287', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-1999-1037', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0599', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0559', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0443', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-0574', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0335', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0286', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-0448', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0257', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0010', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0007', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0034', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0031', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-0030', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0032', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0010', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0011', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0011', 6.4, 'AV:A/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0012', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-1999-0993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0241', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2004-0547', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0582', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0432', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0422', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0428', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0434', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0572', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0586', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0444', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0292', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0288', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0260', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1064', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1082', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0306', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0166', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-0480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0273', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0355', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0633', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0641', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-0483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0169', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0316', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0670', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0617', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0621', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0179', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0492', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0507', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0376', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0386', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0685', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0518', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0521', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0525', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0539', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0544', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0700', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0704', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-0566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0391', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0572', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0098', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0100', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0079', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0055', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-0105', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0127', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-0128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0112', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0113', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0095', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0122', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-0130', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0125', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-0128', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-0116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0084', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0107', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0131', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0142', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0077', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0079', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2003-0160', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2004-0117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0105', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0148', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0138', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0150', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0140', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0189', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0074', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0035', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0030', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0046', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-0048', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0029', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0070', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0032', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0053', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-0058', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0078', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0070', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0038', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0041', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-0039', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0085', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-0087', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0074', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0087', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0044', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-0041', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0066', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0082', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0094', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1092', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0600', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1093', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0455', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0351', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0303', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-0649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0655', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0488', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0612', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0480', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0680', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0625', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0683', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0639', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0385', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-0514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0284', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0643', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0405', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0290', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0343', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0585', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-0591', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0265', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-0660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0668', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0675', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0724', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-0679', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0296', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0411', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0617', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0202', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0699', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0583', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0743', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0729', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0654', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0587', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0207', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-0419', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0666', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0213', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2003-0612', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0614', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0749', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0676', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0361', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0218', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0282', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0756', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0759', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0761', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0766', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0770', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-0646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0447', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0188', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0040', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0011', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0023', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0042', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0033', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0031', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0016', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0022', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2010-0015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0036', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0027', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0019', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-0041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0018', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2003-0057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0058', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0020', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-0063', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0045', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0030', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0022', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2004-0051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0031', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0039', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0052', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0039', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-0056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0079', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0032', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0043', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0035', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-0036', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0086', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-0065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0095', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0049', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0061', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0049', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0101', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0051', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0056', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0109', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0089', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0090', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0098', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0110', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-0066', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0054', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0102', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0100', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0118', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0108', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0102', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0068', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0057', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0066', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0119', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0077', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0124', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0117', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0130', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-0131', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-0123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0091', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0124', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0141', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0143', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0108', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0111', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0150', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-0095', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0143', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-0098', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0099', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0115', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0143', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0163', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0149', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0114', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0173', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0095', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0162', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0075', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0170', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0113', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2003-0209', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0180', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2007-0119', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0190', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-0193', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0120', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-0205', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0206', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0160', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0170', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0225', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0230', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0172', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0127', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0208', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0173', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0093', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0268', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2004-0180', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-0133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0183', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0187', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-0188', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0355', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0214', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0217', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0144', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0371', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-0156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0093', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0118', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0234', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0249', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0053', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0025', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0024', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0025', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0042', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0062', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0064', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0029', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0047', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0071', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0073', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0074', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0076', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0043', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0074', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0078', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-0070', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0073', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0041', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0043', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0045', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0080', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0079', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0080', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0043', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0046', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0100', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0093', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0047', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0067', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0077', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0051', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-0099', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0113', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0122', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0103', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0073', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0062', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0123', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-0077', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0072', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0129', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-0074', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0061', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0132', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0063', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0094', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0144', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0139', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0067', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0154', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0144', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-0101', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0151', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0085', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0113', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0163', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0120', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0088', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0015', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0021', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0037', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0030', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0041', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0042', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0044', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0044', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0032', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0037', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0021', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0016', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0052', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0017', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0029', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0051', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0047', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0024', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0028', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0049', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2005-0056', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0031', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0030', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0052', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0051', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0025', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0034', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0029', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0041', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0042', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-0047', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-0079', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0082', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0071', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0083', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0072', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0086', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0042', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0071', 9.2, 'AV:L/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-1999-0081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0047', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0676', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0597', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0409', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-0298', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-0544', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0730', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0186', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0560', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0306', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0330', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2004-0694', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0640', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0712', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0714', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0745', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0741', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0277', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2004-0745', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0664', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-0212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0617', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0622', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0434', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0754', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0684', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0699', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0075', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0070', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0068', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0071', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0076', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-0067', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-0089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0079', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0130', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0088', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0137', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0071', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0112', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0155', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0088', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0119', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0131', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-0124', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0123', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2003-0193', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0126', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0129', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0164', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-0133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0078', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0081', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0123', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0238', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0223', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0226', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0231', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0084', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0107', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-0086', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0062', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0095', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0077', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0114', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-0097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0084', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0060', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0107', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0129', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0124', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-0118', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0132', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0136', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-0090', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0062', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0133', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0190', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0194', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0149', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0169', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-0203', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0219', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0083', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0084', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0213', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0224', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0085', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0159', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0182', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0182', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0112', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0171', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0202', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0185', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0114', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0215', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0236', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0174', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-0149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0211', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2003-0649', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1168', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0371', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0209', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0275', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0279', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-1179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1180', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0465', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2003-0694', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0765', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0219', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-0482', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0771', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0293', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0313', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0796', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0812', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0820', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0353', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0417', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1193', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0802', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-0496', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0331', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0367', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-0807', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0225', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0837', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0340', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0344', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0819', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-0441', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0505', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-0371', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2004-0808', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0851', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0855', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0831', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0513', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0859', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0867', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0358', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0753', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0519', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-0872', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0874', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0876', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0878', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0166', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0107', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0206', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0090', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-0139', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0142', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0196', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0184', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0192', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-0201', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0147', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0122', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-0235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0151', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0187', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0232', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0221', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0259', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0272', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0105', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0278', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0162', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0231', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-0202', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-0233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0202', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0205', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0207', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0206', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0237', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0165', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0148', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0159', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2003-0241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0215', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0232', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-1999-0399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0252', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0239', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-0190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0253', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0256', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0425', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-0120', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0230', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0237', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0242', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0270', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0250', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0256', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0262', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0040', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0078', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-0090', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0046', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0073', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0099', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0094', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0103', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-0079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0081', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-0049', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0051', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0096', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0057', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0116', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0118', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0069', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0124', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0072', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0074', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0121', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0071', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-0115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0058', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0260', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0265', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-0252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0254', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0257', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0265', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0268', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0274', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0279', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0307', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0288', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0298', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2006-0303', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0471', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0315', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0321', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0183', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0315', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-0318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0200', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0285', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0288', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2003-0295', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0350', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0308', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0312', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-1999-0490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0213', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0332', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0052', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0084', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0098', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0082', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0107', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-0106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0055', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0072', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0105', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0063', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-0113', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-0114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0068', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0083', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0104', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0109', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0112', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0114', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0067', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0078', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0075', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0126', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0131', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2013-0133', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0085', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0134', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0129', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0127', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-0065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0128', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0143', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0141', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-0078', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0366', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-0707', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0718', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0192', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0729', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0733', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1170', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0375', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0214', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0398', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0299', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2004-0762', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0787', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2007-0478', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0768', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0703', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0813', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0817', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0415', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0801', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1198', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0778', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0300', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0829', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0302', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-0843', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0347', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0432', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0434', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-0438', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0443', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0449', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0231', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-0169', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-0236', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0254', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0186', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0199', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0255', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0259', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0177', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0215', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2004-0247', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0251', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0254', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0280', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0271', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0274', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0279', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0283', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0286', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0271', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0308', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0289', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0181', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0464', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0279', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0292', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0127', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0358', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0187', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0372', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0226', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-0329', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-0341', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0346', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0358', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0606', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0228', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0213', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0378', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0119', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0125', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0673', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0404', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0411', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0229', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0233', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-1999-0712', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0238', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0718', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0729', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0332', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0403', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0427', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0334', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0337', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0438', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0348', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0288', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0291', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0275', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0196', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0204', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2006-0297', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0125', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-0221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0289', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0333', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0339', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0098', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0355', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0198', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0223', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0299', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0109', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-0310', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0325', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0331', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0342', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-0341', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0347', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0604', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0377', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0379', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0208', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0225', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-0227', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2007-0218', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0670', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-0403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0227', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0680', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0415', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0691', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0325', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0329', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0235', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0432', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0202', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0754', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0347', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0445', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-1999-0766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0772', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-1999-0778', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0356', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0208', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0416', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0487', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0893', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0532', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0911', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0942', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0853', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0372', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0961', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0966', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-0337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0984', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0380', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0996', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1013', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0511', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0948', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1284', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0966', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0972', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0545', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-0986', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0861', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0874', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0387', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1005', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2004-0959', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0972', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1010', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2004-0981', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1087', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1027', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0252', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1022', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0362', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1037', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0402', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-1116', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0254', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1065', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0579', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0076', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0120', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0063', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0077', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0080', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2009-0087', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0121', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0138', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0091', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0082', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0145', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0153', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0134', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0142', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0150', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0104', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0156', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0109', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0122', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0123', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0122', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0173', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0175', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0104', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0171', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2011-0077', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0125', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0135', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0133', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0136', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0137', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0147', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0129', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0142', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2003-0155', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0099', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0100', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0149', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2003-0161', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0107', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-0110', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0129', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0116', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0072', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0157', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0181', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0098', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0099', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0192', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-0124', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0125', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0102', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0197', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0148', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0181', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0173', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0133', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0168', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2004-0152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0177', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-0143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0183', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0194', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0231', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0176', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0163', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0251', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0151', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0227', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-0196', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0201', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0135', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0234', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0343', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0201', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0141', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0210', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0209', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0196', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0094', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0111', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-0181', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-0162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0172', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-1999-0342', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0350', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0363', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0216', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-0214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0385', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0388', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0245', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0222', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0228', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0173', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0247', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0214', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-0240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0231', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0265', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0246', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0266', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0283', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0262', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0272', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-0280', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0285', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0197', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0326', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0474', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0330', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0283', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0342', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0327', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0336', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0371', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0374', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0306', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0201', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0322', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0326', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0333', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0054', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0080', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0101', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0122', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-0110', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0056', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0111', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0128', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0116', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-0069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0080', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0121', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0064', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0066', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-0122', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0137', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0078', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0120', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0072', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0148', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0066', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0113', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0111', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0086', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0087', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-0118', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0156', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-0159', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0160', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-0096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0158', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-0108', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0071', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0112', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0121', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0160', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0161', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0152', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0143', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0134', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0108', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-1999-0184', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-0165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0138', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0135', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0182', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0193', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0179', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0173', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-1999-0199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-1999-0204', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0148', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0157', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0232', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0183', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-0248', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0173', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0156', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0215', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0179', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0197', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0290', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0297', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0229', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0179', 2.9, 'AV:A/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2015-0199', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-0166', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2004-0194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0351', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-0191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0203', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0212', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-0143', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0241', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0217', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0335', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0343', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0346', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0344', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0347', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0355', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0219', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0612', 0.0, 'AV:N/AC:L/Au:N/C:N/I:N/A:N'),
('CVE-2004-0385', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0377', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0395', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0668', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0711', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0237', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0200', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0735', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0429', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0752', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0757', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0131', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0455', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0138', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0787', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0469', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0800', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0248', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0253', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0811', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0259', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-0504', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0213', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-0362', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0214', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-0517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0367', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0271', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0217', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0849', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0852', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0858', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0871', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-0891', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0369', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0901', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0911', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0922', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0452', 4.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2009-0245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0251', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-0926', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0382', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0529', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0351', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0847', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0813', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0467', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0475', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1236', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0861', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0869', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0382', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0873', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0759', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0763', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0884', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0898', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2009-0490', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0913', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-0922', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0366', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0828', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0926', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-0835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0371', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0869', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0506', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0903', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0967', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0981', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0855', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-0994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1002', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0540', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0916', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0856', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-0945', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-1279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1282', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0967', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0928', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0992', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0860', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0947', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1052', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1063', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1069', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1075', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0983', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0885', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-1030', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1043', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0990', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0896', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1003', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1099', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1009', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0449', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-0134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0458', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0791', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0405', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0140', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0146', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2006-0467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0413', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0209', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0420', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0249', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0211', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-0490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0497', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0359', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0245', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2006-0512', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0367', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0366', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0276', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-0251', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0433', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0290', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-0294', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-0297', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-1999-0882', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0223', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0902', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0916', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0374', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0454', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0253', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0371', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0379', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0303', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0531', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0458', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0460', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0381', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0221', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0475', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0965', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0487', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0393', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0492', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0401', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0407', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0399', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0422', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0506', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0236', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2004-0519', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0524', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0244', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0249', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0250', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1031', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0251', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1043', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0288', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0329', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0432', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0438', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0564', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0544', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1078', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0546', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0407', 6.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-0604', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0419', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0408', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1138', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0557', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0565', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0269', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0273', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1145', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0571', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0619', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0285', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0310', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1117', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-0402', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0427', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0579', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1168', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1323', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0582', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2005-1181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1181', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1186', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0433', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0636', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1197', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0435', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1189', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0967', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0979', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1211', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1224', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1226', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1204', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0356', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0389', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0204', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0217', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0220', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0133', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0682', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0331', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0708', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0239', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0738', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0741', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0440', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0207', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2004-0407', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-0142', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-0462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0152', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0156', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-0474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0140', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0257', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0503', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0246', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0159', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0237', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-0269', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-0273', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0275', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-0247', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0282', 4.9, 'AV:L/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-0252', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0254', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0372', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0867', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0874', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0877', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-1999-0881', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-0220', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0892', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0905', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0920', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0448', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0149', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0257', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0164', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0162', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-0239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0393', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0172', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0253', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0260', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0192', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0245', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0255', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0270', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0185', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0178', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0278', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0282', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0255', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0270', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0301', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0281', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0286', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0291', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0300', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0306', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0469', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0205', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0329', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0287', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0331', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0338', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0341', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0323', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0303', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0351', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0354', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0310', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0359', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0211', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0365', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0331', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0191', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0315', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0218', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0344', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-0113', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-0348', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0351', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0117', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0357', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0203', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0605', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0607', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0391', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0206', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0396', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0225', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0802', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0250', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0258', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0809', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0424', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0813', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0511', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-0515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0817', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0822', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0359', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2009-0215', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0268', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-0238', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-1999-0839', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0842', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0847', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0431', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0850', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0255', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-0295', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0298', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0868', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0444', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0896', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0900', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0917', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0375', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0453', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0254', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0927', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0933', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0166', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0943', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0469', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0168', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0957', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0390', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0153', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2003-0398', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0402', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0406', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0410', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0413', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0501', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-0520', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1010', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0273', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0589', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0289', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0254', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0578', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0457', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0459', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0263', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0163', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-0268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-0469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0473', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0305', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0349', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0479', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0456', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0352', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0252', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0177', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0620', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0630', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0639', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0650', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0277', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-0658', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0485', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0170', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0278', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-0669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0682', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0175', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-0169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0140', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0214', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0115', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-0189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0126', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0241', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-0253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0225', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0174', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0177', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-0230', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0200', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0113', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0146', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-0116', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0243', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0378', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0386', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0223', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0229', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0174', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0408', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0198', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0254', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0258', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0176', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0241', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0200', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0235', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0281', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0191', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0277', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0103', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0168', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-0163', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-0169', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-0076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0201', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0109', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0079', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0172', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-0213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0143', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-0121', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0216', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0247', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0201', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0172', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-0155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0216', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0098', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0276', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0232', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0183', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0198', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0186', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0346', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0364', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0208', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-0142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0147', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-0164', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-0242', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0117', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0225', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0392', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0398', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0251', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0407', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0119', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0145', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0146', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0102', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0081', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-1999-0152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0106', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-0083', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0084', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-0139', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0141', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0127', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0155', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0113', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0178', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0158', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0161', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-0169', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0174', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0196', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0131', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0129', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0175', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0151', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0211', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0080', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0178', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-0156', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0191', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0158', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0233', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0239', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0224', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0250', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0214', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0176', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0158', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0269', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0104', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0200', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0178', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-0201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0163', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0191', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0348', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0164', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-1999-0360', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0362', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0205', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0235', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0372', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0384', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0653', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0440', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1229', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1255', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0607', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1273', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1277', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1243', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1284', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1289', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0665', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1302', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0673', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1337', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1254', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0375', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-0391', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-0615', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0319', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1376', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0320', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0435', 6.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-0688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1372', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1426', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1105', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2003-1111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0435', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0439', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0445', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0472', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-1146', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0490', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0501', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1449', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2003-1175', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1463', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0264', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0490', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0400', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0408', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0421', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0504', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0274', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-1011', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0536', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1019', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0271', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0282', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0417', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0278', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0600', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0326', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0612', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-0161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0446', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0438', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-0455', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0294', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0298', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0461', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0264', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0250', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-0302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0527', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1023', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1059', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-0568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1055', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0363', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-0583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0370', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0256', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0376', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0379', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0543', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0395', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-1079', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0407', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0416', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-0607', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0936', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1136', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0554', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0559', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0262', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0617', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0409', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1151', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0286', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0310', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1097', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1114', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1138', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0626', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-1161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1325', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0947', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1177', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1180', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1196', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0434', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1190', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1209', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1219', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0437', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0646', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-0416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1340', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0650', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0654', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0595', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-1003', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-1016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0601', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1265', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0352', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-1275', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1249', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1295', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1300', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0330', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0197', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0199', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0725', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2004-0401', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0733', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0421', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0737', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0442', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0444', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0132', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-0138', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0476', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0484', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0422', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0141', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0498', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0262', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-0263', 9.2, 'AV:N/AC:H/Au:N/C:N/I:C/A:C'),
('CVE-2005-0363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0829', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0274', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-0848', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0253', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-0288', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-1999-0862', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0870', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-0876', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0884', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0219', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0224', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0897', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0904', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0302', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0249', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0151', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0955', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0538', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-0543', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0308', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0271', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0493', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-0398', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0423', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0503', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0982', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0234', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1004', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1007', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-1009', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-0527', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0410', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0542', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0166', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-0234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-1999-0404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0260', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0241', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0269', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0248', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0252', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0258', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0267', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0275', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0194', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-0123', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0289', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0267', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-1999-0455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0297', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0299', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0278', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0283', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0277', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0467', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0312', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0318', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0337', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0286', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0480', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0487', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-0362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0491', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0224', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-0188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0376', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0321', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0323', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0350', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0352', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0610', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0381', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0386', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0348', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-0209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0369', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0371', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0226', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-0120', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0672', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0406', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2003-0486', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0260', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-0548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0697', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0323', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0574', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0402', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0264', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0578', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0664', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0713', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0256', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0260', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0458', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0276', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0284', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0278', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0322', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-1999-0475', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-0332', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0343', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0348', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0304', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0335', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0375', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0107', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0108', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0319', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0092', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0081', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0064', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0126', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0141', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0096', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0098', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0156', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0141', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-0080', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-0070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0165', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0157', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2003-0180', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0162', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0100', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0125', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0127', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-1999-0176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0172', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-0160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0182', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0167', 2.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-0110', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0149', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0229', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0174', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-0185', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0222', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2003-0233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0202', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0147', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-0107', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-0159', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0197', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0169', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0581', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0336', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0440', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1063', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0295', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0302', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2004-0590', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1073', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1085', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0614', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0299', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0313', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0466', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0619', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0623', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0634', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0305', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-0647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0477', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0257', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0503', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0630', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0635', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0489', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0497', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0522', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0646', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0701', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0389', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-0325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0342', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0651', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0584', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-0707', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0517', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0662', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0536', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-0712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0598', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0242', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0233', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0239', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0275', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0250', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2004-0259', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0269', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0436', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0251', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0177', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0258', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0448', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0266', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-0269', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2004-0296', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0273', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0306', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0124', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0472', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0206', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-1999-0473', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0126', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0185', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0346', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0314', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2004-0364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1312', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0669', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0427', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1341', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0389', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-1362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1377', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1382', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0420', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1389', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-0421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1398', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1407', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1043', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1052', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0321', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0431', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1094', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1373', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1375', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1124', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1433', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1442', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0475', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-0413', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-1153', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0492', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-1164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1451', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0418', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2004-1461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1188', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1203', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1469', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1475', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1481', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1292', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0420', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1313', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0507', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2013-0523', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-0645', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-1418', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0684', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0686', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0689', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0230', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0135', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0719', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0128', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0420', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0137', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0750', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0342', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0439', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0760', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0133', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0788', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0475', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0803', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0251', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-1999-0810', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0505', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0143', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-0144', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0831', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0272', 9.2, 'AV:N/AC:L/Au:S/C:N/I:C/A:C'),
('CVE-2009-0218', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0284', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0287', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-0289', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0861', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-0873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0147', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0885', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0300', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0921', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0521', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0370', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0526', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0387', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0167', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1099', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0621', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0475', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0314', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0482', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0361', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0652', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0318', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0609', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0659', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0614', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-0280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-0281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0502', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0627', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0493', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0367', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0373', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0379', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1109', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0519', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0524', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0647', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0687', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0691', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0312', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0549', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0558', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0319', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0289', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0571', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0652', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0577', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0583', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0588', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0593', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-0521', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0659', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0665', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0540', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0599', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0545', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0191', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0737', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0622', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0627', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0636', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0705', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1140', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0715', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0724', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0584', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0590', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2007-0420', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0358', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0124', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0405', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0228', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0231', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0681', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0685', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0695', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0327', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0699', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0702', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0198', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0235', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0762', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-0769', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0793', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-0139', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2006-0465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0493', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0423', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0426', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0366', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0834', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0869', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-0883', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0888', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0222', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0240', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-1999-0915', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0259', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0456', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0525', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0262', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0941', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0535', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0379', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0953', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0391', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0473', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0270', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0154', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0497', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0401', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0172', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-1999-0984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1187', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1198', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1207', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1470', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0324', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0458', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1223', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0508', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0643', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-1236', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1429', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0443', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-1999-1435', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1255', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0527', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-1321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0449', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1273', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0533', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-1329', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1511', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1523', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0170', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-0235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0175', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0251', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0268', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0180', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0232', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0261', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0268', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0274', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0276', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0248', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0264', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0273', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0433', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-0276', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0280', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0284', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0263', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0292', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0295', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0300', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0304', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0309', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2003-0286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0288', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0316', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0097', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0287', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0345', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0479', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0486', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0214', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0129', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0192', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0106', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-0297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0312', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0130', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1232', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-1427', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0442', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2003-1248', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1319', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0464', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1439', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1282', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0540', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-1294', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1300', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1303', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0433', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1513', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1518', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1522', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1308', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1525', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1350', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1357', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0470', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1528', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0580', 6.4, 'AV:A/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-1374', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0439', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0717', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2004-1541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1545', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1322', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1556', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1557', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1393', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1581', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1602', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1420', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0492', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1426', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0608', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0619', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1618', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0627', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1628', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2004-1635', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0333', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1145', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0528', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0674', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-0457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0170', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0311', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0156', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-1002', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0523', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1015', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0535', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-0247', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1030', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0270', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0276', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0591', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-0605', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0328', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0331', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1045', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-0576', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0588', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0613', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2003-0441', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1068', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0341', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0296', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2003-0449', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0164', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0453', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0353', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0617', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-0580', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0319', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0275', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0284', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1042', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-0425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0435', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0565', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1049', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1054', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0453', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1066', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1071', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1083', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0447', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0448', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0474', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0300', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0451', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0251', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2003-0462', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-0354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0625', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0632', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0306', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0648', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0605', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0607', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0366', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0640', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0380', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0384', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0515', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0505', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0520', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0323', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0328', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0536', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0689', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0287', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0341', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0553', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0315', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0570', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0263', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0399', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2004-0648', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0586', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-0616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0413', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0195', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0698', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0334', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0731', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0650', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0656', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0336', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0206', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-0421', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-0659', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0618', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0216', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0753', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2003-0625', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2003-0634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0645', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0260', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0266', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0709', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0758', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0291', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0656', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0277', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0776', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0723', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0295', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-0728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0541', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0348', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0619', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0693', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0620', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0702', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0713', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2004-0718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0728', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0588', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0748', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0423', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0660', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0665', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0599', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0214', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0752', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0758', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0633', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0639', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0283', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-0679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0702', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0705', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0249', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0256', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0262', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0268', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0191', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0134', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2003-0326', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0713', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0209', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-0136', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-0739', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0437', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0404', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-0450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0206', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-1999-0794', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0141', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0461', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0466', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0417', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0247', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0256', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-1999-0808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0242', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0243', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2006-0513', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0360', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0236', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-1999-0837', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0277', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-0248', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2004-0432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0291', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-1999-0872', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0257', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0265', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0221', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0227', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0910', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0376', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0450', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0212', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-0252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0928', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0932', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0150', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0372', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0950', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0389', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0215', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0392', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0223', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0479', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0265', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0189', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0115', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0161', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-0213', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0177', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-0218', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0224', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0230', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0197', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0424', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0244', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0183', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0216', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-0236', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0262', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0272', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0278', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0279', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2003-0282', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-0263', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0122', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-0218', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0259', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0293', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0667', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0338', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-0427', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0677', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0362', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-1999-1154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0751', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0765', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0755', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0698', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0244', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0255', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0264', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0368', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0759', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0652', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0290', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1171', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0376', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0670', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0285', 9.2, 'AV:L/AC:H/Au:N/C:C/I:C/A:N'),
('CVE-2004-0761', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0215', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0391', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-0289', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2009-0405', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1187', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0792', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0794', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0483', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0780', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0784', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0787', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0788', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0706', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0811', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0799', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2008-0219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0392', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2003-0396', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0399', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0495', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0971', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0424', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0155', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0402', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-0428', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0990', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0521', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0528', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0537', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0576', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0543', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0581', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-0320', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0423', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0427', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0333', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0558', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0563', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0174', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0583', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0450', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0289', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0261', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0301', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0591', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0456', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0175', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0597', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0475', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-0616', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2003-0454', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0604', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0168', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0629', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0642', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0275', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0307', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-1999-0991', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0522', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1012', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0585', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1046', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0577', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0582', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1060', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0290', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0259', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0162', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-1999-1070', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1072', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0595', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0298', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0266', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0248', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0348', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1091', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0599', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0603', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0274', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-0635', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0317', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0487', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0660', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0665', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0485', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0677', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0365', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0497', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0180', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-0637', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2003-0494', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0506', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0353', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-1999-0608', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0380', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0388', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0132', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0224', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0392', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0393', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0221', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0669', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-1999-0671', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-0675', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0195', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0410', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0398', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0233', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0717', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0210', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0402', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0424', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-0431', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0776', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0243', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0147', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-0412', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0418', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0489', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0246', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0254', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0807', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0358', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0142', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0508', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0368', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0145', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0270', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-0853', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0293', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1456', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1460', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1464', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1469', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1172', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1173', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0768', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1679', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1682', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1688', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1696', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1713', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1732', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0336', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0464', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1490', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0537', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2004-1754', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1761', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1500', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1769', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1509', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1369', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-1522', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0699', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-1787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1206', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1797', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0701', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1812', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0711', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1240', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0550', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0618', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0622', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-0315', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0640', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0363', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0255', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2004-0608', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0490', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0678', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2003-0490', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-0181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-0513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0325', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-0331', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-0540', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0698', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0702', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0322', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0324', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2007-0400', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0706', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0656', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0582', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0587', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-0592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0526', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0673', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0714', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0722', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-0678', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0684', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0297', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0547', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0607', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0686', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0733', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-0567', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-1999-1130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0307', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0199', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0332', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0580', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0631', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0635', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0697', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0356', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0335', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-0276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-0653', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0589', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0422', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0296', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2009-0395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0461', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0217', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-1999-1184', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1188', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0346', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0766', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0410', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0776', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0301', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0490', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0221', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0800', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0354', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0770', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1195', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1202', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0786', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0345', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0430', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0793', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0440', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0509', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0311', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0450', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0316', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0820', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0463', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0740', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0855', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0323', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-0515', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0863', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0481', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-0755', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0789', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0303', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0310', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0295', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0207', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0335', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0294', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0300', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0357', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0361', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0128', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0298', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0203', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0551', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0320', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0330', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0340', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0345', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0131', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0194', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0370', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0408', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0232', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0419', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2003-0338', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0341', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0446', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0784', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0790', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-0139', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0590', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0596', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0520', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0667', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0672', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0718', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0681', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0299', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0543', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1125', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0554', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0603', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0303', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-0615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0271', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2003-0578', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0197', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0579', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0331', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-0746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0730', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0742', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-0746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0760', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-1999-1167', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0210', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0276', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0744', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0280', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0384', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0459', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0340', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1182', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0760', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1185', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0473', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-0793', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0409', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0772', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0779', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0309', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0789', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0801', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0808', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0818', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0324', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-0327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0718', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0823', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0774', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-0333', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0368', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-0428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0306', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-0831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0442', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0736', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0308', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-0373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0840', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0315', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0303', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0492', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2003-0484', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0500', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-0631', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0638', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2003-0491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0499', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0508', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0383', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1110', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0502', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0506', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0645', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0527', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0699', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0292', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0407', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0524', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0663', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0535', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0266', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2006-0726', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0410', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0349', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0178', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0731', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2009-0352', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0734', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-0204', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0354', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0355', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2005-0630', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0641', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0645', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0181', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0723', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0732', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0657', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2003-0595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0603', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0359', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-0615', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0499', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0812', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0815', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0303', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0836', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0341', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0845', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0348', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0818', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-0822', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0436', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0850', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0507', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-0510', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0312', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0810', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0853', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-1220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0465', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0830', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0744', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1230', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0381', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-1999-1240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0871', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1246', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0866', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0527', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0890', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0898', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0905', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-0909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0533', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0492', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0920', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-0931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0827', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0832', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0841', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0368', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0938', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1261', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0881', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0844', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0945', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0904', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0936', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-0982', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0379', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1266', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0964', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0971', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0544', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-0985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1022', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0552', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0939', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1033', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1038', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0956', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0958', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0923', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0921', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-1999-1259', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0830', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0367', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0237', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0503', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0305', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0854', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0538', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0905', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0976', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0241', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0911', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0956', 2.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-0962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0965', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0979', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0991', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2011-0245', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1027', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0548', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0938', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1028', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1288', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1290', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-10001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-1999-1295', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1064', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1068', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0969', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0974', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1088', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1028', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0393', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-1042', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0988', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1092', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1098', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1010', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1050', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0904', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2004-1020', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1026', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0148', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-0154', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2004-0421', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0210', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0255', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-0812', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-0425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0352', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0358', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0265', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-0827', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-0160', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0838', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0216', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0844', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0283', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2011-0146', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0296', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0240', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0878', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0262', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-1999-0887', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0445', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-1999-0907', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0301', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0519', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0925', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-0929', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0163', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-0386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0461', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0946', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-1999-0967', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-0970', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0405', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0396', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0411', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0416', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0498', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0502', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0312', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-0858', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0866', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0380', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0484', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-1999-1245', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0764', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0869', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0488', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0891', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1255', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0792', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0910', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0234', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0844', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0930', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-0501', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0934', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0847', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-0871', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0851', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0902', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0965', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0937', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-10001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1277', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0914', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1015', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0968', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0929', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0978', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0982', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0546', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-1019', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0386', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0550', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0940', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1039', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1049', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0385', 9.2, 'AV:L/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2005-1061', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0967', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0392', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0975', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0980', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1086', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-1024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0348', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0556', 9.2, 'AV:N/AC:H/Au:S/C:C/I:N/A:C'),
('CVE-2006-1038', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-0976', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0406', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0229', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0243', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0277', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0173', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0321', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0272', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-1999-1033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1036', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0587', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-0603', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0609', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0451', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0442', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-1081', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0245', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-0462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0615', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2015-0247', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0471', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0165', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2003-0452', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0458', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0271', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1097', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0356', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0643', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0362', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0656', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0661', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0664', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0619', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0488', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0634', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0259', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0517', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0610', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0613', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0339', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0431', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-0757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0635', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0186', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0680', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0771', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-0696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0701', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0372', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0284', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0293', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1177', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0385', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0963', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1066', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-1070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0971', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1011', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0982', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1046', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1090', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-1001', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0396', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-1051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0900', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0903', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1111', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0253', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1050', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1119', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0366', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0386', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-0602', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1129', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1131', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0552', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0561', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0938', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0268', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0614', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0939', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0277', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0410', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-0411', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1097', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1119', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0577', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1116', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1120', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0426', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0580', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0237', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1003', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1006', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0526', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0533', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0409', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0431', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0548', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0549', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0322', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0414', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0420', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2004-0555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1038', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-0441', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0579', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0584', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1051', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0445', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0258', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0294', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-1999-1069', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0460', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0297', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-0470', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0598', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0301', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0311', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0474', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0627', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0638', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0178', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0657', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-0482', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0620', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0255', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0165', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0528', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0530', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0378', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-0945', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0471', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0539', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0393', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0553', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2003-0391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0426', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0563', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0567', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-0997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0313', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2004-0529', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0315', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1028', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0584', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0274', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0325', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0421', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0554', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0590', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0433', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0442', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0426', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0279', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1148', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0755', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0628', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0640', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0648', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1159', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0263', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0308', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-0453', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0204', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0730', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0378', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-0676', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0387', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0688', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0295', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0755', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0290', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2015-0298', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1186', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0786', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0763', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0472', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0474', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-1999-1190', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0220', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-0782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0311', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0791', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0794', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-0802', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0798', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-0351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0769', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0362', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-0365', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-0492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0824', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-0811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0828', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0832', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0369', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-0847', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0789', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0794', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0305', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0802', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0837', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0806', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0737', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0314', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0452', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0845', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0355', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0621', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0217', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-0750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0762', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0768', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0641', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0285', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-0449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0711', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0450', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0274', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0734', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0213', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1173', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0658', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0677', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-1178', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0388', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0463', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0693', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0795', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0796', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0694', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0338', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0705', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0573', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0398', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0649', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0581', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0185', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0717', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0677', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0539', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0300', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0549', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0602', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0606', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0611', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-1126', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1128', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0192', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0196', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0414', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0626', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-0633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0417', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0701', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0704', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0725', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0655', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0596', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-0747', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0602', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0606', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0278', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0436', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0444', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0763', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0753', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0644', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0284', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-0446', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0695', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0700', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0286', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0265', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0400', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0795', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0804', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0318', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0350', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2013-0356', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0771', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0361', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0726', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0729', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1199', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0585', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0394', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0385', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0392', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0409', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0935', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1067', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1140', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0264', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1077', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1081', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1092', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0278', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-0624', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0290', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-1158', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1165', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1128', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1113', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1121', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1140', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0311', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0430', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0317', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0413', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0965', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0407', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2004-1200', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0975', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1206', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1214', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1223', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1198', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0994', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1013', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1019', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1029', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0567', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0401', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0924', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0580', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0537', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-1123', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0592', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0378', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0545', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0396', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1127', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0402', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0609', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0550', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0259', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0612', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1085', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0395', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1089', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1150', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1315', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0279', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1088', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0282', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1094', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0941', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1095', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1118', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1136', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1141', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1147', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1166', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0318', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1184', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0319', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1193', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2010-0409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0455', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-0852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1223', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0748', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0834', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1235', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0864', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0378', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0516', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2009-0486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0760', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0768', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0777', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0783', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0304', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0922', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0928', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0909', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0331', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0837', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2003-0815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0824', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0493', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0369', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0848', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0882', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0505', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-0957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0963', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0934', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0986', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0989', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1271', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0384', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2006-0942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0950', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-0923', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0927', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0930', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0543', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2006-0989', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-1023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0306', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0222', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1196', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0296', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0497', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0813', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-1204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0343', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0792', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0796', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0501', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0439', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0506', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-0511', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1224', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2003-0739', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0512', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0376', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0758', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0771', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0880', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0781', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0788', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0888', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-0893', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-0903', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-0329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0793', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0491', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0840', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0845', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0933', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0941', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0884', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0889', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0950', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0952', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0376', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0906', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0909', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0939', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0507', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-0509', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0512', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0924', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0977', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0849', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0795', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0799', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0800', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0833', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0838', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0504', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0804', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-0353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0853', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0809', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0319', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1227', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0468', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0865', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1241', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0482', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2003-0761', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0767', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0876', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0882', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0782', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0889', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0232', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0921', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0925', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0365', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0912', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0841', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0819', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0923', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0499', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-0502', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0850', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0943', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0848', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0954', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0933', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0978', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0988', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1001', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1274', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-0508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1283', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0515', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0859', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0633', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0283', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0538', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0542', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0509', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1113', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0397', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0650', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0580', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0184', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0708', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0293', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0522', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0327', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0369', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-0289', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0735', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1172', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0747', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1176', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0383', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-0294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-0779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0466', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0763', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0345', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0292', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0477', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0778', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0790', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0814', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0822', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0767', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0320', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0360', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0419', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0727', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0806', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0334', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-0733', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1200', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0787', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0827', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0342', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0788', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0807', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0313', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0453', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0738', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-0457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0464', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0466', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0514', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0375', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2006-0870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0485', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2003-0757', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-0868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0871', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0775', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0431', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-0631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1183', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0432', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0320', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0324', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0973', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0414', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1215', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1221', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0334', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0643', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-0335', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1000', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0655', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0659', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1234', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1259', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-1272', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1242', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1286', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1292', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1299', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1350', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1308', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1331', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0355', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0376', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0381', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0443', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2003-1037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0452', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0686', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2004-1395', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1416', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1053', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0388', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0249', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0520', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0976', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1080', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1015', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0887', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0386', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2004-0985', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1048', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0307', 7.8, 'AV:N/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2010-0358', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0905', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1106', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1062', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0255', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0589', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0593', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0391', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-0384', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0393', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0606', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0549', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0323', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0972', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1204', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1208', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1213', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0333', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0644', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-1215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0651', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0997', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0343', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1013', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0599', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0417', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1029', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1032', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1254', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0606', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1271', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1246', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0418', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1336', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1343', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0374', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-0383', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0445', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1367', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1372', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0616', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1387', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1399', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1266', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1042', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0457', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0400', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0427', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-0692', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1084', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1274', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1428', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1380', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1116', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1431', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0436', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1133', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1138', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0478', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-1152', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0488', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0594', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0270', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2003-0459', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0253', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0460', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0468', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0631', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0304', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-1999-1101', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0486', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0478', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0663', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0483', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-0676', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0493', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0623', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0628', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0636', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0498', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0510', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0375', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0439', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1211', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0992', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-0593', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0596', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0597', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1230', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0345', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1034', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1236', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1260', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1266', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1276', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1280', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0317', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1304', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1353', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1311', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1325', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0671', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1345', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0378', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0386', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0444', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-1355', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1366', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1371', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2004-1378', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1262', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0618', 7.8, 'AV:N/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2010-0434', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1049', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1270', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0467', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-0694', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1096', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1101', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1104', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1127', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1434', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1383', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0406', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1145', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0414', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2003-1157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1169', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0440', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0518', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1031', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1051', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-0994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1293', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0978', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0250', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1033', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-1045', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-1089', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0564', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-1101', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1015', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0898', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1103', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1107', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1057', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1043', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0530', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0364', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1064', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-1060', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0597', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0389', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2006-1074', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1063', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0415', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2003-0931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0423', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-1142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0562', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0566', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0266', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1144', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0309', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1128', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-0644', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0686', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0340', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0320', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0183', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0655', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0579', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0406', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0589', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0711', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0725', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0537', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0267', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-0729', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0269', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-0350', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0604', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0272', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0198', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0624', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0696', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0615', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0275', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-1148', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0283', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0625', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-1160', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1102', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1109', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1105', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1129', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1133', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1148', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1153', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1167', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1326', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0949', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1185', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1189', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0408', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1203', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0971', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1212', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1222', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0588', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-1199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0649', 6.4, 'AV:N/AC:H/Au:M/C:P/I:P/A:P'),
('CVE-2009-0594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0342', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1228', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0346', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1235', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-1256', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0987', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0553', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0941', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0875', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0950', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1000', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0961', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1008', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2005-1085', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1022', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1039', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0996', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1000', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1018', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1033', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0590', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-0595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0538', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1309', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1312', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0608', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2004-1064', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0555', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0616', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-0276', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0622', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0700', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1202', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0519', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-0778', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0780', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2003-0786', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0889', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0894', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-0895', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0900', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1256', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0364', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0802', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0831', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-0928', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0849', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0880', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-0888', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0240', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0935', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2004-0908', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2005-0983', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0951', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0963', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0864', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0946', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0519', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1001', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1296', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0960', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0389', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1073', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0979', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1014', 4.9, 'AV:L/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-1017', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1029', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-0557', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1040', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-0987', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0992', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0356', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0359', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1031', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1052', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0926', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0519', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0523', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0671', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0720', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-0727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0600', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0412', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0302', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0732', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-0189', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0692', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0415', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0625', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0632', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0706', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0357', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0211', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0607', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0747', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0360', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0428', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0752', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0219', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0749', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0760', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2003-0637', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1156', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0448', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0243', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0245', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0257', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1165', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0731', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0283', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-0382', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0287', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0389', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0390', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0781', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0397', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0464', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0542', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0548', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0347', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-0351', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-0187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-0304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0194', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0203', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1445', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-1166', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1170', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1173', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1457', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1199', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1286', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2004-1487', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0460', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1300', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1305', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1224', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0513', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0522', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-0642', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1491', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0326', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1431', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0649', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-1253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1497', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1326', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0707', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1281', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1284', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1305', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0544', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-0566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0461', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-1443', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0571', 2.9, 'AV:A/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0713', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2005-1355', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0329', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1534', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0478', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0585', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-1537', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1543', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0442', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2005-1388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1394', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1395', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1568', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1572', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0501', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2003-1326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1402', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1614', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1415', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0488', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1313', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0667', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-1326', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0318', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0387', 8.5, 'AV:N/AC:L/Au:S/C:P/I:P/A:C'),
('CVE-2004-1350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1364', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-0448', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1048', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0456', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-1999-1367', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1417', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0465', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1083', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1090', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1120', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-1126', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0441', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1135', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2011-0404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0410', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1158', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0494', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1165', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1168', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1174', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1455', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1459', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1204', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0457', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1211', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1400', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0325', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1238', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2003-1244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1262', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2003-1268', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2003-1287', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0560', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2003-1309', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1446', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1353', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1361', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0479', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1448', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0716', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2004-1539', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1381', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1325', 6.9, 'AV:A/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2004-1601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1609', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0503', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0491', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0730', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0611', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0620', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0748', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0505', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1142', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1147', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2003-1336', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1457', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1091', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0284', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-1157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1099', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1103', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1096', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1120', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1118', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1131', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1154', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0316', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1179', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1186', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0584', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0411', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0638', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1205', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1210', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1225', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1201', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0645', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1012', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0600', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-0602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1233', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-1261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0422', 6.9, 'AV:L/AC:H/Au:N/C:N/I:C/A:N'),
('CVE-2009-0609', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0441', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1297', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1324', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-1999-1354', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0354', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0377', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0385', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0446', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1369', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0611', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0215', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2004-0748', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0674', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0620', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1149', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0433', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-0437', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-0443', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0682', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0445', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0694', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0254', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0367', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0267', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0710', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0288', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0194', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0724', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0211', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0746', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0286', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0456', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-0752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0297', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2009-0394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0468', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0758', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0764', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0348', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0704', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0797', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1322', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1149', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0412', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1172', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1192', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1198', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0321', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2011-0330', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1216', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1337', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1202', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0591', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-1004', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1017', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1228', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2005-1227', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1230', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1262', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1267', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0612', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1282', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1287', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0666', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1305', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0429', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2004-1342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0419', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0384', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1349', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0680', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1363', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1385', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0453', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-1038', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1366', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0392', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1073', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0417', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0420', 4.9, 'AV:L/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2007-0610', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1137', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0553', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0270', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1083', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1090', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0569', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1090', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-0400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1162', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2004-1101', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2004-1113', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1127', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1119', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1126', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-1143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1152', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0627', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-0314', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-1170', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0948', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1187', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0312', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1202', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0968', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0981', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1207', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1217', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0332', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0314', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1227', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0315', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0469', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0790', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0475', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0312', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0702', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0411', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0489', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-0806', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0766', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0357', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0416', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0363', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2003-0708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-0223', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0808', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2003-0734', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0831', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0370', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2005-0848', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0816', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0433', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-0839', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1376', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0401', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1278', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0434', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0437', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0440', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0697', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-0411', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0479', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-0484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-1162', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1447', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0323', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1182', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0699', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1205', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1471', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2004-1480', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1391', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1301', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0504', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0511', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1239', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1430', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1493', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0529', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1325', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1272', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1276', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0709', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1331', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-1293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1341', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1346', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-0711', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0551', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0567', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-0462', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-1444', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1447', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1319', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-1370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0578', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-0581', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0437', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-0472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1547', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0591', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0443', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0655', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1560', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1571', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0492', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1407', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1411', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1327', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1423', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2003-1329', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-1422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0733', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1454', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0614', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0452', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-1440', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0660', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1642', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1335', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0526', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-0533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1458', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1158', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1160', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1667', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0534', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-0679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1677', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1686', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1705', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1182', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-1999-1482', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1193', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-1353', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1741', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1198', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1758', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1499', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1770', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0698', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1393', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-0467', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-1800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1808', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0549', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1225', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1228', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1235', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0470', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1490', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0509', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-0512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-1317', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1424', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-1999-1428', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1245', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1261', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1500', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1269', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0534', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-0538', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1307', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0543', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0558', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1516', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1310', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0435', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0463', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1358', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1372', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0477', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0438', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1384', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0444', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1323', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0598', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1398', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1586', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1603', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0331', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0602', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1433', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0612', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0624', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1333', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0506', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0513', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-0519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0761', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1146', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0529', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1655', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1462', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1150', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0458', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0767', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1675', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1422', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0466', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-1089', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1377', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1119', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1441', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1137', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0474', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1151', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0485', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0489', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2003-1177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0503', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1206', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1386', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0419', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-1222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1233', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0427', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0648', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1433', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1257', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1496', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1322', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0448', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0465', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1274', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0431', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0531', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0535', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-1292', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1297', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1304', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1503', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1509', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0553', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-1519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0460', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-1312', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1524', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0577', 6.4, 'AV:A/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-1527', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0476', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0718', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2005-1378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1548', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0592', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-0330', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0673', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0441', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-0626', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0631', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0767', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0642', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0187', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-0681', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0690', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0189', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0258', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0722', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0757', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0452', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2011-0205', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-0655', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0732', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0773', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0671', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0386', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0785', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-0761', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0218', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0408', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-0777', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0786', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0799', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0491', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0366', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0712', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0495', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0728', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-0730', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0810', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-0814', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0339', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0349', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0817', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-0820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0797', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-0829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1226', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2003-0749', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1229', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0357', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0483', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-0325', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1244', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0880', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1250', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0892', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-0897', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0897', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0489', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0233', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-0903', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0917', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0801', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0839', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0235', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0500', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0870', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0537', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-1999-1263', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-0891', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0852', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0953', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-0959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0964', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0907', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0990', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0998', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0917', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0381', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0920', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1016', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0976', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0990', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-1026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1043', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1056', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0977', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1081', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0886', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0555', 9.2, 'AV:N/AC:L/Au:S/C:C/I:N/A:C'),
('CVE-2006-1037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0984', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0989', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0295', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0329', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0364', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-0493', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-0297', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0332', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0781', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-0809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0826', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0301', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0346', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0435', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0309', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2006-0843', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0747', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0832', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1231', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0860', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0361', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0756', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0874', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0836', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0794', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0926', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-0906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0914', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2003-0814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0927', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0497', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1262', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-0875', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-0886', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0504', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0932', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-0968', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1834', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1410', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1848', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1852', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0714', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0720', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1549', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1424', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1534', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1883', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0340', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1576', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-1892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1896', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-1899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-1999-1537', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1541', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1457', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1465', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0731', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1470', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-1273', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-1474', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1476', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1480', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1494', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1495', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1607', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0736', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0737', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1277', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-0787', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1498', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1501', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-1502', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1505', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-0474', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0609', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0618', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0622', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0625', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0332', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1634', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1445', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0764', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0521', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1144', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0530', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0673', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-1451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1151', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1159', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1163', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1340', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-0770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1678', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1683', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-1475', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1699', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1707', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0775', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1184', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1190', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1191', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2003-1345', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1731', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1359', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1740', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1489', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1491', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1197', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1498', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1502', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1748', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1753', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-1768', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1774', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1376', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1378', 9.2, 'AV:N/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2003-1381', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1524', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1209', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1798', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1215', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1519', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0705', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1522', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1817', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1234', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1238', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1690', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1715', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1719', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1354', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1483', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1483', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1744', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1488', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0538', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1496', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1778', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1781', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1795', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0548', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1802', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1221', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-0633', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0777', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1230', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1825', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1409', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1419', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-1850', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1855', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0718', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0553', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1874', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1423', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1561', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1431', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-1568', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1434', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1437', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1438', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1887', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0779', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1578', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1893', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1894', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1452', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-1453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1455', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1903', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1538', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1906', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1909', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2004-1913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1256', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1261', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0341', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1274', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0450', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1391', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0619', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-1410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1414', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1050', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0620', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0438', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-1370', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0426', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0689', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1107', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-1117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0405', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0477', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2003-1149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0482', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1159', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1163', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1450', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0454', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1486', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1392', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0461', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1306', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0520', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-0462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0426', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0444', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1256', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1260', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-1323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1266', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0650', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1279', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0710', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0651', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2003-1313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1317', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0475', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0584', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0480', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1546', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0654', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1396', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0485', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0495', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-1598', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1611', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1414', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0490', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0494', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-1999-1453', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-1617', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0616', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0453', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1620', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1392', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0489', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1584', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1597', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1410', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0483', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-0599', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1421', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1451', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0607', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0613', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1442', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1443', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1624', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1626', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0629', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-1999-1456', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1632', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0516', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1645', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1651', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0759', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0531', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1657', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1152', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1465', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1468', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1339', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0678', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1468', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-1477', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-1479', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0535', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1192', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-1351', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1357', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1362', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-1485', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1194', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1496', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1513', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0689', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1763', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1766', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0466', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-1204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1389', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1214', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1226', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0339', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-0344', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1231', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1270', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1239', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1283', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1248', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1298', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1349', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0424', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-0426', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0364', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0379', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1255', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1365', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0447', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0451', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-1388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0398', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0423', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1051', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1369', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0460', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0693', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1093', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1102', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-1122', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1432', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1435', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0403', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0486', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-0500', 6.4, 'AV:N/AC:M/Au:M/C:P/I:P/A:P'),
('CVE-2003-1172', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1194', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1465', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1094', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0395', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0357', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0361', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1102', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1025', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1030', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1034', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1125', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0596', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-0390', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-0382', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-0397', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-0391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0603', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-1083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0418', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0605', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0933', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0265', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1079', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0271', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1085', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1091', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0572', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0396', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-1093', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0287', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2005-1155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1163', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-1110', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0576', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1115', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-1123', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1142', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1168', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-0963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1188', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1199', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0329', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0331', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0436', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0415', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0794', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1524', 9.2, 'AV:L/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2004-1928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0799', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0800', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1935', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0591', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-1620', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1622', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1627', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1632', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1948', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1525', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0539', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-0992', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1275', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1009', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0915', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0918', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0949', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0244', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-0981', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-0984', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0858', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1024', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0866', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1034', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1287', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0953', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0995', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-0962', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0966', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1009', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1019', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1025', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0521', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0993', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0999', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-1097', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1008', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1014', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0901', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1058', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1035', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2009-0528', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1118', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1063', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1069', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0588', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-0373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0594', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0383', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0401', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0547', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0258', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0422', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0551', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0558', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0611', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0272', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1087', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0570', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0397', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1152', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0401', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-1103', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1125', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1405', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1840', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1411', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1845', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1417', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1244', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-1545', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1250', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1869', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1528', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1443', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1444', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1446', 6.9, 'AV:L/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2005-1580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1451', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-1454', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1902', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1905', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1908', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1912', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1545', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1593', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1473', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1477', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-0565', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0566', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1481', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2003-1483', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0568', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0733', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1485', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0570', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1487', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1488', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1596', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1493', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1557', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1601', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0580', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0581', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1603', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1610', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1611', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0786', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1560', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1500', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1503', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0743', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-0744', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1510', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-1512', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1517', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1518', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-1519', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1520', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1562', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1933', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1617', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1619', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1281', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-1938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1621', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1625', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1944', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1947', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1950', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1951', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1953', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1527', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-1955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1956', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1957', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-1958', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1963', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0807', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1968', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0812', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1971', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1973', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1974', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1978', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0754', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0827', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0830', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-1826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1829', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1401', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-0551', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1839', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2003-1415', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0715', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-1243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1858', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1859', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1860', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1867', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-1876', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0471', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1907', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2009-0723', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1919', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1551', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1260', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0732', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1467', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1595', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1556', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-1627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1444', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1631', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1641', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0672', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-1658', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1448', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1459', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1671', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0677', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-1681', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1473', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1175', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2004-1691', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1702', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1712', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1716', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1178', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1720', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0681', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1344', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0686', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1352', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0437', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-0832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0836', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2011-0226', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0354', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0745', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0356', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0862', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0362', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-0774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0878', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-0883', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-0891', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-0910', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0918', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-0927', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0795', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0383', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-0843', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-0925', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-0929', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-0498', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0936', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0851', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0238', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-0944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0949', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0377', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1265', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-0987', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0913', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0510', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0541', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0922', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-0926', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-0974', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-0936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0991', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0996', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0998', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1020', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0658', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1232', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1345', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0347', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0316', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1257', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1263', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0608', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0613', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2004-1279', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1296', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1303', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1351', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1309', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1252', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0614', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2011-0390', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-1256', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1356', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0449', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1405', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1409', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1412', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0687', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0461', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1100', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0322', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0402', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0476', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-1156', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1160', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0698', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1448', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1176', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-1183', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1192', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1285', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1215', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1489', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-1298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1225', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1425', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2003-1240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1246', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1254', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1495', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2003-1263', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0450', 9.2, 'AV:N/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2003-1270', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0536', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1290', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1299', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2003-1306', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-1502', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1521', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1311', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1318', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-1354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0576', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1526', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0467', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2008-0474', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1533', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0586', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-0653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0715', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2005-1379', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1549', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1386', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1387', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1324', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1576', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1600', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1330', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0496', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0606', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1616', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1331', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2005-1435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1625', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0667', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1636', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0668', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-1999-1457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0525', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1653', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1452', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1162', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1167', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-0543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1780', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1515', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1807', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1222', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1810', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1818', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1130', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1135', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1125', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1133', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1150', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0311', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2004-1163', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0429', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-1172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1183', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0583', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1194', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1187', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0640', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0590', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0652', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0341', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0549', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0517', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0942', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0346', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-0964', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-0968', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-0970', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1023', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0894', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0387', 4.9, 'AV:N/AC:M/Au:M/C:P/I:P/A:N'),
('CVE-2006-1047', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1002', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1006', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1011', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0360', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-0902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0525', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1105', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1108', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0399', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1027', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1032', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1038', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1051', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1115', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-0584', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0308', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0393', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0406', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0389', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0257', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0410', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0932', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0394', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0556', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0560', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0563', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0263', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0267', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1147', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1087', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-0620', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0456', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2003-1210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1299', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0632', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-0525', 2.9, 'AV:L/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-1999-1416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1426', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1247', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0447', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0466', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0532', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0537', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-1501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1298', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1507', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1520', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0712', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0579', 4.9, 'AV:A/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-1377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0440', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-0714', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0590', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-0656', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1577', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1583', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-1587', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1607', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1405', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1424', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0603', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0605', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1431', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0610', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1436', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0623', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0626', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0508', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1639', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1459', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1659', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1453', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0334', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0603', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2003-1025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1028', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1033', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1268', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1274', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1285', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1288', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0664', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1301', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0442', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1338', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-0373', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-0431', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-0388', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-1368', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2004-1381', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0617', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1392', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1396', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2004-1402', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1419', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0463', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-0428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0468', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-1999-1374', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1379', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1125', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1129', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2004-1437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1134', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0453', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0487', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-0502', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1197', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1467', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1476', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2003-1209', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1395', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1403', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1297', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1303', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1307', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1311', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1226', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0517', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-1999-1417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1235', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0445', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1265', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0708', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1288', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0539', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0541', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-1999-1440', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1347', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-0454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1504', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0549', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0559', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0568', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-0328', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1472', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1476', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-1474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1477', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1695', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0630', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1186', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1723', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1727', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1733', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1480', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1484', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1743', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1746', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1493', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1497', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1201', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1504', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1363', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-1751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1757', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1497', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1503', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1771', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1377', 8.5, 'AV:N/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2003-1382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1385', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1216', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1520', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1816', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0712', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1241', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1830', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1412', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1418', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0717', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1525', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1565', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1432', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1572', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-0554', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1535', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1549', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1922', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-1258', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0560', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0472', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-0940', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1100', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1112', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1123', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1114', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1122', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1134', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0629', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-1167', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-0945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-0950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0405', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0406', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-0414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0313', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0438', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-0990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0417', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-0994', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0340', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0419', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1342', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1027', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1031', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1235', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1258', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1264', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1278', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1247', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1293', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0423', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1310', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0672', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0676', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0428', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2004-1339', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-0382', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1676', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1342', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0769', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0460', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2006-1174', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1687', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1701', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1708', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0631', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1350', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1355', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1361', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1742', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1492', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1199', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0536', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-1364', 7.8, 'AV:N/AC:L/Au:N/C:N/I:P/A:C'),
('CVE-2009-0688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1760', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1772', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0691', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0692', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0542', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0544', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1788', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1792', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1804', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1521', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0700', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2003-1395', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2006-1223', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1227', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1231', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1527', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1528', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1396', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1831', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1408', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1414', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1853', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1856', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1857', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1862', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-1251', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1875', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0436', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1365', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0464', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0473', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-1532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0441', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2004-1538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1542', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1385', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2013-0593', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1569', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2004-1573', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0493', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1590', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1604', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1408', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0479', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1416', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1418', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0601', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0604', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0504', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0617', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0621', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0749', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0664', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1646', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0527', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-1656', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1470', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1662', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1470', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0335', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1714', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1482', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1486', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1390', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1260', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1411', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-0436', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1045', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1054', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0454', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-0439', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0690', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1095', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1378', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1108', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1438', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1140', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1144', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1279', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1155', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1444', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1167', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1453', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1458', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1208', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1482', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1294', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1414', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0505', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-0510', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1242', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0446', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1494', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1271', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0327', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1532', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1570', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1447', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1255', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1540', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1544', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1460', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-1463', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-0557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0559', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1590', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0729', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1923', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1468', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-1271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1555', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1475', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0342', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1276', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0735', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1608', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0590', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-1614', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1278', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-1999-1561', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1927', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-0344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0791', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1521', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0798', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0801', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1937', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1631', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1285', 4.9, 'AV:L/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2004-1961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1964', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0813', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0817', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0819', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1979', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1980', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-1999-1567', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1986', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0828', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0834', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0529', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-1999-1570', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0346', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1580', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1590', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2004-2007', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1638', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2011', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-1293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1488', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1508', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1515', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1750', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0776', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1504', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1367', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-0465', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1388', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1392', 9.2, 'AV:L/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2006-1207', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1794', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1512', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1801', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1805', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1394', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1224', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0708', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1824', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1530', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1828', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0721', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1546', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1866', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1551', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-1999-1526', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1556', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1557', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1422', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1560', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1426', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2003-1428', 4.9, 'AV:A/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1563', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1880', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-1573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1885', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0778', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2003-1440', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-1582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1897', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1536', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1910', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1914', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1546', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1918', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1456', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1263', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1269', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0730', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0634', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1469', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1270', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-1275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0780', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0473', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1296', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0467', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1316', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1356', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0572', 2.9, 'AV:A/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-1371', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0652', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2005-1380', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0589', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-0594', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-0445', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0597', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-1559', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1565', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1585', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0450', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-1606', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2004-1612', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0489', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1615', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2013-0615', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0454', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1621', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0662', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-0756', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-1633', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1644', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0763', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0532', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1460', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1156', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1161', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-1166', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1664', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1338', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0758', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-2015', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0004', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0530', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0006', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-1296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2021', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1537', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0010', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0014', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1301', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0018', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2028', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1303', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1305', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2000-0026', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0028', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-0836', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2000-0034', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0838', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1319', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-1320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1641', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0842', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1644', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1645', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0759', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0760', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2031', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0477', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0594', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-0734', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0569', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2003-1486', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0572', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0636', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0576', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0577', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1606', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1940', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1941', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1946', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0749', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1287', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-1290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1565', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1526', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1954', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1528', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1529', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0527', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1959', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1960', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-1969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0475', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0821', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0825', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0752', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0753', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1981', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1983', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1984', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0528', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-1988', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1990', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0592', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-0829', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0833', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-1292', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1535', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1689', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1698', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0632', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1718', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1721', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1189', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-1726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0682', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1349', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1745', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1507', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1365', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0690', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0337', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1373', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1519', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2004-1777', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0338', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1815', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1819', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1822', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1526', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1399', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1838', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1861', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1249', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-1870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-1877', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-1878', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1571', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1436', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1439', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-1888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1445', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1583', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-1898', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1586', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1462', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1267', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1553', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0635', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1575', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1993', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1994', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1577', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1995', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1578', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-1997', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1998', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-1999-1591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0835', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2000-0002', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1538', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1298', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-0593', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-0012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2027', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1302', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0021', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2029', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0022', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0023', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0024', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0025', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1308', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1309', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1311', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1315', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1471', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2003-1478', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-0785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0573', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1489', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1613', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0740', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0788', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1499', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1509', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1514', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2003-1516', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0790', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0802', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-1936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1618', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1284', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1286', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-1966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0815', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0816', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1982', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-1991', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0832', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-1999-1568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-1999-1569', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-1992', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0476', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-1999-1584', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2005', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2006', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1635', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1636', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2008', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-1999-1592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2012', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0001', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2014', 4.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2004-2016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0005', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2019', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1297', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0008', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0009', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2022', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0015', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0019', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0020', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1304', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1306', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0027', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2000-0033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1316', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1318', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0840', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1540', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0841', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1541', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0844', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0846', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0347', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0848', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1653', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0763', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1655', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0764', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1656', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0767', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1658', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1659', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1662', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1663', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1664', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1665', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0035', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1542', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0849', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0036', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0037', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0851', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1545', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1546', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2039', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0855', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0856', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-1666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1667', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2043', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2046', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2047', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-0770', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0039', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0040', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0042', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1548', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0478', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0637', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1669', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0532', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0596', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0597', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0348', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2060', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1549', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0044', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0050', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0056', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0058', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0060', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0062', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0066', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0067', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2068', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2073', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0069', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0863', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0071', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1551', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1552', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0866', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2000-0074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1553', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-0075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1558', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1560', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1562', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0538', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0539', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0602', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2083', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1325', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2086', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2088', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0868', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0870', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-0871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2096', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0480', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0881', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0350', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0098', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0100', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0105', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0109', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2099', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0115', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0886', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0887', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0889', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0890', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0122', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0605', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0126', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1569', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0610', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1571', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1675', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1575', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0616', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0481', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0547', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2117', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2118', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2120', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0143', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0595', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1323', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2054', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2055', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2058', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2059', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0045', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0047', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0049', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0051', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0054', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0599', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0059', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0061', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1550', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0862', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2069', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2070', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2072', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2074', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2077', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0771', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1324', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0349', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0072', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1555', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1671', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1672', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0081', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0082', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1557', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2003-1559', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1561', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1563', 6.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2010-0536', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1564', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1567', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-0603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2084', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2085', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2089', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2090', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2091', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2092', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2093', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2094', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2095', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2098', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0874', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0773', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0352', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0160', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2000-0162', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1676', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0482', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2000-0169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0171', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0174', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0176', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0551', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2127', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2129', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2131', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2132', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2133', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0177', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1336', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0179', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0180', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2138', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1581', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-0182', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0183', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2140', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2142', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0185', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1590', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0879', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0086', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0880', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2000-0087', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0088', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0090', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-0091', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0604', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2003-1568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0096', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0097', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0101', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0772', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2100', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2102', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0117', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0885', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0888', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0119', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2109', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0124', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0608', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0127', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0128', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1570', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2003-1572', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2003-1573', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0131', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0132', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-0615', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2003-1576', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0617', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1329', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0351', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0619', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0133', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0139', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1331', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0140', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0141', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0142', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2111', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2004-2112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0549', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2114', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2115', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2116', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2119', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0620', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1577', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1332', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-1333', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0149', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0151', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2000-0152', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0153', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0156', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0893', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0550', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-0894', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0164', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2121', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2122', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0166', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2123', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2124', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0167', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1595', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0628', 7.8, 'AV:N/AC:M/Au:N/C:N/I:P/A:C'),
('CVE-2008-0631', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0632', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2147', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0553', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2000-0190', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0354', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0205', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-0207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0209', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0638', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0644', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0213', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0220', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0225', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0226', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0228', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0236', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0241', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2194', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0485', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1346', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1682', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0572', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2004-2226', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0053', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2000-0271', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2237', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0063', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2256', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2257', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0587', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1693', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0589', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2260', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0109', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2269', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0116', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-1360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0125', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-0132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0159', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2297', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0192', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-1364', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2004-2301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0662', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1369', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0210', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-0211', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2004-2317', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2331', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0365', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-1709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0672', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2359', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0613', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2381', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2402', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1383', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1387', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2000-0359', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0360', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0701', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1741', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0392', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1404', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2000-0405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0409', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0427', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0800', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2125', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0172', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0175', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1334', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2126', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2128', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0622', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2134', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1335', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0625', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2137', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1582', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0638', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2003-1585', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1587', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2003-1588', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2003-1589', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2003-1593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0483', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2150', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2153', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0198', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2160', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-0202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0208', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0210', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0639', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0643', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2165', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2168', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2169', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2170', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2172', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2179', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0217', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0355', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1339', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0563', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-0487', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1679', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0039', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0261', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0270', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0056', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0061', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2244', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2253', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2000-0285', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0077', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2000-0291', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0296', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0299', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1695', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-1698', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0303', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0106', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0113', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0127', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0137', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2009-0777', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2004-2286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2298', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0194', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-0200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-0513', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1409', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0505', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0517', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1412', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0521', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0522', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0528', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0539', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2405', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-0266', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-0390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2407', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2422', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2430', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2436', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1422', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1425', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2451', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0554', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1432', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1836', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1853', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0543', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-0545', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2488', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2000-0564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0572', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2491', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-0587', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2506', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1883', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0605', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0843', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-1464', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0851', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0622', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1467', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0279', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-0553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2525', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0668', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1482', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0678', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0679', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0683', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0665', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0709', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0300', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2005-1932', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2569', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0674', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1510', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2000-0757', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0763', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2570', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0565', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0944', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0697', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-0595', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0598', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2319', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0217', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2327', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2330', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0231', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-0360', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0324', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0369', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0372', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0334', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0242', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-0244', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2364', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0495', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-1375', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1378', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2004-2389', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0377', 6.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2004-2401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1740', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0503', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0395', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1753', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1759', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-0446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0704', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0803', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2005-1766', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0481', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1408', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0503', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-0716', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-1789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0526', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0545', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2406', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0527', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0647', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2577', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2584', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2004-2590', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0331', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-0434', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-0437', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2610', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0706', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0342', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2000-0812', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2622', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0956', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2650', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2069', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2074', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0841', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1532', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1535', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1540', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0760', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0862', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-0888', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0578', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2664', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2117', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0763', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2140', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0466', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0896', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0728', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2005-2175', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2673', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-0583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0358', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-0589', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0591', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0492', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0906', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0604', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1563', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-0607', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0910', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1569', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0928', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2222', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0938', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0947', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0365', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-0769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2249', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0914', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2272', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2702', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0973', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0615', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1601', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1423', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0732', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0393', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2004-2464', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0650', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0541', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-1435', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1841', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1846', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2482', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1864', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0565', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0598', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1461', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0839', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0610', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0412', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0420', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0276', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-0283', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0286', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-1899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2523', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-0554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0661', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0862', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0556', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1916', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1918', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-0295', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-1486', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0666', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0687', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0694', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0704', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1503', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0715', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2552', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0724', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-2566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0670', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0680', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0748', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0308', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2005-1947', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0762', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0925', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0689', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1518', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-1968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0878', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0949', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2599', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2605', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0782', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0786', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2006', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0708', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0955', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0439', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-2284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1002', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2292', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0768', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1003', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-1621', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-1008', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-2300', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0394', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-0409', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-0423', 9.5, 'AV:N/AC:H/Au:N/C:C/I:C/A:P'),
('CVE-2016-0438', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0441', 9.5, 'AV:N/AC:H/Au:S/C:C/I:C/A:P'),
('CVE-2016-0443', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-2714', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-0447', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0657', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0460', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1642', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1018', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0787', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0791', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2325', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0658', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1069', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1074', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0792', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-1085', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2727', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2000-1096', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0813', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1030', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0807', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0815', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0513', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-2340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0836', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1144', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1151', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0934', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-1052', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2361', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1177', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2732', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-1681', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2740', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1693', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2745', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-2402', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0511', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0636', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0643', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1695', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0674', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0544', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1067', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0675', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1075', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0676', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-0529', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1710', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-0653', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0552', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1082', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-1721', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2016-0566', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2423', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0576', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1225', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2455', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1088', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2056', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2004-2646', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0837', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0891', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-2094', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2667', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0871', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0874', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0447', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2126', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0461', 7.8, 'AV:N/AC:M/Au:S/C:P/I:C/A:N'),
('CVE-2005-2147', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0472', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-0475', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2174', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2016-0346', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-0590', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0486', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0902', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0498', 2.9, 'AV:N/AC:H/Au:M/C:N/I:N/A:P'),
('CVE-2000-0926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0608', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2217', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2227', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0610', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0369', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-2247', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2255', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2262', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0960', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0915', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2278', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0922', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-0613', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0968', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-1596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0992', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1606', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1609', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0592', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2495', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-1241', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0022', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1247', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0025', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1726', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1097', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0852', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1100', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-1103', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0866', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0032', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1108', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0702', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-0986', 6.4, 'AV:N/AC:M/Au:M/C:P/I:P/A:P'),
('CVE-2009-0989', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-0993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0889', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2596', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1008', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1010', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0039', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0067', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0548', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0043', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0912', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0089', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-0715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1154', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0565', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2009-1033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0722', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0119', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0927', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2650', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0052', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1170', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0053', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0944', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1056', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0133', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0144', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0057', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-0763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0502', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2289', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2294', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0790', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1625', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0769', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0399', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-1640', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-0411', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0506', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2000-1038', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0455', 7.8, 'AV:L/AC:L/Au:S/C:C/I:N/A:P'),
('CVE-2008-0803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2322', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1068', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0486', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1083', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2724', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-2335', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0823', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0623', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0804', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0822', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1117', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-1129', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0829', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-1664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1044', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0933', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1148', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0504', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2015-0518', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-2354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-2364', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2730', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1185', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1057', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2736', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2743', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0665', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-1060', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0156', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1185', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0961', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0742', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1202', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0608', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2009-1082', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1223', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0170', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0597', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0177', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0079', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1737', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1230', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0104', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0108', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-1089', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0120', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-1091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0975', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1252', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0131', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1254', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0146', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2726', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0183', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2732', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0192', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0204', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-1744', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-10002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1006', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1014', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0240', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0245', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0736', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1309', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-0251', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0259', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0740', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2794', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2401', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2405', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2756', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0528', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1204', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0545', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1066', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-0825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2759', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2768', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0530', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0547', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-0950', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0578', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1230', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2460', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2461', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2475', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2000-1238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0829', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0015', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2499', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0685', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0680', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2530', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2545', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1105', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0022', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0030', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2574', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0036', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0997', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-0704', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1122', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0895', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2605', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0782', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0660', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2859', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0641', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2005-2868', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0286', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0789', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0867', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-0870', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2006-1796', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0886', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0901', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2010-0906', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-0915', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2001-0295', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1054', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-2929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0803', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-0807', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1073', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0692', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0312', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0939', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0700', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0705', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1821', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0717', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0321', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1081', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0958', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1826', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0074', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0685', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0547', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2001-0083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0042', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1136', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0551', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1149', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1162', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2652', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0600', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2016-0605', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2008-0935', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0939', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2681', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0965', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1100', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0969', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1099', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0757', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0644', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2001-0337', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0764', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0766', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1381', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1129', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1137', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-0787', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-1852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0815', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1399', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1113', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-1405', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1854', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0818', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1408', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1875', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1881', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0999', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2005-2995', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1133', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1161', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1138', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1169', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0855', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-0860', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-1431', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3014', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1930', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3038', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0381', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1943', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3048', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0386', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0863', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0389', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1007', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1955', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1448', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1067', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1071', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0168', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1085', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0174', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2001-0179', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0081', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0085', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0087', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0105', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0110', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0114', 4.9, 'AV:L/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2000-0189', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2003-1592', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2003-1594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0774', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0630', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2148', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2149', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2151', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2152', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2003-1596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2156', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2159', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0199', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0200', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0201', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0203', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0204', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0206', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0633', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-0634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0636', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0211', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0640', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0642', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0555', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0214', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0216', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2185', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2187', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0223', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0232', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0647', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0242', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2197', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0648', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2215', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2217', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2224', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0266', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-2228', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0054', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-1464', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3081', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3083', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1171', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1185', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1178', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3111', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0438', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3123', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1489', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1190', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2019', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2020', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-1027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1029', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1034', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-1189', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1498', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1213', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0284', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0662', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-2040', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1536', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0186', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0709', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2707', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0977', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0757', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-0761', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0142', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0721', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0161', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0168', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2001-0197', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2725', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0215', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0217', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0985', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-0614', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-1268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1005', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1748', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1273', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1281', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0223', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1749', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1752', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0776', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2767', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1291', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0213', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1769', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1304', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0254', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0640', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2005-2793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2797', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1325', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-2807', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1330', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1021', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2817', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1788', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-0849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1026', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0663', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2010-0852', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-1042', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0788', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0865', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2893', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0798', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0875', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0880', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-0893', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0910', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0666', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2001-0300', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1052', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-0683', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2001-0301', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0926', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-1067', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0935', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2011-0808', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1815', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-0937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0943', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0810', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0702', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1358', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1822', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-0319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0959', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0728', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2959', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0272', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-0273', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0776', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2000-0287', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0297', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0300', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1697', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0305', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-2262', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0110', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2268', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1359', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0122', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0130', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0140', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2272', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2274', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2279', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0164', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0658', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-0187', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0203', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0206', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2004-2305', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0660', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1707', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-0228', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-0362', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0321', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0323', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-0788', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0329', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0790', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0237', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-1710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0245', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2005-1715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1716', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2369', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0249', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2011-0496', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0498', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2390', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0681', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0350', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1380', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1385', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0367', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1747', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-0966', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0237', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-1828', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0978', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1100', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0752', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0335', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2969', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0241', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0763', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1380', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1109', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1387', 10.0, 'AV:N/AC:H/Au:M/C:C/I:C/A:C'),
('CVE-2015-0795', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0646', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-1110', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1116', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1878', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1884', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1886', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0360', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0249', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1125', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2999', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3002', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0647', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2001-0366', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1423', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0853', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-1913', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1918', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1926', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1935', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1937', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1003', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1180', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1142', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1442', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0624', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1755', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0408', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0804', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2010-0634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0477', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0488', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0494', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0497', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1775', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0712', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1783', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0722', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0533', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0541', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0265', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-1415', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-1800', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2409', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0816', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0268', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-0648', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-1815', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2443', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0392', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2004-2463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0402', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0735', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2476', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-1832', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0272', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-1433', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0651', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-1868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2490', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1874', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2499', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-0597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0747', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0656', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-2511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0611', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0617', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0620', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1891', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1893', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0285', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2000-0639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0652', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0658', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-1901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0868', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-0902', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1485', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-2184', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2190', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0562', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0486', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0570', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0012', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-0025', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2000-0254', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2223', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0052', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2000-0268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0057', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2248', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2255', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0282', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0588', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-0290', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1699', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-0105', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2264', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-1355', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1358', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0494', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0126', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0129', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-0639', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0358', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2281', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2287', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0166', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0657', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0189', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0204', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2004-2308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0659', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1370', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0597', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-0599', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0665', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2004-2315', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2318', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2320', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2004-2328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0230', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0784', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2006-1957', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1967', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0864', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0650', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2001-0409', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1467', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-1166', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0752', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0435', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3112', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0865', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-1186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0265', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1028', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0866', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2016-0298', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-1495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1497', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0690', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0698', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0714', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2555', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0728', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0736', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0676', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1937', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-0753', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0765', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0562', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0568', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0317', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2000-0769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0773', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0324', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-1969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0948', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0777', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2583', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-0953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1988', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2602', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2020', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0705', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0883', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0574', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0715', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2073', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2076', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0833', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0843', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1537', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0861', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0969', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2095', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-0864', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-2109', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0441', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-0451', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2005-2128', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2137', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2142', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0894', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0879', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0467', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2025', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-1200', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1207', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3164', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-1212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1512', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2032', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0287', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1041', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-0755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1526', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-3200', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3208', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3217', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3222', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3230', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2069', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3254', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1545', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2085', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1074', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1222', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3286', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0872', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0667', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-0366', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0370', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-0606', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-2345', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-1373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0239', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-0246', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2354', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2361', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1729', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0793', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-0675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2372', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2378', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2385', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0798', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2394', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2395', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0500', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0254', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-0505', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0389', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0402', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0263', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2000-0449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0637', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0641', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0495', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0518', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0514', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0522', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0524', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0540', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0383', 7.8, 'AV:L/AC:M/Au:N/C:N/I:P/A:C'),
('CVE-2008-0724', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0528', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2004-2410', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2418', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1420', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1812', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1817', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0531', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2449', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2450', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2453', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2459', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0398', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2004-2469', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2475', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0551', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1431', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1434', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0559', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1848', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1453', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1866', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0654', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-0563', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0571', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-0746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0582', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2493', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2004-2500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0749', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0601', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0844', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2009-0855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0237', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0240', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0243', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2198', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1678', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-2205', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0005', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2010-0571', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2016-0022', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-0356', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2000-0262', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0264', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0269', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2233', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0059', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2004-2241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2247', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0656', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2000-0281', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0294', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0591', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-2263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0114', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0123', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0139', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-1361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2276', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0198', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0202', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-0205', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2004-2309', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0600', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0901', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0598', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0918', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1550', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-2675', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2006-1558', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1561', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0906', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-0981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0908', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1572', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2683', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0366', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-0370', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2000-0951', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0739', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2256', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0963', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2279', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0971', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0986', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0750', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0996', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2004-2706', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1006', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1612', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0503', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-0380', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2004-2710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1629', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-0652', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0433', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0439', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2713', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2000-1036', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0507', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2000-1050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1021', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0471', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3318', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1563', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0485', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0491', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-1082', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0622', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0659', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1105', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0797', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1648', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0806', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0932', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1041', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1145', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1156', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1051', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1671', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1171', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0937', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0516', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2368', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1686', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0945', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2390', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2000-1194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2749', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2406', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0641', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0523', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-0532', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1069', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1699', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-1215', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1704', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1709', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0656', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0548', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0551', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0531', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2417', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0570', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0580', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1234', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1083', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2454', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1084', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1089', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0016', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1093', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0858', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2005-1896', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1474', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0277', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-0426', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1902', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-0865', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2007-0907', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2535', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1490', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1498', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0703', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0299', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2004-2548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2553', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-0913', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0722', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-2563', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2000-0743', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0305', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-0683', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2000-0756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1954', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0561', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1961', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0567', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0929', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1526', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0322', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-0943', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0216', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2323', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0219', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-0227', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2337', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0367', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0331', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2343', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0671', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0243', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1713', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2356', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0792', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0796', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-1730', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2374', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2384', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0380', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2403', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0697', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1394', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0253', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1745', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1749', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0474', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-1769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0485', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0490', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0502', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0806', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-0519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0720', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0520', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0529', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0537', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0267', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2009-0812', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0546', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1807', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1816', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1819', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0728', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0644', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0233', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0646', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1340', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2196', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2208', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1683', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-1686', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2016-0041', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2219', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-0252', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0259', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0265', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2227', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0055', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2236', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0275', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-1352', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0592', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-0111', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2270', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0136', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-0641', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2273', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2277', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2282', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0162', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2004-2291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0778', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2004-2313', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0308', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0003', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0864', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0984', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2001-0034', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0037', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0998', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-1727', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-2582', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-0899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1124', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0597', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-0908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1005', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-1351', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0295', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1691', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0304', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0102', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2261', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0108', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0112', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-0493', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0134', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-0640', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0149', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0154', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2283', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2292', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0781', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0359', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0596', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-0666', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2004-2325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1371', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2000-0327', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-1372', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0789', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0341', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0240', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-1712', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0247', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-1719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2360', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2367', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2371', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0620', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0250', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2004-2391', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2393', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2400', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1379', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0352', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1391', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1393', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0381', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0390', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0398', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1752', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1756', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0947', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2576', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2585', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2592', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2595', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0433', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-1996', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0793', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0880', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2030', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0573', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0829', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2628', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2642', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2648', 2.9, 'AV:L/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2000-0835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0343', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2000-0849', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-0761', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0866', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2671', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0444', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0446', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0726', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0455', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2005-2135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2141', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0898', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2168', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0582', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0355', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-0587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1547', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0593', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2674', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2006-1551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2679', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-0904', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2215', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0927', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1575', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0929', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0948', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0499', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-0770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2266', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2692', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1582', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2004-2698', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2701', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0967', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0921', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2000-0975', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0981', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0989', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0775', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0760', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0504', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2296', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1617', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0794', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1630', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1143', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2001-0100', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1152', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1158', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0563', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0101', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1169', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0112', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0116', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0120', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0928', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2007-1172', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2678', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1059', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1060', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0141', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0152', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0589', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-0164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0064', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1225', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0171', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0076', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0080', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-0084', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1228', 6.9, 'AV:L/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2012-0101', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0113', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2008-0973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1241', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-1090', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0974', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0129', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2001-0191', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0132', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0976', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0135', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-0141', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2712', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0762', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-2720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2727', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0764', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0210', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2738', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2741', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0193', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0727', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0987', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0766', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-0729', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0535', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0553', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0406', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2005-1833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1838', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1843', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1850', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1858', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0824', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-0576', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0585', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0594', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1880', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0657', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1889', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0846', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0551', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2515', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1892', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2005-1897', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0634', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0642', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0646', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0656', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0662', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0670', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0555', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0291', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-1904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0867', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2534', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-1915', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1923', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-1492', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2540', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0432', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2000-0713', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2000-0717', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0912', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2565', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0734', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1941', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1945', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0755', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0760', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0767', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-2572', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1516', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0770', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-0938', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0570', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2582', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0952', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0336', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0339', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2005-1994', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1998', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2004', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2013', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0707', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2038', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2039', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2055', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2060', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2651', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0844', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0859', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0417', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0434', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0770', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2004-2715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0448', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-0800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1045', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2016-0461', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-2312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0472', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2016-0476', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0479', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-2334', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1077', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1088', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1095', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1644', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1028', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0496', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-1106', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1654', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1657', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0624', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0625', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1150', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1157', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1675', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2353', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2365', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0662', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2378', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2394', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0506', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0510', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0516', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0525', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1199', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0540', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1697', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1210', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1705', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2765', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1716', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0549', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0561', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-0564', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-0568', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2431', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2444', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2467', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2488', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0413', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0643', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0443', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0448', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0512', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0458', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0802', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2010-0638', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1770', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0480', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0501', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-1776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0717', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1790', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-0645', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-0387', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-0725', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1797', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2411', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1419', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0547', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2434', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0532', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-2448', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1831', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2473', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0556', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0407', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1436', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1842', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0410', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0274', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1870', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1876', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0745', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1460', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0589', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0833', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1879', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0547', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0275', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-0841', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0608', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1465', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0418', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0422', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0282', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2000-0637', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0648', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0655', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0664', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1481', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-0292', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-1908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0427', 4.9, 'AV:L/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2005-1921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2537', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2539', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0616', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-2753', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0633', 7.8, 'AV:A/AC:L/Au:N/C:N/I:P/A:C'),
('CVE-2011-0774', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1270', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0226', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1761', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1286', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1768', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0233', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0215', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-1775', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2790', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1337', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2813', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0271', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2858', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1096', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0854', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2008-1046', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0792', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0869', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-0799', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0882', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0897', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0902', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-0907', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0914', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0296', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1049', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1347', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2016-0208', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-0209', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-0663', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0218', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0222', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2004-2329', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0226', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2333', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0232', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2000-0318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0363', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2000-0325', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0667', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-0373', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2000-0336', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0791', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0343', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0346', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0241', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2346', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2348', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1720', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2362', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0794', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0676', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1732', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1733', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2383', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0374', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-1382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0699', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-1396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1738', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0703', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0260', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-1402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0376', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0385', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0399', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0411', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0261', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2000-0430', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1761', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0445', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0452', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0801', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2000-0470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0640', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-0479', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0709', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-1407', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2000-0500', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0507', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1778', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0714', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0516', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1791', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-1794', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0535', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0543', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0385', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2004-2419', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0011', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2496', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0684', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0840', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-1254', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-0027', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0002', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0029', 10.0, 'AV:A/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-0857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2543', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0012', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0031', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0867', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0033', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0883', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2571', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0035', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0038', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0042', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1118', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2591', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1125', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2602', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-0907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1002', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1132', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2621', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2626', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2629', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1020', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-0072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0090', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1144', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1150', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2009-1031', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2007-1155', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2007-1160', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0717', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-0909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1930', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1506', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0726', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-2568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0678', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0921', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2000-0766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0928', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1962', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-0877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0936', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0569', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1974', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0778', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2587', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2591', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2598', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1993', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2001', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0788', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2014', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0709', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0438', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-2041', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2004-2643', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2070', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0832', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0840', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2084', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0853', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2656', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0863', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2110', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0973', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0445', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1545', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0465', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2151', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2177', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0354', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2015-0476', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-0979', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0980', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0485', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-0488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0904', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0911', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0603', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2676', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0920', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2208', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2680', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0932', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0936', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0363', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-1805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0304', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0930', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2939', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0693', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1818', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-0942', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1359', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2948', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1825', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1085', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0730', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0739', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-0970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1370', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1102', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1101', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1103', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1104', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0761', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1131', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1384', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-0779', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1851', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1144', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0245', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1393', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1396', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1398', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-2983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0358', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1117', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0997', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1409', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1880', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0819', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1887', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1000', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-1414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0364', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2997', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0824', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1420', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0838', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0845', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0850', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-0854', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-0857', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-3015', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0648', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-2088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-2097', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0869', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0975', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0877', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0456', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0463', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2145', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2149', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2170', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0348', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-0584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0356', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-0360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-2193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0483', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-0487', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-0595', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0908', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0602', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1552', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0905', 2.9, 'AV:L/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2005-2198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0921', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1568', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0733', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2000-0940', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2682', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-0367', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-0768', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0740', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2263', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0956', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1581', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2699', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0614', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2704', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0754', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1005', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1611', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0782', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0376', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-0619', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0381', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-0389', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-2304', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0505', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2016-0401', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1639', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1015', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0420', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-0818', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-1811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0729', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2004-2452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0391', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-0399', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-0536', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2477', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0405', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2004-2483', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-1855', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2485', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2487', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1459', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0570', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0586', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0593', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1878', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-1882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1885', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0837', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0840', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1462', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0623', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0414', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2004-2516', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1895', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0659', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0638', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0644', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0660', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0898', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-0672', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2526', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1903', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1911', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0682', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1924', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2547', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-0559', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1037', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1043', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1051', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2663', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2669', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2676', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1194', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0166', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-0702', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2703', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0065', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0172', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0074', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-0077', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-0086', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-0090', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1232', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0754', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0117', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2007-1236', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0123', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0187', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0708', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1246', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-0144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0155', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0160', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0171', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0177', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0981', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2728', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0185', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0617', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-2736', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0211', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1265', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2012-0199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0205', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2000-0952', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2248', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2259', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0988', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2000-0957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1580', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-1585', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0611', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1593', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0744', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2000-0977', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-0998', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0761', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1610', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0784', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2295', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0379', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2007-1006', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0386', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-2302', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0620', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0654', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0408', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0422', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2013-0656', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0437', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0772', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2000-1037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0449', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0454', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0804', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-1047', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0463', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1058', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0484', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1076', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0494', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2723', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0814', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-0795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1109', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1032', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0821', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0827', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-1136', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1042', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1668', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2000-1155', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-0626', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1175', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0519', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2358', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2366', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1178', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0615', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-1742', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0621', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0631', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-1008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-1750', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1757', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2755', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-1287', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0211', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1764', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-1765', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2758', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2759', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2762', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2766', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1289', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0232', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0247', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0252', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1321', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2809', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1933', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3040', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1941', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1944', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3046', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1437', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1444', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1951', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1952', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3059', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1458', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1969', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1462', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-1975', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0408', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0808', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1187', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3132', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1490', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-2018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3136', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3141', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2021', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1197', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2007-1491', 6.4, 'AV:A/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0462', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1493', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0657', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2000-1188', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2384', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2393', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2747', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-0522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0519', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1202', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1206', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1080', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0949', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1712', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0663', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2428', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1228', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0585', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2442', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2462', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2466', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0021', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-1095', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0957', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2533', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2537', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1098', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0013', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2558', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0862', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0967', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2001-0026', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0972', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-0976', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-0981', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1112', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2576', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0039', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0999', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0888', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0050', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0890', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0897', 9.2, 'AV:N/AC:M/Au:S/C:C/I:C/A:N'),
('CVE-2005-2594', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2598', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2604', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2611', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1007', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1011', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1016', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2001-0070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0543', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-0544', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0079', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0081', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0086', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1022', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1028', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1137', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0552', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2001-0092', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-2310', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1032', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2717', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-0777', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-0801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0456', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0806', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2313', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1020', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0470', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-2321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0477', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2331', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-1071', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1084', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2729', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0511', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2006-1653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0808', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-0824', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1132', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2016-0502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1146', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2342', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1670', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-1166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2357', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1055', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-1186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2370', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0671', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2381', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1191', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2748', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0514', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0642', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0524', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1197', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0537', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1209', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1068', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0527', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2412', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2767', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-1715', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0664', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1719', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0569', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1232', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0951', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2468', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0008', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2812', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1783', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2830', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1023', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0276', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2005-2860', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0858', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-0860', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2005-2888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0794', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0797', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2005-2904', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0890', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1345', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2001-0303', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1062', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1809', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0924', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1354', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-0691', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1816', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0940', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0949', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0707', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-0713', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2000-0710', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1505', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0716', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-2554', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0721', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2000-0723', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2000-0727', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2000-0732', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1939', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0307', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-1513', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0761', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0563', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0684', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-1517', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0321', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-0940', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0328', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-0695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0704', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2581', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2589', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0332', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-0879', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2601', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1995', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2003', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0789', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2033', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0809', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0818', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0826', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0830', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2052', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2649', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2004-2653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2078', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0839', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0886', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0647', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2661', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0889', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0865', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2670', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0876', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0458', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-0464', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0895', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2157', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2163', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2173', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0349', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-0585', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0648', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0362', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2000-0892', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-0489', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-0491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0596', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0913', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0606', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1554', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0732', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-1574', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2000-0931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0935', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2684', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1199', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1509', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0282', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0867', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0474', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2035', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1225', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0663', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-1044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1520', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3189', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0484', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-2049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1524', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2057', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2061', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3212', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3218', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3229', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3234', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3239', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3251', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1540', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0871', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1216', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3290', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1230', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1553', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1560', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0930', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1038', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-2643', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0601', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-0932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2659', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0054', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2001-0129', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2667', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2680', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1057', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0845', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0138', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0140', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0949', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1061', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0151', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0060', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0061', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1191', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1062', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1196', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1214', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0748', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1073', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-0068', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-2704', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0753', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1087', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0089', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0092', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-0102', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2001-0184', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2012-0112', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-0118', 4.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:P'),
('CVE-2011-0755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2952', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0722', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0332', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0735', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1366', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1829', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1832', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1106', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-1834', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1119', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0762', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0772', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-1141', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0989', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-2976', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2977', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2981', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1119', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1148', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1869', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1877', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0248', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-1129', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1132', 6.9, 'AV:L/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2006-1894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1898', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1902', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0367', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1139', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0846', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1173', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0856', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2001-0370', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0797', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0501', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1564', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0883', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-1094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0678', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-0885', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3337', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0697', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2010-1117', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-0310', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-0896', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2001-0527', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2109', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2122', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3349', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-1582', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3351', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0834', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-1601', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1130', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0540', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0554', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0837', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0609', 2.9, 'AV:N/AC:H/Au:M/C:N/I:N/A:P'),
('CVE-2006-1740', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0134', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-0611', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0159', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0169', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2721', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0200', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0202', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0182', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0184', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0207', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0725', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2001-0214', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1264', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0198', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1266', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0228', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1756', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1013', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0229', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0733', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2756', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0018', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0595', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-2517', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-0833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2524', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2005-2531', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0687', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-2541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0010', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0681', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0023', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0028', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0974', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2573', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1116', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1119', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0035', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2597', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2600', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2607', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-10004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-1004', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-1133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2622', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2625', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0060', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0064', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0683', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2001-0078', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3041', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3049', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0392', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1960', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1155', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1971', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1976', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1474', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0418', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3085', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3101', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1476', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1990', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0263', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1484', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0813', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0925', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1151', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3429', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0951', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1255', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0713', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-3449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3451', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1161', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1169', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-1638', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1273', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2169', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0323', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1642', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-3466', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1643', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1196', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0984', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2257', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2265', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2689', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2271', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-0961', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2700', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-0917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0612', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0994', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0927', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0999', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0928', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2286', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2293', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1615', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1001', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1620', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1019', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0792', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-0798', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-1628', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2005-2309', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0400', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-0655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1025', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1014', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0429', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0436', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-0774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0445', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2719', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0799', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0459', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2005-2311', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-1049', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0468', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2720', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0478', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2332', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1072', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0488', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1081', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2726', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1647', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-1112', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0805', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0825', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1656', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1659', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-1128', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0831', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2000-1137', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1038', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1140', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1669', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-1168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1674', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2360', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0939', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0669', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-0672', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-2387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2751', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2755', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0448', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0464', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1187', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3146', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1035', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-3153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1191', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0817', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1501', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2053', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0822', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-1767', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0243', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0246', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0258', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1320', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2798', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2803', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0265', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2810', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1786', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0653', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0662', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0282', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1794', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0851', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2890', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2895', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0888', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0290', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1801', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0225', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0642', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2001-0306', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0229', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0927', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0802', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0806', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1075', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0811', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-0701', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1090', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0727', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1827', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-2962', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1098', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0334', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1104', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-0751', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0756', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0336', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1377', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0991', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0867', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2211', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1670', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0995', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3503', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1672', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1303', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0877', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2224', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0602', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2230', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1678', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2235', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-1684', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1691', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0606', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2257', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2272', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0736', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-2287', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2291', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0225', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2004-2332', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2335', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1708', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2342', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0320', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0364', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2000-0326', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0371', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2000-0332', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0668', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0234', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-0235', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2005-1711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0248', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2004-2349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1718', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2363', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0615', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0678', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0252', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2004-2386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0642', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1742', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1401', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0373', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0387', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0396', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1751', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0262', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2000-0425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0464', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0707', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0643', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-1777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1411', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0517', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0525', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0264', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-0388', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-1801', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2004-2408', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-0815', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2423', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2432', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1808', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0534', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2447', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1830', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2454', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2460', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0539', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0552', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1430', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1438', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-1851', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1856', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0409', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-0775', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1345', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2200', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0002', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0010', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0021', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0028', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-0031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0033', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-1685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0244', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0246', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0247', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0491', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0277', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0104', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0124', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0138', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-0145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0160', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2296', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1704', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2300', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2303', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2307', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2311', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0661', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0207', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0214', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0215', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2004-2321', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0223', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0229', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0233', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-0368', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0238', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2004-2347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2353', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2366', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0617', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0497', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2004-2373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0376', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2396', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1381', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0499', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0691', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0693', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3215', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0491', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3226', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0293', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3233', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3236', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2068', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0824', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3255', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1547', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2087', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0301', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3270', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0826', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0497', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3303', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1554', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1559', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2102', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-1567', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0516', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1103', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1109', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0832', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3342', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1119', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2110', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2131', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1578', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1127', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0702', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-1164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1045', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2653', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0130', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2666', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-2670', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2674', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2677', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2679', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0945', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2005-2682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0135', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0136', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2693', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2696', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0063', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1068', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1079', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1084', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0752', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0083', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1229', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0095', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2012-0115', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0189', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0128', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1247', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0768', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1382', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-1140', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2005-2974', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-2975', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-0995', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1395', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1400', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1146', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1871', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-1879', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0796', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1411', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1131', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-1892', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-1895', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-1899', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1903', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0826', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0832', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-3009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0843', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1912', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-1178', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1925', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1932', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0862', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1146', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0390', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0649', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-1875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0569', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0577', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2495', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-2503', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0845', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0847', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-0853', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0618', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0413', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0417', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-0419', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0281', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2007-0897', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-0287', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2000-0645', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-0653', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0671', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2531', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-0662', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1917', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0431', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0684', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2541', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0908', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1507', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0719', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2004-2562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0735', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0740', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0681', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1511', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1951', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0923', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-0927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0688', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0934', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-1973', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2580', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-0950', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0330', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2005-1989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0341', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2004-2608', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2613', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2005', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2017', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2022', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0813', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2623', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2644', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2064', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-0957', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-2080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0848', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0854', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0860', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0887', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2005-2092', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1541', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-0723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2666', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2115', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0976', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1542', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1392', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0702', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0501', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0259', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-1748', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0382', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2000-0391', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0394', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0628', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0410', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0381', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2000-0437', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0439', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-0511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0467', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0472', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-0639', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1772', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1774', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0509', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0518', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2000-0524', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0527', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0542', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0382', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-1798', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1803', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2428', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0271', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2008-0727', 9.2, 'AV:N/AC:L/Au:S/C:N/I:C/A:C'),
('CVE-2004-2438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2442', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2446', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0395', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1429', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0549', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0408', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1840', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2481', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1849', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1458', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0740', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0574', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0831', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-0836', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0603', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0609', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2513', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0416', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-0645', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0280', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2000-0632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0289', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-0646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1196', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2407', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1701', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-2757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2762', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-1717', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-1219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1720', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1226', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1231', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0589', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-0952', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2479', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1239', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-0830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0014', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1094', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2498', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2512', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0838', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2544', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0011', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1102', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0700', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-0868', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0970', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0701', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-0879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0977', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-0982', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-1115', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0994', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1121', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0893', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0898', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1324', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1714', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0629', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2324', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1721', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1725', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0633', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2329', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2344', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1341', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1353', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1762', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0911', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0649', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3571', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1767', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0402', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2387', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1211', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1790', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0698', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0502', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1403', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-0383', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0629', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-1754', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0423', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0453', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0459', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0469', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0642', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0482', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0515', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0486', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0493', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0499', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0523', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0538', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0384', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-0646', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1417', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1418', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-2424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0270', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-0726', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1813', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2004-2440', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0649', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0394', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-0400', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2470', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0555', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0542', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2005-1847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0653', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-1857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0741', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0743', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0578', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2496', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-0588', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2502', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2504', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0602', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1463', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0852', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0658', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0415', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2004-2517', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1894', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0626', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0288', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2000-0649', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2004-2524', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0660', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0860', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0674', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0425', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-0676', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0866', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1914', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0685', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1488', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0558', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0691', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0695', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0706', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1502', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0718', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1256', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0719', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0137', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0147', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0720', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0165', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0172', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0198', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0983', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0200', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0203', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0636', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-0612', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-0618', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-1743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0772', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-10004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0220', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0773', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1282', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0224', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1759', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1293', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0779', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0457', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0462', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-0468', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-2152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0474', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2005-2158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2162', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0350', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-2180', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0478', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-0594', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0600', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0901', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2214', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0909', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1571', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0930', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0609', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0950', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2246', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2687', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0958', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2696', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-2273', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0916', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0745', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0373', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2000-0987', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0749', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2006-1598', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-0753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0757', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0765', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1970', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1157', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-0810', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0424', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0812', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0262', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0437', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1998', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1189', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2001-0447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3131', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0449', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0450', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1194', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3139', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3143', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1195', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1190', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0468', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3149', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2024', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-3158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1192', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1201', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1593', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1599', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1607', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1131', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3378', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3384', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2142', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0544', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1240', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3409', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0914', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2153', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1150', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-1616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0560', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0709', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1246', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3433', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0847', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-0715', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-0979', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0321', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2165', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1279', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1647', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-3480', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1651', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0580', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0328', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1283', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1282', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0585', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3493', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1284', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-1295', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1296', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1288', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3497', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1299', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1198', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2196', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1663', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1215', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1045', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1049', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1056', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-2409', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1058', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1381', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2415', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1803', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0688', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3624', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3634', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2433', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1385', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1371', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0937', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1820', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2452', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1828', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1830', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3669', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1834', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1241', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1392', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0712', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0560', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0303', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-1508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0310', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1963', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1520', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0320', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-0327', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-1972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0698', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2575', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2588', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2596', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0435', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2005-1997', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0785', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0954', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0803', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2043', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0885', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2059', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2065', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2655', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2005-2079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2087', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0577', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2112', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0977', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2015-0460', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2143', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0897', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2000-0881', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2159', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2169', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0351', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-2184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0359', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-2192', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0482', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-0490', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2015-0495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0599', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0919', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1553', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-0899', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2209', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-0925', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2226', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0986', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0364', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2004-2685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0953', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0738', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0657', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0293', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2000-0680', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2532', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0296', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2000-0686', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2538', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0667', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0668', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0692', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0701', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0646', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0919', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2000-0731', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0679', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0306', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0311', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-1949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0922', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0312', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0325', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2007-0945', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0781', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0571', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0335', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0338', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0340', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-1999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0572', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2617', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0806', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0440', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0824', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0827', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2627', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2636', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2054', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2645', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0575', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2657', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2090', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0488', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2199', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2204', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2210', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2213', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2216', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0490', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0035', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2000-0250', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0258', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2004-2225', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2229', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2231', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-2234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-1688', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0278', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0280', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2016-0072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2258', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2259', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0357', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1696', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-1701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0590', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-0103', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0107', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2004-2265', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1356', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-0147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0148', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2004-2275', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1703', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2284', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-1705', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0664', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0221', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0783', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2000-0333', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0342', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0236', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-0611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2351', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2357', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2398', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0354', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1135', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-0843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0549', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-0553', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0556', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-1148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0599', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2007-1159', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0562', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0721', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-1165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1034', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0113', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0123', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0728', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-0931', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2005-2642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0729', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0128', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1055', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2672', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2689', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0139', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0142', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1177', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-0579', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0947', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0059', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-0736', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-0581', 7.8, 'AV:N/AC:L/Au:S/C:C/I:N/A:P'),
('CVE-2016-0607', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2007-1327', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2806', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1332', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2816', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1787', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-2838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0654', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-2853', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0274', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1793', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-1039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2879', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0862', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2891', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0795', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-0877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-0883', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0891', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-0899', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-0222', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0911', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2917', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0297', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2918', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0682', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0305', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2932', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1349', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0929', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0934', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-1070', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0232', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-1076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0948', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0952', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1823', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0327', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0718', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-0967', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0746', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0753', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0760', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2972', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0338', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1218', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0286', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0480', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3198', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2056', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3207', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2063', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3219', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3224', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0294', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-0299', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3245', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2079', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2091', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1210', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2093', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2005-3291', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3307', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1557', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2099', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1565', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0671', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-1568', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0686', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-0692', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2001-0517', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3339', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1115', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0895', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-3343', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0897', 6.9, 'AV:L/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2010-1121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0758', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3355', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3357', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2007-1587', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1591', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1598', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0382', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-2301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0393', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-0396', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-0650', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0413', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-0425', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-0432', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2000-1030', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0778', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-0457', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0784', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0786', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0467', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2000-1052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1055', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1057', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2330', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0508', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2004-2725', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0822', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1029', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0799', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0816', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0830', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1143', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1162', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2344', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0824', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0517', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1183', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1682', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0521', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2004-2741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0667', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1690', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1061', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0635', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-1694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0531', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2000-1203', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0543', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0523', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2410', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2411', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2764', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0677', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2005-1779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0715', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1786', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0269', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2445', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2458', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0396', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0403', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0538', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0550', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0821', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1437', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2480', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2489', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0583', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2498', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-1881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2106', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0868', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2114', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0443', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0450', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0453', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0467', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0764', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0357', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2005-2191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0480', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-0484', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0903', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0910', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0900', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-2211', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0922', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0912', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-0984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0734', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2219', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0939', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0736', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2231', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0737', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-0741', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2268', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1583', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-1586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0743', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2277', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0372', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2000-0969', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0983', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1595', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-0774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1604', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1000', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0756', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2285', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0781', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2297', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0791', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1002', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-1017', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1010', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0390', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0392', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-0398', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2000-1023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1024', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0407', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0415', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0781', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-0788', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0789', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-0790', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0473', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2000-1060', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0480', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0482', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0489', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-2721', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-1092', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0819', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1666', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0990', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-0866', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0356', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1669', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3502', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0996', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2222', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1291', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1293', 4.9, 'AV:A/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0365', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-3523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1685', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2243', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2248', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1306', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2250', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0731', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-1696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2265', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2271', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3546', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2273', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2285', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0733', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0612', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3551', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2292', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0739', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-3553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0740', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2009-1332', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1711', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0900', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3567', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-1106', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2012-0244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1853', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-2982', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2990', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0996', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-1151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1134', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1896', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-1904', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0827', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0835', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0847', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-1176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1427', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0798', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0800', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2254', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2694', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2000-0959', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2000-0976', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0985', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0988', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2283', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0759', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0501', 6.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:C'),
('CVE-2004-2708', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0377', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-10002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0378', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-1626', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0385', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-1627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1635', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1638', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1013', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1029', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0424', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2016-0435', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1017', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0444', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0446', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0452', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1041', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0462', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1019', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-1051', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1054', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0474', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2000-1061', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-1070', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1073', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0492', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1080', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1087', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0812', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1027', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0512', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-0501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1110', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0817', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1134', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0931', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0514', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1046', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1147', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1160', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2343', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-1672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1172', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1673', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-0938', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1676', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1680', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-2371', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0666', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1190', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2382', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2389', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2395', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2750', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0515', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0527', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1198', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0538', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1208', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1065', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-0648', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-1074', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-1702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0650', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2766', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-1713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0546', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1727', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1732', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1738', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1742', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2340', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-1339', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2001-0641', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1351', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1357', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1756', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2351', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2355', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2361', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2368', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2383', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0750', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1369', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0410', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0752', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-3585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1210', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0420', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1374', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1788', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0433', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-0440', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0755', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2010-1216', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2406', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1377', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0681', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1221', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1225', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0760', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0138', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2710', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0145', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2715', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2722', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0205', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0186', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-0209', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0634', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0993', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0206', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0613', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-0770', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0731', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0620', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-1747', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0775', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1279', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0225', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0227', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1760', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0208', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-0210', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0848', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1288', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2771', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0652', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0214', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1294', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1301', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-1016', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-1773', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0780', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0385', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3052', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1447', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1451', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-0805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0404', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1465', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1466', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0417', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1170', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3088', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3104', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0811', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-1989', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1997', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1184', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0653', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2001-0443', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2016', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0453', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3138', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0454', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0655', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-1466', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2011-0552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0421', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1898', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0278', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2000-0631', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0650', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1480', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0423', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-1907', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0869', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0871', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-0663', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0681', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0297', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-0664', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1494', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2004-2546', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2000-0697', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0301', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-0910', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0725', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0745', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0758', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1956', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0564', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0685', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0318', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-0319', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2000-0774', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0942', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-0946', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0699', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2578', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1976', 2.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2004-2600', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2604', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2611', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2615', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2008', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0802', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0553', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0557', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-0560', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0679', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0581', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0591', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-2448', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1235', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-2463', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0826', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2477', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1091', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0010', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-1244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0024', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2522', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2526', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0843', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0686', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0851', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0005', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2540', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0008', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0859', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0863', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0029', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0034', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0980', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2007-1110', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2577', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0043', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-10001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2001-0054', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0708', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1126', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0538', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2620', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1009', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0545', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0911', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1728', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0550', 7.8, 'AV:N/AC:L/Au:N/C:C/I:N/A:P'),
('CVE-2005-2634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0555', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0097', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1151', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0718', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-0103', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1730', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0110', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2638', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0114', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0118', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-0926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0051', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2005-1737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-0506', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2000-0397', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0625', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2000-0406', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-1757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0426', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1405', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2000-0436', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0633', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0444', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0455', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1406', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0465', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1767', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0476', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0498', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0504', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1781', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0644', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-0519', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-0523', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-0536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0809', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-0811', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0389', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-0526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-1804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0817', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-1421', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2441', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0819', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2004-2462', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0401', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2004-2472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0548', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0558', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0273', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2004-2479', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0652', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-1454', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-1859', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0546', 10.0, 'AV:A/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2005-1871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0567', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0575', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2492', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2505', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1884', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-0748', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0842', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-0854', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0548', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-1890', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0625', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0630', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0284', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2005-3148', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0658', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1502', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1505', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1217', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2029', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2031', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3194', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0665', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-1055', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2060', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1539', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3216', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3227', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0298', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2005-3244', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1065', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2073', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2077', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2081', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1543', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3268', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1214', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-3285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2094', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1655', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-2338', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1037', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0835', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1045', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1142', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1163', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0515', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2000-1174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2362', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1056', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2733', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-1677', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1684', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2373', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0629', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0673', 9.2, 'AV:N/AC:L/Au:N/C:C/I:N/A:C'),
('CVE-2011-0633', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0505', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2016-0518', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0526', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0539', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0647', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1214', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1707', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2763', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-1714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2769', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0562', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-0563', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0567', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2426', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2430', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2433', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2437', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2778', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2005-2465', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-0681', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1090', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-0828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0007', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1243', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0023', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2525', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2527', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1725', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0004', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2557', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0596', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2001-0024', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0032', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0971', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0556', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-0565', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0678', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0571', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1224', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0678', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1085', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-1087', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1237', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0682', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0012', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-1242', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-0020', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0683', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0955', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2529', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0694', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2546', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0697', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2554', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2005-2567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0865', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0964', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0969', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-0987', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-0991', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0052', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0901', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2005-2609', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2613', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2618', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2624', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1013', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1015', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2001-0068', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-1132', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0314', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3366', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1142', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2005-3372', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3381', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1609', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0538', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2147', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1610', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0543', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3399', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0557', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1270', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1247', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-0959', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1254', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3436', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1620', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3445', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2160', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3452', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3456', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1628', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1264', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-3459', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1163', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0567', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0975', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0569', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3463', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1278', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1177', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1180', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1185', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0571', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2182', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0854', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-3471', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1648', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1650', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1191', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-3487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1281', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1654', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0582', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1292', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0720', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-1286', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-3495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0337', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1662', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0989', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-1301', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2199', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0600', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0763', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0712', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2004-2620', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0825', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0828', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2629', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2640', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2057', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2652', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0838', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2085', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1538', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2000-0858', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2662', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2104', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0893', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0449', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2127', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2146', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0887', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2166', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0345', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-2179', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0586', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0897', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0496', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2000-0907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0766', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1556', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1562', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2212', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-0923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0767', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1577', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2225', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0941', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1578', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2230', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0949', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1584', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0500', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-2282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0999', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1614', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0787', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-2291', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0788', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1005', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1018', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1009', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0387', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-2306', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0397', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-0653', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0402', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0405', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2000-1026', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0412', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-0427', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1641', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1035', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2718', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0451', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0621', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1066', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0684', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0442', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1233', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0701', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1387', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3656', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2465', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3673', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-1791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1033', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2005-2878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0285', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0861', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0793', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2010-0868', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-0872', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2898', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0884', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0894', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1799', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2930', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1350', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0925', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0933', 6.9, 'AV:N/AC:L/Au:S/C:N/I:C/A:N'),
('CVE-2012-0230', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2940', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0804', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2012-0231', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2944', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0311', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2945', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0699', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0706', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-1824', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2956', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0961', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1089', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0736', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0741', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1369', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0982', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-0749', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-0560', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0719', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0923', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0723', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0107', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0111', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0925', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0727', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0122', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0049', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2009-1042', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0125', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1731', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0975', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-0979', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-2572', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-1114', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-0990', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2001-0040', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1120', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0892', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-2588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2593', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0037', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2610', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1127', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1014', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-1017', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2001-0066', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0541', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0077', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0087', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0098', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2635', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-0915', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-0919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0561', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0104', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0725', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-0924', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2640', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0117', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0050', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1040', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1044', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2648', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0127', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-2656', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0730', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-0937', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0940', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1173', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2660', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1082', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-0498', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3310', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-1232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0499', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1558', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-3317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0503', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0509', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0873', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0884', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-2101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0672', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0675', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-3328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0684', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0690', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2001-0518', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1099', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0887', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1110', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1116', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0528', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0900', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2117', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2123', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1574', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2132', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-1125', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0313', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1239', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1596', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0534', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3360', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1137', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1140', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3374', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3379', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2145', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2150', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0549', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0553', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3401', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3405', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3412', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0705', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-3421', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3425', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0707', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2001-0556', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0919', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0559', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1155', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1250', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-0711', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-1257', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2010-1160', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3442', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1260', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3458', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1277', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-1167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-1170', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-2690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2699', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2700', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0580', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1179', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0737', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1187', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2015-0591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0960', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1199', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-1070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0745', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-1072', 6.9, 'AV:L/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2012-0116', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2012-0124', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0188', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1253', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0192', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0759', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0194', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0158', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0616', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-0879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1301', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2001-0603', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1305', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1304', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0376', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1312', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2258', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1006', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0765', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0738', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-0894', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-3554', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1314', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1326', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1712', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0654', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0665', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2529', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2530', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2000-0677', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1905', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2533', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-0903', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-1922', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0557', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1493', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1928', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-0693', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0708', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1504', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-0911', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2000-0738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-1934', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0304', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-0682', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-1944', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0754', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0759', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-1953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0768', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-1959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0566', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0314', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-0876', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-1970', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0696', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0780', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2586', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2594', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2597', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-1990', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0436', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2004-2609', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2002', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2007', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2024', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0711', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2004-2616', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2000-0805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0811', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2004-2625', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2040', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2633', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2004-2637', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-2053', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2061', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2654', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-0836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0716', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2000-0855', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2004-2663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0892', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-0720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0725', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-0970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0344', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-0459', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2144', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0469', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0880', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2000-0884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-0888', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0765', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2176', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0353', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-0588', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0361', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-0479', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-0592', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-0898', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0493', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2000-0905', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0912', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0917', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1549', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-0982', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-0924', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-0983', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2223', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0805', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1048', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0785', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-0465', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-2317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0475', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-0483', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0487', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1078', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1086', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2728', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-0809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1646', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1099', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0499', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1031', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1650', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1652', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-0803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0814', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0826', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2000-1131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0828', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-1661', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1039', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-1138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0503', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2000-1165', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1173', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1054', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0627', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1687', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2004-2738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0628', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2004-2744', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2403', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2004-2752', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0517', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0530', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2000-1201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1064', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2000-1212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0649', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2414', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-1708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1711', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0652', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0550', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0554', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0559', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2420', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2000-1233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0587', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2443', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2449', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1405', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0713', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1840', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0448', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-2492', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-1385', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1843', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1745', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-10003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1003', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2754', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0732', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1007', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0221', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1763', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0212', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0231', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1290', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1766', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-2774', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2776', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2785', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1303', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2001-0250', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0739', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-1322', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2805', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1020', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2811', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1784', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1341', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0270', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1792', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2854', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0283', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1040', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2877', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0856', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0864', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0873', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0744', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2919', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0671', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0684', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-2931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1808', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0149', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1186', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1192', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0958', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0962', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1197', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1203', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3573', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1361', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2364', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0401', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-3577', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1366', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1024', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-1333', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2001-0665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3583', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3587', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1785', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2005-3592', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1361', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-2403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0921', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1794', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1050', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0679', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0769', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1840', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-1105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1378', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1143', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0354', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0988', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-0994', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1391', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-0822', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1124', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1900', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-0828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3006', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0836', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-1908', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1177', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3011', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3018', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1920', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1435', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1934', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1938', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3051', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1149', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0394', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1452', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1457', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0948', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0150', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-0955', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1734', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1184', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0739', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0956', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0963', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1064', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-1069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0701', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2001-0167', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-1216', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-0067', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1218', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0704', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-0173', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1226', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2001-0175', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1736', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0088', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2001-0180', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0106', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2005-2705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0119', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-0707', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0710', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1249', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0978', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0758', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0614', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0162', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0167', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1812', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-0932', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1813', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1817', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0235', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-1092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0963', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1368', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-0742', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0979', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1103', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-0755', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-0240', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-1383', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0773', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-1850', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0344', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0352', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0243', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1107', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0816', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-1392', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1397', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1111', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1147', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2992', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1882', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2994', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0361', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2008-1127', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-1890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0250', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0825', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0837', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-0844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0851', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-0861', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-0749', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0383', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1175', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2176', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2180', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-3465', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-1279', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1645', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3474', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0982', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2190', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0586', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0330', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-0983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2469', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2474', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2482', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0953', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-0837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2534', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2012-0030', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2005-2542', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0021', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0025', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0031', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0871', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0882', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1109', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1111', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0988', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2009-0992', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2001-0044', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0887', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2001-0051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0896', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-0900', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-0682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-10003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-2606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0905', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1003', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1006', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0071', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0686', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2228', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0942', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2000-0946', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2240', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2000-0954', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2004-2690', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2004-2695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2274', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-0371', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-0649', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2000-0978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2281', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-0990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0752', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1608', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0618', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-0929', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1619', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1622', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1007', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0793', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0797', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0651', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0421', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0430', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0442', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0775', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-0776', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0453', 2.9, 'AV:A/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2000-1046', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-0807', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2016-0469', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-2320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1024', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-0930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0808', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0490', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2004-2722', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1090', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1645', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1101', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0498', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2000-1108', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1649', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0801', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-0823', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2000-1133', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0833', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1665', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N');
INSERT INTO `tpandora_cve` VALUES
('CVE-2007-1047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1141', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2000-1154', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1164', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-0936', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2351', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2000-1176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2363', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2000-1180', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1678', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2372', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2004-2737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1364', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2427', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2438', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0934', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1389', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1821', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1831', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-2463', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2466', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-2468', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-3667', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2472', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-0941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1833', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0943', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-0764', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-2475', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-2480', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0445', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0962', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1250', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1253', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1256', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-2489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1384', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-3693', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3698', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1089', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-2375', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2376', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2392', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2398', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0512', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0521', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0529', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0541', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1079', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2004-2760', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1718', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1722', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2000-1229', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2436', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2452', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1086', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0679', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2000-1240', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0954', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-0956', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2532', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0688', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2538', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0698', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2565', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-0860', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-0968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2570', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-0973', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-0978', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-0985', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2007-1117', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-0996', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-0894', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0902', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2608', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0904', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-1001', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-1129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0540', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-2619', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0391', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0398', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1954', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1968', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3065', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1014', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1470', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1977', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0420', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3079', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-1169', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-1174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3098', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0431', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1985', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1999', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1185', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2006', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0264', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3124', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1487', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2014', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0465', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3069', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3072', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1972', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0410', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1167', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1475', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3087', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3090', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1478', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0651', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-1988', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1996', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3116', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1485', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2003', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2011', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1486', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3129', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2017', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3137', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3142', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0269', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3144', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0463', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0271', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1203', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-0276', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0277', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1195', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0278', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1216', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1514', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0819', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0476', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1230', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3184', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1522', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2062', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-2065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0295', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3235', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1057', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1061', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3246', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3249', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-1071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2084', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0495', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0302', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3261', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3265', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-0982', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-0722', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0187', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1263', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0208', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0218', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0728', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0771', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1010', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0222', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2779', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1302', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1094', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1319', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1018', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2791', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2796', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2804', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1329', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2818', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2839', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1022', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1789', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2851', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0275', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0277', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2866', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0857', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-0859', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0287', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0664', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-0871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2896', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2900', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0887', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0900', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-0904', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0665', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2010-0917', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2001-0294', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2922', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1056', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1811', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1352', 4.9, 'AV:A/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2005-2936', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1074', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0947', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0953', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0704', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0715', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-2947', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0084', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0091', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2001-0096', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1145', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0598', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2007-1156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0557', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-0564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-0921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1729', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-0108', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-2655', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0603', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1053', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2664', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2668', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0987', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-3708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0729', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1862', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0453', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1096', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1401', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2512', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-1101', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1866', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1285', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1286', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0747', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1406', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1877', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-2528', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2533', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2534', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3736', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1430', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0762', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0765', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0767', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2538', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-2540', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2543', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2546', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1416', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1883', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-1884', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3747', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0778', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1431', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2026', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-1210', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2028', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-0661', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1516', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1222', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1040', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3183', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1228', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2041', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0869', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0291', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3202', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3205', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-3211', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1056', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1058', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1062', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3247', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1544', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1077', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3267', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1211', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-1215', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1225', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0304', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3292', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2095', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2096', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0829', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0505', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1562', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0880', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2100', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2016-0668', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-1233', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3279', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1081', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3300', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0757', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0679', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:H'),
('CVE-2016-0685', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0689', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2001-0515', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1097', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1100', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1107', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-1108', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-1111', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0696', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-0699', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-0701', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-3347', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2111', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1770', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0255', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2001-0264', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2792', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0216', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1019', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0742', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2815', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-1785', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2005-2829', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1790', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0272', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0787', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-2863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2874', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0791', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-2892', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0796', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-2897', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0885', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2010-0892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0898', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0289', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0909', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-1800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0293', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0224', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0919', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-0227', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1351', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2005-2935', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1068', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0944', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2946', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1080', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0716', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0320', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1086', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1093', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0236', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1364', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-2963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0971', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-0975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1835', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1371', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0758', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1842', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-0985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1379', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0770', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1130', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1142', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0993', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-1389', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1406', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0817', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1120', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1870', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-1876', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-1883', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1150', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2226', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1202', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-10004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-3530', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0366', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1689', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3533', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2247', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3537', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1307', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1699', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1008', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-2290', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2294', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2297', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2001-0615', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1317', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1322', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1322', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0616', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0624', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0628', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0630', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1723', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2332', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-2335', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0391', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2343', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-0905', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2347', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1352', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0648', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0396', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-0912', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0132', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1058', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1733', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0137', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0143', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0946', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2016-0606', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1182', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1190', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0062', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-0959', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0595', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1074', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1076', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1077', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1081', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1083', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1222', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0596', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0073', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0075', 2.9, 'AV:N/AC:H/Au:M/C:N/I:P/A:N'),
('CVE-2009-1088', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1227', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-0091', 4.9, 'AV:A/AC:H/Au:M/C:N/I:P/A:P'),
('CVE-2001-0181', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1237', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0127', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1244', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1262', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2711', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0170', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0979', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0206', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0723', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0189', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0765', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0213', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1572', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3341', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3346', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1120', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1122', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2126', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1580', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2010-1126', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1584', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1240', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1597', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1138', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3377', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2146', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3387', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3402', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-3406', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0316', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0839', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-0708', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-2955', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1088', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2960', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0238', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1102', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0754', 7.8, 'AV:N/AC:L/Au:S/C:P/I:N/A:C'),
('CVE-2005-2966', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-1843', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-0984', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0242', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1139', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0355', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1108', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-0991', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1123', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0998', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1885', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1412', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-0823', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1897', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1419', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-1906', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0256', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1426', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1909', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-10006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-1914', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1179', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1921', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-1924', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3030', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1939', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0257', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1145', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2623', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2628', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-2630', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1018', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-1021', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2015-0542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0076', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0546', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1029', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0099', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1157', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-0559', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-0920', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-2657', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0602', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-0942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0131', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-1054', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2124', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1237', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1606', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0910', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-1133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1139', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3370', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3376', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2144', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0912', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0555', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0917', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0922', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0924', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0926', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0317', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1888', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1126', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1128', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1893', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1416', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0833', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1421', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3007', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-0848', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1171', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-1174', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0858', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-1140', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1141', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-10007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-1915', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1922', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3026', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1929', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1940', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1945', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1439', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0802', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0399', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1953', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-1956', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3067', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1461', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-1183', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0415', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1979', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-1980', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3086', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3089', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-1176', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0434', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-1987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1183', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3115', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1188', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0654', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-1152', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1617', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3431', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1253', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1259', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3439', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2159', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3450', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0760', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0319', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-1168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0978', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0322', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1179', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0852', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1640', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2183', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1646', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0761', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1653', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1287', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2191', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1659', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1768', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1770', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1370', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1775', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0666', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1031', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-1352', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2400', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1212', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0426', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0430', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-0432', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2402', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0674', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2412', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1218', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1227', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1379', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2416', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0687', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3622', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1363', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-3638', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0696', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2425', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1365', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-3650', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1386', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2443', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1370', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1824', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1827', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-1391', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3666', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1832', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1835', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1239', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1377', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-1242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3678', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2476', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2483', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3687', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1171', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2011-0980', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1637', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1649', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-1190', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3488', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1290', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0329', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-3492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1197', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2194', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1661', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2007-1665', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0988', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2198', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2016-0724', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-1948', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2001-0393', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0751', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0258', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0406', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3073', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0807', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3080', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1173', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1480', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0432', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1991', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-1995', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0652', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2015', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3133', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0268', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2209', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2216', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2220', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1292', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3513', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2228', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1295', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1300', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1680', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3526', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-3529', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2237', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1688', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-0882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2251', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1003', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1697', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1316', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0734', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2286', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1701', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2296', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2304', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2310', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0741', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-3555', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-3556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2317', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1713', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1717', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1718', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2005-3569', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0390', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-1736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2331', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1743', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1744', 9.2, 'AV:L/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2001-0643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1348', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2016-0746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1287', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1199', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2204', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-1200', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0599', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1000', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1675', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2234', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1683', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0604', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2244', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1306', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0367', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0764', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3548', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-2279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1007', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3550', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2289', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2293', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2308', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-2312', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2009-1320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1327', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1331', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1709', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0620', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1719', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3566', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2325', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1726', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2330', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1850', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0770', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-1273', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1858', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2001-0727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1427', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-1394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2501', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3728', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3732', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0979', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2007-1181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0740', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0588', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-0967', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1078', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-1219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1224', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1086', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-0070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2001-0176', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0078', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0082', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-1739', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0182', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0111', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0122', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0706', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2005-2706', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1255', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-0610', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-0143', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0163', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2719', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0199', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0190', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2737', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-0984', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0726', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0202', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0767', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0267', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3140', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1196', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0459', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0275', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1198', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-1494', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3152', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1198', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2016-0659', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1511', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-0283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0868', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1039', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1226', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0870', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3187', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2051', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-0487', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2055', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2058', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3214', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3220', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3225', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3228', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3232', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1060', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1066', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0493', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2080', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3258', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3278', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3288', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0666', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-3304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3311', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3313', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1764', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-0907', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1358', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3574', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0767', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2363', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0653', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2366', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0400', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1208', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2393', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2396', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-0751', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1781', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3581', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0419', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1782', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1373', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-1357', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2015-0918', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2401', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0920', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0439', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2405', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0675', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1217', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1051', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1052', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0682', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2414', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-3147', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0816', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1196', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0279', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1038', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2027', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-3178', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2036', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1519', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2046', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3197', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1525', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0292', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0297', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3240', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3242', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1068', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0492', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0825', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2092', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1213', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1218', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0308', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1561', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3320', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0507', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0513', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1093', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0673', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0677', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1300', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-2787', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1306', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0253', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1017', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1331', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1779', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0784', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1024', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0280', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2864', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-2867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1795', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-2876', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0217', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-0879', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-1047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0912', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0223', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1802', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2923', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-1344', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0828', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0830', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0875', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-3325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0683', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0691', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2010-1095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2104', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0889', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0695', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2001-0523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0700', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-0311', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3345', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1573', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-0901', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0904', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2006-2127', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2130', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0833', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1589', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1141', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2005-3375', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2140', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3389', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0546', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0913', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0393', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2001-0644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1765', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0397', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-0913', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-0747', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-0403', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2006-2378', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0914', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2385', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-2389', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2394', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-1025', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1029', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2001-0667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1032', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0753', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2005-3594', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1375', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1793', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1795', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0757', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-2408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1797', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1799', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2001-0680', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0925', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0926', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1064', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2418', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1068', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2001-0689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3626', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0691', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2434', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1232', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3653', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1368', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0920', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1810', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0923', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0928', 6.9, 'AV:L/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2015-0689', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2005-2938', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1069', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1072', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-1098', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1360', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-1820', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-0322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1362', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-0960', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1091', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-2958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0977', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0750', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-1836', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-0983', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-2968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1844', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2970', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0747', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0990', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1390', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2991', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1867', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1410', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-2996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1130', 9.2, 'AV:L/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2006-1889', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-1901', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0830', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0681', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-0687', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2001-0520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2106', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3329', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0890', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0894', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-1118', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3344', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0899', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2119', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2129', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-1577', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0529', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0908', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1594', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1600', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2134', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0703', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-3361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3368', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3371', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2139', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0704', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-1147', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-1611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0545', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0547', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3403', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3427', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1153', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-1157', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-1159', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0563', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3438', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3444', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3446', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3453', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0846', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1621', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1626', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3457', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2424', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3633', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2431', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2435', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0697', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1366', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1812', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1819', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0707', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1826', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2460', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-1240', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1407', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3680', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1245', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1249', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0967', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2491', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2005-2820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2836', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-2840', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2845', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-2850', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-2855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0273', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-0786', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-1038', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0219', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-2887', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-0866', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-0874', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0878', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-0896', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2010-0903', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0918', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1803', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0680', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1806', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-1063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-0921', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-0931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0745', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0643', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2005-3008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0255', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1172', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0859', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-1428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3012', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3021', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0377', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-10010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-3050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-1946', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-1148', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1958', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1449', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-1455', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1963', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2015-0806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3070', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2008-1161', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1472', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0416', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3077', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-1992', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-1019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2002', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3121', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3126', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3128', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0446', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1191', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0753', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0558', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1244', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0844', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0710', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1275', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2156', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0961', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3440', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2158', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1261', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0962', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3461', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0848', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2163', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0850', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0568', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1172', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-1636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1272', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2166', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2006-2175', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2178', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3464', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3657', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2462', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3663', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3675', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-0763', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2008-1379', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2016-0765', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-1404', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0951', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1409', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2477', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2006-2482', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1244', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1380', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1260', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1417', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0715', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3694', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1421', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1268', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2497', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-0769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1390', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1853', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0771', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2007-1859', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0772', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2010-1278', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0730', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0731', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0725', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-0737', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1097', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1830', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-0976', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0814', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1841', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-1848', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-1375', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1128', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1135', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-0340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-0992', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0794', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-1394', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-2980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1401', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1404', 9.2, 'AV:A/AC:M/Au:N/C:C/I:N/A:C'),
('CVE-2006-1866', 9.5, 'AV:N/AC:L/Au:N/C:P/I:C/A:C'),
('CVE-2006-1873', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-0748', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-10001', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2005-3000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1135', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0831', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-0253', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0840', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-1911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-10004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-1429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3016', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1916', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-1923', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3027', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1267', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0716', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-0970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-3707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1854', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1856', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0773', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-3710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1393', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1097', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1398', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1098', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0980', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2011-1102', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1868', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2516', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2519', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0749', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1411', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1288', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1108', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1165', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-1266', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1639', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2009-1274', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-2171', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0574', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1186', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1280', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0326', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1192', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0583', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3472', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1189', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0856', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2188', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1655', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1286', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0581', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0584', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1291', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0590', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0333', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0721', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2011-0986', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0593', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2197', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2202', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3500', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0359', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0361', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0597', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1290', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3510', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0878', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-2227', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1203', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1674', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2236', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-1302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2242', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1309', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2254', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1005', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2262', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2274', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2280', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1698', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0888', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-1319', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1318', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-0895', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1329', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0623', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0899', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-2320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3559', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1331', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0656', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3166', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2033', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1221', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0820', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-1229', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0821', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3191', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2047', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2052', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-0486', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1053', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3206', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3209', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3213', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1063', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1067', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2076', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0300', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1546', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3256', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0303', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1549', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0306', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0827', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1397', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1099', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2007-1864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1869', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1876', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0746', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1407', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0782', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2001-0761', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2544', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0777', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1417', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1881', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-1425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1294', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0787', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2001-0782', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1429', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1437', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2553', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0785', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0789', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0791', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0794', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1893', 6.4, 'AV:A/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-1435', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1447', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2006-2557', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3759', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1465', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1467', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1895', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3771', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3777', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-2564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0508', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1235', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0674', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2007-1569', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0680', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-0688', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-0694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-1096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2105', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1571', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3331', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-0886', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3340', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1236', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1123', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0903', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2120', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1576', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1581', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3353', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1605', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3373', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0315', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3411', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0706', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-1931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3036', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1936', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-1942', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3054', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0387', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1147', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1154', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-1959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-1965', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3064', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1460', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3068', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1463', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1158', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-1974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0407', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3097', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1186', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-1993', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-20001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-3127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2012', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0266', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1031', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0466', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2023', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1495', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3156', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3163', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1206', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2195', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0875', 2.9, 'AV:A/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-2221', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3507', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3517', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0601', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1304', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1204', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1673', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3524', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0880', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1687', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2245', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1310', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1693', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1311', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1004', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2006-2264', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2268', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3549', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0609', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-0737', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-1320', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0890', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1702', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1321', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2305', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1898', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1469', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-0392', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1745', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-1356', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2353', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2354', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1766', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2365', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0398', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1773', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-2386', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1026', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0916', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-3582', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3586', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1340', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-1349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1358', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1362', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0435', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0923', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0756', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-2407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0678', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1219', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1223', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1513', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0289', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1231', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3188', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2001-0482', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3193', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1521', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3203', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2059', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3210', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3223', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3231', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3241', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1064', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3248', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0756', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1079', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0305', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3293', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3299', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3306', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1231', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3319', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0506', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0882', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2103', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2005-3323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0831', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1328', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1330', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1328', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3568', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2323', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0902', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1018', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1347', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0906', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-1205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-1106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3338', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1112', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0698', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0898', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0905', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2007-1575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1579', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1583', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3354', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1128', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2149', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3393', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0552', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0394', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2349', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2356', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1771', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0407', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2388', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2397', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-1027', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1778', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3580', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0418', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1784', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0754', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2010-1214', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0922', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1054', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1796', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0677', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1380', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2419', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0685', 4.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2009-1384', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2422', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1230', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1614', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0916', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0920', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-0923', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0840', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1248', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1158', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1251', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3437', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0712', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0714', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-3448', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1276', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-1625', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1631', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0963', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-0966', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2011-0976', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0851', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1271', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1275', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2170', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-2174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1276', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0855', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2187', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3484', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1293', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1300', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0862', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1664', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2201', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-3498', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2210', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2212', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-0994', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2218', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0874', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-3505', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-0997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2223', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0364', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2005-3516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-10002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2229', 4.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:P'),
('CVE-2008-1299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3525', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1378', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1804', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1229', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0931', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2423', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3632', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0933', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-2426', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-3640', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0698', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3647', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2439', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-2441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1813', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2447', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2458', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-1829', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3662', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1374', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3676', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0444', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0961', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1254', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1258', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3689', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1262', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1415', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0714', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0771', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1149', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0915', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0918', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0921', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-0941', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2154', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1273', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3432', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1252', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-0960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2155', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3441', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3447', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2161', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3455', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1622', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3460', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1166', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-2162', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-0977', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1635', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-1270', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2173', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2001-0570', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3468', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2186', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3475', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2189', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1284', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1289', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-1194', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0861', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-0762', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3649', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0706', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1373', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3685', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3531', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1682', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1690', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2241', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1303', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1307', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1002', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1695', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2252', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2256', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2269', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0886', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2284', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2303', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1313', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1325', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1330', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-1271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2496', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2500', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0772', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2005-3711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0978', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2502', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2511', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-1100', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-1103', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-0992', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2006-2200', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-0993', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1667', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0725', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2203', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2206', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2213', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0363', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-0883', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2246', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-0884', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3543', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0885', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2276', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2278', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1318', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0389', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2328', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2333', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2336', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2339', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0634', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1350', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1747', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2348', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0646', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0395', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2357', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1362', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1207', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3576', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2382', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0660', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2390', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2395', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0915', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1371', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0417', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3589', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1338', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1353', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1786', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1036', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2008-1359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1213', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2404', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1792', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1263', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-1088', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3691', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0969', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3699', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0717', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1091', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-1389', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0971', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1392', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1095', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-1281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-1400', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3729', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2505', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-1867', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2515', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2520', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1405', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1878', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0778', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1879', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1289', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2529', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2536', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3737', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0760', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1291', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0784', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-1292', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2542', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2545', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1412', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2547', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0776', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1423', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0457', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1296', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2518', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-0745', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1410', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-0774', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2525', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2530', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0781', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2001-0756', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0783', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2001-0764', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0768', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2539', 6.4, 'AV:L/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2005-3746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1415', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1419', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-1882', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-1427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1886', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1295', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2288', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-2295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1311', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2306', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2309', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-1316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2311', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-1011', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1323', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1329', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1710', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0625', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3557', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0631', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2326', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1015', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1729', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1733', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1739', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1741', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-2341', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0904', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2001-0642', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1354', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1749', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1751', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0910', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1228', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1382', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3625', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3635', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0693', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2430', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3645', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1071', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2442', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1822', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2459', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2461', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2464', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3668', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3671', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0708', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0762', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-0950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1394', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1406', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1408', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1410', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2479', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1412', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2001-0712', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1252', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2486', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-1257', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1259', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1264', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-1416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2490', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0447', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1419', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2005-3696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2498', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1891', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1438', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1442', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1434', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2554', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1446', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-2558', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3760', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3763', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3766', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3770', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2568', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1901', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-1903', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-0992', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3787', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2576', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3791', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3795', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-0996', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3799', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2577', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2578', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1022', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0406', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2392', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1332', 9.2, 'AV:N/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2006-2398', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1776', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1337', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0411', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0768', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3590', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0421', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0429', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-1787', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0434', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1376', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1046', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-2410', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1802', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-1065', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2417', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1067', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-3636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2428', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2437', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0703', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1072', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-1817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1823', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2467', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-2471', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0938', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3672', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0709', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0722', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-1277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1860', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1094', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-0973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0977', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1396', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-2503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-2504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0777', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-1870', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-1874', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0741', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0744', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-0748', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1404', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1918', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1484', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-1450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1453', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1087', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-3690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1420', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1387', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-1270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2494', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0768', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-1848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0972', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0723', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1279', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0449', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2526', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2535', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1290', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0759', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3740', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0769', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0775', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0774', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1420', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1432', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1892', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2550', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2552', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0784', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0788', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0790', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0795', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1434', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2555', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2556', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1448', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2008-1455', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3764', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3767', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3773', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3776', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2566', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1297', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1298', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1899', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1902', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-0991', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1473', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0995', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3785', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3786', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0460', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-0450', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-0974', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0735', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0773', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0736', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2506', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2508', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-2510', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1402', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-1104', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1284', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0743', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1287', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2524', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2532', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-0456', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3738', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3739', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1880', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2001-0766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2571', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3789', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1314', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0803', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0804', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0805', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1442', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3800', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3801', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1910', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1911', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-1915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1916', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1917', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1483', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1446', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1448', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3811', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3813', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2001-0816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0780', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0783', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1444', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1113', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1437', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1462', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0458', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1896', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1897', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1900', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-0990', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1472', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-0994', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-1440', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1309', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0790', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-2585', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2587', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2588', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-0997', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1318', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2605', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2607', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2608', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2610', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1455', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1488', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0794', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2001-0819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2612', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2614', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2617', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2631', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-2633', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-1926', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2635', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2643', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2644', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-1313', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-3792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3794', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1906', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1907', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1908', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2583', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2589', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-1923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1924', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-1115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2606', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2609', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1925', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-1489', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1493', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1495', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-1496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1497', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-0820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0821', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0822', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2613', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-0823', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2630', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2632', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-0998', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0795', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-2640', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2642', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1320', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-2646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1500', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0825', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0827', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2651', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-1927', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1929', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1930', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-1459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0778', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0828', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-0999', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1460', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1321', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-1935', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1323', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2007-1936', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1324', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2010-1325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1937', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1326', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2658', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1000000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1461', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-1939', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1941', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-1942', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2659', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1943', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2660', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3820', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-0798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-1000001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0832', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1000002', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2009-1462', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1000003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1000005', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1000006', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1000007', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0800', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1000008', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-1000009', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-1000010', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1000011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1000012', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-1328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1000013', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-1329', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2011-1118', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1465', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0833', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-10001', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2010-1331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1332', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0779', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-0464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0465', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0466', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2011-1120', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1947', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-10005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-1948', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1506', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1955', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0840', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0467', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2671', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2672', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3824', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1958', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0469', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1340', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1342', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2675', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2676', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1345', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1346', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2678', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3828', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1513', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1959', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0843', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0851', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0853', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0855', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0470', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0780', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1353', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-10009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1480', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0858', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2681', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2682', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2683', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2684', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2685', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-2686', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2687', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2012-0471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3839', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1482', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1483', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1964', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-1518', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0868', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1357', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1358', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-1360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1530', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1362', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-1364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1485', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2690', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-0473', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0870', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1966', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-1967', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1968', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1490', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1970', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1491', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2693', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2006-2694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1383', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0474', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3851', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0781', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0851', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-2695', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2697', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-1127', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0872', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0873', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0874', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0879', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0884', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0475', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-3853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3854', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3856', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-1976', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0852', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-2698', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-10015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2699', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1533', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0887', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-1536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1537', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1538', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1541', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1545', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0478', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0891', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1981', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1385', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2704', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2705', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0892', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0486', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0487', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-1982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1493', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1494', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1495', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1131', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0494', 2.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-1498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1500', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1506', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2708', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2709', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2710', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2713', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0894', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0897', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1554', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1555', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1561', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1513', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2719', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-2720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2721', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0497', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0857', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-1991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1387', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-10020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1570', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1518', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1519', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1520', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0904', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2725', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0858', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-1139', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-0859', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1140', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0906', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1523', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-1996', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1581', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1144', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-2732', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2735', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1390', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-3872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-20001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2001-0915', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1529', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1585', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1537', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1542', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-2001', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0499', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0920', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1547', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1550', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1564', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2002', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0923', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0925', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0926', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2739', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3877', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1567', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0943', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1571', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0953', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1572', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1573', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1611', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2741', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2743', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0959', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-0961', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1574', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0871', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-3881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2013', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1577', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2746', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1394', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0965', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3885', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3886', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3889', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3892', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0966', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1579', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1625', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-0971', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1395', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1628', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2005-3909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2755', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-0980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0881', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-2761', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2765', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2767', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2022', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2027', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0983', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1397', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2773', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-3913', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1633', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1592', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0990', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0776', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2005-3752', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1461', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-3778', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2563', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0789', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1471', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-0993', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-1299', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2572', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1006', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0791', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1019', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1178', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1608', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1612', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2779', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1621', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3790', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1303', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-1304', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2573', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1305', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1307', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1308', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1310', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1474', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1441', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1311', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1312', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1904', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1315', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0807', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2001-0808', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1475', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-1317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1913', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-1914', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-0777', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0893', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-0894', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2001-1041', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1045', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1046', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1647', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3947', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2042', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1631', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1052', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0897', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-0899', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2013-0795', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3970', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2782', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3979', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1404', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1658', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1659', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1642', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1644', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1645', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2048', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1653', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-1654', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1655', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-3988', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0902', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2001-1063', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1659', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1663', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0903', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-2054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1074', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1677', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2058', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0511', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1685', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0513', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1094', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0516', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0517', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-0520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0797', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1482', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1449', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3812', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2005-3814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2586', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-1921', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-1922', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2590', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1486', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1456', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1490', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0524', 4.9, 'AV:L/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-0530', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-0536', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2001-1106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1110', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2063', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1116', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0799', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1686', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1409', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0544', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-2802', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1192', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1173', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1693', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1685', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1178', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-1184', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1697', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2638', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2639', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2641', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1319', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1498', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-2648', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2649', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2652', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3818', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0829', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-1931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1322', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-1933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1934', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1000', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0830', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0831', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1940', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-1117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1000004', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2662', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1944', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2663', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3821', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2664', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-1464', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1466', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1502', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2828', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1205', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1217', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2840', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2099', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2111', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-1232', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2116', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-1236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2124', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2126', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4029', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1246', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1247', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-4031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0918', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2001-1260', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1261', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2863', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1266', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0920', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2864', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1689', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1268', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0921', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-2868', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1704', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0551', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-1202', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0834', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-2666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1334', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-1467', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1335', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-1953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0837', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2670', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2673', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-1957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0468', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1468', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2139', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0567', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-2141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1417', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2877', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1271', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1716', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-10074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-1418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0490', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-1492', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1496', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1497', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0782', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2711', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2714', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2718', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-1553', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1559', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1562', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1517', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-3866', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1569', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2001-0900', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0901', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1137', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2728', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2730', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1142', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0783', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2677', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1347', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2679', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1349', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3829', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3830', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2680', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3831', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-3832', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0845', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0846', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0848', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0854', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1469', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1351', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1476', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1352', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1354', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1122', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1282', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1734', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2005-4073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1736', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2159', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2162', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2163', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1215', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4075', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4077', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2896', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2165', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-1298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1583', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2733', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1147', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1584', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1528', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1530', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1532', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0864', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-1533', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1534', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1536', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2009-1538', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1391', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1553', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1151', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-10029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-3875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3876', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0921', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0939', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0941', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0944', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0945', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0952', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0954', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0869', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2005-3878', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1607', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1155', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-0956', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0870', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-2006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2009', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1614', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2745', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1617', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1159', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2688', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1515', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-0472', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2689', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2906', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2006-2908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1742', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3883', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3888', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3891', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3896', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3900', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3902', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1620', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1621', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1622', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2748', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-1580', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-2017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2749', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1627', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2009-1581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0789', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1165', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0790', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2754', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2759', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0882', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2006-2763', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-2018', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2768', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2026', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0982', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1589', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2028', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1590', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-10043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0989', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3929', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3934', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-0995', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0996', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2001-0997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0998', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-0999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1000', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2921', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2923', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-2179', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-1322', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1324', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2928', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4150', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1245', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2197', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1250', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1254', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1257', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-4151', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4153', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2941', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0933', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1340', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1010', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2222', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2233', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4194', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2946', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2001-1354', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1761', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1439', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-4204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1359', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4208', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0594', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0857', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4222', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-1356', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1359', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2691', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2692', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-10012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-10013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-1126', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1532', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-1977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1384', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1544', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2008-1549', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1129', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-0853', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-2700', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-0890', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0854', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2702', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-10017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0484', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0485', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0488', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0489', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-1983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0491', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-1987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-1988', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0492', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2012-0493', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2010-1386', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0495', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0496', 4.9, 'AV:N/AC:M/Au:M/C:P/I:P/A:N'),
('CVE-2016-0855', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-1503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1505', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2706', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2707', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1512', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2001-0893', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2966', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2241', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-1797', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-1802', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0864', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1815', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-2981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1832', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-0866', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1388', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2267', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2010-1486', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2279', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2283', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-10120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1840', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3003', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1491', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3006', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2292', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3015', 9.2, 'AV:N/AC:H/Au:N/C:C/I:C/A:N'),
('CVE-2007-2298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-1309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1749', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1857', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1766', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-1595', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2008-1642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1009', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1010', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1011', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1015', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1018', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1597', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1600', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1602', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1400', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0504', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0792', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-1610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1027', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1184', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1031', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1627', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1643', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2717', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2008-1552', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1557', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1558', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-1990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1564', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1567', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1515', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0898', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2723', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2724', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1522', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2011-1136', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-1992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3867', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0905', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-1388', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-1995', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2006-2729', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-1141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-3868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1580', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0498', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-0860', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-1582', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1389', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1525', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-1146', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1526', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2734', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2736', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-10027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-3873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1531', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1590', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0784', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1505', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1508', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4292', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1325', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-3027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1326', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3037', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-1881', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1443', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1883', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1891', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1525', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1526', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1482', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1489', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1532', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1536', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2006-3055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3057', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3062', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2350', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3074', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0614', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1544', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1550', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2365', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-1050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3950', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2005-3952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3954', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1652', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1653', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3957', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3960', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3971', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1655', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3972', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3975', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2005-3977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1057', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1639', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1640', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0901', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-1641', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1661', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1662', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1665', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-1667', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1647', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2051', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1672', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-2784', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1665', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-1668', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-1672', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1539', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0916', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0917', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-0919', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0865', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1592', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1565', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1602', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0924', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-10030', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2001-0927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0867', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-0868', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0938', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1566', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1568', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0942', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1569', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1570', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2003', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1392', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-0947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2740', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0955', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1154', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2005', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1604', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1606', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-1608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1609', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-2742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0960', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1393', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1576', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1156', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1158', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2010', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-2012', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-2014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2016', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1618', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1619', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-0787', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1675', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0507', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0509', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-2059', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0514', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2001-1098', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0519', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2001-1102', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-0523', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0525', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2006-2786', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0538', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2001-1105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3997', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2001-1115', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1119', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-2795', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2796', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1142', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1144', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1689', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2074', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0540', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0546', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2008-1690', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2803', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1149', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1162', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1164', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2805', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2806', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2807', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1171', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2079', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2809', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2815', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1694', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1175', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1179', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0801', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1699', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2827', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1197', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2082', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2829', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-2830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2833', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1213', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-0805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1701', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1702', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-1225', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2083', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0807', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4023', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2090', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1687', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2376', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2388', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2394', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0004', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1584', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2007-2406', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3105', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1385', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1391', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2417', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0030', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3119', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4335', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1810', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3123', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3129', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1071', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1826', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-1407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2747', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3887', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2005-3890', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3893', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3895', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-3897', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3899', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2005-3901', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0968', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0788', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0972', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1164', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2009-1582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1585', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-0973', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2750', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-10039', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-1396', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1586', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3910', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0976', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0977', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2762', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2764', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2766', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-2769', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2024', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-10041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0984', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0886', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-2771', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-1167', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2029', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-3920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2101', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2123', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2131', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2133', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1255', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1258', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2866', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1705', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1416', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-1269', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0559', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-1707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-2140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0829', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1003', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4051', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2147', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0833', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1023', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1179', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1605', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1607', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1609', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2778', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0887', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-1614', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1617', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3939', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1624', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1401', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0793', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2780', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3941', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1402', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0794', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-2884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1207', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1738', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2894', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2001-1299', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1304', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1739', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0574', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0575', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4079', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0891', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-0892', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2001-1040', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2016-0895', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2001-1042', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1043', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1186', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-3948', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1654', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0898', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2005-3962', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1632', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1657', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-3973', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4089', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2008-1745', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2922', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1584', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-0502', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-2758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0981', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0883', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-0986', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2770', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2006-2772', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2774', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3914', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1591', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-0988', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-0991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-0994', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1398', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-3922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3923', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3927', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3928', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1637', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1638', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-1639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1004', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1399', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1596', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-1599', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1175', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1603', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-1020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1025', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1606', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1611', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-10049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-1613', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1615', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1620', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1625', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-3940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1183', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-1029', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1628', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0890', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2009-1629', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1036', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2781', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2001-1044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3946', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1648', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0896', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2009-1636', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1663', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1666', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2049', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1660', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1661', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1678', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1666', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1671', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1679', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1680', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0904', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2001-1069', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1070', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1078', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0508', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0510', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-1188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2185', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2187', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1703', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2005-4134', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0845', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4147', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2199', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2203', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1253', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1256', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1270', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0846', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1277', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1280', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2942', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1705', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4158', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1428', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1706', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4163', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1341', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4175', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2231', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-1750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1708', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2236', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-1763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4202', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0855', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1766', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1783', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-1789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4229', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1363', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-10111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-0860', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-1448', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1796', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1457', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2247', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1377', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1800', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0905', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-1100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0527', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0528', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0531', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-0532', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-0533', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-2789', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-2060', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2791', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2062', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0537', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-0906', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-1103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1107', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1111', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1113', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2066', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1120', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1123', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1681', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1126', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1128', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1141', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4002', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-1688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1146', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2800', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0542', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0545', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2005-4006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1150', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0800', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1168', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2808', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1172', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2813', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1177', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2001-1186', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2823', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1403', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-3951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3959', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3966', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3974', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-3980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3982', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1635', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1637', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1187', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-3986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1476', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1813', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-1817', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-1825', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1828', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-1833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2256', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2988', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2266', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2285', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-1837', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4250', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1489', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3005', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3007', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2296', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1728', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1310', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-10126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1744', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1849', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0938', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-2311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1029', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1762', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1772', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1406', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1420', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1043', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1509', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1511', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-3030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3038', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3044', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-1055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2340', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1893', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1479', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1487', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4304', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0612', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1062', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1676', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1405', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1667', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1674', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0796', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1067', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1073', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1077', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1082', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1085', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-1086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3995', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1406', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-1101', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-0529', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-2787', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0534', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-2790', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0798', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1127', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1129', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1131', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2794', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-4001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0909', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-1139', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1682', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2072', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-1147', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1191', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2086', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2838', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2016-0913', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-0915', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2005-4021', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2100', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2102', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2108', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2114', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-1234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2117', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2125', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2128', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-2848', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-2852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1250', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1200', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3072', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2355', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1537', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1546', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1553', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3081', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-1556', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-1559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1580', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1783', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1784', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1594', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3091', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0002', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0619', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1916', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2392', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3094', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1803', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2397', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0007', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2402', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2407', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-1376', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3102', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2412', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-1389', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4325', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1395', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3118', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-1925', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1927', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2418', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0031', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3127', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4346', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0624', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1943', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1947', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1952', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1597', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1609', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1827', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1960', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1967', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4348', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1706', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2138', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-0564', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0571', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-2876', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1708', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1714', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1691', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-2148', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2149', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0926', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0927', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1722', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4060', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1729', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-1278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1209', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2157', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-1422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4076', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0931', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-0576', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-10088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-1424', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1220', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1221', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2171', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0578', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-4091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0582', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2008-1746', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4131', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1702', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2178', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0842', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2804', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1170', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2812', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1410', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1696', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0547', 0.0, 'AV:N/AC:L/Au:N/C:N/I:N/A:N'),
('CVE-2013-0804', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2821', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2825', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4014', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1412', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1686', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0914', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2007-2088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4022', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2098', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4026', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4028', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2110', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1231', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2115', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0916', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2129', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2132', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2135', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2137', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2860', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-2861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1253', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1415', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0809', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0828', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1970', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3153', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1832', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1974', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0069', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2002-0071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4354', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4358', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4362', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1979', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0900', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1747', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1258', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1265', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1269', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4178', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1345', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1751', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2947', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0565', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-4049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1715', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1717', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2151', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0928', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2015-10079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-2152', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4069', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1732', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-2889', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2891', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2893', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1280', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1208', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-1281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2155', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-1735', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-1295', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1214', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1737', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0836', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1839', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2006-3177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2031', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2450', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1077', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0203', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1844', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-1846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0955', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-2036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0637', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1218', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2170', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2005-4088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1700', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-4092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1743', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2173', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2175', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-10093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-2180', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2001-1317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0584', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2001-1319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1425', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2181', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2182', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2184', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1229', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2196', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1244', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-1260', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1704', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1274', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2937', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1337', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4166', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2221', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0849', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2227', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2230', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4192', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-1431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1748', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0850', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-10102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1755', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2948', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1760', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0853', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2238', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-10106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-0854', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4203', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-10107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-4205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1765', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1361', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1787', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2958', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2970', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2244', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1372', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0863', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2974', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2975', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-1300', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1382', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1478', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1718', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2012-0600', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1487', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2994', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-0870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0601', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2997', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3001', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-3002', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1492', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4262', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4274', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2294', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2297', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3014', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1727', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1733', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1741', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0874', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1014', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-1502', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1753', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-1757', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3021', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0606', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2315', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1861', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-1416', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1321', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4200', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2952', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4206', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2009-1711', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4210', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1790', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1794', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1795', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1366', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2971', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2242', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1803', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0598', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1469', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1475', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1810', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1824', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0599', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4439', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1863', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4445', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1444', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0270', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0272', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2062', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2075', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2479', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-4480', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3224', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2008-2078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1667', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4483', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3227', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0287', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1082', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2079', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2002-0300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0304', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0308', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0312', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0318', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2488', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1677', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0331', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0333', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0341', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0936', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0939', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1687', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1693', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2010-1701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1454', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1879', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-4505', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4511', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1748', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2001-1457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1336', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-1476', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4303', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1530', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-0884', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0867', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-10119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1836', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-2268', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2274', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2281', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4253', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-4259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4261', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4268', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1725', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0603', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2303', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1743', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0604', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1313', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0605', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1315', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3264', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-1469', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0417', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3269', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2119', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0432', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0437', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2120', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2126', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2131', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1902', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0960', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0457', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-2557', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-1760', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1549', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1555', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0616', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1347', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2005-4320', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0618', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2384', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-1914', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2391', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1922', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1801', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2395', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2409', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3104', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1923', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-4329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3117', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-1930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1589', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1070', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4345', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1823', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3131', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1940', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-0064', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0498', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2177', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1762', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2576', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3284', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0677', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4625', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-1490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-2197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1917', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1767', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1492', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-1768', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4638', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0562', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2210', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0576', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0583', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0617', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4651', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0638', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-4661', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1943', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4671', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4676', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4679', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2226', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4284', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1860', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1408', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1776', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1419', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3025', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1047', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1874', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-1875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3039', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1513', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1514', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-1889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1515', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1519', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1470', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1474', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1480', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1491', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1534', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1497', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1510', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1514', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1532', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3067', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-1546', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-1548', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2001-1539', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0615', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1558', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1569', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1573', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1576', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1345', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1585', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1357', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2374', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2377', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2380', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2385', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2387', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1791', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1374', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1377', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1388', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2434', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1072', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1416', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1622', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-0096', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0103', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0120', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4385', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1835', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-0144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2440', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1626', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-2442', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0689', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0666', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2610', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0690', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0691', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4684', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-4689', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2617', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0707', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1959', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4703', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4708', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3311', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2266', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0728', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0730', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0741', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2007', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2634', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0702', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-4728', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0712', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-4735', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2012-0718', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2011-1513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1520', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0777', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2276', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2289', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2024', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4760', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2642', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2643', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-4780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1528', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1534', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1537', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3171', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1838', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4401', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0196', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-2459', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1633', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1845', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1439', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0210', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0225', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1637', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2002-0237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1856', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1859', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1585', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0023', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1931', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-4337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0044', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-4343', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1402', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1944', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1606', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1824', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1830', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1958', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2431', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1831', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0626', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1972', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1973', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1617', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-0897', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0835', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2042', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2683', 6.4, 'AV:L/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2002-0846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1784', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0867', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0734', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-0870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-0894', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0905', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3370', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0911', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4813', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2695', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2327', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0744', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4829', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3388', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0751', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4837', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0951', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2355', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4841', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2013-10017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2727', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-2731', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2007-2736', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2363', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3407', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3412', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-2057', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-2740', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4409', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2049', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-4414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4436', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4458', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2002-0248', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0647', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4474', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-0919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2058', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-10023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1121', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1004', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-10027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-1014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1019', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1031', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2002-1077', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2392', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2002-0121', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1423', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0132', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0138', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1987', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1997', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-2006', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1426', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3167', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2014', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1627', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1428', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-0162', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-1629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2022', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0165', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2443', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0178', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1434', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1436', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0281', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0284', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-0923', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2067', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4874', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-2397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1005', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1815', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4889', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1103', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2776', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1110', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3477', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1607', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1126', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2009-2107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3487', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0933', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1681', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-1690', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2002-0344', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2494', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1878', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1728', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4508', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0944', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-1737', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1746', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0946', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2506', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0386', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2511', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2522', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2101', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4526', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3265', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-2110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0409', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2111', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0418', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3268', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3272', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0431', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3275', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1475', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4579', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0447', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4585', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2143', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-2147', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0469', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2567', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0476', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0480', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0500', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2186', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0516', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0525', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1763', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2584', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4626', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-3181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0198', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3184', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-0908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0232', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3207', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3208', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0640', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2466', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4412', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1862', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4415', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4456', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3299', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0563', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0596', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2216', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2002-0603', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0613', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0614', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2605', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-1934', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2475', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-1448', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2478', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2077', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0288', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3228', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0293', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-0297', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2484', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3230', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0303', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0309', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1870', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-0928', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0934', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-3235', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0935', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0342', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4490', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1686', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1453', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0354', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1709', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1712', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1719', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2092', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-2096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1723', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1880', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3245', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-4503', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0943', 6.9, 'AV:L/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2006-3249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1888', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-0385', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2509', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-2514', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1465', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2537', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1896', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2539', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2002-0411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0415', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-2114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2116', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0423', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0669', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4559', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0427', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2123', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0441', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4576', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1758', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2552', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1759', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0459', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-0462', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2002-0466', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4604', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2157', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0482', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0485', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0495', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0501', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1485', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0533', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1486', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0679', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1489', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-2591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1919', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0594', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0601', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2603', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3301', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1936', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1942', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4650', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4655', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0640', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4663', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-0651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1946', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4673', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1951', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4678', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0654', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1498', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-0662', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1502', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-2613', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0687', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2620', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2623', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2259', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1504', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2624', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1990', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-1992', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1509', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2625', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2630', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-0731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0736', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2632', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0703', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4730', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0720', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2636', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3328', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4743', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4746', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2637', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4749', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4753', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0793', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4765', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-4771', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0819', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2299', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1535', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2302', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3354', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0844', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3358', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0725', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1692', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-1718', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3961', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-3967', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0900', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-3976', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3983', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1059', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1643', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1646', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1669', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3993', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-1068', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2057', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1681', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1682', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0512', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-0515', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-1678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1099', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0521', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-3996', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0535', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-3998', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2798', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2799', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0541', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-0543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2075', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2076', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2078', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1151', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1154', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1156', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1691', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1163', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1165', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2068', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1408', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1140', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1143', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1190', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1692', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4007', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2810', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1194', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3365', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-3373', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2321', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2325', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2692', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-2703', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2002-0922', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3377', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2005-4827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2713', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3390', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1001', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2720', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-0941', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0957', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2052', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1560', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2730', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2360', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-2735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1568', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3408', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3414', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-1571', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1800', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0991', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3429', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3434', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2378', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4857', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-1003', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1078', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2758', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4864', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4869', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2763', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4878', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2399', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1252', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4033', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1259', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-4035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1263', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4039', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-1201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1713', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2144', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1007', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-4044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2005-4052', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1719', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-10073', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-10075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-10076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-10080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-10082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1204', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1205', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1289', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-10085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-2156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1303', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1305', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-10087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2916', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-1741', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4086', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0580', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4093', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0840', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2224', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4189', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4190', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1346', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1349', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1749', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-1350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1754', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-1756', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1759', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10103', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-0852', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1352', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1353', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2001-1356', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-2954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4212', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1768', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1772', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1776', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1782', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1786', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2957', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1713', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2012-0596', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2963', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2245', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2246', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1458', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1189', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1193', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1196', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4013', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4015', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1201', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4017', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1204', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1209', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1218', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1223', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2084', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2087', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2109', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-2112', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2001-1233', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1414', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2122', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2127', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2851', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2856', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1245', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2874', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0561', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-0562', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1270', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1709', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1712', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1792', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-1455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-2972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2243', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0597', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2976', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1465', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1472', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0865', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1816', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-2979', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-1821', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-2252', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1386', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1480', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1834', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-1721', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1303', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2995', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2295', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1726', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1854', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0876', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1855', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0878', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1765', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1030', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1317', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1506', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1319', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-1862', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1324', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-1039', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1042', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2319', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1332', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3033', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3043', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-4299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1465', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0611', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1811', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-1819', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2984', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1827', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1385', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1481', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-2986', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1723', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2992', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4252', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0872', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1494', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0873', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1730', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2300', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1853', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1756', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3020', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1760', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-2314', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1774', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2316', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1418', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4291', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1421', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-1510', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0881', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2001-1294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1213', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1296', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4074', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2895', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1301', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2897', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2899', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2900', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2005-4081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2913', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-4087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1222', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4095', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-10090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-0583', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-2174', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2188', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2191', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0844', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2194', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2929', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4149', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-10097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1278', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1333', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1335', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1223', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2189', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4145', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4146', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4148', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2202', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1255', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4152', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1272', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1279', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2940', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-10098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2001-1334', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4172', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4173', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2213', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2944', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2832', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1700', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1226', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2839', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-1413', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2089', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2119', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2120', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0548', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0550', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2130', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-2134', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1243', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1248', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1249', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1251', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4030', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-1267', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1703', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0811', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2869', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0552', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-0922', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-1690', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0569', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1711', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4046', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2016-0925', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-10070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1272', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-1693', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1592', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2087', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2101', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1104', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0765', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1115', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1605', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3479', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3482', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-2109', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2419', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3484', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3486', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2118', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1649', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1657', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2424', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1134', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1527', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3059', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1511', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1521', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0613', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3071', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1536', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4311', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2357', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2360', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-2361', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2001-1540', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1545', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2363', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-1558', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2001-1575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1346', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3086', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1584', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4321', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1353', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3090', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1367', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3093', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1707', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-10100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10104', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-10105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-1435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-1438', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1440', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-10108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-1764', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-10109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-4211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1769', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1712', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1773', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0595', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1447', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-1452', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0862', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1367', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1370', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1374', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-10115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1804', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1805', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2978', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1822', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1302', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2880', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-10077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1724', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1725', 9.5, 'AV:N/AC:M/Au:N/C:P/I:C/A:C'),
('CVE-2008-1727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1419', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0572', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2005-4066', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-1008', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-2886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1276', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1730', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1206', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2153', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2890', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2001-1277', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0835', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2431', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0002', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1660', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2129', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1017', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1861', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-2803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1167', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1870', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3494', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1182', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0012', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0015', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-3519', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1689', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2159', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-1910', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1691', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1697', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4083', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2910', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2915', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2917', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-2919', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1699', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2007-2169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0932', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-2176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2177', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2186', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-2927', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1327', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1246', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1266', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1271', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1275', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4154', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2209', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0848', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1342', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2217', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2223', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2344', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1490', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3061', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1512', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1539', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-0885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1274', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-10078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-0929', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-2881', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-1726', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1728', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-1694', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-1275', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0573', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2016-0930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-10081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-0834', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3011', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4280', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1852', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1311', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-1314', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1761', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1924', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-3115', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0013', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0021', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0025', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1400', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1807', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3122', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1932', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-4344', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1821', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0047', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1938', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2008-1946', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1828', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1966', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-2433', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0065', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1409', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4357', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-4361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4371', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-0097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0107', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1418', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4381', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-0851', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2950', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0592', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4201', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1358', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1775', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-1777', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1454', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1368', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1373', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-1901', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0889', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4289', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1710', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-1762', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0593', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1360', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4216', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1785', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2013-0859', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1801', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-2410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1069', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1587', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3114', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0011', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1928', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1591', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1815', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0049', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0057', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1939', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1945', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1949', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1601', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1608', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1406', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1962', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1965', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4350', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0627', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4356', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4359', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-1978', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-3157', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4367', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0080', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1073', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0104', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0184', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3178', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0191', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0636', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2002-0215', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1635', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0638', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-0231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1638', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0240', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3200', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1857', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2045', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1639', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2051', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1930', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1934', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1231', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0028', 4.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2006-3526', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2167', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1703', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1239', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2170', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2173', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2009-2175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2180', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2185', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1705', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3556', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2488', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-1952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0046', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-2831', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2490', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2195', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2836', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-3565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1318', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1334', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1339', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1717', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2199', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-2500', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1727', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2505', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1979', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1360', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3574', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3575', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1157', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2864', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1372', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1373', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2873', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4298', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1517', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1458', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1337', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2001-1477', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1338', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1528', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3063', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2001-1507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2348', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1527', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1533', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2356', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1544', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1547', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3079', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3083', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1574', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1344', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2369', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1902', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1782', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1571', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-1904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1788', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1364', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4322', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1789', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1912', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2389', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2008-1919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1792', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0620', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1799', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1461', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1378', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2249', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1716', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1473', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1820', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-2983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1826', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1830', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-10118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-1720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1387', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1482', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1389', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2264', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2284', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1839', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4249', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2290', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1841', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4256', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3009', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1842', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2293', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-1493', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1307', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3016', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3017', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0877', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1758', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1027', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2001-1290', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1696', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-1216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0577', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2005-4080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4082', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2166', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1740', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1698', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1217', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2902', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-2903', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-2904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2905', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1423', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2914', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-2918', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1009', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0579', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2005-4094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1744', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-2920', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1701', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-2190', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2192', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-10095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-4137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2930', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2931', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2200', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1252', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1262', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1273', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1276', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4156', 9.2, 'AV:N/AC:L/Au:N/C:C/I:N/A:C'),
('CVE-2013-0847', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2210', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2001-1336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1338', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1429', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2225', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-4191', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-1288', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2945', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-1753', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0591', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1981', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0129', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4384', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0143', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1995', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2004', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-2010', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2441', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0632', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-0170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4394', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2027', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-2446', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2250', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1814', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-10117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-1301', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-2989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2265', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2275', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1304', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1642', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4455', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4467', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0249', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1864', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1080', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1650', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0265', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0268', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0271', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0648', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-0276', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0282', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1668', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3225', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1671', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3107', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1392', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4324', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2414', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1394', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3116', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1806', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2419', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4341', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1592', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0894', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4278', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1738', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4279', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0875', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1851', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1745', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1750', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-1503', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1759', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1769', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1775', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1777', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1320', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1866', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-1044', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2325', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1885', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1887', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1516', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1471', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3052', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1499', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2349', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1540', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1528', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2351', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1535', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2359', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1549', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2367', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1557', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1561', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1568', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-0617', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1356', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2371', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1068', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0311', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2490', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-0937', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-0938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1679', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1876', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2493', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4491', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4494', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0368', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2098', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3246', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1886', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0375', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4510', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0947', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3253', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-2510', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2519', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2523', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0665', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3259', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4528', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4532', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0403', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2109', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2117', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0424', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2140', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-2145', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0455', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0460', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0639', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3199', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3204', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2042', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2053', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1443', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1613', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0073', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4363', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4366', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-4372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0086', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0113', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1420', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0630', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0137', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1986', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1624', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3166', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0146', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2015', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4393', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0176', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4395', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0633', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0635', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2452', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-2455', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-1632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3183', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4402', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-0200', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-0205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2037', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-2038', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0064', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1383', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2002', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-2003', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0065', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0793', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1040', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2007', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1411', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2012', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2027', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2210', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2038', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2008-2541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2214', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1754', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1773', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1405', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1778', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1417', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1038', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-1863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1040', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2318', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3029', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1431', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2324', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-1329', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3035', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-1050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1448', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3046', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1060', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-1334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1469', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1523', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1478', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1481', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3051', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1498', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3060', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4306', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1505', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3066', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1525', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1530', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3070', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2352', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2362', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2001-1542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1550', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1553', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1898', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0888', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1796', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0005', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2398', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2006-3101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0621', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0893', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0465', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0470', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0474', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1480', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2174', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-0502', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2185', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0508', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2574', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3279', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2192', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0539', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0544', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0678', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2583', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0680', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1913', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2592', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0684', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2213', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1769', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0589', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4646', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0604', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0611', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2602', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0616', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3302', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1709', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1355', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-2951', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0856', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4214', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4219', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0858', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-2956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-1793', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0861', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-10114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-2967', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2001-1369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1466', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1474', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1809', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1812', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1818', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1823', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1829', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-1831', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2253', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1722', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-2990', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-2991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2263', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2271', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2007-2280', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2282', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0869', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1490', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4269', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0602', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3013', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1737', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-1740', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1013', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1015', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1312', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-1747', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1856', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2306', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3193', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0213', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0216', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0227', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0230', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1860', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1861', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4417', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-4419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2050', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0246', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1079', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2470', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0259', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1646', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-1648', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1446', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1657', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1658', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0273', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3216', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4476', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1866', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4477', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0275', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2064', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3217', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-2066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2068', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2069', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0921', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1877', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1429', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0608', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3036', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2001-1437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1442', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0609', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1450', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-1518', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1058', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0610', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2001-1464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1472', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1524', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4305', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1494', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2001-1522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2354', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-3077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2001-1548', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2366', 10.0, 'AV:A/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-1551', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1563', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1567', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1560', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-1897', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1570', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1366', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2011-1370', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2375', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2378', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2382', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1918', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-1790', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1373', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2006-3139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1610', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2430', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2008-1954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1968', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0896', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1768', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3022', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1409', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2001-1410', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1318', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0607', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-1871', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4296', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1327', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2322', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3031', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1051', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1884', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2337', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1664', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1081', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1378', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0692', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3308', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1503', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-1968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1975', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1981', 4.9, 'AV:L/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2005-4717', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1989', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-2627', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0721', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0698', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-20001', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-2633', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4721', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0710', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0714', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0717', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-0989', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0772', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1521', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2002-0781', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3325', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2285', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2018', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4752', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4758', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-2638', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0799', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4764', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-2291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2647', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-0814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1780', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4787', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3338', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-2032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2034', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-1529', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1782', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0724', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2081', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-2083', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1675', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0323', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1455', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3068', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1341', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1534', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3160', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-2437', 6.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-2438', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-4375', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0131', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1074', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1625', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2018', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-2020', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1837', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1430', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3169', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1937', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3132', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0055', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1941', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-2427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1596', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1604', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0625', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3143', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2010-1616', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2002-0074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4364', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-3158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4369', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0083', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0629', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0110', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0124', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2439', 9.2, 'AV:N/AC:L/Au:N/C:C/I:N/A:C'),
('CVE-2006-3165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1998', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-2005', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4387', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0947', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-1429', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-1836', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0169', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0175', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1799', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1372', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2503', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1462', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2513', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0664', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4520', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2105', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-2532', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4523', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2106', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2002-0399', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0670', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0445', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0301', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0314', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0325', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-1874', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2489', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1452', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-0940', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2087', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2097', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-1724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2498', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1882', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1730', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1812', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3128', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2011-1403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0048', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1404', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2005-4347', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1405', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-0895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0202', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3186', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1841', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1848', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0909', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0851', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0729', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-0878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1000', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0892', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0893', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0908', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3366', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0740', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2320', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2697', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1548', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2002-0919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0742', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0748', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3384', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2342', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4836', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-2348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2350', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2352', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0943', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4839', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4848', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1565', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1002', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1793', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3417', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0969', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4851', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-1796', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2002-0976', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0983', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0987', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0990', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0998', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2002-1013', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1021', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1024', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-1620', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4373', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0087', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1833', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4376', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0099', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0105', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0125', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0130', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0135', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1984', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1988', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-1994', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1999', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1425', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2013', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1628', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1431', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1432', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0164', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2444', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1433', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0950', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2002-0181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0634', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-3174', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-1435', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1355', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-1362', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1910', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1802', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2396', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4326', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4332', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2011-1396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0622', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1401', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-1817', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3137', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0058', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1950', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1611', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0062', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4349', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3147', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3151', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1614', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1619', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4360', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2012-0628', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3159', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2435', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0092', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0106', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0114', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1419', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-0126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1623', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4383', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1989', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1996', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2152', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2568', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2173', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-2175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0509', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0513', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0523', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0526', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0531', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0535', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4504', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-0941', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1740', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2505', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1890', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-2100', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2526', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4524', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1894', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0406', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2112', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2005-4550', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3273', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-4558', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2134', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4577', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1904', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4598', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0456', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0461', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1905', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-4603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0239', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1855', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3203', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3205', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2046', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4422', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4423', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4425', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4426', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2005-4429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4440', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2054', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4442', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4444', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4460', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1858', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3206', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3210', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1441', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4434', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1442', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1645', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-0918', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0524', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4607', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0534', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4613', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2589', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1915', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1918', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1932', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0556', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2200', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0565', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4642', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2601', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2604', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2606', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1940', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4653', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4659', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0643', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2221', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0679', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1771', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4682', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4685', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-0693', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0697', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2616', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0708', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2240', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2256', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1958', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1969', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2011-1507', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2454', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-2458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1437', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4405', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3189', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-3192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1078', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2041', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3196', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1449', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4489', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1873', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-0930', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-1083', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3214', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0253', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1445', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1865', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4475', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0266', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-0920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2063', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1038', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1058', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2383', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2754', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4863', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1583', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1584', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2761', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1586', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-0759', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1591', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2095', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1594', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1087', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1595', 6.4, 'AV:A/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-1007', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1094', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1099', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3469', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2002-1113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1129', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-4891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1010', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0639', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0642', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4667', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2220', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1949', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-4675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0658', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-0659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0710', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2244', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1774', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1963', 7.8, 'AV:N/AC:L/Au:S/C:N/I:P/A:C'),
('CVE-2005-4709', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1984', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1993', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2002-0727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0753', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0756', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0761', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4726', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4734', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-1515', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2275', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0784', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2639', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3333', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0806', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2648', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2028', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4775', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2030', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2654', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2659', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1530', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2009-2036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1536', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2300', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2038', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2666', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-1538', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2009-2043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3353', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2008', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4389', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0157', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4391', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-0902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0343', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1689', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-1704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0352', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0358', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1718', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1722', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3241', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-1456', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2507', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2508', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2536', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1892', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4536', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1980', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-1983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3317', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1995', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2009-1999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4718', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0732', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2001', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2005', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3320', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4744', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2008-2287', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4754', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0800', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2644', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2009-2027', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0817', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-0992', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3340', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2656', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0995', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2303', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2304', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0997', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3355', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0840', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4803', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2005-4806', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2686', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1540', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-3357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4809', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0728', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0736', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0877', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3266', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1898', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4552', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4557', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0671', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0435', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-2122', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2550', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4584', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0448', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-0961', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0463', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2564', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2565', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-0475', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2161', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0486', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0497', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1482', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1484', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0529', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-2582', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1487', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4621', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2590', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-2595', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2195', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1916', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3293', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4636', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2199', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0568', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0588', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0599', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-2681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2689', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0999', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2048', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-0726', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-0731', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2002-0871', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0873', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3361', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0896', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-1545', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0915', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2702', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-10007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2002-0918', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0920', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3379', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0746', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-2340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2714', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1553', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0932', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3391', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0934', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2726', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0952', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4843', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-10018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2005-4844', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-4847', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3398', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2733', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1564', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3406', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-2054', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0964', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1570', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4850', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2364', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-3425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0978', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0988', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0993', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0997', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1006', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2747', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1017', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1575', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1030', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2013-0906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2110', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-2114', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1643', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2783', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2426', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1133', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2784', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-1139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1141', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2786', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2438', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1666', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2790', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1850', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-1856', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-2450', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2797', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2798', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-1860', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1677', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1165', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-1678', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2808', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1880', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-3510', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-3513', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0016', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-1195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1686', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-1899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-1902', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2156', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0018', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1917', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1216', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1921', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1926', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1225', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0022', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1700', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2823', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1651', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-4472', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0262', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0267', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1663', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2476', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0274', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1666', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1867', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4481', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4482', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2483', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2002-0296', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1674', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3231', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-0299', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-0306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2486', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4488', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1676', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0327', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0335', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0337', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2013-0929', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-0932', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-2492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1685', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3237', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0349', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0353', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1714', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2496', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-2088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4498', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0373', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3244', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-1732', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3257', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0663', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1749', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4664', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0650', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4668', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4672', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1952', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1953', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2006-3303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2227', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2002-0661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0665', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2611', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0678', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2232', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4680', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4688', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0690', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1956', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2002-0700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2618', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4693', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2238', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2257', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4699', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-4700', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1967', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-1972', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2005-4715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1987', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3316', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1994', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-1997', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3319', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1777', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0749', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0988', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4722', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4727', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4736', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2005-4738', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0719', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0773', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1778', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0785', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2011', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4748', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4751', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4755', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0991', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2292', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1634', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3194', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0208', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0211', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-1850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0958', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2002-0218', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0219', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0224', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0228', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0233', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3197', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1440', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4449', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2005-4454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2471', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0917', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3372', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2326', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4812', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2699', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2011-1546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4823', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3385', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2715', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2716', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0939', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2721', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1555', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1791', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1792', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3403', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1569', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3413', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2739', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0972', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-10026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2002-0995', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3436', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2375', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-2377', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-1025', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1028', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1037', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1043', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1045', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1049', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1051', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1053', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4859', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2007-2753', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3458', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2760', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-2075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2079', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-2083', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-2400', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3535', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1248', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1704', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3538', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2827', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1947', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1959', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1707', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0043', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-1708', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1284', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0779', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2834', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1032', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1313', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1340', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1154', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1713', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-1348', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1721', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1353', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2846', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0056', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2009-2200', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2010-1975', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-2856', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1987', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1359', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2521', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2860', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-1990', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1367', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0062', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-2866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2872', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1033', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1034', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1042', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4858', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3452', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3455', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2752', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1579', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-2756', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4860', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4868', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1814', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2081', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2766', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3463', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0760', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0291', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0295', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1869', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1089', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-3465', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2405', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0763', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1108', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1009', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1124', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1011', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1646', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2428', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1143', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2788', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3489', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1853', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1673', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1857', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1156', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2132', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0770', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2802', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1864', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3490', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1175', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2807', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1876', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1881', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3506', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2809', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3512', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-1684', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1685', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2007-2812', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-1876', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1432', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2321', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2323', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1331', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3034', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2336', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-1880', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1441', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2001-1445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1054', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-3045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1059', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2001-1463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3050', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-0883', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3258', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-1466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0666', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4546', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0410', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0416', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0422', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2005-4548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1899', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1900', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0434', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2548', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0446', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4587', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4595', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0454', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0458', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2005-4600', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-1907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0467', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0471', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0473', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0481', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1761', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2180', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3281', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0530', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0790', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1996', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2006-3581', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3582', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2006', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3588', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-3590', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3593', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-0792', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2002-1395', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3600', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-1400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3613', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1752', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2888', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-1173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2039', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1434', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1439', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2048', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4778', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2033', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4799', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3350', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1539', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2671', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-0839', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2679', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3360', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0863', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0733', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-0876', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-10002', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2002-0885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0898', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2317', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2323', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-2693', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2007-2700', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-2701', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2005-4814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4819', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1788', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3382', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4830', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-2344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2051', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-2147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1901', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2154', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1908', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0019', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-1913', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3521', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2470', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1699', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0773', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0775', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2480', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3534', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2002-1245', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-3541', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2828', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-1152', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1945', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2830', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2194', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0044', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1283', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1711', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-2843', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1344', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1712', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1688', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1084', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-1877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2499', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-1887', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3247', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1733', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4545', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4549', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4563', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3274', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0433', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4575', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2129', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0442', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4590', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2138', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0450', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2554', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2005-4599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2482', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0292', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-0924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2549', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-2905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-3636', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2585', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4617', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4624', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2588', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0560', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4662', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2224', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0653', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2230', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1499', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4686', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3306', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0702', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1957', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1962', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1965', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1006', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2768', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1818', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2404', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1609', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2002-1118', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2423', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1645', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2430', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2785', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1013', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2432', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2439', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1665', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2443', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1671', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0768', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1149', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1674', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2449', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2800', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1158', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0009', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-3076', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-2353', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2358', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1552', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1554', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1556', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4317', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3084', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2001-1586', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1568', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1572', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1359', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2001-1593', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-1905', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1577', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2381', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2383', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-1913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2393', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2005-4323', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2405', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1381', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1384', 6.9, 'AV:L/AC:H/Au:N/C:N/I:C/A:N'),
('CVE-2011-1390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1393', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1805', 6.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2011-1398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0036', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0043', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1813', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4338', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-1933', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-1935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0623', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2423', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-1942', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1948', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1598', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1607', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1825', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-1829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-1957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-1963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2432', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-1969', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-1408', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2002-0334', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0931', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2491', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1875', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4492', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1715', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0369', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2497', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-1881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1457', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4506', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0942', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0945', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2520', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2104', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-2528', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2533', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4525', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1891', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-0400', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0407', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0408', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2115', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4567', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-1472', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3276', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1901', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2546', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2133', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4581', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4589', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3569', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1349', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1719', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1352', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0054', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1729', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1730', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1735', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0060', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-1983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2858', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1038', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1563', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1567', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3405', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2053', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3410', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-10022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2005-4853', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2008-2370', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3427', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2061', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1023', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1808', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1122', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1054', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2384', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1079', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2755', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2759', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0756', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2077', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-3461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1589', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2402', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2093', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2911', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-2232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0083', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-2918', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1502', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2926', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1507', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2934', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-3675', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1512', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-1205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4704', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1971', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-1974', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1977', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1986', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-3315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0697', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1998', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2002-0715', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-0987', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0740', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2006', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0748', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0700', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0705', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-0708', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4731', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2271', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4740', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-1517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-0775', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3326', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-0788', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2290', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2022', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4756', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3331', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0805', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2646', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2657', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1526', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0994', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1783', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2306', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4804', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4805', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2687', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2045', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4810', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0737', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-3363', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-10004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0738', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-10006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-3375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2694', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2704', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2011-1549', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2013-1020', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1879', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1178', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0013', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0014', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-1682', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1204', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1690', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2157', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-1906', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2468', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2469', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2164', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3523', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-1149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1939', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-3532', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2171', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-3537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3542', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-3548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1706', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1958', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-1961', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1253', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1279', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2837', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-0048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1968', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1715', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1155', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2560', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0464', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-2563', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0468', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2154', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-0479', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0489', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2189', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0512', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2579', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2190', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4609', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2191', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4623', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1912', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2198', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2598', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0558', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0584', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2214', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0602', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1937', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1941', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4648', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4652', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2005-4658', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0648', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1948', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2235', 6.9, 'AV:L/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2002-0686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4683', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0698', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-0472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2159', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2163', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2166', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0488', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0493', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0517', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0521', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3278', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0532', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0537', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0543', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1764', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-2194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0682', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0582', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2215', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2217', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2600', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2771', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4888', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0762', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1008', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1604', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2005-4890', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1119', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2415', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4900', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-3150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1411', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-1413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0115', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1421', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0136', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0141', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-1991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1424', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-2000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0631', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3170', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1076', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2445', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3584', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3596', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0796', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-3602', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3605', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3607', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1749', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2002-1410', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2707', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0745', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4835', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-3386', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1789', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0937', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2722', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4840', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2356', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4845', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3396', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-10019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-0962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1120', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3415', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1801', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2741', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0986', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1806', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4855', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-3448', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1020', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1026', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2391', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-1081', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4865', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1004', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2071', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2076', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1124', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0620', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4654', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-2608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0687', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1500', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3305', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2237', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2619', 6.9, 'AV:L/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2002-0712', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2253', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2258', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1960', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-1966', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-1508', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4713', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1985', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3313', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-1991', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2008-2268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2629', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2002-0723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0729', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1511', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2008', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0754', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0699', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-1512', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4739', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2002-0771', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0774', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3322', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0782', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2283', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2640', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2002-0803', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4767', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2645', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4786', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-2658', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4794', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3342', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-2661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2688', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2241', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2255', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1964', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-1505', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-1970', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1973', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2005-4711', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-1979', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4716', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1988', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-3318', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1996', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-2000', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0737', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2009-2009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0752', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0760', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-0701', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4729', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0713', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2005-4737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4742', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0723', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0770', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0779', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2281', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4745', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2026', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0792', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4762', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4766', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2005-4769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0810', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2650', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-1525', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-0993', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1527', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4800', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-2039', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2667', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3352', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2684', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-1542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0727', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-0864', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0058', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1726', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1736', 7.8, 'AV:N/AC:L/Au:N/C:C/I:N/A:P'),
('CVE-2007-2848', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2852', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2503', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2511', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1989', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2202', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1377', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2867', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2524', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0063', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1381', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1998', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2002-1396', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1398', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3603', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1402', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1405', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2527', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1750', 10.0, 'AV:A/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-2008', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-2016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1041', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1171', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3617', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2539', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1416', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1423', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1753', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0073', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3628', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3632', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1451', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1417', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2543', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3625', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2547', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1425', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2002-1430', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1445', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1478', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1493', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2227', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1761', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1197', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1200', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2912', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2917', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0084', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-2242', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2065', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2925', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2447', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-2028', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-2448', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2008-2029', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2032', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1840', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2449', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3180', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-0907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2594', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2275', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2604', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1593', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2611', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-2956', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1600', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1601', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2620', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1065', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2624', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1635', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3693', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2285', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3696', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3699', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1773', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3704', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3719', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-3723', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1774', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2006-3726', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1640', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1642', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1645', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1653', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1657', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1658', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2641', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1662', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0847', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3740', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1778', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3742', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1854', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2795', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-2131', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-1676', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2134', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0769', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2804', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2139', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1679', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1680', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2145', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2810', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1186', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2146', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-1193', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1209', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1898', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1900', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1903', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0017', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-1911', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1912', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2819', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-1920', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1928', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2822', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3528', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2824', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2481', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0035', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3540', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3546', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0037', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3557', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1951', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1960', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3563', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-1291', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2196', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2497', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0780', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2844', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2198', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-1337', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4808', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-1785', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0852', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0732', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0735', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-2050', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0874', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0879', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-10001', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2002-0887', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3367', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2318', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0914', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1787', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2705', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2002-0917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0743', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4833', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2711', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3389', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0936', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0940', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2723', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-0945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1556', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1119', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0963', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0753', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1795', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2089', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2009-2097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1819', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1100', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1105', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2778', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-0766', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2408', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2111', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2115', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2009-2117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2120', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-1653', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2427', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1658', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-0001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1145', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1014', 4.9, 'AV:A/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2126', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1661', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2435', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2436', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1664', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2445', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1015', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1848', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-1852', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-2446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1154', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2799', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-1018', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1159', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2010-1863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1877', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1460', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2552', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-1463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3654', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-3656', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3657', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2220', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3660', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-0813', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1465', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1466', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1470', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2057', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0814', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-1192', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0080', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2223', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1051', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0818', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2558', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2919', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3673', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0829', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3674', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-1510', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2068', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1521', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1531', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1539', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0059', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1978', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2855', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1981', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1357', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1988', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2517', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2519', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1743', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1993', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1366', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-1368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1387', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1389', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0068', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-2877', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0071', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2019', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0797', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-0798', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-3610', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2881', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1170', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3611', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2002-0875', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0889', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0897', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1786', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3369', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2698', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0741', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4828', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2002-0926', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4834', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3387', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-0935', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-0946', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4838', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0752', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2729', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2357', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3399', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-4849', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3411', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2366', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3423', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4854', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1799', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0981', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3426', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2746', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2011-1574', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3435', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4856', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1016', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1807', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2748', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-2749', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2064', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1058', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-1765', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2070', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-1524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1532', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2941', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1540', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1544', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-2262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2074', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0093', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2570', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2944', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1557', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2085', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1560', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0095', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1062', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2575', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2578', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2951', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2952', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2586', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-2588', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2589', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2590', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-3689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1579', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2601', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-2606', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2607', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2609', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2610', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2618', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1603', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2621', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2008-2622', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2623', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2625', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2009-2276', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1625', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1633', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1637', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1772', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-2094', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3697', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3701', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-3707', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2006-3709', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2286', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3716', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3721', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C');
INSERT INTO `tpandora_cve` VALUES
('CVE-2016-0979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2467', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4424', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2005-4437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0247', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2060', 7.8, 'AV:N/AC:M/Au:N/C:P/I:N/A:C'),
('CVE-2005-4443', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4448', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4453', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2005-4459', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4463', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2061', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0254', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1647', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1652', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1655', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1659', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4473', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1793', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1796', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1800', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1808', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1812', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1128', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1819', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1134', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-1826', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2119', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1849', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1853', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1856', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1900', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1902', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1909', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1913', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1920', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1928', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2147', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2153', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3769', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-1964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1969', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3418', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2367', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2369', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1572', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1805', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1576', 6.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-1027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1029', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3454', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1064', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2065', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2757', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2066', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1812', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2289', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3735', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2100', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2290', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2639', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-2642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1663', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1671', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1673', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1676', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1091', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1092', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1094', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1096', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1705', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1709', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1711', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1714', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1718', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0851', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1735', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1558', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1562', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1564', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1592', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0840', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3700', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3705', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3713', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-3717', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2958', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3731', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2002-1052', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3456', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2002-1063', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-1580', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2005-4866', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2068', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2396', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2074', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-2080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4882', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2084', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2091', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2100', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0761', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2772', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1599', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-1128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3471', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1109', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1111', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1610', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2409', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2780', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2781', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1021', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2463', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2464', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-1188', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2150', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1023', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1909', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-1914', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1226', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0776', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1233', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2014-0027', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-3527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0031', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-3530', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2483', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1247', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2169', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0778', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2184', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3553', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1251', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1943', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1946', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1963', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1255', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0039', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1265', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1276', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-2491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1709', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2835', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-2197', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2002-1315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1320', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1351', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1972', 8.5, 'AV:N/AC:L/Au:N/C:C/I:P/A:P'),
('CVE-2002-1354', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1734', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2847', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1740', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-2850', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2005-4883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-1086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2094', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-2103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1126', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-1091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2029', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-2035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3622', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0807', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2545', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2046', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1443', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0076', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0811', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3643', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3650', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3653', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-3655', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3658', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3661', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3663', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2058', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0079', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2059', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2224', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1049', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0081', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0821', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1198', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-2062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0827', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-2237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2915', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1498', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1503', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1504', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2924', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3480', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1117', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1623', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2005-4895', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2411', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2420', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3488', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1823', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1824', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3739', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2650', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-1666', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1683', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1708', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1710', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-1112', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1716', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1719', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1723', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1724', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1727', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1747', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1753', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1785', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1788', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1789', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1761', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3750', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1120', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1785', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1789', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1792', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1794', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1798', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1802', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1814', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1824', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1794', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2125', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-2787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2434', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1669', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1150', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1016', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1858', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1862', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1168', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1170', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3493', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-1871', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1187', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1192', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1203', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1687', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2002-1213', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2151', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1215', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2163', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1919', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-1220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0774', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1927', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1932', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1935', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1937', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2166', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1940', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1702', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3533', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-0034', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1991', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1992', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2522', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1744', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2009-2203', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0789', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1390', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1997', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-1999', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2001', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-2004', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0066', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2002-1392', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0794', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0795', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1401', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2205', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0067', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2009', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2880', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2014', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3608', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2012-0800', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1414', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0804', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-2887', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2031', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1432', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1446', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1447', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2054', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3637', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-1462', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1464', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1047', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1554', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1556', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1559', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0094', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1061', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1063', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2573', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-0096', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0838', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2582', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2585', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2587', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-2266', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1769', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-3688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2592', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2002-1576', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2595', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2602', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-2605', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-2953', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2954', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1598', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3694', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1851', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0004', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0005', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-0006', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2133', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1859', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0772', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1181', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1185', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2815', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1904', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1915', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0020', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1701', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1938', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2478', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-2484', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2825', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2177', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1942', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-0777', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3545', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3547', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-2486', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3552', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1948', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2190', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-2191', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2833', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-2493', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0047', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-1966', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2838', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0781', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1967', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1323', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1338', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1341', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3571', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-1970', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0053', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1971', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1725', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1728', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1733', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1741', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2512', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2516', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1976', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2011-1742', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1356', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1358', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2865', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0788', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3578', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1165', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1386', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2481', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0289', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-1868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0290', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0294', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3229', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3232', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0321', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-0926', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3698', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3706', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3708', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3715', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3725', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3730', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1085', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1641', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1086', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2136', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1881', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1890', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3766', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1903', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1907', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1911', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1918', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1924', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1926', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2152', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2156', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1947', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1960', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1967', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1982', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1984', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2664', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-1986', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1989', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1990', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0870', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2162', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2125', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2002-1839', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1841', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1845', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1850', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1854', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1858', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1861', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1873', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1883', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2002-1888', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0857', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1922', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1925', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1927', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1929', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1945', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1970', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1971', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1155', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1172', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-0865', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-0866', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3778', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2312', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3784', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3786', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1999', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2666', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0871', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2015-1224', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1757', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3667', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0078', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-2554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1479', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1485', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1487', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0815', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2225', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1050', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2910', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2061', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0819', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2226', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2228', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1053', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-2231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0826', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2562', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3672', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2011-1763', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-0085', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0086', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-2923', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2255', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1515', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1523', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1527', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0831', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1537', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1545', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2072', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2012-0833', 2.9, 'AV:A/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2002-1549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3681', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-1553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1208', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2007-2943', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2945', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2086', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-2947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2948', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0837', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1567', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2576', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0097', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2008-2580', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2581', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1173', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-3775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1801', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2163', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2327', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-2679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3791', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0875', 7.8, 'AV:L/AC:M/Au:N/C:P/I:N/A:C'),
('CVE-2008-2680', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1226', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1403', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1751', 10.0, 'AV:A/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-2021', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-0799', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3612', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-2532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2884', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-2028', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1422', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3619', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-2542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2893', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3623', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3631', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1433', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3633', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2903', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2906', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2053', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2002-1452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1454', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2550', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3640', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3651', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2055', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1480', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1760', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0822', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0825', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2916', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-0087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1508', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-1514', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1528', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1534', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1766', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-2076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3680', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-2080', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-2084', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0092', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-0041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1288', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1153', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2839', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1316', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2845', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1720', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1035', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3573', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2853', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1355', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1973', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-1980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1982', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-1986', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0787', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2863', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1995', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2002-1382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1384', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2000', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2016-0976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-3589', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3592', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3601', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2325', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-0874', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0101', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4493', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1710', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2086', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2099', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-1727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4502', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0377', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3250', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-0384', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1889', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0389', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4521', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3261', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2535', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2005-4530', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-1893', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0667', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0668', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0419', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-1555', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2946', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0836', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1563', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2002-1566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3682', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2600', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2603', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2002-1588', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2608', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2002-1594', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2614', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2615', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2617', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2619', 2.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-1066', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1620', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2090', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1632', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2284', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3724', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2097', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3729', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2012-0842', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-2635', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1644', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1758', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1764', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3753', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1770', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1780', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1123', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1801', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1804', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1815', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2662', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2113', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-2115', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1139', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2002-1829', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1830', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1832', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2123', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2006-3759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2127', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1844', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1862', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1875', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3768', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-2303', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1149', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-1942', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1948', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1953', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1972', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1975', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1977', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0862', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1168', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-0867', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0868', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3779', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1983', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3785', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1985', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2665', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1987', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1992', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1993', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1996', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-0869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1176', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-3685', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2267', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2270', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2596', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1581', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1583', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1655', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1659', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0845', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-1781', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-2648', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1677', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1691', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1694', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1696', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1707', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-1726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1729', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1740', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1742', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1744', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1748', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1117', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1784', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-1786', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1787', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1762', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3751', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0853', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1767', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1803', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1807', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1813', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-1816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2112', 9.2, 'AV:N/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2013-1135', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-1825', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-2116', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1827', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1828', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2122', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1831', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1473', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2142', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0487', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0490', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0496', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0503', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3277', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0507', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1483', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0515', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0676', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2580', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3282', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1488', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-0104', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-1812', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3831', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3833', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3834', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0883', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2713', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3836', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2714', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0895', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1222', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2006-3840', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3841', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3846', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1817', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2681', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2683', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2684', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0103', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0803', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1418', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3620', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-2894', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2900', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0809', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3629', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-2901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2215', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2216', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2551', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3647', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3649', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2907', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2009-2217', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2218', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1758', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2553', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1467', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1472', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1482', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1193', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1048', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3669', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1491', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2229', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2561', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1199', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-2230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2238', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2064', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2009-2240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2921', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2931', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2067', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1517', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1525', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3676', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-1530', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1533', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-2939', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2940', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1538', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2073', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2010-2078', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2079', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2083', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-2568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4620', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0681', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2005-4627', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1491', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-0683', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3294', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0685', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2005-4656', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2005-4660', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2005-4666', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-1944', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1496', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2228', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0680', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-1955', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2005-4681', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4687', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4690', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-1773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-2621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2254', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4702', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1506', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4710', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-1978', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-1982', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-0986', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2164', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2329', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1807', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-0982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-3797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3799', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3802', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2690', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2694', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3810', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2702', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2705', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2707', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0878', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3828', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1813', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1814', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2006-3756', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1837', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1840', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2704', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3812', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-0105', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3814', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2168', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3817', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3821', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3822', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3795', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-2685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1809', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2699', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2577', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2007-2950', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2591', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2268', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1064', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1582', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0839', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2955', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2613', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2616', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1602', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1069', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1618', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1079', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2281', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1083', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0099', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3703', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-2627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3710', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3714', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3718', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0841', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2631', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2957', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2963', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0844', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2002-1647', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1651', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2291', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2105', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1088', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1672', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1210', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3864', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3868', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2173', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3900', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3903', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2350', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1312', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-1320', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2351', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1336', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2353', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2355', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-0922', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0926', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0119', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3915', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1350', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-2972', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0750', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2635', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-0765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0767', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0709', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-0716', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2010', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-1514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1519', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0780', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3324', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2288', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-2023', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4761', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2002-0801', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-0804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4772', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3336', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2005-4777', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2005-4781', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3339', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2035', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-0827', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0996', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2668', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-0833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0838', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4802', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-0998', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2676', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2307', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2047', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2002-0849', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0853', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0856', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-0860', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0730', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3362', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0901', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1544', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-3371', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2322', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-0913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2691', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2013-1192', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3830', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-1202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-0882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1218', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-2334', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2014-0109', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2335', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3893', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1828', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1288', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2346', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3904', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1317', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1322', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0916', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0918', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1329', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1331', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1335', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1831', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2356', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2358', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0924', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0928', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1347', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0933', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-0984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-3912', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3914', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-2360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-0934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1351', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-2361', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2362', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2364', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0121', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-3918', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1834', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2007', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-2022', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1361', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2178', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3923', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-2975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0944', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2730', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2372', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2745', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0125', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-1839', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2752', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-1684', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1697', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1699', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2107', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1739', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1745', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1116', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1752', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3747', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-3754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1795', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-1821', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1822', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2114', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-2118', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3757', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0855', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2129', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3764', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1857', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1859', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1868', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2299', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2301', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-3765', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2715', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3838', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3844', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3847', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3848', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-1234', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2151', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-2154', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1946', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1954', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1959', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2304', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1154', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2160', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1169', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3772', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2101', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2638', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3737', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2646', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1670', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1675', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2002-1679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2654', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1682', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1093', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1702', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1704', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1715', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1728', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1734', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1743', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1115', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1118', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1754', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3749', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1766', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1782', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2111', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1790', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1864', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1866', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1874', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2037', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2758', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-2761', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-2762', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-2049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2051', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2766', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2767', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-2056', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2057', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2058', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2773', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0946', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0947', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2780', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2376', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2978', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2979', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-2982', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2389', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3931', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2985', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2988', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2398', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2399', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2097', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2100', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2120', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0955', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-2788', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2122', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2124', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2790', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2125', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2126', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2127', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3935', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-2129', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2131', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3941', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3943', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2002-2141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0132', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2973', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2001', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-2026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2032', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1550', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2002-0921', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2005-4825', 6.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2012-0747', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3383', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4831', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2712', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2345', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2719', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1790', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3392', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-0954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-0958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2354', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4842', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2013-10015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-0961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3393', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-3395', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2732', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2361', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2008-2362', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1566', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3404', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-0967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-10020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-3419', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2368', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3421', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2005-4852', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-0971', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1802', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-2742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-0982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2060', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1002', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1005', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3438', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1018', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2062', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-10029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2380', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-1039', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3453', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-1056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2393', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2005-4862', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2005-4867', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2069', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2005-4872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0757', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2072', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2005-4880', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1084', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-0758', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2765', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2011-1590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2005-4884', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2009-2090', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2767', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-2403', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-1826', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-1243', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-2723', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2724', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3894', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3897', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1289', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1301', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1303', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1306', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1309', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1311', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2175', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1318', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1240', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0116', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-1237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2384', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2386', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2069', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2073', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2391', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2090', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2094', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1863', 8.5, 'AV:N/AC:M/Au:S/C:C/I:P/A:P'),
('CVE-2012-0980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0981', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1867', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3023', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3024', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3036', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1890', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3044', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3045', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0984', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3790', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2676', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2677', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3793', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3794', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1810', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-0881', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-1220', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3767', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1931', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2149', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2015-1219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1127', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2775', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1095', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0764', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2407', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1606', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2108', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2116', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-1647', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0767', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2121', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1132', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1140', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2789', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-0972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2437', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-1825', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1148', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1849', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-1855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1675', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2801', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0008', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-2140', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2806', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1869', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0010', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1681', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-3511', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1022', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1683', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1210', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1688', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2153', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-1907', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2161', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2818', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-1918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1929', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-1936', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2475', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0029', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0033', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-2482', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2182', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2177', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0936', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2006', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2016', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0938', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3549', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1250', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3551', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3555', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-1252', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-1941', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-1944', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1950', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-1962', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1275', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1290', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-1294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1307', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1311', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3566', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1345', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1716', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1724', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-2849', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2201', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0786', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-1984', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2002-1362', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1364', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0061', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-2861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1369', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1159', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2525', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1385', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1039', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3585', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3587', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0791', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1399', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2347', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1315', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1323', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1346', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1956', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0863', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0864', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3773', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3774', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-0981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2161', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2314', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3787', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1806', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1820', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-1821', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-2342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3875', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3877', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3882', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3885', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3890', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1240', 6.9, 'AV:L/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2014-0114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3901', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1994', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2674', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1225', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2011', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2013', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2018', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3609', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2023', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2528', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3615', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-2883', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2886', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2024', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2212', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0806', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2540', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2897', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0808', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-3627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2548', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1444', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-2051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1177', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2002-1458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1471', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2056', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-2221', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3668', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-2909', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-0817', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2557', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1492', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1195', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0823', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2920', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1057', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1506', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-2932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1511', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2260', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0090', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1522', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2938', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1535', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1542', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1206', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-3917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2363', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3921', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-1352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-1353', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2002-2008', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-2011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2012', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2014', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0122', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2012-0937', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2023', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2726', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1836', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0943', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1837', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-2748', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2025', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1364', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2744', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2747', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2749', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-1838', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2754', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2039', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2042', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2047', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2771', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0126', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2776', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2777', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2977', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0127', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-2783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2379', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0129', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-1842', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2080', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0952', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2007-2983', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-2986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2993', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2396', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0954', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-3933', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-2402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2404', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2101', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2787', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2768', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-2769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1840', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2065', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0128', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2784', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-2380', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2980', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2981', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2070', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2388', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2076', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1247', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2167', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3818', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3823', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1815', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2716', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2717', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3853', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3859', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-0903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2721', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1824', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-2128', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3936', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-3944', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3945', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3006', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0956', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3947', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3961', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2154', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2162', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2166', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0961', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2186', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1848', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1849', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1850', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1851', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0974', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1853', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1854', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3018', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-0138', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2185', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3976', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3977', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2205', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2206', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2207', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1859', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0976', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2002-2214', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3892', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1825', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1827', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3898', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2089', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1080', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1624', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3695', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3702', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3711', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-3720', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-1775', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-2633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2962', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1777', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2102', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2292', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-2964', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3738', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3743', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-1664', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-3744', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-1678', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-1680', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1681', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1685', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1688', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-1698', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1097', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1703', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2161', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2163', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2002-2169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0134', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-3966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2182', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-1365', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2198', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2798', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1847', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2006-3975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1852', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0137', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2208', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1860', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1862', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0977', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0979', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1865', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0140', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-0141', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-1866', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3022', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3025', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3029', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1889', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3041', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1897', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0988', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0990', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-0991', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2002-2219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1900', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2220', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-2221', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-2409', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-0998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2224', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-2225', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2411', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-2412', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0144', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2009-2422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0145', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-1788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0854', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1797', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1806', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1129', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1818', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1133', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-1137', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2117', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2121', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1838', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1846', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2300', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1878', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1886', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1895', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1897', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2302', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1908', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1910', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1914', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1916', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2701', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2703', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-10001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-10004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-3993', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3058', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3995', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2199', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2245', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2203', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3996', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3061', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-3062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2210', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0151', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2337', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2338', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3850', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-3854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3856', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3857', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3858', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2720', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3861', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-0897', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0898', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0900', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1235', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2305', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-2307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1799', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3780', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1981', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2174', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0117', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3902', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1290', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2011-1829', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1297', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1302', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1307', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1310', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3906', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1316', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1321', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0915', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1325', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1327', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1328', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3909', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3910', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2725', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-0923', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0925', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0927', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3075', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2463', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2256', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1922', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-2260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2265', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-2464', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2807', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2269', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2014-0156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2808', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2276', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2279', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2282', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2465', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2288', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2289', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1923', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-3078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-10011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0158', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-1265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2165', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3798', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-3803', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2693', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0106', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-3815', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3826', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3827', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2712', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0884', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1221', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3837', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2170', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1816', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-10014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-1926', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3091', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2002-2309', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2312', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-2313', 9.2, 'AV:N/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2012-1002', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4030', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2323', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2331', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-2332', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2346', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1003', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1006', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1007', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2360', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2361', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-2362', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0165', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-0896', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1818', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1822', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3867', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3876', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3878', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3879', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1225', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-3886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1236', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-1623', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1626', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1628', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0098', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1013', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-4039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2812', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-20001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2002-1717', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1721', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1725', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1730', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1741', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1114', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1750', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1119', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3748', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1765', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1771', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-1777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1783', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2384', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2390', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2397', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2399', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2403', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2410', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2475', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2002-2418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2426', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2045', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3925', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-2778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0951', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2375', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2066', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2079', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2393', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-2084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-2987', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2087', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2401', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2095', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2405', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2103', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2108', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2115', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2118', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2785', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3934', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-2791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3937', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3938', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3939', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1051', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1053', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1057', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-1061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1848', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1852', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1855', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1860', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0856', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2002-1869', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1876', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1880', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1889', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0858', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-1896', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1917', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0859', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2138', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2150', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2663', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1939', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1797', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-1940', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1941', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2158', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-2159', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-1943', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-1951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2965', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-1966', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0861', 10.0, 'AV:A/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-1974', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1220', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2189', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-2192', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0135', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0136', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2184', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3017', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-3970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3971', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3972', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-0986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-1253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0142', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2002-2216', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1898', 10.0, 'AV:A/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2002-2217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0992', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-1899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0993', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-0994', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-2187', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1901', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2800', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2419', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2431', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3987', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-2226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2227', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3052', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0146', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-2436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-10002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-2437', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2440', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2442', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2443', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3989', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-3990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2002-2229', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2233', 8.5, 'AV:N/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2010-2195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2236', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3054', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3055', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1910', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1988', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-1991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-1995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-1997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2000', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2667', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1808', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3800', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3804', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2689', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-3809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2166', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1188', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2332', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1229', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0152', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2250', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4005', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2213', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2805', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4011', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2002-2253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1919', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3073', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-1920', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2002-2258', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3087', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-4024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2306', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2308', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2311', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-1267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2169', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3845', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1223', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-0111', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2719', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2171', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3852', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3855', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1224', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2006-3860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1819', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-0905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0907', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-2343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1236', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-1242', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-2967', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-0911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1296', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1304', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1308', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1319', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1324', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-0917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1330', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0118', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1338', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0920', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2009-2357', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1832', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-3916', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1004', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2009-2473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-2357', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1009', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2365', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2367', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1014', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2012-1015', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0166', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2369', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1270', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3927', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2779', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1246', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1845', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2144', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2182', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3954', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2172', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1846', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1251', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2393', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2394', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1931', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2417', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2477', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2479', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-2823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2491', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1054', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2756', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2757', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-2040', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2041', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2759', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2760', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2002-2046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2763', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2764', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2002-2050', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-2976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2055', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1245', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2493', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2498', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2238', 6.9, 'AV:L/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2006-4050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1068', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3116', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3117', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3122', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2832', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2530', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2841', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4052', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4053', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-0180', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3129', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-3131', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1947', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2533', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2435', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3133', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2246', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2002-2013', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2017', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2369', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2018', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0939', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2002-2024', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1835', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2031', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2033', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0123', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-2974', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2371', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0124', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1244', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3980', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3030', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-1891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0987', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-2218', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0997', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-3983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2410', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3048', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3985', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-2984', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1843', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-2997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0948', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2374', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-0985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2381', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2067', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2068', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2180', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3932', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-2085', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2086', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0953', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2007-3002', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2403', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0130', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-2099', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1844', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2111', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2181', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2786', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2406', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2795', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2797', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2167', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2175', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2002-2177', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2002-2178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2184', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2187', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2191', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3014', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1855', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0139', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-2201', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2202', 6.9, 'AV:L/AC:H/Au:S/C:C/I:N/A:N'),
('CVE-2007-3021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3978', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1857', 9.5, 'AV:N/AC:M/Au:S/C:P/I:C/A:C'),
('CVE-2011-1858', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-3979', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2209', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2210', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2002-2211', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1861', 8.5, 'AV:N/AC:M/Au:N/C:C/I:P/A:P'),
('CVE-2012-0975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2213', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-0978', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1254', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1986', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1988', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1990', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1082', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-1995', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1996', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1998', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2000', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2001', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4067', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4068', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2008', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2012', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4072', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3155', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2134', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3007', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3010', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2152', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-3962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0958', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-3965', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-0959', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2158', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2794', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-2796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2165', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3013', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-0960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-0962', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2183', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0150', 6.4, 'AV:A/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-2244', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2204', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2211', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2247', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4003', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4004', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3067', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0153', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4006', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1918', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4012', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4014', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0154', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3074', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3076', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-10009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-0996', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-3982', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3046', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0143', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2002-2223', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2415', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2420', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2009-2421', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2425', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2426', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2429', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1902', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1921', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2002-2263', 9.2, 'AV:L/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2002-2267', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2268', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2002-2272', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-0988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-2275', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2284', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0159', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2291', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4021', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2002-2293', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4023', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2297', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2809', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2007-3082', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-3084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1266', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1864', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3035', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-3037', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-3039', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1892', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-2799', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-0985', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1895', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-0986', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2215', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1255', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2235', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2240', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2197', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-1911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3056', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3060', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2242', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2202', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2803', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2452', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2251', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1914', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3071', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2214', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2461', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2215', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2257', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2259', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2264', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2266', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2271', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2273', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2274', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-10010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-2281', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1367', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2466', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4016', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4019', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-4022', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3079', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2007-3080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1924', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-10013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3086', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-1925', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4028', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2810', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2302', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2307', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-10015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-10016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2002-2319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2322', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2330', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1928', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-2335', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0161', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2002-2347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2002-2351', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2353', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-4037', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1008', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2811', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2366', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1269', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2314', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4031', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4033', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2002-2325', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3095', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2002-2334', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-2338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2342', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0162', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-2221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2350', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0164', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3988', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2432', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2435', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1366', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1905', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2189', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2190', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2228', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2230', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2191', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2232', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-2192', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2193', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2237', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2445', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2446', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-2447', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2448', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-3992', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1907', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0148', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-2802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1908', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2198', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2241', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3057', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3059', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1261', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2243', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2450', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2205', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2206', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-3998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-3999', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2207', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2208', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2212', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2248', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2456', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2457', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-10007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3068', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0168', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1028', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2378', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2387', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2388', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3102', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2396', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2398', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2400', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2406', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2228', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2411', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2419', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2421', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2820', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-1036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1037', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2476', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0172', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2821', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1273', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3072', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2009-2459', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4013', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-1263', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-0989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-2392', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2395', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2405', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2002-2407', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2409', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2002-2412', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2002-2416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2002-2420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2423', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0170', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1934', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-4043', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0173', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-2428', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1039', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1937', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2485', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3108', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-3109', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3111', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2489', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1055', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1058', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-1060', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-1062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1065', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2827', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2828', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4049', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3112', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2235', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-2492', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-2495', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2496', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2497', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2499', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-2500', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2501', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2502', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2503', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2504', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0177', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-1275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2518', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3113', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-3114', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3115', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1940', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2831', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2002-2286', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2217', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2467', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4020', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-10012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2002-2292', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2468', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3083', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2469', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2298', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2299', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2301', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-2303', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2009-2470', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2310', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2317', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2002-2320', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2002-2321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2329', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-2471', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1929', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2337', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2344', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2349', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2352', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-1005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2356', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3098', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1012', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-0167', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-2370', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2372', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2002-2374', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2813', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2474', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-3100', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1019', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1023', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-1024', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1025', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1027', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2227', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2014-0169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-1029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1031', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2002-2375', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2376', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2380', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2002-2382', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2002-2389', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1271', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3124', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2833', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2241', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2242', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2838', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2002-2432', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1072', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2525', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2527', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2529', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2433', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1073', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1944', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1946', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2245', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2012-1075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3130', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1945', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2002-2434', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1369', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1949', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-1950', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-4057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0184', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2002-2436', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2859', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2537', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3143', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1959', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-1960', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-1962', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1963', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1282', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2002-2427', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2229', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0171', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2822', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2230', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-1046', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2481', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-2484', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2231', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-2234', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1050', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1052', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2490', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1056', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1274', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2534', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-1952', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2857', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2858', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3137', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4058', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1078', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2535', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1079', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4062', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3139', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3140', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3142', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-3144', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-1954', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3145', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-3146', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3147', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3148', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3150', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3151', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1961', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1964', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1081', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1969', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-1977', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-1978', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-1979', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2544', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2009-2545', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1980', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2546', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3154', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1982', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4065', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-1983', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2002-2437', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-1987', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0185', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0187', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-1993', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-1997', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1999', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2009', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1083', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1086', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2547', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2002-2439', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4074', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1370', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3158', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3159', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3161', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3162', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3163', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4076', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3165', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3166', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3167', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-2868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2002-2443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2548', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1088', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-1089', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0003', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-4077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0008', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2006-4078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0009', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-0011', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-0012', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2008-2872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0014', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0018', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0019', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3168', 7.8, 'AV:N/AC:M/Au:N/C:N/I:P/A:C'),
('CVE-2017-0023', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0027', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-0029', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-0030', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0031', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-4070', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1084', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1085', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3157', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4075', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0192', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-0002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-0028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4079', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3170', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2549', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2552', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2553', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0053', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2554', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0065', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2011-2021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0066', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2015-1283', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2236', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-2506', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2237', 6.9, 'AV:L/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2010-2239', 6.9, 'AV:L/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2011-1939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-1941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3123', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2521', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0178', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-2835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2839', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2840', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0179', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-1943', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2528', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2531', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3126', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3127', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3128', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2244', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0034', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0037', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2873', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2876', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3171', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2550', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0059', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-0064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-0068', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2010-2250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-2878', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-0093', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2879', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-2880', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4084', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-0106', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0108', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0110', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0195', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2881', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2252', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-4085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4086', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0135', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2009-2559', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2884', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2562', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2887', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2888', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2566', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2568', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0146', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-0148', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2893', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2573', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-3178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2253', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4089', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4090', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-1951', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3134', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2849', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-2851', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2852', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0194', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-0195', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-2906', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-0197', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0200', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0203', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-0221', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2578', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0227', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0228', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1098', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0229', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2258', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0230', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0231', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2008-2909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0234', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2910', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0235', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0240', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3189', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4095', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1287', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-0143', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2572', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0152', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2898', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2901', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4092', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-2576', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-0992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2905', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1371', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1286', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2919', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1288', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2574', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-2896', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2897', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0160', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2899', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2024', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2903', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0201', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0202', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0205', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3180', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2017-0210', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2011-2039', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-2256', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2908', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3181', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3183', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0236', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2914', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3191', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2009-2579', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-0249', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-0254', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2042', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-0262', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0266', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2916', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4098', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-0285', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-0286', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-2260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0288', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-2920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3141', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-1957', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3149', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1972', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2543', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-1989', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-1992', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-2863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2010', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2864', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3164', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2002-2444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0193', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-0006', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-0020', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0033', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-0040', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3169', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2877', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0049', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2007-3172', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3173', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-0052', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0060', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4080', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2017-0069', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2006-4083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0073', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-1094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-2917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2583', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-0281', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0282', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-0283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0284', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-1103', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1104', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-1105', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-2591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1106', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-2262', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2600', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2602', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3210', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2610', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-2923', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2615', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0301', 6.0, 'CVSS:3.0/AV:A/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2008-2921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0303', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-0304', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-0305', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3200', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-3201', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2007-3202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3205', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3208', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3209', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2608', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2617', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0105', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-0107', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-2555', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0130', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2556', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2557', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1096', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-2560', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2885', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2561', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-0140', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2008-2886', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2563', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-2564', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0144', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-0145', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2570', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2889', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0147', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-2571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0149', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2894', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0154', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2015-1285', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3218', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3224', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1292', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2072', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2074', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-0316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3214', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3215', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2076', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3216', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2624', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-0993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2926', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2264', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-2077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2626', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2009-2628', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3219', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2007-3220', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3221', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3225', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3228', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3230', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3233', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3237', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2928', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2929', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2279', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-2282', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2284', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1117', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2289', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3245', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-2627', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3226', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3227', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3229', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3238', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-3241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4109', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4110', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-2266', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2268', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2269', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2927', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2930', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-1293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2278', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2010-2281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2283', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-0358', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4113', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-0360', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-1118', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3246', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2933', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2009-2635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2934', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2082', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2641', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2643', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2651', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3247', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2088', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2654', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-2655', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1120', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2017-0361', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1296', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-2907', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0199', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0204', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-0207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-0208', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2009-2577', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-0222', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0224', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0226', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0233', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2007-3184', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3185', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1099', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0238', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-2912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2913', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0241', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2009-2650', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1119', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-4116', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2091', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2296', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4118', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-0994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-2658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3251', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-4119', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0243', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3190', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3192', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2006-4096', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2040', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0247', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-0248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-2581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-0256', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2007-3193', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2041', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1100', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-3196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0260', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1101', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-0261', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0264', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0265', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-4097', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-2582', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0287', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-0289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2006-4102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2597', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-2598', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0290', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0292', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0293', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-4104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2286', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2291', 2.9, 'AV:A/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-0359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-2932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2294', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2632', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4115', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2081', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2937', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2646', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2648', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0302', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-3207', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-2603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2606', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2611', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2613', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3213', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2075', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2263', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2620', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2622', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2625', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1291', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2008-2942', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3255', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2299', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4120', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4121', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2940', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2941', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-2948', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2665', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0199', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1373', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0200', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2100', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4124', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2101', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2102', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4127', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2006-4128', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2105', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2667', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-0363', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-2952', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2959', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2961', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2308', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2310', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3258', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0202', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2297', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2657', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1121', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2010-2298', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1122', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2017-0362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2300', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2943', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-2947', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2954', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-2955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2957', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-2963', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4130', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3256', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-2311', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3259', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2313', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3260', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-1127', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3261', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-1302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3262', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1303', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2664', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1125', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2094', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2095', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2096', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2098', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2666', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-2668', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2106', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2305', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2951', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-1126', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2960', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-2962', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3257', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2314', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2670', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0204', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-2317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2967', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0364', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2320', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1129', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2109', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1305', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1306', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2330', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2331', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2333', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2337', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-3266', 8.5, 'AV:N/AC:L/Au:N/C:C/I:P/A:P'),
('CVE-2009-2673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2973', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2976', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2979', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2348', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2349', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2350', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0208', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2356', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2358', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1131', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2675', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2112', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2992', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-2993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2995', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2997', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3005', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-0996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3013', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3015', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1313', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-3019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2361', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1132', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1307', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4144', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-2971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2110', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2974', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2978', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2982', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2984', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2985', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2987', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0209', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3269', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3003', 9.2, 'AV:L/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2011-2113', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3009', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3014', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3018', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3020', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4158', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2362', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4161', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0214', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2116', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0215', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-2676', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1321', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3029', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2677', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3278', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2272', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2273', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1111', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0357', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2276', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1112', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2285', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2287', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2936', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-2083', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2084', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2321', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2322', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-2671', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1128', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2089', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0196', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3282', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2366', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1322', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3285', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0219', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-2368', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0220', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2371', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2378', 4.9, 'AV:L/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2010-2380', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-0997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2395', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2398', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2403', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2010-2405', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-2406', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2409', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4183', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4185', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2125', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1331', 6.9, 'AV:L/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2006-4191', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3040', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1332', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-4192', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3302', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3303', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2426', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4195', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2689', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2429', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0375', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-1315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0213', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1316', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-0368', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-1133', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3024', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1318', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2117', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3028', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0216', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1375', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3279', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3284', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2119', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1135', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4168', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3290', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4175', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3296', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0370', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-1136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3035', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2369', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2375', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2377', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-2389', 2.9, 'AV:L/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-2396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2397', 4.9, 'AV:L/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2010-2401', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-2404', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-2415', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2010-2416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2420', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1378', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2659', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2938', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2662', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2092', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3252', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-3254', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-2663', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1298', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3263', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0365', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-2969', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3264', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4137', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4138', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-4140', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2326', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-2327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2329', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2332', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2334', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2340', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2343', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2345', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2347', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-3265', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1130', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-2981', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1374', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-2986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0366', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2006-4154', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2111', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1335', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1379', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2692', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0379', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-2437', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1142', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1341', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2445', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1345', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1384', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2451', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3327', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3329', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2704', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2705', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-1138', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2425', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3300', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2127', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0374', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2128', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1334', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1140', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3304', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-2433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2130', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4198', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2694', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1141', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1308', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-2352', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3270', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3272', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-3274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1309', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2994', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-2996', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-2998', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3000', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3001', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3275', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2008-3004', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3006', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3008', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3010', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3021', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1314', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2115', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1320', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2118', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1377', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0369', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-0218', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2121', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3291', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3295', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2379', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2391', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2008-3037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2714', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-1397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3337', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3340', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2135', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1338', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3314', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3316', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2439', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2442', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3049', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3318', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2697', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1380', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3050', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1342', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2701', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-4208', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0224', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2010-2408', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2411', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2010-2413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2414', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-3299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2417', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-2419', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2124', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4186', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4189', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2421', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2685', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-0372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2126', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2687', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2427', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1386', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2711', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-2461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2715', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3336', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1398', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-2463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0227', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-2470', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2718', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0228', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-3059', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-1405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3066', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1148', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2719', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0231', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3351', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1152', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3359', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3361', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-1412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4223', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4227', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2724', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2730', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2732', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1000002', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-4240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4245', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3081', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3092', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4246', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-4249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1158', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-3374', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3095', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3097', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-2738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3375', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3100', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2740', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4253', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-2747', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4258', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-1425', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-0244', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2750', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-4262', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-0249', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-4264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0251', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-0377', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-0378', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3305', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2131', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2133', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0380', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-3311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3312', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-4200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2440', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3317', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1383', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3052', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-2450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1144', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3326', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-2703', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-0999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2456', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3334', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2712', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1393', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-1147', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0226', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2717', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3057', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1402', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0229', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-1406', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0230', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-3067', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4215', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3346', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-0232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2721', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1151', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2761', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0257', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0260', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0269', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2139', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-1164', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2014-0276', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0278', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0280', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0281', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2484', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0282', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0283', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0284', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0286', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0287', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0288', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3381', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2007-3385', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1165', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1166', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0304', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1427', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0311', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0312', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0313', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0321', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0325', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0333', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1361', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1153', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1154', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3072', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4228', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-4229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4231', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-4232', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-4235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1416', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1352', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3350', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3356', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-1407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1150', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4221', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1408', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0236', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-1409', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4226', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2010-2474', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-4230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3365', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2726', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-1000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3074', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3076', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2137', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1417', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2016-1000001', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2006-4239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4242', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-0238', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2099', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4126', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2302', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0201', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-2953', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2956', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2958', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3080', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2735', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4247', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-1355', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2138', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3093', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0240', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-1422', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-3377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2744', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4256', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0247', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2754', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3378', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0258', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0261', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-0268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0271', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0273', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0274', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0279', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2483', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1000005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0293', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0297', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0299', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2764', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0302', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0306', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0308', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0309', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0310', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0314', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0319', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2016-1000007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0322', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2142', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2778', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2143', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2781', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-2782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2784', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2148', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2150', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3397', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4291', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4298', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0344', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2496', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3106', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4317', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0363', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-2173', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-1463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4339', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0375', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-0379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0380', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3107', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1383', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1386', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2813', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-1000111', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-1000121', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2188', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000129', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1393', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3426', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1157', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-3083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3087', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3091', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-2736', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2737', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-4248', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3372', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3094', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3098', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0241', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1423', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3376', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2739', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2741', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4252', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1160', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2009-2746', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4257', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-2748', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0243', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-1161', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-0245', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1358', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2749', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-4263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2752', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-2753', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0259', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0267', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0270', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0272', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0277', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2482', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4268', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3383', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0303', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0305', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0307', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0324', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2765', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2489', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0332', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0336', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2323', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4134', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-2968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2108', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4273', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3104', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3390', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2146', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2154', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0341', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-4283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1431', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4270', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3389', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3391', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-1000028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-2769', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2771', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2772', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2144', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2493', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2151', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2153', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1368', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4294', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3405', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2162', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0347', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2016-1000037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0348', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2011-2167', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1192', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-1195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0391', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3429', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2193', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-1396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-1397', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1000136', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4389', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2196', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3438', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0394', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0396', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1222', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-1223', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4413', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4418', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-4423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4424', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4425', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-2983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-2988', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4146', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2351', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2353', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4157', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3007', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3012', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3277', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2114', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2363', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-4162', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0217', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1376', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2678', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-3280', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-4165', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2120', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4169', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-3032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3286', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2122', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2381', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-2385', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-2387', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-2388', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-2390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2123', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2402', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-2410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2412', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-4181', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1137', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4184', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2681', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-2683', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-4190', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-2686', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0221', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2688', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-0373', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0223', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4316', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1444', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-1377', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-4326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1178', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1454', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4331', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1462', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4333', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2006-4337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0371', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0372', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-1465', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1181', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2499', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3418', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1468', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-3109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2842', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-1000153', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3467', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1239', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3121', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1424', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4438', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-10002', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-1497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4442', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2220', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2222', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2850', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2227', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2230', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3126', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3131', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3134', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2557', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1434', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2241', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2242', 2.9, 'AV:L/AC:M/Au:M/C:P/I:N/A:N'),
('CVE-2016-1000220', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-2853', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2564', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2253', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2007-3487', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4460', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1438', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2277', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-2281', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-4466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-2300', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2303', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3155', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2318', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2016-1000236', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2327', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2875', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1139', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3042', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2690', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2431', 4.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2017-0376', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-2693', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-2432', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2434', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1336', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2435', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4199', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2441', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2879', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3164', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-3499', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-4469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0406', 4.9, 'AV:L/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2010-2583', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-1508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3170', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1344', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2448', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2009-2699', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2452', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4210', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-1385', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3331', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3332', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1389', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2713', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3338', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3341', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1399', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3060', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3064', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1349', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2007-3344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0233', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3357', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3358', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2136', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3360', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3362', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-2723', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3363', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1183', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0384', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-4377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3425', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1476', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0386', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-3431', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4388', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1402', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000137', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3434', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2527', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1215', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0399', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0400', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2011-2202', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-1000142', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3448', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000143', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1490', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4233', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-4234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0237', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3075', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3078', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3373', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3096', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1356', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3102', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2743', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4259', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4260', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1163', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0248', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4265', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0253', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0275', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0285', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0289', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0290', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3382', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0298', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1359', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4426', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000151', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3468', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4446', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4449', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3122', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2226', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1248', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2556', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2561', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2570', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1500', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2576', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2272', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-2275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2283', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-2577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4461', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1252', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3146', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1502', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2011-2310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2324', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2876', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2331', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3160', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2894', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3165', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2584', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2585', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2902', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4474', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3197', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-1511', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-3200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1456', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-3205', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1514', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-1515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1292', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4486', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-0413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000345', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-0418', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4490', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4499', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4500', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3523', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-1518', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0420', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2006-4514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2612', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2919', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-2924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2928', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3224', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1472', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3226', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2944', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2947', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2354', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-1480', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-3231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-0334', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1428', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1363', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2491', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2767', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3387', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1167', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2006-4275', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3388', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1365', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1429', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2009-2776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2140', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1168', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2015-1366', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2145', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2011-2152', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3393', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-0342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000033', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-4296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3400', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1172', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-3404', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3406', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1374', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3409', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-1000104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4315', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2627', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1383', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2948', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3242', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1395', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1402', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1407', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0437', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-0439', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-4550', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2634', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-2638', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-1497', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1419', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2641', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1429', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4564', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1437', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1439', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1440', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1442', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10012', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2644', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-0886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3259', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-4565', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-0888', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-1445', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0362', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4334', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2798', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2799', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0367', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-0376', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-2177', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0378', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-3417', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1466', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2804', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2502', 8.5, 'AV:N/AC:M/Au:S/C:C/I:P/A:P'),
('CVE-2010-2504', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-4340', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2016-1000110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1385', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4351', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2505', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3552', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1467', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2966', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1469', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3273', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2370', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3571', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1483', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1485', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1538', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1493', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2016-10026', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-2978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0893', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3294', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3589', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0461', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0897', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10031', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2008-3301', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3305', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1499', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4585', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-0469', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3314', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4589', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3599', 9.2, 'AV:N/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2013-1546', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-0902', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2984', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2377', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-0906', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2519', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1191', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-1394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2191', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1197', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0392', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-3428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1398', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1478', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2822', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1214', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2528', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2204', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1481', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2534', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1485', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3456', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4420', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3615', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4618', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2663', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4620', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2012-1236', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1237', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4434', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1000155', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1493', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000156', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2216', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1243', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1000218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-4450', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3474', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2012-1245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2225', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2851', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3477', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2571', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2262', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2856', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2007-3482', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-2264', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2271', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2274', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2278', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2578', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0405', 6.4, 'AV:L/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-3144', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1253', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-2307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3157', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3159', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2322', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2011-2325', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-2874', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2330', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-3162', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3498', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1256', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2896', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3503', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2901', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3169', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000282', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0483', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2007-3630', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3632', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3634', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2412', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3638', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-2676', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2680', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1523', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1530', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2698', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0488', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2992', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1577', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-4632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3650', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1558', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3663', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2724', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-2733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3364', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2748', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3678', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-0915', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10054', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2755', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3003', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3007', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0493', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3376', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3389', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3395', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3687', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3688', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-1564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3398', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-3400', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1535', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1543', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3691', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3695', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-3706', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3712', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3027', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3725', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3726', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1569', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3736', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3737', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4687', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1569', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3743', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4714', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1604', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4721', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1573', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1580', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1583', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4724', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4735', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1586', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1589', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-1590', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1596', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4753', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3053', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3058', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2432', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1597', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4755', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3765', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4758', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2010-2770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3780', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3790', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-2779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3795', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-1626', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1633', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1636', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1648', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-2783', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2010-2786', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1667', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2445', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10071', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-0921', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4784', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1712', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1733', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1740', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1744', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1647', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1772', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2009-3089', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2494', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3398', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2160', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4292', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1175', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3407', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2164', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2166', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0350', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-1376', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-4322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4328', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1451', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2013-1455', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0364', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0369', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2178', 6.9, 'AV:L/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2009-2802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3108', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0382', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0383', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-2500', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4344', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4353', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4355', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4362', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1000118', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000123', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1000125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4369', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-1185', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4376', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4380', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4382', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2520', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1395', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-4386', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3113', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1207', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2200', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1217', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0393', 2.9, 'AV:N/AC:L/Au:M/C:N/I:P/A:N'),
('CVE-2011-2201', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-1000141', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3449', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3450', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2531', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-2206', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2007-3459', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-4421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000148', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2539', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1000150', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2541', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1495', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1242', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4444', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2848', 8.5, 'AV:L/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2013-1438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4324', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3412', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4325', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2497', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1447', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1450', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-1461', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4332', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000109', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-0368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0377', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1180', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3475', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2238', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-2240', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-2250', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-2572', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2573', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2575', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3483', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1250', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3148', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3150', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1503', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-1000232', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2011-2305', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-2308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3156', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2317', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-1000237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1257', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-1258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-2899', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4471', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1510', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3181', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2903', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-2337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3194', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3195', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1454', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2008-3204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4481', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2341', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1262', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1473', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4374', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-4375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000127', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1000128', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000130', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2190', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2817', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000133', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0387', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-4384', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4385', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1477', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2523', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2192', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3111', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1472', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0385', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1392', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1189', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1193', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-3427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2522', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1203', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000135', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1206', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3435', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3437', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2529', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0395', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0398', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1480', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1221', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1482', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1488', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1235', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-2841', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2844', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2217', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2847', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-4276', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3392', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2147', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-1169', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-2786', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2156', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2157', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3105', 8.5, 'AV:N/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2011-2158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2159', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4288', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2787', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2790', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1171', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1000032', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-4297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2163', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1176', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2165', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3410', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1439', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4305', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4309', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4314', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2198', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2015-1414', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1220', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000140', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2205', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000145', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1483', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1484', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1487', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3117', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1227', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000146', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4427', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4484', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2015-1462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4493', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3522', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3527', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2009-2917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-2923', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2618', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3529', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-2351', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4443', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1244', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-1432', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000219', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-1247', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4455', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2548', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-2232', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-2852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3140', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2255', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2569', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3493', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2263', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2267', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2282', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-2579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1505', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2011-2302', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2315', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-2321', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-2329', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2883', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4468', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3163', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2582', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-1509', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2008-3172', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000338', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-2589', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0407', 6.4, 'AV:L/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2016-1000339', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-3199', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-3203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1458', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4476', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3210', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3215', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4482', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4318', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1177', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1378', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-4327', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1379', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-4330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1381', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0366', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0370', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2013-1464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2176', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0381', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-1182', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2503', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1469', 4.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:P'),
('CVE-2013-1470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4356', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4359', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4360', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-4364', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000115', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1000116', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1000120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1000124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2515', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4371', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-2816', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000131', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1000132', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1196', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2194', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1399', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-2540', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1423', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1000154', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2546', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2558', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2239', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-3141', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-2248', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2252', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2574', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2011-2260', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-4458', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3478', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3480', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-3492', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2016-1000229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2279', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2015-1441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3232', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1337', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3236', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1387', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1489', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-1398', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2949', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4549', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0444', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-3249', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1415', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0885', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-1434', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1447', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1515', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1516', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3546', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1517', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-2647', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1532', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-2965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2970', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2369', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000342', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-1516', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-4485', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-0414', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1000344', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-3514', 7.8, 'AV:N/AC:L/Au:N/C:C/I:P/A:N'),
('CVE-2010-2594', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000352', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-2348', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000112', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-1000113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1000117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1000122', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3110', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2507', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2185', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1389', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000126', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1474', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1186', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-4378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1475', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4381', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3112', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0388', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0389', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000134', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2526', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2197', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2301', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-3153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1254', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2320', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2323', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2328', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2897', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3171', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10003', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3186', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3192', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2338', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-3505', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-0411', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2008-3201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1457', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-3207', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000340', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-2342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1477', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10028', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1545', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0463', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2980', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4577', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4582', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1548', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4584', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0900', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-1558', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-2659', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4593', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2982', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0423', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2009-2916', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2918', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2922', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3225', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2937', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3530', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2945', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3532', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1482', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1526', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1385', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1487', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2012-1392', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3536', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1404', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4543', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4552', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0884', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-1499', 7.8, 'AV:N/AC:L/Au:N/C:N/I:P/A:C'),
('CVE-2014-0449', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10011', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-1426', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1445', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1448', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1456', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2645', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3445', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3451', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3116', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000144', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1486', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1489', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1000152', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2212', 10.0, 'AV:A/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-4433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1213', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3436', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1479', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000138', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1216', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1405', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1419', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2535', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3455', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2207', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-0401', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-4488', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3512', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1464', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-1296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000346', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-2596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2347', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0422', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3525', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-2609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4517', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-2920', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2931', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-2934', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10009', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2012-1507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1508', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1551', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-0910', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2988', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4625', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-1568', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3329', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2411', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-2681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0486', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-0487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2702', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1580', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1560', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2007-3662', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3338', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3345', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3357', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1234', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000149', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0402', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-0403', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-1427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2221', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1431', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0404', 4.9, 'AV:L/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2010-2547', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3133', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3135', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-3137', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2562', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2251', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000221', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-3486', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1426', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2214', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1000217', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4447', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4448', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2223', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2545', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3127', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2257', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2855', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2280', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-4465', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2288', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2297', 8.5, 'AV:L/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2007-3495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2860', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2864', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3550', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2363', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3551', 6.9, 'AV:N/AC:L/Au:M/C:N/I:N/A:C'),
('CVE-2012-1466', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2961', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3263', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3554', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-2967', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3559', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3572', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3577', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1474', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4569', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-10024', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2012-1495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0457', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0460', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-3292', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-3295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2979', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0464', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-0898', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2011-2373', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-4578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4587', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0471', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4523', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3531', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-1476', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0431', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-2624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0434', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4534', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4540', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1370', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-3237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2631', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1389', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1396', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1408', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2635', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1414', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2359', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2738', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3361', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-4642', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2751', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-2752', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2753', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0492', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2756', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3391', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2421', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3405', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1537', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4673', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-1568', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-3409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3410', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3690', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-3696', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-0917', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3022', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3023', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-3420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2880', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2581', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3182', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1000307', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2588', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3504', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2906', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-3214', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-3217', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1545', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0473', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0474', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0475', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0476', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4616', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3604', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-3608', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10043', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2006-4617', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0478', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2008-3322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3324', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-4621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2987', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3622', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-2671', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1000222', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-2273', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1251', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-2284', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4464', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2858', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2859', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2580', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2319', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-2326', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-2878', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3497', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3166', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2898', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3168', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1506', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2008-3173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3177', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4472', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2587', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2904', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3185', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3187', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3190', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-2590', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3196', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0410', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3507', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3208', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1000341', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3216', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3508', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1512', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1289', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1291', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3218', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4492', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1302', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3515', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3517', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2910', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3738', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4693', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4709', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1601', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3044', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3746', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-1574', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1606', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-1590', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3759', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2768', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4751', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1609', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2441', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2643', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-3544', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3257', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2954', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-0887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2009-2960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1534', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1536', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-3266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2964', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1522', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-2650', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4567', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-2974', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2652', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4483', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0412', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-3511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2346', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1297', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2600', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3635', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-2677', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1529', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2697', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-2699', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3641', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1578', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-3653', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1559', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-2711', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3665', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3673', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2717', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3675', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3353', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2732', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-1562', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-10051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2997', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2998', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3681', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-4651', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3373', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4658', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1563', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-4664', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3393', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4671', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2422', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0496', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1538', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1545', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-3693', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1558', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4676', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-3412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3698', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3702', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4679', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1598', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1570', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2349', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2603', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2613', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0427', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-1521', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3069', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1606', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-4763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1613', 6.4, 'AV:A/AC:L/Au:M/C:P/I:P/A:P'),
('CVE-2009-3070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1616', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-3791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1631', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1642', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3796', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-1652', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1657', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1668', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1621', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10072', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-1627', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-1671', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3077', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4783', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1687', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1691', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1694', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0505', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2794', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-1633', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1633', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4787', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3804', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1741', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1748', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1644', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-1761', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-2799', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0508', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1482', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3277', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1537', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10025', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3279', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10027', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3282', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3288', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2372', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-1540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3592', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0465', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0466', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1497', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4581', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3312', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1550', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-1554', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2375', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2378', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3617', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-3619', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1553', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-0911', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2012-1514', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3327', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-2989', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3221', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1520', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-4508', 4.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:P'),
('CVE-2007-3524', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4513', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2602', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2604', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3526', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1335', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3528', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2617', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4519', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4520', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2946', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4525', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4526', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1523', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2013-1525', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2625', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0881', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-2358', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4708', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3430', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2426', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3748', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3046', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1572', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1577', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2767', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4725', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-3809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1649', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2010-2801', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1659', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2014-0512', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1662', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1639', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3097', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-4824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1640', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-4826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3829', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3839', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-4827', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-1643', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4839', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1788', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2453', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3132', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1653', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2009-3158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3161', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1680', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-1659', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-3168', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4855', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-0925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4521', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2352', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1336', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1475', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1481', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4537', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-0882', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-1527', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1348', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1388', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1488', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1393', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1394', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1400', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4547', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3244', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3253', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3543', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-0451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1423', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1430', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1436', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1531', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1449', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1390', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1391', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1397', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1409', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1493', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2012-1413', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4553', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3252', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1416', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1594', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2438', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2443', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4759', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2012-1605', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1611', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0502', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-0920', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-3776', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2771', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1618', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2015-1634', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1620', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1670', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3076', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2446', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4782', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2014-0504', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2790', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1631', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-1706', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1555', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-3331', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0484', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2667', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-10046', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2010-2685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1525', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2703', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3639', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-4631', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2994', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3655', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3668', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2415', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3352', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2996', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3868', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3207', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3212', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3213', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10093', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3449', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3451', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0521', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0527', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10099', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-4883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3458', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3466', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3471', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3893', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3896', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3242', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3902', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4888', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1695', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1696', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-3490', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2458', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3915', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-3920', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2016-10101', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4910', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1810', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2015-1729', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1732', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4790', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4796', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1743', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1642', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1752', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1763', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-3806', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4798', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4803', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4806', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1650', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-4811', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1655', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-3814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3816', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1774', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4819', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-2451', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10083', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3106', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10084', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1783', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-2648', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2968', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1468', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-2973', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-2366', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-2651', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0892', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-1481', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3286', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3293', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1546', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-0895', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2008-3298', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-3300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1460', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1464', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2646', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3261', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3262', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-1533', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-3556', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-0890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-2975', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3563', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0456', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3274', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2371', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1539', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2007-3583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4570', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-2745', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-4652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2754', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4661', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2759', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-0494', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3392', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-3394', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0495', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3689', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-4674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3015', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3019', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3414', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3707', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2424', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2764', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3304', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2658', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3597', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-4586', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2015-1551', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1559', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4595', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-0904', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3601', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2006-4603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10036', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1509', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1510', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1548', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-3320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2985', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2381', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10039', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2007-3614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4619', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P');
INSERT INTO `tpandora_cve` VALUES
('CVE-2012-1512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1513', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-1554', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3325', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-0913', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-1520', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3625', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0482', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-1556', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-4627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2666', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4830', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1651', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-3118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3122', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-3125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3129', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3152', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3156', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2009-3160', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2012-1676', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-2806', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1685', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1793', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2006-4857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4858', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1688', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-0519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1671', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3210', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3872', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10094', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10109', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3508', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2852', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10000', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2011-2464', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1703', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2008-3520', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3931', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2862', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2474', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000015', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3936', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-1706', 4.9, 'AV:N/AC:L/Au:M/C:P/I:P/A:N'),
('CVE-2006-4940', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3945', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-3307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4946', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4684', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3425', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4705', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3756', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1575', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1578', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1588', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4723', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4727', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3283', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-3285', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0894', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-10029', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-3590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2657', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10030', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3303', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4574', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3598', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2017-0901', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-1547', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0472', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4600', 2.9, 'AV:A/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-2660', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4614', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-2380', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2661', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1588', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2006-4750', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3052', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10069', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-4756', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3060', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1610', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-1615', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4771', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3769', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-3072', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2772', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1614', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1627', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1639', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1641', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1649', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2784', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-1660', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1665', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1616', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1617', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2788', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-1623', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1684', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-2447', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1625', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3079', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1704', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3080', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3452', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3222', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0526', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3887', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4886', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3473', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3241', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1806', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-2700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3337', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-3647', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2709', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3651', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3656', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-2995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3339', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1588', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1591', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3676', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4657', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2417', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4669', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3380', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3381', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3384', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0916', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1566', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2015-1594', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3016', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1563', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-3025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4682', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3734', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3037', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4697', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4704', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1602', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3432', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3747', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1517', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2014-0415', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1463', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4497', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2911', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4503', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1326', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2010-2601', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-2914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3222', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-2614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3321', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2486', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1820', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3329', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1821', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3345', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3351', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4972', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3356', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3368', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1830', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000033', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1833', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-1000038', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3379', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3381', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1696', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-4980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3539', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4991', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2881', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4994', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1838', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2008-3545', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3547', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-3392', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5001', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3397', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1699', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3408', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3421', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1841', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5018', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1842', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3968', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3559', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1843', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3437', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2887', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5028', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3441', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5031', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1849', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3589', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1851', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2007-3984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3985', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3445', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10130', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-3988', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3595', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2901', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3611', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3616', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2383', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-2386', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1518', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3326', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4624', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-3328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2397', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3626', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2399', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2402', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3628', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3332', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2406', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3633', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-2410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1521', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1739', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1641', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-1753', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1765', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3085', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4799', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3807', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-3811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0922', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1777', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-2802', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1661', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4822', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3095', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1664', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3108', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3818', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-4825', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2452', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3823', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3825', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3832', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1646', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4836', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4838', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2805', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3128', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4845', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3149', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1654', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1677', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1791', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3167', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1669', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4860', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4865', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3856', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1796', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3907', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0532', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0928', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3494', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-3257', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2009-3260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1700', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-3919', 9.2, 'AV:L/AC:M/Au:S/C:N/I:C/A:C'),
('CVE-2016-10103', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10104', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-1678', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2838', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3923', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-0936', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2009-3276', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0535', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3045', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1576', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-1578', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1580', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1581', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1584', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1587', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1589', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3758', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3049', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3760', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3762', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3763', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2434', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2437', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1613', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-3061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1604', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1617', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-4766', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3768', 7.8, 'AV:N/AC:L/Au:N/C:N/I:P/A:C'),
('CVE-2007-3770', 7.8, 'AV:N/AC:M/Au:N/C:C/I:P/A:N'),
('CVE-2007-3775', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1613', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3782', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3792', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3794', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1632', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0503', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-1661', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1621', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1623', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1673', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2791', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1685', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1689', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3800', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2014-0506', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2935', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1473', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-2620', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0432', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4527', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-3230', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0435', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-4532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1484', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2012-1346', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4541', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3234', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1380', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1382', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3239', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-0883', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2015-1492', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-1399', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1401', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1403', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2633', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4546', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0438', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0445', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2637', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4554', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10010', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0448', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-4558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-1425', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1431', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4563', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1450', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1461', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0453', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-3549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1521', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-2963', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3553', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1535', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3265', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3268', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3271', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4922', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3289', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2472', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2017-1000004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-1813', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4939', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10112', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3939', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1687', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3300', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3312', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3947', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2009-3326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-1854', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-1706', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2505', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-1000081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2920', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0544', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2935', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2941', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000088', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1709', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000092', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0546', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1798', 2.9, 'AV:A/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4876', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3197', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10091', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-2808', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3447', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10096', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2010-2810', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3455', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0523', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0529', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4880', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1673', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3229', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-4885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3474', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3477', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3480', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3483', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3246', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4889', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3906', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3910', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3255', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3256', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2826', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-0927', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-1677', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1627', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-1630', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1705', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1708', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1715', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4794', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3084', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1764', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1771', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1648', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2011-2450', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2800', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0923', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4812', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1652', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2007-3813', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1660', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-1776', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3099', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3102', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10087', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-1787', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-3838', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4828', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1649', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4842', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-1666', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3121', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-3150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1790', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1581', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1585', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3664', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4638', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3355', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4639', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2728', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1561', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3362', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3368', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4653', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1532', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2757', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3006', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10058', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-1471', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1472', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2012-1475', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1479', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4955', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4959', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2875', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3340', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3346', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4967', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1827', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000029', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000032', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1828', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-3952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3956', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3373', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3377', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3380', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1713', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1697', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-1698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2883', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3412', 2.9, 'AV:L/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2009-3428', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3460', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10148', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-1868', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1872', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3978', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3577', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2898', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3983', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3986', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000059', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3592', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-3594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3449', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000061', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-1000063', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3597', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2902', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2507', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1000082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3615', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2762', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2423', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3694', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3700', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-3710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4680', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1597', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3716', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1006', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2006-4685', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-3428', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4706', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-3751', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4719', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3752', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1573', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1579', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0499', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-0500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1883', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1889', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3476', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1899', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4026', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3490', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1715', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000106', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:H/A:N'),
('CVE-2006-5068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1914', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1923', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1929', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1930', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-10155', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-10157', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4047', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-5072', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-5078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3524', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4058', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3670', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3534', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3537', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1932', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2970', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1943', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1951', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5111', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3551', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3553', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1958', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2987', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1969', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2547', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-2561', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-2563', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4073', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4571', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1543', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-3302', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-1498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4573', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2014-0467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2374', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2981', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3262', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1699', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2007-3917', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4900', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-4906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4907', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4908', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1679', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2848', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3272', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2461', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3925', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-2854', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3281', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2858', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000001', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-3521', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2471', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4935', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3855', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4874', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10092', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3880', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3446', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10097', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-2809', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3453', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3227', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2813', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2511', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-4005', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4007', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2930', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000087', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-3458', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1859', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0545', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2237', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3138', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2559', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2243', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-2560', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2244', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-2245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1249', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2854', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1436', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3147', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2013-1504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2865', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-3158', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2877', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3167', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1000271', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2586', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3175', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1453', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4473', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-2905', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3191', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0408', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2339', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-1459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3510', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-1264', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4487', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0417', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0419', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4491', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10005', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-3519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4506', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-1519', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4509', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4510', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4511', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0425', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0426', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4596', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-10034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-2983', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3602', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-4605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4609', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3603', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10038', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2006-4612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4615', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-3605', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-3606', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-3612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3613', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0477', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2382', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-3618', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-2986', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3323', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-2664', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0480', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-2391', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2403', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-2990', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2668', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-2405', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2991', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1522', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3050', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4739', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4743', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4749', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4754', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2433', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2436', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4757', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2006-4761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4767', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3771', 6.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-3779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1619', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3781', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1621', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1623', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1619', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2015-1646', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1658', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1666', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3798', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1672', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1682', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1686', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1629', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3078', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1742', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1747', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1751', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1760', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3805', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2009-3086', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4807', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2013-1637', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1653', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3812', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1656', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1775', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-0510', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1779', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-1781', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3243', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4887', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3901', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-3244', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3908', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3912', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3493', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2834', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2835', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1701', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1808', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2009-3266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2589', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3558', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3000', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10162', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2594', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1982', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-3003', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2602', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-2603', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-1000117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-3565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000118', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5160', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4116', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4120', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4122', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4124', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-4131', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3568', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3574', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3582', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3583', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000122', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-1000133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3601', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10169', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-4138', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1992', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000143', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-1996', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3603', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5172', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4149', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4157', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4159', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3935', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1000013', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4938', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2865', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1705', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2866', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1686', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4942', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-3537', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-1000018', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-3301', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3311', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0538', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1712', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4956', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4963', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-3337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4964', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4976', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3366', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3369', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-2877', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1832', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2007-3953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3958', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-2879', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3375', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3376', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3382', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4989', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1836', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2011-2350', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4518', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2615', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2939', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2619', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0430', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2011-2353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-1479', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-4020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3472', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1894', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1897', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3649', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3650', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-1906', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1909', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5060', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3482', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-3489', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4032', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4901', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-10105', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3270', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10108', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2850', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3284', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1682', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1816', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3940', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4943', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-1526', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2695', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2704', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3335', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3643', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2993', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4635', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-2710', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3652', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3657', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3658', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3667', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2722', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1590', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2730', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4640', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4646', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2416', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4660', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-3009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1533', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3396', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1565', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3399', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3407', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1539', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3013', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3692', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-3017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1595', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3715', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3028', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3032', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4694', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4695', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4702', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0498', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5065', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4039', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2528', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10151', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1921', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-1721', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1927', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3522', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3525', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4059', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-3532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3677', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5090', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3535', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1933', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1934', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1944', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1945', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1946', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3545', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-5114', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5122', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2010-2974', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1720', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1963', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1971', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2006-5133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5134', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-5140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4087', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4090', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5144', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5146', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4098', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-3557', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1734', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3022', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-3024', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3039', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3042', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3044', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1741', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-5185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2620', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1756', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-2621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3054', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3061', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3064', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-20105', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2009-3617', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-3618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3619', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3694', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1760', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1762', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1766', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1770', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000190', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-1000191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-2624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4191', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1776', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000195', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-3627', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000198', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-1787', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1714', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10124', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-1000043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3961', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3385', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2006-4993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3387', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3543', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3388', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1839', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2007-3963', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4996', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1000051', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3553', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3395', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3404', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-5016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3411', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2009-3415', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-3422', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3558', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3563', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3439', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3574', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-3973', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3576', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1848', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000054', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5034', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2900', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10131', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1000066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2502', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1782', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3111', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3826', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3833', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1667', 7.8, 'AV:N/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2009-3119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3127', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3131', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3153', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3157', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1674', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-1662', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1792', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3169', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3854', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-4864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2807', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3179', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3192', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3199', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3874', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-4878', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3875', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3014', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0497', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3699', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3708', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4681', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3029', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-3728', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3031', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2765', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4712', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0918', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4718', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1574', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3229', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0436', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2356', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-4539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1381', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1384', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1386', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1485', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1490', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2015-1491', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-3535', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1406', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0440', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-4551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-2950', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3248', 6.9, 'AV:L/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2010-2639', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-2951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3254', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2640', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-0450', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2361', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3302', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1819', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4960', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3338', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3344', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3350', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4965', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4971', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4975', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3358', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3361', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-3951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2878', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-4990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3544', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2006-5000', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3221', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3225', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0528', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1689', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-3888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3230', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3459', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-3472', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3476', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1674', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3897', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3245', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3250', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-3251', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1676', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3918', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10100', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-10102', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1680', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-2503', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2508', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-2912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2913', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000083', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3998', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2940', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1858', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4014', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1860', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000095', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-4016', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10063', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-1576', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1581', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1591', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10066', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-4733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4745', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-10068', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-3277', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2855', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3282', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2467', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3929', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3524', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-4924', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4927', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2863', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1684', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4937', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-1000012', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000016', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-1685', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1582', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1586', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10065', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0501', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1585', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-4740', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1591', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1593', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4752', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2430', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2435', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2439', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1600', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1609', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-1607', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4768', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1618', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-4770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1611', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3772', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3777', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2777', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-1625', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1651', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1662', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10070', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-5148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2593', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1981', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-1983', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1987', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-10165', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2006-5162', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4113', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2007-4117', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4123', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3578', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000126', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-3591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000134', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-1000137', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4135', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-4139', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1725', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1997', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1731', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-20001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-4152', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4154', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1726', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2642', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-2953', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2362', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3545', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-2955', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-2956', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3547', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-3548', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-3260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-2957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2364', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-2959', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2365', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3264', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3557', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0455', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2367', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2007-3561', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-0891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3573', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3576', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3581', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1476', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1478', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1480', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1484', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3462', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2951', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2953', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5056', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1882', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-3470', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000102', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3478', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-4024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1898', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1907', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2522', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000104', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3488', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-1000105', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-4034', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-3494', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000110', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2009-3508', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3514', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1916', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3660', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1920', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1925', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-1717', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2006-5070', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10158', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-3967', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1716', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3433', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2884', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2888', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5025', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3976', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3442', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000056', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1717', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2018', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-2026', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-2028', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2631', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1796', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3631', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-2043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2046', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5238', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2478', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000017', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3298', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-1818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3944', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2870', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3305', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2872', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4949', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4958', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4962', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-3339', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-1000024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2487', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2440', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4760', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1612', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4772', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3773', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3774', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-3071', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4777', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-2778', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1624', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1650', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2785', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-2787', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1624', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2010-2792', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-1688', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1700', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-2448', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1710', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1714', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1638', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-1728', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1731', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4788', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1738', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1639', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-4797', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1759', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2798', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3352', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3363', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3364', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2488', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3372', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3954', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000034', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3959', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3384', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2882', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3964', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3401', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-3407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3409', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2009-3416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3423', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3426', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1700', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-3528', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4065', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1935', 8.5, 'AV:N/AC:L/Au:S/C:P/I:P/A:C'),
('CVE-2010-2969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1942', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1949', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3544', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1954', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1956', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5119', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2011-2546', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5127', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1966', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2562', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2564', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1723', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4080', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-5132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4086', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4092', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0552', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2587', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-4172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3036', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1742', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1744', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1749', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10170', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1000172', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4179', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-1730', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1763', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-3584', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3289', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3290', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1541', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-0462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3594', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-0896', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-3299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1547', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-3308', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4576', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0470', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1555', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-1503', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1544', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1506', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3600', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-0905', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2376', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1561', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4608', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10037', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2006-4610', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-1549', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3607', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10040', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-10041', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0909', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2385', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1552', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3620', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3624', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2401', 8.5, 'AV:N/AC:M/Au:N/C:C/I:P/A:P'),
('CVE-2015-1572', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3629', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1574', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2407', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-2686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1524', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10047', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-3586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3982', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10133', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000062', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000065', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3450', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000070', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4006', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2927', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2929', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4009', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2937', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3625', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000089', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2010-2944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2945', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2515', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-10143', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2516', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000094', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1865', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-1866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1719', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2949', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1870', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2520', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2015-1875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3465', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10001', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:H'),
('CVE-2010-2956', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-3640', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3466', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3641', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3469', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3473', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4025', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1901', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1904', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3652', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1910', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3483', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4029', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4031', 7.8, 'AV:N/AC:M/Au:N/C:N/I:P/A:C'),
('CVE-2016-10073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1692', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1624', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1626', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-10074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1635', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-2449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3803', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1631', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-1711', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0507', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1736', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1737', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1646', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1762', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2009-3087', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3090', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1773', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4801', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-4805', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4809', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-4810', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1658', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-1638', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4821', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3817', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0514', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3110', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2007-3820', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3112', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0515', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3113', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2007-3834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1645', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-1650', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3845', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3123', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3130', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1670', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4848', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3969', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1844', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-2889', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3971', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5024', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1847', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-3977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3979', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3582', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2899', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3448', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1852', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1705', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3600', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3993', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3996', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000073', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5043', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1718', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1724', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3562', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-2993', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2996', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2999', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3002', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1976', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-2595', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2599', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5152', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1985', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2010-3009', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-2607', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5164', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4115', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5165', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10167', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-5168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2610', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3581', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-3595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1727', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2612', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-5171', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1993', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1000147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1000151', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000157', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-4144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4148', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4151', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4162', 7.8, 'AV:N/AC:M/Au:N/C:C/I:P/A:N'),
('CVE-2007-4164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4170', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1727', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2017-1000159', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3693', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3040', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3041', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1739', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1743', 2.9, 'AV:N/AC:M/Au:M/C:P/I:N/A:N'),
('CVE-2012-1745', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1747', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1753', 6.4, 'AV:N/AC:M/Au:M/C:P/I:P/A:P'),
('CVE-2012-1651', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-3094', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2012-1654', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-1657', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2007-3815', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0511', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3098', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3100', 6.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2009-3107', 4.9, 'AV:A/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-3819', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1641', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-1784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3822', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-3824', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3827', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3836', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3837', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4829', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-4831', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-0924', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4843', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4844', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-1652', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2006-4846', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3135', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3147', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4847', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1671', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3847', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4850', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1682', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4000', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-2933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2936', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2942', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-5047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3627', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10146', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-1862', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-2947', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3615', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000171', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5188', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3056', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3062', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1731', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1767', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-20106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4189', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3622', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5198', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-5199', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3071', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000199', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000201', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-4199', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2031', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4203', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2632', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000224', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2010-3092', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2017-1000232', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1811', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4250', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2007-4254', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1819', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3694', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1762', 8.5, 'AV:N/AC:H/Au:N/C:P/I:P/A:C'),
('CVE-2008-3719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2076', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000240', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1826', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-10194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2663', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1770', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4270', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1828', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-2090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2091', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000246', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1000247', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-5270', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000249', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-4272', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000250', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3170', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3853', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3857', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-3859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3178', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3182', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3871', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1799', 4.9, 'AV:A/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-3198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2811', 6.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-0522', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0525', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3883', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3456', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-3237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3890', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-4206', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1800', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2636', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4216', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4220', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2015-2047', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-10188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1675', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3911', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3258', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-1010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3921', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-0931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3497', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3499', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3503', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2837', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2840', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3271', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3505', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4915', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2460', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1681', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1679', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-1656', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10089', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1794', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3181', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3870', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3211', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3214', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10095', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-3444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3216', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3218', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3219', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3223', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1804', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-1672', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2456', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3233', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3475', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3895', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3636', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1712', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4022', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1000100', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-1884', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1886', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3467', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1896', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000103', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1913', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5059', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3653', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2524', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5064', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-2701', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-0914', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-4633', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-3645', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-4637', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-3649', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3659', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3672', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3350', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1589', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-2720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3356', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1531', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3360', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3365', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2747', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10053', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-3654', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2526', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000108', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-3510', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1924', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1928', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2011-2530', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2533', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-3663', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2536', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2543', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-4051', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2544', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3529', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4185', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3621', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5195', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1781', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3624', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2011', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-2014', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-3075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4204', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-1797', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5220', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2633', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2035', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4041', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3656', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2961', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0549', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10156', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3521', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5074', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5077', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-1718', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5086', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-3671', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5094', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1941', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-5097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1947', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1953', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5120', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-4069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0551', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3514', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1704', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-3519', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-4925', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2859', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2475', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4936', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2864', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-1814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3295', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2867', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-1779', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2008-3740', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3742', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3744', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-1835', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2107', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-3724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2684', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-3764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1845', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3696', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4654', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10055', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-1592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3685', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-2419', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3385', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2420', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2760', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10059', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-4062', 7.8, 'AV:N/AC:M/Au:N/C:N/I:P/A:C'),
('CVE-2007-4064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3675', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3680', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1948', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5115', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4068', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-3550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2986', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5130', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4075', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2577', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4081', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000113', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3555', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-3699', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-5245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3652', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3701', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3654', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-1000234', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-1753', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3708', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4256', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3661', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3666', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3102', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2650', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3105', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-4262', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-2080', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-5259', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3726', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2083', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1824', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1766', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-3733', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3111', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3736', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-3112', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5268', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5274', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-1778', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2009-3719', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3741', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3745', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2013-1782', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-2110', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2112', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-4276', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2681', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4277', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2015-2118', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1967', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1974', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-5141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1722', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2592', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2992', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2997', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-3005', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-1723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1567', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-1561', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2763', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3703', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3709', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3714', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1596', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-3026', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1599', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3035', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-4683', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4707', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3429', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3431', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3745', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2427', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1585', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2428', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4726', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-1593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-4731', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-2429', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3637', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000219', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4227', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000220', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5241', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000225', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4246', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5244', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3704', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0565', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3673', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000239', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3717', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2590', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2591', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3561', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-2995', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4105', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2604', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2016-10163', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-1986', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3006', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5167', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3570', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3580', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3597', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4140', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3017', 6.9, 'AV:A/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2015-1999', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4143', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-1000154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4145', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4150', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4155', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000163', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1000169', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1751', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2457', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3254', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1807', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-3492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3263', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3916', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-0930', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3502', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-3264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4897', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4902', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2459', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2839', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3922', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5157', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-3007', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2605', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5163', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-1000120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000121', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3573', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3577', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3692', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000132', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-1000140', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1728', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-4141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000141', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-1000144', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-1994', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000146', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2614', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5177', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3608', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-20019', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0555', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3536', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-3943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1688', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2010-2871', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3304', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-3306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1690', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000022', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-3948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-2874', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000025', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-2876', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4973', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3354', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1000027', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3370', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2489', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2490', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3383', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000042', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-4981', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1607', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-4744', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2431', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1599', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-3764', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2442', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1616', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3068', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4762', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1608', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1614', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1617', 10.0, 'AV:A/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-3785', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2007-3789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1622', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3074', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1653', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1659', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3075', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1620', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-1683', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10075', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1632', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-2795', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-4785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1703', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1709', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2796', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1717', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1718', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1730', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4789', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1640', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-1745', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1645', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-1767', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4802', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2656', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1825', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2086', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3734', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1827', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2664', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-1769', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0566', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3704', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4271', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5271', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-3737', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1831', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5273', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-3714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3717', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3721', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-3114', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3746', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10199', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-3115', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-2676', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2015-2115', 2.9, 'AV:A/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-3730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1788', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3766', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3118', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1737', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3614', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-4988', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1835', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-1000046', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-3550', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3403', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3405', 4.9, 'AV:A/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2009-3413', 4.9, 'AV:N/AC:H/Au:M/C:P/I:P/A:N'),
('CVE-2009-3414', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2009-3419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3966', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3429', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3561', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4808', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2016-1008', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10081', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0513', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3096', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3109', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10086', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-3835', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-3841', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-3115', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1648', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1669', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3126', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3133', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3846', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3151', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3159', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1678', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-3163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3166', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1686', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1668', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-1795', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3852', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3177', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3186', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3189', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4873', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2455', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3206', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1802', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-3873', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1803', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-3448', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2812', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0524', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3457', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-4884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3231', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3460', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4282', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1854', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1855', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1862', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3769', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3773', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3274', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1702', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3928', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-2465', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2011-2470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3522', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4923', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3288', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4926', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1683', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2473', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2017-1000005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2477', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-1707', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-1815', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3532', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3533', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1881', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1889', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4289', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2132', 6.9, 'AV:L/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2008-3776', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3122', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3781', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3125', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5287', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-2137', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4328', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3788', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4335', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2141', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3800', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-3801', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-1000353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2125', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-4296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2134', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-3783', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4322', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3744', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5286', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4324', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4329', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3130', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1902', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000256', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4338', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3767', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1906', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-2143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-3134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4352', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-4356', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10203', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3828', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1915', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000360', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-1810', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2006-5306', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2622', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3065', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1758', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1764', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1769', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4192', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5203', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-3069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-20107', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2006-5205', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3942', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-3538', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-2869', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4945', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3949', 8.5, 'AV:N/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2015-1822', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1693', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-10204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000355', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1919', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-1924', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2166', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4309', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-3742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3765', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4327', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000254', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-3766', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1901', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3795', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4346', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000257', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-2142', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3814', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-3820', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3824', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2144', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3138', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3153', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1804', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5303', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3830', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10209', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-2697', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4373', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3797', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4377', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-1815', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4378', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3799', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1926', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2170', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3808', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1820', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-0578', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3831', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1690', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1693', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-3899', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3903', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3248', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3485', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3253', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4893', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1697', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-3261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-0929', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3500', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3265', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-4899', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3924', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-4913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-4914', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-4918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3926', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-4919', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-3515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2857', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3927', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2468', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1812', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2007', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2010-3053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4180', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000188', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1773', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4186', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2626', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5197', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5201', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2007-4195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3626', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-20109', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-10002', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-3695', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3628', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-5210', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1792', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-2027', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1799', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5026', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2897', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3443', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000053', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3578', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000075', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-2909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1707', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3623', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2934', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1708', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3626', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3816', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4383', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3850', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2188', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2194', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3855', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2718', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-5330', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3863', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1830', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3873', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2180', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10214', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-2181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1933', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2711', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4407', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-3847', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2190', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4408', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2197', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-3859', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5363', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-5376', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-3879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5349', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5360', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5367', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-2722', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-5380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4431', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5393', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3169', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5403', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5408', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1952', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3840', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3846', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2713', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1824', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3848', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4413', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2720', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4414', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-1834', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-5347', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5354', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5364', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2006-5370', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5377', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-2202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4420', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10221', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-4427', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2725', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2204', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1853', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2728', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-3933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0536', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1708', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3529', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2481', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3946', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-4947', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3313', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-1711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2873', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000023', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3371', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4977', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-4978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-3955', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-3957', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-4979', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3378', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2880', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-3960', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-4992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3551', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3389', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3393', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5002', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3400', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-3402', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2009-3406', 2.9, 'AV:A/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-5017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3418', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3424', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1840', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3431', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3555', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000200', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-1788', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1789', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2016', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-1000203', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2025', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2029', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0558', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4205', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-5230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2634', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2943', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-3630', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-4017', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-5051', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2948', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-4018', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0547', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5406', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-3171', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-5411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2217', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5420', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5427', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2222', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3175', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3860', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2233', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3864', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3867', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4448', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2238', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3635', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4219', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2637', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4223', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1747', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1749', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3639', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-1000221', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-4235', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3641', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3647', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4243', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1807', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3698', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3089', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-5248', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-1000228', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3651', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3702', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5252', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3657', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-3097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4259', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3674', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000236', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3693', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000237', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3718', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-2072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3700', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3732', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3109', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2662', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5430', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3866', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3871', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5445', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1959', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3178', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-5460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3921', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-4457', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-1968', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2754', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1872', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2762', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5472', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4471', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5480', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4478', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4485', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4493', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1890', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0586', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1802', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-3085', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4231', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3087', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3088', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1809', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000226', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-3091', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1810', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2058', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3096', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3655', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0564', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3710', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-2062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3106', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3729', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2652', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2084', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2654', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2658', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000243', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-2667', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-2671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2672', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3716', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5276', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1780', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2008-3739', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1781', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2008-3755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3758', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2113', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5277', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3760', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2682', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-4279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2122', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-1789', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3117', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1856', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2008-3853', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5410', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3863', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2890', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3440', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1702', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-3980', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-1704', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10134', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-3451', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2504', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3607', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-1855', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-3999', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000085', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-1695', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0540', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-4986', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3542', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-3386', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-4995', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1885', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1888', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-3477', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1902', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4027', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-1720', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5063', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2527', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2529', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3515', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4043', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3659', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-1922', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4045', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3662', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4280', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-1856', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1859', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1874', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1878', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1896', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3734', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4304', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-3778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4314', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1898', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3748', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3127', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3128', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1799', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4347', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-3818', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3787', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3131', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5298', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-3826', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3146', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3148', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4351', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3156', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5301', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3157', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2149', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4369', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5453', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2744', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4451', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2745', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5456', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2748', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-1866', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2008-3882', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5014', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3410', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2009-3420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3965', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3425', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3562', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-3970', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1845', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1701', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5027', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3573', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-3972', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-3975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0542', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3579', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-1000058', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-3990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1000067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0543', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3708', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3712', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1832', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4273', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3749', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0572', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3728', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2686', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5278', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1860', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2012-1863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-2124', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4284', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1879', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0573', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3775', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1897', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1795', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3124', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4331', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1900', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2139', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-2772', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2270', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0587', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2272', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-2779', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-3205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3907', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3213', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3910', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5500', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3231', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3239', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3912', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3244', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3914', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-2931', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2932', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1856', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2008-3624', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2513', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-4013', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000091', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2009-3459', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10144', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000093', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-3461', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1863', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3635', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2952', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3464', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1874', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5057', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1876', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000099', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-1000101', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-1881', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-1890', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-2957', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3480', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1895', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-1903', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3651', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-0548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5066', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3493', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3497', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1915', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3661', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3518', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4057', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3667', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1719', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3536', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1938', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5101', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1950', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5108', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5110', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3687', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1957', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-1962', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-1964', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2989', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1972', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4072', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1721', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2584', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4096', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2006-5147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3691', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2990', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2588', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-1979', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2598', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1984', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-3004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3564', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2007-4108', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3008', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2167', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-2705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1930', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3843', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4401', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3838', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3845', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-2191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4409', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-1937', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3847', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4411', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3871', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1836', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1839', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3876', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3606', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1000071', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-2911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3614', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-2915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-2928', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4010', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2512', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1857', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-5045', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10140', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000090', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2514', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5048', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3628', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1710', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3634', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-1711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-2950', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3463', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-4337', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-3789', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3794', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3132', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3792', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2145', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5300', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4357', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4359', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1806', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4366', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000357', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-2701', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-1920', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5316', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-5319', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-4380', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2169', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1927', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-2606', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2608', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-4128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3571', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3575', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3585', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-3587', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000128', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-3598', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3018', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1989', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0554', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3604', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3020', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4158', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2617', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1939', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5345', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5352', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3167', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1847', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1943', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2724', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-5385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-5394', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5398', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2209', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1949', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2730', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1954', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5425', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2733', 8.5, 'AV:N/AC:M/Au:S/C:C/I:P/A:P'),
('CVE-2010-3174', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3930', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2757', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4467', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4470', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5475', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1883', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1887', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2007-4483', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1971', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3196', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2011-2778', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-1898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1901', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-1902', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4496', 10.0, 'AV:A/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2010-3201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000390', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-1973', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3230', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3235', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3242', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2291', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2292', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-1908', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3952', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1912', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2535', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4050', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0550', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4060', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2007-4063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3678', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3682', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3684', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-2971', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5098', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5106', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5109', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3546', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-1955', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5117', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4067', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3547', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-1959', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1887', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1713', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3644', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-1900', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-1905', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-5061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3484', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000109', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5069', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-1926', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-2532', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3520', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3664', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3523', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3530', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4061', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3676', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-1931', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1936', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-1952', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5116', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3685', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3549', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5125', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3554', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1961', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-1965', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2560', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5129', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4079', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5137', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2583', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4083', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4099', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2007-4101', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4102', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3560', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-2994', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3001', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000116', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1818', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3812', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4392', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2172', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3165', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4400', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10216', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3843', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3849', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2187', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2743', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3890', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-1961', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1864', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3900', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2012-1964', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2009-3920', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1969', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5465', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4461', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3931', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4475', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5476', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4476', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1888', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10245', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3896', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3897', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-1968', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1975', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2555', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5138', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2581', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4091', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000114', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2007-4093', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-4097', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2011-2585', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4100', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4103', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-2991', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-2998', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-1980', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3563', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-5156', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0553', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3011', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1724', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5169', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3576', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3584', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3589', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3592', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000131', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-3600', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000138', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1726', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-1748', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-4176', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-1729', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-5186', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-2009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-3616', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-0556', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1768', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1772', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10173', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-2625', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1775', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1733', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1734', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2628', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-20108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2629', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3073', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2013', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1790', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2015', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3215', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3221', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3228', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3237', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5510', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-2784', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5333', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2013-1843', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-5348', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4416', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5359', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1845', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2006-5373', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5381', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0581', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5389', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10222', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-1945', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1946', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2727', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-2729', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5404', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-1857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1859', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-5412', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2731', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-1978', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4111', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5150', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10164', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4112', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5161', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-10166', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2609', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4127', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4129', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-1725', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10168', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1000127', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-3593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1000139', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-4136', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-1988', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-1995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000149', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000156', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2009-3606', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4153', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2006-5176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4166', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5178', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-3609', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3028', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-3032', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3038', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2618', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1728', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2019', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2023', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-2030', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3630', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-5215', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-5219', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3632', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1000208', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0560', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0563', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-1000209', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000214', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2638', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3083', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1743', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000217', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2639', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5240', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-10189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-4225', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2640', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3648', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1808', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3095', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-1758', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4257', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3671', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000238', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10190', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5258', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-3724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2665', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000150', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-1732', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1733', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-1000152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000155', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-3607', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2615', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2616', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3611', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-1000160', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3030', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3037', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-4174', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-1000168', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-3043', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1735', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2012-1740', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-1754', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1755', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2619', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2005', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-20067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-2008', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-3055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3060', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10172', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-4182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1757', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1771', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3868', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000376', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3896', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3179', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5466', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2008-3888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2756', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4463', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4466', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3932', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4472', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1880', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2263', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-5477', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-1885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5479', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000193', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4197', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5207', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-2012', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-3074', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5212', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-2630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1736', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5227', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3633', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3701', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2089', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3711', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-3753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1837', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0569', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2678', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-3763', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1790', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1846', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10171', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-4178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4181', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3063', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2623', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1759', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-4184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1774', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1732', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5200', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1783', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3625', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5204', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-1000196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5211', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-3629', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4200', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4221', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000211', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-1740', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-1744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4232', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000227', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3650', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3094', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2006-5246', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3653', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5250', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4252', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3715', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3662', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3670', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3100', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3101', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1818', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-3692', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2071', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-2073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3723', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2016-10191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-3699', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1764', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3108', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5262', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2666', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2095', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5269', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3707', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3113', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1777', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3738', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2673', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2674', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-3743', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-3747', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2108', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-1784', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-1841', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1786', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-2116', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-3762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000251', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0561', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1738', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2641', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2642', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000223', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3093', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-1000229', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1000230', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3703', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3656', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3098', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3712', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3672', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3104', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1813', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3691', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4260', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000241', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2006-5264', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000244', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-1829', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2093', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1775', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-2266', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1877', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1885', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3736', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4302', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-4305', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-4313', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3749', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3796', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3715', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2111', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3759', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3727', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3761', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-1787', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2009-3729', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3731', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2123', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-1873', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1880', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1887', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4294', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3120', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5284', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3743', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3755', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3762', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3126', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3129', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5280', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1895', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3733', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4303', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-3777', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3782', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4321', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3756', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3758', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3764', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4325', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2140', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3791', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4344', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-3782', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-3784', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0574', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10201', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1909', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3150', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4362', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1912', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3158', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5305', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000358', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1000359', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-1000361', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-4367', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4371', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1917', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4376', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1814', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-1925', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0577', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-3809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4384', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5327', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4396', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3830', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10215', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3832', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-1936', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3133', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3151', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3155', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3793', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3794', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-3159', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3796', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1918', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4374', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-1812', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3798', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1923', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5313', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2702', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2157', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3800', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3804', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3810', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5295', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3789', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3791', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4350', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3137', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3141', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3142', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3147', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3149', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-2146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10205', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-1807', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1808', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-3853', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5335', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-1938', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3161', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4375', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2010-3162', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1813', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2154', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3163', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5320', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2156', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-2165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5323', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10210', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10211', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-3805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3807', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3811', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3814', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1928', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-4386', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3823', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1822', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2009-3829', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2712', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-3834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3837', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10217', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-3844', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2189', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2716', 10.0, 'AV:A/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-3858', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4412', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-3865', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3869', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3872', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5358', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5366', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5372', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5378', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-1846', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-3880', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5384', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1850', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4428', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5391', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1854', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1948', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2214', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2218', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1953', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5424', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3858', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4442', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3874', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-5455', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-5457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1962', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3912', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3916', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2752', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-3887', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-2755', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2199', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3867', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1831', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5339', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-2721', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5371', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1941', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4422', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1851', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-1852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10228', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3854', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-1950', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-0582', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5414', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1955', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3857', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4441', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5437', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5446', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4449', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000366', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5362', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5375', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4421', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1944', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4426', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1947', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3170', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5418', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4438', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5428', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3884', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3865', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3878', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0584', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2746', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-3891', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2749', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3883', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4455', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5464', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4460', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1871', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4462', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-3903', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-2269', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-1000383', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-1893', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2776', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2271', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-2777', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1897', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-3199', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3207', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2285', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3947', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3214', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2286', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-3220', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1907', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3236', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3240', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2289', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3916', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3919', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2293', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4499', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10250', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-2294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3921', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3922', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3923', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3927', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2787', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2764', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4473', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3181', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1884', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2264', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4482', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4489', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3892', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2769', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10247', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1000385', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-5490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2774', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-1000386', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3193', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000388', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-2281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1900', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-2284', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3203', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3908', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5499', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3219', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3234', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3913', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-3898', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3901', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000382', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3954', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1921', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3940', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3252', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5524', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4504', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000395', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-2789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10251', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1000393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3251', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3939', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2788', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1978', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3961', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5535', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1979', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-1931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0590', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2791', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3966', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3257', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5545', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5519', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10254', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-3935', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1923', 4.9, 'AV:A/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2015-2301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3956', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5529', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5530', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4508', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5532', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2790', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4234', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3646', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1804', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5247', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000231', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5253', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4251', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3659', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1756', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1812', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3099', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1816', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3716', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1820', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-1821', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2078', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3728', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3107', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-2653', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4265', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000242', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-2657', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3731', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-2661', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2087', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1977', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2010-3256', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2308', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5533', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5540', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1989', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-3965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000399', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-4522', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-5547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3969', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1993', 4.9, 'AV:L/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-4529', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-1000401', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2008-3988', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3990', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-3995', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4000', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-4005', 6.4, 'AV:N/AC:H/Au:M/C:P/I:P/A:P'),
('CVE-2007-4531', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4011', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2008-4013', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2795', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5543', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5546', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-2314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4521', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2792', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1995', 4.9, 'AV:L/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4004', 4.9, 'AV:L/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4008', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4009', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-4012', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-2319', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3971', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2793', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4041', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-4047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4049', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4532', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3261', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4533', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10266', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-10268', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-3263', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0632', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-4535', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5569', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-5574', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3270', 10.0, 'AV:N/AC:H/Au:M/C:C/I:C/A:C'),
('CVE-2014-0642', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-5577', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3271', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1833', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3756', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1785', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-1842', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2114', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2680', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1843', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-2120', 9.5, 'AV:N/AC:L/Au:S/C:C/I:P/A:C'),
('CVE-2010-3116', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1847', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1849', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1858', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1875', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1882', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1886', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1888', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1894', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4290', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4306', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4308', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4315', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-3752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3759', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3763', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2136', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-4326', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4025', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4030', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4033', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3259', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4056', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3260', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-3970', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1998', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3977', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5563', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1941', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0619', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0630', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0633', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-0638', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2797', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1940', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3975', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2324', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0624', 2.9, 'AV:A/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0634', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-0640', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-5566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-20001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3267', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-3980', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2798', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4557', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2009', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3276', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3790', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5297', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-3135', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3152', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3154', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3827', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4363', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2148', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2694', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-1809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-2698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1811', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2008-3834', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1949', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2325', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-4545', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3982', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2799', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0657', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-2800', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3164', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3837', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3815', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3818', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4391', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3819', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3821', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3826', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1821', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2184', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5328', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3844', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3833', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4404', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-3841', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-2715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0580', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3854', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3860', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-2719', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-3862', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3866', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1829', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-1833', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-3874', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3878', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5338', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5342', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-5346', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-4415', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5357', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5365', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1940', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4417', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-1942', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000369', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-5386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10220', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-4424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10223', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4556', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0650', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1954', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10270', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-3279', 9.5, 'AV:A/AC:M/Au:N/C:C/I:P/A:C'),
('CVE-2006-5591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-3984', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3281', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5593', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-5615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2801', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3282', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-4561', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4563', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4062', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2022', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1960', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2023', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2804', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3172', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-2219', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2735', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2737', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1958', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1861', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3879', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1862', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-1865', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-5468', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3889', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2753', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000425', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2029', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5625', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3999', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2348', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2351', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1978', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0708', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4002', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000432', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-2375', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2377', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2380', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2383', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4580', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1962', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3988', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5609', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2025', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5616', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2805', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3180', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4474', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3933', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4490', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3182', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2268', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2006-5487', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5489', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3940', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-1972', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5493', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3192', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2273', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-3944', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1903', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1904', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3218', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3232', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3241', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5511', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-0588', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0691', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2006-5628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-2032', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2352', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2379', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2385', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2388', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2389', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2390', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4583', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4584', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0709', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000433', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0718', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-2403', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2408', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2414', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0719', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-1000438', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2009-4006', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0724', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-4008', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2448', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2450', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4599', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3322', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-4610', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4612', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4613', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3353', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0731', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3361', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2467', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3372', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-2482', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2485', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4016', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2499', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5658', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-4066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4575', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3951', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2013-1909', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-1911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1974', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3248', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4500', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3924', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-3925', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-3953', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3929', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2296', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4501', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10252', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-3938', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-5521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3955', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0589', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2427', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4592', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2441', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2445', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2449', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2452', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3946', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-3948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3950', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1926', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-4507', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3255', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3960', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3962', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-3963', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-1930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1000398', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-1987', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2015-2312', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-0600', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-3967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3258', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4517', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-4524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2316', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3974', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-3977', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3980', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-3982', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2017-1000402', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-3986', 2.9, 'AV:L/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2008-3992', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-3996', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4006', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4014', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4017', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4024', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5553', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-4028', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4031', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2320', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2813', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-3300', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-2033', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5632', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2410', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2411', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2412', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1982', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2425', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2435', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2446', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5643', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3329', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3349', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3354', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3355', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2463', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3360', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5647', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-3363', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3369', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2468', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0733', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2479', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000453', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3376', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4019', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-2526', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2033', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5229', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-1737', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2039', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2635', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10187', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-3697', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4218', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000213', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4222', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4229', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2643', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1805', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3658', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3709', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3663', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3727', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2501', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2502', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2036', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2523', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4637', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-1994', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2564', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3400', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-1995', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1996', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000466', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0743', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4642', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1997', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000471', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4029', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4030', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-1997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5559', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3969', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3978', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3262', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0622', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-0626', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0629', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-0637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1942', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4537', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2002', 8.5, 'AV:N/AC:M/Au:N/C:C/I:P/A:P'),
('CVE-2006-5578', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-4543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3273', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0643', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-0645', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2014-0646', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4546', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-0647', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4549', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3275', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1953', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2006', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2012-2008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3277', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000407', 4.0, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-2541', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000454', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2557', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3397', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000456', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-4024', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4633', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4635', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3398', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2037', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4025', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3402', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3405', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3407', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4640', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-1030', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2006-5672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0567', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0568', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1830', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3709', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1776', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10198', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-1834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1783', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2007-4275', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0570', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2677', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-4278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2685', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2121', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-1844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3767', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3770', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3771', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1876', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1891', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3119', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3737', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1794', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000472', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2007-4644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4034', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-4647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2570', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0752', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4654', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0755', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5706', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4104', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-0763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3430', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2010-3431', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5721', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-4106', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-2041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4066', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000418', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-2016', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-4562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4564', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0661', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4108', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2044', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4072', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2573', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-4663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4111', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-4664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2046', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2575', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2015-2135', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4323', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5293', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4343', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-3781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3785', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3790', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10202', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000421', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2020', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2332', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5602', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1961', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3989', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5614', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2014-0681', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5617', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5620', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3290', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3292', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-2336', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000424', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-2346', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-3293', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-3996', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2028', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0685', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4578', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000429', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2030', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2809', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-2031', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0694', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2814', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-2378', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0576', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5310', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4666', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2013', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2831', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-4121', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2050', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5736', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-3441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5740', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2833', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-2056', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2061', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2582', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-5750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3302', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-2406', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2415', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0722', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4590', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-2431', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4593', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2440', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2442', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-3802', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3803', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3813', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4381', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1935', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4398', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4405', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-10219', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-3848', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2186', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-2192', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3166', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3851', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3160', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1984', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4009', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000448', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-4071', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2455', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3323', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2010-3326', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3328', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3332', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-3335', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-2462', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3350', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3357', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4616', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-3359', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2009-4012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3362', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1988', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2469', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2471', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5654', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-2819', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2158', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-4385', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1929', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-2709', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1931', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3840', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4399', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4402', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10218', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-3845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4410', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3861', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1835', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-1838', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-1840', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-5332', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5334', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-5337', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5341', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5344', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5351', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5356', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000367', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000368', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2007-4418', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2010-3168', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4434', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5397', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5400', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-2210', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3852', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3855', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4436', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5417', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4674', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2591', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-2592', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2073', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-1000510', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10006', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-3449', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1832', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-3875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5336', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5340', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-5343', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5350', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5355', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5361', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5369', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5374', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-5383', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4419', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4423', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4425', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-4430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10226', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-2206', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2726', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-1855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5405', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-1951', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4437', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2223', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-3859', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3885', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5442', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5447', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5454', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-1960', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2244', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1863', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-4454', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3895', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-3898', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2009-3905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3909', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1867', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2012-1966', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3922', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5461', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-1967', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5657', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2510', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2520', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4077', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-3382', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5661', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3393', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2542', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4078', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0740', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3399', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-2563', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0741', 9.2, 'AV:L/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2007-4639', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1000460', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-2736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5432', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-4444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3862', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2234', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-1957', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2740', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2742', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5449', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5451', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-3877', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3894', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1963', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-1965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3918', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2250', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5469', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2759', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1874', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0585', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2765', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-1970', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2768', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-1000381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-3938', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10246', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-3904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1892', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-3941', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-1895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-3189', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3942', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-3197', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3200', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-3906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2780', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3946', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3217', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5503', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3233', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3238', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000391', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2007-4494', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2267', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-3936', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-5486', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3186', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2773', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10249', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-3191', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2278', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3943', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3909', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-2782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-3872', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2738', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2739', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-2741', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4452', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2747', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-3897', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2750', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3902', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-3904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3915', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5462', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-3924', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3885', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1881', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-3934', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1889', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-10244', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2770', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3895', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1891', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-2771', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3899', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3183', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000392', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4497', 6.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2008-3928', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3930', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2295', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2298', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-5515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10253', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3937', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1975', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10256', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3254', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5526', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1927', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000397', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-5531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1976', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1913', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3926', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-3931', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3932', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3933', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3934', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1914', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3249', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000394', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-4505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-1925', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-5525', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3956', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-3957', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5528', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000396', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-3190', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5492', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-1000387', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3905', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-2282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1899', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5497', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000389', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3945', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-5508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2783', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1933', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0591', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2014-0592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1982', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-1984', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1985', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-1986', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2009-3960', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-3961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2313', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-0602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5541', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-1992', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0603', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4526', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0604', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3973', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-3976', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-3978', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-3983', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-3985', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3989', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-3991', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-5551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-3998', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-4002', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-4007', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0607', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4029', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1939', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2796', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-3959', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3958', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4511', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-1932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-2310', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2009-3959', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-1988', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-2311', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0594', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-1938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-1990', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4514', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5542', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-5544', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-1000400', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-3972', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2008-3975', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-3979', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-3981', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-3984', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-2794', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4651', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2000', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5702', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000479', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-4096', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-4040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4041', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3417', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000482', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000484', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2001', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4101', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3429', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5579', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5581', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1948', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3981', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4547', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4548', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4550', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-2004', 8.5, 'AV:N/AC:M/Au:N/C:C/I:P/A:P'),
('CVE-2008-4060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3983', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000409', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000411', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10271', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-2013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000412', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-3280', 8.5, 'AV:A/AC:M/Au:N/C:C/I:P/A:P'),
('CVE-2012-2014', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4048', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4051', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4057', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3976', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-1999', 9.2, 'AV:N/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2016-1026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0636', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-3979', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3269', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4536', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000406', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-0649', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4065', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3433', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-5729', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2042', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000488', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000490', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000491', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5730', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4073', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2045', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5732', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4076', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3436', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4115', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4118', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4665', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2047', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3250', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10255', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-3941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2304', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-3957', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-3964', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000408', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10272', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-2326', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-4061', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000413', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1000414', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1000415', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-2328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000416', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-2015', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-3985', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2802', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0772', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4125', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2049', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0774', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5737', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4669', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0777', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0779', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2016', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4129', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-2584', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-3443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2063', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10317', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-4671', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000507', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4672', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-4675', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2068', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-2069', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2590', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2072', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-2074', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2076', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-2078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4086', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-2835', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4515', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4523', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-3970', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4530', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-1994', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-3987', 2.9, 'AV:L/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2015-2318', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0605', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-3993', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-3994', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-3997', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-3999', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-4001', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-4003', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4010', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4015', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4016', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-4044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000404', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4050', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0610', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-3965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10267', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-10269', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-3264', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0625', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0628', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3266', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0635', 8.5, 'AV:N/AC:M/Au:S/C:C/I:P/A:P'),
('CVE-2014-0639', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0641', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5565', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5567', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5570', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4538', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4539', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1944', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-1946', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-1947', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2003', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0644', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-4554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0648', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5601', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-1000422', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0666', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2024', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4566', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0679', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1963', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-4570', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2338', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-2339', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-2341', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-2344', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-3995', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1966', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3997', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1000428', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1968', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2006-5626', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4000', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1972', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-1973', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-5599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5600', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2019', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4560', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-2803', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3288', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000423', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2342', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-1965', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4065', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2806', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2082', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-1000600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2084', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4088', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4089', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4138', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3451', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2595', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-2596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4699', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5631', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0710', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-1000437', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2402', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2404', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3304', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-4068', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-2421', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2423', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3306', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3308', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-2434', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2034', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2444', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3311', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3315', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-4600', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4602', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5642', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0729', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1985', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3319', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3325', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3327', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-1986', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3333', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2818', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5589', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000410', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-2085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3452', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2598', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2599', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-3453', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2031', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10011', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10012', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2012-2086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10013', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2007-4706', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10014', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-10015', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10016', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10018', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-5762', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-2839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000417', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1000419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-0660', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-2330', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-5594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-3986', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-4559', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5595', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5598', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4063', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0662', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-4565', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-3987', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-5603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3284', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3286', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4064', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4568', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2334', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5611', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3289', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-3994', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5618', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2026', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3291', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2335', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2337', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4572', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2340', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-5624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1967', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3358', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4617', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-3364', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5652', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2466', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2470', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1989', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2480', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2484', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-2486', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2491', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2493', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4017', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2500', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4620', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3378', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2505', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2522', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-5663', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-1992', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3396', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4631', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4080', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2559', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-3403', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2566', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2015-2567', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2017-1000470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5675', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0749', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4646', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4649', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4577', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0686', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2017-1000430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1971', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-1976', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4067', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-2811', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-5627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4001', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4003', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2397', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2401', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2815', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-2413', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5634', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-1981', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2816', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-5636', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-0720', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-2418', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2422', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4591', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2817', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-0725', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3321', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-1000450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0783', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2008-4147', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2613', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1002026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0784', 8.5, 'AV:N/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2011-2841', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5767', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3473', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-3474', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3475', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-4106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4108', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4111', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4726', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2090', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2843', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2372', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2376', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5633', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2384', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2391', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000434', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1980', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3303', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-3305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-5637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000442', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-2419', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000443', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-2424', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1983', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4069', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4594', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-2443', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2447', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2451', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3312', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-4072', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3316', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-3318', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3320', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0730', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3336', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3340', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3342', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3343', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2035', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3345', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4607', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000451', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-1987', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4615', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-1000452', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5651', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2464', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2477', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2487', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2490', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2492', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2494', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2498', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3374', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1990', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5645', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3330', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3331', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3334', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2456', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3337', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2460', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3346', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3348', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3351', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4011', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5646', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4618', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0732', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3365', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3366', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5653', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2475', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5656', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2481', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2489', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4619', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2503', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2504', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3380', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2532', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3383', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3384', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5659', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3386', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3387', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5664', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3394', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2545', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2555', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2556', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4626', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4022', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000455', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1000457', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-1993', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4634', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000459', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4079', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2560', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4084', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4638', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0742', 9.2, 'AV:L/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2008-4086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4641', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-1000461', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2017-1000463', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000467', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5673', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0747', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4098', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2013-20002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4053', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-3422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0758', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5717', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2572', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2005', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0767', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000495', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4074', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4109', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000499', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-4117', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-3481', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3486', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3487', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3489', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10323', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10326', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2037', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-2621', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2625', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-2627', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-2629', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5773', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2094', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2634', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2637', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4156', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4119', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4124', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2640', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4127', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4164', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2014-0793', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2040', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-4173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5783', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5785', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2102', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2009-4134', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4135', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0802', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-2043', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-4140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3493', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2044', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-4747', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4749', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2645', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2647', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-2047', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3377', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2820', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-2521', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1991', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3381', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4625', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3385', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3389', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2558', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0736', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000458', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3498', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-2049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-5796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3512', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-5799', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3521', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3524', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3530', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3533', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3536', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-2114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4193', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1002150', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2056', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4754', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2649', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-2653', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-4158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5806', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10331', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4159', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2655', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2015-2656', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2657', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-2658', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1002153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-2659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2660', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2007-4759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5807', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4760', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4091', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4028', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2038', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4033', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4645', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-4093', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4035', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4648', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5676', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-1999', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000473', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000475', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000476', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1000477', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1000478', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5677', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4650', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-3415', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1000502', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3440', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2009-4079', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2048', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4126', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-1000504', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4082', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-4083', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2822', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-4085', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4087', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3411', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4652', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2039', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0753', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4655', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4048', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4049', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4050', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4051', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000485', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4055', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3425', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4100', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-0757', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4656', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0759', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5708', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5709', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2062', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-2065', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2834', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2070', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-1000509', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2022', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5752', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0805', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-5810', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5813', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0806', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2122', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-1002201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10024', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10025', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-10026', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-10351', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10029', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10030', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10031', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2006-5817', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-10032', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2007-4766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2063', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2851', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000462', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000465', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3412', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-1998', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10052', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1036', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4167', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-0809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4199', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10362', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2066', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2068', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2015-2668', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3541', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-3547', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-10364', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4169', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4177', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5712', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5713', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5714', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5715', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5716', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2002', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4103', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2571', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-2003', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0764', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5722', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5725', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2040', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5728', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-1000487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000489', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1000492', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3434', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2043', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10007', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-10009', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1001000', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-2027', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4140', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1001002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2594', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-4094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1001003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4039', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-20001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-4097', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2006-5705', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-4043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1000480', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000481', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4099', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-20004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000483', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-3418', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2825', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5826', 6.4, 'AV:N/AC:L/Au:M/C:P/I:P/A:P'),
('CVE-2009-4185', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4188', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4195', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4197', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2009-4200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10369', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5830', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5832', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5834', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5838', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-2128', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2854', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2829', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4119', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-4120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0771', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1000501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0816', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4768', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2130', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2009-4211', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4212', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4769', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2009-4214', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5843', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5844', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5845', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0833', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-5847', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1002005', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1002008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4712', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4713', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2610', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1002020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002022', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2840', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2619', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3464', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3467', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3468', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4109', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2034', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5724', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5727', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-2004', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4659', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2006', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2007', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4107', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-4071', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-5731', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-3435', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2017-1000494', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000496', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1000498', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2828', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2052', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4668', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5738', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2006-5742', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5743', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5746', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-5748', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2055', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4081', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4670', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2583', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10310', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10311', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1000505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-3444', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3445', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2585', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2017-1000506', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2067', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4673', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2020', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4677', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4112', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3480', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5771', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3482', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2035', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4117', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4152', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4740', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2620', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2626', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2633', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2015-2635', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4153', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4158', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4121', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2095', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4742', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10329', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0791', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2097', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2039', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0794', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1002101', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2006-5778', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4166', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4167', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-2098', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2099', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4170', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2041', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-4171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4175', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-4177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4180', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4746', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-5779', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2101', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2006-5786', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4133', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2103', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-2104', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2042', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4136', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5851', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5853', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10053', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-10063', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-10066', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-10371', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-0836', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-0842', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0844', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-5859', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0854', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0857', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0859', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10377', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5866', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-2701', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-0864', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0867', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-4235', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2103', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-10068', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2007-4784', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10072', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2009-4239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4241', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4243', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4110', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-4116', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4077', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2576', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2579', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2581', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2010-3439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-4122', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4667', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2014', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1000503', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-0773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2051', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2054', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0778', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5745', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-5747', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0781', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4132', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3447', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4083', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4676', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4136', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2071', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-2593', 9.2, 'AV:A/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2012-2075', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2009-4137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5790', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2108', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2643', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-2646', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5794', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2111', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3500', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-3502', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-4750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3505', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-3510', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4144', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4148', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3520', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-4155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3527', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2010-3531', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3534', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3537', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3538', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4187', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2052', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5801', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0804', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-2053', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2054', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5805', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2648', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-2650', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4194', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2118', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2080', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2081', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10008', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-3450', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10010', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-1001001', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2083', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4139', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-2837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2077', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-2079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-4085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1000508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2029', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2006-5759', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2597', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2030', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4091', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2600', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-2601', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1001004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-2604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2607', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0884', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-3550', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2141', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-2108', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2013-2109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-4264', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2704', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-2142', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-5876', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0889', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0891', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4269', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0894', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-2706', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4231', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4233', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2014-0905', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0909', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4292', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4295', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-2708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4803', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4815', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4824', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4092', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4145', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10019', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2017-10020', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1002000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2032', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1002004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1002007', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-4098', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-1002010', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2608', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3456', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1002021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4100', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2612', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2615', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2616', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-1002024', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1002025', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10021', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4717', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-3460', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2618', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-3463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2089', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4105', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2007-4718', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-4719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4720', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4722', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10320', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-2842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002006', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-0782', 8.5, 'AV:N/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2007-4707', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1002011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1002012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002015', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5763', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-3454', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1002016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1002018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002019', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2611', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-1002028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1002100', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4101', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-2617', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3466', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4102', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2033', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2008-4195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1034', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-1002157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2661', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5809', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5812', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4162', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2062', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3488', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10325', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-2844', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4120', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4161', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4163', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-4744', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5775', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4129', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-4165', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-2641', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2011-2864', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4303', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2866', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-5894', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2119', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4151', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0787', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3476', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4107', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4725', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10321', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5770', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10322', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4727', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4730', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4113', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4114', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-4115', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4116', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-3484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10324', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4118', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3490', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2091', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10327', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2622', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2624', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2628', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2092', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-2093', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-2632', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4741', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2638', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10028', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2006-5816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10033', 2.5, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10035', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10039', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2014-0808', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10040', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2017-10041', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10045', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-10046', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10047', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10048', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10049', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-2667', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10050', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10051', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2064', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5784', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2106', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2107', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3492', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5791', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-5793', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2013-2045', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2846', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4309', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4310', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4314', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5912', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10397', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-2162', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2165', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-4246', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2125', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4830', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4831', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-4261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4264', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4265', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4326', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4330', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4332', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5922', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4836', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2869', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4170', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4172', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-4175', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0812', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4767', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4180', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4181', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2675', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-4184', 9.2, 'AV:L/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2012-2125', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-4203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5819', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4207', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10365', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3497', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-3506', 4.9, 'AV:L/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2009-4143', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4145', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4150', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3518', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3519', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-4152', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4154', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3523', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3525', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3528', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-4181', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4751', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3539', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2017-1002102', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2008-4188', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4190', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4192', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2055', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1002151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10330', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-2652', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2654', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2116', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2117', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4155', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-4159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2096', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4743', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2639', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4128', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4130', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-2845', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5931', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-5935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10078', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-2715', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2129', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5958', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5963', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5968', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4349', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4351', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3553', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2717', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2872', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10367', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-2677', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-5827', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2126', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4194', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-4199', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4208', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2069', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2680', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4215', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0820', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0821', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4771', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0831', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2855', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5972', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5974', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-2721', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5983', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-4880', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10083', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0915', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2190', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0923', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0925', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4888', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-5986', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5990', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2006-5994', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2194', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-4890', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-2196', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4895', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2202', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-2725', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2206', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-2726', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6010', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2212', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5782', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5789', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4139', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2046', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4748', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2644', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2112', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3496', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-3501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2048', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-5800', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-0803', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-2113', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4151', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-4153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3522', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-3526', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3529', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3532', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3535', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4183', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4191', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2011-2847', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4756', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4758', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4761', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10022', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-2663', 7.8, 'AV:N/AC:L/Au:S/C:C/I:P/A:N'),
('CVE-2006-5808', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2664', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4764', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2850', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2729', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2877', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10056', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10061', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2015-2688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10064', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2079', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10374', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-2086', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0839', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-0840', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0843', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0845', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2014-0846', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0849', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-2694', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-4225', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5858', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5864', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-0853', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0858', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4227', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2089', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2016-10378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2696', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2013-2091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3549', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2100', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0861', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0862', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0865', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2014-0866', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0869', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0872', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0873', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0874', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0875', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-0876', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4236', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0878', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2059', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-1002152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2120', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-4160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2061', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-5811', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4197', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10345', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10349', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-4163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0807', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-10044', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-2065', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-0810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2067', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3544', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-3546', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-4920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4309', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1035', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10350', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-10027', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5815', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10034', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2008-4198', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-10043', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2013-2102', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10069', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-4785', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10070', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10071', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2009-4237', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4240', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0883', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4244', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0888', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2006-5868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4253', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5873', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2861', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2111', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4183', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10366', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5828', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4192', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2129', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0815', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0817', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2006-5841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5842', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2071', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-2684', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-2687', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-0823', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0824', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2134', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2073', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0829', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-0834', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-5852', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2074', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10054', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10057', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10059', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10065', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:H/A:N'),
('CVE-2009-4221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5856', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2081', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2135', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2015-2690', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2085', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0841', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-0848', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-2692', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2009-4224', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4772', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-10375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-5862', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2857', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0904', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-0906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4790', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4802', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5882', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5883', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4813', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2115', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2147', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4299', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10074', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2010-3545', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-0811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4200', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-10363', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-5818', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4174', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-4202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4178', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4179', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4182', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2014-0813', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5820', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5822', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10368', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5825', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4189', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4193', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-4198', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2678', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5829', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10077', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2009-4304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2151', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2154', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5897', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10395', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2867', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2711', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2159', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-5898', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5914', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5915', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2121', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-2124', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4243', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-4245', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4322', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4253', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2016-10399', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4328', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4334', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4278', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0914', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-5925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5938', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4216', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-2682', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3548', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2070', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2007-4770', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0819', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4219', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5846', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-0822', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0825', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0830', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0832', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5855', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10055', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10058', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2017-10060', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2014-0835', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2858', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5947', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5949', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2130', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-2131', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4346', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4840', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4353', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-2183', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2185', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-4354', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-10403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-5971', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4842', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5973', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4850', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4863', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4873', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5980', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5982', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4284', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2008-4285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10081', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-0917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0918', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2015-2724', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4293', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2875', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2080', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2082', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5857', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0850', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2088', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-5860', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5861', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10376', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2006-5865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2090', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4776', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4780', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4228', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2698', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-2859', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-4781', 9.2, 'AV:N/AC:H/Au:S/C:N/I:C/A:C'),
('CVE-2015-2697', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-2099', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-5867', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-4233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4783', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10067', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-2138', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4238', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4242', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4245', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0887', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2013-2105', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-4249', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-2139', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4250', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4254', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4257', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5870', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-5872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4910', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4912', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4304', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4378', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4915', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0931', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-0932', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6025', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0935', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2014-0940', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0942', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0946', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4311', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4782', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0863', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0868', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2014-0871', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4232', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0879', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10073', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-0885', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0886', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2013-2104', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2009-4248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2702', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5869', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-4252', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1038', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-2107', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4265', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5874', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-5875', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2110', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0890', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0892', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4270', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4787', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0896', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0897', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-4225', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5877', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0908', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-5878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2112', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-4293', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-4384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4385', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0960', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-0966', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4389', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4391', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2225', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4941', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-0989', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10088', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2007-4948', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-6042', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4963', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4965', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2006-6048', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2236', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-100002', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4977', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-4329', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100006', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4983', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2174', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2899', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-4344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2178', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2740', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2249', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3558', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2006-5886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4812', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4819', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4822', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2116', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2148', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-4298', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10075', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10076', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2009-4302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5893', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4226', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4232', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-0901', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0907', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0910', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0912', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-4273', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4274', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4294', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2144', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2113', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-2114', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4821', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3551', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2146', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6071', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-100019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10002', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5009', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6077', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4414', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5019', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6086', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-6087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10090', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2006-6091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5022', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2281', 10.0, 'AV:A/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-4447', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4453', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2006-6120', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6123', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-2149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5896', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3552', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2150', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2153', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-2155', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2120', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5905', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-5909', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5913', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-5919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4242', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4255', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4259', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4260', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-4325', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-4832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4327', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4331', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4833', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5924', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-5928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5939', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-5940', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5942', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5950', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10079', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5967', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-2132', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-2174', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2184', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4279', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-2718', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4847', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2720', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4297', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4301', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-5892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4305', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-2117', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4826', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2015-2710', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-5900', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4829', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5916', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-5920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2122', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2123', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-2712', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2164', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-4319', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4321', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4252', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-4254', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-4256', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-5921', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-4258', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-4266', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4324', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4357', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5981', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-4359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10082', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4292', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2874', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4329', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4335', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2127', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2714', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5944', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10080', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-5960', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5965', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2173', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5969', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4841', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2135', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4848', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-4874', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2199', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2143', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4898', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2008-4298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-2205', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2727', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4900', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4902', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-4903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4906', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4909', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4371', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-1041', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2007-4913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6016', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-4916', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2215', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6019', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4923', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4381', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0947', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-4314', 7.8, 'AV:N/AC:L/Au:N/C:C/I:N/A:P'),
('CVE-2006-6026', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4924', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2880', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2139', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-4283', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0920', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0921', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0930', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-4889', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-4366', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2144', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4367', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4368', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4303', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4914', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-4917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0933', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4305', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-6017', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6022', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0963', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-0969', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4940', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2223', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0983', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0987', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3556', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4961', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6044', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2158', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4322', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4396', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4970', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4972', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2239', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-4333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6065', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-6066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4988', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10089', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-2181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1044', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2006-6069', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-10001', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-100012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100016', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2182', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-6070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2742', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2151', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2882', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4935', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2887', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4938', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-0950', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2007-4939', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0959', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-0964', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-2891', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6040', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0979', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-0988', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0993', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2894', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4945', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4955', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4964', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2895', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6045', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4967', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2738', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4342', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4405', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4407', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5004', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4363', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2269', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2908', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-10094', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2277', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2750', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4450', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4389', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2914', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6131', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-6132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6135', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6136', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6139', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4465', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4466', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4392', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-5023', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6146', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-6151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5025', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4991', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4995', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2242', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-100010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2250', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4401', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4408', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-4411', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6159', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2929', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-2932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2764', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2290', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2294', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2301', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-4415', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-4490', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4496', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10101', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2009-4498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-10033', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-2769', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6180', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-10037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4510', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-6184', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2946', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2951', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2953', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2773', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2230', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2774', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6191', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6203', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2320', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-2960', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2961', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2964', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2236', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-6217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6219', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6227', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6228', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6231', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2238', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2781', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10091', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2006-6095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2276', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6107', 2.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4434', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4454', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-4387', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2913', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2200', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-4467', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2009-4470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6145', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4393', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4394', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10097', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5031', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4398', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4407', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-2924', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-2207', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2006-6235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4421', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-4423', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2979', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4528', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-6240', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2242', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2245', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2246', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-10071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10504', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-2250', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2254', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2324', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6245', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2786', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4431', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2327', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2871', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10402', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-4355', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2137', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5975', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-5976', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4849', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4861', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5979', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4281', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5984', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2873', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4886', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10085', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2012-2187', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0922', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-0924', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-4294', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-5987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5989', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2192', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-2193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4894', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2876', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4370', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6020', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4922', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-4310', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-0936', 6.4, 'AV:A/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-0944', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-2731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6035', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4937', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-0951', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2153', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0957', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0958', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-0978', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4390', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0980', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2155', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-0994', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4943', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4954', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0995', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4395', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6047', 6.4, 'AV:N/AC:L/Au:M/C:P/I:P/A:P'),
('CVE-2006-6050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4971', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-100004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4330', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2173', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2175', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2241', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4401', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4352', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4411', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-6080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2189', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5011', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5020', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-100022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2273', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6085', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10092', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4381', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6097', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2009-4428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6102', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100029', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-100033', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4449', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2013-2199', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4388', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2754', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6133', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-6138', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2757', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6153', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10096', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2009-4474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100039', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4397', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10010', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-10015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10022', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-10023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2285', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2762', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2931', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6166', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4413', 9.2, 'AV:L/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2009-4486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2765', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2214', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2217', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-2305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2766', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2767', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10030', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-2937', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3563', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2312', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2223', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2011-2940', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2941', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-2771', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2943', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6183', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2950', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4512', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-10104', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2011-2956', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-4515', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6197', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6205', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-10066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6207', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6211', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2779', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2780', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2168', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-2169', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2170', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-5955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5956', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-5957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5964', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-5966', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2012-2171', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2870', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2175', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2133', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-10400', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-5970', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4843', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-4846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-5978', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4862', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10404', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4356', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2186', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-4879', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-5985', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0919', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-0927', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4887', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2142', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-0929', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4299', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2145', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4525', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4425', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2006-6237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2241', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2243', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2247', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2980', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-2784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-10076', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6246', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10079', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-2259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4439', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6254', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10107', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2008-4448', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4450', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2334', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2268', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10086', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-0945', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0949', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4313', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-4383', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6028', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6032', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2733', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2884', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4318', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2734', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3555', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4382', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0941', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0943', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-0948', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-2879', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0961', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-0967', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0970', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2890', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-2217', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2009-4392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0986', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0992', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4393', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4950', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2230', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4959', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4962', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-0999', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6046', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2160', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2163', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4337', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4982', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4986', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6068', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-4990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2248', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100015', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-4356', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6072', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4358', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2252', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2253', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6076', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5006', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4361', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-4362', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4412', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5018', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-6082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4418', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2275', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2197', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-100028', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2749', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4440', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4891', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2197', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-2200', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4897', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4297', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4363', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6008', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3554', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4901', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-4905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4911', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4369', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-6011', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2213', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4376', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2214', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2009-4559', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2351', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2273', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2356', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-2360', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-10385', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2365', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2367', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-6269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6271', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5033', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10386', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6274', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6277', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-10387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5034', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4588', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2289', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5039', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5042', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5044', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10519', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10390', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-5046', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2374', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6289', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2803', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-4490', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-4491', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2298', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4603', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3571', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2302', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4505', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-4610', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5064', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-10398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4526', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4638', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4642', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6329', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2009-4654', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10110', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-2152', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2881', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4452', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-6118', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6124', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6130', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6142', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-100037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2758', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-100038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4478', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4479', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-4483', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-10007', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4396', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4400', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-10016', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4403', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6158', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2287', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-4412', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4484', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4487', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4488', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2213', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-4491', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-10031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2768', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3564', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-6176', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4502', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2949', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3565', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4308', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-2149', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4931', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4316', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2150', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-4932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2883', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4934', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-4936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0952', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-0954', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2889', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4387', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4319', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-0965', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0968', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-0985', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4946', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4951', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4960', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6043', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-100001', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-4969', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-0991', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10087', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-2736', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4321', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4325', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-4974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4976', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-4332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2739', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4667', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5085', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4680', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4686', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6340', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2393', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5098', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1208', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2310', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5107', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2316', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-10112', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2006-6350', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4537', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5124', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5129', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6375', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4716', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5138', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5143', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5146', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6382', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-4726', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4730', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3575', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-1224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3582', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3592', 7.8, 'AV:N/AC:L/Au:N/C:N/I:C/A:P'),
('CVE-2010-3593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3596', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-3600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2322', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-2324', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2818', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2331', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4743', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4750', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3609', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4544', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3613', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-3021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10065', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2957', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2233', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2006-6196', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10067', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-2963', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3566', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6220', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2248', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2896', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-4338', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-2168', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2176', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-100007', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2246', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4355', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5005', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4366', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-4370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2271', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2746', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-6084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2192', 4.9, 'AV:A/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2016-1045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4420', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10093', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-4382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4425', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6101', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-6104', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-100026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100027', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2279', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-4438', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4444', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2282', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4445', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-4448', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6121', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2755', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4987', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4343', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3557', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2903', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2251', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4406', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5007', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6079', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5017', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2270', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-4374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2193', 6.4, 'AV:A/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-6088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4421', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4426', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6105', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-6109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10003', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4442', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2753', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2912', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4451', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6119', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2916', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5024', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10098', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2007-5029', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5030', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2759', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4476', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4480', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4482', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10005', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-10009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10014', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2760', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-10106', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-2785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4531', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10506', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-10074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10507', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-4532', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-10077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-2329', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4434', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4436', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4437', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2015-2789', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6252', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2264', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2790', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2989', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-0981', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-0984', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-0990', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4944', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-4947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2737', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4324', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-4966', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-4968', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-4981', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4339', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-4985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-100008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4403', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-4992', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-4993', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-4996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-2244', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-100009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-100013', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2902', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-100020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5003', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4408', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5013', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4417', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4460', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4461', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6141', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2915', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6148', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2202', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5026', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4472', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2920', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2927', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2288', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2763', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2291', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2293', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2296', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2298', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2299', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2303', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6169', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4494', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4495', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2219', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-3562', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2991', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4465', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4471', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-10382', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-2794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4557', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2009-4562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2272', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6262', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-10514', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-2355', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-6272', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4480', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2997', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10517', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2006-6281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5047', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6290', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-10392', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2376', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6389', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1244', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2839', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6395', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4787', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4560', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-4563', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3638', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2437', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3026', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4379', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4429', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-6103', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-6110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6113', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2748', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4435', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4439', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3560', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2009-4456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4384', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4385', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6143', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4469', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6144', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2203', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10006', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2284', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-10008', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4399', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10099', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-6155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10100', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-10020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4409', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6163', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2304', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4493', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10034', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-2938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2222', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-10035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4499', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5056', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6291', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2012-2379', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4608', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6300', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5063', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6306', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-6307', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4530', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4664', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-5084', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6336', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6339', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1201', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10529', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2310', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-6175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4500', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2770', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6186', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2945', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4511', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-2955', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-10017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4402', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4405', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4406', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2922', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-10024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6160', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2286', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2208', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6409', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-125009', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-125018', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-125024', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-6416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6423', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-125027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6424', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-4807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2363', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4578', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4811', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4822', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4595', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4826', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6442', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5227', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4615', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2493', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10102', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-2318', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2775', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-4517', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6198', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-2958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2776', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4519', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2959', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6222', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6225', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-4522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2975', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4526', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4426', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6241', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-1050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-2981', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2982', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10075', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6248', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-10078', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-10378', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2266', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-4535', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-10379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4455', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2270', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-2336', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4704', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5108', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1219', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-6353', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6363', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4539', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4717', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5141', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6380', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5148', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4733', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4740', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1223', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3585', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-4741', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3589', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2010-3597', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2811', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2815', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-2817', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2820', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2337', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1234', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1236', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4756', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4757', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3607', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4543', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-4761', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2339', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2822', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10538', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2007-5164', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5169', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2415', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4771', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2345', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2347', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3627', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4778', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3633', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4548', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2417', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2421', 2.9, 'AV:A/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-2423', 2.9, 'AV:A/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-2825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4551', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-2939', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2009-4505', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2225', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-2315', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-2316', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6182', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4509', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-2772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2947', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1049', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10103', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-10064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-6189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2297', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-2300', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2011-2934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-4489', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-10029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2307', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-10032', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2308', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2309', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2228', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6185', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2948', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2952', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2954', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4513', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4514', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-1051', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4470', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4476', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4553', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2009-4567', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-2996', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2352', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2359', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2364', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10516', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6278', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4585', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2370', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2287', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5041', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6286', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2293', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4487', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2532', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2557', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2860', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-2376', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4876', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-2564', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4639', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4880', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2379', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-4654', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4881', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10130', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2009-4887', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2576', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4659', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5254', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2592', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4666', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4901', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5261', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-4905', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4681', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2383', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5264', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10137', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2007-5265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10566', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6401', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2358', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4795', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5191', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4800', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-125012', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-125021', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-6421', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5201', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4809', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4813', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4582', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2364', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2365', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2366', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2367', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2459', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3641', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6444', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5216', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5218', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2371', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3642', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2486', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4616', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-2490', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4841', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4844', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2496', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2499', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-2513', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2515', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6457', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4620', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2519', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5237', 9.2, 'AV:N/AC:H/Au:N/C:C/I:C/A:N'),
('CVE-2007-5240', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4852', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2560', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2562', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-4864', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4868', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4873', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3645', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5245', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4878', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-125048', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2008-4647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4652', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4884', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2962', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4520', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6236', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-2977', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2321', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6238', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6242', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2244', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4529', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4530', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2255', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-10105', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-2256', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-3567', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2983', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6247', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2984', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2258', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-2985', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2986', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2778', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4420', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4521', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6229', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10070', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-2978', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4527', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10503', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2008-4427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2783', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2012-2325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6249', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-10375', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-10509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6250', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-2788', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4533', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-10377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-2987', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2988', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3568', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10395', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3002', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4504', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-2380', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6303', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10522', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-4520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4625', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4630', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4637', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4641', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4656', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3006', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5080', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6334', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3008', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4677', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4681', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3572', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5092', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2392', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2807', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1210', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-5103', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2399', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5113', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6346', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6351', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10530', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6356', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10531', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6359', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6366', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4712', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6373', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3019', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-125052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-125053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4674', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5260', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3649', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4907', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2604', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-4685', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10135', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-4688', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2611', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3039', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6255', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2333', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2990', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2791', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-4454', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6257', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4472', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4473', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4474', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4475', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4477', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-2992', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4540', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4549', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10511', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4555', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4478', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3569', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6265', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4479', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2354', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-2363', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2366', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2009-4569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4572', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6276', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4581', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4584', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4482', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-2278', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5040', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6256', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4452', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2012-2335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2337', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2341', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6266', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-2995', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2358', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2012-2361', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-6268', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2275', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-10569', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10158', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10162', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2012-2629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-5269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10171', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2006-6474', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2390', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-125071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4926', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4932', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2635', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4943', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6483', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-6487', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-2638', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5274', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-4702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5293', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-125078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10182', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10575', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2643', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10192', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-6498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5318', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2645', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-4957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2647', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-4961', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3044', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2384', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10161', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10166', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2010-3658', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10175', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-2633', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2895', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-10570', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6482', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6490', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2900', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4711', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2902', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10185', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2008-4715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4720', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5323', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-125085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-125087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2653', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10195', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2009-4974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4977', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-125093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3046', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5036', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10518', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2292', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-5045', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2296', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-4594', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1052', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5060', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2378', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4512', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2304', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-4527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4627', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4632', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2009-4634', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4643', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4658', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5082', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4665', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4685', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4694', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4698', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2806', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3011', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1202', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4535', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3574', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2329', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1226', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2333', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10535', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10114', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2009-4754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3605', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5157', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5163', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5168', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3619', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4769', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4776', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3634', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4547', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2418', 10.0, 'AV:A/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-2422', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2425', 2.9, 'AV:A/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-6387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2827', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-6391', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5172', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2838', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2841', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2845', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2353', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6288', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4497', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4601', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4602', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4605', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4606', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10394', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4500', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5057', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4502', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2301', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4503', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4609', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6299', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-4508', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-4511', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4617', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4620', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2381', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6310', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4631', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10524', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2006-6330', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-4650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4652', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2009-4657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4532', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5081', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5083', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2306', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-4672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10526', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2009-4682', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10401', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2009-4695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2387', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2389', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10528', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3014', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5100', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1211', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4706', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5117', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5119', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2401', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6355', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1222', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-2403', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6364', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5130', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-125092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5337', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10581', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3047', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2406', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10201', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-2926', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10589', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10206', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-10207', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2006-6504', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5348', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6505', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10215', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10220', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-10223', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2012-2676', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-125106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-5011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5371', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10231', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-3668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-1253', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-10235', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:L/A:H'),
('CVE-2012-2679', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2933', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6518', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10237', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2016-10593', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5391', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2683', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5020', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-2685', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5398', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10241', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2007-5407', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10242', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2009-4991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10584', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4998', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2009-5000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2407', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P');
INSERT INTO `tpandora_cve` VALUES
('CVE-2017-10199', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2009-5005', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-125102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-2927', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10208', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-5344', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5347', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3667', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-10214', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-10219', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10224', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2009-5010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5364', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5369', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2677', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6512', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2011-3054', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2851', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5186', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2436', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4564', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5194', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-125002', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-6408', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-125004', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-125005', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-125007', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-10542', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-4571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-125016', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-2447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-125025', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-5197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10544', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-5207', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-4804', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5208', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-4580', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4581', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-4585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10116', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-10548', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4602', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-4606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2374', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-5229', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-4613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4847', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3573', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-2311', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2315', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1215', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5114', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6347', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-6348', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5121', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6352', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6357', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6361', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3018', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2808', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5147', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4737', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3583', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3590', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2010-3602', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2821', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4744', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1235', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-4749', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2410', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4759', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2411', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4767', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5165', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5167', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2414', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-1242', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-3624', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2349', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4775', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4777', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3631', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4546', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-1243', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2826', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-2828', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2427', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1245', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4555', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-2417', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5029', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2947', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2008-4726', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5436', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-6541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4732', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10244', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-10246', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-10248', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2712', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-10252', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5457', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-5035', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2725', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-3679', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-2733', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10263', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2006-6565', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-4738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10604', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4754', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4756', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6580', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-5464', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-4768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10607', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6584', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3691', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-4787', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-6597', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5382', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6523', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5388', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10597', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5400', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-5022', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5406', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5410', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5413', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2009-5024', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-5026', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2692', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2007-5425', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-6534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4725', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4729', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5439', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5442', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-2950', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-5451', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2705', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-2708', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-2951', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-2713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6558', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10258', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2719', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-2721', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2730', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10602', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5461', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-6567', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3685', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4762', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-2330', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-6251', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4440', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2331', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6253', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4447', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4449', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4451', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4453', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4456', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-10380', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6383', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6384', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-5153', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4739', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10533', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10534', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-3594', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-3599', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2015-2812', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2323', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-2814', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-2326', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2819', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2332', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2335', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4747', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1233', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3606', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3616', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4764', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2416', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10539', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2344', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3022', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4850', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2548', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10121', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4634', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4865', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2377', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2016-10554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10555', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-125047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2567', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-4645', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-2378', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-4653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3647', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4893', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2864', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5250', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5252', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3648', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2869', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2873', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-2580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2585', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4662', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2598', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4668', 8.5, 'AV:N/AC:L/Au:N/C:C/I:P/A:P'),
('CVE-2008-4673', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5257', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10561', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-5262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4678', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-4683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4687', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-10564', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3653', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10151', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-10155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2387', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2012-2627', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2017-10156', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2013-2388', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10164', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-2630', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3656', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10170', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2012-2631', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4693', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5273', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-2389', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4925', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4697', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4699', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-5282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4457', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2340', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-6258', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2796', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4556', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4558', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4561', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4564', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10513', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6267', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-2357', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6270', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5032', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-3570', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-10108', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2006-6279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6284', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-2277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4587', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5043', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-10389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4486', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4488', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10391', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4595', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-2299', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-10109', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2008-4501', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-2300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2377', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6295', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4509', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3003', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6308', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10523', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-4636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4653', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10525', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4663', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5086', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4558', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4562', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2356', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2435', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-1248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6405', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1250', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-125006', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2009-4796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4572', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-125011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-125013', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-2449', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-125022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-6413', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6422', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4577', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-2455', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-5210', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-4810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4812', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10117', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-4591', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4598', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4601', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5215', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4833', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-5221', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6449', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-6451', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5226', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6453', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5236', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2012-2500', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2012-2514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4846', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6458', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6463', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-4630', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10550', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2546', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10119', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10123', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-4633', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-4635', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4877', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5246', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4640', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-4641', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6386', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2352', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2011-3023', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5185', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4788', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-125077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2901', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5300', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2391', 4.9, 'AV:L/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2017-10184', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-4951', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4712', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4952', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10578', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10579', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2009-4965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10193', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-2655', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-1058', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2658', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10582', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4984', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4988', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2401', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2403', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-125099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2668', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-3050', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3646', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4646', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4886', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10134', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2380', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2596', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4664', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-125056', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-4679', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3038', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4794', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6406', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6407', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-125010', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-2442', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-125014', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-125017', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-2450', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-6414', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2451', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-5198', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10546', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3027', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4676', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4678', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4690', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2307', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-4699', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10402', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2007-5091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2394', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3013', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-2993', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4543', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4545', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10510', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6259', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-10383', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-10384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6263', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2274', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2353', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-2362', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-10515', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-2998', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2276', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6282', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-10388', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-4589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4483', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4484', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5051', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4489', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4493', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4593', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10393', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6297', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2303', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5066', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4528', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6311', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4629', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3005', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4633', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4639', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6318', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6331', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2009-4659', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-10400', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4668', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4697', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6335', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6343', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3694', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6602', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5487', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1061', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4792', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-2422', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5496', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2746', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2006-6613', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6621', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3704', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2753', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5509', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5511', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5515', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5531', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10617', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2963', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10278', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2006-6642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3069', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10272', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2006-6615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6618', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3067', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4587', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4588', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10549', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6446', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4834', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3032', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2400', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10111', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2007-5120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3016', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10150', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2008-4692', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-125067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10168', 4.2, 'CVSS:3.0/AV:P/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2017-10172', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6476', 4.9, 'AV:L/AC:H/Au:S/C:P/I:N/A:P'),
('CVE-2009-4936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4698', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-5280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2640', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6493', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-5290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3042', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4839', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4845', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-125037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6456', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6465', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1055', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6466', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5238', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-4632', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3644', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4866', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3035', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2770', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-1062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5535', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6651', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6658', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3739', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-5539', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-3751', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3758', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2775', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2776', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5544', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-5560', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10628', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2429', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-5088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2782', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5092', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2996', 7.8, 'AV:N/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2006-6679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5119', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6702', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3078', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6372', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5135', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2318', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-5140', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5149', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3020', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5102', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4705', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5109', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5112', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1053', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2402', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2007-5126', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6358', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10532', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6371', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5133', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2012-2404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4722', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5139', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4725', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-5151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4732', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4736', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2809', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3579', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-3584', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3588', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-4542', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3598', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2015-2810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3603', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2813', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2325', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2328', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5154', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2334', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4745', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10536', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4758', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3614', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-4763', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4766', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5166', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5170', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4768', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3623', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4773', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5306', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10576', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6497', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5316', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5320', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2007-5332', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2646', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4962', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4963', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2009-4967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6500', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5335', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-10197', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2394', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-2657', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2661', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2399', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-125095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3048', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6502', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-4987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10583', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5599', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6731', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6735', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5135', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6743', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5136', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-10654', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6753', 4.9, 'AV:A/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2011-3085', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5342', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-2673', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-2675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6508', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-6509', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10226', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2007-5362', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10230', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-2414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2678', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2006-6515', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5392', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4760', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3615', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5160', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3621', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2343', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4772', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2346', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2348', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2350', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3630', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3632', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6388', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2426', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-5174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2831', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4781', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2842', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2844', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6393', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5183', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3636', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2355', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3637', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6396', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6398', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6400', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2357', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2438', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4793', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-2359', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6403', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-125015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-2446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2360', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3640', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10547', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4579', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3031', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10126', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3709', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6638', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-5060', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-3711', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3713', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-5064', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2426', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3734', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3071', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3803', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-5158', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10663', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6767', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2016-10665', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3092', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10198', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-10202', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2011-3051', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5402', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10598', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5409', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-2691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5417', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10209', 2.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2014-125104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5355', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2412', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-125105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10222', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2007-5366', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5373', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5377', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-5012', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-5013', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-10233', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:H'),
('CVE-2015-2931', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10591', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2680', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6522', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2935', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5394', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10596', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2686', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5399', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3759', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3763', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5555', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-5078', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2007-5563', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5082', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2009-5089', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-5095', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1298', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1063', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4798', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10634', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6685', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5591', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6687', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1309', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5122', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3011', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2797', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5600', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3781', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2805', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-2806', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6737', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-5603', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3800', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6740', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6750', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6755', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6757', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-2813', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-6761', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-6762', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5613', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6764', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1329', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2437', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10669', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6786', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-6788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3097', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3626', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3629', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4545', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-4549', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-5171', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2009-4779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5175', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4896', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2577', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-125055', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-4900', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2597', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-10560', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4902', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4682', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10563', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3650', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3652', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10143', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10147', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-10152', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10159', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3654', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5445', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5449', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2704', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10249', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10251', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5458', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10259', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-3677', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3678', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-2731', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-3680', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5460', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2017-10264', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2006-6569', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-4739', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4747', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6574', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2738', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-4770', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10608', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5466', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4786', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5470', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5042', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2006-6599', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5476', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2743', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3697', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10269', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2007-5488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5491', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-10611', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-5051', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6620', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6627', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1342', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10674', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6810', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3816', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5623', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3063', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6822', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-10331', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-10335', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3076', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6827', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5628', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4828', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0086', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-0093', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0097', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3108', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6528', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5023', 6.9, 'AV:L/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2006-6530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2944', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2946', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4727', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3673', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-6540', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6544', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6548', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-5448', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10243', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2012-2703', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-10601', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10256', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2717', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2723', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-2729', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3681', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-10262', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2419', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2952', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2735', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-4749', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3686', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10605', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6579', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3689', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4773', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4776', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6591', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4789', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5481', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10271', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-5489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5492', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2012-2749', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6623', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10666', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6772', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6777', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6781', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2820', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5223', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5224', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6452', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4610', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5231', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-4617', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4840', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2498', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2010-3643', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2516', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6461', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-4623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4626', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2523', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2528', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5239', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2017-10118', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-2559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2859', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-10552', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-2561', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4853', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4859', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4863', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2861', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4638', 6.9, 'AV:L/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2007-5244', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10556', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10557', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4651', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10129', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2009-4888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2381', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-5251', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-125069', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-5272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2634', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-6475', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2009-4928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4937', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6477', 4.9, 'AV:L/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2006-6479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6480', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2898', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6489', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5278', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-5281', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5289', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-2641', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3661', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10183', 3.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2008-4714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5304', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5308', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5310', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3043', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6794', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10318', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2007-5618', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10672', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5052', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2957', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3706', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2015-2958', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-10274', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2006-6635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6639', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2764', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2652', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10580', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2398', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-125096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-125097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2402', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4994', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4997', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5001', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-125100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2410', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-10203', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-10204', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2007-5341', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10216', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10225', 6.0, 'CVSS:3.0/AV:P/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2007-5375', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-10228', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-1252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6514', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2009-5015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10592', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5389', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2936', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-3057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4796', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2759', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5056', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2006-6636', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10619', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-5062', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2007-5532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2768', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6644', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2966', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-5533', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-6648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3733', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5536', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-2772', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2427', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6660', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10623', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2975', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2978', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-2980', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2982', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5090', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3768', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6676', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6677', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2015-2997', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3077', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4790', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-1249', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3639', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4799', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-125020', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-6415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4815', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2009-4816', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4817', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4818', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4584', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4819', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4820', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4592', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2368', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4825', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4827', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4829', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2009-4832', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5219', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-4835', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2373', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-4872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6860', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3735', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2010-3738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3740', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-3072', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5542', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-10399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4635', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6328', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2006-6332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4651', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4660', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2385', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-4661', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-3007', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10527', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-4692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4700', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6338', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-5088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6817', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3104', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2512', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6460', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2524', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2856', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-2543', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2550', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10120', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-3034', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6663', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5546', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5554', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2016-10627', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2778', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5564', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2006-6666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5086', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5577', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2994', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-10285', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2006-6678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10632', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1302', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-5113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3772', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6686', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6695', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4801', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5123', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-5124', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3012', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2800', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3780', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-2803', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6745', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3801', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5138', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-4894', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-4907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4910', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10696', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6893', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10698', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3834', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3837', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-3147', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2006-6908', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5673', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3151', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-10347', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-1363', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6929', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5700', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2007-5706', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3860', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6952', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4957', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5403', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-2688', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2690', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6531', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5030', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5431', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-5433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6539', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2949', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5447', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-1268', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5450', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1269', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2707', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-6559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6563', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-2720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-2724', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-2728', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10261', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-10603', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6571', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2736', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2010-3682', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-4755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4759', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4763', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4769', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4671', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5259', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4677', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10565', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2612', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4690', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10567', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4691', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2626', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-10141', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2017-10145', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-10149', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10160', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-10165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-3655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3659', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-125068', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-2894', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2011-3041', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0094', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-6833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6837', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6845', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6848', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6852', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2836', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-6856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5647', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2837', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6863', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0101', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2007-5655', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2795', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1311', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3775', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2432', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2799', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6725', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2802', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5131', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3788', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3790', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10652', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6749', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2812', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2006-6759', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1325', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2815', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5147', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2011-3086', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5101', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1213', 7.8, 'AV:L/AC:L/Au:N/C:N/I:P/A:C'),
('CVE-2007-5111', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2313', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2017-10113', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2007-5116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2317', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-3017', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5243', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10558', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10559', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10128', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10132', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2009-4890', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2382', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-2578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4897', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5253', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4898', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2591', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4663', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4672', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2603', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-4903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4904', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4906', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4909', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4680', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4686', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-4689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2878', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-5266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10140', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10144', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10154', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-2385', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-10157', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10163', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-10169', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10173', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2008-4694', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1057', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4944', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10571', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3062', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10296', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-2818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2449', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-3187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6961', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3085', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-6988', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-6993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4995', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4998', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5001', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5298', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-10176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10179', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2007-5305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5309', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5330', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-125083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5333', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-125086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2649', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4972', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2660', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-2395', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-5338', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4990', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2400', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3049', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4908', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-6884', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2445', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-2849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-2637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4946', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6481', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6485', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4700', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5283', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10573', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6496', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-5294', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10574', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10177', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-10180', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10186', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-5301', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10187', 2.7, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2017-10189', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10577', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5314', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5325', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5326', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5328', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5331', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2393', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2009-4956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4960', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4964', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5334', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-125089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-125091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2654', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10196', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2009-4973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4978', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-4979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2397', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-125094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6501', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4981', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4986', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2664', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5002', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-6503', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10200', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2012-2670', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2672', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5008', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-10211', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2413', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2017-10217', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-10221', 3.7, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2006-6511', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5363', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5372', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3053', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10304', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2817', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4713', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5137', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2406', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4738', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2319', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3581', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-3587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3591', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3595', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-3601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2327', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2330', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5155', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4746', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5158', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-10537', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4765', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2342', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5159', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3620', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3622', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2823', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3625', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3628', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3635', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2419', 2.9, 'AV:A/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2012-2420', 2.9, 'AV:A/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-2424', 2.9, 'AV:A/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-5173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2840', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4553', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5178', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-2741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4791', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5484', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6604', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5495', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4794', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6622', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6626', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10616', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3707', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-5057', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2424', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6646', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2967', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10620', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2971', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2016-10622', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3752', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5543', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3765', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5617', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3811', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10313', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-4817', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6799', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2825', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5786', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3087', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0198', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5012', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0207', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-0210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-3882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5013', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1386', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5014', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1388', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2454', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-7045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7055', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3666', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-10588', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10205', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2009-5006', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6506', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6510', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-10218', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-5358', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10229', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-1059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3055', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3855', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6939', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4919', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2008-4924', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4928', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5689', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6943', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5710', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-4938', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4942', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4944', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6954', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-4947', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4949', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4950', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5717', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5721', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4967', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5728', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4974', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4979', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4988', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5742', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2007-5746', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6774', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10667', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6778', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3038', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6517', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5387', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2681', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-10238', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2009-5018', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5396', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10240', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2012-2687', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-5404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-5405', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5412', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10599', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5415', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5416', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6532', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5429', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4722', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4728', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5437', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-5441', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2696', 2.9, 'AV:A/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-6552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6554', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10253', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6561', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2716', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3061', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-10540', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-4569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5193', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-125003', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2006-6410', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-125008', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-125019', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-125023', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-10543', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-2361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6420', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2362', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-4808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6425', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4586', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4589', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6426', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4828', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4831', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-6445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5217', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5228', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-4612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5232', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-5234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2511', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6464', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4624', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4625', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4628', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2521', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2522', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4849', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2375', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2539', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4851', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4631', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4867', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-4874', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-4637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-125046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2565', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-4643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2862', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-4648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10125', 6.0, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2007-5248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-4882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10131', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2017-10133', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2008-4656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1056', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10358', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2006-7080', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-7081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3204', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-3921', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10732', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10735', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-5559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-2977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2779', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2781', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-5091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2990', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-5576', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5580', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5099', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2995', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2787', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2790', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5115', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5118', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10286', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-5595', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-6704', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1312', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4808', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3013', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-3778', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4812', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6741', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-6747', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4813', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10658', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10595', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-5019', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-2937', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-5397', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3058', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6808', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3047', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3051', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2829', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1346', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5627', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4825', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4830', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4841', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5639', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-6834', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6841', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3819', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4865', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4867', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5646', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3111', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0110', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-4879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2845', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2018-0112', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-0113', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3123', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3125', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2846', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10695', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4913', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6894', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6898', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-3833', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5663', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3846', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6909', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5666', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-6913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5676', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4915', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3154', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-3156', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3162', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3166', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2853', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1337', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4661', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2602', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10562', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4676', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-2606', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-2614', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10568', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10142', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10146', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-10148', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2017-10153', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2013-2386', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2014-125066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-5268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3657', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10167', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10174', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2007-5271', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4695', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2896', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-3660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4931', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4934', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-125072', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4942', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2897', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10572', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5279', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2899', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4701', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4704', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4707', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5291', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5292', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5299', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10178', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10181', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2012-2642', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2903', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10188', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10190', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-10191', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2008-4719', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5321', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5327', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5329', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-4954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2392', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-125084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-4959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2913', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-4966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-125088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-125090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3045', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4969', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5729', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5735', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4982', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4987', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3868', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-6965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3870', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6989', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-5753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6995', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-6997', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6999', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5000', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5005', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3086', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5775', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4735', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2006-6566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4737', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4740', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-4742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4748', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-3683', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10606', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4767', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-2953', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4771', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6585', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-6592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4780', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5469', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4788', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6596', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5473', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5044', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5426', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6536', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2693', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-5430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5434', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5032', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-5446', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-6542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5453', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-5034', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-2702', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10245', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10247', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2710', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-10250', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-2714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1270', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6568', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4741', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4746', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6577', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6589', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10609', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4779', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10745', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2007-5824', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2018-0270', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0271', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7139', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2012-2918', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3983', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5839', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5842', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7153', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10758', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7156', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5898', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-5067', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5078', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3999', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7178', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-4007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-7180', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7182', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7183', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2928', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-2468', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5923', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7197', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-10392', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2008-5104', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2936', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5108', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10425', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-5117', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-3243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7216', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-7218', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-2950', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3103', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6968', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-6972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5751', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6976', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6990', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2016-10711', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6994', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-4993', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5007', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7001', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2006-7004', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5760', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7007', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-7011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2865', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2440', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3102', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2956', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2959', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-5154', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5947', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5171', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5953', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3104', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5971', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4046', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5220', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2473', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2009-5043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4790', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2742', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3065', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10299', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-10303', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2006-6770', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2438', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6771', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6779', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1334', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4816', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1336', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3040', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10310', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1338', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0023', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-6791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10312', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2015-3041', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3812', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3042', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6616', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-6617', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-6624', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5502', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-5507', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2007-5512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5530', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3068', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2918', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4982', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-4983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-4989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-4993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2405', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-125098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2009-4996', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10585', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2667', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-2924', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10586', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-125101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2408', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2409', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2411', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10587', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2493', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5228', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-3003', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-4069', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-2498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3004', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3107', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5238', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-5988', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5989', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10778', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6000', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10729', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10268', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3066', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10677', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5626', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6828', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4863', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6839', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1382', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0221', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3886', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-7021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5798', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2453', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-2871', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6866', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2016-10688', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4878', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-4880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6871', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2844', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7050', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1409', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-2878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1424', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-3913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0231', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2010-3916', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7078', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2456', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3919', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-3923', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7094', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-3925', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2006-7098', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-2892', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-5795', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2010-3884', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1385', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3893', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7027', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5015', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-3899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3900', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-2874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4795', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5528', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5055', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-2760', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6637', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5059', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2015-2964', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3716', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-3070', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3142', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3080', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5664', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3149', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5667', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3170', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-3715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10280', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-6645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5534', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2009-5073', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5537', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-2773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3743', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5075', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10625', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10626', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2777', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5079', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-2988', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2009-5096', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2786', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10630', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5585', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2788', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5110', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6682', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2431', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2792', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3773', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3001', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3010', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1310', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10641', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6715', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-3079', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3052', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10232', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2006-6513', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2007-5378', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-2826', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10735', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10747', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10752', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10758', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1501', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-5262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4089', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5267', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6030', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5276', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4090', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10791', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2010-4093', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0032', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5279', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3021', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5281', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6045', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6047', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6048', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3031', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5304', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6055', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6060', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6082', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3117', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2577', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1515', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-3049', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3058', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-6820', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-6823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10336', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-10341', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-10344', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2011-3105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5030', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5031', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7125', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7127', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10234', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-5379', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2415', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5016', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6520', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-2934', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3670', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2007-5393', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5395', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10239', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2006-6526', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5401', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3671', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-2942', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-3672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2418', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2694', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-4730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5438', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5444', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3676', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5452', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3060', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2910', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3097', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1474', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1476', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-7151', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-5052', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5900', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5062', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3229', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7173', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6928', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6933', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-6936', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3174', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3083', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-4930', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-10348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2007-5690', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5709', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4935', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4937', 4.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2006-6944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4940', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4941', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5712', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-3862', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-6959', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4955', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-3863', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3864', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-4964', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5723', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4973', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4977', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4984', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3867', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-6963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2858', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3910', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0230', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2006-7065', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2734', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6573', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-10267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-4745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4760', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2737', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4764', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4775', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-5465', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3690', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6587', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5467', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3692', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-2420', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6598', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5478', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10610', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2748', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6614', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6619', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10613', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-2752', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5510', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5009', 6.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2007-5767', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5768', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5774', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10717', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2868', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4020', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2008-5100', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10389', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2017-10397', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10403', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2006-7202', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-5107', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-10415', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10424', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5123', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5127', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4032', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3250', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5148', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5152', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7225', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-5526', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6632', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6640', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5058', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-3712', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3714', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2013-2425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6647', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5065', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6649', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3736', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3737', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2006-6650', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5538', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3749', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3750', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6662', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-2973', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5561', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6664', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3767', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-2981', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2009-5081', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3074', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2435', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5151', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5615', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3090', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2009-5072', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6659', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3741', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2010-3748', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3754', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3757', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3762', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-2974', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-10282', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-2976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10629', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2983', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5080', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-2986', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5085', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-2987', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-2783', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6668', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5573', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2785', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1301', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2789', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6683', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-5592', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5593', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5117', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6700', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-4802', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6714', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3776', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3026', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5602', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3793', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2434', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3030', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-6742', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6754', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2009-5141', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-5142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3088', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4868', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4869', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6859', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4873', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0086', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4173', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2016-10789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3122', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2623', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10849', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6161', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3283', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3124', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2458', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-3929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2893', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7020', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2016-1072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7026', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3895', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1398', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-3188', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2006-7048', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7056', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10728', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-7062', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-1423', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-0228', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2014-1466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2896', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1299', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5100', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2430', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-6681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3076', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3809', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4893', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-4898', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0134', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-0141', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3135', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5658', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10694', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6905', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3845', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3081', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4916', 6.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2011-3155', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-5683', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3160', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3164', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-3168', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6919', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6925', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6934', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6938', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3175', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6940', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6941', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4927', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10705', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5693', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5701', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5708', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-4936', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4939', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6948', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-4943', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5711', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7066', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-1425', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3200', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0233', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2011-3201', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-7077', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3092', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10731', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3211', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10373', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7109', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-1458', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-5812', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0260', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-10743', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-3937', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-7131', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3945', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0266', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-3951', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10746', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-3964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3965', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1469', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-3972', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0268', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-1472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5843', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-0281', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2007-5891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2464', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10311', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1339', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3100', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6170', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-6172', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5957', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-5958', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7235', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2976', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5185', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5961', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4043', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-7243', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5204', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5214', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7246', 5.2, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-2480', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2487', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-2998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2999', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4057', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10776', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2503', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2516', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-5991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3973', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2915', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5828', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5830', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-1473', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2919', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3976', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3979', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5833', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-5834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3987', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10751', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5892', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10382', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2008-5056', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10762', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-7177', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-5080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5909', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2466', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2006-7194', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4009', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3043', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4821', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-3054', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10325', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10328', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10333', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-10337', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2017-10340', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2012-2831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5120', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3244', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-4033', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-7222', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5160', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1489', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3099', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4000', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5082', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-0285', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-5089', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5910', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5914', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5915', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5917', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7188', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7189', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10414', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10420', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2017-10426', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5114', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5119', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7204', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2947', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2009-5125', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4807', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3777', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5601', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6728', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-3028', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2009-5134', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6738', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10766', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10774', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3112', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5257', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4088', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10799', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-5282', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10806', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-5296', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5298', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6051', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6067', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-5931', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7214', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-5939', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5944', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5138', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5945', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5143', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5147', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5959', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2969', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-1490', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-5153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2436', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1327', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10302', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10306', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-0011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-6769', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3808', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6782', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10668', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4045', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5211', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-4047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2475', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2478', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4051', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3106', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3001', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-4070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5720', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5736', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-2857', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5317', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-10818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4153', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5332', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4159', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3052', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0088', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6102', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10840', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5175', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2977', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7240', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3105', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1492', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2996', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2477', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2486', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-5221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2494', 6.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:C'),
('CVE-2017-10667', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4056', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10679', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1496', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-3098', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6855', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10683', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10684', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10687', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3822', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6865', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6868', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0106', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-0107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-4882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6869', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6870', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6874', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3129', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2444', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0120', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-4901', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0129', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0145', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4904', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-3136', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4905', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10346', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2006-6888', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5660', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6892', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6896', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3836', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-2850', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4994', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4996', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5002', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5757', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5761', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7010', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5769', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5778', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2007-5782', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5011', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3879', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-10354', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2007-5794', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-0205', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0208', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0211', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-3088', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1387', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7030', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1400', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-5803', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1401', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-7039', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2875', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3805', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1331', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1333', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0015', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1335', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6790', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10670', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10673', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1344', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6812', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10675', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0041', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2828', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5995', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5998', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-10699', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6007', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5245', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10732', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10737', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10740', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10749', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10753', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10755', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10759', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10768', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10779', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5259', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6020', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6025', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-6029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5274', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4091', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10794', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-6039', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5990', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0016', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-5994', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1498', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10757', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10770', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4086', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6011', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2562', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6018', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-10338', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2006-6825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3817', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4824', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4831', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0091', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0096', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-0100', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2010-3818', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6840', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6847', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6851', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5642', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3077', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5652', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-10681', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10345', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2015-3078', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5654', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4877', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10689', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0111', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-3130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5656', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3824', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0119', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2008-4889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0135', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-0139', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2010-3826', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6044', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4102', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5288', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3028', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1508', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2007-6059', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4114', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4145', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6077', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6089', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5334', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5338', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10824', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3072', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6824', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5631', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5634', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-5636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6829', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-5641', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3055', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10848', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10791', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2007-6156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7064', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3199', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-1426', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0237', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-0238', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2006-7073', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10360', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2011-3203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7083', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-7085', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10730', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1439', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-7091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6111', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-6120', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3054', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1519', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1520', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1522', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6149', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0321', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3305', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-1528', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3318', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-6187', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10869', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-5277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10803', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5283', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-5284', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3115', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6052', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-5314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4113', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4142', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6086', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5318', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-10817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5322', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-4149', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4151', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5328', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-5331', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5336', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10826', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10828', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10691', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3137', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10692', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5671', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5677', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10375', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2010-3928', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-7103', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2018-0248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1456', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2894', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3823', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0116', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2008-4891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0146', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2011-3134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3138', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-2848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3113', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-3325', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6236', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4211', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4218', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3330', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10889', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5349', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-6249', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6255', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3144', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-3148', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-10893', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6286', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3151', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-3155', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3346', 6.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2007-6290', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6293', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2692', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2693', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6318', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6324', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4260', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2700', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6331', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2702', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6333', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-4264', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0335', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0340', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10907', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2010-4270', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5340', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6116', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10841', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2604', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-6162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10851', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0319', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3057', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3288', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6173', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3310', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-2630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6183', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5346', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2013-2446', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3152', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-6917', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3153', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3851', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2011-3157', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3161', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3165', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3853', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1365', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4923', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4929', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10706', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5691', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5695', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-5699', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3182', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6951', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2448', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-2461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3088', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2447', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4922', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6949', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4945', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3084', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5739', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4985', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6980', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-6984', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-6924', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6926', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2854', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3947', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3967', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5045', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0269', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2008-5051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5835', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5841', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2922', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7152', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-5054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5859', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7154', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10755', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3989', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5897', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-5899', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-7169', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5906', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-5074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3231', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4005', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10386', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5090', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10767', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7192', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4022', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5099', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10391', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-10394', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-10399', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-10405', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2008-5102', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-3096', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-3118', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-10872', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3132', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-10873', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6222', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10795', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3137', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-3141', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-6233', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2010-4207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4212', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4214', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4217', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6242', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4230', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6244', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4236', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4237', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-4240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6250', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0103', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6268', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6271', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0105', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4247', 6.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-6275', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2652', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6278', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7015', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5784', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10350', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2007-5793', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2018-0206', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0212', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0216', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2006-7019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1384', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1389', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5110', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5116', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-5121', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7207', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5126', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7212', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5935', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7220', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-5135', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-5139', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5141', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5149', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5156', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2962', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-7227', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10623', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5167', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7228', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5173', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5181', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5954', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3268', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5186', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5191', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10772', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2008-5200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2985', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-10774', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5218', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7247', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2997', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2476', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-2481', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4053', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-10664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2725', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6354', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6355', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1554', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6361', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4297', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2735', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4308', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4321', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5357', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5360', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-4327', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4329', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3410', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6385', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0142', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2008-4952', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4970', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5731', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2007-5738', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1367', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10349', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2006-6977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5756', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6998', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7000', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4997', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5758', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5762', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5772', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5777', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5780', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10714', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5787', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10352', 5.3, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2016-10718', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-7018', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0202', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-0204', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0214', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-0218', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2013-2452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3887', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7022', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10721', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3892', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7031', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7035', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-3902', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5807', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2876', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2506', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2018-0297', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2008-5237', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10686', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10689', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-6004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10701', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10779', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10726', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10731', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10736', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10746', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-6291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3156', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2007-6299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4257', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-6323', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5352', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4960', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4972', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5732', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4981', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5745', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6970', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5747', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1369', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-6978', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6982', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6986', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2006-6992', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-5006', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5008', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5770', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-5773', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5776', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3878', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2867', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10764', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10771', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2559', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5252', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-2563', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1502', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6028', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3015', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4098', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6042', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3030', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3116', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6085', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4150', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5327', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-10825', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3119', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3195', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10726', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-2881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10359', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-10362', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2017-10364', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2006-7087', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7090', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1443', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10737', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10738', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10739', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2011-3210', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7096', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7097', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2890', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0263', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2012-2898', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3982', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5840', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7145', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-7149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5858', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3098', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7157', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-3991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5060', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5065', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5071', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5076', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0287', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0290', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-2927', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5913', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5920', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3238', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-2938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10422', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3242', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10600', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2006-7208', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7211', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-2576', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10839', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6118', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2019-0089', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2621', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6139', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10844', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0317', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5342', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10850', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0320', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3063', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2007-6338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3162', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6341', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3133', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6350', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-2716', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2717', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2721', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3374', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-3377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1555', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4303', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-3382', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2733', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5933', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-5937', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5942', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-4034', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5150', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5157', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3262', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5161', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2016-10770', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-5952', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5180', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4040', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3297', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3299', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-2628', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6181', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-4199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0328', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3076', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-2632', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0215', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-0220', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3883', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-6227', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4229', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4233', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1533', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3145', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2011-3341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5350', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1420', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-3196', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10727', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3091', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3915', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-7079', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3918', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-2886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6302', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6317', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-6320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0333', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2011-3358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2708', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3360', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6348', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-7242', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-4044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2982', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5207', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5217', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-5982', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2485', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-2492', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4055', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10669', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-5225', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-0017', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5993', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5997', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2551', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6006', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10730', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10745', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10751', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3010', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10765', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10775', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10783', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6015', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5265', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5268', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5271', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6031', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-10790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3018', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10801', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4100', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6046', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4103', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5302', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10812', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4111', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5315', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-6058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4115', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-4120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6062', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5323', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3118', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0138', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4275', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4278', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-6352', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2720', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2723', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2727', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6358', 6.9, 'AV:L/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2011-3197', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2006-7067', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2006-7069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3914', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-1428', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-5809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5021', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3920', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3139', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6234', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10886', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10887', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4215', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-1531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10797', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0104', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6270', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1536', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2686', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-0110', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2457', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-7099', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10365', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-10367', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-10368', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10369', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10372', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2006-7100', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2891', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7107', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2459', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5009', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10210', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2017-10213', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-2928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-5041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3693', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6601', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-5483', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6603', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5486', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-10270', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:H'),
('CVE-2010-3700', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6605', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6607', 2.9, 'AV:A/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-6609', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-2956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2747', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10612', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6625', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10615', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6631', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5504', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5506', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-5508', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5513', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-5516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4797', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10276', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-6634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10820', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3053', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2582', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10744', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-7120', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7122', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5818', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-5820', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3933', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2018-0264', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2010-3955', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3958', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3962', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2463', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7147', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3988', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10754', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0283', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2007-5896', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-5057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7160', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-7164', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-5901', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3230', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10763', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4001', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10387', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2008-5086', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3234', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5814', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5028', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5815', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7123', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7126', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5034', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7129', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-5817', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5819', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-3931', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7133', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5039', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5821', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3954', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7136', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3971', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2905', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7137', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3975', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5826', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5829', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-2916', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5049', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3980', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5837', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2921', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1075', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10752', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-5893', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10381', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3990', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7158', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3992', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-7163', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3994', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-5361', 7.8, 'AV:N/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2007-5374', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-10227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-2929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10590', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5380', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10236', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2006-6519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3056', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2942', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2006-7213', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2006-7217', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-3259', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5159', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3263', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5178', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5183', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5184', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5970', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2009-5061', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2012-2763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3717', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10279', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2009-5066', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3732', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2015-2970', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2009-5074', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2774', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3761', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3764', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3073', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3100', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5918', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10768', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-10395', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10402', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2007-5926', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-7200', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5105', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5927', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-2939', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-2941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10412', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10417', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-3102', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5936', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-5941', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1077', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5142', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5145', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2953', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5151', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5153', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7223', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-3252', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5170', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10842', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6123', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6126', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10843', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-6129', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0318', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4195', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0093', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6175', 8.5, 'AV:N/AC:H/Au:N/C:P/I:P/A:C'),
('CVE-2011-3298', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3303', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-1527', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2631', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3105', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2633', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3135', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6208', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-6213', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3136', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6226', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-6228', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10888', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-0102', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6262', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1534', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0106', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3149', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2006-6527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2943', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5414', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-5423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5031', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5033', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2006-6550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10600', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2711', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-10254', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-6557', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2722', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2726', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-2727', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2006-6564', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-5036', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5463', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6572', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-10266', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-3687', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6582', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5084', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2009-5093', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1297', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6673', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3769', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10631', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5587', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2009-5101', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5111', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-4800', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1304', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2791', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5590', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6698', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3008', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4803', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6706', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-1313', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4809', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5598', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6732', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6736', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-10650', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6744', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6746', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1324', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3802', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10659', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-5150', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5612', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3089', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6669', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5574', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6674', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5179', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2471', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5956', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7234', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2978', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5188', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7241', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2007-5969', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-5194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7244', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5203', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5210', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2482', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-4052', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1494', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1303', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2009-5109', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6680', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10633', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-2998', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2999', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-1307', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2793', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6699', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10287', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-6703', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6708', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6712', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6721', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3080', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-4068', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-5986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-1538', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10895', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2691', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6289', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1540', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6296', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2694', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-3350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3351', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2007-6303', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-6309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6315', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-6319', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6322', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1546', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6330', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1547', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4268', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2707', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2709', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3160', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6344', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3362', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3000', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2009-5120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2794', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2796', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6711', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5126', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6724', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2009-5127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10294', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-6734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3792', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3029', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-2807', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1323', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6756', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-5607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1326', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6765', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3804', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10300', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-10301', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-10308', 2.5, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-1330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6768', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10708', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4084', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10738', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10742', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10748', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10754', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10756', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10762', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10767', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10777', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6013', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2565', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-6017', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-6019', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6033', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-6037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10800', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-1505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5299', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5313', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6053', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6057', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4116', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10815', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4143', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2740', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-2954', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2421', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6600', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10273', 3.7, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2010-3699', 2.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-4793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6610', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2009-5050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-5497', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2423', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2750', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5514', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10618', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10277', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2006-6643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2009-5063', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-3718', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-2965', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-3719', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2009-5067', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-3730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10621', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3747', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3753', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-3760', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-5541', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3008', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-10727', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10733', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10743', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2555', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10763', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10773', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10780', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6036', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-4096', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10780', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3025', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2822', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2816', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-6349', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2719', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2724', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1553', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6363', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2010-4294', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10806', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2734', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4313', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-3136', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6382', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6775', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2011-3094', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5309', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10783', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6087', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10831', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10787', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-10836', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4167', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10281', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-10283', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10284', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-2780', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6665', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5083', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6670', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2784', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6675', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1300', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3770', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2009-5102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3771', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10635', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2009-5114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2009-5116', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-1308', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10292', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-6705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2798', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6713', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6719', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5335', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6114', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2801', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3779', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-3027', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-6729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-2804', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3791', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3081', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10314', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10316', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10317', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-1340', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6800', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6801', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3101', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5616', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2819', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3039', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10309', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2006-6796', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0038', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1341', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4818', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4819', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4820', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2013-2441', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-3050', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3056', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6813', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3064', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6821', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-3066', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10334', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3075', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5625', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10679', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5630', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4827', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0089', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-2832', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2009-5145', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3087', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4814', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10295', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2009-5159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1066', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3091', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10949', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6393', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5377', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6402', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10970', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2007-6423', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-10973', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-2778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4353', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-3174', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1571', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-4358', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10983', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6428', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6430', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-1099', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-6119', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-2600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2602', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6122', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6124', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0090', 6.0, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2007-6127', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6133', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6144', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-3123', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4191', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6174', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-10860', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3302', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-4198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-3810', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6792', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10315', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3099', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5402', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5407', 9.2, 'AV:N/AC:L/Au:N/C:C/I:N/A:C'),
('CVE-2007-6431', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3179', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-1577', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2007-6436', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4371', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5415', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5419', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6438', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3186', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-5420', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-3190', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-3193', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-4373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5425', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5429', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4375', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4380', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4389', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2793', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-4395', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4400', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3044', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3052', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3057', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5622', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3061', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10322', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-6815', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-6819', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-10327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10339', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4829', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4837', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5635', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5638', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-5640', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-6832', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6844', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6853', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2834', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4184', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6145', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0091', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4190', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6160', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2625', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10857', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-3296', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-6177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3125', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2629', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0322', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6198', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3107', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3109', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3115', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6203', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3326', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6211', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6214', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6221', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2016-10671', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5619', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3814', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5620', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3046', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3048', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4822', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5621', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-3059', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3062', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10321', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2006-6814', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2015-3065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10323', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2006-6818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10326', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-3067', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3069', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10330', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-3073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3074', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10342', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-0046', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10678', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1347', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5633', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4832', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3106', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6862', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6864', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0105', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-0108', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-2843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1104', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6483', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-3163', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1107', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2007-6498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4427', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4432', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-4445', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-3220', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-3223', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2012-3232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-6509', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3477', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6516', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11109', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6521', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0352', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0148', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3258', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3262', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0360', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-1593', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0130', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3133', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10693', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6879', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-6883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6886', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6891', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4914', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-3840', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5665', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10701', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-6918', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3159', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3163', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-3167', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5684', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6920', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5685', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3854', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3179', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6942', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5694', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2007-5697', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5702', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5707', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2006-6957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3323', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6200', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3110', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3117', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6202', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3133', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6238', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4225', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4227', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4231', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-6243', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6246', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6263', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10798', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-3147', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-10891', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0109', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6281', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10894', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2687', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3153', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2019-0111', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4252', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0112', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-2439', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10319', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2006-6805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3813', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-1343', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3060', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10676', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10324', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3068', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10329', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-3071', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4866', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3820', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2443', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6858', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10680', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3821', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4870', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-4871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5653', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10682', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10686', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0373', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6534', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6545', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2829', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-3187', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3274', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3504', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3512', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-0380', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-1617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-0400', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0406', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6553', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3284', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5510', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3525', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-6564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3528', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-2839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10685', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-6861', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0109', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-3122', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3124', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3126', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3127', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-3079', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0121', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4897', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4899', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5657', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0144', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0149', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10690', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3141', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5659', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5661', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3146', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6907', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1362', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10796', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-2640', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3143', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6267', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3146', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2011-3340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2651', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1537', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5714', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5718', 6.9, 'AV:L/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2008-4959', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4965', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4968', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4971', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5734', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-6960', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3186', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5740', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6964', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-4990', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1368', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-2860', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4463', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1646', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2017-11144', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3315', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1651', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3316', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3317', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0121', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0122', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2007-6313', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-6316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0127', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2697', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2703', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3357', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0339', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0134', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10905', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-0135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6346', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10908', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4274', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2715', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2011-3367', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4255', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-1080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6314', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10800', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0129', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1545', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2699', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2701', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2704', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-2710', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6347', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3364', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1550', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-6876', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0132', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-0138', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-6877', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6887', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3143', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10697', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3838', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3847', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2851', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3852', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-5687', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1364', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3171', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-6935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4917', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-4926', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4932', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2006-6950', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6953', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0187', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-4948', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4951', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4954', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10709', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-4958', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5725', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5730', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3185', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5743', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-4989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-6969', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4844', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5637', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-2833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5354', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3376', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2729', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1557', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4311', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5358', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3137', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6387', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1562', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3164', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-10957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2006-6974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3872', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6981', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-6985', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6991', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2007-5754', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2451', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-10713', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-5781', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5790', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10351', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10353', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2012-2855', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3166', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-5364', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3167', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-5396', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6427', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10987', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10926', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1559', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-3390', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3392', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3411', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5361', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-10945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10950', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4341', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3142', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6396', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6397', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2765', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4345', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10809', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5366', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5369', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5372', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6400', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5378', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2770', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6405', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-6406', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5393', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3168', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-3169', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3172', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-6414', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3148', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5397', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3112', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-5785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0219', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0223', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-3891', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3894', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5800', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3896', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7029', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1399', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-3190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7036', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7041', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-1402', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5808', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3903', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7046', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3192', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-3090', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3890', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3897', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3089', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7032', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7037', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7042', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10356', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5403', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5408', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-6432', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3177', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2015-3153', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3181', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-3185', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-6441', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3192', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3195', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2786', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-5424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5427', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4378', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4382', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4385', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4393', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4401', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3155', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5436', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2008-5440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5448', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6456', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10812', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6461', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6464', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5461', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3201', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-1586', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-3132', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0137', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-0147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2847', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10708', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-6958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-4953', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4956', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4966', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5727', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4975', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4978', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4983', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-6962', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-6966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5538', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1665', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1672', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-6597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5565', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3347', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-1679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3198', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3356', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1682', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-7057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7058', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7061', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2455', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2882', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5486', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1102', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3161', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4409', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3164', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2019-0146', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6494', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4413', 6.4, 'AV:N/AC:H/Au:M/C:P/I:P/A:P'),
('CVE-2017-11097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6497', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2806', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4422', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-4428', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-4431', 2.9, 'AV:L/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2010-4438', 8.5, 'AV:L/AC:L/Au:S/C:P/I:P/A:C'),
('CVE-2010-4441', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-2808', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3224', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-3227', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-10815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3479', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-6511', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6518', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11112', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11119', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-3484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2818', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-3487', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3252', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-3177', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2011-3488', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0354', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0357', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0359', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-10712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-0199', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-2869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7054', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-2879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2006-6897', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3835', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2006-6903', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3839', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-3842', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3148', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6910', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-6911', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5674', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1070', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3082', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2006-6923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-6937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3856', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-4925', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-4931', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10707', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-5705', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-1366', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-4946', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-10361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2017-10363', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2011-3205', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1073', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0240', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2012-2889', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2007-5802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-3901', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-7040', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-10724', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-7044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10725', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2006-7052', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1418', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-5017', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0229', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-5019', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11160', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6603', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6604', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6605', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-5596', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4468', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2008-5597', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5602', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2853', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5621', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-3374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11171', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-5625', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7106', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7108', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-10740', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2006-7110', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2008-5026', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2006-7112', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-2897', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3266', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3180', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-0366', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4448', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-3183', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0370', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6536', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3495', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2828', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-5507', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-3497', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3498', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3502', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4451', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-3275', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11131', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3189', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-1609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-0386', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4452', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4377', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4381', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2789', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-4394', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4402', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3156', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-5442', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5446', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-4403', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5458', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-3198', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-3158', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6470', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-6474', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3160', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-4406', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3202', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5497', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6480', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2007-6484', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6487', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-6491', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6493', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2803', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4412', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4414', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-4416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4420', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-11096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1589', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4439', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-4444', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3216', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2007-6502', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-3229', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2809', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2012-3234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6506', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6510', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2811', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-11110', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11117', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-3482', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3175', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-3254', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6524', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-3261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5505', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0363', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0367', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3181', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-11126', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-3493', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1113', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6537', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3186', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-6543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0149', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4450', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-3500', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3279', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3510', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2011-3514', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-3520', 2.9, 'AV:N/AC:M/Au:M/C:N/I:P/A:N'),
('CVE-2018-0394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1615', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6561', 6.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-1631', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-6562', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3524', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6563', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3527', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-4454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3286', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-3532', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4456', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3289', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3538', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3291', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-10822', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1640', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-3292', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-11136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11140', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-3294', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3298', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1643', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-3926', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1449', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2006-7105', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5810', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1459', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5813', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0262', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5027', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10742', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1467', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3219', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5032', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5036', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2462', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3934', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-3950', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2907', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-5048', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2920', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2006-7148', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5846', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-0277', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-10750', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10759', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10383', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7165', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3996', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7130', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3946', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3949', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5043', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-5825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2912', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5827', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7141', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-7143', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-3981', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-3986', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0280', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1478', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5905', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-3998', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0289', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-5911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7184', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5919', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7186', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5922', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5096', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-5925', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-10404', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2006-7201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5907', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-5073', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5077', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-1480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10385', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2008-5083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0288', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-2467', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5092', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7185', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3235', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2006-7190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5094', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3237', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-1484', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10396', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:H/A:H'),
('CVE-2017-10401', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:H/A:H'),
('CVE-2017-10406', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-7199', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-10407', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2017-10408', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2017-10418', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2017-10423', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10427', 3.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2008-5113', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2008-5118', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7206', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-5122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4031', 8.5, 'AV:N/AC:L/Au:S/C:P/I:C/A:P'),
('CVE-2014-1486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1639', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-11139', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1114', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-3295', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-3297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3300', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2012-3301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3302', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3305', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-3308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10413', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10419', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-2469', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10428', 3.7, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2012-2945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-5125', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2948', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-5940', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7219', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2008-5136', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5140', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-5949', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-4976', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4980', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-4986', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3869', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2006-6971', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6975', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2007-5752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10710', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2006-6983', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-6987', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-2862', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3218', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5649', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3385', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3220', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-5657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3386', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3388', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-1703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3266', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2006-7232', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-2968', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10771', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-5960', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2983', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5209', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2984', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2990', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2991', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5227', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10674', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3322', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11147', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2008-5535', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10825', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-3350', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11152', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-3353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3357', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4467', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1116', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5587', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5591', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5594', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3365', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5598', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3548', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2470', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5144', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4035', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7230', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5176', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10668', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2495', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5231', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-5239', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3005', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10688', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-10690', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3093', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0243', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2017-10366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0244', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2010-3927', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7101', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0253', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-2895', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0201', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10761', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10769', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10776', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10781', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2561', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2008-5256', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5260', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10798', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10781', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4104', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4105', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-5301', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-3032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-3898', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3189', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2006-7033', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7038', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2006-7043', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-5806', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1403', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7047', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3194', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3907', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1419', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-3908', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-3909', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-7060', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5018', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10729', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3198', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2006-7068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2884', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10819', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10827', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3120', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1517', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2585', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6100', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-5663', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5666', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-5667', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6620', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-3225', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3226', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3227', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11178', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1118', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11181', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3228', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10733', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3207', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1442', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-10736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-7093', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-10370', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2014-1447', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4183', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6148', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3056', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4192', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6166', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3287', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3060', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-1525', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3301', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-6182', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6189', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6191', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6194', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3094', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6197', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3106', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3108', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3116', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3134', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-3328', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-6207', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6210', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1500', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3011', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-10782', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5263', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5272', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-5275', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10792', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-6038', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4095', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1506', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2008-5291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5297', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-5303', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6050', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4112', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6079', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6088', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4148', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5320', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-2571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5326', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1512', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5816', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3936', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7132', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-2901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3952', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7138', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2006-7142', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2007-5831', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-3978', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5050', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-5845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5849', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5889', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-3993', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2006-7166', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5063', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5068', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7174', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2465', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10765', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-7179', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3233', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-2926', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2006-7104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-3930', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0254', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2006-7111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5811', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2460', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2006-7117', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-5038', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0267', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2007-5823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2902', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-1471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0272', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-3236', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-4021', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2008-5101', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10388', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10400', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2010-4024', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7198', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5106', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3241', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-10411', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10421', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10769', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-7205', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-2944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5132', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5934', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-5943', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1488', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6224', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3142', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-10885', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6239', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4213', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4216', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4232', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3128', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4238', 6.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-6253', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6265', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10892', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6279', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6287', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3150', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-6292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3157', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-0113', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-0115', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6304', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3264', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3265', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2981', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-2472', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5975', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-1491', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2483', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4054', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10665', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4071', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-10680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6325', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1544', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3356', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2705', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10910', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4279', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10804', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-5339', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2603', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5341', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5242', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3109', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-6005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3110', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10711', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3111', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3135', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4304', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-3383', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4306', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6373', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2728', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2736', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2737', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4312', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2019-0140', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10928', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4322', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6379', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4325', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6384', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3393', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3396', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4334', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2010-4337', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-6390', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3141', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10943', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-10947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3163', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-10955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2758', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1096', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1565', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3143', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4344', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10963', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3144', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5368', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5370', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5373', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5375', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3423', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6409', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2776', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3171', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2777', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6429', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10993', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2781', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2783', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-10995', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-5413', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5416', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-4372', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6437', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4397', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5437', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-5439', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-5444', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5451', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5454', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-5457', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3197', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-5490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1101', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3213', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2802', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6492', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2007-6496', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4411', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11099', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4430', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-4434', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-4437', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6501', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-3219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3226', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-3230', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6503', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-3984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-5838', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2006-7150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10753', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-5888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-5890', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10380', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2006-7159', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-5059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7162', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5066', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3232', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2006-7181', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5091', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2930', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2006-7191', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4015', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5098', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10393', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2017-10398', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2012-2935', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5103', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3239', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-5109', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-2940', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-10409', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10410', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-10416', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2007-5928', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-6507', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11104', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2007-6514', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5502', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11114', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11118', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-3483', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2817', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3249', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6523', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-2823', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-5504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3260', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1604', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3499', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0383', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-0384', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2010-4453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3282', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3517', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-0391', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0396', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10821', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3192', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-6136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6147', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1523', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2010-4194', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4196', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10855', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1526', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3300', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-10861', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-3315', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-3319', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6186', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3322', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6192', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6199', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10794', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10741', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4085', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3009', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-10760', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6010', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-10778', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5250', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3014', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-6021', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1504', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-10795', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4094', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-3022', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-3026', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6049', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10782', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5305', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6056', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6061', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5316', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4144', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6080', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10784', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10785', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0042', 3.6, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4154', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4156', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4168', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4171', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6103', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6105', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6115', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3324', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3119', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-3126', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-6209', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3140', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-6231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6237', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-4208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5348', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-4226', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4234', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3332', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3129', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1632', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3521', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3523', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3526', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3529', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3530', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3531', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4455', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-3533', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-3535', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3288', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4461', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2007-6565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6567', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-1638', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3544', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3152', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-4253', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0114', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6300', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6305', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3131', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5115', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-5929', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5129', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-10612', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-3249', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5137', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5146', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-2957', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5155', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10617', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2008-5169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5177', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-5955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3267', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7236', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5189', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-5972', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-2986', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2007-5976', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-5977', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-5984', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-2995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2006-7250', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2479', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2484', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2006-7254', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4189', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5343', 8.5, 'AV:N/AC:L/Au:N/C:C/I:P/A:P'),
('CVE-2011-3294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10858', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10862', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-3074', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3075', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-4202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-5985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5234', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5235', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5236', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10777', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-10685', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10687', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-5987', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3108', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5244', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-10725', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10728', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10734', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10739', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10744', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10750', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6009', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10772', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4087', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6016', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3113', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6321', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6326', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-0130', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:N/A:H'),
('CVE-2012-3159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6334', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4265', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-6335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6336', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10906', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6339', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4273', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3366', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6351', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-1551', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2726', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1552', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1556', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3111', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-6204', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4221', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6027', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10789', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-4092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4097', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4099', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-10805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3024', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3034', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5312', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2566', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6090', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4309', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2747', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-3389', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5359', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3403', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3413', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4338', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2007-6391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10942', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-10946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6395', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4462', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3310', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2016-10823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6579', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6581', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-10824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6582', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-6583', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6584', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-6585', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5515', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3321', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5519', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-3324', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5522', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5523', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1652', 2.9, 'AV:A/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5525', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5527', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5529', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5530', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1664', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5537', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-3338', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-3340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5542', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5544', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5547', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5548', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5560', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5562', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1115', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3343', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2848', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2653', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-10799', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-3345', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3154', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-1539', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6294', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-0116', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6298', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2698', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3354', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6328', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6329', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-5333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0072', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1516', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6101', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-4170', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6109', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6112', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3355', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2010-4262', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6332', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3132', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2706', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6337', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10802', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6340', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0136', 4.0, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2013-2712', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10909', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3369', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2718', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6357', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-3378', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3381', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4299', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4302', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-5355', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2730', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3385', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3387', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-6376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10924', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-10925', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2750', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4326', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1561', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2007-6389', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4336', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-10948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1564', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-10956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-2760', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5362', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-10962', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2766', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6398', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1567', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5363', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-6401', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5381', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2773', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6117', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2619', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4187', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-10859', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3073', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-0324', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-3321', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6193', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3114', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6421', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5398', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10978', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1572', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4361', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10985', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5400', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5404', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4370', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6435', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-10994', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5418', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-2785', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3180', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-6439', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3196', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2007-6451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2788', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5423', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5430', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4376', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4384', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4386', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6453', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4391', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1583', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5374', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5380', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5383', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6408', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6411', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5394', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6422', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-6424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6426', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2017-10974', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4350', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-10976', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4352', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3173', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-3176', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-10979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4355', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-10981', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4363', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10989', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-10991', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5405', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5409', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4369', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-5411', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5412', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1585', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6460', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2796', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6472', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6476', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5493', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3214', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6479', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-6490', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3165', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5499', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1105', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2007-6495', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1106', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1588', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2805', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6499', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-4425', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4429', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4436', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5500', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3361', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-1683', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5583', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5586', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1686', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3207', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5588', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5589', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5590', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3368', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-3210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3370', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-5617', 7.8, 'AV:N/AC:L/Au:N/C:N/I:P/A:C'),
('CVE-2008-5618', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5619', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3213', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11162', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11163', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11164', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11166', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11167', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1117', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5620', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-5624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3222', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-6513', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-10816', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3251', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5503', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-3253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2824', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-0353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3178', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-6525', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3259', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3490', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6527', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-0364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2826', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2018-0368', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6528', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3182', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-6529', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11127', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5506', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6532', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6535', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3185', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3496', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11130', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6212', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6215', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3127', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6235', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6245', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6252', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6254', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6260', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3337', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6273', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0107', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6277', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0108', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3343', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3130', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4259', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0334', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-0336', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1548', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3507', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3511', 4.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2018-0382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-1611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10820', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3283', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1620', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1624', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2018-0401', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3285', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3541', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-11135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1637', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10829', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6606', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6609', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-2858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1549', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3375', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6356', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4295', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4296', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4305', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6369', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4307', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-10929', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2744', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5356', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10807', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6381', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-3391', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6383', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-3404', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-3183', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2012-3188', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2787', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-5422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5426', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-1582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2791', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2010-4392', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5441', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5447', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-5450', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-5455', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-5459', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5462', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5463', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-6469', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6473', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2800', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5492', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3162', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5495', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6481', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2007-6485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5498', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4410', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4419', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2017-11098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-2804', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2013-2807', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4423', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3217', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3228', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2012-3231', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6504', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-1591', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5512', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3311', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3412', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6386', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3138', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4331', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1563', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2754', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1566', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-10965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5367', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5371', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6399', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5376', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5379', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0143', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-3146', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3170', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-10972', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6416', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4349', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3427', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-4351', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1098', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4356', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5521', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5524', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5526', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5528', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3329', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-3330', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5531', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5532', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3546', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-5533', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3331', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-1663', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5536', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2847', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3171', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3478', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6512', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11108', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11111', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11115', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2010-4447', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-3486', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3248', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3176', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-0356', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3256', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3257', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2012-3263', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3267', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3270', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3179', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2007-6526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11128', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6531', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-3184', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3494', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6539', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1595', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6546', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-6547', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3503', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3280', 8.5, 'AV:A/AC:M/Au:S/C:P/I:P/A:C'),
('CVE-2008-5646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3550', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-3382', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3383', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-6612', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-3219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6614', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3384', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6615', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3509', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3281', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-0390', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3516', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-3519', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2019-0150', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-0398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1626', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6555', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2838', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5570', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5572', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3547', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1681', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3304', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3309', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11143', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1649', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3312', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3313', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3314', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-11145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1650', 6.4, 'AV:A/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-6573', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-6574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6575', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3545', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3319', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-10986', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4366', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0144', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2010-4367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3443', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5401', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5406', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3152', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-1580', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5417', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3191', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2012-3194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5421', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5431', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4379', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4383', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4387', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4390', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5518', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2012-3341', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5545', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5546', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6591', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6593', 9.2, 'AV:N/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2012-3345', 9.2, 'AV:L/AC:H/Au:N/C:N/I:C/A:C'),
('CVE-2014-1671', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-6594', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6596', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1083', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4472', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2008-5669', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5670', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1704', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5604', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5606', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3367', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-1691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5568', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-6600', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-11156', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3200', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-5579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3358', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3359', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-3360', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2010-4466', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11157', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3201', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3362', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3363', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-3202', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-5585', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11159', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1685', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2015-3204', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2794', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-4399', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5434', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1100', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5445', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6457', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5452', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-5456', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-5460', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-3200', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6468', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6471', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6475', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-4405', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2801', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1103', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-10813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6478', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6482', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-6486', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6488', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1587', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4421', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4426', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6500', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2012-3218', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-3221', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3225', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2012-3233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11103', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5636', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5639', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5642', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3377', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6607', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6608', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3381', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6610', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3216', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11116', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3174', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-1592', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0361', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2010-4449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3492', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6530', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0371', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1594', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5601', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1694', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3551', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3390', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-3392', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2012-3398', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-3222', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3223', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-2863', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1607', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3278', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0379', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1610', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-0385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6552', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-3518', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-2837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3552', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-6623', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3237', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2010-4473', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11188', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2007-6627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3408', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-3553', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-4474', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3238', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2015-3239', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-10832', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6628', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1119', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11190', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11194', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11195', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5626', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-5629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5630', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4469', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3378', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3549', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10830', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-11182', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5672', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6621', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-3401', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5673', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10831', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3232', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-3233', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-11184', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5674', 9.2, 'AV:N/AC:L/Au:N/C:C/I:N/A:C'),
('CVE-2007-6624', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3235', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-3403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5675', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1120', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6630', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2870', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3306', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1647', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2010-4464', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-2843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1700', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5677', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-5678', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-3241', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2015-3244', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2007-6632', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6634', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10833', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3554', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3245', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3246', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3247', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6641', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6643', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6646', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5682', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3414', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3251', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2874', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5647', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5656', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3323', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5520', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3325', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-3333', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5534', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3334', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5539', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5540', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5541', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5543', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3342', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5549', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5553', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5561', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11150', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4465', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6592', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1670', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6595', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-3195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-3351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5567', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1680', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3197', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3355', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-11154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5573', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11158', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10827', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5592', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6601', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3394', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6617', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3395', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-3397', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-3399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5659', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3366', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5600', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5603', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5608', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3369', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2012-3371', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-5616', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2855', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6659', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3417', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2007-6662', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-1715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0410', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-0411', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6673', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6674', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11183', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-3231', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-3402', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3253', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6660', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6661', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-6663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3418', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2876', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5628', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5645', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-3380', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4470', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3214', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1701', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3410', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2868', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4476', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3256', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6670', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6672', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3387', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2010-4471', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3389', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3391', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-3393', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3396', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-3221', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2007-6618', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5662', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5664', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6629', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4482', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-3427', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3271', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3274', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3422', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5697', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6677', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0414', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-3423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3425', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-1720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6625', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3236', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11185', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3404', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3405', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3406', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3407', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2866', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5676', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3411', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11197', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5679', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6633', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6635', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-5680', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3275', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11210', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-1722', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6636', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5681', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6642', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4475', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6648', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-3248', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2007-6651', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3555', 7.8, 'AV:N/AC:H/Au:N/C:N/I:P/A:C'),
('CVE-2014-1713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5704', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-5705', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5706', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3431', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3558', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1724', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6640', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2007-6644', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5683', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-3250', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6653', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6654', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3416', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5687', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5691', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3252', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10834', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5686', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-5688', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3254', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-5692', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2007-6664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3419', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11209', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-1121', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3255', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10835', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5693', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5694', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6667', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3556', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3420', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6684', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10837', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2881', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-3435', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3441', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5714', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-5715', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5716', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5717', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4486', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5709', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-5710', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3559', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-6687', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3434', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3280', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2015-3281', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4489', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3436', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3437', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3440', 9.2, 'AV:L/AC:H/Au:N/C:N/I:C/A:C'),
('CVE-2007-6688', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3283', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6690', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3284', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10839', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-1728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6675', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2878', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3268', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3426', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2015-3269', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3270', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-4483', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6679', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3277', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3557', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3421', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5695', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2007-6676', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-3258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2879', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-4490', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3282', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6685', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6686', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6691', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11211', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5720', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3285', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6692', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2012-3447', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2013-2887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3286', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5721', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1729', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3272', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2015-3273', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2007-6681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5728', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-3563', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2011-3564', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3452', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-3569', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3571', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2011-3573', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-3575', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-1726', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6711', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6712', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2007-6713', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6714', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5749', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5751', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6702', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1730', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-5703', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-1723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0422', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1731', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3292', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5757', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3466', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5732', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5735', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1732', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3587', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3294', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2008-5759', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3297', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0431', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4502', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5760', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4505', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5767', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3298', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5773', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3293', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-1734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3560', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-5722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6693', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5711', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1725', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5762', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5770', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4512', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10842', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6728', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5780', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3299', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3592', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2901', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6698', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-3450', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2007-6703', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5790', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3473', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-3301', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3595', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5791', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4523', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3306', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5793', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3476', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3598', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3481', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3482', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2015-3308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6740', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-3601', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6743', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-5799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2907', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5718', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3442', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4491', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5719', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3444', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3445', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-4493', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5787', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2008-5788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4521', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6734', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2007-6735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3474', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3302', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5792', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5794', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3597', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5795', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2905', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3603', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4535', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2886', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6705', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3568', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-3570', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6706', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4495', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-3455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3579', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2008-5730', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5731', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3580', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3457', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3489', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5744', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5748', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5750', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3461', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3585', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5753', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6720', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-10841', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3588', 6.9, 'AV:A/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2007-6721', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5758', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2007-6722', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0429', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4500', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3321', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11216', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5808', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3494', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2007-6751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5809', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-4546', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2008-5810', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5812', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5813', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3495', 8.5, 'AV:L/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2010-4547', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5814', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-5815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2007-6755', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2914', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3446', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2007-6696', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2011-3561', 2.9, 'AV:A/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-3562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3449', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-5723', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0421', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2007-6699', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2007-6701', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5724', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1084', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5725', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5727', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4549', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-3500', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-3501', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3502', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5828', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1748', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4506', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-5764', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4509', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4511', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2007-6724', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2007-6725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6726', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3565', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3566', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3453', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-3454', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-3574', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-3576', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3577', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4494', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3581', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3458', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-3289', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-5742', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2008-5743', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5843', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3507', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-1796', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0452', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0453', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-0457', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-5845', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1815', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0483', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10848', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1829', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5847', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-4556', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5852', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1830', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2920', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4532', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-3483', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2016-10844', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2007-6741', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2007-6742', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2012-3484', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-3602', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-3485', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0435', 5.3, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2013-2908', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3639', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3528', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2933', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4577', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3640', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-5772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3590', 6.9, 'AV:A/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2010-4515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-4517', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4519', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1835', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4566', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2922', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3459', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2011-3582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4573', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5862', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3518', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5867', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5872', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-5873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10843', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-6737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2007-6738', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3478', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3599', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-3307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4530', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4531', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4536', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3487', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2007-6744', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3320', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5805', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4539', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2007-6746', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-4543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0439', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3493', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-2911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4550', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5839', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10847', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-3503', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-3616', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2012-3504', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-3326', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-1751', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3505', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1752', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1753', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1754', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1756', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1760', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0445', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1764', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2917', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3340', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-3642', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2011-3646', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3342', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-1861', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0495', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-2937', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10852', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5897', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5901', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1868', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3345', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-3542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3649', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-2940', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3547', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4582', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2955', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-1870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2959', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2961', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0497', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3348', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5746', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5747', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1733', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1740', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1841', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3521', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1842', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3635', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5878', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-2928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2970', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-2974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2978', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2013-2979', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2981', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2983', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2984', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-2987', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2992', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2994', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-2997', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2999', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3003', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-3007', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3352', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3012', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3016', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5907', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5912', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2014-1878', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3353', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3017', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5914', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2018-0500', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3354', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2016-10855', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3020', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-3557', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3023', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5929', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5931', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5933', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4592', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-3026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3029', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3357', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5937', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-0013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0020', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-0022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-3359', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4596', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-1884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1887', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-11222', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4600', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4603', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-0158', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3042', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3045', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0449', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-1806', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1809', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0462', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1813', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-1816', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-1827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0482', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1744', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3362', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5952', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-5954', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3363', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5961', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0164', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4605', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2013-3063', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-5963', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3569', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5964', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3079', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-3665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5965', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3369', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3666', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4607', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-3669', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3113', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3114', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5971', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3120', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3122', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5978', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5980', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3127', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3129', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1908', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3140', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3142', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3146', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3153', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3580', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-3164', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3171', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4624', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3184', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3187', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3189', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3202', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3375', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-3209', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5985', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5987', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5752', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2007-6718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5756', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3523', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4576', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11219', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10846', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-2913', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3589', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3686', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1915', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3692', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-3694', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3695', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3698', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3701', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3704', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3710', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3714', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3715', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3717', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3723', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3728', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3729', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4638', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10860', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2013-3214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3740', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3751', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3755', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3756', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3761', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3766', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-3772', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3777', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3783', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3784', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3787', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3792', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3796', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10865', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3804', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3808', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5997', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-1922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3816', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4643', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3820', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6002', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2008-6008', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3828', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4646', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3386', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3836', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10869', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3387', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3846', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3388', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-3625', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5853', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5854', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2921', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3319', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3488', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-5801', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10845', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2007-6745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4538', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-2910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3295', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-3296', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3589', 6.9, 'AV:A/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2010-4507', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4508', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5765', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1834', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5857', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-3516', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4568', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5859', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2010-4572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3517', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1838', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5860', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-5861', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0438', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3491', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-3492', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-5806', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2007-6750', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5807', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4545', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-2912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5817', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5822', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2915', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0186', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6029', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6034', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1929', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11227', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3859', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6046', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0196', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-10877', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3609', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6056', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10879', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3864', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1933', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-0050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3613', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3870', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2008-6071', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3251', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3252', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6077', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1745', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1750', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-3506', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1757', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1758', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1759', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0444', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1761', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1763', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1765', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-11217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-1769', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1771', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1772', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4552', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1774', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1775', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1778', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1779', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3620', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1786', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1790', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1795', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1797', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1805', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0458', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3526', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-0468', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3591', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-3300', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3472', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-4516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4548', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2012-3498', 7.8, 'AV:L/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2008-5816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5819', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5821', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5824', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3519', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2925', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1858', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-3337', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2934', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2935', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5887', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4578', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11214', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2007-6736', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-2903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3480', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4528', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-11215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2916', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-11229', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3260', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3623', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0518', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3625', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1948', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-3264', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-1949', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3421', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0524', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2011-3883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3046', 4.9, 'AV:A/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-5942', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3366', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-3068', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3075', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3570', 6.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-3367', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3572', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-3575', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3368', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4612', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3578', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4617', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5969', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3116', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3118', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3123', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3125', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3128', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4622', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3147', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3150', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5982', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3158', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3670', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-3581', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1910', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-3206', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5984', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3588', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5988', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3689', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1916', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3211', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3379', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-4590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0501', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-3355', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3657', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3356', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3027', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4593', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2023-0014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10856', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-3560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3358', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-4594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3561', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0155', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1788', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1792', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1802', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1803', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1804', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1808', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0507', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3360', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5940', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4597', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1885', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2019-0157', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3038', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5941', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-3563', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-4598', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3660', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3039', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3041', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-3361', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-3049', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-5944', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-1889', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-5948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3663', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-5959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3057', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10858', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0035', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3080', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-11223', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5876', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5877', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0490', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1843', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3636', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3334', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2007-6739', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-2906', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3044', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3048', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5947', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5951', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3565', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-5955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5956', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5962', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3567', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3571', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-0036', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3576', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1905', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4608', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4609', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3115', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3371', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-3132', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3137', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4623', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-3148', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3152', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3156', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3159', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3161', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3582', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3192', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3203', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4625', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3587', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-3210', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3687', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4627', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3378', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-5846', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2018-0486', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-5849', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3512', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4558', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3513', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5855', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1831', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6088', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0212', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0527', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3273', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6097', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6098', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-1959', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-1962', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0529', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-0215', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6100', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3274', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0216', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3431', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10892', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6109', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3887', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4534', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-3313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3486', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0436', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2015-3314', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3316', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3317', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3318', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-5856', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3514', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1832', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1833', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10849', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-0487', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3515', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3627', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-3628', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1836', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-4567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5858', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3668', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4610', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3577', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3370', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1907', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-3106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3110', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3117', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3119', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3121', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3124', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3126', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3131', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3139', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3141', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3144', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3372', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3151', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3155', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3162', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3166', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3373', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3185', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3194', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3199', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3207', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3208', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3585', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5990', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3693', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4628', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3696', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3702', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3708', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3712', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3719', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3720', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4629', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3730', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3734', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3741', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3744', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3746', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3749', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3754', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3759', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3762', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3765', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3768', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3775', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3780', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3789', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3791', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3797', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3801', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3805', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3811', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6000', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3812', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3817', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3384', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3823', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3826', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3595', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6005', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3524', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0492', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1846', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3525', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-3527', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2012-3530', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0006', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2012-3532', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10851', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0494', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-5883', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-3533', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-5885', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1859', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-5888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5889', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3535', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1867', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3343', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5894', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5896', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11220', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2939', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4581', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3346', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2944', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-5903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3546', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3347', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2945', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-2951', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-2954', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-2956', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2957', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2960', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4583', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-2962', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-3650', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3651', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4584', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-1921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3212', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3709', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3713', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5994', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3716', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3722', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3725', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4631', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3742', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3592', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3748', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3753', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3767', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3770', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3774', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3779', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3788', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3793', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3800', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3803', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3810', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5998', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-3813', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3818', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3819', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3824', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3825', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4645', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3385', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3830', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3833', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2019-0170', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3835', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0171', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6021', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3590', 9.2, 'AV:N/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2011-3699', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3706', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3711', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3591', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3724', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3380', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3731', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3735', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3738', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3739', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3747', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3750', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3757', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3381', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3764', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3773', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3776', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3782', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4642', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3790', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3794', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3799', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3806', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3809', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3594', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3815', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3822', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3220', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-6001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6010', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3829', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3832', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6012', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-3834', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4647', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3845', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-3598', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3599', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3390', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4537', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0437', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3605', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3607', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-4540', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4541', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5871', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2018-0488', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1839', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1840', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2007-6752', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3496', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-1746', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0534', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0542', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-3280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0220', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-6116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10895', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10896', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0545', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10897', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3440', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6123', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0173', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2015-3389', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3851', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3391', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3602', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-3604', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3400', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3405', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6039', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3858', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4658', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-10875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3608', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3239', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-6050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6053', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6057', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6058', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4663', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6070', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3871', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-11228', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3601', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3392', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3853', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1087', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3854', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3407', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-0194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1970', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-3446', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1971', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0548', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-3281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4697', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0550', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-4700', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3454', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3455', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-3894', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3349', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2964', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2976', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-2982', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-2985', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-2988', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-2989', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-10854', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-2993', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-1875', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-1877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4586', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-2998', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-3001', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3008', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3009', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3011', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3653', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10867', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3596', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3848', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0172', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4651', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-5818', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-5823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5838', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4551', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-1749', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3618', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2926', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1773', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1776', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1777', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-1780', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1781', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1782', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1783', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1784', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1785', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3509', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1789', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1791', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1794', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1799', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1800', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0450', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0451', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0455', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4553', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0464', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-1823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1826', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2023-0001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3393', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-0046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3395', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3605', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4587', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5911', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0499', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3555', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-11221', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1879', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3654', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3018', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-5918', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5925', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3558', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-5935', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0503', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-3031', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-3559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0504', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3634', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2018-0489', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-2927', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0553', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-6127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3610', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3300', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-6128', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4708', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6129', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-0075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3651', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3652', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3653', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3654', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6139', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1987', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1991', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-1994', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3618', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3254', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10881', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3878', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1943', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0783', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6427', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0804', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6430', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-1928', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3408', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3860', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10876', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3411', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-6047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3242', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2011-3862', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6048', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6051', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6059', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3865', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0200', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-1935', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-4667', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-3873', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3333', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5938', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3036', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2010-4595', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3037', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1886', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3659', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4599', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4601', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4602', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-10857', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3040', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3043', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3047', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0511', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1122', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1845', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0491', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-3335', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0609', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4819', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2010-4820', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0594', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2043', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-4823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3660', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0605', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3941', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4831', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3705', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6331', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3330', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3950', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0639', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4842', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6342', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0642', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-3622', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6146', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11234', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3623', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-6158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0232', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0565', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0566', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-2005', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6161', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4722', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0240', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-0241', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-0244', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3665', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2014', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6170', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-6171', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0255', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-10910', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3668', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3625', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4734', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-4735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10913', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3911', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-0673', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0680', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6399', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-2054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4889', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6403', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0752', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0763', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6414', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6415', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3332', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4916', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3963', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3261', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3262', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-3626', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3529', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-2931', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3409', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3607', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3238', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-3241', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-3245', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6055', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1932', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3610', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3611', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0199', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6065', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6069', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3249', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3414', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3868', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3869', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2012-3614', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3615', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6074', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3875', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0202', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1939', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3257', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10882', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3258', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3621', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3259', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3622', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1944', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0517', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3624', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10887', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-5960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3056', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-3058', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4604', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3060', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2011-3664', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10859', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-3667', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4611', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3111', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3112', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5970', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5979', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5981', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3579', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3133', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3143', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3145', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3149', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3154', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3157', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3163', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3178', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3186', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-3190', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3191', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3204', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3205', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5983', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5986', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3376', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-4626', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-5989', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3685', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-3690', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1914', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3691', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3697', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3700', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3703', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3707', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3718', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3721', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3726', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3727', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4634', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3732', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3733', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0876', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10962', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2010-4956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3969', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1957', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6087', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3271', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0213', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6096', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-5884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-5886', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3534', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3645', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2936', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-1860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4579', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-3536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3344', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5893', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2011-3647', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4580', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3537', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-2938', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0496', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-3538', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3540', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-10853', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3544', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-2950', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2967', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-2968', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2012-3553', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-2969', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-2972', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3350', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2977', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-2980', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3652', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-5906', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4585', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4964', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-4968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4973', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3688', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0916', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5024', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-2071', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2075', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5032', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0925', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2092', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2094', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0929', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0937', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5073', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0981', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-6099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3886', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3633', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0217', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3634', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0532', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-3278', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-3435', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0533', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6110', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0535', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0540', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11231', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3637', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3439', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3888', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0652', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6382', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0657', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-0666', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0675', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6398', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0617', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6404', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6410', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0762', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2011-3960', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3628', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6191', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3673', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4743', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11236', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-0573', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0574', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4750', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3632', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-0575', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-3915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0810', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4941', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6435', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0623', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0824', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6437', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4949', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6447', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-3881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3253', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10880', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6084', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3743', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3745', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3752', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3760', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3763', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3769', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3771', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3593', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3778', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3781', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3785', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3382', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3795', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3798', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3802', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3807', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5996', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-5999', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3814', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3383', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-3821', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3221', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2010-4644', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2011-3827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-3831', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3837', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3597', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6018', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3849', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3600', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3852', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4652', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6025', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3603', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6027', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3404', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-10871', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3606', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6045', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1930', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-0195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1931', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3240', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-3412', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-1876', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3351', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0498', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3004', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-3006', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3010', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4588', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-5913', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-5916', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-5917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3556', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4591', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5919', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-5921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0502', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-5932', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-5934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3024', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3028', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3030', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3033', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-5936', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3034', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0211', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3630', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3270', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-1958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3272', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0055', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10890', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3429', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0530', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3634', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3680', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0579', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3681', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0282', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0284', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-0289', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2016-10920', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0306', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0308', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2019-0322', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-0328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3682', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0337', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3683', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0345', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4762', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3684', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6235', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0379', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-3923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0585', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0385', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2019-0393', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-6240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3690', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6250', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6255', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-4778', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10886', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3417', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3263', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3418', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3627', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-1955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3628', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3269', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3422', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3629', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3884', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0991', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5079', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-5080', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1000002', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1125', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-5094', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3992', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3758', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5099', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5103', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-2133', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0653', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3790', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5111', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5138', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6496', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2019-1000013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3349', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3352', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3354', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1000014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3359', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5140', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3798', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5142', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5143', 4.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2012-3806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6526', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0660', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2008-6529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4004', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6531', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3631', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0528', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-3427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1960', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-1963', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3632', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6103', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0809', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4943', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0822', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0823', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0828', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0830', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6441', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2062', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-10959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-0197', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2008-6054', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6060', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6063', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3612', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1934', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-3866', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3250', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3872', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-6073', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-3616', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0201', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3617', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-1938', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6079', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6080', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3876', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3276', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-10898', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0064', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3443', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1972', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-0067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3449', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0224', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4698', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3286', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3451', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3328', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3692', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0590', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2010-4783', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-3693', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4787', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-4788', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-6273', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-2032', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4790', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2010-4793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4798', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4801', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6276', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6282', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-0602', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0546', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0558', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0603', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0564', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2158', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-3361', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4022', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5146', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-2173', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4029', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10012', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6559', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10018', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5152', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6566', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3825', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1002100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4034', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5173', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6575', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2008-6581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6599', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3835', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10022', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10024', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-11020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6610', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-3372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2199', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3342', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5012', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11246', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-5016', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5020', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5031', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3973', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3978', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-5046', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2088', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6467', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5067', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5072', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0643', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3986', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2114', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5074', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-5086', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-1000001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5088', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11249', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-5091', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-5101', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-5102', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-2132', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1000007', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2010-5107', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6480', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6482', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1000011', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-0219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0537', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0538', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0543', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0544', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3638', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3639', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0221', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1969', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-3442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0871', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1096', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3334', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0142', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-10965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-0911', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4960', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0912', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0913', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3970', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-0531', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-3277', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-3432', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0218', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0547', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3643', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0549', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3448', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3450', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1973', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1974', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-3644', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3645', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3287', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-1976', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-0070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3456', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-4704', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6126', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3648', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3896', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3893', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-0226', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6125', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-3895', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3256', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3620', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0513', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4812', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6299', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3934', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3702', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3841', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5195', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5198', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5202', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6631', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6636', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4050', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4051', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5208', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5210', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5220', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5225', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6651', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3866', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5228', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5234', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3406', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2010-5241', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5249', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5256', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3407', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3868', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2010-5263', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3871', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3884', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5265', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3732', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4074', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5283', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3434', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-3451', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6679', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6680', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4078', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6681', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4079', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-5295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1003016', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3475', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5297', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2019-1003018', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2013-3478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1967', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-3640', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3641', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4693', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10900', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4706', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-1980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0227', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1985', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-3320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0560', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-3900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0914', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4974', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4978', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0915', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3335', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3341', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3971', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6313', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0593', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3937', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4824', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4825', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4829', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6507', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3355', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3360', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1000017', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0658', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3800', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2014-2151', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-1000020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-6522', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1000021', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1000024', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6537', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10009', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3812', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-2166', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2169', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-4028', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2008-6546', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5147', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6555', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3362', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0515', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0516', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3420', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3268', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-1956', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0525', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-1983', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-4710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3897', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0551', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4703', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3458', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1090', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4705', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0552', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-1979', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5156', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-3824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-5162', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5171', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5184', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-2180', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-11018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6587', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6590', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3834', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-5188', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2196', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10026', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-6609', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3368', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-6620', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3840', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3847', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0669', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5199', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5200', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3730', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6630', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2018-0672', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4714', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2000', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2010-4715', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0563', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4716', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6156', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-3659', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6159', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-3906', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2232', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003021', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2013-3481', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2241', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3483', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-11058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2243', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-6704', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5319', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6707', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-4093', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-3493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5322', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5326', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-0195', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-6720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6727', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3498', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3513', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6731', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4107', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6744', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4111', 10.0, 'AV:A/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6748', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003042', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6761', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2265', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-1003045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3538', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1003047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-3962', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6783', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6786', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4118', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2022-0002', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-11230', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-0526', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2008-6085', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6091', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6093', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0917', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0920', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0922', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5040', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2096', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0932', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5062', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5070', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0947', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2103', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2019-0958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0642', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2115', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3752', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3987', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-10983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-5078', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1000003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-10988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5098', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-5100', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2010-5104', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-2134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1099', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6477', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6486', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3793', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3794', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-10998', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10901', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3315', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-3612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4711', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3319', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4712', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3321', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4713', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0567', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-0238', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-3324', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0243', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4723', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3908', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0229', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6140', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-1986', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-1988', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-1992', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-1995', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-6144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0562', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3619', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3657', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3656', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-1998', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2001', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-0564', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2010-4717', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-4718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3624', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-2003', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2011-3907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10911', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6186', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-10912', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3910', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0572', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-0265', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4043', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6637', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5204', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2212', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5211', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11255', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-6650', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4056', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-3399', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-5229', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5235', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5246', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5254', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5266', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3412', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-5272', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3887', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-1003008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3429', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2010-5284', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3890', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6672', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3461', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2012-3941', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5296', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2008-6687', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3734', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4083', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5300', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3480', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3735', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3351', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10999', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3358', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1100', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2147', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6511', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2019-1000019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-3797', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6512', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6514', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-3805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6524', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6528', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6530', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2157', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-6533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6534', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2008-6539', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-5145', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6540', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2019-10008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11252', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-2161', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2171', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1101', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6551', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6553', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6558', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6564', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-3828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5159', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5161', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5168', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5174', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5183', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6574', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0054', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6147', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3627', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10915', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3674', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6201', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3675', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2006', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6165', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3663', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3664', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0249', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0251', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3667', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6172', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3669', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6183', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-6184', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0091', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2010-4729', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3670', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0262', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0267', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0270', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4741', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4742', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6192', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10916', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0274', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3631', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2010-4744', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6200', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0277', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-0100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4749', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6207', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2010-4753', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10919', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0279', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0105', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2010-4758', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-11237', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6585', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6603', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3363', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-11024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6621', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3843', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3863', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4037', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2205', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2013-3378', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-0671', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4039', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4052', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6641', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-5213', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5217', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5222', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3389', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-3731', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4055', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3402', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6655', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5238', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5239', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5250', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4063', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2010-5259', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5262', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3885', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3410', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-5276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2224', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6670', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1003010', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-11256', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1003054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003078', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6805', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3557', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3563', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2289', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2017-11262', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1003087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6817', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6818', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3573', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3744', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6837', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6843', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4158', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-6855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6863', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6902', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6905', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-4166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6915', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11265', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-6925', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6927', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6928', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6930', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6953', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2327', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4182', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2328', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6968', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2329', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-4189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2331', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-4201', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7006', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7010', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4211', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3749', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4218', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4222', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6705', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6708', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-2245', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-3492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3958', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6218', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2012-3678', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3326', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0578', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4759', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-0281', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0293', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0303', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0305', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-0307', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0311', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0321', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0326', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0330', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-0331', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0335', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0341', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0346', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-0355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0357', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6219', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-6222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0363', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2014-2024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4764', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-3327', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0367', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-0369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0287', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2019-0291', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0301', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0304', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0312', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0315', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0319', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-0327', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2020', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4761', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2021', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3509', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3738', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4108', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6754', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-6759', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6771', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1003049', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3661', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6163', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0085', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-0568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3666', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0248', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4725', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0254', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4727', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3909', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-0624', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3951', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4855', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4858', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2010-4866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4868', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6363', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3713', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0654', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-3331', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6381', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2008-6384', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6385', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6387', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3715', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-0658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-0669', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-0671', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0676', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-7027', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3750', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-7049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4246', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7050', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7064', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2342', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3979', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7080', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7088', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-3593', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2023-0247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3598', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-3601', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-7094', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7101', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7106', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7107', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7112', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0251', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3753', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11270', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3617', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2008-7121', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7125', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2023-0255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3625', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-2368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7133', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-11062', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2008-7140', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7143', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4259', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10893', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3635', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10894', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-0539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3636', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3436', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2023-0061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0546', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10899', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-3642', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4694', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0223', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-3285', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-11232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-4699', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-1975', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-3646', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-0378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4766', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-3687', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3688', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3643', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3924', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6790', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-4119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6801', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6807', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3553', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3560', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3965', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0264', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-11067', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2008-7149', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7150', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7151', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2377', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3639', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7154', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7155', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2378', 9.5, 'AV:A/AC:M/Au:N/C:C/I:C/A:P'),
('CVE-2011-4266', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-11070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-11072', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-7160', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-4284', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4295', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4296', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2011-4299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4305', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4308', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2384', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3989', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7170', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7173', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-11078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0276', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7182', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-7187', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11289', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7189', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4318', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-0278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3653', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2391', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-11082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3659', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-11083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4740', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0269', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3629', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6193', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3630', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6195', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-6198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2016', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0278', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-4747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4748', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4751', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6208', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6217', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0280', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3916', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-4763', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3685', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-6234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3686', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10925', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0381', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0584', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6239', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0386', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-0390', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11238', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-4768', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0396', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2008-6249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0587', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-0402', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6397', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0727', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4890', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0743', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0748', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0753', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-0764', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6411', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4894', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0771', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0620', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6417', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2058', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2010-4923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6423', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4702', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3457', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-3647', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-1977', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-1978', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3649', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4707', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-3650', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-10902', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4709', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-11233', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-6131', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-1984', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0558', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6132', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6134', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6136', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3898', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0588', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6253', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0589', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-3650', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4784', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6266', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6271', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3694', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4792', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4799', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-11056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3663', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3664', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7203', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7204', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2404', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2410', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3992', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2417', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3672', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-7209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0693', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2422', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11298', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0288', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4133', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6814', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1003090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6826', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3967', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6835', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1003097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1004', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4159', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6860', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6886', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6898', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10046', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-6911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6926', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6935', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6943', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6959', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6973', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4188', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-6981', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6999', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7008', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7014', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7016', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4213', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4221', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3976', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-0236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7045', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-1127', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7070', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4248', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6259', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3649', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4781', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6274', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3654', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0559', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-0561', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-0604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2037', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6291', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0582', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6296', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3929', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-4806', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-3658', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4807', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-4809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4814', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0591', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2040', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2018-0608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-10934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6304', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4818', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2016-10935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3936', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3703', 8.5, 'AV:N/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2008-6311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3940', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6314', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6316', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6321', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0608', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2011-3945', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3947', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4833', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6141', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-1989', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-1993', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2018-0561', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3903', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3658', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3905', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4802', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4803', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6288', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-6289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0606', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3700', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10933', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4811', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4813', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-6300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3701', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2352', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2011-4250', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0249', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-7092', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2355', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7111', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7113', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-7116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2357', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-7124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2364', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2367', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3626', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7130', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-7134', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7137', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11273', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-7142', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3631', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-7147', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11277', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7152', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3987', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-3638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3765', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0611', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2049', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0627', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3708', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0632', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4846', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3663', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4854', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0640', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0646', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6352', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6361', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6368', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4876', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4880', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0190', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-5303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5305', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6699', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3736', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3488', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5320', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3489', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6714', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6717', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6722', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3510', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-11259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0592', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4760', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2019-0314', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-0318', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0332', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0338', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0340', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-0344', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0348', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3640', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0118', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-0119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10924', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6226', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-3922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10908', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0083', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-10909', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6160', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0245', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4724', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0247', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6169', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6173', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6175', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6177', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0256', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4726', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4728', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6185', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0571', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3671', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3325', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0266', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0268', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2012-3672', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6735', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6739', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1003041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6749', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003043', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6764', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6768', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3535', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6770', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-5336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2270', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6773', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4114', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-4117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6789', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6791', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3555', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3561', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-3562', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2284', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1003082', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-2286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-4130', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6815', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-1003085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2294', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3966', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10926', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-0384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4767', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-0388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0120', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2010-4769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4777', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-0399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-10929', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3646', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-6251', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6256', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-3647', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0537', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-0540', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6265', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4786', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-6268', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4789', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-6270', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0699', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3996', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7218', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3998', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7221', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7222', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3704', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3705', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-0702', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4001', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4360', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7227', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7228', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2432', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2018-0706', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3718', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-7234', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4005', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3719', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0709', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7245', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2436', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-7251', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7258', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3734', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4006', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-2439', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2023-0315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0722', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0723', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7270', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4011', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2441', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4014', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-7274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2448', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3744', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-2456', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-3758', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2460', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3761', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2474', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3772', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7278', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3775', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4281', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2382', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4286', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4293', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-4294', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-11281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2383', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3642', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-4311', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-11076', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11286', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11287', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11288', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3990', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2392', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-0282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0284', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2008-7198', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3714', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6388', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-10945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6199', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-6202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10918', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4752', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3676', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3914', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6821', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3574', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2014-2296', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-3580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6825', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6829', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6832', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6836', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2310', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3745', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6868', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2317', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6895', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-6912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10049', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2008-6951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6954', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6960', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10053', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6965', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6972', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-7002', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4203', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-7011', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4212', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4214', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7026', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2339', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-7036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2340', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7053', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7069', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7073', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2349', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3980', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0123', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0591', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1093', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11239', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-0600', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3697', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2015-3657', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0556', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0560', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-10932', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-6292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3329', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3699', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3677', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4755', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-4756', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2018-0576', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3679', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3633', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2398', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4327', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1109', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2409', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-2415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3667', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-7207', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3671', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3993', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2420', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-7212', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3685', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4344', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-4951', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0862', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4954', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2065', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6450', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2067', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2008-6317', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3661', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0609', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6332', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3706', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4834', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-3707', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-2018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3637', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0283', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-0285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0325', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-0333', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0334', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10922', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0580', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0343', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0349', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0353', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0356', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-0361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2022', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2011-3921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3809', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-3813', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0326', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3785', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3789', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-3791', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2478', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2014-2479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2482', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-4025', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7289', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-1121', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4027', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4028', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-2485', 2.9, 'AV:L/AC:L/Au:M/C:P/I:N/A:N'),
('CVE-2008-7292', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11322', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-4029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11323', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11325', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11327', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3792', 6.9, 'AV:L/AC:H/Au:S/C:N/I:N/A:C'),
('CVE-2008-7294', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-7297', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-7298', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-7301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11330', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11332', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4032', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-7311', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-7312', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-11336', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11342', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1122', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4048', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7319', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0341', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3794', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4452', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3795', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-0590', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3935', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3659', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10936', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4821', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6320', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0606', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6330', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-3944', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3946', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0610', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0613', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4836', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4838', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2019-0622', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6341', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0631', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11241', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4843', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4851', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3710', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6346', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2429', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-0290', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11301', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0291', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2008-7214', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11302', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4349', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3694', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7215', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2018-0700', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0294', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-0296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-3999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4358', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-7225', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1116', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-0300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7230', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4368', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7233', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7237', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-7238', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2023-0306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7241', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7090', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-4251', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3604', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7105', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7110', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2012-3982', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7114', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3983', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7127', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3984', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7131', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7138', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4258', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-11064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6229', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-0370', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-0375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4765', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2014-2029', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0382', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10927', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-0391', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3644', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-6241', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0586', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-10928', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-4772', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4773', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3689', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-4774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4775', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2031', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6252', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6257', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3691', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-6260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0538', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4785', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-6267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-4794', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4800', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0124', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1124', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-0601', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3656', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0545', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0548', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6287', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10931', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4965', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-4977', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3339', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3972', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7248', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7253', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-0312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4007', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3736', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7265', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-7268', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4371', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4010', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-4012', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-7276', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3746', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2452', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-3759', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3760', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3763', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-2467', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3768', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3770', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2018-0729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3777', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3810', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-3814', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1131', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4022', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2023-0328', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-11311', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3784', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-3788', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11275', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-11066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3986', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-11068', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11279', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4289', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-4303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-11073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7164', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2387', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-11282', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7168', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7177', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7185', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3711', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0649', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3954', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3698', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2091', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-0930', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-5053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5068', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6470', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0950', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-0976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-0979', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0988', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3343', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0990', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-5077', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2019-0993', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0995', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3990', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3344', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0734', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3800', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-4064', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4457', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2011-4458', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4460', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4462', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4070', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2490', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2491', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2493', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2011-4505', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3802', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-4882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0651', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-4319', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7190', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7193', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3991', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4329', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2403', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2418', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4332', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2419', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-11293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6406', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3669', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0618', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0742', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0746', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2011-3959', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0619', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6420', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4914', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0621', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4918', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4922', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3965', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3952', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6344', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0644', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3665', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-0647', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4871', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4875', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4881', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3666', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6373', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3956', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11319', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7283', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-7285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2481', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2483', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4026', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-7291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7293', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-11324', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11326', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-7296', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-11329', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1134', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4403', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-11343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4037', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-2486', 4.9, 'AV:L/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2012-4051', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4432', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4435', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4447', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-4449', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2487', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4054', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4057', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1123', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4063', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2042', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6308', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6312', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4822', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6315', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3704', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0611', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-2046', 9.5, 'AV:N/AC:L/Au:N/C:P/I:C/A:C'),
('CVE-2019-0607', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2047', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6336', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-4835', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-3949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3662', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4852', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3709', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3664', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0692', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11295', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4337', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4340', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2424', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-3675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-11297', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3784', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11299', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4345', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2018-0697', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3791', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3693', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-3792', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11303', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3697', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7219', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4354', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4355', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3333', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-4948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0825', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0827', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3967', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0652', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5105', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-2138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0656', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1000012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5137', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6503', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6362', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3712', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4874', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4883', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2010-4884', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6383', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-10946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0665', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0674', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0724', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0739', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0761', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2010-4891', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0768', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-2056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4895', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4897', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4900', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2010-4907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3962', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4509', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2504', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-2505', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4513', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4514', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4515', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4516', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2507', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2011-4519', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2508', 8.5, 'AV:N/AC:M/Au:S/C:C/I:P/A:P'),
('CVE-2011-4520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-0374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4151', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4156', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0655', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3667', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2053', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6393', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-0667', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0672', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11242', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2008-6394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3668', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-10949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3958', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2431', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2018-0703', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4002', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4361', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4363', 4.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2018-0705', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-7231', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3712', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2434', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4369', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7243', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3724', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0714', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7250', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7261', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2438', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-3735', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0316', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3798', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-4461', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-0093', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-0360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0361', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-4486', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-4496', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4497', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4078', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-4081', 6.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2023-0365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2489', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2019-0668', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0686', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-6400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6440', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11244', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-10957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0861', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0867', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0872', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2064', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-4955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4972', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4988', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4991', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4995', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3340', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5011', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0921', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2010-5017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5023', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2494', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-2497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4517', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-0181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4518', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4920', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4928', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-4933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6431', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0806', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6434', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4946', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0813', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0817', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-0820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2061', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6439', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-0769', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3961', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0773', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0778', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2078', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2010-5036', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3976', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6461', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2089', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5065', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0940', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6472', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3748', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2019-0946', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2099', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3985', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2019-0951', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-0989', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2116', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-3988', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0648', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3753', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2118', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2159', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-4005', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1001', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2170', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6542', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2012-3815', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0181', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2008-6550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6552', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6556', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10015', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-11013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4033', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6563', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5151', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2023-0183', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2010-5165', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6572', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5185', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6583', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2185', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2010-5187', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-4035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2197', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6617', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3374', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-3837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6622', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5194', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5197', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3379', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2209', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6635', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3865', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2010-5203', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5214', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5216', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4053', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3388', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-4054', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5230', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5231', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5232', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5240', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5255', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5260', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2444', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3755', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2459', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-2463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2466', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2014-2470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2473', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2476', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4020', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-1120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3778', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3781', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3811', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4021', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-7280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7281', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4024', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3790', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-11317', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1132', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2477', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-7284', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-2480', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7287', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-2484', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0762', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2515', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2018-0765', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0767', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2011-4525', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3806', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-2521', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2011-4526', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0771', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-0382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4531', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-0385', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2011-4534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-0502', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2012-4145', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2509', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2512', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-4147', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4148', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4150', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4152', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4153', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2513', 9.5, 'AV:N/AC:M/Au:S/C:C/I:C/A:P'),
('CVE-2012-4154', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4155', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4157', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2518', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0379', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3805', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-4926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0622', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-0798', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3964', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-0650', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-3754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-3991', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0733', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-7295', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-7299', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1133', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11331', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-7309', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-11335', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4374', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11337', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11339', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11341', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4404', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-7315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4049', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4407', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2524', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-3886', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0774', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4536', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0391', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2532', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2015-3897', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-3898', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3811', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2018-0786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-0790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-0505', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2013-3812', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-3818', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3820', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3821', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-3824', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-3826', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3828', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0808', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0840', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0848', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0849', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0853', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-0864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1131', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0874', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0891', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-0903', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0907', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0909', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5268', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5271', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3425', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5278', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-5285', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3430', 8.5, 'AV:N/AC:L/Au:N/C:C/I:P/A:P'),
('CVE-2008-6671', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3433', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2019-1003011', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2008-6676', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5292', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-1003012', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-1003013', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3935', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3936', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3466', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-4939', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4944', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4947', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-3966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4053', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4450', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2011-4451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7321', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4058', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3796', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2023-0357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0358', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4459', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4065', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4066', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-2488', 2.9, 'AV:L/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2011-4465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4487', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4067', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-4069', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3801', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0931', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3830', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2013-3836', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2023-0405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-0935', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0940', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-3933', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3940', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-0952', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10066', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-0412', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-0955', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11357', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11359', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0511', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0991', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0996', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1148', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1137', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11379', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-3857', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11383', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000001', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11391', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3873', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1154', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-3875', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3886', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3890', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000002', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-3892', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3893', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3895', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0768', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4528', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3881', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-3883', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3789', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0168', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1000010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6499', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2008-6504', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0657', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6506', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-0173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3713', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2492', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4506', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0735', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2495', 2.9, 'AV:A/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-2496', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2011-4508', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0737', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3803', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2011-4511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2502', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4143', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4512', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0773', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2528', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3810', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2019-0835', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-4950', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-4952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0864', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-0866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-10960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3686', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11245', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-10967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3687', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1097', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6453', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6455', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5027', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0924', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-3979', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5044', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-2080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2093', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5049', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0933', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1003017', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-3477', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6690', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2233', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-11257', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5299', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6696', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1003023', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3482', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6703', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11258', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1003028', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-3491', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-4902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11243', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2010-4910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0780', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6424', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2019-0801', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6428', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2059', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2060', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-5064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-10979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0971', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-0980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3751', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5075', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2117', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-5087', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-3756', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-10987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1000004', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1000005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2125', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2135', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3345', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3791', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3346', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-10991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-3993', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2018-0655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3792', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6478', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6481', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3357', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4000', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6519', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-11004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6532', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2165', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2168', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-2172', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-6548', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5148', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0182', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-5153', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5155', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5157', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5163', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5169', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3727', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6592', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2184', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1102', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1002101', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6612', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-0884', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-4957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0143', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2066', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-4970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4979', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3338', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2068', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2010-4940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0812', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0826', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0829', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0831', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-0860', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4953', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0624', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0141', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-0739', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2506', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2020-0198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0758', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3804', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-1126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2510', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2014-2511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4149', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4159', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4160', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2514', 9.5, 'AV:N/AC:M/Au:S/C:C/I:C/A:P'),
('CVE-2018-0764', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2516', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-2517', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4524', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5325', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6718', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3504', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2023-0196', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-3514', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6730', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6740', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3739', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6751', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2260', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3532', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6762', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2268', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1003046', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6774', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6782', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2274', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0001', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-1003056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3963', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5015', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6458', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6459', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5043', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-2087', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2095', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5051', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5054', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2098', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-3984', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5069', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-0952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-0956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1098', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-10980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:L'),
('CVE-2018-0805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1006', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-0847', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-0850', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-0852', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0866', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0872', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0889', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0893', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0916', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0919', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-0924', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-0927', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-3923', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3831', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-3834', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10063', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-0507', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0936', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0937', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0941', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-0406', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-3932', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11348', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-0950', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-11352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3796', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0659', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6521', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2019-1000022', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6538', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-1000031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0180', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-2163', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2174', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3817', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-4031', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-11012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10019', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-6562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5149', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6569', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5158', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5166', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5170', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5176', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5177', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5178', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5179', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-3830', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6584', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6593', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6601', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5186', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-10023', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-6604', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3369', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6619', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10027', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4036', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1103', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1003', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0668', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1105', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6627', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4042', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0673', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-6638', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2008-6642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5215', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-0674', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5221', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3403', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2010-5233', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5244', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5251', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5257', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3873', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-3889', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0187', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2010-5281', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3908', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3442', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-6675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3733', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3462', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-3938', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003015', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-2520', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2014-2522', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2020-0404', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3807', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2018-0769', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3880', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4163', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4532', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-2525', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-0503', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4535', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0775', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0504', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3902', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6804', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2279', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-3558', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2282', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6813', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4135', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4138', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1003091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-3579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2301', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-1003094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6828', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6831', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4156', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2312', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2313', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4160', 4.9, 'AV:L/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2008-6850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6869', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4164', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4165', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3968', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6882', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6883', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6890', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6896', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6922', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6936', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6955', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10056', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6962', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6966', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3971', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3989', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5081', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5084', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2010-5089', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-5092', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-1000008', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-0654', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1000009', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6505', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3348', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3356', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3795', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1000018', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-3799', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6513', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6523', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2156', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-4002', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1000023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4019', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2012-3811', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2160', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2164', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2167', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-6543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4030', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6549', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3818', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10020', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-6561', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2010-5150', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-2535', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-3908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0791', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0793', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0797', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0799', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3816', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3819', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-3822', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3825', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-0801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0802', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1130', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3912', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0862', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0870', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3921', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-0910', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0922', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0932', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-2542', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3832', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-3833', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-0934', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0939', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-0944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11347', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0945', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11353', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-0508', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3943', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-0510', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0980', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0981', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-0989', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-3864', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4044', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-6639', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5209', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5218', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5224', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6645', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0675', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3390', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-6657', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5236', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5245', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4057', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0186', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2010-5258', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3867', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5267', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5270', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3888', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5279', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5286', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5291', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2023-0188', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6674', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3453', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-6682', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6683', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6684', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3940', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003014', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3472', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2230', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-2231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3476', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6689', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3954', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5298', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2010-5301', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0683', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-6698', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4971', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-4975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-4999', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5004', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3336', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3337', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5013', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0918', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5019', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5026', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5030', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2079', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-5033', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3974', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3977', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2010-5045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2084', 7.8, 'AV:N/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2014-2090', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-3980', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-0927', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2097', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6463', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5056', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5060', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5066', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6473', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2019-0945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-0949', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-0953', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5071', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-0963', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0646', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11267', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4187', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3972', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-7001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7004', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0228', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7022', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4219', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4232', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7046', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-7055', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-7059', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-7068', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2008-7074', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7076', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-7077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-3981', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-7082', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-10986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5090', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-3757', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5097', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2018-0651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2137', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5106', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2010-5108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-10994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6492', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6500', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6502', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2016-10996', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-3347', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3350', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-3994', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6508', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3995', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1000015', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1000016', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-11000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-3996', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-3997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-3998', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2155', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6520', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1142', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-1143', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11356', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11360', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0994', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-3840', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-11366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1149', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0513', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3847', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3854', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3856', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11386', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3871', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11392', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3891', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3905', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3906', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3908', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3909', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3912', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3915', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3916', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3917', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4168', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4170', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1156', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-3921', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2553', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-1160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3927', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10077', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4539', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2565', 10.0, 'AV:A/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-4171', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1008', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0518', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3933', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3934', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4174', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0995', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0998', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-1145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3843', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3846', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11367', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3852', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11368', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3855', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3859', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3874', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3473', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2019-1003020', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-2238', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0191', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2008-6702', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3485', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003026', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1003027', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-0686', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6709', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-4095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1003029', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2008-6713', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-3737', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3826', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5160', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5167', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5172', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5182', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2016-11017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6586', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6600', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3832', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2192', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2194', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6602', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6613', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3370', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3836', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11254', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0667', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3838', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3845', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-3846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6623', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6625', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1104', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-3859', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2206', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4038', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4041', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-1003003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003031', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2008-6719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5327', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6725', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6726', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-3502', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-3512', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6736', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-3525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3960', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6756', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6758', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6766', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6769', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2008-6772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-0427', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-0770', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3882', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4530', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0501', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3808', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0772', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3887', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2527', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2531', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-3809', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2018-0776', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3900', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-0777', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3906', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0778', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2536', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4164', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0780', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-2537', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-0781', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0785', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-0787', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2538', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3814', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2015-3910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3823', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-0800', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-3827', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0812', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10060', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0841', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0506', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-0842', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2541', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-0873', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0875', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0402', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-0892', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-1133', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-0908', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0913', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0915', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3922', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-0920', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0403', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2018-0929', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2013-3829', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2018-0933', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0942', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2023-0410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3935', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4167', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11355', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-3947', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-3487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2244', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6710', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2023-0194', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4099', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3505', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3507', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-6729', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6734', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0197', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2008-6738', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003038', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4109', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6745', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6750', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2262', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2264', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-6767', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2269', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-3961', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6536', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4014', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-3810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6541', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2162', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2175', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2019-10010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3821', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-10016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10021', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-6560', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2010-5154', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6568', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3829', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5164', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5175', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5180', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2010-5181', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6573', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3831', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6582', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-6597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3833', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10025', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-6607', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6611', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3373', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-11023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2198', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3377', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2010-5193', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5196', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5201', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4040', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2010-5212', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5223', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6646', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5219', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5226', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0185', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2013-3387', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2008-6658', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2008-6659', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2010-5242', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5248', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5252', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4061', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4064', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5261', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3870', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-3881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5269', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6668', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5277', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2011-4073', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2010-5289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3901', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4076', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3431', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-3444', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-3450', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3919', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5293', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-3454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-3937', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2227', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-0680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6688', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3955', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2008-6693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6695', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0685', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3486', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-0192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2010-5314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6706', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-4094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0687', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4096', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2010-5324', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6716', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3496', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4102', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-3499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3508', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-1003034', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-1003035', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-3515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3519', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0198', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11410', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11419', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-0519', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2575', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-10082', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2012-4177', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4553', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2020-0520', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10085', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0521', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4555', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-2583', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0400', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-10061', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0845', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0869', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4165', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-0914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0921', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0930', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0404', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-3931', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10065', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-2543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0943', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0946', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0949', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-11354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0953', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0954', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0978', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0979', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11358', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-0987', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-0993', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0997', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3839', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2020-0512', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1152', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-10070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3848', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3858', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3860', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-11387', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3870', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3882', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3889', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0199', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2008-6797', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2008-6799', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1003062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2278', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2015-3742', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3556', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4137', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3571', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2013-3575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-0208', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-1003093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1003095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4142', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2271', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3741', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-1003064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6806', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003080', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-3559', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1003081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6812', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-3564', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1003086', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-1003088', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3576', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-2303', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4143', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6833', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6838', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6841', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6842', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6878', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6900', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6913', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6918', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6919', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3969', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6961', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6967', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-3394', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5237', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5243', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5247', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2010-5253', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6665', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-3872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3886', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2010-5264', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2010-5274', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4075', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003009', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2008-6673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2226', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-3459', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-3460', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-3939', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0189', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3949', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-4082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3952', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-6692', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003019', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2010-5302', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N');
INSERT INTO `tpandora_cve` VALUES
('CVE-2014-2235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2237', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-3956', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4088', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4089', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0193', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2011-4091', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-3957', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0988', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-0990', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3841', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1150', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1153', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3845', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3849', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3850', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3851', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3853', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-3861', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-11388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11390', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3872', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3885', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3897', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-0514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3911', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-3919', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2545', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000005', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-1159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3922', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2019-10074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3923', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2559', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3928', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3929', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-11404', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3930', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-0516', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0517', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2011-4543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6746', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6747', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6760', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-6765', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-1003044', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-3740', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2010-5337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1003048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6777', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6785', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-6794', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2277', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-1003063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3552', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6810', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4128', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6811', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-3964', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4129', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-2287', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2011-4136', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-3743', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000003', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-3896', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-11397', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3910', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3914', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1157', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3920', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2550', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11399', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1140', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2558', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3925', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-10076', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11405', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10078', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11406', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4172', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4545', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-4173', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11407', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0424', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10081', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4185', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6974', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6997', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6851', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6862', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6893', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6899', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2019-10045', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2008-6903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-6907', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2319', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10047', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3746', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6945', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10052', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6956', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-10055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-3970', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3747', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6975', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3748', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6984', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-6986', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6996', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7003', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7009', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11268', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6711', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-3494', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2010-5323', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003030', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-1003032', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2011-4100', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-3497', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2013-3503', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-3511', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-1126', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-3959', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003036', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-4105', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3522', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6737', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-4544', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11408', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1171', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11409', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1141', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11411', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11415', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2571', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-1172', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2573', 2.9, 'AV:A/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2016-1173', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2577', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10083', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-3937', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-4554', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-2579', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-3939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1179', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2588', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-1180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1182', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-1000009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4560', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-4562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3943', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-3962', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1184', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1185', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-1186', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1187', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-1188', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1191', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-1192', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1193', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2572', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-4175', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2576', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3938', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10084', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1177', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1178', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-2585', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-3942', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2587', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4179', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1181', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1183', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4559', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4561', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000010', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3944', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1189', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-1190', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1196', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1199', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1205', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4566', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-3945', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2591', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2592', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2593', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2019-1003089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2297', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2299', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1003092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6827', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6834', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6839', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1003099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6845', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-6849', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6856', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4163', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6884', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6897', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6914', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6933', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6946', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6958', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4172', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-6978', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6985', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3973', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2008-6994', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-3974', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2333', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2008-7024', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4244', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7031', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2338', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2008-7039', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2341', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7062', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7015', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7029', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2023-0234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4245', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7047', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-3978', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11269', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-7056', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7058', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7060', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-7066', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7067', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3587', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2343', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2346', 6.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2008-7079', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3752', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7089', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2353', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2354', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3600', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2008-7093', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3528', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6752', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2263', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3536', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3543', 9.2, 'AV:N/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2008-6776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6784', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2010-5340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2276', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-6787', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6788', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6793', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6796', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6798', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1003076', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-6809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6820', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4140', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2302', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4144', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2008-6830', 4.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:P'),
('CVE-2011-4151', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-1195', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-1197', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1198', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1200', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-1202', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0433', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-7100', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-7103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7122', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11271', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-7132', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-11272', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2375', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2008-7144', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4262', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4263', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1128', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1107', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-7157', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4285', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2011-4291', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4304', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-7163', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2597', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-1000012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-3946', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3947', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4180', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2598', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2600', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4570', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2602', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4573', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0438', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-2605', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2606', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2019-10087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000015', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-6840', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1003096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4157', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10038', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6846', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6861', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6877', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-6880', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6881', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6889', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-6901', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-6904', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6909', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6916', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-6921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-6929', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6931', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-6937', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1005', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6948', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2324', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4170', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2008-6964', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0221', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-6971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1106', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2008-6979', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6982', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-6988', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0225', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2008-6998', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4202', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7007', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2332', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2023-0229', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2008-7020', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2386', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3650', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3652', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4320', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4321', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-11080', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-3654', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-11081', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2008-7191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7194', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7196', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7197', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-11084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3665', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0690', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2401', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2406', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-2408', 9.2, 'AV:N/AC:H/Au:S/C:C/I:C/A:N'),
('CVE-2014-2416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7205', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-7208', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0691', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11294', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0286', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-0439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1210', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000018', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0440', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-2609', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2610', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2014-2612', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2617', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2619', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-2621', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-2622', 9.2, 'AV:N/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2014-2623', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2626', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2014-2628', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3956', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3981', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000023', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2630', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2633', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10093', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-3987', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2639', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4581', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-4584', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-4587', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4590', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-4593', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4182', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4223', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3975', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-7038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7044', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7054', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-7063', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2345', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-2347', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2011-4249', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3590', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3597', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3599', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3605', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7104', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7109', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7118', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7123', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4254', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4255', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2366', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2008-7129', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4257', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-3985', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-3629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4595', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2641', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-3959', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3960', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2011-4596', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-1218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3993', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4598', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2642', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-3998', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2643', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4183', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1220', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0450', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2011-4252', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7117', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-0253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3754', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2008-7126', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2365', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2008-7128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3755', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3624', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2011-4256', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7139', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-11063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3630', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2011-4260', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7146', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11276', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7148', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11278', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-11069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4265', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4273', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2380', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-2381', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-11071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4283', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4287', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4292', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4297', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-4298', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4301', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4309', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2385', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-11075', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4313', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3647', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4314', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2008-7176', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7180', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2008-7186', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11290', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11291', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2013-3656', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-3674', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2421', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4346', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-0696', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0292', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2014-2430', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-7217', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4353', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2008-7220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4356', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7223', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3706', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-3708', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2433', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4367', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7239', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7244', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7249', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2008-7254', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3728', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-0715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3729', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11274', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-11065', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-3636', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11280', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2008-7156', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2379', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3641', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2008-7159', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-3988', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4274', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4288', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-4300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4302', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4306', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-11074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3644', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3645', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7166', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3646', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7174', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-11077', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-11079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2008-7183', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1108', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4316', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2008-7192', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7195', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2393', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3971', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3972', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3978', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3979', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3981', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3985', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-2645', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3989', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-3992', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2023-0454', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-2647', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1226', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3996', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-3999', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4000', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11424', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2653', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4606', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-4001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1010003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2397', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-3662', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-11085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2008-7200', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-3779', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-11086', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-4328', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2402', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2407', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2414', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4339', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-4341', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2426', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2012-3994', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10086', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-1000014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2604', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2607', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2016-1208', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000019', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000020', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2608', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2611', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-2613', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-2614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2615', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2616', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1211', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2618', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-2620', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-4181', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2624', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2625', 7.8, 'AV:N/AC:L/Au:N/C:C/I:P/A:N'),
('CVE-2019-10090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10091', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-4576', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2411', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1110', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4334', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3673', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-1111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11296', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2425', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-0694', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7213', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4008', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7264', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-4009', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7267', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7269', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-3739', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3742', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-11307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2440', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2018-0724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4015', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2446', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2447', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4017', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3749', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-2451', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-3754', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2461', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3762', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3764', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-3767', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2475', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3774', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-3808', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-3812', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-3815', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-0695', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2428', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-11300', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3788', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-3790', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-0698', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-3995', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0293', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-4352', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2008-7224', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-4003', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4362', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0707', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7232', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2435', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-3720', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3978', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1213', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4577', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2629', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2631', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1214', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2015-3988', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-10094', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0447', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-4582', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2011-4585', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4588', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4589', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2016-1216', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3958', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1115', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-3997', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11304', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3703', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-0701', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2008-7229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4364', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3709', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2008-7242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-0710', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2437', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7246', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2008-7252', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7255', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-0718', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1118', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7262', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4185', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11439', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4012', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2013-4014', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4016', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4017', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-1010034', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4020', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-4025', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4032', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000039', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4615', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2665', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-11445', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11446', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1010054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2668', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4040', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4041', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2669', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000041', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4042', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4043', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4044', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-4045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4046', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4048', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4049', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-4050', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-1230', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1231', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4054', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4056', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1010057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4064', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2014-2670', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4074', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2008-7247', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-3801', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-0313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4016', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-2445', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3743', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0319', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-2449', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-4372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-3747', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2455', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-3990', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-3991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3994', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-3995', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3961', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4601', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3969', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-3970', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3973', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-3976', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2013-3977', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3980', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3983', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1221', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3988', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3990', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1225', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-3993', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-3997', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2017-11423', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4607', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4608', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11427', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2654', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4609', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4000', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2008-7263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-3737', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2008-7271', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-0728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2442', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-2450', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-7277', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-3751', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-2454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2457', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3756', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-2464', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-3766', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-3769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-3771', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-3773', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-3776', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-3780', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-3782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2008-7279', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-11309', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-11310', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-3783', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2008-7282', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2011-4373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11318', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0330', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2008-7286', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2008-7288', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2008-7290', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2023-0331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0332', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11328', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-7302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11333', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2008-7310', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-11334', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4078', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4080', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4619', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4094', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11338', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11340', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4033', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-3793', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2023-0338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4406', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2023-0339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4415', 2.9, 'AV:L/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2011-4431', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2008-7320', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1010005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000030', 2.5, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2018-1000032', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11460', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1010095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0463', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4002', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2018-1000036', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4005', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-11434', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11440', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2659', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000038', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4013', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4015', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4612', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4614', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4019', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4022', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-4024', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4033', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2013-4035', 5.2, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-1010038', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2667', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-1010104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000057', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4021', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4111', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-1247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1248', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4065', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-4067', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4617', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-4081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1010069', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4620', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1236', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4622', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-4623', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000049', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4093', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4187', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4099', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000051', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1146', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4101', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-1240', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2675', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4102', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-11461', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-11462', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10101', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0462', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-1010100', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1244', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4188', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0466', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1010150', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2681', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2017-11475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1254', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4017', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4018', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11482', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4112', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-1010124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4116', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2023-0465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1010142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4118', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4193', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1010147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4122', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-1010149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1253', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4038', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-1010177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4138', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-11507', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1151', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11516', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4026', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11480', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11481', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1149', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-1010153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4029', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1150', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1010161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010163', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010173', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11503', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4135', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4039', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11506', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-11508', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000074', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11511', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4140', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-11522', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1010183', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4143', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4640', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-11523', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2682', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4154', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4646', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-4196', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-4197', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4659', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1010199', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4157', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2023-0473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1010039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0460', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4053', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4055', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4057', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4058', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4070', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2671', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4618', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1010062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010065', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1010083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1145', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2013-4095', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2627', 6.4, 'AV:A/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0441', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-1212', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000022', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-3982', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-10092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0443', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-3983', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-2632', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2634', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2014-2638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4578', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-3986', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-1215', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-3989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4583', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4586', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4591', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4592', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000025', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1217', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4597', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4600', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1219', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-3999', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11530', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4165', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-1010209', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11540', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11542', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11546', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11549', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1155', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11551', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11554', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010220', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-11559', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11565', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4201', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11567', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4040', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-1000075', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4155', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-1010191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11526', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10102', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010202', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4199', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11463', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1243', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4189', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000055', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2016-1245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11471', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1246', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4191', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4192', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010123', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000027', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0452', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-3975', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3982', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-3984', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-3986', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2646', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4602', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11421', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4603', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2648', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-3995', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-3998', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-10099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11574', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1288', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-1290', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-1293', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000078', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4045', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11581', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4680', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4202', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1309', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1316', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4173', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4178', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4682', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000083', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000084', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4180', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11586', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1322', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1010246', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4204', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000067', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4024', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1252', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4119', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000069', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1000029', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010004', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1010006', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1010009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2655', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000031', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000033', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-1000034', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-11429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1143', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1010017', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000035', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2658', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4003', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4004', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4006', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-1010018', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4610', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000037', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11438', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-1144', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-1010028', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11529', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1010208', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11531', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11533', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0484', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-4183', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2690', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11593', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11594', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1160', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4686', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1340', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4205', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010251', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4689', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4189', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000097', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4191', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4192', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-4195', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4196', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4198', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-4200', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-2708', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1161', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-0490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2709', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4693', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4694', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11613', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1010263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000100', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2715', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2716', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-4696', 4.9, 'AV:A/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-11441', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4018', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-4021', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4027', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4034', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-4036', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-11444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000040', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4039', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-1229', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4051', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-11447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4061', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-4062', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4068', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2013-4069', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4073', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11543', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11547', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11548', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11550', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11552', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11555', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11557', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1156', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11561', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0543', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11570', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1291', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0544', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1296', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1300', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4041', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1255', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0467', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4128', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-11478', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4206', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4700', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4703', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-1162', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010268', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4704', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-1010275', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11628', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2720', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11629', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11637', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11639', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11640', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4712', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4213', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-1354', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1356', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000107', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11663', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4216', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4169', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4172', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-11582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4681', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-4177', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-1010239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000079', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-1318', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4683', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1320', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0483', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-1159', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11590', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11592', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4182', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1010248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0545', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1342', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4076', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4077', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4079', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4083', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1010060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1233', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000045', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1234', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000046', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4088', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1010084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4092', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1238', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11459', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2674', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000053', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11464', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1241', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1010162', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4134', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4037', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-1010176', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1152', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4634', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1010182', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1010189', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4152', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4153', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11524', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1000093', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4185', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2020-0547', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000054', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2015-4010', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1242', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11467', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2680', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1010101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4190', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000056', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2013-4105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000058', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010113', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000062', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4113', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4117', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1010127', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1249', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1251', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000068', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4644', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4647', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4650', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010190', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11525', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4198', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-1010193', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4156', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010201', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11527', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4161', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010207', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4197', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2013-4199', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-2707', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010257', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1000099', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10001', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11612', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11615', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2011-4697', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-4702', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-11627', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4208', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4710', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1010279', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-4209', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4210', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11643', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000106', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-1000070', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4123', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4124', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000071', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4025', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11479', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1148', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4027', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4130', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4131', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11496', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11497', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11498', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4035', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11499', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0499', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-4217', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11668', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1371', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11674', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11677', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000111', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4718', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1392', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-1399', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4727', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4731', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4212', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4047', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-1353', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-2730', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1357', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4214', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2017-11653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11662', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11665', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0498', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-2732', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11666', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1364', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000109', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1368', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2733', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2734', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-11669', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11670', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4716', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4218', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-2735', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-11675', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1168', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-1382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1394', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2016-1402', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000112', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4728', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4730', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2737', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4733', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4734', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11691', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4750', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1415', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4752', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1418', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0503', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2011-4755', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1423', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4758', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4759', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4764', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1439', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4051', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2016-1442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1443', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11692', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11703', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11705', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4223', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4770', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000114', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-4780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0505', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-1171', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-4783', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1010301', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1447', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1284', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11569', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11571', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11572', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1286', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-11573', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11576', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11577', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0481', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1010228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1301', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0482', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1304', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4679', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-4046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1311', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4176', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1010241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000081', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1323', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1324', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-2686', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2689', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4184', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4747', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4748', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1411', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4756', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4757', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1427', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4221', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4760', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4761', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4765', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-4768', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1444', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-0504', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-1170', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-11704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4222', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4772', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11706', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11714', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11715', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10103', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2744', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1448', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4228', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4229', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-4057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1010308', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2760', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11718', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4789', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2771', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2775', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000119', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11719', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2784', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2789', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11723', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2797', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4234', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2803', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2804', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2808', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2814', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-2818', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2821', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2822', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11726', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11729', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11730', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11731', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-4066', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000121', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11739', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2830', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11742', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4070', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1010169', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010170', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010171', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010172', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2745', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2019-1010304', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1010305', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1010307', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11717', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2753', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1010314', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2756', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4062', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2759', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4787', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2766', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2769', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2772', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2773', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11720', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4064', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2782', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2786', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11721', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2788', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11722', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2790', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2792', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2795', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2798', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2800', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2802', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2807', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2810', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2816', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2823', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11728', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2825', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2826', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2828', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-11733', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11736', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4239', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-4802', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4067', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11738', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11740', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4805', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2838', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4069', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-11747', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4807', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000123', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10107', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11752', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2844', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4243', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4812', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2845', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4244', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0010', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11766', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000129', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000130', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1460', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4815', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-4195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4136', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11512', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4639', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4642', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2011-4643', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-0472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1335', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1339', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1343', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2012-4206', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4194', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-1345', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4691', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4818', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11770', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4075', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1178', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4251', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2849', 9.2, 'AV:N/AC:L/Au:S/C:N/I:C/A:C'),
('CVE-2018-1000132', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-11792', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4078', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-10108', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-1470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1471', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1472', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0509', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-10105', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11749', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1175', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11751', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11753', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1000124', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-11755', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4215', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000126', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11761', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4816', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4820', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-2848', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11776', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1466', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11791', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-1000133', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11794', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-1000134', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4829', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1477', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1481', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1473', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4826', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4828', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4830', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4082', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1480', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1484', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4834', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4085', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4838', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1180', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4853', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4262', 4.9, 'AV:L/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2015-4094', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4858', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4263', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11802', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2858', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11805', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4218', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4219', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1493', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000141', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-4226', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1494', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-4111', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000142', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0013', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2862', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-11809', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11810', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4273', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1482', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4832', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11797', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4849', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000136', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4261', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-4217', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1010261', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4692', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4698', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-4701', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-11626', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1000104', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4705', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-0494', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4708', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4709', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11644', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11647', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0496', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-2727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1355', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1360', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-0497', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-1010287', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11654', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000108', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4714', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-1010290', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4715', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11667', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11671', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000110', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1373', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2016-1374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1375', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1377', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1380', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1381', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1383', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1386', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1389', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-1391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1393', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2017-11680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1400', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1401', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1404', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4722', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2023-0502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-4725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1405', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4729', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1408', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11684', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4160', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1010204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1010206', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11528', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2863', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11811', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11826', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11834', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-11840', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11844', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-11856', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11863', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11882', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4280', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4281', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000149', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-0562', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4134', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-4137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-0563', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11893', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4245', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000152', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-11804', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2857', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4108', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2860', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11807', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4225', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1281', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11532', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11534', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11535', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4164', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11536', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-11537', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11538', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11539', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1154', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11553', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11556', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11562', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000077', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-1283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11568', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1157', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1285', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-11575', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1289', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1294', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1297', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4168', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1010235', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4678', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1305', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010237', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2684', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-4203', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4175', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11583', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000080', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-11584', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000085', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1000087', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4684', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1010247', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4737', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11685', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4739', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4740', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-1169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1413', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4751', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4753', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4754', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000113', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2741', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2742', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-4762', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4766', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4767', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4769', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-1440', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-1441', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2011-4771', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4773', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000116', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4776', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4777', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2743', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4053', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1010300', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1010302', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4784', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4785', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2016-1449', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1450', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1452', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-11716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4230', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-4786', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2754', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2764', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2768', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2770', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2774', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2778', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1010315', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4233', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4791', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2785', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11724', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2796', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2801', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1010317', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2809', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2811', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4800', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-2815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2819', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2824', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11732', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4237', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4685', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000088', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000089', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1000090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1338', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-0546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4687', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000095', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4688', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000096', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4690', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1010319', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4214', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2829', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-11737', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4068', 9.2, 'AV:N/AC:L/Au:N/C:C/I:N/A:C'),
('CVE-2013-4241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4806', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11744', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000122', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-2864', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11813', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2865', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4119', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11822', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1183', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11838', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11845', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11848', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-4236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11855', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2867', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-11866', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1500', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-15003', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4129', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-11872', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-11878', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11884', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4237', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11887', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4132', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4282', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0561', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2869', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1189', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000150', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4244', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-1000151', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-0565', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4139', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2872', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4140', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2873', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11894', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4251', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000159', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4255', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-0568', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10112', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2884', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4156', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-4274', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4276', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4165', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-15018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4278', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4279', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4280', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-15019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4166', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4285', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4289', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4292', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4295', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4297', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2891', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-15022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0569', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-2892', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4306', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4310', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-15025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4173', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-1010260', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11750', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-2843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11756', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1458', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4819', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4250', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000131', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11775', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1464', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11790', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-11793', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4077', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2850', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-4216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4255', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-4256', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11796', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1474', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2011-4831', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4084', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1483', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-0557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4833', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4836', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4259', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4260', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-11798', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4848', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-4850', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-4851', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4852', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-4854', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4145', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000156', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-15010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4291', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4293', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4252', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-4253', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4256', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4259', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-2875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11895', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0529', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-0530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0531', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-11903', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0532', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-4298', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-4264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11906', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-0535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000164', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-4336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000174', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4315', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4337', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0575', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4341', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4316', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4317', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11611', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2710', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1010266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4699', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-11617', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11624', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11625', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4208', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000105', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11630', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4711', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4212', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2729', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-1352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1358', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-11652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4215', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4713', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2731', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11661', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1369', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4210', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2853', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11801', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2855', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-0012', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-1489', 5.8, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2015-4106', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2859', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11806', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1491', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4230', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11808', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4112', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000143', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1181', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0522', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4272', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4274', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-4232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000144', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1495', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4118', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-11812', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11820', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11825', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11827', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2866', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4235', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4127', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11833', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-11837', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4196', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4345', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4322', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-4878', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2016-15035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4351', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4879', 7.8, 'AV:N/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2013-4327', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4222', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4229', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0554', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-4331', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2905', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4255', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4265', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4267', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0555', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-4271', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-4881', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1513', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4279', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4283', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-2906', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4289', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-4295', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4299', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2015-4303', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4304', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-4307', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-1518', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4315', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2015-4319', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-2913', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4328', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2018-1000182', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2015-4331', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2023-0558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1520', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000183', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4887', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2916', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4340', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11913', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4341', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-15017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4273', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4282', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2890', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1502', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-0541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4283', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4288', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4305', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4294', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4298', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4303', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2023-0543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000169', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-4717', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2017-11672', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1372', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-11679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1390', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4726', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4738', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11686', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4741', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4742', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4743', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4744', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11687', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4746', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4749', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000147', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11841', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11854', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-11869', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4277', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2016-15004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11877', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1000148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-15005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0016', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11889', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4240', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4286', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2020-0564', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0017', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2871', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4287', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-4288', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1501', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4289', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000154', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000158', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2874', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4290', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4292', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4295', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4254', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4258', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0019', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000160', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4326', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10114', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4862', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4332', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-0570', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4335', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-0071', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-2936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4356', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-11916', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4890', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-1522', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4345', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4354', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4355', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11919', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-1526', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2012-4263', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0528', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-2880', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4859', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4148', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11908', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4270', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4153', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-15015', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4271', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4155', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-4272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2886', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4301', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4778', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1445', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4213', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1010306', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2746', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2019-1010310', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-1000118', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2755', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4232', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2757', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2758', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2761', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2763', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2765', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2767', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4790', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2776', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4063', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-1010316', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2783', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-2787', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2791', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2794', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2799', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4236', 2.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-2806', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4065', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2813', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2817', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2820', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11725', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11727', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2827', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-11734', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4803', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4240', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0508', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2011-4804', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-11741', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-11746', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11748', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4242', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-10106', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11754', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4810', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4813', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1176', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11764', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000127', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4817', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-4822', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1177', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11774', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1462', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-0556', 3.7, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-1179', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0512', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4286', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-4304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4290', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4293', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4296', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-15020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4896', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-11937', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11939', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1542', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4359', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4898', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4361', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0084', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4363', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4899', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0085', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-4370', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4371', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-1549', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1551', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-4352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1203', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1205', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-4378', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4373', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-0594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4378', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2018-1000194', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-15031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-0583', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-4318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0550', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-2900', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4319', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2018-1000177', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4874', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4875', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4180', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4182', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2023-0551', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2015-4189', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-15033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4347', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4348', 10.0, 'AV:A/AC:L/Au:M/C:C/I:C/A:C'),
('CVE-2012-4349', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4211', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4324', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4325', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4326', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4217', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-15034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1191', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11910', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4239', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4240', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4244', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4252', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4254', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4273', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4332', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4282', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4290', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4292', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4298', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4305', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-1000181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4316', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2012-4354', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4338', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4330', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4883', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4355', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-2922', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-11912', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2926', 2.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-11914', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-2928', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2014-2935', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4335', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4336', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4338', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4342', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4894', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000188', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-4348', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-12065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2963', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-15023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000172', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4863', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-15028', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4867', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4334', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000173', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4868', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-15029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4869', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-4870', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1503', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11935', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4360', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1543', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11940', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0568', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1544', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-4362', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4364', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1198', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4368', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-4900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1547', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-1548', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2016-1485', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1486', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-4837', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2852', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4847', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-11799', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11800', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4855', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4856', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4857', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-0558', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000137', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4100', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-1000138', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-2856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10109', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4320', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-4321', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000179', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4179', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4188', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4214', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4216', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4219', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-2903', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4228', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2015-4233', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4880', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1505', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2015-4242', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-11911', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4353', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4259', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4262', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4281', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4286', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0556', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2011-4882', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4310', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4317', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4318', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4320', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4322', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2023-0557', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4327', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1519', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10116', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4379', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4357', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4377', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-4382', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4380', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4396', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-12068', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4373', 4.9, 'AV:L/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2012-4383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4375', 2.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2018-1000198', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0583', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1207', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12070', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0584', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-1490', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2018-1000140', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4265', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1492', 4.0, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-0519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4116', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1497', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1182', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1498', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-11821', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1499', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:H'),
('CVE-2017-11836', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11839', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11843', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11846', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0560', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4885', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2921', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2933', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4337', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0072', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-11918', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000187', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4346', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-4351', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2015-4353', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-4356', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1524', 6.0, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2011-4895', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-10118', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0567', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-11930', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0079', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000190', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-11936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4359', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2948', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-2949', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-4897', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-1194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000192', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-11858', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-15002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11876', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11879', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-11886', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4238', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-4283', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-11890', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2870', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10111', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4384', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4389', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12071', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4905', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12072', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2983', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4143', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4144', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0567', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4250', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-4296', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-4257', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-15011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4297', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-15012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1190', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-11901', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0021', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000162', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0533', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-0534', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2012-4265', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2879', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11905', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11907', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000163', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4152', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-4269', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000167', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-11909', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-15016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2885', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2013-4302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4860', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4281', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0093', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4362', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-4363', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1200', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4377', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1202', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4372', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4376', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4379', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4381', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4383', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4385', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-4390', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4392', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4358', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4363', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2972', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4387', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4395', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2988', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2012-4291', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-15021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4861', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4301', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4171', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-4305', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2893', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4311', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4325', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-15024', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000170', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-2894', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-15026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-15027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4864', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4328', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4865', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4331', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4866', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-4333', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4415', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4420', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4907', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12075', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4394', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4388', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12076', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1562', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4389', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-2989', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2994', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000208', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0591', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-1564', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4396', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4390', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-4910', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4871', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-2899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-15030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000176', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4873', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-15032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000178', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4876', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-4877', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-4183', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4343', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4218', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4350', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1504', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4221', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4253', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4256', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4257', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4269', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-4270', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000180', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4276', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1517', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-4280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4333', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-4302', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-4306', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-4314', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4325', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4329', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0029', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0070', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1000184', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-2927', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-2934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000185', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1000186', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0566', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4344', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4357', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1523', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-4344', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-4347', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4350', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10117', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1192', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2017-1193', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1525', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-1000189', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2946', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4357', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4358', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2947', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-11932', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-11934', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-4358', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1531', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0083', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1195', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1546', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4365', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4366', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4361', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-4367', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-1199', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4369', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2956', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1201', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1550', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4351', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4353', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-0572', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000193', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-4374', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-12061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4380', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0088', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2015-4386', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4395', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-4362', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4398', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4381', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4365', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-2966', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-2968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2971', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-1000197', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-4386', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2974', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4377', 2.9, 'AV:A/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2011-4903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2976', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-2977', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-2978', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4378', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4383', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-4411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0586', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000205', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-2987', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0592', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-12078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4911', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1569', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-4400', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-4402', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2014-3004', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4405', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4393', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1571', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-12079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1208', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4407', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4408', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-4394', 9.5, 'AV:L/AC:H/Au:N/C:C/I:C/A:P'),
('CVE-2014-3007', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000215', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4409', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0594', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-4395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12081', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12086', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000216', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3008', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3009', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3011', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3012', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3013', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3014', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1572', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4396', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12082', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4402', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3021', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3022', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3024', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000223', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4918', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4920', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4921', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-4409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1577', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2015-4429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4408', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000221', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1581', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000224', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10130', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12101', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12103', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12105', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12106', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12107', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12109', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12110', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12111', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0598', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10131', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-1585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4413', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12134', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-12135', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1000301', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-12140', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0609', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000300', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12131', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1583', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4421', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2019-10132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000400', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4415', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4424', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-4426', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3025', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3033', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4419', 10.0, 'AV:A/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000403', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4420', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-4434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4939', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-3037', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3041', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4435', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-3042', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-10134', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4941', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4423', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3050', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-4436', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3053', 9.5, 'AV:A/AC:L/Au:N/C:C/I:P/A:C'),
('CVE-2011-4942', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3062', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3066', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1586', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12136', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-12142', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12143', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1592', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4925', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2012-4427', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3032', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3035', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-4926', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4930', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4430', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1596', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4421', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4425', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-0601', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2016-1607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0673', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3088', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-3095', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-4429', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4445', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-12157', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-0711', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4432', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-10141', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2012-4447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-0712', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3111', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-0713', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4449', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4955', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4434', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0628', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12164', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0629', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-0759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000417', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-0630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0765', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-4455', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2020-0767', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4456', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10147', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-1000420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4457', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2011-4968', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-4452', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4460', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-0793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1217', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4463', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2011-4972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4438', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4465', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10155', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-1000426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12175', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3068', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-3073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3076', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3077', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3079', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2019-10136', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000408', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-0640', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0650', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4433', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4949', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12151', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-4472', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-4474', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12176', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3093', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0623', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4443', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000411', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-3106', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12156', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4446', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4448', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4953', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1611', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4450', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2019-10143', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12163', 4.2, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2012-4452', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-1613', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2015-4375', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-12062', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4384', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4387', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-4388', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-4389', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-4391', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-2960', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4393', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-4394', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4359', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4364', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12066', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-2967', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4374', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-0581', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12069', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-1000201', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4379', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-4380', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2018-1000202', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-2980', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-0585', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4390', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-4385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4391', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4414', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1626', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2011-5007', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-5008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-0830', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4487', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-4489', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-10159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4476', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-4499', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-0831', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0832', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000524', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4507', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0851', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1628', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2023-0588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12074', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4393', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1615', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-4510', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3156', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1565', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1566', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4427', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-2995', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-10127', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1000209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1567', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4391', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-2996', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2018-1000210', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1568', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-4392', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4399', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4401', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-4403', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4404', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-4912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-3006', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000211', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0097', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-0923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12191', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2013-4490', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-10163', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-3160', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5041', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3161', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3123', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2016-1617', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-0970', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5058', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-5063', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-12197', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12200', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0125', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1223', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4497', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4502', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-4504', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2017-12244', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2011-5081', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12251', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-3169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1618', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2011-5098', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4468', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4471', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-0824', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000500', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10156', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-3147', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4482', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-12178', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000502', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5003', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10157', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12179', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000503', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000504', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12080', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1573', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4412', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4413', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2023-0600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4399', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-4400', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4401', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-4406', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4414', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000217', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000218', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000219', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4407', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4415', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000222', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1209', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3020', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1580', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1582', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4922', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4923', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000225', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4416', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-12097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4417', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-12099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1210', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12102', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1211', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4419', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5009', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-12181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5011', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4475', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2015-4441', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4497', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2017-12182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1627', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000527', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4481', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-5027', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1629', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5033', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4518', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-4487', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12132', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000539', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-4525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0951', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5052', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5054', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000546', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5059', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-0991', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5060', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2016-1637', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10168', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5089', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3170', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-1587', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12138', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-12141', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4423', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1593', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0641', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-3172', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-12261', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12262', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000607', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-3176', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12291', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-4927', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-1000402', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4429', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4436', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000415', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1612', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2016-1599', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3038', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-3040', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3043', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000406', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-4940', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-4422', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4424', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3045', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3051', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3054', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4437', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3055', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-4945', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3061', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3070', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3072', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4432', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4947', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-0603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4411', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4422', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4430', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12133', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12137', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-12139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12144', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-4924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0610', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1000401', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10133', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1594', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3026', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3031', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3034', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3036', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4431', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4928', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1595', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4431', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4433', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000404', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1597', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1598', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5037', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4523', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2011-5038', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3159', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-1603', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1606', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3074', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000407', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10137', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-4948', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3083', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-0652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1640', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-3115', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4957', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10144', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-4435', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4440', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-4441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0758', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-4961', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4454', 2.9, 'AV:A/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4444', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3121', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2019-10146', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-4966', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3162', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0968', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5055', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0969', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3165', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5080', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-0674', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0694', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0700', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3090', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0706', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-1000410', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4430', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3096', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3097', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3102', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-1610', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-5066', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1220', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000548', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10167', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4532', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3069', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4426', 4.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-4427', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3084', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2018-1000409', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-0693', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3087', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-1609', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3094', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2023-0621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4442', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2020-0710', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3099', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3103', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3104', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3105', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12158', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4431', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2017-12252', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5092', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5095', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-4509', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-10002', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4553', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4554', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000604', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3056', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4944', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3064', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2014-3065', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3075', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-4946', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4435', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-4437', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-4956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4439', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2020-0760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0112', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-4458', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0789', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-3127', 9.2, 'AV:N/AC:H/Au:N/C:N/I:C/A:C'),
('CVE-2018-1000422', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10152', 5.8, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2011-4970', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12169', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000423', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4971', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-4973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-0115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5097', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2019-10176', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2012-4550', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-3171', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12159', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4951', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0110', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-12150', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-0618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-1224', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12249', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1000556', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5085', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5091', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5096', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4510', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2016-1644', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10181', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4557', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000605', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-10183', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-5107', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4559', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0645', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-0646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0136', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-12263', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12264', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-12268', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2011-5111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5100', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4556', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-4558', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10182', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-5108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1647', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4519', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4564', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5117', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4428', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2020-0696', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-3086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3089', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2023-0622', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12167', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3129', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4455', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4457', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0114', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-0692', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4477', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-5001', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-0826', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4472', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-5002', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-3119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4962', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-4963', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4445', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-4446', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4447', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4449', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-4450', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0768', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1616', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-0627', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000414', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2014-3113', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-5113', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4517', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-4518', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-5115', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3177', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1229', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0140', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0141', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2013-4531', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4583', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4585', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-0145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5131', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1657', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1000425', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4469', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2020-0823', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1620', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4566', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-4524', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2022-0138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3091', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3092', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1000513', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000514', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-10158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000515', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000516', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0829', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4486', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5006', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-12180', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1625', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-12290', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12300', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-1000616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5125', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4573', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2016-1655', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-0827', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4474', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000507', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-5004', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000510', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12172', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-4465', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2013-4467', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0633', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5124', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-5127', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000617', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4572', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2022-0113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1000629', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1661', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5132', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000621', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4579', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4581', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000624', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000625', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1660', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000416', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4453', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-4959', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-4960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10145', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-4442', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3120', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1614', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2011-5144', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1664', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-4470', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5000', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2020-0825', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4473', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-4475', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-4471', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2022-0116', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-4496', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-4500', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-5019', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-4540', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4594', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4595', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000521', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-0848', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4451', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000421', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10150', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4460', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3137', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-0795', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10153', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2012-4464', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-4454', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-4459', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4458', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4459', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-3138', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-12171', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-12173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4598', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5148', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000636', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-5149', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4546', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4599', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4600', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000637', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5150', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5152', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5153', 9.2, 'AV:L/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2011-5155', 9.2, 'AV:L/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2011-5158', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4601', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2022-0152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000639', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-4548', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2022-0153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000642', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3198', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0872', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2012-4511', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2020-0878', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4516', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000534', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4517', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4544', 6.4, 'AV:A/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2023-0673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000635', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4450', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3196', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000424', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1619', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2020-0810', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5035', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4522', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-0932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000538', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-5047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4491', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4492', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000542', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4602', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5159', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4550', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-4603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4604', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4607', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000650', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1020002', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000651', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-3201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000654', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000656', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4562', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1020009', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1020010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4566', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2019-1020012', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-5177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5029', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10161', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0884', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-0891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4488', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-0933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000647', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-1000648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4608', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4609', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5172', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4478', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4480', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4483', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4484', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-0828', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000511', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000512', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1000501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5012', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4488', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4490', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4478', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-0833', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0847', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4503', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000540', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0961', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000543', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0124', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000663', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4491', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4492', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-4493', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-4495', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2018-1000520', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4502', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4504', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4505', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-5023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-0852', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000529', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4480', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4482', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-3154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5028', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-1000531', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000532', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3155', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5065', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5067', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-1221', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12214', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12225', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-1639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4570', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000669', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5185', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10201', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-5191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3243', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4461', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-5197', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000803', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4684', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-4689', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-5056', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5061', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4529', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-1638', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2011-5030', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2011-5031', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4485', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-5034', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-4486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12189', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1219', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-0892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0900', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-5036', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-0924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1632', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4451', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1020008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3209', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4565', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4629', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-1672', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4456', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-4571', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3227', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-4672', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000671', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3246', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4675', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4575', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4465', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4682', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4686', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4467', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-0164', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-5204', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-5045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1633', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12245', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-1641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-5208', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5209', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5210', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5213', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4701', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000817', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1685', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4506', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2011-5021', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5022', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0855', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12184', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4696', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5207', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5211', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000816', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4474', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3265', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10209', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-5216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000820', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-3272', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2020-10029', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000822', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-4582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000823', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-3275', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1687', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1000551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4500', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2013-4505', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2019-10171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-5079', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-10172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-5082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1226', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-5086', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5088', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5090', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-5094', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-1643', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1020015', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4454', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4667', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1020017', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-4669', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-5188', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2014-3222', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3225', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-10202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4460', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0158', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2011-5032', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-0123', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-10165', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4527', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-0972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4444', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10166', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5062', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5068', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1222', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-10177', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2018-1000601', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4551', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-5102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4555', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2023-0643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3174', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1689', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0172', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2011-5224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000831', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-4711', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0174', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1000535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-0895', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-0899', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4489', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4520', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2020-0925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-5048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5053', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-10164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4496', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4540', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4498', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2013-4499', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5078', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4501', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-5044', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3175', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-5110', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5112', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4522', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000808', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2011-5206', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4694', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2016-1682', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000834', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-4728', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4488', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3296', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-1000840', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-3301', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5245', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3305', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4747', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4753', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3326', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4761', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000848', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4777', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3337', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2011-5260', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4602', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1706', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-1000615', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12296', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5123', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4529', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5128', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4448', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-4578', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-4582', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2023-0663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3188', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12250', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-12255', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5093', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0130', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4548', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0131', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4549', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-10178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5099', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5101', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0655', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12276', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2011-5118', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1651', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-0178', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-1000836', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-1693', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1000544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12195', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-0971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-0976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-0977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4700', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4477', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4479', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000826', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4482', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000828', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-4483', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5222', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4708', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1690', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5057', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-0978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4528', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-12196', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000547', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-5069', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-12212', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000549', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-5071', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5072', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000550', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3166', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-5241', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4733', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-4489', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-4492', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0184', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3324', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3329', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1701', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000847', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3333', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-1702', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-4498', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3336', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4792', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1000606', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12267', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-4561', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5134', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000627', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3190', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4525', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-12292', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12297', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2023-0661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10214', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-5236', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4729', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2018-1000839', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4731', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-4736', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4595', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4739', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5064', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4495', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5073', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4534', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2011-5074', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4445', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5084', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4545', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-1642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1225', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-5083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000558', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5259', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4502', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4503', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4505', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2018-1000854', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1709', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4447', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4523', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-12285', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-12287', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2011-5119', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1652', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4539', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4592', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10194', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4596', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-5145', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-1665', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1000619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5130', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1656', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-5272', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4511', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3370', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-3385', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-4826', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-4635', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4830', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5286', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4839', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4841', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4847', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2011-5287', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5290', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-5293', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5295', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3406', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2011-5302', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4858', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4524', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4526', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5322', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4873', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3418', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10048', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-5251', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4754', 9.2, 'AV:L/AC:M/Au:N/C:C/I:C/A:N'),
('CVE-2012-4758', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4768', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1700', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3331', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-5257', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3339', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1705', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000602', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4552', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3173', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4512', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2014-3374', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3386', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-3387', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2011-5277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4516', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000863', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2012-4837', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-0648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12266', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-0652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000609', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0137', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-3178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000611', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1650', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12306', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4571', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4526', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4574', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4584', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-4586', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2022-0147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000622', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5133', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5137', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4536', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4537', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4449', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4591', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1662', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5151', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5156', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5157', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10197', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-4547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3197', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12302', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-1654', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-5292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5298', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4520', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-4521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4862', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4864', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4668', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-5326', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4889', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3422', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-4530', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4534', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2012-4893', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4538', 7.8, 'AV:N/AC:L/Au:S/C:C/I:N/A:P'),
('CVE-2014-3430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3434', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10080', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-5166', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000652', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-4556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4557', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3202', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1020006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3203', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000657', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4616', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000658', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3210', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000661', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-5176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3214', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0156', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5141', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2023-0665', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-0666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-5143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1663', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-5109', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10185', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2016-1648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4532', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2022-0221', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-4671', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3433', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4894', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000876', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3439', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2020-10081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4820', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1707', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-3449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3451', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5269', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-1000857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3368', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-1000858', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000860', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4515', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-5278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5279', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-4823', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3397', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-3399', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2012-4840', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-4842', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4650', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-5296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4848', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-1000865', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4587', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2022-0148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1658', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-10200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5163', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000645', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4552', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10082', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-1000881', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4693', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0685', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-0688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1725', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0691', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4923', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-0052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4933', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-4938', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0235', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1228', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12284', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12286', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12288', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-10187', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1000614', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-5122', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-4569', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12293', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-1230', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4576', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4678', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5202', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4685', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10086', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4907', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3204', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000664', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000665', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3215', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000666', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1020014', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4452', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1674', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10225', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-0697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-4853', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4857', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2018-1000869', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3411', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4653', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4528', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4867', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4662', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2011-5320', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3415', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4871', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4880', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4884', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3421', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2020-10078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4531', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-4536', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2018-1000874', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4537', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-3425', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3426', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000875', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4673', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4897', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4679', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-3442', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-3443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-1723', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000882', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4903', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4575', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5129', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0144', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-3187', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1000633', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4545', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3195', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-5135', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2011-5140', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4538', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4593', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0690', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-3464', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2012-4914', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4705', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4920', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4926', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-4555', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4716', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1001', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1002002', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1728', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-10229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1002008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3472', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2019-10232', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10237', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1002100', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4719', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4720', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1724', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4700', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000886', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0229', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-0012', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-0013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4912', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4706', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2020-10089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4715', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4929', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2023-0696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5187', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-4670', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-4671', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-3230', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-5193', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-4674', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3244', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5194', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4462', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4676', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-1678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-1667', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000626', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4535', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2011-5136', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-4589', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3191', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000640', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4549', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5164', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5167', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4610', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5170', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5171', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1020004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1000655', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4560', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1671', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2015-4473', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1683', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5146', 4.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2013-4542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5147', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-1666', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1686', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-4601', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10239', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3474', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4604', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4947', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10243', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4606', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4729', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2015-4607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10244', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1002103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4610', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4957', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-4613', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5162', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000644', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-3199', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4949', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-4724', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4726', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3476', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2019-10245', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-1002104', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4614', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1002150', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4745', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12310', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12313', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12317', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1002202', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-1232', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12322', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12334', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1002203', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-3481', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12341', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0705', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3248', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-4693', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3250', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4580', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-1002', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-4475', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1684', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000668', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4569', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-5183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1020018', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-1020019', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5189', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-4457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5192', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3242', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10203', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-1677', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4617', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12311', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2017-12314', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4746', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-12331', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12333', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12336', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-3482', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3483', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12349', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12352', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12356', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1236', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12364', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-12369', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-1002207', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-0712', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-10026', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4555', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1020003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4558', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-4612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1002005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4599', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3473', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1024', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4721', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000825', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-4706', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-1000830', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-3283', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2011-5229', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1691', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000638', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5154', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1668', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4707', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-5221', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4584', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0173', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2011-5223', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5225', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5226', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5228', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3287', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-1000833', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-5234', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4590', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4730', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2019-10216', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5239', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4734', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2011-5242', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4596', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000841', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4740', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4741', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3319', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2016-1697', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4493', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4495', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-0678', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5160', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5161', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1020001', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4605', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5165', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5169', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1020005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4559', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-4614', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1020007', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4615', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1670', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-1020013', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-5178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4453', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3216', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-4568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5180', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000667', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4578', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2011-5205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4469', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-1000809', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000812', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1002105', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4616', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1231', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12312', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1002201', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-12329', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-12332', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1234', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12343', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1235', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1002205', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4749', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12366', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10250', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10029', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12371', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-10031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4754', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0718', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-4772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5256', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-4781', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4791', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-4817', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4819', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3345', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3346', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2018-1000850', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2011-5264', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4609', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-5267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3362', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-0198', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2013-4617', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4620', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5271', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-5273', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3375', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5275', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0204', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1713', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4825', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4517', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4833', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4834', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4845', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2018-1000864', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10032', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0266', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4758', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0721', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4632', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3504', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2014-3508', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10272', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10066', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0727', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-4778', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-4972', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1239', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1241', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0729', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-4993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3520', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4644', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12375', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10033', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3493', 2.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-12379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4767', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10059', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3509', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10289', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-10068', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4640', 2.9, 'AV:A/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4781', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4976', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3517', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-10291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10073', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4991', 9.2, 'AV:N/AC:L/Au:S/C:C/I:C/A:N'),
('CVE-2019-10302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10304', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-4647', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5005', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12415', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5238', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4732', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1694', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10310', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4808', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10099', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-4810', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4813', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1020016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3219', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1675', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4703', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4480', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3277', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-1688', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1676', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4793', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5002', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5007', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-0286', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3531', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4655', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0742', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-4802', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10095', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10097', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12421', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4815', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12376', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10052', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4759', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4762', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-12378', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3499', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3503', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10278', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4633', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4974', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4982', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4987', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4988', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10072', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12410', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3521', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-4792', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2012-5000', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10084', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5004', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0739', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-12419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4799', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2022-0287', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3407', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5311', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3317', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2012-4743', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4744', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-1699', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-4756', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4760', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000844', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-10051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4499', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4787', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-0192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5265', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000852', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2013-4610', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4506', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4508', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-3366', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-5270', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2022-0200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4625', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0203', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3416', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3417', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4529', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0216', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3423', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-4535', 8.5, 'AV:N/AC:M/Au:S/C:P/I:P/A:C'),
('CVE-2013-4670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3431', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3436', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3437', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4678', 2.9, 'AV:A/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4900', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3450', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4551', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4667', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4822', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4670', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2023-0749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12430', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10317', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12442', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12444', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12447', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4674', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10321', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-1011', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5048', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-12452', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4683', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10327', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-4685', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3544', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3545', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-4852', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5055', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1765', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4699', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4869', 0.0, 'AV:N/AC:L/Au:N/C:N/I:N/A:N'),
('CVE-2018-10122', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3552', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-4873', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5063', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-4715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10205', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2013-4573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5195', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000801', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-4679', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5199', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4681', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000807', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4691', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0166', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3249', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3390', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-3395', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5276', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2011-5280', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4824', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-1715', 5.3, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2012-4832', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4835', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5288', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2011-5291', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-5294', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2011-5297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5299', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4850', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4851', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2011-5312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000867', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4859', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2011-5317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5318', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0213', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2018-1000883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-0226', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-4906', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000832', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0179', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-3292', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2019-10215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000837', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1000838', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-10217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4490', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4491', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3316', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-4745', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000842', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5253', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4767', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2011-5254', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3332', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2011-5258', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10233', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-1278', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3744', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10518', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-1839', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12784', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10520', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-12785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5211', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-12788', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3758', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12798', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4823', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-10102', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12427', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4835', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12428', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12432', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12441', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12443', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12445', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10319', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4673', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12448', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4677', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5196', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4840', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4682', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10325', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10115', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10118', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1033', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10119', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12439', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4671', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-12802', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0403', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-3776', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3777', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3781', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0407', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3342', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5263', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4504', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-4611', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4619', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0199', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-3369', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2013-4626', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3383', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-0205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3455', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4703', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10088', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-3466', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4918', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4556', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4936', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1727', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4559', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4588', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10226', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-1002000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1002003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4590', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4596', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4942', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4836', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3402', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5289', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2022-0210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5305', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5306', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5310', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4523', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1000870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4527', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-4866', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4661', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2014-3414', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000872', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3264', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2022-0167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0170', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3274', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-4704', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3276', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-4481', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2011-5219', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3280', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-10211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4710', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4485', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-3251', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4472', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000815', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2011-5214', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4581', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4476', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3267', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000821', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-4478', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-10210', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5217', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5218', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4705', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3282', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4709', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0175', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-5227', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4713', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2019-10213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2011-5233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-5059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10121', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4713', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3553', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2012-5065', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-12465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10135', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4717', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-12468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4725', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1034', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4890', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0219', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-4892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1000873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10079', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-4677', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4543', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4547', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10084', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3454', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10322', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-3797', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3800', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3802', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12847', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-1285', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12856', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-0073', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-0074', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0414', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-5323', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10553', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10554', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10563', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12869', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-5324', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5328', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2022-0426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12787', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5162', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-10527', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1840', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1280', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12800', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12806', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12811', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5178', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3796', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-1025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5185', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5196', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5309', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-5198', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5199', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-5319', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4714', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4486', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000835', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2011-5235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5067', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4724', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3560', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-12471', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4734', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12473', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4912', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4924', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4744', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-4930', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4934', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-10169', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3571', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5070', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0770', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4943', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4944', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-1249', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12494', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10190', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12500', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12507', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12513', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4952', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4758', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10352', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-3575', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4765', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-12523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12536', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10647', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10649', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3851', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12884', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3863', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5092', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1867', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12897', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3885', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10667', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-5333', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1897', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-1899', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-12909', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12921', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5352', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1907', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-12938', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0444', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-12944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10686', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-5220', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3892', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1916', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5369', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-12949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12953', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5383', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-5387', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-5390', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5400', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5405', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5418', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5433', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-1920', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-5457', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5238', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5467', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12985', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3898', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-3900', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4737', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4598', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1696', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3318', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3320', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-1698', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-4752', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3323', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-4757', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4497', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4773', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10052', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1703', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10053', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1704', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1000885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4701', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3465', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4958', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3579', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4771', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2018-10206', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4964', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-0311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1692', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-4877', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3424', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-4539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4672', 10.0, 'AV:A/AC:L/Au:M/C:C/I:C/A:C'),
('CVE-2013-4676', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4542', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4546', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-3452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-0224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000887', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1000890', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1726', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4924', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10090', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-4934', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4937', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0694', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-0051', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10016', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-4939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3469', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1002004', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4943', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4608', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3352', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4510', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1711', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1855', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5322', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0419', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1287', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12870', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12871', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12872', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3838', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3842', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10643', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3843', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10650', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2014-3845', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3852', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3864', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-3871', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5211', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1895', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-0077', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10111', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12453', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4844', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1762', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-4689', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5054', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4732', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4736', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4900', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4739', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-4927', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-4929', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-12474', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10171', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5069', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-1018', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10184', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5240', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5244', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4597', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3302', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4600', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3314', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-4742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1000843', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5252', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-4755', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4759', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4771', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4496', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4775', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4776', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4782', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3338', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2020-10054', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3363', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4507', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-12552', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2013-4969', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-10237', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12557', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1256', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12564', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0792', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-4811', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2018-10257', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-3603', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-10284', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1029', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10295', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0326', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4998', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5003', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0796', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12587', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0330', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4723', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-4725', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1002101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4954', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0249', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-1742', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1233', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12338', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-0707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1002204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4946', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4722', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4727', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1002102', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2014-3477', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4952', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4953', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4612', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4958', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2022-0251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10246', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-5248', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5528', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-12991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3907', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-5249', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5559', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3911', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5097', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4598', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-1023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-3471', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10238', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10242', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3475', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-4950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4728', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4730', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4951', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4608', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4609', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3382', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-3388', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-1000862', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1714', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-0207', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4846', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4519', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2011-5301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2011-5307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1292', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10581', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-10672', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5355', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10679', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1911', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5364', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2019-10685', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3891', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5223', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5376', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12966', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5420', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-5423', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5425', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-10691', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5450', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-5459', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2017-12977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1927', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5487', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-5506', 10.0, 'AV:L/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-1299', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5525', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-1000856', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4821', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1710', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10248', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1002206', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-12367', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-12368', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-10253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10254', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10260', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10263', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10051', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4761', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-3497', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10055', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2014-3498', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3505', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1238', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0724', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-0725', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-0274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4638', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4780', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2023-0728', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-4977', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4788', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-4789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4763', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2017-12522', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10195', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-3577', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-4768', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-4959', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4769', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-3578', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3580', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5078', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0802', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0803', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-10313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10314', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10326', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4825', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2019-10392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10393', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-0816', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-3623', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-5024', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-12619', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-10357', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5029', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5031', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10365', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4832', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4833', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-5048', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5059', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5056', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4697', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3551', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4706', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5060', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2012-5062', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0760', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4718', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2023-0761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-1247', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3562', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-4898', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4730', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-10342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5704', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-5706', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4168', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-10531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5083', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5098', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4845', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4854', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10405', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-12634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5118', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10404', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5119', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4861', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2020-10114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10423', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10425', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3655', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-12647', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3657', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3523', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4994', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-10083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0284', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2013-4911', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4922', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4742', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4745', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4748', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2023-0765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10167', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3569', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4754', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1035', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4940', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-0772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12491', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12495', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12505', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1781', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2013-4947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4953', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4762', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-12521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3576', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12528', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12529', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12530', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12533', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12534', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4767', 2.9, 'AV:N/AC:H/Au:M/C:N/I:N/A:P'),
('CVE-2018-10198', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5072', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4772', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2018-10593', 5.2, 'CVSS:3.0/AV:A/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-0456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4822', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1000861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5274', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3384', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-3389', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-3391', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-4633', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2011-5282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2011-5285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5300', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2011-5304', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2011-5314', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2011-5316', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4861', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4865', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5323', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4875', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4876', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4878', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4881', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4883', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4886', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4891', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4669', 6.9, 'AV:N/AC:H/Au:N/C:C/I:N/A:N'),
('CVE-2015-4533', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-3429', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4895', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4674', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3440', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2018-1000878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4899', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3444', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10083', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-4548', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4698', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-4699', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-0684', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1000884', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3456', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3461', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4704', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4909', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-5717', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-4198', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-5722', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-5725', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-4200', 6.9, 'AV:L/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2014-4202', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4205', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5113', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13669', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2029', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-1367', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-13670', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4219', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13673', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5114', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4234', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4236', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-2040', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2044', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5762', 4.9, 'AV:L/AC:H/Au:S/C:P/I:N/A:P'),
('CVE-2013-5769', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-5770', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2022-0546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4254', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5772', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-4625', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12346', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12348', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12354', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12357', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12359', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3485', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3486', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10249', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10251', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10027', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0716', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-10262', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4631', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0719', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-3491', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3496', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10057', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-3506', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3507', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10271', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-3928', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3930', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12345', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2015-4627', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12360', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-12361', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12362', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-10023', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0713', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0715', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-3488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10257', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12374', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10049', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10266', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0722', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-4768', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0726', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-3515', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10219', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12544', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4965', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-10228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4791', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2017-12547', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-10362', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-0777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10233', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0785', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5006', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4650', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0741', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-10421', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12653', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1266', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-12664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12698', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4873', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4874', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3663', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3412', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1000871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5319', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12380', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1029', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10071', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4985', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-0279', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0730', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-12414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4790', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2023-0734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-3524', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4797', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5003', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3939', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3942', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3959', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1963', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13022', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4971', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4989', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4992', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2018-10076', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10300', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12412', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0280', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-4643', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10082', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4795', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0736', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3528', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2014-3529', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-12418', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10307', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-4652', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-10092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1242', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10312', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4775', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10208', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10210', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4782', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4788', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2018-10223', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10230', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10361', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10364', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10368', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10241', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10242', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10243', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-0790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12565', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12572', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4807', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2023-0793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10296', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12581', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4995', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5001', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-10298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12595', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5569', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3922', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4917', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-4919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4928', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4932', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1002001', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1002006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1002009', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10231', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5117', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4266', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-4271', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2011-5324', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4872', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4874', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3419', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4882', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-4885', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2011-5328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2011-5329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2011-5331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4896', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4540', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4541', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4544', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2021-0001', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4680', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2018-1000880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4683', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-4901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4902', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4697', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2020-10085', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3453', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4702', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-1000888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1000889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4915', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0693', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1000892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-4921', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-4922', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-4930', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2012-4935', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1000998', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10224', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-4941', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0238', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1002007', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1731', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4944', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10233', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4800', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-1031', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4656', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10096', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12423', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-0744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4814', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4659', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12425', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4817', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4826', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4831', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2022-0290', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-5014', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3614', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-12599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10305', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10306', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12602', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1032', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5021', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-12605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5080', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2019-10391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4819', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4824', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2022-0335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-12618', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10360', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3625', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3629', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-10372', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10377', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5035', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2020-10096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5092', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4812', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4661', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4819', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-4666', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-4821', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-4832', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-12704', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4883', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4893', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-12707', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5094', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12711', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5100', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10438', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3668', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4899', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-10441', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-4904', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-4909', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-12713', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-0100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3970', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-0473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10612', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3974', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3977', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2021-0104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10614', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13029', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3984', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3986', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-4611', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-4956', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-4959', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-4744', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4615', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1002200', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-12316', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4620', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-12335', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-12344', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4628', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5252', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3941', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-3947', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-3956', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3961', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3963', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-4983', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4984', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10266', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1027', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12579', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1258', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-4986', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3604', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4987', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-3607', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-4997', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0797', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3608', 2.9, 'AV:A/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-10380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0332', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0800', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10383', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4841', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4849', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3637', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0829', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-3640', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4915', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10450', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10177', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4933', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4936', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5119', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4602', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10240', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4818', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12426', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4830', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4833', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4837', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4678', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3538', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5049', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-3543', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-12455', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-4279', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13709', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-13712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4290', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4292', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4297', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4300', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5276', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13716', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1372', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0564', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-13721', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13722', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-10744', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-4306', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-13735', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1374', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13741', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5122', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4676', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12451', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10324', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-5051', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4684', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-4687', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12456', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4858', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-3546', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4696', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-3548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10331', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-4704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2099', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0567', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-2100', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-2104', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5277', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13763', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4334', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5278', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13774', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13777', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10753', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-13780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4342', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4348', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-10594', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-10596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10597', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-10599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1060', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10758', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5279', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2111', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2016-1965', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-13028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1303', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3981', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2016-1970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5606', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-10637', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3999', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1981', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10407', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-0837', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12648', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10418', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-10429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10430', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4865', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2023-0840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10117', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-5086', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12693', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1270', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10303', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3615', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-10309', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-0809', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-10389', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-5079', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-10327', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4823', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2018-10350', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12610', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-10396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4827', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2019-10397', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-12616', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5026', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0338', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-5028', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-10400', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-0341', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10367', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1037', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-10374', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12625', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-5033', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0354', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10433', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5089', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-5091', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-5092', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2022-0358', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10439', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3669', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4898', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-4903', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5109', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3537', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2017-12440', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12365', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1002209', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-10028', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1237', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-4753', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3490', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3494', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-10267', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4766', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3500', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-3502', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-10277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-4969', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1007', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4641', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-4975', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-4983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-4990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-4996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-3526', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10306', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-4951', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-4959', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3679', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1272', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12730', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0371', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5131', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13032', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3988', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3992', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-10717', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2013-5601', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3994', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10719', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-0120', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10645', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-13050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-4955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4870', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10332', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-10333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3555', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-4881', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10128', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12467', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3558', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-4889', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4735', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3565', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4920', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4740', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2019-10343', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4932', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4935', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-10170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10172', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-0305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-1076', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10760', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-5784', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10764', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-10765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5280', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2121', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5061', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5066', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10336', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10133', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1772', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-10338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4887', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4727', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4731', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4921', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4926', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4746', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4749', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-4751', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12475', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10345', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10165', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12476', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10174', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4752', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-12479', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10187', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4938', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-4942', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-4945', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1019', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5046', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-5054', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-10097', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3635', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5099', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-4847', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5100', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5107', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4860', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3653', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-1042', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12649', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1043', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1265', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-10284', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-20001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-20005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0496', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-13086', 5.2, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-20008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-20011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1310', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13105', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13131', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13136', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-5618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13144', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3533', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4804', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10098', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-4809', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4811', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4660', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10100', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10314', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10101', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4827', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12429', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4677', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-10109', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10323', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12454', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4846', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-10117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10328', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-10329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12457', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3549', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4910', 2.9, 'AV:N/AC:H/Au:S/C:N/I:N/A:P'),
('CVE-2020-10138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10140', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-10174', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4913', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2018-10483', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4925', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-1018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4934', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4935', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10452', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4943', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-3675', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3676', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4947', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-4956', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2015-4958', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10460', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10461', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10462', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2015-4993', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4998', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3683', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5015', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5021', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2018-10494', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5134', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3996', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4013', 6.4, 'AV:A/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-13048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1305', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1993', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-13054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5611', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-13055', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13062', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5614', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13081', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-13082', 5.2, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-10372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-20006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13083', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10183', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12499', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4948', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4759', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5792', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5793', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-5795', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2125', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0593', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-2138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2017-13792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2012-5295', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5150', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5151', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2140', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5799', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5306', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5154', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10496', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3691', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3694', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-5039', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-3696', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5141', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12435', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1032', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10320', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1245', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12450', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4681', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12358', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12363', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1002208', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-4751', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-4630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12370', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-12372', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-3489', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-10193', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4766', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1254', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-10355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4961', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1783', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4773', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-4774', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-4778', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4779', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-3582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4790', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3586', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1786', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-12549', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2015-4796', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-12550', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2017-12551', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2013-4973', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10379', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13099', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13104', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13138', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13140', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10401', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10405', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10424', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5647', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5648', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5654', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-5655', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2020-10452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10740', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-10741', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10487', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10489', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10502', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-4030', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5672', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5676', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-0520', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4039', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1332', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1341', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1346', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1348', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1354', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1363', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4056', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4063', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4072', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4083', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4086', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4091', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4096', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4100', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4101', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4102', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4103', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5110', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4112', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2017', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-4134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4137', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4145', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5697', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5701', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0530', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0532', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-10467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5017', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-5024', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-5035', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5037', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-0383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3701', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3702', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-10503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-4868', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-12665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12671', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5087', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0847', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3662', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-10470', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-4878', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2018-10473', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5045', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1837', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3704', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3706', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10511', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2015-5065', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5066', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12556', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4974', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4805', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-4978', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12558', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12567', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1257', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4809', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2015-4812', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2018-10254', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10259', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10377', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-10297', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10378', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-5002', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-10379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0328', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2013-5008', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4813', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5009', 10.0, 'AV:A/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-5010', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0801', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5013', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0804', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5017', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5020', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0805', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-4816', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2018-10320', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4880', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10137', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4882', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4885', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3563', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0763', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-12472', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4738', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4743', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4747', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4750', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3567', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2018-10168', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3570', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4755', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3572', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-10349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3573', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-1779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-4941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1248', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12480', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12481', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12482', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12488', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12497', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12503', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12511', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4950', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12518', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4760', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4761', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-5308', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5309', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-12458', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5058', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4703', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4871', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10334', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2013-4879', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4158', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0534', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2021', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-2023', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4195', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4197', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4199', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2013-5738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4211', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-4216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-5744', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5745', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-4235', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-2038', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10543', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-10544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5273', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4248', 2.9, 'AV:L/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2014-4253', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4257', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2020-10554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4258', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4259', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-1368', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-10560', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2056', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2058', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4260', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2017-13682', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4879', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2015-4882', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0355', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5090', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-12708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10436', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5099', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5101', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4896', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4901', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4902', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-0359', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5636', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2020-10398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0515', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0517', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10482', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-10508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0519', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-10513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10743', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-5679', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-5687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4043', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4047', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1333', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1342', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1350', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1352', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2017-1355', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0525', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-2009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4061', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2014-4068', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4075', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10506', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1051', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5059', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5063', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1020', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10209', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4781', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4787', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1784', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10227', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1036', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1785', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-3587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-0317', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-4793', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4795', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4798', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10234', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5074', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-4971', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3596', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-0788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5321', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2151', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5159', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5325', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-5326', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2152', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2153', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2155', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-5162', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5163', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2016-2156', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5328', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4955', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-12524', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10194', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5071', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2019-10353', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4962', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-3581', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10201', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4776', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10207', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10211', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10213', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4789', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3584', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0313', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-12545', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10359', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2017-12546', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2013-4968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12548', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-1062', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3737', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2020-10227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5197', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5078', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3741', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4265', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-4269', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-5118', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5120', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13696', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5777', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4274', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2020-10573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4285', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3620', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-10329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4821', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1034', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10394', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-10395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5081', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10398', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5082', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10364', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4830', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-5150', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4098', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10517', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4106', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4122', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-4126', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4133', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4140', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-4152', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4153', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2022-0531', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2020', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4167', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2022-0537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5269', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2026', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5726', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10537', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5270', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4207', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-4209', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2018-10245', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4979', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-3600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4810', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5076', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10375', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10267', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10286', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5000', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12588', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12596', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10382', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2015-4815', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-5019', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4818', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2018-10312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10316', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10265', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0720', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-3492', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10058', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4769', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-0723', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-3513', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2019-10273', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10063', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4637', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-4639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-4970', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1240', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3518', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10292', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10075', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3522', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2012-4995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3525', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3527', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-4798', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0740', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-4651', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-4801', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3532', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0743', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-4657', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12422', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4820', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2015-4668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4669', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10316', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12431', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1771', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-4716', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10136', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10138', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3559', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-12470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4729', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2018-1014', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3564', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4737', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-4741', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-3566', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2013-4931', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4936', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1255', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4792', 2.9, 'AV:N/AC:H/Au:M/C:N/I:N/A:P'),
('CVE-2014-3591', 3.6, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4800', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2018-10236', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10365', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0780', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-0783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3593', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2018-10238', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10367', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10244', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1025', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-12559', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3601', 6.9, 'AV:A/AC:H/Au:S/C:N/I:N/A:C'),
('CVE-2018-10521', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-5208', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-12789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10240', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-12791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5222', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-10243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12799', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10534', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12805', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5227', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2018-10540', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3780', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1283', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-3782', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-12839', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2012-5183', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2020-10245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12844', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10546', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3742', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10236', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2012-5155', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-12849', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5188', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12852', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1286', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3824', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4213', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4214', 2.9, 'AV:N/AC:L/Au:M/C:N/I:N/A:P'),
('CVE-2014-4223', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4227', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4229', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2022-0541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2041', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2046', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4240', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-4243', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2014-4246', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-4252', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2047', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2051', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12434', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3536', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4675', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12449', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-4838', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3542', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-10326', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-4688', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4854', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-4694', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2014-3550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12459', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10120', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5051', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5097', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-12629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4842', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3636', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-12630', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4857', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2017-12631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0832', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-3642', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-10391', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10253', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10256', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10268', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10294', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0795', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-4988', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-4999', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12583', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1038', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3609', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10300', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5011', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10302', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5016', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2019-10385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10307', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10311', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10321', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3621', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5353', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-13795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10798', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-2164', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1080', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-5802', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2167', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-5358', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5361', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1081', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-2174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10846', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5774', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-4267', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5275', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13697', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4826', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-10355', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12620', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10358', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-12622', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-10362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10368', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10373', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10401', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3632', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2019-10402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5163', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12804', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1281', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12823', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12836', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5300', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3791', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5087', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10254', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5305', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3805', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5197', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5315', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-5317', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-1063', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12860', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10549', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13710', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2072', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10578', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4288', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-4293', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4294', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-2073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0563', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5778', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4303', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2016-2084', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-4304', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2087', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-10582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13723', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4307', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13729', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13731', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13733', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13736', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13744', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13756', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13760', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5780', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-5124', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4329', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1075', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10566', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12875', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5090', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10646', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12879', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10571', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3856', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12883', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2012-5207', 8.5, 'AV:N/AC:L/Au:N/C:C/I:P/A:P'),
('CVE-2014-3865', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2022-0432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10166', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10176', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4753', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4946', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12487', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12498', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12502', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12508', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12516', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4757', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-4954', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-4956', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-1782', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10428', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3661', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5022', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1261', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12615', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12617', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1262', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10359', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-10399', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-3627', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5032', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10371', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4835', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5034', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3633', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2023-0821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5045', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2013-5052', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5095', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4840', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10379', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1370', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13706', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-10335', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5064', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-3554', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3556', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10337', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12527', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12532', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12535', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-12672', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12675', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-1012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1268', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12691', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5088', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4870', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-4876', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2022-0352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10431', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-3664', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4884', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4888', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4892', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0357', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4895', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-5096', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-5097', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10477', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3823', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5089', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5201', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3829', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3830', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12867', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5202', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10564', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10565', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0424', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10640', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10654', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3849', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-3854', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12881', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5367', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-2176', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-10847', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5179', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5180', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5373', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-2180', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5049', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5057', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5091', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4839', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4850', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-5106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4856', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-3639', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5112', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5113', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10408', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10105', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4859', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2020-10109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4337', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1378', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10754', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-4341', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4343', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-4345', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2019-10756', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10600', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-10602', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2109', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2076', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2016-2082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2086', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2094', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2097', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10589', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2098', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-13732', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13739', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13745', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1375', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13754', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13761', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13764', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13766', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4326', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4330', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2106', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10382', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0831', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-12632', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-3641', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2020-10104', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1039', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5114', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-0833', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5116', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-12638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3651', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12645', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3654', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10417', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10116', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-0344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-12908', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12920', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12924', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0442', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-10586', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10676', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-1294', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3894', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5365', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5371', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1917', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12961', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5393', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5401', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5440', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1919', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5453', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2022-0451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1922', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5355', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2012-5357', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2169', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-5172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13797', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4721', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3561', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4728', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4733', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10406', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4863', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10420', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0345', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10118', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-4866', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2018-1046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12654', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10423', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12680', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12697', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4872', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-10429', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0351', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5206', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0430', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1866', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1894', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3883', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10666', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5213', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-12900', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5334', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12907', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12912', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3888', 8.5, 'AV:N/AC:M/Au:N/C:P/I:P/A:C'),
('CVE-2019-10682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-1914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2017-12948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5380', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12962', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12964', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12971', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1918', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5427', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5443', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5461', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2112', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10759', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5785', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5786', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-2118', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5130', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2120', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5789', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3583', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4786', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10220', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10221', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-4966', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-4967', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-10231', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4794', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-12555', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3594', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-10240', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-4803', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4804', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3597', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10250', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12560', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12561', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12563', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12566', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3602', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4808', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2018-10255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0322', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10134', 4.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2018-10478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3670', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3672', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-10136', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-5110', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10612', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2012-5385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5185', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10855', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0620', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5391', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5188', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5409', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5191', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10619', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-2183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5416', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-2184', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4336', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13776', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13778', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5127', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2108', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2110', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2114', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-13783', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0574', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-0575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10445', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5112', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2171', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10845', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-5174', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2175', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5176', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-5368', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0614', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5371', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10610', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-10851', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5804', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-2179', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5376', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-12980', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12986', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3902', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-1938', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-3906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3908', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-5554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12995', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3909', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3912', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-12998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1300', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5578', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1951', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2014-3924', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5582', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3925', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5587', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-5098', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-12666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12673', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1047', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1269', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5136', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-10426', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10427', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4877', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2019-10430', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10128', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4880', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4887', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3665', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2124', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5791', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2020-10606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0591', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-13791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10782', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5143', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-0594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4923', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4925', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-4928', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-4933', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1778', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4756', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2018-10186', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12490', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12492', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12496', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1250', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12504', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1251', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-4949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-4951', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4764', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-12520', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12525', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12526', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1253', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-0061', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10196', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-0062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10354', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5116', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4363', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5788', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1077', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10773', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5132', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1379', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-10778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5790', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-5133', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5794', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5796', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-0590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5134', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5106', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10135', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2012-5108', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10447', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4916', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4921', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-4926', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-5118', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4894', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2020-10130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3666', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4900', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-10479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10442', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-4906', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4912', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-5111', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12978', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0452', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2012-5381', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2019-10853', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5394', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0623', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-5190', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2020-10618', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1062', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5417', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5195', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5424', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-10622', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5198', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0871', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-0333', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-12601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3616', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3617', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-3618', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10319', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0818', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12614', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-0364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4940', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4944', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-10485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10454', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-0368', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5429', 6.9, 'AV:L/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2015-5199', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5200', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2012-5450', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10869', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5809', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10871', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10873', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-2187', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-4963', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12543', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10205', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-4777', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4780', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10212', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-4783', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4784', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-4785', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1022', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10222', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0775', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3589', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-4797', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-5073', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-1789', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-12553', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-0787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4802', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-4806', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-3598', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-0319', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-5292', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5149', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2022-0597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5152', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5300', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5798', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5301', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5305', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5307', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-2145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2146', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10784', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-0595', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5145', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-5287', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5146', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0596', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-5147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5148', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5797', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-5303', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2142', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5800', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-0601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-5160', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5161', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12717', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4957', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5123', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4905', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-10444', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-10146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4914', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-4919', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4924', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4927', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10484', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4941', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-4942', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-10453', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5120', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5117', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1941', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1942', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-10598', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-1947', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2013-5560', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2014-3916', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5567', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2013-5571', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0461', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-5201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5203', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0630', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2012-5472', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-2190', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10877', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-1063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5810', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5811', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-5204', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13803', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5476', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0632', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5477', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-5208', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2012-5480', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2012-5484', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5210', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-5812', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2013-5813', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2022-0635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0636', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4974', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4987', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-3680', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4996', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5005', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2022-0372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1834', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5036', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5137', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4928', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-10486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-5121', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12586', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0798', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10301', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0799', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5077', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-5012', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-5015', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3613', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-10384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4843', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4846', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2020-10100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3638', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10102', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12633', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10409', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-10108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10405', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5123', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-4862', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-12646', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10419', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-4864', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0842', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-12650', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1044', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10457', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-12719', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10458', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-4971', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-10488', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1833', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5001', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-5003', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3686', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10466', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2012-5130', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5158', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5318', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5324', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4949', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4950', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4960', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2015-4962', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4980', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4953', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-10487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4964', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-4981', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4988', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2012-5126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5327', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-2154', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5801', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5329', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-5330', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5331', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5332', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5335', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-5165', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2157', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5336', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-10793', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2012-5337', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5339', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-5340', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5344', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5346', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5348', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2158', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5002', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3681', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12732', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0373', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-13011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3943', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-10610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1958', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-3946', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-13015', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13016', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10707', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10709', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13017', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2203', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0639', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2204', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-2206', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5214', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5816', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5217', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2023-0890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5221', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5498', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10883', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0907', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0909', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5504', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5506', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5127', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10792', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2012-5338', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-10794', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2012-5341', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5345', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10795', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-10608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5349', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-2159', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-2160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5167', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5168', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2162', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5350', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-5169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-0606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3619', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10310', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10318', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10322', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5011', 4.9, 'AV:L/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2018-10492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-5016', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5023', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-10191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10498', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5140', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4867', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0846', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12676', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10424', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12692', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12699', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-4875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10122', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2015-4885', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-12706', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-10131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12710', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5148', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3667', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-10708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10495', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3692', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12740', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10477', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-10499', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10195', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-0388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10500', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1052', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3703', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-10203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10502', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5128', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5143', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5009', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5013', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5020', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-0379', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3689', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5454', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5456', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0629', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5019', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2018-10493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12612', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12613', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-10354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4828', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-0819', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5025', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-12623', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10361', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10363', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-3626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10366', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12624', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12627', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5047', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-12628', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5093', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5094', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5096', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-4836', 2.9, 'AV:N/AC:M/Au:M/C:N/I:N/A:P'),
('CVE-2015-4838', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4844', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4848', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4851', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-4852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10380', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4858', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-5084', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2022-0390', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5146', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-10718', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1062', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10621', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0485', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-10723', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10476', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1274', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0384', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1051', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5142', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5354', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5356', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2019-10803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5104', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10446', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-10143', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0361', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3693', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5138', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-1056', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10508', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3709', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12759', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5070', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5072', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3739', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2020-1023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5151', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10661', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-5240', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5242', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-5512', 4.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2020-10663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-10899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0921', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-3990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10716', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-0108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0482', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-10620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5602', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5196', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3710', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-3735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2020-10223', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-10229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12774', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0392', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4023', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10654', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1989', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5479', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-2195', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5211', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-0634', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-2198', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5212', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2202', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2205', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5814', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1381', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2163', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10799', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-0607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3695', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5139', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10451', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4930', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-4931', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4932', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3677', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10455', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-10456', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-4955', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4961', 1.4, 'CVSS:3.0/AV:A/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4965', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4967', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-4973', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12729', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4989', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4992', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4997', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1049', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5052', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5195', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5057', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10507', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-10512', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5061', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-1059', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5069', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10222', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-5074', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10514', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12763', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10806', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-2170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10842', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5803', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2019-10844', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0613', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-5175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10849', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0867', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5181', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5523', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-2209', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2019-10908', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5533', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5537', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-5253', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-5543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5545', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-5548', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5549', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5552', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5556', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5559', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-5256', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0672', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5562', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13049', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10650', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1987', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13052', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13059', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1995', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5105', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1996', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-5261', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1050', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-10199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5049', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-5054', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1055', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10504', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1275', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5062', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2020-10211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5171', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-12810', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5176', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5086', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5179', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1284', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3787', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0408', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1997', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1999', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13070', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-20004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13078', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5106', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0497', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2014-4024', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13106', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10381', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-5635', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10400', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1315', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0516', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10458', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-10462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10479', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10484', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10486', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10490', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10491', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10496', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10499', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-1327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10504', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10742', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5109', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5198', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-1052', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5156', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2166', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-10802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0835', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2014-3649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1264', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1041', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10424', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5085', 0.0, 'AV:N/AC:M/Au:S/C:N/I:N/A:N'),
('CVE-2023-0838', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-3660', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0844', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1045', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12670', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12674', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12677', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5135', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4871', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-12702', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4881', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-4886', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2020-10129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-4890', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-5493', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-5219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5220', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10649', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10650', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5499', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5227', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10884', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2207', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5502', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-10888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5503', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1066', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5234', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10491', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5006', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5014', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5133', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1276', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12776', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10516', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-5081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5082', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12782', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10237', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5158', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-12790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-10523', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3759', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0396', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-5167', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5168', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10537', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12812', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10538', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2178', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10852', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5378', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-5379', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-5382', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2013-5805', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10854', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5186', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-5389', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5390', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10856', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0621', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1380', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5395', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0624', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-5194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2185', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13073', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13087', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-13100', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1312', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5642', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5830', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5263', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5567', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5831', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-5265', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-5569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5570', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5571', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5266', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5572', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-5267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5573', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-12775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5153', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2168', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0377', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-0378', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-10192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5136', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5199', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12792', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12794', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5216', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-12796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5225', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12809', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-10539', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1282', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12838', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5180', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-5182', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3790', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-3793', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10251', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5187', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-10547', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1854', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10550', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3833', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5325', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3836', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0425', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2014-3750', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-3752', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5161', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-3753', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-10522', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5221', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10535', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10536', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5172', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5228', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5301', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-3798', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5302', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5303', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1849', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-1836', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10497', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3698', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5041', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-5043', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5053', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5144', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10848', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5645', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5660', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1320', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10457', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-1046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1324', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10480', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10481', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10493', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10494', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-1050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0518', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-10503', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-4027', 2.9, 'AV:A/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-5832', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5837', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2012-5575', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-5271', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5272', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-0681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-0934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5273', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-5274', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-5838', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4452', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10911', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5578', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5581', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5444', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2186', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1271', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5098', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5102', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4908', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4911', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0363', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-4917', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-4923', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-4929', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-4938', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4945', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-4946', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-3678', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-4954', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-4963', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-4966', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5507', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-5508', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5241', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5509', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5243', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5244', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5823', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1383', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-5252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-10907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5529', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2022-0669', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2012-5531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3844', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-1859', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3853', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3855', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3857', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3860', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5330', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1289', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2014-3877', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3882', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5212', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-3886', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-5093', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1291', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12910', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12927', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10583', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1904', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-5359', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1913', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5453', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10626', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5468', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5470', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-5471', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5473', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-10876', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0872', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10878', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10879', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5474', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10632', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5481', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5483', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5485', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10635', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-0877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0638', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-4415', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0880', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5489', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5490', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5491', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-10643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0889', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5492', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5218', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-12817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5177', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5229', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-3783', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-3788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3789', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12843', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-5306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3808', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5311', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5088', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5377', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-5380', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2012-5383', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-5386', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5387', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5388', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-0869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5806', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5189', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2023-0870', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-10866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5807', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-5808', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2019-10867', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4038', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5690', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-1335', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1338', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1345', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5266', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1364', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4055', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2012', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-5694', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4066', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4071', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4080', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4087', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4088', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4090', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4099', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4104', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4105', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4123', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5700', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4040', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0521', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2014-4046', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1334', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1339', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5692', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2017-1356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13649', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4050', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4052', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4065', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4073', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4077', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4084', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2016', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4093', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4094', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4097', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4107', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4108', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4110', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4116', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4124', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4128', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0529', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4138', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5267', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4156', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5705', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-5708', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2022', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-1365', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4190', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2020-10535', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-4201', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4203', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-2028', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-13668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4221', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-4226', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2017-13675', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4228', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5271', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3803', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3806', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5310', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0413', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5277', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5584', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-5587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5588', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2012-5589', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2016-2211', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5604', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5605', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-5840', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5124', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3807', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5313', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3828', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3832', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12868', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5326', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5327', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12874', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5058', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2018-10509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3708', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-5060', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5068', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12758', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12761', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1838', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5224', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1295', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12954', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-12958', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12959', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12960', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5394', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-5397', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5228', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12974', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10689', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5417', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5230', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5444', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5448', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5452', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-5237', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1924', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1926', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5243', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5486', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10591', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-0453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5542', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5553', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-5557', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2023-0929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1858', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5329', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10573', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3859', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10574', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5091', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-0436', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5332', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1900', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-12932', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1902', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5357', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10587', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0443', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10185', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-10489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-4990', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-4991', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-4994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5004', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-10464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3684', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2018-10490', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5022', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-10473', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5495', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5497', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5223', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5225', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5500', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10885', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5232', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0914', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5233', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-0916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10659', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-0658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5505', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10660', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-10895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5820', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-5237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4233', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-2039', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2045', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4238', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-5766', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13677', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5272', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4245', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2022-0545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2048', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-10552', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-13678', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13679', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2057', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-0549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-13683', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2025', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5715', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4189', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5716', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-5719', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-5721', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-5724', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2027', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4206', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2017-13666', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13667', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4210', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4212', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-4218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-13671', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5748', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4237', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-2037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5749', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5751', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5764', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-5768', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2020-10549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4247', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4251', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4255', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5773', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2052', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2018-10572', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12882', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3862', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-3870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1864', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-12894', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5214', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1898', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12905', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-12922', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5353', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5356', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5094', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1059', 4.0, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2012-5225', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5226', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5370', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12952', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5382', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-12963', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12967', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5402', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-12972', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-5409', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-5414', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5416', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5233', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-5431', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-5445', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5447', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5454', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-1923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5465', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-1026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1857', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3835', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-3837', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-12873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3840', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-5204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10644', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3848', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3850', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3861', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12885', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3867', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3876', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1277', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-12778', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-3743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12781', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0393', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-0552', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4261', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5040', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3697', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2020-10196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5042', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5044', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5051', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-3707', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-10505', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2012-5145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10897', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10900', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5246', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10902', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0922', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0665', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2012-5519', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5521', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5522', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2019-10905', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10906', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2012-5524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3878', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3881', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1876', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1290', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10668', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10580', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12911', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12934', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-12937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5358', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-12940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1912', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10687', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5222', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10688', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5373', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5375', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5379', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-12956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5391', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5398', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5406', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5411', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5421', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5424', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5429', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-5438', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-12976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5449', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5455', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2012-5234', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2018-10590', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5464', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-5468', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5488', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5490', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-5508', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2019-10694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10264', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12982', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5494', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-12988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5096', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5530', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-1940', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-1943', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2018-10595', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5557', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2016-1950', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3926', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3927', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10513', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5073', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-10224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3740', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-5152', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5261', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-2210', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2023-0931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12989', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5531', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-1939', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5614', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-13856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5625', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-0699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5303', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5627', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5630', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-5304', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-5633', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3903', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-12990', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-12783', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5084', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-0670', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-5255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0671', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2012-5560', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-5561', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10909', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5563', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2022-0673', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-5825', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5826', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5829', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5260', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5262', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-5264', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-10672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5568', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0406', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-10545', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-12840', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3801', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2022-0409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10252', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2022-0410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1279', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3755', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-10529', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5166', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-12797', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1053', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5169', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5170', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-5404', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5407', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-5422', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-5458', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5460', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-5240', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5466', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-3896', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-1933', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-3897', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10265', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2017-12987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4268', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-10568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1057', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-3935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5591', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0466', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-5851', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5641', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5642', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13864', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-0963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4468', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2280', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2281', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2012-5647', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5648', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5859', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5651', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5860', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2012-5654', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-5868', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-3804', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5192', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5316', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10548', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-3810', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-3811', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5200', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1948', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-12999', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3920', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-13001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5276', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5583', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-5585', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-5586', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2012-5591', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5603', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2019-10912', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2016-2212', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5606', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5841', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0685', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5558', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-12997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3914', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13802', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5451', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-5452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5458', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5459', 10.0, 'AV:A/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2188', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5568', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2018-10602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5250', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5572', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-5576', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-13003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5251', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5469', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2193', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5207', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2023-0874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5209', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5478', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2012-5482', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2016-2196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2197', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5486', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-5487', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-5213', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-1064', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-13004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5589', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5656', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5315', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10691', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2013-5874', 2.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-0976', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5879', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2013-5881', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-5660', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5662', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-5882', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2013-5886', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5887', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5889', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5317', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-13707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1371', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10577', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-4287', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-4291', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4296', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4298', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-2075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1058', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5779', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-2077', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2081', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13720', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-10581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2089', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2091', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2015-5123', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13727', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13737', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13740', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13742', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13755', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13758', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2103', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0569', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-13767', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10751', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0572', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5590', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13010', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-0090', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1962', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5254', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1302', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3960', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-0098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13025', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5597', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5255', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3973', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-1968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3982', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-3985', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5279', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5282', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3866', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5209', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5331', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-12896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3884', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3929', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-3931', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3933', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-1954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5099', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-3944', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2021-0094', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13019', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0887', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5817', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5496', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5222', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2019-10882', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1065', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5818', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-0899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5501', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0905', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10886', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2208', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2013-5819', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-0918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0919', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-5235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1382', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-5822', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-3966', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-1966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0476', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5599', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2228', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2242', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5847', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5612', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-0952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5291', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5848', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2272', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2275', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1092', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5295', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-0955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0957', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2012-5622', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5297', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5849', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-0698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4465', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-5299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5301', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2022-0702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5629', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5306', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5850', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5636', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4466', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5667', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-10699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4473', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0993', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-10700', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5894', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2020-10701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10702', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5896', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5897', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-5901', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-5674', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2023-1003', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10619', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13036', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5257', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10624', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5103', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13041', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5603', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5258', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2217', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5608', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5285', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2221', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-10674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10913', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5287', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-0948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2226', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10915', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5844', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1008', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5905', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2020-10704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5906', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2020-10705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10709', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-1019', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10929', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2307', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5909', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2014-4477', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5102', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-0106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1975', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-0112', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2107', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2113', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-2116', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0950', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5846', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2268', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2012-5615', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2277', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5616', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-1386', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5619', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0696', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12906', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12925', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1293', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12933', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1903', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-1908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10678', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1910', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-5217', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-1915', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-12947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5372', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-5378', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-5381', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-5389', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1297', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12973', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-13020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5596', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-0102', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5101', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1967', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-13027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3975', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-3980', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10613', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10615', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-5256', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13033', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10898', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5247', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5250', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2020-10665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5251', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2022-0706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0707', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-0960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5853', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-0968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10686', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-10687', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-0970', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5857', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2013-5858', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-5652', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10646', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1983', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5259', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1992', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13060', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13068', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10292', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-0493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13080', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-20007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13090', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2001', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-0501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0972', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10689', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5655', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0712', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-5867', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5312', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2023-0973', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-0975', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5658', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5870', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5871', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-5873', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5877', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5880', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5316', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0978', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5884', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2290', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5888', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5666', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5668', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-0985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-0987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5891', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2020-10697', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-10715', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5932', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5934', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-5937', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10934', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2317', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5329', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-10718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5943', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10719', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-5592', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3945', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2022-0467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0488', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-10651', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1986', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1990', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13051', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13053', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13063', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5260', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5612', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0486', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10904', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5824', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5526', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-5530', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-5534', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5538', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2012-5539', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5254', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5544', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5547', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5550', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5554', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-0928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1043', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5337', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2335', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5339', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2344', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10723', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2350', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1065', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-2351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2353', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1068', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-0724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10729', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5308', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5852', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-5311', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10685', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-0969', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-5854', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-5856', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2014-4469', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-0971', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5653', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2022-0713', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-13866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5415', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5426', 6.4, 'AV:A/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-5430', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-5456', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5242', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12979', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1931', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-12984', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-3904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-10594', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-12993', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-12996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5604', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10649', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-0472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-3971', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2013-5598', 8.5, 'AV:N/AC:M/Au:N/C:C/I:P/A:P'),
('CVE-2012-5671', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5319', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5892', 6.4, 'AV:L/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2013-5893', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-10924', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5895', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5898', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-5900', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5902', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-5673', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4474', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0726', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-1073', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5951', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-5348', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1071', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-5955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2363', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5679', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2364', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5680', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5959', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2012-5683', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5961', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5962', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-2367', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5685', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5963', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5964', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2023-1072', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-5610', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13056', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1306', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-20002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-20003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0495', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2017-13077', 5.2, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-13084', 5.2, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-13088', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5262', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13098', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5107', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-13108', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-20013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5619', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5259', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2022-0674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3978', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-1969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5600', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-1972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-1973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13035', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-3995', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13038', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10721', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1304', 4.7, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2014-4470', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5878', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5659', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2020-10693', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-5890', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2022-0714', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2300', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-1004', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1006', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-2301', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-5322', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4475', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1018', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10710', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1301', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-1955', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-3938', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-1957', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2014-3949', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5100', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5966', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5691', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5692', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5968', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5695', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5972', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5975', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2373', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5977', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-13141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5650', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2017-1318', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1319', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5651', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10732', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-10734', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-5672', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-4472', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10698', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-0989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-5320', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-20012', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-13101', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1311', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13135', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1314', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0508', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5641', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-10930', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2308', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2013-5910', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-5911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10712', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2023-1022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-5913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-5914', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10713', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-1024', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-5676', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5917', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10714', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5325', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5918', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1026', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2312', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5919', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-1976', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2015-5268', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-5835', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5836', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5574', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5269', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5576', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-0933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5605', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-0129', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10647', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5104', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10652', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-1985', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-10655', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10657', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-1994', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-1978', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-5607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5700', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5375', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2378', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5378', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5990', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5991', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-5992', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5993', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5994', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5995', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-5996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2380', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-5757', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5999', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-5766', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-5380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5767', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5770', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-0995', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5899', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2299', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-5321', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-5904', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2302', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2303', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-5907', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2304', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-1017', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5323', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-5842', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5284', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2213', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2216', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5607', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-5843', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-0944', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-0945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-0946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0686', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-2222', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2012-5609', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-5286', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2016-2224', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5610', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5611', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-5936', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-1027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5330', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1028', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-2324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5335', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-1035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2329', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2330', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13884', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5661', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10488', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-1049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-10510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5673', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5680', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4044', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1331', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1337', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4048', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1357', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-4049', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-4058', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2014', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-4070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4078', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-4081', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4476', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10711', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-0147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-1998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1035', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1308', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10378', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-0503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-20014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-20015', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5264', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0512', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-10399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5646', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-1317', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13079', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1309', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5263', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5332', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-5333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1029', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-2326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2327', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1045', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-10721', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2336', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2340', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-1055', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2345', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10727', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5343', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-10728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2225', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5845', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5288', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2022-0689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-5289', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2022-0691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2233', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10917', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5613', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2022-0693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5292', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2023-0953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5293', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0695', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5296', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2012-5777', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5783', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-5383', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1086', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1087', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-10936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6005', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6006', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4501', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1089', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-1398', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5402', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2392', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-5403', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-6018', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4503', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-4505', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2397', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5406', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-5408', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2013-6024', 6.9, 'AV:L/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2023-1093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-5410', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10746', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2014-4515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5413', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-13999', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0717', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-2334', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2337', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2342', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2343', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5677', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2346', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5341', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10724', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5342', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-10725', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-13885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10726', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2354', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5344', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5346', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0727', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-5653', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-5656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10735', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10485', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10492', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10500', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-4036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0522', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-1347', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1349', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1362', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-5693', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4057', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4062', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-4082', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5345', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2355', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1070', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2013-5952', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10731', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-5953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5350', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5678', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5954', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-5956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4111', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4117', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4129', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4130', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4132', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4143', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4149', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5698', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-2018', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-2019', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-4163', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4164', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4166', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5268', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-20018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13143', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5108', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1322', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-10453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10459', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1325', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10483', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-5265', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5624', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-10683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0700', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5300', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5628', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2012-5631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5305', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2022-0703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5635', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-10684', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-0705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-0958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-0962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5307', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-5347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5349', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5353', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5354', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5957', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5960', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2366', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5688', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-5689', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2013-5965', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2369', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10732', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2017-1326', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1328', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-4031', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4033', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5671', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5688', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-4045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1336', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1340', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-1353', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-1359', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4051', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4059', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4067', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4079', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2015', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-4089', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5723', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13672', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4231', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5649', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5650', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5869', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2288', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5657', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5314', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2289', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10752', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4521', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14010', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4524', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14017', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1104', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1105', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-10949', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-4085', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4095', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-0527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4109', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-5695', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4121', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4127', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4141', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4151', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5111', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0536', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2024', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4174', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4188', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-13652', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-4194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-5718', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-5720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1366', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4204', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-10538', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5739', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4208', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-4217', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4222', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2016-2030', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-13674', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4230', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4232', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2043', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5750', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5761', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-5763', 2.9, 'AV:L/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-5765', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-5767', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-2034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2042', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0544', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-10548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5115', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4249', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2049', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10553', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5116', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-13681', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5274', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13689', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4263', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-5976', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5979', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4532', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5837', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-0981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4471', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5669', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-5318', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-10923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-0994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5381', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6000', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5781', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6001', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6002', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-6003', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4270', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-5119', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5771', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2014-4244', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2014-4250', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-4256', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13680', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-13685', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13688', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1369', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4262', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4264', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-13690', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13692', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5776', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-10570', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-0998', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-13870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5675', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1010', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2305', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2306', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-5908', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2013-5912', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5324', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5693', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5694', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2372', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2012-5696', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5367', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5790', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6009', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5815', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2390', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-5401', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6016', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-2391', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13986', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13991', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6017', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4506', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2016-2393', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4507', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-6022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2399', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2402', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5409', 7.8, 'AV:N/AC:L/Au:S/C:N/I:P/A:C'),
('CVE-2020-10744', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2023-1094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2406', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6028', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5829', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10575', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-10576', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0561', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4289', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2022-0562', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4295', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4299', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2020-10579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2079', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5122', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5915', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-5916', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10933', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5935', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-5938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5942', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10717', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-2316', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2318', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5331', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-10935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4479', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5336', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5429', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4540', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14031', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4541', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5431', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4543', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14037', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10770', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-10771', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2022-0741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5433', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-5839', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5369', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2376', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5984', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-5701', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5769', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2012-5785', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2387', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5786', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2389', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5816', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-1395', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5817', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-1396', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2012-5824', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-5827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13985', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13988', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2078', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2088', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2014-4305', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13726', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13728', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-13730', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13734', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13738', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4309', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4310', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-13743', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-13749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4311', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-13757', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13762', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4313', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-13765', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5340', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2347', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2349', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0720', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-5355', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-5958', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5356', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2365', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2368', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5690', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2370', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-5967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2371', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5971', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5365', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-5697', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10734', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-5698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5368', 7.8, 'AV:N/AC:M/Au:N/C:N/I:P/A:C'),
('CVE-2013-5978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2374', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5370', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2375', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4545', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14042', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14049', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1405', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10775', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-4546', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10778', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-10779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4547', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14060', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6039', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-13990', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6019', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5404', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5405', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-5407', 10.0, 'AV:L/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2014-4509', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6025', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-10941', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4511', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5411', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2013-6029', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2408', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2427', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-13997', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10751', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2015-5417', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5833', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-14016', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2015-5419', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4527', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5835', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4333', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5125', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5782', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-13779', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4338', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2014-4344', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-4349', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-10757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-5783', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-2115', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5129', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5372', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-5699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-5986', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-5987', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2377', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5702', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5704', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2012-5705', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-5379', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10736', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10737', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5765', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1084', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-5412', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2020-10748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4517', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10750', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10753', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-5418', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-10943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10951', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4531', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4533', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10762', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5426', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5836', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5423', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14024', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2020-10763', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4537', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0740', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-14061', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5442', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5443', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-5444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14063', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5448', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-10790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5452', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5453', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-10791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14077', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14079', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6050', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-6051', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-5455', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4557', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5456', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2510', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5457', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14085', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6054', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14086', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14087', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4538', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14029', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5428', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14030', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5838', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-14032', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14033', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14035', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5430', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-10761', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-0576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0578', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-5787', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2119', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-13785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5131', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5285', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5784', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6004', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2512', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-2513', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-2515', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5460', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6075', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-6076', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-6079', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6111', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6114', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-2517', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4563', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5462', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1127', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5399', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1088', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-5400', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-10740', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-13984', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-13987', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-13989', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-4502', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6020', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2396', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-13993', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10940', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5432', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14038', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5286', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14036', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0754', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4565', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10749', 3.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2014-4519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0743', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-10780', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2015-5440', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2022-0745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14053', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14056', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14057', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14059', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6038', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10754', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14019', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10756', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-1132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2528', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2531', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-6141', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1411', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2533', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6164', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5470', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-5843', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10782', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-10783', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2022-0746', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-4549', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6041', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5840', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-1119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4551', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6043', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10788', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-4552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6045', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5472', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-6166', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14070', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4554', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6047', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14075', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6048', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5451', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5841', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6053', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-10793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14082', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14084', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14088', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1409', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14090', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-14091', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14093', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5458', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2511', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5459', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6058', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6074', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6077', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6078', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-14095', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4560', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2516', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5461', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-14096', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10800', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5842', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-14097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14099', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14102', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14105', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6127', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-4564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5463', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5465', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5466', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2518', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-1131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2519', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2521', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2522', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6128', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-6129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2523', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2524', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2525', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2526', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2527', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2529', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2530', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2532', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5468', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-14107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6162', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14108', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2536', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4568', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6163', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5471', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2537', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2538', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-14111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5849', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5474', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-1136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0759', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6167', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14114', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2017-14118', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1412', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14121', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14122', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-14123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5851', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2540', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5475', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6168', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5853', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-5854', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2541', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-4572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6169', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-14124', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-1139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-2542', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5477', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2012-5858', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-5859', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14126', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6171', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-14128', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14129', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14130', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14134', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14135', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14138', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14139', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6172', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6173', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6174', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6175', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6176', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6177', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-5481', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6180', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10807', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5482', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-5483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6181', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4576', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5484', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6182', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5865', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-5866', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5868', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-6188', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14142', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6189', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10809', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4577', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0767', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2015-5485', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5487', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5488', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-5489', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5490', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5491', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-6191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5493', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10810', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0768', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-6192', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6194', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6195', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6196', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-10811', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6197', 6.4, 'AV:A/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5494', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5495', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-5497', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5498', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14153', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6202', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5503', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6204', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4579', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6207', 9.2, 'AV:N/AC:L/Au:N/C:C/I:N/A:C'),
('CVE-2013-6208', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5505', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5506', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5509', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-5510', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-5511', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-5512', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5513', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-5514', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-5515', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2015-5516', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5519', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10812', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5520', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14158', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10814', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10819', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5876', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14159', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14163', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5877', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14166', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5522', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14167', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-14169', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14170', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2555', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14171', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14176', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5879', 9.5, 'AV:N/AC:M/Au:S/C:C/I:C/A:P'),
('CVE-2012-5881', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5882', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5884', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5885', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5886', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-4585', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5887', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2558', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2561', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2562', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-14177', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4586', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5888', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14178', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-4587', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5889', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2563', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6211', 7.8, 'AV:N/AC:M/Au:N/C:P/I:N/A:C'),
('CVE-2013-6212', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-5528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14179', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5530', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4588', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5890', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2564', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6213', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6214', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-2568', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-6215', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2016-2569', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2570', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2571', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2572', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4589', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5531', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5891', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4590', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5892', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4591', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1418', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5533', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5893', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-10968', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14180', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14181', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5894', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5534', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6216', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6218', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5535', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6219', 6.9, 'AV:L/AC:H/Au:S/C:N/I:C/A:N'),
('CVE-2014-4595', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2774', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5898', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5899', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5901', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6224', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5904', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5910', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-10972', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-5913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5918', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2013-6226', 7.8, 'AV:N/AC:L/Au:N/C:C/I:N/A:P'),
('CVE-2014-4597', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2775', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5920', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5931', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2016-2776', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5936', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2780', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5937', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5939', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-5943', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5946', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5949', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5950', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-5952', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2012-5953', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-6227', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6230', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2782', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2783', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2784', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10974', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-10858', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2787', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-5956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4601', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6233', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4602', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14189', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5963', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5965', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5967', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4604', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5975', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-1158', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-10978', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4606', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-10980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6241', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-6242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-5978', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1160', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14191', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14193', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6037', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6245', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6246', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1161', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2020-10867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14197', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6038', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6039', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6042', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-6044', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2020-10870', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-10985', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-4609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6048', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6049', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6052', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6053', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6054', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6055', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6056', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6057', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6060', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6062', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1421', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6063', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1422', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14222', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5544', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14223', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1167', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14229', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6066', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-6285', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14230', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-0790', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-6295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6300', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6302', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6303', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-6304', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-6305', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-14232', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14238', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14239', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6307', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-14240', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14241', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14242', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6309', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-14245', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-14247', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6311', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14249', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6316', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-14251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6320', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-14257', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10878', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2017-14260', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5545', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10994', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-10879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14266', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6322', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6329', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-6332', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-6333', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-2799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6073', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-4614', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14274', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5546', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1428', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14282', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14286', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1429', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14294', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14299', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14304', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14308', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14314', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-6080', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-2803', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1175', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2013-6338', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2021-0182', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6085', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-4617', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4619', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-6342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14323', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4621', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-4623', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-6091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4626', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-2812', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6346', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4633', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-6359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-6102', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-6365', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-6103', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6106', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2017-14348', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14350', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14357', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14363', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1187', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2818', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6115', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2820', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-6116', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-6370', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6374', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11004', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2831', 5.3, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2016-2832', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-6130', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14384', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6384', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-6385', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2012-6131', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2833', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11007', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-11008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11009', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-0807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-0808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10909', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-5895', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6220', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6221', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6222', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4594', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5896', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14184', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6223', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5897', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5902', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-10971', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5905', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2012-5907', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5909', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5912', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-5917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-4598', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5930', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-5932', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2779', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2781', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2012-5938', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5942', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-5945', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5947', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-5948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5951', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6229', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5539', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5954', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-5955', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4600', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6232', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-1153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5958', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-5959', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2789', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4603', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-5960', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5961', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5962', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-5964', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5540', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4605', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-5972', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-5973', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6237', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2012-5976', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-2791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-10981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-5977', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1439', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2840', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11024', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2841', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2012-6150', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2019-11027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4677', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14398', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14406', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14410', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-6153', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6410', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6411', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6414', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4683', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2022-0818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6417', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-1442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6418', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-2856', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4689', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-6026', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-14192', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14194', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14195', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-10982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6243', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6244', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5541', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6422', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2016-2857', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2013-6424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-6426', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-4692', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-2865', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6428', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-6277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6429', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6290', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2021-0220', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2012-6302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-0232', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-2872', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6433', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2012-6324', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-2793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6041', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6043', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6045', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10871', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6047', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-1166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6058', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6059', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6061', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-2794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6064', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4695', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0829', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-2879', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2883', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-0276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1443', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2887', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-2889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2914', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2012-6344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5561', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4701', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6443', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2927', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6444', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-6352', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6354', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6356', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-6369', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2930', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6448', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6432', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6433', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2937', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-2938', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6454', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1448', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2941', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4726', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2945', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6459', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11047', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2016-2957', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2961', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6065', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2017-14228', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1423', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6283', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-10990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-6067', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-6068', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6288', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-6069', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-10991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14231', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-6070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6289', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2797', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6299', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6301', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-10992', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1169', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1424', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6308', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-6310', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-14246', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-14248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6312', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6314', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-1425', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6319', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-14252', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14258', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14259', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14261', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-6331', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-10889', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1170', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2016-3001', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6469', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2021-1051', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2013-6472', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3032', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3035', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3045', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3046', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3056', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6477', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1106', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3059', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1235', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2013-6492', 6.4, 'AV:A/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1450', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3080', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6496', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14522', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3091', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14534', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14542', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4845', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14571', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5572', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-1059', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3097', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6072', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6327', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6330', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2022-0792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-0892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3111', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10978', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14590', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-0897', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-4890', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4898', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3126', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3128', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2014-4909', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14597', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4911', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6447', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1073', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-10991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5576', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6458', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14610', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10994', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4919', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2014-4925', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6639', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6074', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-14271', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14273', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14275', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14276', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6334', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-14280', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14283', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14287', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14292', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14295', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14302', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14307', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14311', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4932', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3141', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4939', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14627', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3144', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14637', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5578', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-11005', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6503', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-6507', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1081', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6512', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6515', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-11011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6522', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14721', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14277', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14279', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14281', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14285', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14288', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14290', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14296', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14300', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14306', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6076', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14312', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6081', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-6336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-6339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-2805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6341', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6088', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14324', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10894', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-5548', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-3164', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2012-6528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11014', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2014-4992', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14725', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1085', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2016-3176', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-6662', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-14735', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14293', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14297', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14303', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14309', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14310', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-0186', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4661', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4664', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6140', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-6146', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-6399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14394', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2843', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2809', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-4624', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2810', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-1434', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6337', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-2804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6086', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14321', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6087', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2808', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14325', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6345', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-6092', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5024', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5027', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14754', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3235', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14397', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14407', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1441', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14411', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10913', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1092', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0815', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-6415', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6271', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10933', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4686', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-0180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1176', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-6084', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4630', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-4631', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2813', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-6349', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2023-1180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14345', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6095', 2.9, 'AV:L/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-6357', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14756', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3289', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3295', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3318', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6552', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-3357', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3390', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3400', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3401', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14352', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14355', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14360', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14361', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-4636', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2817', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2014-4637', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-6097', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-6098', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2012-6101', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-6104', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6105', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14359', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6108', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10898', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1186', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1189', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0939', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2023-1306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3408', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3411', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5590', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-0944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3433', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3439', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-1321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6721', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-6580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4638', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14370', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6112', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-0801', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4690', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6321', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6323', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6328', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4612', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4613', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-14270', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4615', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14272', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14278', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6075', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-14284', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14289', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14291', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14298', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14301', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14305', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10891', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2802', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5547', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6335', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-4616', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-10996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14320', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4618', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-4620', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14326', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14333', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6090', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14337', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14339', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4629', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2020-10896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6366', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4635', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14349', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14354', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14362', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-14322', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4622', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2022-0797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4649', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-2822', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-6373', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2012-6119', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2825', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-6121', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10902', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11002', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2830', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-5550', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-6110', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6114', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4639', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-6371', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-14372', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6117', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14373', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6372', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5551', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2826', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-2827', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2866', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-10940', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11036', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-2867', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4693', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10901', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-2824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5564', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2949', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1229', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-0827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5560', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2878', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11040', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-4698', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6339', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6342', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10903', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-1202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14376', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10904', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6128', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-10905', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-6129', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5552', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14378', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-14379', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1204', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-4627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14342', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-6093', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-4632', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14344', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6347', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5549', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4634', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6099', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-6100', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-2815', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1183', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-14353', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14358', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2816', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-0834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14450', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2017-14460', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2925', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6349', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4702', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4703', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6350', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2928', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-6399', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1225', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-10906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6389', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-6132', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6395', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6397', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-6142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6144', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6398', 2.9, 'AV:N/AC:M/Au:M/C:P/I:N/A:N'),
('CVE-2015-5554', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6386', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6387', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-6388', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4658', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5553', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4659', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4660', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6134', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6396', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2021-0193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6141', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6145', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-6149', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-2838', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1210', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2971', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2980', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2016-2986', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11048', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-6461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6467', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-3014', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-10959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6109', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-1188', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14369', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1190', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6113', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6369', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4643', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-14371', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4646', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2821', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4648', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-6391', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2834', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6393', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6136', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-2836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6139', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-14388', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6143', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4668', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4669', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-14390', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4672', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14395', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2844', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14389', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6402', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-11025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4671', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-1213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2842', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6404', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-6151', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-14396', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6408', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2017-14401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14408', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6409', 10.0, 'AV:L/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2015-5563', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4720', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4723', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1228', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-0813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2848', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5556', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10932', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11032', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5557', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11034', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-10935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6419', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-2855', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11035', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-5558', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6425', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-6427', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2861', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2862', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5559', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6486', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-11065', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4762', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4766', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4778', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4792', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-3074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3076', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14504', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-3079', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14508', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4811', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4815', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1056', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-4826', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-14518', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14523', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14527', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14532', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14541', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14548', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14551', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4837', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-14564', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4846', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4848', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14573', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4852', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1058', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-1254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3096', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4736', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2955', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2959', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-4738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1230', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-14478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2940', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14482', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14483', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6457', 6.4, 'AV:A/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-10952', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-2828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3414', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3415', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6572', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3447', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2013-6726', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6730', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-6583', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-6742', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2829', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-0804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-1256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6626', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11029', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14412', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6412', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2845', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2974', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2976', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2983', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2987', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2991', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4746', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3004', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2014-4750', 2.9, 'AV:A/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-3009', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-3010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1105', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0891', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2016-3109', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1459', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-4875', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3120', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4887', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4892', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4903', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3125', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6631', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4684', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-6270', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-2944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6456', 7.8, 'AV:A/AC:M/Au:S/C:N/I:P/A:C'),
('CVE-2017-14484', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2963', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2977', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-2995', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2997', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4744', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4747', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5566', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-10957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3018', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6473', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3042', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3047', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2019-11057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10967', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-3063', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3065', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-14493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6437', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-3452', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3454', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-14859', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-3459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3470', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-1340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-5130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6795', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1488', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14920', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5180', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6807', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14929', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14939', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6810', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2860', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2868', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-6299', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2869', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4694', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11038', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-6307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3040', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2013-6474', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3054', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6475', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5567', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0860', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-6481', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5568', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1236', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-14495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6490', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4764', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-4776', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4785', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-4793', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-11069', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-3075', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14500', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14507', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6497', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1451', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0875', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-14510', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14513', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4807', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-4814', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-4818', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4821', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4824', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4829', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4832', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-14517', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3090', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14538', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14545', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14549', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14556', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14565', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14569', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14578', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14580', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4854', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-2874', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2881', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-2882', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6439', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-6346', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14461', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-11041', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2013-6442', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-2924', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2926', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1438', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11006', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2013-6466', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-6468', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-3013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3020', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-3033', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-3034', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3039', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-3044', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-3048', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3052', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3057', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10965', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0859', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3060', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-6480', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0862', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-14491', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6485', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-3069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11066', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4757', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4758', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-4760', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-4763', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4769', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4771', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-4782', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4787', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4790', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2022-0870', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4688', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6421', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2858', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2014-4691', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6298', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6303', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6313', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-1093', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2849', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2850', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4685', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4687', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-10936', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-6620', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1364', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14961', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14962', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6631', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11113', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14968', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3517', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-6862', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-0966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14974', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1113', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6874', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-3525', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3532', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-3542', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-6453', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6638', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-10968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4817', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-11073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4834', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1452', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14529', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-1057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14546', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14550', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4836', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-14558', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14561', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6325', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-1221', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-4715', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4718', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2932', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-2933', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-11043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2935', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-14477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11045', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6455', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-0848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0849', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6458', 10.0, 'AV:A/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2020-10953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-2873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11039', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2013-6434', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6329', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6435', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2023-1222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6462', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5577', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-11000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-14633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11003', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-14681', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1077', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14684', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14690', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6493', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5579', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-6495', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2021-1078', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6649', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1061', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-3101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3104', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5573', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3112', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3115', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2016-3118', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-4895', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4904', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6630', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-1062', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-10976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1063', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4870', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14589', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-1065', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-0896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6629', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4812', 2.9, 'AV:A/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2014-4813', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4825', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-4828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6617', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14531', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-3092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4838', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-14562', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4844', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14574', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14579', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14583', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4857', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3100', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3106', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6892', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-6900', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-15018', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15023', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6901', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6662', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-15032', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3615', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15035', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15039', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6671', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6905', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6684', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6691', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6694', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6913', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-3639', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-6699', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6916', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5632', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5633', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0985', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-6394', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-11010', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4663', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2837', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2012-6147', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-6148', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6401', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4670', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-10910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6403', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5555', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6438', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1445', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6446', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2012-6355', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-6360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4717', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-2931', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4719', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1447', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2936', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-6452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4721', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2016-2954', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2960', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-2984', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2988', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3012', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10958', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-3038', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3049', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11050', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2016-3055', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-1233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-0992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6953', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5639', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-5214', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-1420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5642', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2021-1146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6713', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6985', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11044', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-11045', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-11046', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-6994', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-5240', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-5659', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-7003', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5256', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5266', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6502', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2020-11009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4974', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4975', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1083', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6634', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1444', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10945', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-0296', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-2922', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6348', 4.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2014-4710', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6357', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-5562', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2929', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6450', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2022-0842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4725', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15054', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6932', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2017-15055', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-6933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6706', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-1139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5217', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5641', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2021-1141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6407', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2020-10912', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6152', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-14400', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14404', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14409', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1103', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-10914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4682', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2946', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2953', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2956', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4741', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2966', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2970', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2972', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2985', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2994', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4748', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4749', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-3007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3015', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1232', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2012-6440', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5574', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4888', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1066', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4897', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14592', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6632', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-10983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14603', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6636', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14596', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1461', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10993', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2012-6460', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-14612', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6461', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-14614', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10996', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4928', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6640', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1074', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-10992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11095', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14611', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-1075', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:H'),
('CVE-2016-3138', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-10941', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0825', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-5236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1219', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6718', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1221', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2023-1439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1445', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1463', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-3645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5667', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-5263', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5268', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2015-5681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5276', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-15112', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15113', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7013', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1523', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-5298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11073', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5269', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5270', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-1226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11063', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1235', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3647', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-1022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11071', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2014-5313', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-11074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1033', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5314', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-15124', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7033', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2021-1255', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-5319', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-15132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5322', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-15136', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-1532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3139', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4735', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5565', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4737', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2964', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2981', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2998', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-3000', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-3002', 1.4, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N');
INSERT INTO `tpandora_cve` VALUES
('CVE-2013-6462', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6465', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4930', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11001', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2013-6641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6326', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-2875', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1104', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2876', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6436', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6330', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-2877', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-2880', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-0265', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2888', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2912', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0833', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-1223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-14620', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14626', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3142', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2017-14641', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14646', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14647', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14649', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0909', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14653', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6644', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5318', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-5689', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5321', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-1045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5695', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3664', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3672', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3182', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-3183', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1474', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1462', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4937', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4940', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6642', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2847', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0866', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4942', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0906', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1467', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1469', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14691', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14696', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1263', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4963', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14713', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11102', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6500', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4973', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-14717', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6505', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7063', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-11146', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3687', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-3688', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7079', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2020-11088', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2016-3694', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15190', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1541', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-11094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1542', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2013-7094', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11095', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2017-15194', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15197', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15202', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15206', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15209', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-1521', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5341', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-5719', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7107', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15239', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7138', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7139', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5370', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15248', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15264', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3025', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3028', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10960', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-6476', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6482', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-14492', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6487', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14496', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4770', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4786', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2014-4801', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6493', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4805', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11070', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-11071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4806', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14511', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3085', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2014-4816', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-14742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1288', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5025', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-14746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11033', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4783', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14501', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1107', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6501', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14519', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5571', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-0880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4835', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14557', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14563', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4847', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14570', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14572', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14577', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3094', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0883', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6624', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4946', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1260', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-4960', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14705', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14718', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6655', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6471', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-14683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14688', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14694', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2017-14695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14706', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6496', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4964', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6498', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14714', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3156', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6483', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-6484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14494', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1053', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3071', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5569', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4767', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4775', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4784', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4803', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-1243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5570', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-0876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4819', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4827', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4833', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14520', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14525', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3089', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14543', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14552', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4839', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-4840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3093', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-14576', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1458', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2013-6622', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7185', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4830', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-14526', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14539', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14540', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14555', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4843', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14566', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11082', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4853', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3095', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10977', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11089', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4883', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4889', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3124', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1604', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-16040', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6244', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6246', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-5028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3276', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-3288', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5031', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3296', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3316', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6556', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6557', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3365', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3379', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3387', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5033', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-5034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5039', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-1476', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6567', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14770', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3407', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6689', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-14775', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5588', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4905', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4906', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4910', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14594', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14607', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2012-6449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14609', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6657', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2023-1265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-4977', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4979', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2012-6520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6523', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14722', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4980', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6527', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2020-11013', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-3170', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4991', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4995', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14726', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1267', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-11085', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-1536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7073', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-1538', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1052', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11091', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-15188', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5712', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2013-7089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3703', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15196', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-7100', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2021-1275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7104', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-5342', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1522', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15228', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15235', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5353', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2013-7140', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-1556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5726', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15245', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15249', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15252', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15257', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5383', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-7175', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-7177', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5389', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5736', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-3725', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-5745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5399', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15278', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5403', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15286', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5405', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-5753', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7251', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6707', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1480', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3422', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2016-3431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2012-6573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3443', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-1323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5600', 7.8, 'AV:N/AC:L/Au:N/C:P/I:N/A:C'),
('CVE-2017-14819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-14820', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-1483', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2017-1484', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6765', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14852', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5619', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6775', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14867', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3102', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-3108', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4867', 10.0, 'AV:L/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2021-1064', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-0895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3119', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14591', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-10980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6359', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6392', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11042', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2023-1226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-3098', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-10975', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3105', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0890', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14587', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3107', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-4863', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4868', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-4872', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1109', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-4877', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4896', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4900', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1067', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14593', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3127', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1069', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2015-5575', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6635', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14720', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6517', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14723', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4998', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3174', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2014-5003', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14728', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14868', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1487', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5114', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6788', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6789', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6608', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5127', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-5139', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-5148', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1490', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5160', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-6801', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-14921', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14923', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6808', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1494', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14949', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5203', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3491', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-1358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11024', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2020-11025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6622', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6627', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1115', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-3501', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11112', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6634', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-6839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6636', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6864', 8.5, 'AV:N/AC:H/Au:S/C:C/I:P/A:P'),
('CVE-2017-14970', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14976', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14981', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14733', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-5005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3178', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-3189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-5013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3190', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3188', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-14739', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16044', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7204', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16050', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16052', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16053', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16056', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1606', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16060', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6253', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16063', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16068', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16069', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1607', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7205', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16074', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16075', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16076', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16078', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16080', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16081', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6255', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1342', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7209', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1866', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-6284', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-6286', 6.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-6290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6292', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-1868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-6298', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-7222', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1346', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-16083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6305', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5002', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3180', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11202', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14601', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14608', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-3137', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11096', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14617', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14618', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6466', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14645', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1110', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6465', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4936', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-4938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14629', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14642', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-6469', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4945', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14689', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4947', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-4954', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6645', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5583', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-1282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5016', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3735', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1586', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-3740', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1099', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-6314', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-2871', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-4696', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-0831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2884', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6437', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-2894', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-0279', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2021-1087', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5019', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1290', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14748', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14751', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3212', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3240', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3264', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3274', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-3284', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3301', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3313', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3319', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6553', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-3322', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6558', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-3360', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6310', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6311', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2021-1419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1870', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7229', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16086', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16089', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6318', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6321', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-6323', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1609', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6328', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2015-6330', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6332', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6335', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-6337', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6340', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16091', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6346', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16094', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6348', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-6349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6350', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6351', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6352', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6354', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6356', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1423', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1426', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7230', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16101', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16103', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16104', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16105', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16106', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1354', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-11762', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14687', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14693', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14704', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1079', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-3154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6650', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3233', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3241', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3255', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3282', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3291', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-3315', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3321', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3324', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6555', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3327', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-6561', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3361', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3378', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-3382', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5036', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-6564', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14762', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14763', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6568', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-3405', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6688', 6.9, 'AV:N/AC:M/Au:S/C:N/I:C/A:N'),
('CVE-2023-1307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6463', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3140', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15300', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-1613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1106', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2013-7257', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6453', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-2939', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2942', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2943', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2948', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10951', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2014-4734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11046', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2950', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6435', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2016-2958', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2965', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-2968', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-2969', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2973', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2978', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4742', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-2989', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-2992', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1231', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-15321', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-5426', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-3573', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6644', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6645', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3580', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-0972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6513', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5581', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-11012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-3162', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-1273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3166', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-6530', 10.0, 'AV:N/AC:H/Au:S/C:C/I:C/A:C'),
('CVE-2016-3172', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4993', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4996', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14727', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5582', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-3375', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6562', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3381', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3385', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6563', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-0932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6565', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2021-1093', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5075', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6691', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2017-14799', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14800', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0835', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4700', 6.4, 'AV:A/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2017-14449', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-6440', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6441', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-2923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0837', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-1224', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-14621', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14638', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14644', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14650', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0908', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-4944', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-6643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6652', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3211', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3261', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3273', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3278', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1092', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-3329', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3358', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3363', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3396', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14731', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3424', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6719', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-3445', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-6725', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6728', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-14807', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-5084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14825', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14837', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5602', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6770', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2023-1331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-11022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14857', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14860', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6785', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-5105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5118', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-5122', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-5144', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-6797', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3472', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-6610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5159', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5163', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5177', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2013-6802', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2021-1428', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16107', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1355', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2017-16109', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15362', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5439', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11226', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5452', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5454', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2019-11231', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5459', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2013-6682', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-3406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5076', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-1312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3423', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3428', 1.4, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-3432', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3435', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:N/A:L'),
('CVE-2017-14803', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6717', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-3446', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2013-6729', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-6582', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-3450', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14829', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14834', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6769', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-3457', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2015-5611', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14854', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5098', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5104', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3460', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-5116', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-6791', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5119', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4978', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2012-6518', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2012-6521', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1082', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3169', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6531', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-4987', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4997', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14730', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1086', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3186', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14738', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6667', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3619', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6904', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3622', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15038', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-1504', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1393', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3624', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3627', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14685', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6646', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3187', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-6664', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14940', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-6618', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2023-1359', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6817', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6825', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1367', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-1368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1496', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5427', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5462', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-5468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5022', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5026', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-3205', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0921', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3280', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3298', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-5015', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5584', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14752', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3209', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3234', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3247', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3267', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3279', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-0924', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6672', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-0926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3331', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0928', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3351', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-3364', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5035', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3402', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6566', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14766', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1305', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-14771', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3409', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3410', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5132', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-5137', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1612', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16121', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16123', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11763', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1892', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-1613', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-4972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14719', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4976', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2012-6516', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6524', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6656', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-11208', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-11210', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-6551', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2012-6559', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3359', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14764', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3404', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1096', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14801', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3426', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-3437', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2013-6714', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-3440', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-5599', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6731', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-1482', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6734', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-14822', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-14826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14831', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6741', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2013-6744', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-6748', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6447', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6449', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-0843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-2934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6430', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6431', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2012-6434', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1234', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2013-6806', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6812', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-3487', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3490', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2023-1355', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0961', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11111', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3505', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3511', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-6836', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-3519', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6865', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2019-11120', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14984', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7240', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1894', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-7241', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1895', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2022-1377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1447', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7242', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1379', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-7246', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-7247', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6362', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-6363', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-1903', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16138', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6377', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-6378', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1906', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-5435', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7284', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15358', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15360', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5438', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-7290', 2.9, 'AV:A/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2017-15365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15372', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1538', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15386', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2012-6533', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1084', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4986', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-3173', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5001', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6660', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15053', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6935', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-1416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6707', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5640', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-3644', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0997', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11042', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-5646', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2023-1428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5651', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5652', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6997', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6719', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1450', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5251', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2014-5253', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2023-1328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6773', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14866', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-1100', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5102', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5107', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-3467', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2014-5128', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-3471', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-3474', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3476', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-1344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-5164', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6805', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6615', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-5194', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14927', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-3480', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14932', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14935', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14938', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11023', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-14957', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3417', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3427', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-3436', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-1320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6713', 6.4, 'AV:L/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-6723', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6577', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-6578', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6735', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-1098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5603', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-4781', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6491', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-1242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6494', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-14498', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4804', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-3081', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6438', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-14512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4810', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4822', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-11074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14533', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14547', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14554', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14559', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14567', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1457', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-4855', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4856', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6625', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6576', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6720', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2013-6733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3448', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-14821', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-6737', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-14827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14833', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14849', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5606', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6771', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-3458', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-5087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14863', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14864', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6780', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-6786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5623', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-3461', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3463', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1101', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6606', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6793', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5131', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-1104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3473', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-1491', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5161', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-1347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1107', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5193', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1493', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-3482', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3484', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-3485', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-0950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5197', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-1495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6814', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6815', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-14955', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3494', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3499', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6632', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3508', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2012-6633', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5606', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5613', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5615', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-5628', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5633', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5642', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5649', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5658', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5668', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5669', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7340', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-5686', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5694', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5703', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5716', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15402', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-6382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6387', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6388', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-6389', 8.5, 'AV:N/AC:L/Au:N/C:P/I:P/A:C'),
('CVE-2015-6390', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6395', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-16141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16143', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1910', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-6399', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2017-16146', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6400', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16147', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6404', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-6405', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6406', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-6407', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-6408', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6409', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6410', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-6411', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6413', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-6414', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6416', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6417', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6418', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-1381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6642', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3574', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3576', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3577', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3579', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-11133', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3610', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-0973', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-1007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11054', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-1470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15096', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-1474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5265', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1493', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7008', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15111', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1236', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-3456', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2013-6772', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-14861', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14865', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-5108', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3466', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3469', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1339', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-1102', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-14919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5182', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2012-6612', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5183', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-5190', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6804', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14928', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14931', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14933', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14934', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-5195', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6809', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5202', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11109', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5205', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11243', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11244', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-5789', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-7322', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-7323', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11247', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-5791', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3185', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-5007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6628', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6629', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3503', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-3507', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-3509', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3513', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6837', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6840', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-6858', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6866', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-14972', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11121', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1498', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14989', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14990', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3522', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-3527', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3529', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-3535', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-3536', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-3540', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-3547', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3550', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-3555', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3561', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-3563', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2016-3569', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3588', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2017-14995', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3612', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6889', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2012-6658', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6659', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11114', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6853', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3518', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14975', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6872', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-1381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14992', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3524', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-3530', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2016-3531', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-3541', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3546', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3553', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-3557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3572', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2016-3582', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3586', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3597', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14994', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3614', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1516', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5286', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-5287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5308', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2022-1030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7022', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7039', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2013-7040', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-1531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5790', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5825', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5827', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5836', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5838', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5842', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5844', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5848', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5850', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5853', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5859', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5863', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5865', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5867', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5873', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5877', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5902', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5903', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5905', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5912', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14588', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4874', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2020-10979', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3116', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2014-4894', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4899', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-10981', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-14600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6441', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-10947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-2947', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-14487', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-2951', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1449', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2952', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-2967', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2979', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-2996', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4743', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-0852', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6470', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3031', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3043', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6436', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2020-10962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6478', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2021-1052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6479', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-0861', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-11063', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6489', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-3072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4756', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4759', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4761', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-4765', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4774', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4788', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4802', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-0869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1054', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0871', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2012-6621', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6666', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6869', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14983', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3523', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-3556', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3558', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-3566', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6643', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3587', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-3590', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3594', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3609', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-1500', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6886', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1386', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6890', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-15015', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15017', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15020', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15024', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15029', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-6902', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6667', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5595', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5608', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5611', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7338', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-5625', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5632', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5641', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5653', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5661', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5675', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5679', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5687', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5689', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5708', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5723', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5747', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5749', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15403', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11093', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6459', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-3136', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1055', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-3084', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4808', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-0877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4831', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-14524', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14544', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14553', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14560', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14568', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14575', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11084', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14582', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6439', 7.8, 'AV:N/AC:L/Au:N/C:N/I:P/A:C'),
('CVE-2021-1060', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-0885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1255', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4862', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4869', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-4873', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-3114', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4884', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4885', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4891', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-4901', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0898', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4907', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3130', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14595', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-4912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-3131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1072', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-3134', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1122', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1126', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1401', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3632', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6696', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6698', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15046', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0987', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6930', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2012-6705', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6952', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-15079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15086', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-15088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6710', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11039', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2021-1147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11043', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-1194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6714', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5648', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1509', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6022', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3943', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7379', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3948', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15415', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6838', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-14969', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6863', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-6867', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-14971', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-1117', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6637', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14988', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-6877', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-3526', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3549', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6879', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3560', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3571', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3581', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2013-6880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3592', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3593', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3596', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3598', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-3608', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-3611', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2015-5627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15011', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6656', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-15013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15014', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15021', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-1121', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6419', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2021-1449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1450', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1911', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16150', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1382', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-6420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6421', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6422', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-6424', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6425', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6426', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6427', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-6433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6434', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6435', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1383', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2017-16151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16152', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16153', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16154', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16156', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16157', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16158', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16159', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16160', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16162', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16163', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16164', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16166', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16167', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16168', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16169', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16170', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16171', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16172', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16173', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16174', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6906', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6908', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1129', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3631', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6692', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6915', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-0984', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15045', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-11029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6702', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-15052', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-11032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6929', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-5636', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5211', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5216', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6708', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11041', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-1153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5235', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15042', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-10997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14623', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14625', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14634', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-6468', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-14651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6472', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-14686', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14692', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1261', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-4962', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2017-14709', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-14711', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14712', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-4965', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5580', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2012-6501', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2012-6508', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-6654', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-0915', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1090', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-1291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14753', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3203', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1091', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-3246', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3263', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-1296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3281', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3290', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3304', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6554', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14759', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3366', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-1300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3384', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5586', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-5037', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5038', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-6674', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14761', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14765', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1094', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2023-1308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14773', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14798', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6708', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3416', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3420', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2016-3429', 4.2, 'CVSS:3.0/AV:P/AC:H/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2015-5594', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3438', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-14802', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15092', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15094', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1472', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-1014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1486', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-11061', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-11064', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5277', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5285', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1242', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-1107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7023', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15125', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7030', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6040', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6043', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-7383', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-6045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7386', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16176', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16178', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16179', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1915', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16180', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16182', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16183', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16184', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16185', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16186', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16187', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16188', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6454', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16190', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16192', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16193', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16195', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16197', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16198', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16199', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16200', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16201', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1385', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-16202', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1916', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2017-16203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16204', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16205', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16206', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16207', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-16208', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16209', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1621', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16210', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16211', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16213', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16215', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16216', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16218', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16219', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1917', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6456', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2023-1918', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7001', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2020-1105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-7002', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5257', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11056', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-15100', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5813', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5819', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5821', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7345', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5851', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5858', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11466', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-5874', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5888', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5893', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5898', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5899', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4929', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-14619', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14622', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6467', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4941', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0905', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-14631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14640', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14643', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0907', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1465', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1076', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6470', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1468', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-4948', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2014-4955', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-4958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14703', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6497', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-1080', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6499', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-1264', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-7034', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15130', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7038', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2015-5686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5688', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-7048', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-5694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15137', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-5325', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7061', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2016-3674', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3678', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14806', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6724', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-6732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14832', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1485', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6743', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6745', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6747', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-14850', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6768', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-5609', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-14853', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14858', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14862', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5622', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-5113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6787', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-3468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5120', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-5129', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5136', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1489', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5162', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5178', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5187', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3478', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3483', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2021-1108', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2017-14947', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5199', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3488', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5204', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15056', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6949', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-15081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6955', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6711', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5643', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5239', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2015-5653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1451', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5250', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5252', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2022-1008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15099', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5262', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1489', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5333', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-1054', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7097', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5339', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2017-1520', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15208', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-3705', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11098', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2017-15213', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7106', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7114', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-3712', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5369', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-1075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5723', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1524', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1622', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-16220', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16221', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16222', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1919', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-11765', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-6458', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16223', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1920', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-16224', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1921', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-11766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6459', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16225', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1922', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-3640', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1133', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-1103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-15051', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0988', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0990', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-1506', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5637', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5209', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6950', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-5212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-15085', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-0981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6911', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6912', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-6693', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-6914', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2012-6697', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5630', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5634', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-0986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1412', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0991', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-1507', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6936', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6951', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2020-11036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11040', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-1425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5233', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-6983', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-5234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5649', 7.8, 'AV:N/AC:M/Au:S/C:C/I:P/A:N'),
('CVE-2023-1430', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-6717', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15091', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2014-5242', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-3168', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2012-6532', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-4994', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6659', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-15251', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3722', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-1095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7189', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7196', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2017-15266', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1527', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-15272', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-5740', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1585', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-1098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3731', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3733', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-7220', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15277', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-6460', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1923', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-11767', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-16227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1924', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-1458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16228', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16229', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1623', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1925', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-16230', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16231', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1926', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-1460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1927', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-16237', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5273', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7011', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7012', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1026', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-1027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5300', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-11075', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-1246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7025', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1035', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15131', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1256', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-5687', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7042', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15138', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2013-7057', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5701', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-11080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3498', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-14963', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14964', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3504', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1375', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-6835', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3514', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3515', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1497', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3520', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0968', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6875', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-6876', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3528', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6640', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3537', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3539', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2016-3545', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3552', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-3562', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-3564', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6641', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3575', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3578', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3583', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-1119', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-3589', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3591', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-3595', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2012-6648', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-3606', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2012-6651', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-14997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15009', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3613', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6655', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1120', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6888', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15019', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15022', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1388', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-1503', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15033', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6903', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11027', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-1206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5238', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6993', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7000', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-5655', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-1440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6721', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2023-1465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5665', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2021-1225', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-11060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5267', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15105', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-1488', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1491', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-5271', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7009', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5278', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-11066', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2020-11067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5976', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15409', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15110', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3650', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5284', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-7017', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11072', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2013-7020', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15123', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1148', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1928', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-11272', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-7393', 4.9, 'AV:L/AC:H/Au:S/C:N/I:P/A:P'),
('CVE-2014-6052', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7394', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-15422', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-5259', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5260', 9.2, 'AV:L/AC:M/Au:N/C:N/I:C/A:C'),
('CVE-2014-5261', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5272', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1019', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14740', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14744', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14745', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16239', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1624', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-11480', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16244', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1929', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-6467', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7251', 4.9, 'AV:L/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2017-16248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-6468', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1625', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-1934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6470', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2015-6471', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16250', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1467', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-11028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3623', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1123', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6687', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-3625', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1400', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6910', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11135', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-3633', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6700', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3643', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1134', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-1409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1135', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-11031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11081', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-7065', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-7068', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2013-7069', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7075', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-3689', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7093', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-3697', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11096', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2017-15203', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-3704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7105', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-15214', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15219', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1548', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15223', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-5347', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5722', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-7135', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3717', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6017', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6025', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6028', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-6030', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-7372', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-1130', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-1539', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-5711', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-15200', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15205', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5715', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11099', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-1277', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-11102', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-15225', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-5349', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-7110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5352', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2013-7137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5360', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5361', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7144', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-5727', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15246', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15263', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7176', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-5733', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5388', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7194', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11154', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-15270', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-11156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7016', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7019', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15118', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7024', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11078', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-1252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7406', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7409', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-6071', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6075', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6082', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-6084', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6089', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-6092', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-7419', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3959', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5021', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2023-1289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0919', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3207', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7049', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-5324', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-7050', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1628', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11486', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1569', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1284', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15242', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15247', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15254', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15262', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7202', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5739', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15273', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6931', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-15063', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11035', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2023-1414', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-6948', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-1508', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15087', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5215', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2020-1104', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5231', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5232', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5645', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2021-1211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5650', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5237', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11047', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-11049', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-1222', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-1446', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5247', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15093', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5661', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-5663', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5258', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11058', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-5669', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-1477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15107', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5275', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-1507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7010', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5282', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-7014', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7021', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15119', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-11077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-5316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3163', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-4981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3167', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-3171', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-4982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6534', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-4999', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5000', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6535', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-5004', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14729', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3179', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14737', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7233', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15288', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5029', 2.9, 'AV:L/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2016-3242', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3243', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3245', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-14755', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3262', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-3283', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3292', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2016-3297', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3303', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14758', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3353', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-3362', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3383', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3388', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-3391', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-6673', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-6681', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5073', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7205', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2019-11162', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5742', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3738', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3739', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-5400', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7224', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-5748', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-7232', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5407', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15295', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7245', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7018', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-14741', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5020', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2023-1292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14749', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3202', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3206', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3244', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2013-6671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5030', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-3277', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-6550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3293', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-14757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3317', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3325', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-3326', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-5032', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-0930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5040', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-0935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-0936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5587', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-7102', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5718', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-15216', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7108', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2016-3711', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-7112', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5351', 2.9, 'AV:N/AC:H/Au:S/C:P/I:N/A:N'),
('CVE-2014-5354', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2021-1468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1936', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6478', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7258', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6480', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2023-1939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1940', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-1941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5805', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11273', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11501', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2013-7400', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7408', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5808', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6078', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-6080', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-6083', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6087', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6091', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-15427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5751', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5413', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-15293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7246', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6105', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6109', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6110', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-3971', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3972', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6113', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6115', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6116', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6119', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6121', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6122', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-6123', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6126', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7423', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-3973', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6136', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-11506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6148', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-6153', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6158', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2019-11278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6164', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6175', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6177', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-1549', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5813', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5761', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15312', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7066', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-11086', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-11087', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2022-1053', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3693', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5336', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2013-7095', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5713', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5337', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3698', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15199', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-7098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15212', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15215', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15220', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5345', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1523', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11104', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3715', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-5691', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5693', 10.0, 'AV:N/AC:M/Au:M/C:C/I:C/A:C'),
('CVE-2015-5696', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-3670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7259', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7262', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6481', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2014-6095', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6098', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6106', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6108', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15430', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-5765', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6185', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-6190', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6196', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6210', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-6222', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-11281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6231', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11526', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-3984', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2017-15526', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15529', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6237', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-7454', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7458', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3997', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6255', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-4006', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4008', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15550', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15565', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5725', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15241', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15255', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15261', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7186', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-5735', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-7192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15308', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7259', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11198', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7260', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7262', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5331', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7077', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3690', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7085', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2013-7086', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1540', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1519', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-0941', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1314', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1095', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3412', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0943', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1515', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11084', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-3684', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3686', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1283', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5375', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-3721', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1092', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-5387', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-7184', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-3724', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4014', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-11561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4019', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7473', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6275', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7477', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15573', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15574', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6288', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7481', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15578', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11590', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15579', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15587', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4037', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-11593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4045', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1643', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11332', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1559', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-11336', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4053', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7264', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7266', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2021-1469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7267', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7268', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6482', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-4143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1943', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11488', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1944', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11490', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11492', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11493', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1964', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-11496', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-11497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-11498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11511', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6149', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6152', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-7431', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6173', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6176', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6180', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6181', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-5812', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7433', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7435', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7439', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-6187', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-6194', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6215', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-15518', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5814', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15524', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3985', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6232', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-11283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7453', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7081', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2020-11090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15186', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-7091', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5338', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5714', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11148', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15207', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15211', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-7103', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-3708', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2015-5720', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3710', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-7129', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7130', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2020-11105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5359', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2016-3716', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-15201', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-5340', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-5343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5721', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7113', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-15238', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5355', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5356', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-7141', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1071', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-1073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7149', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15240', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15250', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15258', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5386', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-5391', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7190', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7195', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-5393', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-15267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15269', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3729', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5397', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1587', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3751', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5412', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15294', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1100', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2013-7239', 4.9, 'AV:A/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2013-7241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-15302', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7255', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2021-1310', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-15363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5780', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-7296', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-7301', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-11235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5464', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7307', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5466', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3718', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-1086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5730', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15253', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15260', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5392', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2013-7193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11155', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-15268', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7203', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3728', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7217', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11165', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7221', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7226', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15280', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2013-7240', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-11499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-1471', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-11500', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1629', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7271', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7272', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7273', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7274', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-11503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1632', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7275', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-4145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4056', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4058', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11350', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6304', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15601', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6312', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6313', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1561', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15610', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6344', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6373', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4070', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15271', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3732', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3737', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5398', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7223', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15287', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15290', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15297', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15298', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1481', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6767', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5605', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3996', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-5818', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15535', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-6253', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6254', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4005', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-1554', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6257', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2013-7468', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1556', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4010', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5822', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4020', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-15569', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5823', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11585', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15577', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11216', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-11217', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5450', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5451', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-15378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15384', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11436', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-5786', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15390', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-7258', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5788', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-1115', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-5500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5790', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5767', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5117', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-6794', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5121', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3475', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1345', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2012-6611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5169', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-6800', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-5185', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-5186', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14922', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1353', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3477', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-6616', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-14944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-5201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3489', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6818', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2023-1366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2012-6624', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2012-6625', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-0959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3506', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14965', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14966', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1116', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6493', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6494', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11504', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1633', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-1177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1635', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-11509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11510', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-11511', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16355', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7283', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-1531', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7222', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-5401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15284', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-15296', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1104', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5755', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15305', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7254', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1105', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7482', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5827', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7483', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-1627', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6294', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1166', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4048', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-4052', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5764', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7273', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11211', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-11248', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2013-7327', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5546', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-1125', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5553', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5569', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5574', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5580', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5585', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5599', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5605', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5614', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5623', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5639', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5651', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5656', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1122', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5795', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5681', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5691', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5701', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5712', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5792', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5508', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-5519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5535', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5540', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7331', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-7333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11446', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5550', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5554', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5564', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5567', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5571', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5572', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5582', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5587', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5592', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7336', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-5603', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5618', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5626', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5638', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5644', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5654', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5662', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5667', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5676', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5678', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5680', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5692', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5695', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5700', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5705', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5714', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5730', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5736', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5738', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5745', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5753', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7344', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1124', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15309', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:L'),
('CVE-2019-11196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15357', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5437', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6859', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2013-6861', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2013-6870', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14985', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1499', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3534', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-0971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16356', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11513', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16357', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11514', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-11515', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16358', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16359', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-7285', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-4146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7286', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11517', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11518', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6496', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11519', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11521', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2014-7287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-1972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11522', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1153', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-6498', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-11533', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6500', 7.8, 'AV:N/AC:L/Au:S/C:P/I:N/A:C'),
('CVE-2014-7288', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-7289', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-1975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-7290', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7291', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7292', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-6501', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6502', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7294', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2023-1977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11537', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7341', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5741', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5752', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5761', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5768', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5778', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5779', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5780', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5781', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5782', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5783', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5784', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5787', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5789', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5793', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5797', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5800', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5805', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5807', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5810', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11464', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-5818', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5824', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5831', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5833', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5847', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5852', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5857', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5861', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5866', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5875', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5900', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5909', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5911', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5914', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5916', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5921', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5929', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-1147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5941', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5947', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5955', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5962', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5965', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5968', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5800', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5996', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6007', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6013', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7377', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6036', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-3951', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1132', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-1617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11205', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3413', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-3418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3421', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2016-3425', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-3434', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-1097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6575', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3442', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6722', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2013-6727', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2012-6579', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2012-6581', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3449', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-6738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-14824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5601', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6739', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2013-6746', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-6749', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5610', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-3455', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2014-5091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-6774', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5621', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1335', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-5100', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5106', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5115', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-3464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-5625', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1338', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2012-6607', 4.9, 'AV:L/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2012-6609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6796', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2021-1103', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-5165', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-6798', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-5181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5184', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-14926', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-14930', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-0949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14941', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2012-6617', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-14946', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5198', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3486', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2012-6619', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2023-1360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1361', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-0956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5846', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5882', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5885', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5895', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5904', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5915', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5920', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5931', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5942', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5943', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5950', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5952', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11474', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5980', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5982', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5987', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5989', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5994', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6001', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6005', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6011', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6012', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6019', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6023', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-5446', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15370', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11228', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-15381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7299', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-11230', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1111', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6393', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6394', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4068', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6396', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11206', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-6422', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6427', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6446', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11632', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6456', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-11358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1710', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15696', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7317', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7324', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-7328', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2014-5521', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-5531', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5538', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5542', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5544', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5551', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5552', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5559', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5562', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5568', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5581', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5593', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5598', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11452', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5794', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5670', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5673', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5682', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5688', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5693', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5697', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5698', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5706', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5709', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11538', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-11539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6506', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6507', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7295', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7296', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1476', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7298', 6.9, 'AV:L/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-7300', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7307', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7309', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7310', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6509', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7313', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7314', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7315', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7316', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7317', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7320', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7321', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7323', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7325', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7326', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7327', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7328', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7329', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7330', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-7331', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1981', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7333', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7334', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1535', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7286', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15364', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-5440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1110', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11221', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5445', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7295', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2013-7298', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-15383', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5455', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-5460', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-11234', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11431', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-11236', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15391', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-1369', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-14958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-14960', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3496', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2016-3500', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-5208', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3502', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2016-3512', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-14967', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6635', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-3516', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-6860', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2013-6868', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2019-1112', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-14973', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-6873', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1118', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3521', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-6878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3533', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-3538', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2016-3543', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3544', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-3548', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-3554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3559', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-3565', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2016-3570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1570', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11389', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-15703', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11398', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6482', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-4095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1142', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6484', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-6487', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11448', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11455', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-1219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11461', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2012-6665', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2012-6666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-0977', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2013-7274', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-5430', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2013-7276', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15650', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15662', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15663', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15667', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15671', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6423', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6424', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6444', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5874', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7283', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-15361', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7291', 2.9, 'AV:A/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2019-11222', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5447', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15368', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15369', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15374', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15380', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5456', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2013-7305', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11443', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2013-7315', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15392', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-5429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-7277', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1306', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-5713', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5720', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5726', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5729', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5737', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5796', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5754', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5758', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5760', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5792', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5803', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5811', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5816', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5823', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6454', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6458', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-11359', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15692', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15693', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11371', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15697', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6464', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-6467', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2023-1729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11392', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6475', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2023-1732', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-1202', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15710', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11405', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-11413', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15717', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11451', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6489', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2019-11457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15723', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6493', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2019-11463', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1224', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15733', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5910', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15743', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1363', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-15756', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15766', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15775', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15785', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15788', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7335', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7336', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7337', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7338', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7339', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6510', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7340', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7341', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7342', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7344', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7345', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7346', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7348', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7351', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7352', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7353', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7354', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7357', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7358', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7359', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7360', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7361', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7362', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6511', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6512', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7364', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7366', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7367', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7368', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7369', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7370', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1477', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-7371', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7372', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7373', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7374', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7375', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7376', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7378', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7379', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7380', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7382', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7384', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6514', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7385', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6515', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7387', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7388', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7389', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7390', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7391', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7392', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7393', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7394', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7395', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7396', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7397', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7398', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7399', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7402', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7403', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7405', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7406', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7407', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7408', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7409', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7410', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6516', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6517', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7413', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7414', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7415', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7416', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7417', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7418', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7419', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7420', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7421', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7422', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7423', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7424', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7425', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7427', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7428', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7430', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7431', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7432', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7433', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7434', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7435', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7436', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7437', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7439', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7441', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6521', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7443', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7444', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7445', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6494', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-11473', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15740', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15742', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1575', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15754', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15762', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15767', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15774', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15782', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15784', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6496', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-1233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5917', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1759', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5922', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1763', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1244', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1764', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6513', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-6516', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-1771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6520', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-6522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6528', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-1776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-14993', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1501', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6887', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-15010', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6891', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2017-15016', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1502', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15025', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2012-6661', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15030', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3620', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3621', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2012-6682', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-0979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15395', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-1311', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-15359', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11213', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1133', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7289', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5443', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5779', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7302', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7304', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11242', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5465', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-11444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11245', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7316', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5441', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7292', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-5444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7294', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5448', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-11415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15377', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15385', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11233', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1114', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2013-7329', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7446', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7447', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7448', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7449', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7450', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16361', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-7452', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7454', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7455', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7456', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7457', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7458', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7459', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7460', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7461', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7462', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7463', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7464', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7465', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7466', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7467', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7468', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7469', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7470', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7471', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7472', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7475', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7476', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7478', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7481', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7483', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7484', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7485', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7486', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7487', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7488', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7490', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7491', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7492', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7493', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7494', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7495', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6523', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7497', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6524', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7498', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6525', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7499', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7501', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7502', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7505', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7506', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7507', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7508', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7509', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7510', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7513', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6499', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15810', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6500', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1583', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6505', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-15864', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1369', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-11662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6512', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15875', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15878', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6532', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6537', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-6539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1255', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11674', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15886', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6540', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-6542', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6546', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-6549', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-15887', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15891', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5931', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1386', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5555', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5560', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7334', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5576', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7335', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5584', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5586', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5591', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5600', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5607', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5612', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5620', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5629', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5635', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5664', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5683', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5704', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5717', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5727', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7343', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5733', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5746', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1402', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2012-6695', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5629', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3634', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3635', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5635', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5579', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5601', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5609', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5617', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5621', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5624', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5631', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5645', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5648', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5660', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5666', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5672', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5677', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5699', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5707', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5722', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5728', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5732', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5739', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5743', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5755', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5759', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5764', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5767', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5771', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5775', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5777', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5786', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5801', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5815', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5817', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5820', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5829', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5845', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5854', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5856', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5860', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5868', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5798', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11469', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5922', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5928', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5932', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15408', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11276', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-3976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6151', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6161', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6168', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-6172', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1545', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7432', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1551', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7436', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-11520', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6192', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6195', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6214', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7444', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-5520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5524', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5527', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5536', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7330', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-5557', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5563', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5565', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5577', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5578', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5583', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5588', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5589', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5596', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5610', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5616', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5630', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5646', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5650', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5663', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5671', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5685', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5690', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5696', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5702', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5719', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5724', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-5734', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5750', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5763', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5766', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5769', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5773', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5788', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5802', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5804', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5806', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5826', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5828', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5832', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5840', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5849', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5878', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5879', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5887', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7349', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7350', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-5891', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5897', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5901', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5908', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7352', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5917', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5924', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5926', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7353', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2021-1388', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-6563', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1277', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2023-1809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6569', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-4108', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6578', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-6581', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-6587', 6.4, 'AV:L/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-4110', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1591', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6592', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-15917', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6597', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-1592', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6602', 9.2, 'AV:L/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2020-11710', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6603', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-15923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6609', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-6610', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-1593', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6053', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5806', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6054', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-6055', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15424', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-15872', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6533', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15883', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5928', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15893', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15894', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6557', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2022-1273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6562', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-11698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6567', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-15897', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1553', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3992', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-11535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5507', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-5516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-5534', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5537', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5541', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5543', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5545', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5547', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5548', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5556', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5558', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5561', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5566', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5570', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5573', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5594', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5602', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-5622', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1540', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5634', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5643', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5647', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5659', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5665', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5674', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-5977', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5991', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5992', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6004', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6008', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6018', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6031', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5801', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5944', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5957', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5960', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5963', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5964', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5967', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7368', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6000', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6003', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-1148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6032', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2013-7376', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3946', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3947', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-1131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1283', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6576', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-6577', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2014-6582', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6586', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2017-15906', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-11708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6593', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2017-15914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4113', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6595', 4.9, 'AV:L/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-6596', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6598', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2014-6599', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2017-15920', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4114', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15924', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6607', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5210', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1137', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5213', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2012-6709', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11038', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2014-5220', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1143', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5647', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2021-1185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6987', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15090', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5654', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1436', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1453', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-1464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5666', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15098', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-1473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5671', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15938', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6619', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5947', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6620', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6623', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1296', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-1297', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-6626', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5951', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-6627', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2022-1299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6628', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-6632', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-6086', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7420', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-5809', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6096', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6099', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-6100', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11275', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15429', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5985', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5986', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5993', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5998', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6006', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6010', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6014', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6015', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6020', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6024', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6029', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2017-15411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15931', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15937', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-6937', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5638', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2013-6954', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11037', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-6978', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-5644', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6986', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-1209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-6992', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11048', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-5241', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11050', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5662', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2023-1467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1224', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-5804', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6048', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5810', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7426', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7387', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6047', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-11270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7388', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-15419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-5742', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5751', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5774', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5785', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5794', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5796', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5809', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5797', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5835', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15405', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5307', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-15120', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6261', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-11576', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6269', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-7475', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6276', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6277', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-5825', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-11587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6289', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4028', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4029', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-11592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7490', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-11324', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4043', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1639', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1642', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1165', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-1649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5682', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1487', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1492', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1018', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-5274', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-3646', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15114', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3649', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3652', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11493', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2013-7391', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6051', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1172', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4060', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-6315', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-6329', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-15611', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6368', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6375', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6408', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-4074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4082', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1679', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11620', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6668', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6674', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6678', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6683', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6687', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6690', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6692', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6695', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6700', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6701', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6709', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6715', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6725', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6729', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6734', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6736', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6740', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6743', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6746', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6749', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6751', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6757', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6758', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6765', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5690', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2015-5692', 10.0, 'AV:N/AC:M/Au:M/C:C/I:C/A:C'),
('CVE-2021-1257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7060', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-1258', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5704', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5705', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-11145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7064', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2016-3685', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7074', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-7080', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-1516', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11089', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-1269', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-5334', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3696', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-5335', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1056', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15193', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15195', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15204', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15210', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5717', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2021-1276', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-15218', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5344', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5350', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7127', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1550', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3714', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5881', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5883', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5884', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5919', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5925', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5799', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6679', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6682', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6689', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6698', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6702', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6710', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6712', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6722', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6731', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6738', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6741', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6742', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6745', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7142', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1555', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-5368', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5377', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15244', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5731', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3723', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5737', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6060', 2.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-7401', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2013-7405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-15425', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-5958', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11255', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-5978', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5983', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5984', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5988', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5997', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6009', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6182', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-3981', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3983', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-11519', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6184', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-6188', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-7440', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6211', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7442', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-6212', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2020-11522', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2017-1552', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15525', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7448', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11527', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11284', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-5816', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6902', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11735', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6934', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6945', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6946', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6948', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6952', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6954', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6961', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6962', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6963', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15997', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15999', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6966', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-6769', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6771', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6774', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6777', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6783', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6785', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6787', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6791', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6793', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6795', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5964', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6802', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6806', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6810', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6816', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6818', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6819', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6822', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6823', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6824', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15950', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6829', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6832', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6837', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6838', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6840', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6843', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6844', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6847', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6851', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6852', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6854', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6856', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6858', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6860', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6862', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6864', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6866', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6867', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6868', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6870', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6872', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6874', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6877', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6880', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15953', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15954', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-11733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15955', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6881', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6882', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6883', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6884', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1596', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-3990', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15530', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15532', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15533', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11286', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-6242', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-3999', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4001', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-4002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4015', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6273', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15572', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11583', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1160', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6093', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6097', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-3969', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6101', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6114', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6130', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7424', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-3974', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-6139', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6064', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6070', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6074', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-3957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6076', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6077', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15426', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-6432', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-15684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6451', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-6455', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2020-11633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1136', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11368', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11373', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11375', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6466', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-11384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-1351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1197', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-11395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11397', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15706', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-1733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-5895', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-6107', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6111', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7422', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-6125', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6129', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-6131', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6133', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6134', 2.9, 'AV:L/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2020-11508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6140', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6141', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2014-6144', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6147', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6155', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-3977', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6171', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6178', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6179', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7438', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15528', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-6234', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5817', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-3995', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15534', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1155', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2013-7461', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-11554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1555', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-7469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1157', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-5323', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15135', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5700', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2015-5703', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-11143', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3954', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6041', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2013-7384', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-15417', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-15715', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11459', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-11649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1229', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15741', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15751', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15763', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15769', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15773', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15780', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15803', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1544', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-5411', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-1530', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7249', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7250', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2013-7252', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7067', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-1050', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2013-7071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7078', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2013-7082', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3691', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15185', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7092', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-15192', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-3702', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15198', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-1544', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:N/A:H'),
('CVE-2020-11097', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2016-3706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15221', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5346', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7111', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1552', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1560', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2013-7143', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1562', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5376', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-15243', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15256', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15259', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5385', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-1579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7187', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7188', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7201', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-3726', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-11507', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6137', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7430', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6145', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-3979', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6167', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6170', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7064', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7067', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7070', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7078', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7079', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7083', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7085', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7087', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7090', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7091', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5997', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-7092', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7093', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7102', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7107', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7111', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7123', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7127', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7136', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7137', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-7139', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7142', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2021-1412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6009', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5920', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-1760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1365', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-15863', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6506', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11659', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-15865', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1248', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-11661', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-6507', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-6514', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6519', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-1769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1557', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-4024', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11581', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4025', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-11589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1626', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1640', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6297', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11344', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4059', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11354', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6335', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6347', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6361', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6363', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6369', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6132', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-5811', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11277', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-6160', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-11512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-3982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1550', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-11518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15517', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6191', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6199', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6221', 9.2, 'AV:N/AC:L/Au:N/C:C/I:C/A:N'),
('CVE-2022-1145', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15870', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15877', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15879', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6531', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6536', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-1779', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6544', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2020-11684', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-11685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6552', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1787', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-5930', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6555', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1387', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-1805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6909', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6911', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6916', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6919', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6922', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6925', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6928', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6931', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6932', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6936', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6942', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6944', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6951', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6955', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1402', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2014-6969', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6972', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6975', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6977', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6979', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6981', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6983', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6998', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7005', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7008', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7012', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7015', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7018', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7021', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7038', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7048', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7049', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7052', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7053', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7054', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7057', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7058', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7061', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1601', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7065', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7068', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7072', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7073', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7075', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7076', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7077', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-3727', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15279', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7225', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2013-7231', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-15281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15289', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2013-7242', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-15303', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11619', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15646', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4081', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15519', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2014-6229', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-1807', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-11699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1170', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6568', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-6574', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6585', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2020-11707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4112', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6590', 4.9, 'AV:L/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-6591', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2023-1812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6236', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6238', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-3993', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6240', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6251', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2013-7460', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-5820', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15548', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6259', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11289', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-15566', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11580', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-6283', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-15575', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2013-7480', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1532', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5425', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-1614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7256', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15310', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11199', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1558', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11323', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-1628', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1631', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1638', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4046', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-4047', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6300', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6323', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6331', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2013-7459', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15536', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11547', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6256', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7464', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15546', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7134', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6005', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-16019', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1411', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-7143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6008', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7278', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7279', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1709', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6463', 2.9, 'AV:N/AC:L/Au:M/C:N/I:N/A:P'),
('CVE-2019-1137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11372', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11380', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11387', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-15700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6469', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2021-1354', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6476', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-4064', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1180', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-4071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4086', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1678', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1186', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15576', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5826', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11294', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15582', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6290', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6291', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4041', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-1624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-1629', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7491', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-1644', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4051', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4054', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7288', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7158', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1602', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-6030', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16021', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7180', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6032', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-16023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6038', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-11759', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6064', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-1850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6069', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6074', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-7187', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6078', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6080', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6094', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6107', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6122', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6124', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6134', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1332', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-6138', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7193', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-6143', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6146', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6148', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6151', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6154', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6157', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6160', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6177', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6184', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16031', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1335', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6330', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6337', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6339', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-6343', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-4062', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6348', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6351', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6354', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6357', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6374', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-4063', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6387', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-1669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1564', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15644', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-4072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4076', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4077', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4080', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1565', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15652', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-15653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6428', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5449', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15371', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-15376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11232', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5785', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5461', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11437', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15389', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-11560', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6270', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15571', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7476', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6278', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-6280', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7479', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11588', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2013-7486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6292', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-6293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-1634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1636', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-11325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11334', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1134', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6303', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6308', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11614', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6316', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-6325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6327', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6336', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6340', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6346', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6014', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6015', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-7152', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11478', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5954', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6637', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6640', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6642', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6647', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6649', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6653', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6656', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6659', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6662', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6669', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6672', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6676', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6681', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6685', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6688', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6691', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6699', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6703', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6707', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6711', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6713', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6718', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6720', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6726', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6730', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6735', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6752', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6756', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6759', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6763', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6766', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6775', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6778', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6781', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6789', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6798', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6799', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6805', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6807', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6813', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6814', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6825', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6828', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6831', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6833', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6834', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6835', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6836', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6839', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6841', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6842', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6845', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6846', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6848', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6850', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6853', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6855', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6857', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6859', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6861', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6863', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6865', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6869', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6871', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6873', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6875', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6876', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6878', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6879', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6885', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6886', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15962', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15963', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6425', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6445', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1191', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-6459', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11360', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11363', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11383', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11340', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6302', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1664', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-1665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6334', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6342', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6345', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6350', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6353', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6366', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6376', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-4066', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15639', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15643', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4083', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6439', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1569', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6452', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6460', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2022-1192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15691', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11366', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4093', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6474', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2016-4094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1201', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-11401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1736', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6478', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11404', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1745', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15713', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16035', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6237', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7194', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2022-1336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16039', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7195', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-6240', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6245', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6249', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2023-1856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7199', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11760', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-6250', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-6251', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16041', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7200', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6360', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6362', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6364', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6381', 2.9, 'AV:A/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-6389', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15642', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4073', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4085', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1677', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6414', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-15651', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11628', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6421', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6426', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-15683', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-15685', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-15687', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7318', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7319', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-15394', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-1836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7181', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16022', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6033', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6035', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6039', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6045', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6047', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6049', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6051', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6056', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6061', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16025', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6066', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6068', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1331', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-6071', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6072', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-7186', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6076', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6079', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6081', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6084', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6086', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6088', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6091', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-11403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1355', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11406', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11429', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15722', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1364', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15811', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6504', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1368', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6515', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-1768', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15664', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15665', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15672', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11419', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11428', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11445', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15720', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1222', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15744', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15753', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15758', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15768', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15776', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15781', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15783', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6093', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6096', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6099', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7191', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2021-1417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6114', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6118', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-7192', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6136', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6139', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6141', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6144', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6147', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-16029', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6150', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6153', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6156', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6159', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6161', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6165', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6166', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-5532', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5539', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5549', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-5793', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5590', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5597', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5604', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5627', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5636', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5637', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5640', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5652', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5655', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7275', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6457', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2014-6461', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2020-11634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15694', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1138', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6472', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-1203', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-1738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6483', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2023-1744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15714', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11426', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15718', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6485', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1213', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-15965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6892', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6894', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6895', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6897', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6899', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6900', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6904', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6905', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6907', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5986', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-6913', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6914', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6917', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6921', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6923', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6926', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6929', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11736', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-11737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6935', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6937', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6939', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6941', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6943', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6947', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6949', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6957', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6960', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15998', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6965', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1600', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6967', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16001', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6973', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6976', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6982', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6984', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6986', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6987', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6988', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6989', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6990', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6991', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6992', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7000', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7002', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6488', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2019-11450', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15721', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11456', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6491', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15730', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15731', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11472', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-5909', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15738', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15745', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15752', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15757', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15777', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15787', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15812', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15869', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15874', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1534', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1130', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11215', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11223', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15375', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5453', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2013-7300', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-15387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15680', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-6420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6430', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-1163', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5721', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5725', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5731', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5735', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5740', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5748', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5762', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5776', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5791', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5798', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5808', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5812', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5822', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5830', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5834', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5837', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5839', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5841', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5843', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5855', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7346', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7347', 6.4, 'AV:L/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2014-5862', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5864', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5869', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5872', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5876', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-5886', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5889', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5890', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5892', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5894', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5896', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5906', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5907', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5910', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5913', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5918', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5923', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5927', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5930', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5933', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5936', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5938', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5940', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5945', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5949', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5951', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5956', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5959', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7354', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-5972', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5979', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5981', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5990', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5995', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5999', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6002', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11268', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6016', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6021', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6027', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3941', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6034', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6035', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11269', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2014-7006', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7011', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7019', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7024', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7027', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15719', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-15727', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15728', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11460', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-15729', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11466', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-11471', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15747', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15748', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15755', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15760', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1577', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15789', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15802', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1235', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2017-15809', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1238', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1366', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1418', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7201', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7202', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7203', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16045', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16057', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16059', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16070', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16071', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6254', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2023-1862', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-6256', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-7206', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-4131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7208', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6259', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2022-1343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-1865', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2015-6261', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-6262', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1344', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-7216', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-7217', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6266', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6274', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6277', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-1867', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-7221', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1345', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-11761', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1806', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15896', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-6566', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2023-1810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1249', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-6517', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-11663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1252', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-11666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15873', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-1777', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6530', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-6535', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-6538', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2020-11671', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-11673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11676', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11677', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15884', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1256', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11683', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6545', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2023-1784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11686', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6554', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2023-1788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-1774', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-6526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15880', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1372', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6523', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6525', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6527', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-15871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1118', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6541', 6.9, 'AV:N/AC:M/Au:S/C:C/I:N/A:N'),
('CVE-2023-1782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5929', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15890', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6551', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1795', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4105', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1270', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6558', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2017-15895', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6560', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2016-4106', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5802', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6037', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3952', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6039', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5803', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7382', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-15416', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-1268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6559', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6561', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-11701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6573', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1284', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-6588', 4.9, 'AV:L/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2016-4111', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6589', 4.9, 'AV:L/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2017-15911', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6594', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-1290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15918', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15919', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6287', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6288', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6291', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-6293', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2015-6296', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6299', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6300', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-6303', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6304', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6306', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6307', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-1869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1347', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-16084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7226', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16085', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16088', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-1871', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1350', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6316', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6317', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6322', 9.2, 'AV:L/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2022-1351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6329', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6331', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6345', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-16092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16093', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6347', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-16095', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16096', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16097', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6353', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6355', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6548', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-15888', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6571', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6579', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6583', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2016-4109', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-5657', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1121', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-15921', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15922', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4115', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4116', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15933', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15936', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15939', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5948', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15928', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15932', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4118', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5946', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6611', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5949', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5950', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6625', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-5952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6631', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11718', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-11719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5953', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1172', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6633', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6635', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6638', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5955', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6641', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6643', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6648', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11271', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6049', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2013-7390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6050', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-6601', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-6604', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-6357', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16099', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1352', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1427', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16108', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-5684', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5711', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5715', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5744', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5756', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5757', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5765', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5770', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5772', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5799', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15404', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15423', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1430', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16111', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16114', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7231', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1437', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1883', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-1365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1438', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7235', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16117', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16118', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-5870', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5871', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16119', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16120', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16122', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1889', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-7236', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-1371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16124', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16125', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7237', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16126', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16129', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16131', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1900', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7248', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6360', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16137', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-6364', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-11764', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6088', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6090', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7416', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-3958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-6636', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6639', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-6646', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1302', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6651', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6654', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6657', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6660', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6663', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6664', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6665', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6666', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6667', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5956', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6673', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6677', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6680', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6686', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6694', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6697', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6705', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6724', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6737', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6744', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6747', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6753', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6754', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6760', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6764', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6767', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6770', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6772', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6773', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6776', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6779', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6782', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6784', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6786', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6788', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6792', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6794', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5963', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6797', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6800', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6804', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6808', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6812', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6817', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6820', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6821', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1595', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6826', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6827', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6830', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1306', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-6671', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6675', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6684', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5957', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-6693', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6696', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6704', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6708', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6714', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6719', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6723', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6728', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6732', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-6706', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6716', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6717', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6721', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6727', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6733', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6739', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6748', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6750', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6755', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6761', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6762', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6768', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6780', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6790', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6796', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6801', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6803', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6815', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-5934', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5935', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5937', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5939', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5946', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5948', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5953', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5954', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11470', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-5961', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5966', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5969', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5970', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5973', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5974', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-5975', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-16139', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6376', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1909', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-16140', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6384', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6386', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16144', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7428', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6146', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-6150', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-6154', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-6159', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2014-6166', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-1546', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1548', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15515', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15516', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7437', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6186', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-6193', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2014-6209', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2013-7441', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2013-7443', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11521', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6228', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11523', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11524', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6230', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-11732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-5968', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-5970', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6887', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6888', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-11533', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-3998', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6252', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-11287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2013-7462', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7467', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15549', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6258', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6260', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6272', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4021', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2013-7474', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11582', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2013-7478', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6284', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4026', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7385', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15418', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-6889', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6890', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6891', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15967', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6893', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6896', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6898', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6901', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6903', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6906', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6908', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6910', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6912', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6918', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6920', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6924', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6927', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1597', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6930', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6933', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6938', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1598', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6950', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6953', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6956', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6940', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6958', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6959', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15996', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6964', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6968', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6985', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6993', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6994', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6995', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6996', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16005', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-6997', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6999', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7001', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7004', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7007', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7010', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7013', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7016', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7020', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7022', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7026', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7028', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1309', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-15420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2013-7398', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-5807', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P');
INSERT INTO `tpandora_cve` VALUES
('CVE-2013-7402', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-6970', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6971', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6974', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6978', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6980', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16003', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7003', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7009', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7017', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7023', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7025', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7029', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7030', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7031', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7032', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16007', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7033', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7034', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7035', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7036', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7037', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7039', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7040', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7041', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7042', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7043', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7044', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7045', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7046', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7047', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7050', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-15580', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6299', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-1161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1661', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15602', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15609', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-6328', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-6333', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-6341', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-15612', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6356', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1668', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2017-1563', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15640', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15648', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4078', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4084', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1689', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7115', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7119', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7122', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7129', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7132', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16015', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16018', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6006', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6007', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7141', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2022-1313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7055', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7056', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7059', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7060', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7062', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7063', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7066', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7069', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7071', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7080', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7082', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7084', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7086', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7088', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7089', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11749', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-7099', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7101', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7104', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1825', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7108', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7109', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7113', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7118', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7121', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7125', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7128', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7131', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7135', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1312', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-6102', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-6112', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-1835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7176', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1325', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-11525', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-5815', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2013-7449', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-15527', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6233', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2013-7450', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2013-7452', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-3991', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2013-7456', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2016-3994', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2014-6241', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11538', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11541', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-5819', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-15538', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-5821', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7098', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7100', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7103', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7106', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-5998', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-7116', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7117', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7120', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7124', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11758', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7157', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7169', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-7170', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6021', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6029', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7178', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6031', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1416', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-1839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1328', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-15673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4090', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6429', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-6438', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-6453', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-6462', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1711', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1193', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6052', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-1844', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-6065', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6082', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6092', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6106', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-4126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6010', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6011', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-6012', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-6013', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1832', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-7151', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7153', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11288', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15698', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15705', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-1737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15709', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6480', 10.0, 'AV:L/AC:L/Au:M/C:C/I:C/A:C'),
('CVE-2023-1742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11408', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11452', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-15732', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6022', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7177', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-15739', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15750', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15759', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15765', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15772', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15786', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15801', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-1754', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-6498', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-1757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6503', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6034', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-1843', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-6037', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6040', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6042', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6044', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6046', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6048', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6050', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6053', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6055', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6059', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-1846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6070', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-7185', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2015-6073', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6075', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6077', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-7189', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7190', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6083', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6085', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6087', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6089', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6108', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-16026', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6115', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-6117', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6123', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16028', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-6135', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6140', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6142', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6145', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6149', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6152', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6155', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6158', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6162', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6164', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16030', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6172', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-4027', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-15581', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2013-7484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11591', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-5828', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2013-7489', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4042', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1630', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1633', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1641', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1133', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6392', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4065', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6407', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-6409', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6412', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4079', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1672', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-6431', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6465', 6.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:C'),
('CVE-2014-6468', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2020-11641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11390', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-11391', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-6477', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2019-11396', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15707', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-1739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1571', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6479', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1207', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2019-11410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6486', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2019-11446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11449', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1215', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1357', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6492', 10.0, 'AV:N/AC:H/Au:N/C:C/I:C/A:C'),
('CVE-2022-1220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-15735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15737', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15746', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15749', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-6495', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-15761', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15764', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15778', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-15779', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4099', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15806', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1756', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1236', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-6502', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2022-1239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-15867', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6511', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-4102', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-15876', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6534', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2020-11675', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1257', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6543', 4.9, 'AV:N/AC:H/Au:S/C:P/I:P/A:N'),
('CVE-2014-6547', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-6550', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1783', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-1786', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-6553', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-15892', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-1793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6556', 6.4, 'AV:N/AC:H/Au:S/C:P/I:P/A:P'),
('CVE-2020-11692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-1800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-1804', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-6564', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2022-1278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1396', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-11704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6572', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-6580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-1811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-6621', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6622', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-6624', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2023-1816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-6650', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6652', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6655', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6658', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-6661', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1399', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-6670', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7515', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7516', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7517', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7518', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7519', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7520', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7521', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7522', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7523', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7524', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7525', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7526', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7527', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7528', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6527', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-7529', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6528', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7530', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6529', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7532', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7533', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7534', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7535', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7536', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7538', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7539', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7542', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7543', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7544', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7546', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7547', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7553', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7554', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7555', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7557', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7558', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7559', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7560', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7562', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7563', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7564', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7565', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7566', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7567', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7568', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7569', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7570', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7571', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7572', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6530', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7573', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7575', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7576', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7577', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7578', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7580', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7581', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7582', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7584', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7585', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1389', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-7591', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7592', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1480', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7593', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7595', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7596', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7597', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7598', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7602', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7603', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7604', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7605', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7606', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7607', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7608', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7609', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7610', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7611', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7612', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7613', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7614', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7616', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7617', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7618', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11545', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7620', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7621', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7622', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6535', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7624', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7626', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7628', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7629', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7631', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7632', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7634', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7642', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7644', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7646', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7647', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7648', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7649', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7650', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7652', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7655', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7656', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7660', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7661', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7663', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7664', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7666', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7667', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7670', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1486', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7676', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6544', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7681', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7682', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7683', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7685', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7686', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7688', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7689', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7691', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7692', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7694', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7696', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7698', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7700', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7701', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7703', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7705', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7712', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7714', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7718', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7720', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7722', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7724', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7726', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7727', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7728', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7731', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7733', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6547', 10.0, 'AV:N/AC:L/Au:M/C:C/I:C/A:C'),
('CVE-2014-7737', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7739', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7741', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7742', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7743', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7745', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7749', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7751', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7754', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7756', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6548', 6.4, 'AV:N/AC:L/Au:M/C:P/I:P/A:P'),
('CVE-2014-7760', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7762', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7764', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7766', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7768', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7770', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7772', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7773', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7774', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7775', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7776', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7777', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7778', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7779', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7780', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7781', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7782', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6549', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7783', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6550', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7785', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7786', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6551', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7787', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7789', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7793', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7795', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7797', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7799', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7550', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7551', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7552', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6555', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2021-1488', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7810', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2021-1489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1492', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-1405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7587', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7589', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7590', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7816', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6569', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1493', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-1411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7630', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7633', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7636', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7638', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7640', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7643', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7659', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7668', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7671', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7674', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7677', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7690', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-7693', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7695', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7697', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7702', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6545', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6546', 6.9, 'AV:A/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-7707', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7708', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7710', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7713', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7715', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7716', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7717', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7719', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7721', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7723', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7725', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7734', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7735', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7740', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-1994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-7744', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7746', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7748', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7750', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7752', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7753', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7755', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7757', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7758', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7759', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7761', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7763', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7765', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7767', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7769', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7771', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11546', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6581', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1155', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6582', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7784', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7788', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7791', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7794', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7796', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7798', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7800', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7802', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7803', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7804', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7807', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-16363', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7809', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6556', 2.9, 'AV:A/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-6557', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7811', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7812', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7814', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1402', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2014-7815', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6563', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1404', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-4152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6564', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-6565', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6566', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7817', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7818', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-1414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-6567', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6574', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-4153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6576', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6580', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16366', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-11554', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6587', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2016-4157', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6588', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4158', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11555', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7938', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7819', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6583', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7940', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11564', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1420', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11550', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6585', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7821', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-11551', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-7823', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7824', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-4155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11687', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11688', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-11689', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7935', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1180', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11814', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-11815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7978', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7980', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7982', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7984', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7985', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11695', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-7942', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11552', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11691', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-1522', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-7987', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20020', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-20022', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11714', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8000', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-11556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1502', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11565', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11567', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1421', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-11574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6591', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1503', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11576', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7827', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7828', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11577', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11578', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16368', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7831', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-7832', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-7833', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-7834', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-7835', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2014-7836', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1426', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1515', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-11698', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1502', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-11699', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11700', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-8001', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16390', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8008', 6.9, 'AV:N/AC:L/Au:S/C:C/I:N/A:N'),
('CVE-2014-8010', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11867', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1544', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-20043', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20017', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-11694', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-1518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11701', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1519', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-11703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11798', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7960', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2020-11806', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11810', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-11812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11821', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11827', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7979', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7983', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11708', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-11839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11840', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6697', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11736', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11894', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-1555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8100', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11900', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2014-8102', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-11692', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11583', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11584', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7846', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-7847', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16370', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11712', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8106', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11904', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-11741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8112', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-8117', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1566', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8119', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11910', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8121', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8122', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-11913', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-11743', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8127', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-20056', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20016', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2014-7941', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-7851', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1432', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11586', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-16371', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1434', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7947', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-4164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11590', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1441', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6655', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6659', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6661', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6663', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6665', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11592', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6668', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6670', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1444', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11595', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-4169', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7862', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1452', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-4192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11865', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8026', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8068', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8070', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8072', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-8076', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11727', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-11728', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2019-11697', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-11939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4202', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1586', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-11947', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-4203', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-8152', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-8156', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1601', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-6705', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8163', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-8168', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-1613', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-11756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7957', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7967', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11883', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1530', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-1547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8088', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-11885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8090', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8091', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2020-11887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8092', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-8093', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6698', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11891', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-11895', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-1554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11738', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2017-16394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1520', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-20021', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20023', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7994', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7995', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-11856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7999', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2019-11716', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-11860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8003', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-11864', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11718', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1534', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-20032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11597', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-1453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11600', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7864', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7866', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7868', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7869', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-7870', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7871', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-11601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7872', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1507', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-8527', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2022-1749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8528', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-11952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6812', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2019-11953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6816', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20217', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8534', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8539', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6825', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6828', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8543', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16553', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6831', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-11971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8554', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8567', 9.2, 'AV:N/AC:L/Au:N/C:N/I:C/A:C'),
('CVE-2015-6839', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6843', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6846', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1779', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-20243', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-20252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11987', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1783', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-16560', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16574', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-16580', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-20266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8175', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-8177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4208', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-8182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6708', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8101', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-8104', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2016-4198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11906', 3.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-1564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8120', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1572', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-4200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11931', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1580', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8138', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-1584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6702', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-8143', 10.0, 'AV:N/AC:M/Au:S/C:C/I:C/A:C'),
('CVE-2022-1589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1544', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8021', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8024', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-8025', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-8034', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16391', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8078', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1545', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1536', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7986', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-7829', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7830', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11579', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1459', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2019-11602', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7874', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11603', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11604', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6773', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1592', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-1593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-11747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8150', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1598', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8151', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-1600', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-8157', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11890', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-20047', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11901', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-20051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1561', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-11905', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8116', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20052', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8123', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1573', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-20055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8124', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1515', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11841', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-7988', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2023-20019', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11710', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7991', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6677', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-1999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7885', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7888', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20002', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-11605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11606', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11607', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11608', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-11609', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-1466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1467', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-1161', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-11610', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11611', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1468', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-11612', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11613', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11614', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11615', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7889', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11619', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11620', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11621', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11622', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11623', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11624', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11625', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11626', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7837', 4.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:P'),
('CVE-2014-7838', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7839', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2017-16369', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-1505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6607', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1427', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11581', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1428', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-1611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8162', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8164', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-16401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8169', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-8174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1546', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8180', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6707', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1619', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8248', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-8266', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8267', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8498', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-20212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8502', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1711', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6783', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8514', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8519', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8520', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6788', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16597', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16601', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16606', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8604', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-2029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1430', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7848', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7849', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-7850', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7852', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11585', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7853', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-11587', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11588', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-11923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1575', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-1576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16397', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1581', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-8139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8140', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8142', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8144', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7891', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7892', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11632', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-7894', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7895', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1476', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-6679', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-11637', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11641', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6681', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-7896', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4165', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1437', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-11589', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6658', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6660', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6662', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6664', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11593', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6671', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11594', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1451', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-4167', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4168', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4170', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6674', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11596', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11598', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-1455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8002', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11863', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1537', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-8075', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8080', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8082', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-20044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8085', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16392', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8525', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8526', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1739', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11956', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6822', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8537', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11963', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11967', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8555', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6862', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8578', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-16561', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8584', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16583', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16593', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6919', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6920', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8603', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1793', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-2032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16636', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6943', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2023-2042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6961', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-2006', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8147', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-20069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16400', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8161', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8167', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-8170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20075', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1778', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6849', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2022-1780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1782', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1199', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6863', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-4260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16569', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16571', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16584', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-4264', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2014-8591', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8593', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16598', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16602', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6914', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-16609', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8601', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-8606', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1794', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16614', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6929', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11997', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6938', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-2035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6942', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11999', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-6944', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8629', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4268', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8632', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-4195', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1535', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1537', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8096', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11896', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-8099', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11898', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-11899', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-2046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8302', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-20085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8305', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2023-2009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8306', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6706', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8183', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-16403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16404', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8269', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8293', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6676', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-1995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-1996', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7878', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7880', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-7882', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-7883', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7884', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2022-1714', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-6759', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8109', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8115', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11907', 3.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-11908', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-1567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11909', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1569', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16396', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6701', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-8128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-8129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1623', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1627', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-11768', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11769', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11775', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-16406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8268', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-4214', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8270', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-8271', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-8275', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-8295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12043', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16659', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8652', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16672', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8686', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6992', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8712', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1848', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-8732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1806', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16663', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12067', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-1208', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16665', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16666', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-8671', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-12099', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8703', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1844', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1845', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-8727', 9.2, 'AV:L/AC:L/Au:S/C:N/I:C/A:C'),
('CVE-2014-8728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16724', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16728', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-1640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7898', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7900', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1591', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-11746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8153', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2023-20068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1202', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-1203', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12041', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1809', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4270', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16653', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8641', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-8651', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16670', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16671', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-8678', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-16674', 6.0, 'CVSS:3.0/AV:A/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-1838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8704', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1211', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8723', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8724', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1847', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-11777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6711', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11780', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-16407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8272', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-4215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8296', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6712', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-20081', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8298', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8339', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8349', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8355', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-7890', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11628', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6678', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11629', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7893', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11633', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1475', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11636', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11638', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6680', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20008', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-16376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7897', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8762', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8772', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8780', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-4205', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1850', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-12119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8738', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8747', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8752', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7002', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1851', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8308', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8309', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8314', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11806', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8326', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8327', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2022-1641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11928', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8474', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6682', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-7901', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11785', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20088', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11786', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-20096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8312', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-8317', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8320', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8321', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16409', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11809', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20098', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-8325', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-2010', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-20101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6714', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11814', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8347', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1567', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6716', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6717', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1572', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8368', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-8372', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-8377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8379', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8380', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8386', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-20121', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8390', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8366', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1658', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2014-8367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1662', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8373', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-8376', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6719', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11832', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8485', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8492', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1641', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-4242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8495', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-1643', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1647', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6778', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11649', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11812', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8336', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8350', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11815', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8360', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11820', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1653', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-11823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8370', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-8375', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-4225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1615', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1616', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8363', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1663', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-16415', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6720', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2013', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-20127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8413', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-11846', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1677', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-8420', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2021-1580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-8503', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1713', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1716', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8513', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6785', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-20035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9679', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-20658', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-12453', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12174', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4286', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8874', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-11981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8887', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-8890', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-4291', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4292', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4294', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4296', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8892', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-8898', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7899', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-7012', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-12156', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7014', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-12158', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1585', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6724', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-20152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11867', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8439', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6733', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2021-1599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8398', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8412', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-11840', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8415', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11842', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6721', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8417', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1674', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1684', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-8429', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1697', 3.4, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-2015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6805', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1740', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1742', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1744', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1747', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6807', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-6808', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6810', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16551', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1759', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6829', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4250', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8545', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8547', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8551', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8553', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8557', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12465', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-12391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17620', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7615', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17655', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2067', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-12472', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4728', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1767', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17675', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17681', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17688', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12482', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20093', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-17719', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8440', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6746', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-20182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20183', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-6756', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16555', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6851', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-1781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20253', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6861', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16573', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-16578', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16586', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16590', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8596', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16594', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6913', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6915', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1791', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2015-6923', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16613', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6932', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-1796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20166', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11869', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6727', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-11876', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1652', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11881', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-16521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16524', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8426', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1687', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1690', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-1589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1651', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11871', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11875', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11880', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6734', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8870', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-8871', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8442', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1615', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-1653', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11924', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20192', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-1715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1716', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1617', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-6760', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12240', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8958', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1200', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2014-8988', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2020-12000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4350', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8994', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2016-4353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16775', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9001', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-12006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9006', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-16784', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9024', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9032', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12025', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-16807', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9044', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16814', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12034', 4.7, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:H'),
('CVE-2017-16834', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16841', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12446', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10733', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12458', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17783', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10758', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-17804', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10767', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12577', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20148', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2017', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-7902', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-20009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11644', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11647', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7903', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8438', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1594', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6729', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11886', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11887', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6744', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6745', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1601', 5.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2023-20178', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6755', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6747', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6748', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20184', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1612', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-1709', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11921', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11650', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7904', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12038', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4384', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2016-4388', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12049', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4412', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4436', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9140', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9141', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16876', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12103', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-16881', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16882', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9162', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9164', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11658', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11897', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-11898', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-1192', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-6757', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8449', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6761', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8899', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4311', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16749', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16751', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1221', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4325', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-8943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4331', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-12239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12241', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11997', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8964', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-12001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7049', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4357', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-12014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1720', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7905', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2021-1512', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-11652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11653', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-11654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2001', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-17840', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9713', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2017-17846', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9716', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-17850', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1614', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20193', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8303', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8304', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8311', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-8315', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8316', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8318', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4315', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-8924', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-8927', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4323', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-8940', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12209', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12219', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4330', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-16758', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8949', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2016-4337', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4340', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12247', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16762', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-16768', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16771', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8999', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-12005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12010', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2016-4359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4367', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16789', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9022', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-9028', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9034', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16802', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7090', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2016-4450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4451', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-4455', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4465', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-12143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16922', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9205', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4484', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7104', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12510', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17859', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20199', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9737', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-20716', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20717', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20724', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17879', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9746', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17897', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17905', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2059', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9752', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-10863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9756', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-2066', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-7906', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8446', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8447', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6763', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-2020', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-4239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16539', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8457', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8461', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8469', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8636', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1810', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1666', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2014-8650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8680', 6.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:C'),
('CVE-2022-1831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-16689', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8702', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8705', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12109', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8710', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8722', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9023', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2014-9031', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16796', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9048', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-1683', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9087', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9096', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9102', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-16856', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4397', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9119', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-9120', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4414', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16863', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6683', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7907', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12635', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20729', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20731', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20743', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17945', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-20790', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20801', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2083', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-20830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20842', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2085', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1089', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17987', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7644', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8458', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8459', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8460', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6765', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12124', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-8754', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2017-16733', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8758', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9042', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-9049', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-16829', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16842', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16847', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4381', 3.4, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-12042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16854', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4399', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4404', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4416', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4437', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4441', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-4442', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8472', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16542', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8479', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2017-16547', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6772', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4490', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1698', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4509', 3.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2014-9229', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-9258', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-1701', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4532', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-4537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8484', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-20204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1644', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8499', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-8500', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2021-1651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1730', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2014-8501', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6780', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7908', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8473', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16540', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1193', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16543', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6769', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20238', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9840', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9845', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20241', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20243', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6771', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9137', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1893', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9150', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-7082', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16896', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16897', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7087', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2020-12120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-1214', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1688', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16880', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9158', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7085', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2017-16905', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16908', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7092', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2014-9179', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-9181', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1909', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4467', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16929', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-9196', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-9199', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-12149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9203', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7102', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8494', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6777', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1655', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-1656', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-11826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4542', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17050', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7186', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-7187', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7188', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-17059', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17061', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7193', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-20010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7909', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-20207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16549', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6776', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8521', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-11944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8522', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7912', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20012', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-7913', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4178', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-20013', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-20014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1167', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11674', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-11675', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11676', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11677', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20247', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-18034', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20253', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2026', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-20873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7017', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6775', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4489', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4493', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16950', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9209', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-12247', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2014-9221', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9223', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9225', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-9237', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9242', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9247', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2020-12255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12258', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-9249', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4526', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-7117', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2014-9271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1944', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-20116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8388', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20123', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8393', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8395', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8399', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11838', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8418', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-8421', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1581', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-20136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6784', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4457', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4461', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7096', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16919', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9189', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16927', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1923', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1925', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4474', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4478', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4487', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1934', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16952', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16961', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6781', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11661', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2014-7910', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17068', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4566', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4570', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7212', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1729', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6789', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2014-8515', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8518', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6787', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1695', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1650', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16512', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11879', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16514', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16520', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-20011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11662', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6684', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1485', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9326', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9328', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7216', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9335', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9337', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9338', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9342', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4583', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-17113', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1989', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17128', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1714', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4592', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4848', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4855', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10924', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4859', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7657', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18085', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4867', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4868', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-4872', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4873', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-10931', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4875', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-9260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17023', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7177', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1953', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-11965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6830', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-20224', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8544', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8546', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1769', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8889', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-4287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-12276', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9277', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7180', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8504', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6782', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-7923', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8529', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6815', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-8532', 4.9, 'AV:L/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2022-1756', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-2022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-4543', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4553', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2014-9292', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2016-4561', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17057', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7192', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1965', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-9308', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-9317', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-7293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7295', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7305', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-4610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9414', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-12290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9423', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7319', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7328', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9436', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7335', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9447', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-9449', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1722', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-1705', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7183', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1960', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7189', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9302', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-7195', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-17067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17069', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7202', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1746', 6.0, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-6806', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-6809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8530', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1754', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6818', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11957', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6821', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16552', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6827', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8542', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6832', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-8552', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2023', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20230', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-4252', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8566', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2019-11979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20237', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-11945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8523', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8524', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6791', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10932', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4882', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4886', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20762', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20281', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9918', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20283', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20289', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10945', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4911', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7924', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8548', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16554', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8558', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-11975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8562', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6847', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6853', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-4257', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16557', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1968', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6850', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6854', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-6856', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11989', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16558', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16562', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16572', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6908', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8589', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16595', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6912', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20269', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-8602', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-6925', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8617', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6939', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-2038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6945', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6964', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6966', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-6973', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-12637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10952', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20294', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20773', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10962', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10963', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7669', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12643', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7674', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17080', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7208', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-17089', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4574', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4618', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7348', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7364', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7367', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9477', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9478', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-9479', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-2013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7375', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9481', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6864', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-16575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16587', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8587', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8531', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8533', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6823', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6833', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11922', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8445', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4262', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16581', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6934', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-8621', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16637', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6959', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6965', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1798', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-6971', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8634', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8635', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1803', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:N/I:L/A:H'),
('CVE-2019-12243', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16760', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8955', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8962', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16767', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16769', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11999', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-8986', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8993', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1678', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16785', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16794', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-1202', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9039', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-1681', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16816', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9050', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9483', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7384', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7386', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-9491', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-2024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7396', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-7399', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7408', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7416', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-9496', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7430', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7432', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7439', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7215', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7217', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2022-1985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17099', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1987', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-17114', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9347', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9351', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2016-4584', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7231', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-9354', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-4587', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9374', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2021-20300', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10971', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10972', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10976', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10977', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7675', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18111', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2018-10986', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20305', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4947', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10997', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11002', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11003', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-18123', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-7686', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-2122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4952', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-11973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8561', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4253', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20232', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6844', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11985', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6857', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-6858', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-6867', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8586', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16576', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16589', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-1659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16591', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8630', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-9059', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-16826', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16831', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9093', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4385', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-9100', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9103', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9112', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9114', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4400', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16859', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4417', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4425', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4435', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-16877', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12101', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-17093', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17112', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7226', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-9353', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7237', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-4590', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2015-7244', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9372', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-9378', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7922', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6685', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1488', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-1999', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7266', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1717', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16607', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8605', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8608', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-2031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6931', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8619', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8622', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-2037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4267', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8626', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6968', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1665', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8639', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16654', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8642', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-12083', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16667', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8453', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-8455', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1722', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8471', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-20201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1654', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8478', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-16541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-16545', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1725', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-7927', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4269', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1819', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16661', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8643', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2014-8654', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12097', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12098', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-16673', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8682', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-16711', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12303', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1733', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12308', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9558', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1232', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7459', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7463', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12372', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9575', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-9579', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7687', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8638', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12068', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2014-8655', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-7261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9397', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7304', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-9403', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2014-9413', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-12297', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7310', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-9421', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-9422', 8.5, 'AV:N/AC:H/Au:S/C:P/I:P/A:C'),
('CVE-2014-9424', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7322', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7324', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9427', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7327', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-9438', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9441', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9446', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9448', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7337', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9458', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9462', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9468', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9393', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9398', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9400', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9402', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-9416', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4613', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-12101', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12106', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16690', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8711', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8730', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-8733', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8744', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-12125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8753', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12134', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11952', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8677', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-8684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16683', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8701', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12108', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8713', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-8731', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16718', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16720', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16731', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16732', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2014-8750', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-16735', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-11951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8760', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8761', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8769', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2014-8774', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-12137', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8779', 6.9, 'AV:N/AC:M/Au:N/C:N/I:C/A:N'),
('CVE-2014-8788', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-8789', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9177', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1907', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-7093', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9182', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4462', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1914', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-12144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7928', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8510', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2019-11936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1714', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1715', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1717', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-1733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1204', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-12042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12047', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1205', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16669', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8656', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8683', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16685', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16691', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-9434', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-1720', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-9452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-9464', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7359', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9469', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7362', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7368', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-2010', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:H'),
('CVE-2014-7925', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12135', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8793', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8799', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8801', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8802', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2021-1765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20775', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18184', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7699', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2017-18186', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-20777', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-4957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17423', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12318', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7485', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7101', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-1224', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-1927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7926', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-7929', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8737', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-8746', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2019-12126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8755', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16736', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8763', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-8766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8775', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-12136', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20216', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6820', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8535', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8538', 6.4, 'AV:A/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11962', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8540', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-20222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1771', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11008', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-4964', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-12669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7930', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7393', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7397', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2015-7403', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-7415', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7438', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9509', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7493', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17446', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7498', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7387', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-2023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9490', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7394', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-7402', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7426', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-9497', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7428', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2014-9514', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9519', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7441', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-12300', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1231', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7452', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12360', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-12365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20556', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-12298', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7449', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12312', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7456', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9569', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9572', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9574', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-7470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9587', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7931', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1217', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12176', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1871', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-6686', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1491', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7499', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-12402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7511', 1.4, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17476', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12326', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12414', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9235', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-12252', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2020-12261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9253', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9264', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9270', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9273', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7175', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7176', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6909', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6911', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16604', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-8598', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-8600', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16612', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16615', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6933', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-2033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11035', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20786', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-4976', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4979', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4980', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12696', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4985', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20332', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-20336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4995', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12697', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2014-9593', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-9597', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9600', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12162', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12171', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8869', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-12369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9573', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2015-7469', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9577', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-9581', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-4658', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17408', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17415', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7471', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9605', 9.2, 'AV:N/AC:L/Au:N/C:C/I:N/A:C'),
('CVE-2014-8877', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7033', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4290', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4293', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4295', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1875', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-6687', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7932', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2034', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-20790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17056', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4563', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9310', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7200', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-17081', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7203', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17087', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17424', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12314', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7484', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12395', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12320', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1069', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20613', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-9639', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-17485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1749', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-17504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-20622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17522', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16382', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8873', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8878', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-11991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12190', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8911', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4304', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4312', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16745', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8921', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-12204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4324', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12215', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8952', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2017-16761', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4342', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8966', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1677', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8985', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8987', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8991', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1201', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6975', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16652', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8658', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2014-8670', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2019-12091', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8675', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1669', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12107', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8706', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8716', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7492', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9610', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7542', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9651', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7545', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12432', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1753', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17533', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4705', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-12369', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7561', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16757', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16759', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8948', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8950', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2022-1889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4341', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16763', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8960', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12253', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-4348', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4349', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8996', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-12004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4354', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9005', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7050', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2016-4371', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9018', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-9025', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12021', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-7034', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4298', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8894', 4.9, 'AV:N/AC:M/Au:S/C:P/I:P/A:N'),
('CVE-2014-8897', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-11990', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12189', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8900', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8909', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4305', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4313', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12198', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8920', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8926', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-4320', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1885', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-12208', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16754', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4332', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-1886', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7768', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8893', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4302', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8901', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2019-12196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8913', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4306', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8917', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-12203', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12222', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16755', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8957', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8959', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-12250', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2000', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-20001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9617', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7500', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-17455', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10678', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12324', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1748', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7490', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6688', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16383', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16806', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16808', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16810', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9046', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16774', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4355', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16780', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16782', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4368', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1679', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9029', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9037', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7057', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9041', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-12033', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9057', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16827', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16835', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16845', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2020-12046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-9099', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9113', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9117', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-9127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9673', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17555', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-17561', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12452', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7579', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9340', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17125', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17126', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7227', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7235', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4588', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9358', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-9363', 4.9, 'AV:N/AC:L/Au:S/C:P/I:P/A:N'),
('CVE-2022-1997', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9380', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9386', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7263', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7265', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8734', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8735', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-16721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1673', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8757', 10.0, 'AV:A/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12131', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-4278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-8767', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8771', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8773', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18235', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5002', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7772', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-21411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12714', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5007', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7774', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-7776', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-11045', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7777', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-5009', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11046', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18243', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7778', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18245', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18246', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5010', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5012', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-1998', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2014-9614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9620', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7502', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17468', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1747', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17471', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12323', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9627', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7512', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-17477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9629', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7516', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10686', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7518', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7519', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1070', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7520', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9641', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7933', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-2061', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20614', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-20615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9635', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7528', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1071', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12350', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-17520', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7541', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-17525', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7543', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4360', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-12013', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-4369', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16804', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9043', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-16815', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1682', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16832', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9089', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16852', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4382', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-4386', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4389', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12050', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8790', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8800', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12150', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12154', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-12155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-16858', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-4403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16860', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9136', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9146', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12083', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-12100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9154', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-9160', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1689', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4447', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16862', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-4432', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-12075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1895', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2014-9151', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9156', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-16883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16899', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-16906', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1213', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9174', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7091', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2014-9178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4453', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9394', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7303', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7306', 4.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:P'),
('CVE-2014-9401', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9407', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-12278', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-12279', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12291', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-7934', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11693', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1499', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-12431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12361', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9656', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-17531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12363', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9659', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9661', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-20638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7557', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9664', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-12368', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11690', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7936', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17506', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10711', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7539', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9647', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-12063', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-12067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4407', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4418', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1896', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4444', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9155', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-16892', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16907', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9166', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-1691', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9173', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16910', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-18252', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7785', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11048', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-7786', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11049', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20376', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20377', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17612', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7612', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-12389', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-12467', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-17623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17627', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17649', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12399', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-9165', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-12129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4454', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-1916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4471', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9190', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7098', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9192', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9195', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16933', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1215', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1219', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9204', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-4483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1931', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-7103', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1721', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-9457', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-7343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17226', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2014-9463', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7365', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9473', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-2011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1913', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1915', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7097', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9191', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1694', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4486', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-7937', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5016', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18258', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11050', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5017', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11052', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20389', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2039', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-12170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12172', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7030', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7032', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-8875', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1872', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-12370', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9670', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2017-1755', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17553', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7566', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4460', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9188', 8.5, 'AV:N/AC:L/Au:N/C:C/I:P/A:P'),
('CVE-2022-1920', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1922', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16928', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7099', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4472', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4473', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7100', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1928', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9206', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-1933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4488', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4492', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1696', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4510', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-16997', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12270', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6689', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1498', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-9207', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-1695', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4491', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16951', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16956', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4501', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-16962', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9217', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-4507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-1939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9224', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4518', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9240', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-1941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9252', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1700', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4505', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1699', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4511', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-1940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12251', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4516', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9241', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-12259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4522', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9261', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-12275', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-4536', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7174', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17594', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17597', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17601', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17615', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7611', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12461', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12392', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20662', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12397', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-17635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17637', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17656', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17662', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2006', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12402', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-12473', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4730', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17682', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12475', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17696', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17697', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-12493', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-17698', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12413', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17718', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17722', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20104', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7548', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-17534', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7411', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-7422', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7425', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-7436', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9505', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-9508', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7445', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9524', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1732', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12346', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2034', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12374', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17383', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8914', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4309', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4314', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1220', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-8918', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-1881', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4318', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8925', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4319', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12210', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-12217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4329', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8951', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2019-12246', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-12251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7943', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2023-20560', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12405', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12480', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17693', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-12408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-20083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7618', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17707', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-12416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4535', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9275', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9280', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9281', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9283', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-7182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1955', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7184', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9294', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16793', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9035', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12023', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9045', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-9047', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-16830', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9060', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16837', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9095', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9097', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16857', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-4393', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21431', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5018', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20396', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7803', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-18265', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7804', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-5024', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11057', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21444', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18268', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7181', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4555', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17055', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-1962', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17062', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7197', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-9319', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-4704', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17543', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12371', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12372', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12447', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-11696', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6690', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-7944', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-12438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12529', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4759', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12541', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17762', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17796', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17799', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17802', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10768', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4352', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9014', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4358', 5.2, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-12015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4374', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-16805', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7945', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9300', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9305', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-7198', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-1229', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-17085', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7205', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4569', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9330', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-17043', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4551', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-12062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9116', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-4423', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16871', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12079', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-12080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9147', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4443', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4445', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1899', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-16898', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16900', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12122', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-1800', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-1908', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-12138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1911', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4464', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16920', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1693', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-12148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1216', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9202', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-7810', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12755', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21447', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18269', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21448', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18271', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5025', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2015-7815', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-21450', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-20401', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18272', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20402', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18273', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20404', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-11058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20408', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2041', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20410', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5026', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20411', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5027', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7816', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-17570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7602', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2015-7609', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17593', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-17595', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1760', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-17602', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17605', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17606', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12458', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9689', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1772', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17725', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-12526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12530', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12459', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12542', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4378', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16848', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4380', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16853', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4387', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9101', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-1205', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-12052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4395', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9115', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4421', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12068', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-12074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4439', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9145', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9153', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-12105', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9161', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-16884', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16890', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16894', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9594', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-17407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9598', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1741', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17426', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7473', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-12313', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9604', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12397', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1517', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1504', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-7946', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-1257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12572', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12578', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10772', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10777', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-10796', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17814', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20178', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10799', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17832', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10805', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20180', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7630', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17775', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17782', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17787', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12555', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12569', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12576', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12475', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10778', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20176', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17820', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17824', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17825', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7214', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-9331', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16386', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-7948', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11702', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-6691', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-7956', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-7959', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11807', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17094', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17104', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17110', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4585', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17122', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7236', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9356', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-1995', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1764', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17663', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12403', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-12404', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-20561', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20562', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17689', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7617', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17694', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12491', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12497', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9163', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7086', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2017-16909', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7088', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2022-1903', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4449', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2014-9185', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-4456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16921', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16931', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16932', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4482', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4562', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7190', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7191', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9311', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-7201', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7204', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-2146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20416', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2042', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20420', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20421', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18284', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-7817', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2016-5029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21462', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11059', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18285', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18286', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18287', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18288', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18289', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18291', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1106', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12759', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9208', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9212', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9218', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2022-1938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9228', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-9239', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9250', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-4523', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12272', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-12274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4524', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-4525', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2014-9254', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9262', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2014-9268', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9274', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7179', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17130', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9371', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-2001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9396', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9406', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-7631', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-11811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6692', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-7981', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1527', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2014-7993', 2.9, 'AV:A/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1524', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20030', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-16389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11855', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6694', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7210', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4571', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9707', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12589', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-17845', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-20001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9392', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7297', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7299', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7309', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2019-12269', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12270', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-12272', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9412', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-1229', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9418', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7314', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-7317', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-7320', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9425', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9426', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-17721', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4743', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-12522', 3.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-20109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12523', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-17735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2011', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7818', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-5031', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21463', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20424', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20428', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20804', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20805', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2015-7819', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-12274', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9417', 2.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2021-20190', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4783', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4789', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4791', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-17849', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4796', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1083', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1084', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6693', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1521', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-11711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11713', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17049', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4556', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1959', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17054', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9296', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9301', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2015-7194', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7196', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9316', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-17084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11861', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8009', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8018', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-11719', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8069', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8071', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8073', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8077', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2020-11869', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-11872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-11877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8081', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8083', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-11880', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2014-8087', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-17433', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7497', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-17096', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7221', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9344', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7232', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2016-4589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4591', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9364', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-17149', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9379', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9391', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9395', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7298', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2016-4609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9408', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-12760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12761', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-20429', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20430', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-20806', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2023-21464', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-12762', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20432', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-12764', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12765', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7820', 6.9, 'AV:N/AC:M/Au:N/C:C/I:N/A:N'),
('CVE-2020-12767', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7822', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-7823', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2022-20807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21465', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11061', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-18342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9219', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10832', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-4803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9733', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1786', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10844', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20202', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2014-9741', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-20722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9743', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-17876', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10852', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9433', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-9442', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-9450', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7357', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9472', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2016-4624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1723', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9480', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-2014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17753', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12538', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17776', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4762', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1779', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10752', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12552', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17798', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10763', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12467', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-12571', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-7626', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1533', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6695', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8023', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2021-1994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-17451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9616', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17458', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17467', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17474', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9628', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9630', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10685', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17484', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9634', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4615', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7333', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9435', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-9445', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9460', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9461', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2014-9465', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-4623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9475', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-7370', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7374', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17010', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12277', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-4545', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4552', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17051', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-1956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1957', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-7185', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7211', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-9325', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-17090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9336', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7219', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7637', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1788', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9747', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17892', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17907', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4813', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7638', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-20732', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10858', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10862', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20434', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7824', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7825', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20435', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12483', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17809', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17812', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17816', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17817', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17819', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17822', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17826', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10806', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20183', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-12586', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1082', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12588', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12593', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20188', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17848', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-17497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17500', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9646', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12292', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7318', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1230', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9437', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9439', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9459', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9293', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4564', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7199', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9318', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7207', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-1540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20038', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-11723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8074', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8079', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2020-11878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20040', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2014-8084', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11729', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4810', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-17889', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17898', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1263', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-17917', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1086', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-20736', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9759', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9761', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17931', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17932', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8094', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8095', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-8097', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8103', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2022-1560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-8105', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8108', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7222', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1711', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9349', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-17121', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7228', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-4586', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9360', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-9367', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1996', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-9377', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9385', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9387', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9389', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9399', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10830', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7635', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-2015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7391', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7395', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-7398', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7400', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-7409', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7414', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7418', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7421', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7423', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9498', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-7382', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9485', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-1870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7410', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-7413', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7419', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2014-9495', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9499', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-7429', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-7434', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1729', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9506', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2015-7444', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17934', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17935', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20715', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20727', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20730', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20736', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20740', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20220', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-20800', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20224', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-1532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11886', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-11889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11737', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-8098', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11897', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-1557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-11739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-1979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7213', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9323', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-17091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17092', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9339', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9341', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9343', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2015-7223', 4.9, 'AV:N/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2014-8118', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-11742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-1192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1577', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-11930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8131', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2020-11932', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11933', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20198', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9739', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-20719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10847', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12617', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-17872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17875', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20208', 4.7, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2022-20729', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17884', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17887', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17906', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1791', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9749', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2021-20215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20734', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10867', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-2065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10875', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9763', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17940', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20716', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20726', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7427', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7435', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9513', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9520', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9521', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9523', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-12301', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9561', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9562', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1236', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1739', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1238', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20440', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-20441', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2045', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-5037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21505', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2019-12276', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9415', 2.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2015-7315', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7323', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2021-1857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-7330', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7331', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:C/C:L/I:H/A:N'),
('CVE-2015-7334', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9444', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9451', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9454', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9456', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7358', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9471', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7448', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-4643', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9526', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9559', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-12314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12362', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-2035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7460', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12376', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17381', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2014-9578', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-9580', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9582', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-2039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7642', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17986', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18005', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10891', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-10895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9833', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9850', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10903', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10906', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18033', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-11902', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-6699', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2020-11903', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8110', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8111', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8114', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6700', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-11911', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-11912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-20053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11914', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-11928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8132', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-11937', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8137', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-11941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8141', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1587', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-16398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-6703', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2023-20062', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-8148', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8154', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8155', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6704', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2022-1603', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-1606', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11753', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9650', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-10723', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9652', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9657', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20034', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2014-9667', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9345', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9346', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-9352', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-1712', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17123', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17124', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17127', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7225', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7230', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-7233', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2022-1992', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-1993', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-7238', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-9361', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-9381', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9388', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-2000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20802', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20805', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17967', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-20841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20844', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-20734', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20738', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7641', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9476', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-12302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7378', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9487', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9488', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9493', 4.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:P'),
('CVE-2015-7401', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1725', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7424', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9501', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-9502', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9504', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-11757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8178', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9671', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2014-9672', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2015-7569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9675', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7575', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9677', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7577', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9680', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12386', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7581', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17573', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7604', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-17589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17596', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9686', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17609', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17613', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12459', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7614', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7827', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11063', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21506', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18343', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5039', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7828', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12383', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-17413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17421', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9603', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12384', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7474', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1239', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17428', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2047', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1795', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20850', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20854', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2021-20228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17984', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17985', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17995', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17999', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10890', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18008', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-20858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4817', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10892', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7648', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9834', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9838', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9842', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9849', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9853', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4829', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-10904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4831', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18032', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20250', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20867', 2.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-10910', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10912', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7652', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-17425', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12316', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12317', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12319', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8146', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-4204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11749', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-8158', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9512', 4.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2014-9516', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4642', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9522', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4644', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9528', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20254', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-18037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12393', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20664', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-17625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17629', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17632', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17654', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12400', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8242', 4.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:P'),
('CVE-2019-11763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1622', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11767', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-11770', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8246', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-1632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11778', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-1633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20256', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-10913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18038', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18041', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20752', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18049', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-10918', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4843', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-20270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20271', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12525', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7656', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-7488', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-7489', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9609', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12345', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7453', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7455', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9568', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1738', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7468', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17434', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9621', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2021-20020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17479', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7514', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20881', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-20269', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4841', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-4844', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-20756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4849', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10920', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2023-20884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10923', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-18344', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11754', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-17669', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-1768', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17683', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20564', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12479', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-17692', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-20084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12496', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2069', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12521', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10680', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10689', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9632', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-20026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12418', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9640', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17511', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17513', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20453', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2023-21507', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11064', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21508', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18345', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20812', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-12771', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20244', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4862', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12528', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-12529', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18083', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18086', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4874', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-20892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9907', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-20893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4881', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4890', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9920', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7660', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-11761', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-4211', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6709', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-11766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6710', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1629', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17440', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17443', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1993', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-1997', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-1999', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-2049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20278', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-10927', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-18081', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4863', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4864', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4869', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-4871', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7658', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-20894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4876', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4887', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20897', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-20764', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-18090', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4900', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9917', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18092', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20903', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10939', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-12442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17742', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-12448', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17777', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10740', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12564', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17795', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17797', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17800', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12574', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21509', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21510', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20454', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-20813', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18348', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11065', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11066', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11067', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21511', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2046', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-12777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18349', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5045', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11068', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18350', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4666', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20245', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2025', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-4833', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7651', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2021-20252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17526', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9648', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2019-12637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7373', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7377', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12303', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7390', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7412', 2.9, 'AV:N/AC:H/Au:N/C:P/I:N/A:N'),
('CVE-2015-7417', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7420', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9500', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7433', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4677', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17459', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17466', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20870', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-20257', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-20259', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20263', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-18042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20267', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2021-2027', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-4850', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10925', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-12527', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18082', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18352', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18354', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18355', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7829', 2.9, 'AV:L/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-20461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7830', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2021-20464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11069', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5052', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21516', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-5053', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18357', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-2047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21518', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1107', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-2152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21520', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18358', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20816', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-7834', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-12644', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12645', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4906', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4909', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-12635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9970', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9983', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-10950', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10954', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7663', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1731', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7442', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7447', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9525', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9560', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9563', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4651', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12363', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7454', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9567', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-1734', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9571', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-12370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7467', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12373', 6.0, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-12375', 4.2, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2014-9576', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-1740', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9595', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-17431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17432', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7487', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7491', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7494', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2019-12400', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7496', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1996', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-12435', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9658', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-20636', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-20644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17554', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7564', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1756', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9626', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9636', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7527', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9638', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2020-12345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20619', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2020-12347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1750', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17502', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9642', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12485', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17815', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1080', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10803', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12494', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10810', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10814', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12498', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12499', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7632', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-17833', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9721', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10828', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18084', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8301', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1637', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2014-9599', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9601', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-17422', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9602', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-2042', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20295', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-1096', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-20298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18108', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12673', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10975', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10994', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9622', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17464', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17472', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10677', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9906', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4878', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4880', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4883', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18088', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-10936', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4902', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18094', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18095', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7661', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-12426', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9645', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10718', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-17527', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7544', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-9653', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-20630', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17535', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17536', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12439', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7558', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20193', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4802', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20196', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-17858', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17866', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9742', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4805', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17599', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10949', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7662', 6.9, 'AV:N/AC:L/Au:N/C:N/I:C/A:N'),
('CVE-2017-18101', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-12639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4913', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11005', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11070', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11006', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-20776', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-2058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12328', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4905', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20290', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-1266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18100', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10953', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7666', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2112', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18106', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4807', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17885', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17913', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9751', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-10865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1792', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17920', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7838', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7839', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20478', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18361', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7840', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7841', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20818', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2048', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2017-18365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5060', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12784', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-18367', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7571', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9674', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12448', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20037', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9684', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2017-17571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7601', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2014-9685', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2017-17592', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17598', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1761', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9687', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-12388', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-20618', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10710', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-20620', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17507', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17518', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1752', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10712', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17528', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10722', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12434', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12362', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17532', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7551', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4216', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16408', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8307', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8310', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2014-8319', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6713', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-11807', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-8322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11808', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8324', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1558', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8328', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-1645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17429', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20319', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18188', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20780', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-2032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-20783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4966', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20784', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12673', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9440', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9443', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9455', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9466', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2015-7366', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7371', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2015-7372', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7383', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7385', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-2022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7404', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-9494', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2023-2068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9765', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7640', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-2069', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1088', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20746', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20222', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20804', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17947', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17657', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1073', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7616', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17665', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2007', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21531', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5061', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20822', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-20106', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-1562', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8333', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2022-1647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8334', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-20111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8335', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1565', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-1649', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-11813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6715', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1650', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2014-8340', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8354', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20297', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7673', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-20302', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4946', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7679', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7680', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10995', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12676', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-12390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2005', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2020-12398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17621', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12471', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20671', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17664', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2118', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-12647', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-7677', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1099', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18120', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7682', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2014-9611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17442', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10665', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17470', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17473', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9625', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12415', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20612', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-7706', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7707', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-18199', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7708', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-12693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11017', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1102', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7712', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-11031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20328', 5.2, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-20821', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20829', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17950', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7643', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-20742', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7647', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-1727', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7437', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9507', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2015-7440', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9527', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9556', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12309', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7450', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7457', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9570', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-7458', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1237', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7461', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7462', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7466', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9665', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17557', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9676', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17562', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9678', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9682', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7580', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7600', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7603', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2017-17579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1758', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2017-17582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17614', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12457', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12460', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11818', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20826', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12785', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20079', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12492', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-12495', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-17715', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17717', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17724', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17730', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7621', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17736', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4758', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-10736', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7624', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-17784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4763', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-17670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17672', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12481', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20078', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-20080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17701', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17703', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4737', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7619', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-17713', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17714', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12418', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-9844', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4828', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-20746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18024', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18030', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8371', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8378', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8396', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8351', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1568', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11819', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1659', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-6718', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20113', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-20122', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8391', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-8394', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8397', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-1576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11836', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11839', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1577', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-8414', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11841', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-20129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12334', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12335', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7521', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-12338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10709', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9637', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1751', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9643', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17516', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4692', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10716', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10717', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12394', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-17626', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17633', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1765', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-1766', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-20669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4729', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17691', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4733', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2008', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-12410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10908', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:N/A:H'),
('CVE-2021-20255', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20262', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20264', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20880', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10917', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-17406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17409', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17419', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-2046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12386', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12423', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18176', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18177', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18178', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18183', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7697', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2021-20315', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-4955', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17708', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12507', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17716', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2010', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-20105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-1774', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20113', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12439', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-12441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10732', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17744', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4760', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-8428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1686', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-6725', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-11870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6728', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12431', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2015-7623', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-20125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2013', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-17752', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17774', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17778', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10739', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17803', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12468', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17811', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17823', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10804', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7629', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2021-20184', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9709', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8416', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8419', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-6722', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8422', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6723', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-1691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-8437', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-20153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4847', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7655', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-18209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18211', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7725', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2021-20331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7727', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-7729', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-7730', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7731', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7732', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7743', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12692', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-11039', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4993', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20789', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-12695', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:N/A:H'),
('CVE-2019-12698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11007', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4959', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10756', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18185', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7698', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2021-20318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18190', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1743', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-6730', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-1600', 5.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2021-1603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1705', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-1707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6750', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6751', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6753', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-6754', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2014-8441', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-1708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4865', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1257', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1592', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-1649', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16513', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6742', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6743', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2016-4235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20180', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-6749', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-4236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17763', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17786', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10738', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1075', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12551', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-7625', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17801', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4765', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10773', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17810', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12488', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17813', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7628', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-17821', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20343', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-20347', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-20348', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-2035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7758', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7759', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-12702', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20353', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2015-7767', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-18231', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11041', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20792', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12594', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17843', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12599', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4790', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2016-4792', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18192', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20322', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-17524', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12433', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7546', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9654', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4884', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20898', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-10933', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-12606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20900', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12618', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-12401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17454', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9623', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-7504', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2014-9624', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-1746', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17469', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17475', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2054', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12325', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17478', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12327', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1103', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-7713', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-12677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11032', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11033', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12680', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18205', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4984', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7724', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7726', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-7728', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2023-2137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10809', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20179', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1081', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9701', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-10812', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10813', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-12585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9705', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9711', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9712', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-17844', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-6752', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2019-12584', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9706', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20185', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-17835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1784', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4788', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-17847', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4912', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18098', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2104', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-1712', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-6758', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-20194', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9740', 2.9, 'AV:N/AC:H/Au:S/C:N/I:P/A:N'),
('CVE-2015-7636', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-10845', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10846', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-12598', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9714', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9718', 6.9, 'AV:L/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-1785', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10827', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9633', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-20616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17498', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17503', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20621', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17508', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2135', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-8448', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2022-20726', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1787', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9744', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2017-17880', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17886', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4811', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-1790', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4812', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9748', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17916', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9769', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-1794', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9771', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20728', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20732', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20737', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20747', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12352', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17529', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9649', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10726', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7547', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9655', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7549', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2014-9660', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12364', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7555', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12365', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12366', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9669', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-20646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4804', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10843', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9736', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4809', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17893', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17900', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17914', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-20733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10866', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-7639', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20673', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9764', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20712', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2022', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17944', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-12446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7576', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12385', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20199', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8450', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8451', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8452', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8456', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-1627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6766', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-2107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10958', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2110', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-18104', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18105', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7672', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12675', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-20306', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4949', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4950', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18122', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9662', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9663', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9666', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-20641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9668', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7565', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-20651', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7578', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6762', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-20796', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10885', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20849', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17969', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20235', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18015', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4825', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-9847', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18023', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18027', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4834', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-1757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17591', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12387', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9688', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12464', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8483', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-11930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-1629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8487', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-8488', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8489', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2014-8491', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-6774', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-20812', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17949', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20847', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20229', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17981', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17989', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-18001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20233', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-7645', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-10894', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-4819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6767', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-17648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17658', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12474', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17684', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12483', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12494', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-17699', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-12515', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-20096', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-12516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17723', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-7620', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-20100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20696', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1773', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2022-20698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17733', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7649', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-2024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9832', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9835', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10898', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9851', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18019', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-18021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4830', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-10905', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4832', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-1762', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12401', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4731', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12476', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20077', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-4734', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-12499', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6779', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-20094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17727', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20695', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-12520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17731', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4751', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-12525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7622', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-20118', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20127', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-20128', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12540', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12543', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11939', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-1723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-1724', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-1726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-11946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-11948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16550', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4247', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-6792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1726', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6770', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7696', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-20316', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2078', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-20878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20879', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10915', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10916', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-4840', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4846', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17792', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12566', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12575', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7627', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1680', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8511', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-20214', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-8512', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-1194', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-6786', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2018-10737', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12548', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17788', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12554', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12573', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-12579', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20147', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-10774', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2015', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-10776', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4768', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20334', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7744', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20335', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-4994', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18219', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18220', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12698', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20345', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-20346', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-20349', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-20350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18223', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12700', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7762', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-12699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1783', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2018', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-20181', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-10815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9708', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12587', 5.2, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-1259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12595', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7633', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-6824', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8541', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-20223', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2014-8549', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-20229', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-6852', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-11986', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4256', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8585', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16579', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-16588', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-1785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17831', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12497', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10817', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12592', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2019', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4782', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4787', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2015-7634', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9727', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4797', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20195', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-9738', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-2020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20201', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-12616', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-20203', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2017-18087', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9913', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-4888', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-10934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18091', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9919', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20284', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20285', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2023-2092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1264', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4903', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12621', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4908', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-4910', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18097', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18228', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7766', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-7769', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-21407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18233', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18234', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5001', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-5005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18237', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20369', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18238', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18239', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7775', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7709', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11012', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7711', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11034', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-2033', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-7715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2136', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-1728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-1730', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2015-6790', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-2029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20727', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10850', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9745', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2021-2021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17881', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12623', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17902', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17908', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-10855', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17911', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17915', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10861', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-10871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10874', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9762', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-1793', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20191', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12601', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10831', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2014-9732', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2020-12509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9734', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2021-20197', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2014-9735', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-20718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4806', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10851', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17882', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17891', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17904', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17909', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9750', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2022-1741', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1743', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11950', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1745', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6817', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6819', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8536', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-6826', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-6834', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6836', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-12700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5011', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18248', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7783', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5014', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-12719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20375', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7784', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-18256', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-17936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9772', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20725', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9773', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-20745', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20221', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-2079', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-10884', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20828', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20832', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20835', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20839', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-20845', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-20846', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-17971', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-17994', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18009', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18012', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4818', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10896', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-10897', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8564', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-4254', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6845', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16556', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-20238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-11984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4255', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8577', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-8583', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2017-16577', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8592', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16592', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16596', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16599', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-1788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-6918', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-6921', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-8607', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-16611', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-11995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4266', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6927', 4.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:P'),
('CVE-2015-6928', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16633', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17919', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20218', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-2067', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-20739', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-20689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17938', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9767', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-17942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7791', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-7796', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20391', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18262', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2143', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11055', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12711', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-12712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7802', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12740', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-21434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7805', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-5019', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5021', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5022', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9843', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18018', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-20862', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-20748', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-20246', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-20865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18035', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-16635', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-6940', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2023-2036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1200', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6948', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8627', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-16639', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-2045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-6967', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-6969', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-6972', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2023-2087', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-20871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18039', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7653', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2021-20265', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18043', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7654', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-2078', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-20803', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10887', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-20831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20838', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-10888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2084', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20843', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-20848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-10889', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-17972', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20227', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-17983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17988', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17991', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17993', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-20857', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18004', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18016', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20744', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-20859', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2086', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-9830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9831', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9836', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9841', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8637', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8640', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16660', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20882', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4842', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-4852', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4856', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4857', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4858', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12526', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-4860', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-20888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-20889', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7650', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-18029', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-20864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20251', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18036', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-20869', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-20872', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-10914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18040', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7659', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-1260', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18089', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4897', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1821', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8676', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12102', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-16681', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12105', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2017-16687', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2014-8707', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-1671', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8714', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16716', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1849', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-1672', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8745', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2022-1853', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-9915', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-9921', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18093', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2091', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12619', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12638', 5.2, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-10951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-10955', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18103', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2018-10959', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7667', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-10966', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-2113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-12644', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-20299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18109', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18217', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12693', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4996', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-10974', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12674', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-7676', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20303', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2016-4948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7683', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-18121', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7684', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2018-1100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7685', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2015-7691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18175', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18179', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18225', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7763', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-18226', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7765', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2020-12704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18229', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18230', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-4997', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7771', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-2036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5000', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-18236', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7773', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-11044', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12717', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18240', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18242', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18244', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18247', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20372', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-20373', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12701', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2015-7781', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5013', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-18250', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18251', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18253', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18254', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-20796', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20797', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-2038', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18259', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20386', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8810', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2020-11956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8625', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-1664', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8628', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-2048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16642', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8631', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-18194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4967', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18196', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4968', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4969', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12676', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-4970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20327', 5.2, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7795', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7797', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7798', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21432', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21433', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2080', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7808', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-5020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18266', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21443', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20399', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-7809', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-18267', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-11976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12177', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11980', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-11983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4288', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-11985', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-8891', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-4300', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-11987', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-11988', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-11989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16744', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8902', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8904', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-8912', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2014-8657', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2014-8681', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-16678', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-1834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2014-8690', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2022-1842', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-12114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8736', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-12122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8743', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8748', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-8749', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-8751', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2019-12133', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8764', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2014-8765', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-8768', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-8770', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2014-8778', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2019-12138', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8791', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2014-8916', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4317', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-11993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4322', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8938', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16753', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12218', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12220', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-8942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4333', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2014-8954', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4338', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8956', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-16764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8961', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-4344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16770', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8992', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-12003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8997', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-8998', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2017-16777', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7048', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2017-16783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4361', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9016', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2017-16797', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9036', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4974', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7723', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12143', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12144', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12146', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-7011', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-8809', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2020-11957', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12153', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2015-7013', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-12157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12159', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12163', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12164', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-7056', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-12028', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-1203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16828', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4377', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16839', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16844', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9091', 6.4, 'AV:L/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9098', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2016-4394', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-4401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9129', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2021-1789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4419', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4426', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4429', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4431', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-16870', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16875', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12102', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2014-9152', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9159', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-12108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-12113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-1898', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12184', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8895', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2014-8896', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2016-4301', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8910', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2016-4303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4307', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16747', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-8923', 2.9, 'AV:L/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2017-16748', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-11996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16766', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-12252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2014-8990', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-8995', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-16776', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9004', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4356', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16781', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9015', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2020-12011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9017', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-9026', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-9033', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16799', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16801', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9038', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2017-16813', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16820', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16849', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4390', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4392', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9104', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2014-9130', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2014-9135', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4415', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4420', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-4427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16865', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-16868', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16869', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-4433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-4434', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16873', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16879', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-16893', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-1900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-1690', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-16904', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12118', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-1901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7089', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2022-1906', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12135', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-1912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7095', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5063', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-11071', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11072', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20482', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-20483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11073', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20484', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11074', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12797', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7843', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9227', 6.4, 'AV:L/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2016-4512', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2014-9236', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9245', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2020-12267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9251', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2016-4527', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4528', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2014-9269', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2014-9272', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-4531', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-4534', 2.5, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2014-9276', 6.4, 'AV:N/AC:H/Au:N/C:P/I:P/A:P'),
('CVE-2022-1947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9279', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7178', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9282', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2017-17042', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7844', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11075', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20485', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11076', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11077', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5073', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7848', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11078', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11079', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5075', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5076', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5077', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12801', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18382', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11080', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5078', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12802', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5087', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-20828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18383', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5091', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2049', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-5092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7852', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5093', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2022-1921', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1924', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-16938', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-1930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-16942', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-16948', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-4485', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-4554', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2023-21567', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2020-12814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20491', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5094', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2017-18384', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-2157', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-7853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5095', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2022-2083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11083', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21570', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5096', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-12815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9215', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9222', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9226', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9230', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9243', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2014-9248', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2022-1942', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5097', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5098', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5099', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18385', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20830', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20492', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-20834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7857', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7858', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7859', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7860', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7861', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7862', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-7863', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2020-12821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20498', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20499', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2050', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-5102', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20500', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2084', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20502', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-20840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20504', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2014-9295', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2014-9304', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-17088', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-1977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-1980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-4579', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9324', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2022-1981', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2014-9334', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-1983', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7220', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-17108', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-17111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9348', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1713', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7229', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2015-7234', 4.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:P'),
('CVE-2014-9355', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2014-9357', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-7241', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2014-9362', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2014-9365', 4.9, 'AV:N/AC:M/Au:N/C:P/I:P/A:N'),
('CVE-2014-9368', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7253', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2014-9376', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-21572', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2021-20506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20508', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12825', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2017-18386', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5104', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2051', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-20510', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7865', 10.0, 'AV:A/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2021-20511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5105', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7262', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-1716', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-4604', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-1844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2014-9405', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12277', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12280', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-17175', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2014-9432', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2021-20550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20551', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7882', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20552', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2056', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-20517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5106', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-21574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2018-11087', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7866', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-5107', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-2052', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-20520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20523', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20526', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21575', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5108', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5109', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12829', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2016-5114', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-5115', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21576', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5116', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-12831', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1109', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-11090', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11091', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-11092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5117', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-12832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18388', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21577', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11096', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-20527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5119', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20529', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21578', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-12835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7869', 9.5, 'AV:L/AC:M/Au:N/C:C/I:P/A:C'),
('CVE-2018-11097', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11099', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5124', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18389', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-12845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1111', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18391', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7887', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7903', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-11117', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18392', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-20563', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11118', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20569', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21583', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5126', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20534', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-12847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20535', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-12848', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-20536', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20538', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20539', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12850', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12851', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-12852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20540', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20541', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20844', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2085', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5127', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20575', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18394', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20580', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-5135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11101', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-12856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7873', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-7874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11105', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7875', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-7876', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-7877', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7878', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7879', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20546', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7880', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7881', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2017-18390', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11124', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5139', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2018-11129', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12880', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11136', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11138', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1114', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20585', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5140', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12859', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20850', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-21591', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-20860', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5142', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12860', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7899', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7900', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2015-7901', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-7902', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7904', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2023-21581', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-7905', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20567', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2057', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-18393', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21584', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5133', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21595', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20862', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21596', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12897', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12723', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21597', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7919', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2020-12898', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21598', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11150', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12730', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12731', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18399', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21601', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5148', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21582', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20564', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20565', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5131', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20581', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21585', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-20854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11120', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5137', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-12872', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7910', 6.9, 'AV:N/AC:L/Au:N/C:C/I:N/A:N'),
('CVE-2018-11119', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5134', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5150', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11128', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21589', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1113', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-11130', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11133', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11134', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11139', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11140', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11141', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11142', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18396', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12875', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-5136', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7940', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7941', 2.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:P'),
('CVE-2016-5154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1124', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11243', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18420', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12834', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12837', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18395', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11127', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-20858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5138', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11144', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21592', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-12891', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7913', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-12893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5144', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12739', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7942', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-11163', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5156', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18398', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-20863', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7918', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-12724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11166', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5158', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12844', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5204', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11169', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5160', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-18397', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7912', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-21593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21603', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-12902', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-12895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7916', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2018-11149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21610', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11171', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7974', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-11172', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12865', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-7991', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-7994', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-11202', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11204', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11206', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-11207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12795', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1116', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-12736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1293', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18402', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1115', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-12728', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12899', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-21599', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11176', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5166', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-12874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11317', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12875', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12876', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12880', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-5216', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2015-8002', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2019-12804', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11179', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18407', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-12759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1118', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12763', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-20921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20922', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-20924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11184', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21609', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20928', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2015-7921', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-12732', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12903', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12904', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11155', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18400', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12905', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12912', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12920', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11156', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11157', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11158', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18401', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7939', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-11159', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12735', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-11164', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5157', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2161', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7987', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5174', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11320', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11322', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18427', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8048', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11323', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5220', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-12808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11167', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12745', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11168', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-20909', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18404', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-20910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7973', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-20913', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-11170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5162', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-8022', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8024', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-5191', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11190', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12779', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-20930', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12782', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-12783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12790', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12794', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18410', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11198', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5181', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13033', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18455', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8150', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18456', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5311', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8156', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5317', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5318', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13069', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12963', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5319', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1307', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18459', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5328', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11479', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2088', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12737', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11162', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7943', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12930', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12741', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-7944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11165', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12742', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12743', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7945', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18403', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-12744', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21618', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7975', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7976', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-20588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12749', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-11174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12750', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18406', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5165', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18428', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5223', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21612', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5184', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5159', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21174', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5335', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8232', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2018-11486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18463', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1297', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11499', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-8254', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8004', 2.9, 'AV:N/AC:L/Au:S/C:N/I:P/A:N'),
('CVE-2019-12806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8006', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-8007', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2017-18412', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5187', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11331', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20955', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-8053', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-5238', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11178', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12758', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5168', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5190', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-12748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18405', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5163', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-5356', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11511', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8267', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-18467', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8275', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-8277', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18468', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-13126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11528', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1153', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11536', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11537', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-20625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-20626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5252', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11350', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20632', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11352', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12927', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20651', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-5260', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18435', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-5264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18416', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20606', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12829', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8042', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-12830', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-11245', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20934', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2059', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-7986', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-12761', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5171', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7977', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11175', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12751', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12752', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-7978', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12753', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-7979', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-7980', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7981', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-12755', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12756', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12757', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5167', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5192', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8308', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8309', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11565', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8320', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-11568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5391', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8328', 9.5, 'AV:L/AC:M/Au:N/C:C/I:P/A:C'),
('CVE-2015-8330', 6.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:C'),
('CVE-2023-2171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21710', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5395', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11576', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11578', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13146', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8349', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20937', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-12816', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18414', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-1123', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11230', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8035', 2.9, 'AV:N/AC:H/Au:N/C:N/I:N/A:P'),
('CVE-2019-12938', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5266', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2016-5268', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-18437', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5272', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8062', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1137', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-11372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8063', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12766', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5173', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2016-5203', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5410', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8354', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5414', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2121', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5417', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8361', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-8365', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-13177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18477', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5423', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2015-8370', 10.0, 'AV:L/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8378', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5175', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18440', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-12968', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-20667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18441', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2019-12974', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12977', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1140', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11403', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20917', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-7984', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-7985', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12760', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11180', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12781', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5178', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8036', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-21620', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-18415', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12822', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8041', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2019-12825', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5434', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2174', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-21743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-21745', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18480', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21230', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13237', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13240', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13242', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5444', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8044', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12846', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1129', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8045', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-18423', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18444', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5289', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18445', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5292', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18446', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-13000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5295', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11205', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-11208', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12801', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18411', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-7995', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2016-5183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11236', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11643', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13259', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5462', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5464', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-5473', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5476', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-12765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18408', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-18447', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-5296', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8081', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-13004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-13005', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5299', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18449', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8090', 2.9, 'AV:N/AC:L/Au:S/C:P/I:N/A:N'),
('CVE-2018-11435', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8096', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11450', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5306', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18450', 3.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-11583', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11588', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5399', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5403', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8353', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21720', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11189', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18409', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5176', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5211', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8003', 6.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:C'),
('CVE-2019-12805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8005', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2018-11219', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12807', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8008', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21613', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11221', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12810', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11222', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18413', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11244', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-20936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20938', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8043', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11255', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12842', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2168', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11195', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-7989', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7992', 2.9, 'AV:N/AC:L/Au:S/C:N/I:N/A:P'),
('CVE-2015-7993', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-1120', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5215', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-13013', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11454', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-18451', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13045', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8138', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8139', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13068', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-13070', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11468', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11471', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5329', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13084', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13100', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13105', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5332', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8220', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-5334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5336', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8233', 2.9, 'AV:N/AC:H/Au:N/C:N/I:P/A:N'),
('CVE-2018-11487', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8235', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8239', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13186', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5425', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21796', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-18501', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20728', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5548', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5552', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5574', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-5578', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-13287', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13292', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13301', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5587', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2015-8400', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-11694', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1170', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18513', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13149', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11713', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11716', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11717', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18520', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18522', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12843', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20940', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12845', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2061', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12852', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-20943', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2016-5210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8021', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-11224', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8023', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2015-8025', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2018-11225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8028', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-8030', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2018-11226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12814', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8034', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21734', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21737', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21738', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11620', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21219', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13219', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13226', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21762', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13228', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2123', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-11638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13235', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11321', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5222', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13208', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13209', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21741', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-13220', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-21221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18481', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11634', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13227', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21763', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13245', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5450', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-5451', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5455', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5458', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-13258', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5460', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13260', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5472', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18524', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8404', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11726', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13327', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11730', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11734', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11736', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21239', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13177', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13179', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18544', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18546', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20764', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13351', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20766', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13355', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20767', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8242', 4.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:P'),
('CVE-2018-11498', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18466', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5354', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5360', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5361', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5362', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-11517', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-12987', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5224', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-11307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13261', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5465', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-5475', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-5492', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5500', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21775', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-11650', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5509', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5511', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-18496', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1167', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5526', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-11680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5536', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-5538', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-21795', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-5542', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-5560', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5580', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2020-13128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13288', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13305', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13307', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5595', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2018-11695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5603', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5605', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-11702', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13152', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1121', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12802', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-7999', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-8000', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-11212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11213', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8001', 2.9, 'AV:N/AC:M/Au:S/C:N/I:N/A:P'),
('CVE-2018-11215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5186', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2023-21619', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5228', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5229', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20616', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18429', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-20954', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-20958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5239', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5248', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5489', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-5498', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11647', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13112', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-18493', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5503', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-11651', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5508', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5510', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5512', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11657', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5521', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5522', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5525', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-11678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18497', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11685', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13274', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5547', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-13126', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-5567', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5571', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5577', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-2073', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1169', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13291', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13314', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5590', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5599', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-11697', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-13316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13317', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8402', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-8280', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5383', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8299', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11551', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11553', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11555', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11558', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5387', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13370', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8410', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13374', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18554', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13383', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20772', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13391', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8411', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-21249', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-20775', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2125', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-20947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5219', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-1172', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5623', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-20746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11725', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8056', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-20624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-20967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5250', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-11349', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11355', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18434', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11356', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2065', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11357', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12932', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5262', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8329', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-8331', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11571', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11572', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11577', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11579', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8333', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2015-8335', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13139', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18518', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18519', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13323', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18525', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11723', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-18528', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13169', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-13328', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13330', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11731', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18537', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1174', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13347', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-20763', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-1321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21241', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-11749', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13359', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13362', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11751', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-13372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18553', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13345', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18542', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11744', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13349', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18547', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18548', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13364', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-21243', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-20768', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13385', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13227', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18556', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18558', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20777', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-18561', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11760', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8413', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12827', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18417', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11359', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1136', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8061', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11362', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11365', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11369', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5275', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12950', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11375', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11378', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11383', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1122', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5188', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-13161', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8357', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2015-8358', 10.0, 'AV:N/AC:L/Au:S/C:C/I:C/A:C'),
('CVE-2015-8366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13178', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5430', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5432', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1162', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-18479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13222', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-21222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21229', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13380', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5642', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5646', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13390', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11758', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-18557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13230', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13403', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5652', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5662', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5664', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18564', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11761', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5672', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2016-5675', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21252', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-13409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21255', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-18570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21267', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21268', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18578', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18580', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20790', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-18581', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8417', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12902', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12903', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8049', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2019-12911', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2095', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8050', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-20951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8051', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11332', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20953', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8052', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2016-5235', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5236', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-20619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11343', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18432', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-20969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12925', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18433', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11762', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21254', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11767', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-8415', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-2126', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8064', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12970', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12972', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12975', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12978', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8066', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12985', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18418', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20607', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11637', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11639', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13239', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18488', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13244', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13250', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13252', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13254', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5456', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13256', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13257', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5459', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-13109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5466', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11645', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18492', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8392', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11655', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5513', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5516', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-5518', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5529', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5532', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5535', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5537', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-18498', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11688', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5541', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-5546', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5551', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-5555', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-5562', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-5569', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5575', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5581', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8395', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-18506', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13282', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18507', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8399', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13313', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5589', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2016-5601', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2021-20736', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-8020', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11223', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8027', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8029', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-21614', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8033', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-11227', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5193', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-8057', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-20631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5256', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5257', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12928', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12929', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2080', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-20802', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13451', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21273', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5703', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5706', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18587', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-18588', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-18590', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13254', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1178', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8420', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-5734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H');
INSERT INTO `tpandora_cve` VALUES
('CVE-2021-20810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11784', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-18608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8423', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12930', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11358', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5265', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2019-12940', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11360', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2066', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2016-5273', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21123', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12949', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5277', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11376', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11381', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11382', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11698', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-11707', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5608', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2074', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-1315', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13320', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5287', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12997', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8070', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11247', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12839', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18421', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11254', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11256', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12841', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12958', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5279', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-18439', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21125', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5282', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-20664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21126', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21127', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1139', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20669', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-12976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1298', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12986', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18443', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2016-5749', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5762', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1348', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13484', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21815', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21286', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13498', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-1350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11802', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1182', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5800', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20832', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8082', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-12960', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8087', 2.9, 'AV:N/AC:L/Au:N/C:N/I:N/A:P'),
('CVE-2018-11430', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11432', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5302', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5303', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8100', 2.9, 'AV:L/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-13010', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13014', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11453', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8109', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5613', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2016-5618', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13325', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20747', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-5624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8406', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11737', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-11739', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-13343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20759', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11746', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13348', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13357', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13363', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-12988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11409', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2068', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2019-12995', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11419', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12996', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5291', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5293', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8071', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-5202', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-8078', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-13002', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2069', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2019-13003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13006', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-13382', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18555', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5676', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8414', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-21262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18577', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13421', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11771', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18582', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20791', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2016-5691', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11233', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21622', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11235', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18452', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13031', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13032', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5310', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5315', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21170', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5322', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11469', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13075', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8216', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-13104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8418', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13452', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20806', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11777', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-13457', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5713', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18591', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18593', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13461', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5722', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-13465', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-5725', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13476', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8422', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13450', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11775', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-20797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21271', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-11779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5721', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18584', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5697', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5705', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21275', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-11776', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21807', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-13250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11778', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5716', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21279', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20809', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5733', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5744', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18614', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11443', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5304', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2019-13009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5307', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8103', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2018-11455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8105', 2.9, 'AV:N/AC:M/Au:S/C:N/I:P/A:N'),
('CVE-2018-1126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5205', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5745', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5751', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5755', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8424', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-13266', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5730', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5735', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11783', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18462', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11485', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11494', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-8247', 2.9, 'AV:N/AC:M/Au:N/C:N/I:P/A:N'),
('CVE-2015-8249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18465', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11504', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21179', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-11507', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5358', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5803', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-13514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1186', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5824', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1187', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8434', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12847', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5207', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5765', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13488', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11797', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21287', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11806', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-5797', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11242', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12831', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5201', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1190', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13282', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-18615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13483', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-5769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2082', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-11798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1180', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8428', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20833', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-13273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13515', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5810', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8106', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8107', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21156', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13029', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5309', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8110', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8113', 10.0, 'AV:L/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-8124', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-13035', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18454', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5316', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18458', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5321', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1189', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8436', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-5841', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1196', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1197', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-5874', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8441', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2015-8276', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8281', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11529', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11535', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8298', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11548', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13133', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:L'),
('CVE-2022-21301', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2015-8435', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-21305', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-20848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2085', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-8437', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2020-13283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21308', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5844', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5849', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21310', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21826', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:H'),
('CVE-2022-21311', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2023-2183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-13538', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-5876', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21313', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2023-21836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5901', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5934', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5944', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-5949', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5955', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5963', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5970', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8431', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13518', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5825', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12864', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12867', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8046', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1131', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5214', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-21825', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21828', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-21838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13539', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21845', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-1354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5933', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-21849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5943', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5951', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5954', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12019', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21317', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2018-12021', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21862', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-13289', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-21866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5988', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8446', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-5325', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1308', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18460', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13097', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13099', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13103', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-18461', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8221', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8231', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5337', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8240', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5884', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5890', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5894', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5902', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21314', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5920', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5940', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5942', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5950', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2086', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-12018', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8444', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5992', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6001', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6019', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6033', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6042', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13290', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21278', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-13462', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5723', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13261', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5727', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8421', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13134', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11556', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5386', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11564', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18471', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8316', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8326', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11251', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-20941', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1127', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18422', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1128', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5208', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5397', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5398', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11580', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18474', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11586', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8346', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21714', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8350', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20714', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-5409', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2172', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21725', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-8360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8364', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-13176', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5422', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8369', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-5426', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11614', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11615', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13189', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18478', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21177', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-12982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5350', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5352', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5357', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6028', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6035', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6037', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6044', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6059', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-6068', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12029', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21875', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-21876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6098', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-6103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13293', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2016-5987', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5990', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-21868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6025', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-6031', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6039', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6046', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6061', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8447', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-6090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6102', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6110', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-6122', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6126', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21882', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21325', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2016-6132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1205', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6137', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6146', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12073', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12086', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13557', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21329', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12090', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12095', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12099', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-21902', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6083', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21874', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-8448', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-6104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6111', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-21879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12043', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21884', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6144', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21886', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12076', 3.6, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6164', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12087', 4.0, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-2133', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12094', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8454', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-1192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1193', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21824', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5881', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5900', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8442', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-5945', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12893', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12895', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12896', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11796', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13493', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13496', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5787', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2019-13503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13506', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13507', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2083', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-13271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12046', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21885', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-6147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21328', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12097', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-12098', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-6173', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5967', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5974', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13542', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13546', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5986', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5995', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6034', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-6047', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6065', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6084', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21872', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-21323', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2016-6096', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12034', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6116', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6127', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12040', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12047', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21326', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13190', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-11617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8381', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-8382', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2022-21218', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11621', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11625', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11632', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-21227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8387', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-13229', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21905', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-2191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12110', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21924', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-13306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5750', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5760', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5764', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18641', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13485', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21285', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11799', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20826', 4.7, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2015-8427', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11808', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8429', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-13272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8284', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5372', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-21184', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11549', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11563', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2015-8312', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8313', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8317', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2017-18472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8325', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8327', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-5390', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5392', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18473', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21906', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-21908', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:L/A:H'),
('CVE-2019-13570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12104', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12109', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21910', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12111', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21918', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-13584', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21921', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-8457', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2023-21923', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2016-6191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13612', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21934', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-21935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21938', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6204', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21941', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21942', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-21944', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13308', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8461', 6.9, 'AV:N/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2019-13628', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21347', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2015-8467', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13636', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6225', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21960', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-13644', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12855', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-18424', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12868', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12869', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11309', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11311', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-1295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18425', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8047', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2017-18426', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11319', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12887', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12889', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12890', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12894', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12897', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5218', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-21293', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-1352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13521', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5821', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13276', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6201', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13510', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21290', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20836', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13513', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21295', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-20840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5826', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11587', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20713', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8351', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20715', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-21722', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8355', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18476', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13164', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5418', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13599', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21922', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2016-6189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21926', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-20867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21929', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-13615', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13616', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-6198', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11324', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11325', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5221', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-20845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5833', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13629', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21349', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-13310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13527', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5835', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5481', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13110', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5490', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5493', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5499', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5501', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13113', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-13114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11671', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11683', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20726', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5557', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-5565', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-5568', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-20729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18503', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18504', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5584', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5592', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2016-5597', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13315', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8401', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11705', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11706', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11709', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5610', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-18516', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18517', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5611', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2015-8403', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-6163', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21893', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6168', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8453', 2.9, 'AV:N/AC:M/Au:N/C:P/I:N/A:N'),
('CVE-2019-13566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12100', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6174', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8455', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-13303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21916', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8368', 6.4, 'AV:N/AC:M/Au:S/C:P/I:P/A:P'),
('CVE-2019-13181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5429', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21355', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2016-6256', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-21971', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2015-8484', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2015-8487', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-13655', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12159', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8508', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6271', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8520', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8523', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12162', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13661', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-12148', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6235', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6236', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12149', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13646', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13647', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21969', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8480', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-6220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6223', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-13637', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13645', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8477', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12151', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8488', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-21357', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2016-6268', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12163', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2023-2198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-12901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11326', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12904', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11328', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12913', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1133', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12914', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-12917', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11334', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11338', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11339', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-20956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21307', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5850', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5878', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-5888', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5899', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5905', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21843', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13540', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5927', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5932', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5938', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5947', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13287', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21316', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5979', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-5981', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21860', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13544', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13284', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-21829', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2015-8440', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13536', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21830', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5883', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5892', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5897', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21844', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21315', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5971', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2016-5972', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5980', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21318', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21319', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2016-5991', 3.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-12023', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6021', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6040', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-6056', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6060', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6062', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6072', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13292', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2016-6094', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12035', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13294', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2122', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21220', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21225', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11633', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5442', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18482', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11327', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-20949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12912', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-20950', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-5225', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-20743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5619', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5621', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13168', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18530', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18532', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13333', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13339', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20757', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-18540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-11748', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18430', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-20962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18431', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8055', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5244', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21927', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21930', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-21339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-12168', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-11642', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13247', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13249', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13251', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13253', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13255', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5461', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18490', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5477', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-5482', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-5486', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5491', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-11646', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11656', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5524', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5534', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13272', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13125', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5556', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-5563', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2016-5570', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5572', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5579', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2015-8396', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-13283', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8398', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5985', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2132', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-6029', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12028', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6077', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-21321', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2018-1203', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12030', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6092', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21877', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-12036', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6115', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6123', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8449', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-6133', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8542', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21367', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-6285', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21368', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6286', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6287', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13669', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-18559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5663', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13240', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-18569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11330', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5226', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13625', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-21950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21961', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-6232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6233', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13311', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6249', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-1215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12150', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12152', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8486', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2015-8489', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21974', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-8504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13314', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-13315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5251', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-2063', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20630', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5255', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8058', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-5258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12935', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6149', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6160', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12096', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21331', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2018-12101', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21907', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:L/A:H'),
('CVE-2023-21909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12112', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21333', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2023-21915', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-6185', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13588', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21336', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21338', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-2193', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-6195', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13307', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-8459', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-6210', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-12131', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6217', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6224', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21353', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-6231', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21889', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-6169', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21332', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12113', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21334', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21912', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13577', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5588', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-5591', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2016-5596', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11696', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11703', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11704', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11710', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13318', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13319', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13162', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20745', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13324', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18529', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18531', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13334', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18534', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20754', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13341', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8407', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-13178', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18543', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18545', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-12936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18436', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-12939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2106', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5267', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-5270', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11367', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18438', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21124', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11371', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11377', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11380', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5278', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5280', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20786', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-18573', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13418', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5683', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20788', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5687', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2079', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-11770', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5689', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13602', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12120', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13607', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6190', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8458', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2023-21937', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-21939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-21940', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13623', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21947', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21949', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-21954', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2196', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21962', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6237', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6250', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-12153', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-8481', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12155', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8482', 2.9, 'AV:L/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2019-13657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13659', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-8473', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6234', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6238', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8476', 2.9, 'AV:N/AC:L/Au:N/C:N/I:P/A:N'),
('CVE-2016-6252', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6254', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-8478', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-21366', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6283', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21989', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-13667', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-18583', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2127', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11774', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18585', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-21270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18586', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5701', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5704', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21274', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-21276', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-5709', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-20807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5710', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-21808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21277', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-13253', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18594', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13668', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-20617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2062', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-5240', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5241', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-20965', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-20966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5249', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2097', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5253', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5254', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1218', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21998', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2015-8555', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-21380', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8557', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-2139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21393', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-13322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2140', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-21401', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-21405', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2016-6303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8561', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-21415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22001', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2015-8579', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2022-21417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22002', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-13316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-1320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-20765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11750', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21244', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-11752', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13377', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13396', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21248', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1176', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8412', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-12962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12963', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12964', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-12966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11386', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2067', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2019-12973', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11404', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21133', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18442', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-12987', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8068', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11408', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1141', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8069', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11351', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11354', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20634', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8059', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5740', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5742', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11787', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5748', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5752', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5756', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13265', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-20814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13494', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21289', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13509', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5807', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1184', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21418', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-21419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13681', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-21250', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5674', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11763', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18571', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18572', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18574', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5684', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13420', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8416', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-5688', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11413', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-12999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5294', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8077', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-8079', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-20686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5298', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-21141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5300', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11445', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8095', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-8099', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5305', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13012', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-20654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8060', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2022-2108', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-11361', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5271', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11363', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11364', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11366', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5274', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11379', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11384', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-12960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11385', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13519', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1367', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21372', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12175', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21376', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-13671', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-5690', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13449', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20803', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-5699', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5702', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-21806', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2019-13453', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18589', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13456', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18592', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11780', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11781', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5726', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5731', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13467', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13477', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11785', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21359', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13313', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6265', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21360', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-1217', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-21306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8438', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2022-21309', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5843', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2023-21827', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21312', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2016-5880', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5898', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1200', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5918', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5935', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5959', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5966', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-21383', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6301', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21392', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-8560', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8567', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-13678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-13321', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2022-21394', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-5284', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-20665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20668', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8065', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11392', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21137', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8067', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5747', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21283', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-5754', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5758', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5761', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21284', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8425', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-13268', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5308', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13020', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-13024', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8108', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8125', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2017-18453', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8126', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-13317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6288', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6289', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-21396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22000', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-12989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5288', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-12994', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-11415', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1142', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1300', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13001', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8076', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2021-20681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20689', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20692', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2017-18448', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5968', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8443', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-5975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5976', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5977', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-1202', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5983', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21320', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6000', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6022', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6027', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6032', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6043', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6082', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-6089', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21322', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6093', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6099', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6121', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21324', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2019-13548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21880', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-13551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8450', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2015-8597', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-21424', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2022-21426', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-13327', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22010', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22012', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8606', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8607', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-8608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22016', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11813', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13511', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-8430', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5818', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1185', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13275', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2084', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-8432', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13522', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5822', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13279', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-21302', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13280', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8140', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-21164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8151', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21166', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18457', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8571', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-8572', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-13679', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-1206', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21327', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8451', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-6317', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8613', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-13687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8213', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2019-13078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13083', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8217', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-5330', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5331', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13111', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8230', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8234', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-13113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11488', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13115', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-13117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5297', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5301', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11434', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8094', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1301', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13011', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21149', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-11456', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2015-8104', 6.9, 'AV:L/AC:M/Au:N/C:N/I:N/A:C'),
('CVE-2015-8544', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13318', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-21992', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-21994', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8548', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-13333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6331', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13690', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-5838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8439', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2018-1198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21831', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1199', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21835', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-5893', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5939', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-5941', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13541', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21388', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21399', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-21404', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8562', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-8563', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-8564', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-8566', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-13323', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-8568', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-21414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21387', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6302', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13675', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6310', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12089', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21330', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6171', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-13301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8253', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11500', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11503', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5355', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5359', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8270', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13122', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5364', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11522', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8279', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-11525', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8283', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8285', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11527', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1154', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11545', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11546', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8303', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-11552', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8310', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6297', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13674', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-22021', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-22024', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6333', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8622', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6337', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6338', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8625', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22033', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6344', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21443', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-8628', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-12193', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8578', 4.9, 'AV:N/AC:L/Au:N/C:P/I:P/A:N'),
('CVE-2019-13680', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-21911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21335', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6186', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13590', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13594', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13597', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13605', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21925', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21337', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-12123', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-13619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6211', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21346', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22043', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6356', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6365', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6369', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6372', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6377', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22048', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22050', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-13698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5953', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12015', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21859', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5978', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5984', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12022', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5994', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21869', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-6020', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6026', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6030', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6036', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6055', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6080', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6085', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13291', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-6097', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6113', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6114', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6118', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6125', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1204', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21431', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-22018', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1369', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13691', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-8131', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-13051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13056', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5312', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-12962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8158', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11473', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13085', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8218', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2015-8219', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2022-21413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6305', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22009', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6321', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8614', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-8616', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2015-8617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8618', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21428', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2016-6328', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-8619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21429', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6329', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6330', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21430', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2071', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13147', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2142', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22005', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8241', 4.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:P'),
('CVE-2018-11490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-12980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8252', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-12981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5351', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5353', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11512', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8268', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8271', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8272', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-12986', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5363', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-11516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1152', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13125', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8282', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11526', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11532', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13127', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8621', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22038', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22045', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6359', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6361', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22049', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22052', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1370', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21457', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1220', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6394', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-6395', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6396', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6397', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6401', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6402', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12200', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22060', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2023-22061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22062', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2020-13339', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2016-6139', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6140', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13297', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-21460', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6407', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6408', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22065', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6413', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21464', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2023-22069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21469', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-13340', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2015-8474', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2023-21967', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21968', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6255', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8479', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2015-8601', 2.9, 'AV:N/AC:L/Au:N/C:P/I:N/A:N'),
('CVE-2015-8602', 2.9, 'AV:N/AC:M/Au:S/C:P/I:N/A:N'),
('CVE-2022-21425', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-6313', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6318', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22011', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-13685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21209', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13163', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13173', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8363', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2019-13175', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5421', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8373', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-11616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8377', 6.4, 'AV:N/AC:L/Au:S/C:P/I:P/A:P'),
('CVE-2018-11619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8452', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-6167', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21894', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13299', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-13300', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-12093', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21899', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12102', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13574', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8456', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2023-21919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21459', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-6399', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22058', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18469', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-11547', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8300', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1155', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5385', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5388', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13136', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22017', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22020', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-6334', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6426', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6437', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6446', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6471', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6352', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22039', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22044', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6360', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6376', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21451', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21444', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22040', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-22042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6357', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6364', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22051', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21932', 5.3, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:L/A:L'),
('CVE-2019-13617', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13618', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21943', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6212', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21344', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8466', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-21348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13633', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1214', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13635', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-21350', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-21351', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-13638', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21352', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-8470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8472', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-21966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13217', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13218', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-21742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8384', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-5439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13223', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-11627', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21226', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-11628', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1163', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8388', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2020-13093', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13232', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13234', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11640', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-18487', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13246', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13248', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13262', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5467', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-1327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5479', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5488', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-2072', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5502', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5504', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18494', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21779', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21432', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-22019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13689', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6263', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8509', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-21978', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2015-8522', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13660', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13142', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-11589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8345', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-5401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21718', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13179', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5424', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8375', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8376', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5427', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8380', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2016-5433', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2023-2173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8385', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-13221', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5440', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21465', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:L/A:H'),
('CVE-2022-21467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13705', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-22078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21483', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2197', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6258', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-8485', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2022-21358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6269', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1216', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6273', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8534', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21365', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-8537', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21983', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-21986', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2015-8538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21987', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-21988', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-21448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8629', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22041', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6358', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6363', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6371', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6375', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5540', 5.8, 'CVSS:3.0/AV:P/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2017-18500', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13273', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13275', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5554', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-5573', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-5583', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8397', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-13289', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11690', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13306', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5586', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2018-11693', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-5593', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-13131', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5600', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5604', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2016-6501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6503', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6504', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6511', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6515', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22098', 5.3, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2016-6517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8643', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22099', 5.3, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2021-2087', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22100', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2023-22101', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22102', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-6519', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6520', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-13719', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-21375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12174', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6291', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6292', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21378', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-21993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-21996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6294', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1332', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21997', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8549', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-6295', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13666', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2016-5441', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5443', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13236', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13238', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13243', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18489', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5463', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-5468', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-18491', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5497', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11649', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5505', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18495', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5517', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5527', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5528', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-5530', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5533', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-11684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5539', 6.0, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2018-11686', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5543', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5545', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2016-5549', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-18502', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5558', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-5564', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2016-5582', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-18505', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13286', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13290', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-13704', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-21488', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2023-2211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-20742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13163', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-5614', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5620', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-11722', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11724', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8405', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2021-20749', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18533', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11735', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18535', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11738', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-13338', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11740', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-20760', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-2124', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21472', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2022-21474', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2016-6439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6445', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-6449', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6453', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2016-6454', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-6457', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6459', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6466', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6470', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6483', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-21479', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-21481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-13711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21374', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13673', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2020-13129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-5585', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-5594', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-20733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5598', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-5602', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13132', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11701', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-20737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6506', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6510', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22096', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22083', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-22088', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22093', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-22095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13716', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6530', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6405', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6411', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13703', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6296', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6298', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21999', 2.5, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-21389', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21411', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-8565', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2019-13677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21526', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6484', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22075', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-2148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21482', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6491', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8577', 4.9, 'AV:L/AC:H/Au:N/C:P/I:P/A:N'),
('CVE-2020-13158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13321', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5622', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18526', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18527', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11727', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-11728', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5625', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-11729', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13337', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13340', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20756', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13344', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-18541', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13346', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8408', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2018-11747', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8409', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2019-13356', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21486', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2022-21487', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-6525', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21489', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22113', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21490', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13325', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-22004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-8580', 6.4, 'AV:N/AC:M/Au:N/C:P/I:P/A:P'),
('CVE-2022-21422', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22006', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6307', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6308', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6309', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13326', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21423', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6311', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8603', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1219', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22013', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6319', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6325', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13329', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2022-21496', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6494', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22092', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13715', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-22122', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2022-21525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13350', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2016-6608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21480', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1371', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13710', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-22130', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6562', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21527', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-6565', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22226', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12209', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5637', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2077', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-21245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13397', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5647', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-20774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13684', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12224', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21535', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-22229', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13352', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-13688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18565', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5673', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13614', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13616', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21434', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21436', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21437', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21438', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21442', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-8627', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6351', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21544', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13743', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-6508', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6509', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6513', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6566', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6341', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6343', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22036', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-8630', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22037', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2019-13695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21513', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-1335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13335', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6362', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6368', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-6370', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6620', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6622', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6626', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-13741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21550', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6642', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12242', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22242', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21564', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-12294', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6653', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6655', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12322', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6657', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-2157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13353', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-13739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-13347', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21508', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-21509', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-21512', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22119', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2023-2212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21516', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8647', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21519', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12207', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-8708', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8712', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8715', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8719', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8732', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8740', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21678', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8759', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8773', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12423', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21691', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-12432', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21694', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-13961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12435', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-21497', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-22117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22121', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-6550', 2.5, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-21520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21522', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22127', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-2215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6581', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6582', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-13351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22227', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21531', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12210', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-12212', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-6588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12214', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-12216', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-12218', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12223', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2015-8650', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6591', 5.8, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-13737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21528', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-13732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12254', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21555', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13701', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-22235', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6637', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-22238', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6641', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-12241', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-21553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21557', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-21562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13753', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12464', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13631', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6623', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6627', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22233', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-6629', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6632', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13355', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-21547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21548', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-22237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13744', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-6417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6419', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6425', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6427', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6429', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6430', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21473', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2022-21475', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2016-6435', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6452', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6460', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6465', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-6467', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22074', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-21478', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-13708', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6416', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6434', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6436', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6440', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-6443', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22073', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6448', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13707', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1231', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12320', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6656', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12327', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-8655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13758', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-12237', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6628', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2016-6630', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21541', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12238', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22236', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21545', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21549', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-13356', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-20771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20773', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-11759', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5648', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-13404', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2078', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-18562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18563', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18566', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5677', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18575', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18576', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-11768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21265', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-18579', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6585', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12211', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-12213', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-12215', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-6589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12220', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-22228', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12221', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12222', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21536', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12227', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12228', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21538', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12229', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6594', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6595', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21539', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-22230', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6597', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-1375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6649', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12243', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12244', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-12245', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6644', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12246', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12247', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21554', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6647', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12256', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12266', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21556', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-6648', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12270', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-12272', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12273', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21559', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12290', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12292', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13358', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21560', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21563', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-21565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21593', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2022-21594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13408', 3.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2015-8657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21597', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-6493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22084', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21484', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2016-6496', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6500', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13344', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13386', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6662', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13448', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-20792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5696', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-6505', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8644', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13346', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12339', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6659', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21576', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2023-22252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12353', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21577', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-12356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21578', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2020-13381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13382', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-13761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12542', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12544', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12547', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6840', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6843', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14222', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14230', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12564', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6507', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6512', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21485', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2019-13718', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6631', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6634', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21542', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2016-6635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2155', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-13745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-5711', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8419', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-13258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21280', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-5732', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5736', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5739', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5743', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13264', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-5757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5763', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-11790', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5768', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12250', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-12359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21580', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2022-21582', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2022-21583', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-21584', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-13763', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-2151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22118', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-13349', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-13728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21585', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2020-1340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21590', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2023-22259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1234', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21575', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-13378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13379', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-13759', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-2174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12578', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14241', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8852', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6858', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12580', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12589', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6878', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14278', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2175', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21591', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-12360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13409', 3.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2019-13767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8661', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-13430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7111', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14821', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13361', 2.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2023-22247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13362', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2018-1232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13754', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-13419', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13916', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21602', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22278', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21611', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12366', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-12368', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7115', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14822', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22361', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-7116', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-21247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12864', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14823', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22365', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22366', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22367', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14825', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2125', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-14826', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22368', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22369', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-2237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12865', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8426', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2016-5774', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21288', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-11803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-11805', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5795', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-8651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6598', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22231', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-6599', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6601', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6602', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13354', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6606', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6607', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6609', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6610', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6611', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6612', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6613', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12234', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6614', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-6615', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6616', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6617', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21540', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6618', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22232', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-21604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6667', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22271', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13431', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21613', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2015-8668', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8670', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22282', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13461', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22283', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13473', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13480', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12382', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-13484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13485', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-13936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13494', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13498', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13515', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-12386', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-13568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21621', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-13439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21626', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-12372', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2227', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-6664', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13422', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-13424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8663', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-13432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13377', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-22253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12357', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12358', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-21579', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-13387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13762', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21595', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-21598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22264', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1390', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13915', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8659', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8665', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21616', 4.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2016-6671', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8671', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21291', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-13274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21294', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-13412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13768', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-21640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12383', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13513', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13516', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-21649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13534', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13537', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13541', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12387', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-21628', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-12375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12379', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13487', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13493', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13510', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-12385', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13593', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13594', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1239', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12391', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8682', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-12395', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22373', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-21253', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22669', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22377', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14828', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-13596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13597', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2015-8683', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12397', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12400', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12402', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-8701', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-8702', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-6636', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12239', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12240', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22239', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-13560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13578', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21652', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-13595', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22301', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12392', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-12363', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1342', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21601', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-13919', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13428', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8662', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21612', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-8666', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2015-8669', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21619', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12369', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5823', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8433', 10.0, 'AV:N/AC:L/Au:N/C:C/I:C/A:C'),
('CVE-2020-13278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1188', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5832', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5834', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1238', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13482', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-13483', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12381', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21646', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-13501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22295', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13512', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13514', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13518', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-13519', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13522', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-13524', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13529', 4.0, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-21620', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13434', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13435', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21624', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-13440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21656', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12393', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8685', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8688', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-21658', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-1240', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21668', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-12399', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-21660', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12403', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-20873', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2015-8707', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8713', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12408', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8716', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8722', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8727', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8730', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8737', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1241', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2089', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-21681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8755', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8758', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8764', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2093', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-8698', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-21661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8717', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8729', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8736', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8743', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12271', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1237', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12370', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12374', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-13451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13462', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13932', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-13934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21642', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13533', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13550', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-13551', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13552', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13553', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13555', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2165', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-2163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13024', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13025', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-13026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7475', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7476', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7477', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7478', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7479', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18906', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1303', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13030', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13033', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-13034', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13037', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13038', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13039', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7488', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7490', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7498', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7499', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21355', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2017-18907', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7502', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8711', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8723', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8728', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8731', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8735', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8741', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8747', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2015-8749', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8756', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8765', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-2096', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-21688', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8777', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13956', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12439', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13971', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8791', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-13979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12440', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12445', 2.5, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-8794', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12453', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13495', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13497', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-12384', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13509', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-13511', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-13517', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13520', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13523', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13536', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13539', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13540', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13542', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13544', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13939', 4.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-12390', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-5837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-5848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13756', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-22380', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-22671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22384', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-12866', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-7119', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7122', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2126', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-21260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14829', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22386', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22389', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7123', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22390', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2268', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21261', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-1440', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-7125', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8697', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12401', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8699', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13615', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12404', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21670', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-8733', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21673', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-5882', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-21834', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-5896', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-21842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1201', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-5958', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5960', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12016', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8445', 10.0, 'AV:N/AC:M/Au:N/C:C/I:C/A:C'),
('CVE-2016-5996', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-5997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6018', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2187', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-6024', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6054', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6079', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6105', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2016-6117', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12042', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6138', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12066', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6145', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-18908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7504', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1304', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13042', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-18909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7505', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21357', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2016-7506', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7507', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7508', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7509', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13049', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7511', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18910', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7539', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8710', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8718', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8720', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12409', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8734', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8739', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8742', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-20876', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-21676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2088', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8748', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8762', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8766', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8772', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-13949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12434', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21699', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-13976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8684', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8687', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21659', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12398', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8705', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-12407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8714', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8724', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8726', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2097', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-8778', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8793', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22317', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22319', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-22320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1246', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22322', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-12467', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-13990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13633', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13626', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2168', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8754', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8757', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8760', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12415', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12433', 4.0, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-8790', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-13970', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13977', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8792', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12441', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22314', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13982', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8796', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12466', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13396', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-21581', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2020-13397', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8753', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-8763', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1242', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12421', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8770', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12422', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12426', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13960', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21695', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-13628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13972', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12448', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-21702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8799', 6.0, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21696', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-8789', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-12446', 2.5, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-12447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13981', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12449', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8795', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6793', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-22321', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21704', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21707', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-8804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21711', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-8797', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12460', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12462', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8800', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2015-8807', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12498', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21722', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-8738', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8744', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8745', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21677', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8761', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:H/A:H'),
('CVE-2022-21683', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2094', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-8769', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-8771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-12429', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13950', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2098', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-8780', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13959', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21697', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-13969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21700', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21713', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6800', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12493', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12501', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8815', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8817', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1252', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22391', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22392', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-7126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12867', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21263', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7128', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6802', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12494', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8813', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2016-6812', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12520', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12533', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12539', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21728', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-6153', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-21887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13298', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2018-12471', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-12472', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-21715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12483', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12492', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21718', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2015-8814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13920', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-13922', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-12365', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21615', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2015-8667', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21618', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-12367', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-1248', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8801', 2.5, 'CVSS:3.0/AV:P/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-6796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1247', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-12479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6804', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12481', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13645', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-13630', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12461', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8798', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1400', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1402', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8808', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12473', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6803', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12523', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14195', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14202', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6831', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6832', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13667', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-8822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14932', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14933', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1305', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2277', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-21360', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7540', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18911', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-14934', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14935', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14936', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12522', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6820', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12537', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6826', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14203', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14210', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6835', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-6846', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1256', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12560', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12561', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6852', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-6854', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14232', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8832', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8833', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13438', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21625', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21627', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12373', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21635', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-13930', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-2164', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-2099', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-8818', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12530', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14197', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-13657', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13659', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2022-21725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6827', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8816', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21264', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2019-14832', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12525', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21723', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-13656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1254', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14208', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6833', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12543', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6839', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12550', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12551', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6844', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12557', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14220', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-6847', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6851', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14226', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-14231', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8831', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12480', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6805', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12495', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6810', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12504', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12524', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6816', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2019-14196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12536', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6836', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-14228', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6856', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12571', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8834', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21730', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-6845', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12558', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6848', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12562', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14233', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14234', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12579', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14248', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8837', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8838', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14242', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8853', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8854', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-8856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14258', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14262', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8859', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1427', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14273', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12592', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12601', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6817', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12532', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12548', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6837', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14216', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14225', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-13669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2100', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8836', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14240', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2015-8851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14247', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12581', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21266', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2018-12868', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14833', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-7132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7133', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7134', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14401', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-22405', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7136', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7137', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7138', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14266', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8862', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6888', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12602', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6896', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2015-8868', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14294', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14295', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8874', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12088', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-21898', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6172', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-21903', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2023-21904', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2016-6175', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12108', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-13571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1211', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-21920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13305', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12607', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6914', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12615', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-13788', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22338', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14215', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12563', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6855', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12572', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8845', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14245', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14249', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8858', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13692', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2015-8864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14274', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6886', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8867', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14250', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12583', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14253', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-6871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14255', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12588', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6875', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6881', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1259', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8865', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8866', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-14280', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12549', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6842', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12556', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12559', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22325', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6853', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6857', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14235', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13627', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2015-8460', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7140', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14834', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-22409', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2127', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7142', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7143', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21270', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22412', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7144', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7146', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7148', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12869', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1287', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22414', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21272', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2019-14257', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1426', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12587', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6876', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13702', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-14281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14286', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21793', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13754', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6897', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-6906', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8875', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12611', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12635', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21816', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12654', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1266', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-21821', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12687', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13811', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8930', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8935', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21009', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-8945', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21842', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2101', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-8948', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21011', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21846', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21013', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14290', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14292', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8870', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-6903', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-6905', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6908', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8877', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21804', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13776', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22332', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12621', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12624', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8894', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13767', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6913', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13774', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-12627', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21812', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1380', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12641', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12642', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12656', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6877', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-6879', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6883', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6884', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13696', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-14276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12596', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6890', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6891', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13753', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-14289', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14291', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8869', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-14296', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12606', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21356', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6259', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8483', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-6261', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6262', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-21975', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-6267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12160', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-8524', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21363', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8530', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2015-8535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21980', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-13677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12585', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-14268', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14270', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-6885', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12599', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2177', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2018-12604', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6892', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8897', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21818', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-12650', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8916', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8917', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8920', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8921', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8922', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8924', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8926', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8929', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13812', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8931', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7149', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14402', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-21273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14835', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21823', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1268', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12684', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-8925', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8927', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12696', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21824', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-6927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8946', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21012', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7543', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7544', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7547', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14937', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14939', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21361', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13054', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-14940', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7549', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12610', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1262', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13792', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12631', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12638', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22334', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12623', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8895', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6920', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1263', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-13798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8900', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8914', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-13805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6911', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12609', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13790', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-13791', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13795', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7150', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7151', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7152', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7153', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14837', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-14838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7155', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21275', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-22416', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-14839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7156', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2270', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21276', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2019-14842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22700', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-12870', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-7157', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12713', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-8947', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2021-21010', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13819', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13822', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2023-22302', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-20874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8721', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8725', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2090', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-12414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2091', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-2092', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-12418', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8776', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-2169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-13957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12436', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12691', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-12697', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12699', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8933', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8934', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12702', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21006', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21007', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2183', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12652', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8915', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1267', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8918', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21820', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-6923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8928', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12698', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13813', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21825', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8936', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21008', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1271', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12712', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13817', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-22340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6933', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6936', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22350', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12754', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21917', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21926', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6898', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-13758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8872', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13765', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-8876', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13770', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13772', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21807', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13777', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12622', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12626', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21810', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12632', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12657', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2182', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8899', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13800', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-21817', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2020-13803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12679', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12688', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1269', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12695', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8932', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21827', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-21828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12703', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7550', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7551', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13055', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13056', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1306', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21363', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13060', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2016-7553', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21364', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13065', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7555', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-18913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7560', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7561', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1307', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22771', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-22514', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-7562', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14942', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21016', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14845', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7163', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14403', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2016-7164', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2128', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-2242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14846', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22423', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12871', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21931', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-13902', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-13906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12758', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8982', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12759', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21939', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12761', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9056', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21946', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21947', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9101', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-21951', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2015-9107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12177', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-21990', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12711', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2102', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-6935', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22353', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13882', 3.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-1274', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2188', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21014', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2187', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21015', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12739', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13863', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-8958', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13867', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12437', 4.0, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-8547', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21377', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-21991', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-6293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13319', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8803', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13632', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6799', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12482', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1485', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22424', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2271', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-22426', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18861', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14404', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-21284', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2019-14850', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-22711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12872', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2243', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7165', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22434', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7166', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21287', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-7565', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18914', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1308', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21366', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-7568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22772', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-18915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21367', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1309', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7569', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-7570', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7571', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7572', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1272', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13872', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21020', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22354', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21382', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-21386', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8556', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21390', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-21391', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-8558', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21400', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21403', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2019-13676', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8978', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8979', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21030', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2015-8986', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-13920', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8990', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22367', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22371', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22372', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9099', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21930', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-12756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8974', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-6940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21031', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-8984', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8985', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8991', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1393', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9105', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21037', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22346', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6938', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21929', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-8971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2103', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-8980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21032', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-21934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8987', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9228', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9232', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13943', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22003', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-8973', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-13904', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-8976', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13910', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2015-8983', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22355', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1276', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8989', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9019', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12762', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12491', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1414', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12503', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12534', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6834', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7167', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7168', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21288', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2244', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-12873', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22444', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7169', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-6948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13940', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-21965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9234', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9238', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-9243', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22021', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-8992', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22359', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2236', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22368', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21944', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9057', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21036', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12764', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9253', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12765', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13938', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2104', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-9236', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-21979', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21040', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9250', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21289', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-14856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14410', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2020-14412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7170', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2129', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2016-7171', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-22720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14415', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-7172', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7175', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7176', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7177', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22449', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7178', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7179', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7180', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7181', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14858', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7190', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7191', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9100', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-9102', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14221', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6850', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2206', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18916', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22773', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-21969', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-9235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21978', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-6949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9241', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21988', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22377', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12769', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6306', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8600', 6.4, 'AV:N/AC:L/Au:N/C:P/I:P/A:P'),
('CVE-2023-22007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8605', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6320', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8612', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8843', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6859', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6866', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8855', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14267', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8860', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-8863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6882', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14275', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6887', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1428', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14282', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14288', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1429', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14293', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14297', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6902', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-8871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6904', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9251', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2198', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9248', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12768', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14944', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-14945', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6956', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12770', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-12771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2208', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-22326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1261', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-8878', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-21805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12625', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-8898', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-9259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7193', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14859', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-7194', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7195', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7196', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7198', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22450', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-7199', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-7200', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7201', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21290', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22454', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7202', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7203', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7204', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-22457', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7206', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7208', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7209', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-22461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22463', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-22464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7213', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22470', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12874', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7227', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-7228', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7229', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7230', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7231', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7232', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7233', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-7234', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21292', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-7235', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7236', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-7239', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-7240', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12651', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12653', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22114', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-18917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14946', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22774', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-7241', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7242', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7243', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7244', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7245', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7250', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7251', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7252', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7253', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7254', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7257', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14418', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7262', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7263', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7264', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-7265', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-7266', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7267', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-7268', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-22726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7270', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7275', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7276', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-7277', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-7278', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-7279', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7281', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-7282', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7284', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-14861', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7287', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7289', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7290', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-7291', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-7298', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9273', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6335', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22031', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2144', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-6336', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21440', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2015-8626', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-13693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1333', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13339', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-20186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1334', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-13340', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21436', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15005', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14947', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9282', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9285', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14330', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14331', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9287', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21058', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22107', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22473', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12875', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21295', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22728', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-14422', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9271', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9276', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9279', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9294', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-9299', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22141', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14009', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2015-9305', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14016', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22145', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2015-9312', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9314', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14388', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21855', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-8954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1273', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-8960', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22347', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21019', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2015-8957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-22341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21018', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-6934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13885', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7578', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18919', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22053', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-13700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12774', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9269', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21054', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9270', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9275', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14317', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14348', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12777', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-13991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9280', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-14344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14350', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9288', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14362', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-9293', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13998', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14371', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9297', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9300', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-9310', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-22380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2207', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14423', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7381', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7382', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14424', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14425', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21299', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12876', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7383', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22478', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21437', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13346', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-13347', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21438', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2091', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2092', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2093', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-2094', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2095', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-13348', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7623', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-2096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1335', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15006', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2017-2097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21023', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12755', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21026', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12757', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13912', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13883', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2022-21911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-13884', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21024', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-13891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-13892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21025', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21066', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14393', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-14043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9328', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21073', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-22418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2130', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7384', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22735', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-14869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7385', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22736', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-1487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22484', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12877', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7386', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22486', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-14870', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-14383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1403', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14390', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14039', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21069', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6967', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-8993', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22358', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13928', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21034', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-14366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14368', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14372', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13999', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6962', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14002', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9301', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1278', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9303', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9331', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21076', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-14406', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9334', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14411', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2099', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2017-2100', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-15008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2101', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-14478', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-22792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2102', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15009', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-6942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13923', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-8994', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9096', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9097', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9103', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14413', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9354', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14062', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21063', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9316', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9318', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9319', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14392', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14394', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14397', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21371', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-14950', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2107', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21071', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14400', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9330', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14404', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2103', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14479', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-1448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2104', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2105', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14480', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2106', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13368', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14481', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2107', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21945', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2015-9058', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12763', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-21950', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2015-9104', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13937', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9227', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-13942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9240', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21038', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9231', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21039', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21970', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2018-12766', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9242', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6950', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21041', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7387', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7388', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7389', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22489', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-22741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9337', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14060', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9343', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14061', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21086', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14069', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14452', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1310', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22515', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2105', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-22108', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14402', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14403', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-14874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12878', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2249', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7390', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22742', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22743', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7391', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22745', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7392', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21300', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7393', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-9249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22018', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13952', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-22378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1277', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9252', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-9258', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9350', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9355', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9358', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14093', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21094', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21095', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2110', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-22435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14464', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14471', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21106', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-13946', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12767', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9247', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22004', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22006', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22374', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13955', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22891', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-22892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2214', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14456', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14462', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-21103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2224', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-9383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14477', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14481', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-14114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1337', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14482', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14483', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-14484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14488', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2108', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2109', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-14490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2110', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7632', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21443', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22071', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2023-22072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21471', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-13706', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9335', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9338', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9339', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9341', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1442', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9345', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9346', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9272', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21055', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9274', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14318', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9277', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21057', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2015-9281', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12776', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13102', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21373', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14954', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13103', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-7583', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14955', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22516', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13104', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13106', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21374', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21375', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14957', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1311', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13112', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13116', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14432', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14437', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9356', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9359', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21089', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-9361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-6974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21092', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21045', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-9262', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9286', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14339', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14349', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14352', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21059', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14373', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6963', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14027', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14389', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22494', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21301', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7394', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22496', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12879', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14879', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-7395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21448', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-21449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2145', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-22799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2256', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-13375', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2280', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-7635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21464', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-21465', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-21466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22808', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21470', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-22809', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9261', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-13958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21046', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-13961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14486', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9390', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2111', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-9391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14491', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-2225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14497', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14510', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14511', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14560', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14561', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7815', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-14562', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-7816', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22440', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21108', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-13121', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21378', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-18924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14959', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14960', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18925', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18926', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2018-13123', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1313', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21379', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2138', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-14965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13133', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12782', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14395', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9325', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14399', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-13714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9267', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9268', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22115', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21053', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14312', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-1456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2221', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13962', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2210', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21303', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2016-7397', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14880', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18869', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7400', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1288', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-21306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7401', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18870', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21473', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-21474', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15011', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2281', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1338', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22564', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13409', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14569', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14570', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2020-14571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-14572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22151', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-14056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21077', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14407', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9336', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14409', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13136', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13137', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13139', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21381', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2016-7586', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14967', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21382', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-14969', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14970', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1314', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21383', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14974', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13140', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7587', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14975', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-2212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14319', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22262', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-14126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22909', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-14566', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-13407', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-13408', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15218', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1372', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-6523', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6532', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6534', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-13723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21110', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21477', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21481', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21482', 5.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2021-21483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2114', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2115', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2116', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22813', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-21488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21492', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-21493', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-2117', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2118', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2119', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-7640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2122', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15013', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-9340', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22189', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14430', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13423', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14976', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14978', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14979', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1315', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-13153', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21385', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20004', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1316', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-20005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20006', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14525', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22447', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-12798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14535', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14150', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14152', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-9417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-12799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9291', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-13993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2106', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-13994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12778', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9295', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9296', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21060', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:L/I:N/A:L'),
('CVE-2020-14004', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9311', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14386', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21308', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-18871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14883', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7408', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18872', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2275', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-12880', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-7409', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7410', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2131', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2016-7411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21310', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14438', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1279', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21093', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21096', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22229', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-1446', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-13417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14574', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-13421', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14130', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-9404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14517', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14518', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14521', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21523', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-13729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7837', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21558', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15237', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-14580', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2019-15238', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21567', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7843', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2239', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2017-2240', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2241', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-7851', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14582', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-2245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-2246', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14584', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14585', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14588', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2016-7852', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2252', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2150', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-2123', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2124', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2283', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-15015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15017', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2127', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14498', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-15019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2130', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22835', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-15020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14468', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-6978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14145', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2112', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-9422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1280', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22458', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9317', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21065', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14391', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9321', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9322', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12783', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21072', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-14401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13445', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13448', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15230', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2233', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13450', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7835', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-7836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13457', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14578', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-13458', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7838', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1346', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21559', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2156', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7842', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1348', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21565', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-1349', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14581', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7844', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2016-7845', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2018-1350', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2243', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1351', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1353', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2247', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14583', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-2248', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14587', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-2249', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21109', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1317', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-20011', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20012', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21390', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1318', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15021', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2135', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2136', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13386', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2137', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-15025', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15026', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2138', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2151', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2019-15028', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15029', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21511', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21512', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2139', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13387', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6580', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-8649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6586', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1221', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-6587', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12217', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12219', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-13736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14533', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14534', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18873', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-7412', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14885', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14887', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2016-7413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18874', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2253', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2258', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1356', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2265', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2267', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14596', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-2268', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1362', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-14598', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1363', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2270', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2271', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14602', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2016-7854', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1370', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-1371', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14604', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9342', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21085', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-14423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9348', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9349', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14153', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2015-9419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14506', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-9431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-20013', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1319', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20014', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-20015', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-20016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1444', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-20017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20018', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14987', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21111', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-14589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1354', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14590', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1355', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2254', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2256', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2266', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14593', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-14595', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2016-7853', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1360', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2269', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1364', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-14599', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14600', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1366', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2272', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9360', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21091', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-14092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22436', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14467', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7415', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12881', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12882', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12884', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7416', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14544', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14546', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14547', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22120', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9278', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-13977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-13980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14327', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-9292', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21061', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-9306', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14381', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1461', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-1375', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1376', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1377', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2279', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13784', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2284', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2285', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-13789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14618', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2016-7857', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13795', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13796', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-2287', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13797', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2290', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14626', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7858', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-20026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14993', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-20030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20031', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-20032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-20036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-20039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20040', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-20042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7592', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-21392', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2021-21393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1321', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1368', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-1369', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14603', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14606', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1374', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14608', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-14609', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-14610', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14611', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2020-14612', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-14613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7855', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-13793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15256', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-9407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21115', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-14507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2140', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13388', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14890', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-21315', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12886', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14891', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-12889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1289', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7418', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21317', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-9436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1457', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12806', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22471', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2015-9450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14574', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14584', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12809', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12781', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14387', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21067', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21068', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14396', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22518', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-21394', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1322', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21395', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-20052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-20053', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-20054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20056', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20065', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-20066', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15033', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-14509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15034', 4.7, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2019-15035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-15039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13389', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-21515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2021-21518', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2152', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2143', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2144', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2018-1339', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2145', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-2146', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2284', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-13390', 2.7, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-15041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22840', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21318', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-14892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18878', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-22752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22508', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-7420', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21320', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-14160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9437', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22469', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2015-9439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-2247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-13794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14621', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2288', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2292', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2020-14627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2293', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1380', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2295', 5.8, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2016-7859', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14630', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2020-14632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7860', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2294', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14628', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2296', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2297', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-2299', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14629', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-13804', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-13806', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2305', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14634', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2306', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14635', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14636', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14643', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-14644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21074', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-6968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21075', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-2216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14408', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21082', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14410', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14154', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-21119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6621', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-6624', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-6625', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-6633', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22234', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-13742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-20086', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20088', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-20089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14995', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-20090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-20091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-20092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20093', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-20094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-20102', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-20103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20105', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-20106', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-14996', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20107', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1324', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21401', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2019-14997', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-20108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7598', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14412', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14414', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-9344', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14422', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12787', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22424', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2308', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2309', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7862', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2321', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2017-2322', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14649', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2325', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13812', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7864', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2311', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-14646', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2316', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-2317', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-13811', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2318', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14647', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2319', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-2320', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14648', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-7863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2324', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-2326', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2327', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14650', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-2328', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14651', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-14652', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-2329', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2330', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14653', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-12895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21321', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7421', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14655', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-2332', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14657', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-13813', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-14660', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-2350', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14664', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-15276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14665', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13818', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14065', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9357', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14444', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-14453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-14463', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-14466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14469', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14470', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9386', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21107', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-20109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1325', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13250', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13251', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-13252', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20112', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13258', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-20113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14999', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-20114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7599', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1327', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-20115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15043', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15045', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14514', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15049', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14516', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13391', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14518', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13392', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2331', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-7865', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2333', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2334', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14658', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15266', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14659', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2016-7867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14661', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-14662', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-15272', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-12265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12268', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-21558', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1229', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12291', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6650', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-21561', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22244', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1230', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6652', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-13359', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:H/A:N'),
('CVE-2023-22248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12321', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12326', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21571', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1233', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12331', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12335', 5.2, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21121', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-22470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12807', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1452', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2018-13393', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-15052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2150', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13394', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-7649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2151', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15053', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2019-15054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2154', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7650', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-20116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1328', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13280', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13281', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-20120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-20121', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20123', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-20124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14666', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-13820', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13821', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14670', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-13825', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14671', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-13826', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2355', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13843', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13845', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13847', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1386', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13868', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1387', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22250', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-21573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6658', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2022-21574', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-22251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13376', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-13757', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-14663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15273', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15275', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1382', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14667', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-13822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15283', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14668', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14669', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-13823', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13832', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13833', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1384', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15058', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-15059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2155', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2156', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13395', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13396', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2157', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13397', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2158', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-13398', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14550', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-6986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14565', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21124', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9455', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-21130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-1449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12795', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14121', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14498', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9401', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9405', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14516', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-6981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2227', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-20142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20144', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13282', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-22520', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-20145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13283', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-20146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22521', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-20147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21409', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2141', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-20148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13284', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-13285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21413', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-13844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13848', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13849', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13863', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13864', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13865', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13867', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13869', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13878', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1388', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14674', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2161', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13399', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2162', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2163', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7654', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1340', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15074', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2166', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21529', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2167', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2153', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2168', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7656', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12824', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-13870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13875', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13876', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14673', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-7872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13879', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2359', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1389', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-20154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22523', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13286', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21416', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2020-14444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13287', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21417', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-20158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13288', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22524', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2021-21419', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-2142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13289', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21420', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13290', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13291', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-21586', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-13398', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2022-21589', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-13401', 3.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-13404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-21592', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2226', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-13407', 3.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2018-12361', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-6663', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12816', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12817', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21138', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-15081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15082', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13400', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-15083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15084', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14165', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1390', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1391', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14675', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1392', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2360', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1393', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15293', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14676', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-22933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15294', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15296', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14677', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-20162', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-21422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13292', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-20163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21423', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-13293', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1445', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-13294', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13295', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-20165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-20166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21424', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13296', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14452', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2363', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14682', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-15299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14684', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-14685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2365', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14686', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-22936', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-15302', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12797', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14524', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2015-9411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14147', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-14528', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13297', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22530', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-22531', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22534', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13298', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7613', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22536', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22539', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-13299', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7614', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22542', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22544', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1330', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13300', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-13301', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13302', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13303', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-13304', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13305', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-21129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13980', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2367', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-13981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15319', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15320', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-15322', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2369', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21146', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-14893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7422', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-18879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7423', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12897', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12900', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21323', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7424', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-18880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12902', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12903', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-15091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15092', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15095', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21531', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15098', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14522', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21533', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-13401', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21534', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21140', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14591', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21132', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-15326', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14698', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-14699', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14701', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14681', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-2364', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1394', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1395', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14688', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-1469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14690', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14691', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-15313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15314', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1396', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15315', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22937', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15316', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1398', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15317', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15318', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14694', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-13983', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22938', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-13988', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14456', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-21428', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14457', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21429', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21430', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15102', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21536', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21537', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15105', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15106', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13402', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2115', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2015-9506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14183', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21151', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-9467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22485', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12813', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14604', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22487', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6993', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22488', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-22489', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2015-9478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22612', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-20175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-20177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21431', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:N/I:H/A:H'),
('CVE-2017-20178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1331', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22551', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-20181', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2279', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2017-20182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22554', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1399', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15321', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14695', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-14697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15324', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15328', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15329', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15330', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15331', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14700', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-15108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15109', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13403', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12905', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12907', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12909', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1291', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12910', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12913', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22942', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-7881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22943', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-7882', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7884', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2376', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1543', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14704', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-22947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14705', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7888', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14706', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2016-7889', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-2246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-6984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9425', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-22461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9426', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2015-9427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14541', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14155', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-2374', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14703', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-7883', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22945', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22946', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2377', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12826', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22501', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15110', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22846', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7666', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22847', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15113', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2285', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15115', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1443', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-21328', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-12915', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12916', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18883', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-22755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21331', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-12918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18884', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21332', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-12919', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1292', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21333', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2023-23007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14279', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1428', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14280', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14943', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21636', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14282', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14946', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21155', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-22950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15476', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14708', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14710', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-15478', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15479', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15480', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15481', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15483', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15484', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14712', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-15486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2383', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2296', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2385', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1549', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14719', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2016-7902', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14720', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-15491', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7903', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14721', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-15492', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2492', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2493', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21639', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1282', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12820', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6995', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12821', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12822', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14174', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2114', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-22491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12932', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12933', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12934', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1547', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14707', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14709', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-15477', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13404', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-22852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21546', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14525', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15119', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14527', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2023-22854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22858', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-22860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21548', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12829', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14181', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14194', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-21159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14548', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14549', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-12802', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22466', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-9435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14568', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21125', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2016-7904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14722', 3.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-14723', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-7905', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7907', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7908', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14734', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14735', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2391', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14736', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-14740', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-14741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15501', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14742', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14743', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15503', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14744', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14745', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14954', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14955', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14286', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21640', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21641', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-1496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21642', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15612', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-6996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22497', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-22499', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12825', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-6997', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21334', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-7427', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-7428', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-12939', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7429', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-7431', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1294', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7433', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-18887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7435', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14711', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15482', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15485', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14713', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-15487', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14714', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15488', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14715', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15489', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14716', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-14717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-15490', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2386', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-2387', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1472', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1453', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2020-14530', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15127', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14531', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2021-2155', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15128', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-15129', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-15130', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14533', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-14534', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-22863', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21553', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14535', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2287', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7780', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14536', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-22870', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7781', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15132', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21645', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12833', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14195', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14196', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12834', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9511', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14746', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-14752', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14757', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2016-7437', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-12942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7438', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12943', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14179', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22503', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-6999', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1283', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2389', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-15493', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7906', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15494', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15496', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14731', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14732', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7909', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2392', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7782', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22874', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-22875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14539', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7783', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14541', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-7785', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14543', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14546', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22878', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15139', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15140', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15142', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15143', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15144', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15145', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15146', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15147', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14548', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2016-7789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12944', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-7439', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1295', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18890', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1296', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1297', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12971', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-12972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12973', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-18891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7440', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1298', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7442', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-18893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22473', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-22474', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2113', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2015-9453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-6989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22476', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14590', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1281', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22479', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-6990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22481', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14168', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14753', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2017-2395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2396', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1476', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14760', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-14761', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-14762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12836', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2471', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14872', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-21609', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14873', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14262', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14875', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-12837', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21650', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2306', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21651', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14975', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21652', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2020-14976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15506', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15507', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14766', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-15508', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2405', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14549', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2023-22880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2171', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2172', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15160', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1455', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12830', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14185', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21154', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2015-9461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14599', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14600', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-6992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14170', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14602', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14171', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2015-9468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12812', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-2161', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14876', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14877', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14878', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14879', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2018-14263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14880', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2020-14881', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-14882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7443', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7444', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18894', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7445', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18895', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7448', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7449', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7450', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-18896', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21342', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-1498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14295', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14980', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23082', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14297', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21656', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-14983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15622', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21659', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-14989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-14300', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15511', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14770', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-15514', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15515', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14771', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-1552', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15520', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13998', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13999', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14764', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7795', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15161', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-7796', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2179', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15162', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7797', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2180', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-22883', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15164', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14884', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-21611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2475', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14301', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15627', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-21661', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14303', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8206', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14304', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2511', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-15003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14305', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15005', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-1463', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1464', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12838', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22591', 2.5, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-14653', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14767', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14768', 3.4, 'CVSS:3.1/AV:A/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-1551', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15523', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15524', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14778', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-14009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1401', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15531', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15532', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14779', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-15534', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15535', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14780', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2018-12832', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2255', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12982', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-12983', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12988', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7452', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-18897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7453', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7456', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7457', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7458', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-7459', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-7460', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-7461', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7462', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:H'),
('CVE-2018-12989', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14902', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-22762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1299', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12990', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7466', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-7467', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7468', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18898', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-7469', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7472', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7474', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12993', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14885', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-14266', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14886', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-21612', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14772', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-15517', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15518', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15008', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14306', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15630', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1501', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-14307', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14308', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15011', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14309', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21671', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15012', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-1431', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8220', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8221', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12815', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14663', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22285', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14270', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14667', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22286', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-14671', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14678', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22287', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22288', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2015-9517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14693', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-14694', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14696', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7800', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7801', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15165', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7802', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7803', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2187', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14550', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2188', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2189', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14551', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14552', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2017-2190', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2191', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2192', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7804', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2193', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14553', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2195', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15167', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-7805', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14554', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-2207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2208', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2209', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2210', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14555', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-2211', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2212', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2213', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14204', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12835', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14213', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-21166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21345', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-12994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18899', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-21346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14904', 5.3, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:L/A:L'),
('CVE-2018-12995', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12996', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-13000', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13001', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13002', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1301', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13010', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14905', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-13011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21349', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-2135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14017', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14020', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14782', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-7919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14784', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-15539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7922', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14023', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-22963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-22964', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2297', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14311', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1502', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-15020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21681', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8233', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1503', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-15030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8235', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15637', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-14887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14267', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2476', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21614', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14889', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-21615', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14781', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14013', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14015', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14016', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-22492', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21142', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-14268', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21616', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-2262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14892', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14269', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14317', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1432', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14324', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2525', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14329', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2528', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21685', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-7924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15542', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7927', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14035', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15543', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14037', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15545', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7931', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1404', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7932', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2424', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15546', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14040', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7933', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15547', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14041', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15548', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14042', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18902', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-13012', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21351', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-18903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21352', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14296', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-14297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2261', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22612', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22613', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-22614', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14300', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-22615', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-22616', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14301', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21183', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-15540', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14029', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15541', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22970', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1403', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14033', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7928', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7929', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15544', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2257', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1427', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2480', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14270', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2162', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8100', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14271', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2481', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8101', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14895', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-1559', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14909', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2019-14910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14914', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-14915', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-13013', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14924', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21353', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-13014', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-18905', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1302', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-13021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-12827', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14180', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21147', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-14043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15549', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14044', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14791', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-22576', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-14045', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14047', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7938', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14792', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-1405', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15557', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15558', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15559', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7945', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15047', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15640', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15641', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1505', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2264', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14302', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12842', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21185', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-22895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14556', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-14557', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-14558', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7812', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-2216', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2217', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2218', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2219', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22899', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8102', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21620', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-14896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15563', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2433', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15565', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14056', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15566', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7010', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14263', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21172', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-22297', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14264', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12839', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22283', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21150', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-14654', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15207', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-15774', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14665', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14309', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7015', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14310', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-21188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14272', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21621', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14898', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14273', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14900', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14274', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15573', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7958', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15574', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7959', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1407', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7964', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-14071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14805', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-14078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14806', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-1481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7970', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8587', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14504', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8588', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1451', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8590', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14522', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15223', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2021-21990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2683', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-14526', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15224', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-22782', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-14527', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2684', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-8595', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14532', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22784', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-8598', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14564', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14565', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:N/I:H/A:H'),
('CVE-2017-2222', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7817', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7818', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12831', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14192', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14193', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2015-9509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21626', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15592', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14275', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14313', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2119', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-9521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12844', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14669', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14672', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14679', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-7011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22289', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22960', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-22911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14573', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-13412', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13415', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1342', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2224', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2226', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2227', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2228', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1343', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13433', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-13434', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13435', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2229', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2230', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1344', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-13440', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15225', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15227', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7831', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7832', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14577', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7833', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2231', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13441', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15228', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2232', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13443', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-13444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14318', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2015-9522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1409', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1410', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1411', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1415', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1416', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1417', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2445', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7977', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1419', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2259', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9391', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14948', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-9392', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9393', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14950', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2967', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9103', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-15625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15629', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1563', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22961', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9105', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-15630', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9106', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-9111', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9112', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9116', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9118', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-22963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9119', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22964', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8104', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8105', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14928', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8106', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14277', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1493', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-2486', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2257', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14545', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8602', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21997', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22787', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2279', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1523', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8609', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-15230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2200', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-22795', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-8610', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23389', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-22000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8611', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1456', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-22001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8612', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-15644', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21687', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15647', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8273', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2536', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8274', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16107', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-16108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9394', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2968', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-14951', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16109', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9395', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2969', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14952', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14953', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14954', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14955', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14956', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15775', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15776', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1447', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15778', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15209', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15553', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14050', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-7943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14052', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15560', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15564', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14796', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-7948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14057', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2258', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15578', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14815', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-7981', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2447', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-7982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14816', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-7983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14817', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-22299', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7017', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2163', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-15600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14278', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15637', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-14718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9122', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9123', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9126', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9129', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9130', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15646', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-13446', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-13449', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15229', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1345', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14579', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-22798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15232', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-22804', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14563', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8615', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14565', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8616', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22007', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14568', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15237', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8617', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15238', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14797', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7950', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14059', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14798', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-7952', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15572', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14801', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14803', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1496', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14962', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14963', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14964', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14967', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14969', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14970', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14971', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14972', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14973', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14974', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14976', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14977', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1498', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9401', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14207', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8563', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1578', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8564', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-21979', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-23364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14471', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14472', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14473', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-8565', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-14474', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14478', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15210', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-22769', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-14827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9137', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22011', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14574', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14579', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1458', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12846', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2198', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-2337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1448', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-2277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14481', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23370', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14485', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8568', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15781', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21982', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23371', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21983', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-8569', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22772', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8574', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1449', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15211', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-8576', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-15212', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2019-15782', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23374', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8577', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-15213', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2019-15784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14242', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2158', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-14832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15581', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14243', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14834', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-2300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7999', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-14835', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21631', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7960', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7965', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-14079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14807', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2016-7966', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-7967', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-14808', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-1408', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7968', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-15575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8282', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14331', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14333', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14334', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14335', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15650', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8283', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-8284', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-2544', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14214', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-14221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1502', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2970', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1503', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-1504', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1505', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1507', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1509', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9404', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14586', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23399', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1459', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23375', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8578', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-21986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8579', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-14493', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15214', 5.3, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2016-8580', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15787', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15215', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-15788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21987', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-8581', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15217', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22774', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-8582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14498', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21988', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-14810', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-14082', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2442', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14811', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8005', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21587', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8006', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8007', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-14840', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-14841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14323', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21198', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-21170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-2303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15608', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14284', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15610', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14956', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14287', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14338', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15075', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-15076', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8286', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14339', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8289', 4.2, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2016-7972', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1413', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15577', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-2971', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15122', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9405', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-14246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8008', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2460', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21591', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15218', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-22775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8583', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14499', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8584', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1450', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21989', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-14500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2199', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-14502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14503', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23379', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22779', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8586', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15795', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14505', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15796', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14513', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14517', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14519', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1452', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15222', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-2681', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14288', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14961', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1429', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21644', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2019-15613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15811', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2281', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15250', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15814', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22020', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14597', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15816', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8631', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-14598', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15817', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1460', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15818', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9138', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14720', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14819', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-1421', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-1482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15579', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9406', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15802', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16110', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2229', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8012', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14847', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21596', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14849', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-8016', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2018-14250', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2120', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2015-9525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14745', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14746', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14327', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21200', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2019-15614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2499', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21647', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15615', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14291', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1497', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1462', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14247', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-14629', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-2547', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8290', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15079', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-15080', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8294', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8295', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15081', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8296', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-8297', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-8298', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2550', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15660', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8299', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-2551', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2575', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8300', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8301', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-8302', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8303', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21697', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-8591', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23383', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23384', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-8592', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14524', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21991', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8593', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2685', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1453', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8596', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8597', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1454', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14541', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14543', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22785', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15226', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14544', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14549', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21996', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8605', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8606', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15228', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-14553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14822', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2018-1422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7985', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-7986', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14823', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14824', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-14825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14826', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1423', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7993', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1424', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2016-7994', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-22976', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14721', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-14724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22977', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-14729', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-15819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14601', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22815', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-22816', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-22293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22299', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9407', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16115', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16116', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2231', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-22311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2972', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9408', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22314', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15129', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14292', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14974', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-15617', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-21653', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14977', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14602', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15821', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15260', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-2578', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15084', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2579', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8306', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-15085', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-2580', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15664', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8309', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8310', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-2170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8313', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2016-8314', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15229', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2021-21999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14978', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14294', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21654', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21655', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2019-15620', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14981', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14296', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2504', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22594', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1284', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22284', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22595', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14662', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-7020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21201', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-14829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14241', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7995', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-14830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2453', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14831', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-2454', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23608', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-15803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2232', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-1513', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2974', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15130', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9409', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2975', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2233', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2976', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15131', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8638', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-2694', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-22820', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22821', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8639', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15827', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15264', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8613', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23391', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-22004', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14562', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8614', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14564', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14567', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15239', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-22009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15240', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14572', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8620', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14573', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8621', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14833', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-2455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14298', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2505', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14299', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21658', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15623', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1430', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9410', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23611', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-2978', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9411', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2979', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2981', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9413', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-23614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15133', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15830', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8642', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1499', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-14990', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-2166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15625', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14302', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1500', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-8204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8205', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2510', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21662', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15628', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15002', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-8207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1563', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8213', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8214', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8215', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8623', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8624', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23395', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-14581', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8625', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14583', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23398', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-14584', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14587', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8627', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14588', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22017', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8628', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-15809', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14590', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15247', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2021-22018', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-8629', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15248', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-14592', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14682', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-12840', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14684', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14685', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14686', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14687', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14688', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2118', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-14697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14292', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14293', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-12841', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14298', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-21182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-2773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2775', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2777', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2779', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2783', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2784', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14735', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2791', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2798', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22224', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-14736', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2803', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2808', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23552', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2809', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9154', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2811', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2812', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2813', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15658', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14244', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14838', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21588', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21589', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-14842', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14843', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-14844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8009', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8010', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2459', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14247', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22303', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21202', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8217', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21670', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14593', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14596', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22033', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15270', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8644', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14606', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15273', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2019-15836', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14253', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8022', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14254', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8023', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14857', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2464', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23615', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-15136', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-15138', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9414', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-15139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16128', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2234', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22340', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15140', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9415', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16129', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2983', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1425', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22602', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8017', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-22603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15586', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14850', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-8018', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-22604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2823', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2824', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23554', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1474', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-2825', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2017-2834', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2017-2835', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2836', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2837', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2838', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14740', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2839', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14741', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2863', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14742', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2870', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9160', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-2880', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2886', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14743', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9164', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2895', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2017-2896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14750', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14334', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14335', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2016-7037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14751', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21672', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21674', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14310', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21676', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8223', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15017', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8225', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15018', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-14312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21680', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-15024', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15255', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14851', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-15587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8019', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14252', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8020', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-21601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14853', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-14854', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-14855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8021', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-14856', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-22608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21184', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-16211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23750', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2016-9594', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23751', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9595', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9599', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9601', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9583', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3013', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9584', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-9585', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2261', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2262', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9586', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2263', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15928', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15841', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15278', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2235', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23618', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22358', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-15142', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2236', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15144', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2463', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8024', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14255', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14860', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8025', 5.5, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2016-8026', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14256', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21682', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14316', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-15033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14257', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14867', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21606', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15257', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-15820', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2901', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2902', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22226', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2903', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2904', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2905', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14744', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22988', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2918', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2919', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2920', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9166', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9167', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9168', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1476', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9176', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21186', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-14325', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2526', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9417', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2021-2237', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2238', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9418', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1515', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2239', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-22397', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15150', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2240', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-22409', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9421', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7041', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14340', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12850', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14754', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14755', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8634', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8635', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15822', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-15823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8637', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15825', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15262', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2341', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22042', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8649', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-15845', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-22043', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9587', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9602', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9606', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2241', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15152', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9422', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2242', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-15810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9423', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22439', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2244', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-2362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8027', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-14863', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-14864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14865', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23158', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24461', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2282', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-3124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3125', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3129', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21207', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-22028', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14604', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8640', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15829', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8641', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1583', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22298', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14308', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12843', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21187', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-22638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16206', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3014', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9589', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16207', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15933', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2264', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2016-9590', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16209', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-1621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15312', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9591', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9592', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-16210', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15935', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9593', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3015', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15941', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-9623', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3017', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9625', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23761', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15945', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9628', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15952', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-9629', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9630', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15953', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-16237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15955', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9633', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15315', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15292', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15848', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15293', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15294', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15831', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15269', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-8643', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15832', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15834', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22035', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15272', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-22049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15860', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8654', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8656', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15865', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8657', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8030', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-21605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8032', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9424', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-23620', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15155', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9425', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15813', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15156', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2246', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15314', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23752', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9597', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23754', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23756', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8331', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21707', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15099', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8334', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-15682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8335', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14344', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14345', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2585', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2171', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8341', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15103', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2016-8344', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-2587', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15104', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-15684', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-14311', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-21189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-15304', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15867', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15305', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15868', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15869', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15306', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22636', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7044', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14344', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-15050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21686', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-15642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2530', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-15274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22037', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15837', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2204', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15276', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2022-22828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22040', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1426', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3135', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3136', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3138', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3016', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9603', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-16221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9426', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15157', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15158', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2247', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15818', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15159', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15160', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15819', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15842', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8647', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15279', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22041', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9622', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9624', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15943', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9627', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1623', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-3018', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23762', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9631', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9632', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15958', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-1624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23763', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3019', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15312', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15313', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-15314', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15315', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14314', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14316', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7016', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-9643', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-3020', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-9646', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9650', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-2989', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-1582', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9430', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2248', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-15820', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9431', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15168', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9432', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1517', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16150', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15822', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-9433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15173', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15174', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15175', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15176', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2249', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9434', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2207', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8272', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-15648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21689', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-8275', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8277', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8278', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8280', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8281', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-2539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14332', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8353', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2017-2594', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15686', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-2173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-15108', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2016-8354', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15110', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8358', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-23764', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2016-9636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9637', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15316', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9638', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3140', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16843', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24465', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23172', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23173', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-16844', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-24468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24470', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-9179', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9181', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-9182', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9183', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9184', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9185', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2223', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9188', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9189', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-2927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-15324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15325', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15326', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8667', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-15327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8668', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-15328', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22096', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8669', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-15329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15889', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15178', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1518', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15180', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15182', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15183', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15184', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15185', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16155', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-15186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15188', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15189', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15190', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15191', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9435', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23628', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2021-22497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15826', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15192', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-15193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15199', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15202', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-15827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-15206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15208', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22498', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-22499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9438', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2250', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-22500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14349', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2231', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22045', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-8651', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22047', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15297', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15855', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-8652', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8653', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-22048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1586', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2205', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-22050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2709', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8285', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2020-15074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12845', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14319', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2020-1432', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-21193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1569', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23130', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2599', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-23131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2600', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23136', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-15118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2175', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9639', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9645', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15961', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-8671', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2723', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15332', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-15335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2210', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-15336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8287', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15077', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8288', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15657', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15658', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-21694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15829', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1583', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1521', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9440', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23629', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2023-2363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9441', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2251', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1522', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9442', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22511', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-23631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9443', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9444', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2211', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8676', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15892', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15963', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-15863', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3141', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21751', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-15695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2602', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15121', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21772', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21777', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2017-2603', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-8364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15701', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21781', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2604', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9190', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15665', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-14773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-15870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8659', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15871', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2715', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2206', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-15309', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1523', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23632', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9447', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9448', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9449', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9450', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9451', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-15840', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9452', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1524', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1525', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9453', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23636', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1528', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15842', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15850', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9454', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8291', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-8292', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-22654', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8293', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-21695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2549', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3021', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-9675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9676', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9677', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2606', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2607', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21785', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21788', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22685', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-21789', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2609', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23637', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-2252', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9456', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1529', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22521', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2364', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-9457', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22522', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2023-23641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22523', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2023-23646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15310', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9459', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2365', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22525', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8304', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2576', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15662', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8305', 1.4, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-22657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8307', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8308', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8311', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21700', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8312', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-2581', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8315', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-8317', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2582', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23127', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-21702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8318', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:N/A:H'),
('CVE-2020-15093', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2016-8319', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23128', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8320', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21703', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9192', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9193', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9194', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9195', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-22230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9197', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9198', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9199', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9200', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9202', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9204', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-9206', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9207', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2016-9208', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9209', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-9210', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9211', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9214', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9216', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9217', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-9222', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9223', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9224', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-2928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23776', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8375', 4.0, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-2179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2610', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15133', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-21793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21794', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14369', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15708', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2611', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-15135', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2018-14370', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15136', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-22690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15138', 5.3, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2016-8384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1571', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2612', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-15388', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-15389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23276', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17131', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17132', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-17133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3273', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3274', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3275', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3277', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3278', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3279', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3280', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-3281', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-3282', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-3283', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-3284', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3285', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3286', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3287', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3288', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3289', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-3290', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-24518', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:L'),
('CVE-2021-2289', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1539', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-2328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15316', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8661', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15317', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15318', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15319', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2209', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2020-15321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8681', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8683', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21704', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8322', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8323', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-14340', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21705', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8324', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8325', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9681', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15966', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-9460', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9461', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14722', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14723', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14324', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-14724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14725', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14726', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-14727', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14728', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14729', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-14730', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-12847', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14731', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14737', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7019', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14325', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-14743', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2613', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-21804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2614', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-21805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15142', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-22700', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2616', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2617', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22702', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15713', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15145', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-22703', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2619', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15716', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23143', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23144', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22706', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15717', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22707', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2182', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-2315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23151', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-15718', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-2620', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-23657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22527', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9462', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-16162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15859', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-15860', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-23660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2253', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-22531', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15861', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-17141', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-17142', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-17143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2452', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-17144', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-15390', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-17145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15391', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24523', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-24524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24526', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24527', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23280', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22890', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-15392', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-2453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24530', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-17150', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15396', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-15397', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-15398', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-15399', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-15401', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-15402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15403', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15404', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15407', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23292', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-24532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3291', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23295', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3292', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3293', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-3294', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3295', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3296', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-24533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-3297', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3299', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9686', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9691', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-9692', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-9693', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2017-3022', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-9696', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9697', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9700', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9704', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9710', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9711', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9716', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9718', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9719', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9720', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9722', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-9723', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9724', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-9725', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9726', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9727', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-9728', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9729', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-9730', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-9731', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9732', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9733', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9735', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9736', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9737', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9738', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9739', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9740', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9746', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9747', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9748', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9749', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9750', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9751', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9242', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9243', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-23555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9244', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9245', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9247', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9249', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9250', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15668', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-9252', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9253', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14774', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2023-23556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9256', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9259', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14776', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23558', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15863', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-15864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22539', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9463', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16167', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9464', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2254', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-22540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3142', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22823', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-23181', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23182', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16511', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-16512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16515', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-15330', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14747', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14328', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12848', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22622', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22302', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14329', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7030', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14748', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14330', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9694', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9698', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-9701', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9703', 1.4, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9706', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-9707', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-9714', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9717', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15147', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-21825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2621', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15148', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2622', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15719', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2316', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2020-15149', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2023-23161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2623', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15720', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2317', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-22716', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2183', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-15151', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2023-2318', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-2624', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2319', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15152', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2626', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15721', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-2272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15338', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-15339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15891', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8674', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22100', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-15340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8675', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15345', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3300', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15408', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23300', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22893', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-17159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9465', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22547', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15869', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-22548', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9466', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2255', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22550', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22552', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9467', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15882', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-23687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15883', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9468', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-22826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3143', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16516', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15331', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2283', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-3144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2284', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-23184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15095', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15096', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-15097', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-22664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14341', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-8327', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8328', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8332', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8333', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14342', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7031', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7032', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7033', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23782', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3024', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9260', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22231', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-14777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7053', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14773', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-14774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14776', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14777', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14778', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14350', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8690', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2730', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-15358', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8694', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8678', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22113', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15894', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22114', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15351', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2342', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15897', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-8682', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8684', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15409', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22895', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22896', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-1719', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3302', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3303', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-24538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1541', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24539', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-23780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9752', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2023-23781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3023', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23783', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16519', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15332', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23186', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3150', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3152', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3153', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3154', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3155', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3156', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3157', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-16523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9469', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2021-22553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16170', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-23688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9470', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-15884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9471', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-23690', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-15885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15154', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2023-23205', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2629', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2632', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14392', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15723', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-15159', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-14394', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2586', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14347', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2589', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-14348', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2590', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-15105', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2016-8348', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1435', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2267', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2591', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15685', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-14350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15107', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2017-2592', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9757', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3304', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-1720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1722', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-1723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3305', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22897', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1724', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1725', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-1726', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1727', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3306', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:L'),
('CVE-2018-15411', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1728', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-1729', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22898', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-3307', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-22899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14749', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7035', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22630', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7036', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14332', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12849', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15898', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22844', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8685', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8686', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8687', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8688', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22118', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8689', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8696', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9473', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-16174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16175', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-9479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9480', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-3004', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9481', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16176', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2595', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15109', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8355', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-21733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15111', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-8357', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-15112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15113', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2174', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15114', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-14355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2598', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8360', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21742', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15689', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8361', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2018-14356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3158', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2285', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-23189', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2319', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16529', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3159', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23190', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3160', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-22852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22853', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-22854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3161', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23191', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3162', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-2286', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-22860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16855', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-16531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23192', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-16532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3163', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3164', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-22847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15412', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1730', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-2290', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-1731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15413', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1732', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-15414', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3308', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-22901', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15415', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1733', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2022-23307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15416', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1734', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:L'),
('CVE-2022-22316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22319', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-14354', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-22320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-1567', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9262', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9263', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14779', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9264', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9265', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9266', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9268', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1478', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2739', 1.4, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-22128', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14396', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14398', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22726', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23277', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2186', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-21860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21865', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15167', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-2329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21867', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14404', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1441', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14415', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15168', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-2187', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-21870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2638', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-2639', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14421', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23193', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-16856', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3165', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3166', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16539', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23194', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-24477', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3169', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24478', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23195', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-16874', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8691', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8692', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8693', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8695', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2732', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-15366', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-3309', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-3310', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-22903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3311', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-15417', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24546', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-22904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22905', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-15418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1735', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-23308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8707', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14338', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-7038', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-21205', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-14339', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-22633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9269', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-23559', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9487', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9488', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9490', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9491', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3005', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23693', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-9492', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9493', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23695', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9498', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3007', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16179', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-15367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8697', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8698', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8699', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8700', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8701', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8702', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22127', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8703', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8704', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8705', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8706', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14789', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22325', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7056', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7060', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12855', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14790', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14791', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7062', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14792', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3312', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23318', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-23319', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17354', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-15419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1542', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-22908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2333', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2455', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-15420', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2291', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3313', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3314', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3315', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3316', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-23335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9778', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9772', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9773', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9774', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9775', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3025', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9776', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2256', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-9499', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22563', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-9500', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23698', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-16180', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22564', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22565', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-16181', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9532', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9533', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9534', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9535', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9536', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22567', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-15170', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2017-2641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14424', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14425', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2643', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2644', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2188', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-14429', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22736', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14430', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14432', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14434', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15174', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:L'),
('CVE-2022-22737', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22863', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23196', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-16881', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16886', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16541', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-16542', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23197', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1690', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-22864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16543', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23198', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-1692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8713', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22132', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15671', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-2356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14780', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22911', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23357', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-23358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23365', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22912', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-15422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15423', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2018-15424', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-15425', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-15426', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15427', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15429', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1543', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23377', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2338', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23383', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3317', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15431', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15432', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15433', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15435', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1736', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-17360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17361', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23400', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-17363', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-22915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8709', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8711', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8715', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22131', 4.2, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2020-15378', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22134', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2742', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22135', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3180', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16546', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16930', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23199', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2320', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16932', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16934', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16937', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-16547', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3182', 5.2, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16941', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23200', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16942', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16549', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24483', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23202', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3188', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16950', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-16951', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16952', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24484', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3009', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22568', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:L'),
('CVE-2019-16183', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-14359', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-7063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21218', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-14342', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22305', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-22654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16248', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16249', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22137', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8729', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-15676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15175', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-16954', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16955', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3189', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24485', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16552', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-1696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24486', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-16969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3190', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16554', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3194', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3199', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3200', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23205', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3201', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3202', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3203', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16970', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-22869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2287', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-3204', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22136', 2.5, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-15384', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15385', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-15436', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1544', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15440', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22916', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17365', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15441', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3318', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-17366', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-15442', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3319', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15904', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3010', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16188', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-1619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15311', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22569', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3026', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22307', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22308', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22637', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-7045', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7046', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-12851', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14346', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14347', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7047', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2121', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2015-9529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14769', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-15176', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-15177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2650', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-14440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15178', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-14441', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2653', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2654', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3208', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1698', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3210', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16981', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16558', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-22870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3211', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16982', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16559', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-1656', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-22871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16983', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3212', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3213', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3215', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3218', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23220', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16561', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-24487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3219', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3221', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16985', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16986', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7066', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14362', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14797', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-22641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22326', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22328', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-14800', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9272', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-9273', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15392', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8736', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8737', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8738', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8739', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8740', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8742', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8743', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8744', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8730', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15387', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-8732', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15389', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2021-22138', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8734', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2214', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22141', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9556', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9557', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2257', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-15907', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-16192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22570', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22571', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3320', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-17368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22918', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24568', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3321', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-23401', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24569', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3322', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-1737', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3323', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3324', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2020-17372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3325', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3326', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3327', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3328', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-23402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3027', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16987', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16988', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3225', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22876', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16989', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3226', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3230', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2017-3231', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-22877', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16567', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16990', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3232', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15333', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22331', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-22332', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7068', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22333', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14365', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2016-7069', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3011', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15910', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2023-23714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22572', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9560', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22573', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-16195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9561', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9563', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9564', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2258', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9565', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23001', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-23002', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-23003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-23004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-14787', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9282', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9283', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9284', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9285', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9286', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9287', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14445', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23304', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-14447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14448', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14449', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2661', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2662', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1445', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14451', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2663', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14452', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2664', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14453', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14456', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2666', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-21914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14458', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14770', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-12852', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7048', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22310', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-22311', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2016-7051', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-22312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-15394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15395', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8745', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8746', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8748', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15397', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15401', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8752', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15408', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-15412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14620', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14621', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22850', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2177', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-15123', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-14360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15698', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21773', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15699', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-15124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15125', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-21778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15700', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8365', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15128', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-15129', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15704', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8369', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14366', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21786', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21787', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-14367', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8747', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22152', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8749', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8750', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22154', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15400', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-8751', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1462', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-15411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9795', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9797', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9798', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9799', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9800', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9801', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9802', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9803', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-15977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-2667', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14459', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14460', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2669', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15184', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-9566', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15918', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9569', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9570', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9572', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9573', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-2259', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2260', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9574', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9575', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-3012', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9577', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9578', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9579', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9580', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9581', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9288', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9296', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9297', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2301', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9298', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1479', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14791', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14792', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-14793', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15679', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2017-2936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14368', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22642', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2015-9534', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-22643', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14369', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-14807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14808', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-21223', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-16568', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16991', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3233', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-24488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16992', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-16569', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-22879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3234', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3235', 2.5, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3236', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-16993', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2288', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3237', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1657', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16994', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15334', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-24490', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-16570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15335', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1534', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16571', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14368', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15132', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21790', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21791', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21792', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15134', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-21796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1437', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21797', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21798', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15137', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-21799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14371', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8382', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22691', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2016-8385', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8386', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15140', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2016-8387', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21801', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8388', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8389', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15711', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15141', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-2270', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15680', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9299', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14797', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9303', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-23807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14623', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14624', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2266', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-23798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16572', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-17016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1702', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-23234', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17020', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3239', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3240', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3241', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-16575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-24496', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24497', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1535', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23235', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2450', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-17373', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23403', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23408', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-17376', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2017-3329', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24572', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3330', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3331', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3332', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2017-3333', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3334', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3335', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3336', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-23409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3337', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3338', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3339', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3340', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3341', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3342', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3343', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3344', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3345', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3346', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3347', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3348', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3349', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3350', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3351', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3352', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-22919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3353', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3354', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-2341', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3355', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3356', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3357', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3358', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3359', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3360', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3361', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3362', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3363', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3364', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3365', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3366', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3367', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3368', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3369', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3370', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-23410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3371', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-15454', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-3372', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-15455', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3373', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-15456', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3374', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-15457', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3375', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-15458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3376', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-15459', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3377', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3378', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-23802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9804', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-23803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3028', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23806', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22314', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14772', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1480', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9304', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14800', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9305', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9306', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9307', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14372', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-22645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22339', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-12858', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7073', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2615', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-21808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21809', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-15712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2181', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2021-21810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21812', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21813', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21814', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21815', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-24503', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-24507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1659', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-1660', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1661', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1662', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3243', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23238', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-17049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1705', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17052', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17053', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16645', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-17054', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17058', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1706', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17060', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-17061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8501', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8502', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-8503', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-8504', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-15738', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8505', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-22665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3029', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-15980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3379', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3380', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-2342', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3381', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3382', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3383', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3384', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-2292', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3385', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-22920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3386', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3387', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3388', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3389', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3390', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3391', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3392', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-24576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3393', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2018-1546', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3394', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3395', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3396', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3397', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3398', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3399', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3400', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3401', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3402', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3403', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3404', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3405', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3406', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3407', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3408', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3409', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-24577', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-3410', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3411', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3412', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3413', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3414', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3415', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3416', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3417', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3418', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-24578', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-1738', 2.7, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:N/I:L/A:L'),
('CVE-2017-3419', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3420', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3421', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3422', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3423', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3424', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3425', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3426', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3427', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3428', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2016-9310', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2018-14806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22239', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9311', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2224', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9312', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14808', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9314', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22240', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-15690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1481', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2939', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15693', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-9317', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23809', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22666', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9807', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3429', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-24579', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-17380', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-17381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3430', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3431', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3432', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3433', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3434', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3435', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3436', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3437', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3438', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3439', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3440', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3441', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3442', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3443', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3444', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-22921', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3445', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-3446', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-15462', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15463', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15464', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2017-3450', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3452', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17063', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-17064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17065', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17066', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17067', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16661', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1707', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16669', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3245', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2018-1536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3246', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3247', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-2451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3249', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-3250', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-15361', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15362', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-3251', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-12853', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14784', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14785', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9318', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-15695', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-14812', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9319', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15697', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14814', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-2940', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9808', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2267', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9809', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-8506', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-21944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15191', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-15192', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-8508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22749', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-21946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15193', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2016-8511', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21948', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8513', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2195', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-15194', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-15739', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3252', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2017-3253', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3254', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2017-3255', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-1708', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23242', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3256', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23252', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22884', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15363', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15364', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23258', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-23259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15365', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1709', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1710', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15366', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9333', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15698', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15995', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-15699', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-1570', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15700', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-15701', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15702', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15703', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15997', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15999', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-14818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2941', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-14355', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2019-14787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9531', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22321', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7055', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-23818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9810', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15317', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3030', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23819', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9811', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1574', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8514', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21956', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8516', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15196', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-8517', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8518', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15197', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-2196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14375', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7076', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-22651', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-14813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-22652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-14376', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-22349', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2463', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-23820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9812', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9813', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-22886', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17100', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2326', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-22170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-23468', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-22752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15740', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15198', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-15199', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15200', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15201', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-8520', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22243', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15704', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14820', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15367', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23261', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-23262', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-17106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3259', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3260', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-3261', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-3262', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3263', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3264', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-24512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15378', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15380', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23263', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-17107', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23264', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-17108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17109', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23266', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1711', 3.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2023-24513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17110', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3265', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-3266', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3268', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3269', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1712', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21217', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14821', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15705', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15706', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2942', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15707', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14824', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14827', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14828', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15709', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15710', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-14829', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-2235', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22350', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7079', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21228', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21966', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8521', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-22753', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8522', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15742', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2197', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-15202', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22754', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9826', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15985', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3605', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16729', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1673', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23467', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3606', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17470', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3607', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17473', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-17474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2347', 6.0, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-16738', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-17478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3608', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1674', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3609', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1438', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14380', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2625', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14381', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14382', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14383', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2627', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-21835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14388', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15155', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-14389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2184', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-21840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1439', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9814', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-23824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9819', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9820', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9821', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9822', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9823', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9824', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9825', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9827', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3031', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-23828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22672', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9828', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14627', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14628', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14629', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22169', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3270', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3271', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-17121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3272', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-17122', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17123', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17124', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-17125', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17126', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17127', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17130', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1483', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14831', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15712', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14833', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14835', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15715', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-14836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2943', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14837', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9334', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-1484', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14840', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15719', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-14846', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16000', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16001', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2016-8805', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8806', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14631', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23480', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8810', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-8525', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8526', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8527', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8528', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-14360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-7064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14361', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14794', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-12856', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14795', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21219', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7080', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7081', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7082', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7083', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7084', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-7085', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7086', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7087', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-14378', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-14379', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2015-9538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14380', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-23830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9829', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15156', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-21846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15157', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-21848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2633', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2185', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-21850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14395', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22721', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-2635', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14397', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-21855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1440', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15163', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-15724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14401', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14402', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3610', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17480', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3611', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17482', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-17487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3612', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22959', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-17489', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-2296', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-23473', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3613', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22960', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-23475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3614', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3615', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22964', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2022-23479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8811', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22176', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15720', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-22246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15752', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21973', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8530', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8531', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15753', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-8532', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15757', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8533', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15204', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-21974', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-8534', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8535', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-22758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2944', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16004', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-14849', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15723', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1485', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16007', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-15731', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-22247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14850', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-15734', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14851', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9830', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9831', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9832', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-23832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3032', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-9835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15988', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-15465', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15466', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15467', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23433', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-22923', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1547', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-24580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23434', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21863', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15165', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-21869', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2637', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-14417', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15726', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3616', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23456', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23457', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2744', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2745', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2746', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15989', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2015-9539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2123', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-15759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22759', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-15766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15767', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23342', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23344', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23346', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23347', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-15769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3617', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3618', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-17490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23481', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-3619', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23482', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-22968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17494', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23483', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-3620', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1675', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3621', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22969', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3625', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-17495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3626', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-16751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23485', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-17497', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2297', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-16752', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-14364', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-21220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3454', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-23435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3455', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-1739', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-17390', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-17391', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-15929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-23489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-15469', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-2286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14423', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2642', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15171', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15727', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2645', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1443', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-2646', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14435', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16753', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3633', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-23486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15528', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15529', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3634', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1553', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3635', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1676', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23490', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1577', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-15206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15770', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23348', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-15771', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22172', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23469', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8803', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-22174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23475', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-14630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8807', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14632', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-2348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2748', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8808', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-15990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3033', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-16252', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14382', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2946', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14857', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15767', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14858', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14859', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14860', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-14861', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14862', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14863', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-14864', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14865', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14866', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14867', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14868', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14869', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1487', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14872', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14873', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14875', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14876', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14877', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15770', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22249', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2947', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-14878', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9338', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-15773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2225', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15774', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1573', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14438', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-2648', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-22738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1444', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2649', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2651', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15179', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-22739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-17392', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-17393', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-17394', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-17395', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17396', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-17397', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-2459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-16760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16761', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-23491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-17507', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-15532', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-23492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3636', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-16762', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-16763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23493', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-16764', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3637', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15535', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16765', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2464', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-8809', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7070', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12857', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-14802', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-14804', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-14805', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14367', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-21222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15731', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-14443', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14444', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2659', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15732', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14450', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15180', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-15772', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15773', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2015-9541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9542', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14815', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12860', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22351', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-14383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14635', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23482', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-22177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-23487', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23488', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14636', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14637', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14638', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14879', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1488', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9345', 5.3, 'CVSS:3.0/AV:A/AC:H/PR:H/UI:N/S:C/C:H/I:L/A:L'),
('CVE-2020-15777', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2948', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22250', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-15778', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3034', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16254', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15733', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14454', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15182', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-21912', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2665', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-23837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16253', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22178', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-15931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22179', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-15932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2218', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-22868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15470', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15471', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-15935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22180', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15472', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-8855', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14370', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-14371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-22644', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14809', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7098', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7099', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-21916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2668', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2670', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15185', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15186', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-21926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22746', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-23842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16924', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16927', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15755', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-23598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-24744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18392', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24752', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24754', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24755', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18395', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24756', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24757', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24758', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-23601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22981', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-2476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23661', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-18900', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-15890', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23662', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15187', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-2672', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2674', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8494', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2675', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15737', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-22344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-22647', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-14374', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-14811', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7074', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-22648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14812', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-7075', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21226', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-16255', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9543', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-7101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2015-9544', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-24760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23602', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-18409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15758', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22677', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16263', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3035', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22678', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23847', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-15996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15473', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-15474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8856', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8858', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8859', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15938', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15939', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8860', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3457', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17398', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-24597', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17399', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-3459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24598', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3460', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15536', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-17509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-24643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3638', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1751', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3639', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1554', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15542', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15543', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3640', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-21939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14465', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15898', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15903', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23665', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15906', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15908', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4015', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-17008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24599', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-23437', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15473', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15474', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-3461', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2460', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2023-23848', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15479', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14642', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14644', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7077', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-7078', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-12859', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1286', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14377', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-17511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15546', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17513', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1555', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17514', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16768', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2350', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-17515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1677', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3642', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1556', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16771', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-15560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3643', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1986', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1725', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-19861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17251', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1987', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19877', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17252', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17253', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15995', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1988', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17255', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17256', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17257', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15318', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23850', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23854', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-23855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23857', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2023-23858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15759', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23605', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23607', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2023-24776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15761', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16932', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2020-15779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-15943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8867', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15944', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-15496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15945', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8871', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15909', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15910', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3036', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2268', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15563', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15564', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3644', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4028', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1701', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15911', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15917', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18438', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15762', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18439', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23609', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-15763', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15764', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18442', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-24785', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-23610', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15480', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-15481', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14645', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17258', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17259', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19883', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15996', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15918', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-19001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17011', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-1902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1752', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3645', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15565', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15566', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3646', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23502', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-15567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17521', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15569', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3647', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23865', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-22681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19886', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-19887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19888', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-19889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19909', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-17262', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1991', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-15488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-15942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22184', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15495', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8869', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8870', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15946', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8875', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15766', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15768', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22985', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1694', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-18457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18463', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-3869', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3870', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-15769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18464', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-3871', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-18467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3872', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23615', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-17013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19038', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-4052', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23866', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16275', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23867', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22683', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17522', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-15570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16776', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3648', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15571', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-17523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3649', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-17525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3650', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-4057', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15922', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1905', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-17017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2949', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15784', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15785', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15789', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-2950', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15790', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9349', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15792', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9351', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15793', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-15794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9353', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22253', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-9354', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2951', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9355', 4.0, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-9356', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17263', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-19915', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17264', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-17266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15998', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15999', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17526', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-15574', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16779', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15576', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1678', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-17527', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3651', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-23506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17528', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-16780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8877', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8878', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15954', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-15955', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8883', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8884', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8885', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8886', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8887', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8889', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8897', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8900', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2287', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2016-8876', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-15949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3874', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15771', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3877', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-15772', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-23617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24804', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-15773', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24600', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3462', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1740', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17400', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-24604', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17401', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-2344', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2369', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17021', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2269', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1628', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3038', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-23873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16283', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22254', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2952', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16017', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-9360', 5.3, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:L/A:L'),
('CVE-2021-22256', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-2953', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-7102', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-14816', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2015-9545', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-12861', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3880', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-1853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-24809', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1862', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-2481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23507', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3652', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-16781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23508', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23509', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16782', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1558', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1753', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3653', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-1911', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1912', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1913', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15927', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1703', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-19138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8879', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8882', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22187', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-22188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17273', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17276', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23001', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2954', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22257', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16029', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-23561', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22258', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-22356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-14817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2015-9548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2015-9549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-21233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15929', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16000', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15580', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3730', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23512', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-17530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15581', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23513', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15582', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16789', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-23516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17533', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-15583', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17534', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15584', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1679', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-17538', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15585', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1754', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-17541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15586', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-17542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3732', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16791', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3733', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22974', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15781', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3882', 6.0, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23620', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-15782', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1695', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8902', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22696', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2219', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2016-8905', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15509', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15960', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-8906', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-15962', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15513', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8908', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8909', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-22190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8910', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-8911', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2288', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22989', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-19156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2955', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23562', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23563', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2956', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16951', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1696', 4.0, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-16001', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-23002', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21234', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-21235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-21236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22358', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-14387', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-14388', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-21237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12862', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-14818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-14819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-14389', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-1439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-14820', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-21239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-18659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3884', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3885', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15795', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-24815', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3886', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15796', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3887', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3888', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24816', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3889', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15797', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18661', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15798', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-3891', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3892', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15800', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3893', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-18663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23627', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-3894', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15801', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3896', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23628', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-2363', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-15804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18665', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3897', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23568', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-23569', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23573', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2957', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2958', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-24950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24953', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16002', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-1919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15587', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3735', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-1755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-15588', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-17551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-22697', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3039', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22698', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23883', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15934', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22262', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-2959', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3898', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15805', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-16968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15807', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15809', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3899', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23630', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15810', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3902', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15813', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15814', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15815', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15816', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16032', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16003', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2004', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16004', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2496', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24964', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24965', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22263', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2960', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23440', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23441', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-17402', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-24605', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-22924', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-17403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17404', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17405', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23446', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22925', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3464', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3465', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3467', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23026', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-2270', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3040', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16064', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2023-2358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2961', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15817', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18671', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1697', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3912', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23633', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-18684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23634', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18693', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16005', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23700', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24978', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16006', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-24982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8962', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8912', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8913', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8915', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15516', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-22880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8916', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8918', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-8919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8920', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8921', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8922', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8923', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8924', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2016-8925', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8926', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8927', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8928', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-22885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8929', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-22888', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8930', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2016-8931', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8932', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8933', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15963', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15966', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-8935', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8936', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8938', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-15517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8939', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-8942', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8943', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8946', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8947', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8949', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8950', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-8951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8952', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8953', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15967', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8961', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-4974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4975', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2389', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-4976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23896', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4977', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4978', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2390', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2020-20466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20467', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-23901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16033', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-23885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3041', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24986', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23708', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24987', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23709', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-20096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-24988', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16007', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-24989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24990', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24991', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16008', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24992', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24993', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20118', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24994', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23636', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1583', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-18701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15832', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15833', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-24836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23639', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15834', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3933', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3934', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1584', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1698', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8963', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22890', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22891', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22892', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22894', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1465', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14650', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22899', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-8966', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8967', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8968', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8971', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8972', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8973', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-8974', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-8975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-8977', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8980', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2016-8981', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-8982', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8986', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-8987', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-8998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-8999', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9000', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22908', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2291', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-15522', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9008', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9009', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9011', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9014', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20470', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-20471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4986', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-20472', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4989', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23907', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23909', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23911', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16034', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-20486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24995', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23714', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23716', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16009', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-20120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23717', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1601', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23718', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24999', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-17300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23719', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23720', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23721', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-20131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16010', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-25000', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23723', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-23724', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-16011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15319', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1532', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23898', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14884', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14886', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14887', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-16069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14888', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14889', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22267', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14890', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2227', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-2962', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14891', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9368', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14894', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2512', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20491', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20495', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-23916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14901', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14902', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14904', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14905', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14906', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14907', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14908', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14910', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22275', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-14911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14912', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-2963', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16088', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2964', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4994', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-4995', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23921', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16035', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23016', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-4999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23922', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-20508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5000', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-20514', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2017-5001', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-20521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23017', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2020-20522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5002', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23018', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16036', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23020', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-23021', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23899', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-3042', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16011', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2016-9015', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9016', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9017', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9018', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-15523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9019', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22193', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-15842', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3935', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15843', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15844', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15845', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15847', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24842', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15848', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15849', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-18735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18741', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-16983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1585', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15853', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16985', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15854', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23725', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23726', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20141', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16012', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-23004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23900', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22704', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-16012', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-19229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2373', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23005', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-23006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23007', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-17304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16013', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2020', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25003', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-2124', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-14392', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-7107', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-21240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-14393', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-14394', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2016-7108', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-21241', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2016-7109', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-12863', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-21242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-7110', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23589', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-2359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2965', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1492', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14922', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14923', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14924', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14927', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14928', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14931', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9372', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9373', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9374', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9375', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9376', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3468', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-22926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3469', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3470', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3471', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-3472', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3473', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3475', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2017-3476', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-3477', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3478', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3479', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-3480', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2017-3481', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3482', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3483', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3484', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3485', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-3486', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-3487', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3488', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-3489', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3490', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3491', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3492', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-3493', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2017-3494', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2017-3495', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2017-3496', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3500', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2017-3501', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3502', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3503', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H');
INSERT INTO `tpandora_cve` VALUES
('CVE-2017-3504', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-1741', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2023-24619', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3505', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-3506', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3507', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-3508', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-3509', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-3511', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-23449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15590', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15591', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3736', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3737', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15592', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17563', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-24653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17564', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-24654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1757', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15593', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1680', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-1758', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3738', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15596', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1759', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-23521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15598', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22705', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3043', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-16013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19275', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19277', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15855', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18766', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-18768', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15856', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18770', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18771', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-23648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-23649', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-18775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1699', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22932', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-15526', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15531', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14657', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14658', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15532', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22934', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22935', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-15975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22195', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20593', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-20597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2393', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23022', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-20601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23023', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17356', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16015', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2301', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23523', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3740', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15599', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3741', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-23525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1762', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2017-3742', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15601', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23526', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1764', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2017-3743', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15603', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1765', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-2353', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3745', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1766', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23531', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15606', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1767', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-15607', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9379', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2016-9380', 5.8, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-14936', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9381', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2966', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9382', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9383', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-9385', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-9386', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2228', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-14938', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-23596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9387', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9388', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-14939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1494', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14940', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-9389', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1548', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3512', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-17411', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-3513', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-3514', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-3515', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-3517', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2017-3518', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22927', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-22928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3519', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3520', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3521', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-17412', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3522', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-17413', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3523', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-17414', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3524', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3525', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3526', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3527', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3528', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-1549', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17416', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3529', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16016', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23742', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23743', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23744', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-23745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16017', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2023', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-23746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23748', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15525', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-14653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22194', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19287', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22936', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9043', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9050', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2016-9051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22197', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-22939', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22199', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2220', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-9063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3530', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-3531', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2020-17417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3532', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15491', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-3533', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-17419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3534', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15492', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15493', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1742', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3535', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2017-3536', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-17420', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-17421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17422', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-15494', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3537', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17423', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17424', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17425', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3538', 5.8, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2017-3539', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-22929', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2023-23909', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16014', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-15610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15611', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1768', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2022-23532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15612', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15613', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15614', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15615', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1769', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23538', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-15617', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1770', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23678', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15941', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19303', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1931', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19316', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25004', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2024', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-25006', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2376', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25008', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15857', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15858', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3961', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3962', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18780', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15859', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23651', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18781', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15861', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3964', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15862', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23653', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15863', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3966', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-3967', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14944', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9390', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15569', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9064', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2025', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16019', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1602', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2377', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-23770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17058', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-1932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23539', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23540', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2020-1772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23541', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-23542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1563', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1773', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15632', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-1774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23546', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-15977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9038', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-15542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9042', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9048', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-15543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22938', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-9061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22198', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9062', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15864', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15865', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15868', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3968', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3969', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15869', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-1886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23655', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15943', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17060', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17061', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24892', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-1935', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-17063', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17064', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-19364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15946', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-17074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3540', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-15499', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17426', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3541', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-3542', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-3543', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-17427', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17428', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-17429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17430', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17431', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1550', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2462', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-23911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9844', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-16017', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-16020', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4897', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-4898', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-4899', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4900', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4901', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23774', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-17312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23779', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2026', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-2378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1775', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-15633', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15634', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15635', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1776', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3044', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16016', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-17076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15948', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17080', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1943', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15949', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15950', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-23518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15570', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1777', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3757', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1564', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1778', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2355', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-22977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17093', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15951', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17098', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2352', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-15573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22202', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-17099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1945', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15952', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19463', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19464', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15953', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19465', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19466', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19467', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19468', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19469', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-1947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17105', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19470', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19471', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3762', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23551', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2018-15641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3763', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2466', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-9851', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9856', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3045', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-9859', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9860', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9861', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9862', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9863', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9864', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9865', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2141', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-17542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2142', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-17543', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21426', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17357', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17358', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-20627', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-20628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20633', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9845', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-9846', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-9847', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9848', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9849', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9850', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9852', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9853', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9854', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9855', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9857', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9858', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-16018', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-4902', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-2379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-4903', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3971', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1887', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1587', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23657', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-3972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22987', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-19472', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19473', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19474', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19475', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15954', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19481', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-19488', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15955', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4904', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25017', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-25018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15870', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15871', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18878', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-18879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15876', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-16999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23658', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-17000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-15981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9068', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-15982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9069', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-15983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22943', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9070', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21427', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21428', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25019', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4905', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16022', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4908', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4909', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4910', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-4911', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25023', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4912', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-4913', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4915', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4916', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24620', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3544', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-17432', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3545', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-17433', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-17434', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3546', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-16675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17435', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-15502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3547', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-15503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17436', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-3548', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-24625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3549', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-24626', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-3550', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2019-16676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3552', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-16678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3553', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-22932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3554', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16680', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-16681', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3555', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22945', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15589', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9074', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9075', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9076', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9867', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2016-9868', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23935', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-20636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25134', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2394', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-17359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25136', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-20642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1588', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-17001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15880', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17002', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-22992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17112', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1950', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1951', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15956', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19511', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19513', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9071', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-15985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-15986', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-15987', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22946', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15586', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4918', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23801', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4919', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23803', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23804', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23805', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-2503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4920', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17316', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4921', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4922', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23806', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-25033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4924', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23807', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-25034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-20287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4925', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4926', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4927', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4928', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4930', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9077', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-22950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1466', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17544', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-25450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2143', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24071', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-21431', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-25452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24073', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-2144', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-17547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3764', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23554', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-23555', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16860', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1565', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16861', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15655', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15656', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15657', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15320', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9869', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3046', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2016-9872', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23914', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9873', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-22709', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9877', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23915', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-9878', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9879', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16021', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18889', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-1889', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-18890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15881', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-18897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2366', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-18898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15882', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23660', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15885', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15886', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20658', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23944', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-20662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-23945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23946', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-23947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-20665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5007', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22947', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22205', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-15592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-15593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9082', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22951', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-14661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-14662', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14663', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-14664', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14665', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22952', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-22953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14666', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14668', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15960', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16682', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-22933', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-16683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3556', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3557', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2020-17437', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-15508', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17439', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2019-1669', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-22935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3558', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2019-16692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1744', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-1551', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3559', 5.3, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2017-3560', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15510', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15511', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15512', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17441', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-22937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-4931', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16025', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4932', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4934', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4935', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4936', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-4937', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2382', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-4938', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-4939', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17319', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2271', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9880', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16151', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-22056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16152', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-22061', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25517', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-16156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16157', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-24231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24232', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24236', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-16159', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16160', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2210', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-2552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16162', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2424', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2212', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-22120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16163', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2145', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2146', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-24074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15962', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15963', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-1953', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15964', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15966', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15659', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-17901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-16866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1566', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15660', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15661', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15664', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-23561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15665', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15667', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15513', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3561', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-16695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3562', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15515', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15516', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-17444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3563', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-16696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16698', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15517', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-17446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3567', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3568', 5.5, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2018-15518', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3569', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-16700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3570', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3571', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3572', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3573', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3574', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-2294', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-2345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25140', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20672', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25144', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1604', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23951', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-23952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20691', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-25146', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1736', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23012', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-4941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2032', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17321', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-4942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15967', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1954', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15968', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1713', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15969', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15970', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17130', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-24910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15892', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-23663', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15894', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1892', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-15895', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15896', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15897', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23664', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15899', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15668', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15669', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-23563', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-17952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2147', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-25462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2408', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22712', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9888', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9889', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3047', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9892', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16024', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-4943', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2033', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4945', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4946', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2383', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17330', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-4948', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-20340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25064', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-20345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4949', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1772', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16172', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-22166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16174', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16175', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16176', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2218', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25536', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1618', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22200', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-22201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16181', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4012', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4013', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-4014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23666', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-22711', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1567', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15670', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-23565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15671', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-23567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17999', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3770', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16872', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-15676', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-15677', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20700', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17362', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-20701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-20739', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4016', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-4017', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-1897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18971', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18972', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-18974', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-23669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23835', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4950', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23849', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16029', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4952', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23850', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1603', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15971', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15972', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15973', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17131', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-1956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15974', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19586', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-15976', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22219', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2428', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-2148', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-21480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17554', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-24082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21487', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-24083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23038', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-2149', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17558', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21493', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18998', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18999', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17010', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15678', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15679', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2357', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1568', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3774', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15683', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18032', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1688', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-18035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15684', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15685', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2467', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-9893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9894', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3048', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9895', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16025', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-17336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4960', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25074', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-4961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17337', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-17338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23853', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17339', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-23854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16030', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-4963', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4964', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-20406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-4965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2547', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-21496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17560', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-17561', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2150', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21504', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16074', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14669', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1467', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2221', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-14670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9085', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9086', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14671', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-22956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23959', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20740', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22716', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24280', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-19005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15919', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1903', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15920', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19037', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17014', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-23858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4966', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2386', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-4967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-20413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16031', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4969', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-4970', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-4971', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-4053', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-4055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1904', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-19042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2353', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2016-9091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15601', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9093', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22210', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-14679', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-22958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9099', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-14685', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14686', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14688', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22211', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14690', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14691', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9100', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1470', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9101', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-21505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2272', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3049', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-20425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2387', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-16026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2554', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5049', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17018', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1702', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15923', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-1908', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15924', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2151', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17563', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24090', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21524', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-21525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21527', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-21528', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24091', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25153', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16041', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14672', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-23529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-22957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9094', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1468', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-15602', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15925', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-19110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15926', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9896', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22718', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15978', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17134', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-17135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17136', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17138', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-15979', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1960', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23976', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-17378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23279', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2020-23315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1644', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16444', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-24350', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5103', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-22277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5051', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-1914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15928', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16475', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23550', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23552', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23553', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16476', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-23345', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16477', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-23347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16478', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23560', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23561', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23562', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1824', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-23563', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23565', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24375', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23566', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24378', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23567', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16480', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23357', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-23576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16481', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16075', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-14683', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14689', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22212', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24671', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22978', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-23572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15686', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24674', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1915', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1593', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19150', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-17040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17043', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15930', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15931', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16042', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-25158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17379', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23981', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25160', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17382', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-15980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19609', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-1961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1714', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-19613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19617', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5109', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-2230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21529', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2153', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21530', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21531', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21532', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21533', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21534', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24092', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21535', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25483', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5032', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23920', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3050', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2016-9897', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-23028', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2016-9898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15687', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15688', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3776', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-18070', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-23575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15691', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15692', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-16887', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15693', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-3790', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-3791', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-3792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1649', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-23618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16490', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23365', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-23368', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-16491', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16492', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16493', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18243', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18244', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18245', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23372', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1825', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1650', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23380', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-23381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23680', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16509', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16445', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23280', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16446', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23281', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-16447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16448', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16449', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23284', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25748', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-16450', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25749', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-23286', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23287', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23288', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25750', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-15932', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17143', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-19625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1963', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-17148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16705', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-17449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3575', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2022-23450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1671', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3576', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-16711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3577', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3578', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23451', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-16712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3579', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3580', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-17451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-17452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3581', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22943', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-3582', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3583', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-3584', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-3585', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-22944', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-17453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3586', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-17454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23453', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3587', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2022-23454', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3588', 5.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2022-23455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23456', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-3589', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-22945', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-3590', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-23457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3591', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2017-3592', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3593', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2017-3594', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-3595', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-22946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2555', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16031', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-18081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3795', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-18084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3797', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-18102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3798', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3799', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3800', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-18106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3801', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-18114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3802', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23578', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-18116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25161', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-23984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16043', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-20813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5011', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-16452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-5104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9102', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-15605', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9104', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22214', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2016-9108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9114', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9117', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18255', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17567', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2154', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25484', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23039', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24094', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2155', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1689', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2017-3806', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-18121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15703', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3808', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3809', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2019-16891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3810', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3811', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15704', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16892', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-18127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15705', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-18129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15706', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9900', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23923', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-23924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16034', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-23458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3596', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-23459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3597', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-3598', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22947', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1746', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-17462', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23922', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16033', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-15933', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16453', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2332', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2018-16454', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16456', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16457', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-23327', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-23328', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-24359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23341', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16459', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-15935', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24882', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-15936', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1926', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16513', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25780', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25782', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23726', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23727', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24386', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16517', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23740', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23754', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-23394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23395', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-23396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25552', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-2237', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-2238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2239', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1715', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15983', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17151', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-24919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19667', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24920', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1717', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15707', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-15708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15709', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3813', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3814', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-16897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3815', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3817', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-18151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1571', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3821', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3822', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1690', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15710', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15711', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15712', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15713', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15714', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16903', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-18165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3825', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18169', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23331', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16460', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-23355', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16461', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16462', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-23361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-19267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15937', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19268', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-1927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15938', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1928', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19284', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15939', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25162', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17387', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25165', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17388', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9121', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-15638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-17176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15984', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15985', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19676', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15715', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3827', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2022-23583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3828', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3829', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18171', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-3830', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16905', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16907', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-15717', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16908', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-18184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16909', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3833', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18190', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-1691', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2020-18191', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-15718', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3836', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3837', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-3838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3839', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3840', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15719', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3841', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3842', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3051', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23926', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-16035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9902', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-23927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9903', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-5057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2304', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-21554', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-24095', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2156', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17569', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-2157', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24096', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21573', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21583', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21588', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21590', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24099', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-21595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-24392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-18278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23830', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2019-18279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16523', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-23832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23834', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23408', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18281', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-16525', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2341', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-23411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-23852', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23856', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23861', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16463', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-23370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25759', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-16464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-23373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23446', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16465', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-23449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23336', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2023-25167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-20907', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-25168', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-25169', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-20908', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2517', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-17393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2091', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-20913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25171', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-22965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16189', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3843', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-18221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3844', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3845', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3846', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-16910', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15986', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-17185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1719', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17190', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1968', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3847', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16913', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3848', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15726', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-23588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2468', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-23450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2576', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-25760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16466', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9128', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22218', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-15647', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-22968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-14719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-22969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-15649', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-21598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17572', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24101', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-17574', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-21600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16078', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-23931', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2016-9904', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23933', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9905', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23934', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-16039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15987', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25806', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24409', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16528', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23889', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23890', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1653', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25809', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-23894', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23895', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23896', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23897', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23898', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23899', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23900', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18297', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23901', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23902', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23906', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1830', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1654', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18302', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23911', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16540', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23912', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23434', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-23915', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16541', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16191', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5061', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-23929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3052', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-23930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18308', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23922', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-18311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23930', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23437', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23931', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-16543', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23932', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16548', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16549', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18316', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16550', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1720', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17201', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24365', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16467', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16468', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23339', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-1647', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-23518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23340', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-25764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16471', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2094', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-20943', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-25173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20944', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-20945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-20949', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2095', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17401', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-22970', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15650', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2016-9139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9147', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9148', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15651', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-22971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22973', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2222', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-22975', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14722', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14728', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-15653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2249', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17202', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15988', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1971', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-15989', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1599', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-19722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1473', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22221', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-23548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-22980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2355', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-14732', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-14733', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-15655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-23520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18236', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25765', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-23533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24368', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-16473', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16474', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5107', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-1929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15940', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1930', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20950', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5014', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2016-9909', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9910', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16041', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-2346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-3599', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22948', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2020-17463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16716', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22949', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-17466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2295', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3600', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3601', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-17467', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-16718', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-16719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-16038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-18325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-23973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5117', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2253', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-22533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5065', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2018-15942', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-22983', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2017-2752', 1.4, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-2765', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2768', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9152', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-15656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2782', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-22223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-2785', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2787', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2788', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-2790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2792', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-2793', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2794', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2795', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-2797', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2799', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-2802', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2804', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14737', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-2806', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-2807', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-14738', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-14739', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-22984', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-1672', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2017-3602', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-16722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3603', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16723', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-17468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3604', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22953', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2019-16725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-17469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19724', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24930', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19725', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1722', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-22998', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-17220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17579', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5033', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-20951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17404', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17405', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25177', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-20971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17406', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-20977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16049', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20982', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-20988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-20989', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-5015', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-18335', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23463', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-2347', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2020-23986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1657', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2349', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-18339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24003', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2583', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-24008', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1658', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24025', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-23497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18340', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5119', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2016-9911', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-23937', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-9913', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-3054', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9914', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-23938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23342', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23551', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23555', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-23558', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24373', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2335', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-23559', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2258', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24102', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17581', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15990', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19751', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-19752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-1976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9907', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-3053', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-23935', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9908', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-2814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2815', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-2816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2817', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2818', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2819', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2821', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-2822', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9156', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-2826', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17228', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-19765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-17229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24103', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16079', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2260', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-22607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25578', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5371', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24445', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-5372', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24447', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24448', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24450', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2395', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-23358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-16483', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16484', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16485', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23362', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-16487', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-16489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-17415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25179', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2099', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-17417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-20990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25182', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17420', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16050', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17424', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24934', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-19769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17230', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-1977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24936', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-1978', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-19786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17235', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-19802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25848', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25859', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24136', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-18359', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18360', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24140', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-24141', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25862', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-24143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24144', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-24145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25863', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18361', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-24146', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-24147', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-18362', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2351', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-24148', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-25865', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3851', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3852', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-24684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3853', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15727', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15729', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15730', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-22980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-15731', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15732', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-18282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-22628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23053', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-2263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2264', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16202', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-2265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16203', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9920', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16294', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9921', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-16295', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16045', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-17236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15993', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17242', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17244', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19824', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19825', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-17245', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1983', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-1984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17248', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17249', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-19855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23936', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2016-9912', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-16042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-24743', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2017-5496', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5498', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24133', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-5499', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5500', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5501', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5502', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24744', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-24653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5503', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24745', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-5504', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17146', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5505', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5506', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24654', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-24655', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18674', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24138', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-23631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24158', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24164', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25869', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2587', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-18367', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24188', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21648', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-21649', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-24105', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24107', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15733', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15734', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15735', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-15736', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23592', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-23593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15737', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-23594', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15738', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-24690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15745', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-18324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15746', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-18325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15747', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-18326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-18327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15749', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-18336', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2018-15750', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15751', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24451', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16863', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24452', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24512', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-24513', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-1933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-1934', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15944', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-19360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17066', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-19362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24896', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-19363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1707', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15947', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-24897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-1938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16205', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25586', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1787', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1621', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1788', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5074', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24747', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17150', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17151', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-5507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17152', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-24659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5508', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2016-9915', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-16285', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16286', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23939', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9916', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2016-9917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9918', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1629', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-23940', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23689', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16510', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25773', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23384', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-23385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16511', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23700', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23386', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-23707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23715', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-2339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23718', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-23719', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-23721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16514', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21653', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-21654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17593', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24109', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-21658', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-17594', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-17595', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2022-2411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5035', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16865', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24515', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-24516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24518', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-16866', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24519', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-5377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25872', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16598', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25874', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25875', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-18373', 5.5, 'CVSS:3.1/AV:P/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2017-5122', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23944', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16087', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-16303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9928', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2016-9933', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1631', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9934', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15752', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15753', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2100', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2020-21003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-23990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5016', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-24520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24456', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16867', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-23955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24522', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5378', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16516', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23391', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-24385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23736', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23393', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-23738', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23741', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16518', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16519', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23766', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-24390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2579', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-25792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-23790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18276', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23793', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-25794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23401', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1652', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25795', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16522', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16524', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25801', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16080', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-2309', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2310', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-16225', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16226', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-2414', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-5509', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5510', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5511', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24749', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5515', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24751', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5516', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24661', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1630', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9922', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3055', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23943', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24221', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16603', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25883', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25884', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5124', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1708', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-1941', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1709', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-1942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1595', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24111', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24113', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24114', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24115', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21676', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21678', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21679', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21680', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21681', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21682', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21683', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21684', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21685', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16081', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2020-24458', 4.2, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-24523', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-23956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5379', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24460', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23957', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-16868', 4.7, 'CVSS:3.1/AV:P/AC:H/PR:L/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2022-24526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17426', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2101', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23851', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23123', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16869', 4.7, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2021-23959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2453', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16870', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24462', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5381', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16622', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16623', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2589', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18397', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16624', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25890', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2362', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-16625', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25891', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16626', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16627', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16628', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1840', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16629', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2363', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-23631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1841', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-23639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2364', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16630', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16631', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2365', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16632', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25898', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16633', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16635', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16636', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-18414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2590', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-16637', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16638', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16639', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25901', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25902', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-16526', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-23868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18285', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25804', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-23418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18287', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23884', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16527', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23886', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23887', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23888', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23891', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23893', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23425', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-18290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5115', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24753', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5518', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2021-24143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24144', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16055', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17428', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21014', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-17429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16056', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-16057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2102', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15754', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16922', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9938', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-16318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3056', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9950', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16096', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-15321', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9952', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9954', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9955', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-23948', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-23949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9957', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9958', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16099', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16092', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2019-16317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9937', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9939', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1632', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9949', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3057', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23947', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-16097', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3058', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17604', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-17605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21686', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21687', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5036', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1860', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2022-24532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23961', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2020-24665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5520', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16539', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-18299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23903', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23904', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23909', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-23910', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18301', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23914', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18309', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23921', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-1831', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16542', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23928', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-25815', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-23998', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5017', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-24147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18678', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-24757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5522', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5524', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25597', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1623', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23127', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-25598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16328', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2016-9959', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23953', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9960', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9972', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9976', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9978', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2016-9980', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9983', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9985', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9986', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9992', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2016-9994', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2016-9997', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16102', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-16337', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23029', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-25903', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25904', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25905', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21710', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21723', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16082', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2454', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16872', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5383', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-18312', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16545', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2344', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25817', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-23936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16551', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18318', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16554', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25818', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-23960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1832', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25819', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-18321', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-23445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23967', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18322', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23968', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2016-9961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9962', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9963', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9964', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-23955', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-23956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9969', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2016-9973', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2016-9977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9979', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9981', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2016-9982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2016-9987', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9988', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9989', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9990', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2016-9993', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2016-9998', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3061', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16336', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23974', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2023-23977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17435', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25195', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-16058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25196', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2400', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17436', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-23029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25197', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-2520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2104', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5525', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-18679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24759', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-1868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2476', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2415', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5526', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-24672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5527', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18683', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24760', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-24677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3063', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16349', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-23982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3064', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23983', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2019-16352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16354', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1636', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1637', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16370', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-23987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5384', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18603', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16873', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5385', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24548', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5386', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-23964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16233', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25604', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16236', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16237', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16238', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16239', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16242', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16247', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16248', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5081', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-21724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16647', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25820', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1833', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-23976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23449', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-2345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18331', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18332', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1656', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-23451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18338', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21047', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1606', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5018', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24680', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17167', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18684', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-17168', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-24153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17169', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-17170', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24692', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24693', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24696', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5529', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24765', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16874', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5387', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16875', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5388', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24480', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5389', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2303', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-16371', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-16118', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-23992', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-23993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3065', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23995', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-23996', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1638', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16125', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16126', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-23998', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16127', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1744', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25017', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-24292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17441', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25950', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-25018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17443', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25954', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17444', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24296', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25955', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-17445', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24297', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5530', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24700', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-2416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17175', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24767', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1844', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16657', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18446', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2372', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25928', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23727', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24327', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18447', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-23999', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16383', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2020-16131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2400', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16386', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22741', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16394', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16083', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2105', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-2401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-24481', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16876', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16877', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23969', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-2269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5532', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17179', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5533', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1718', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5534', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5535', 5.2, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17180', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5537', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24769', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-24163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5539', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24164', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5541', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5542', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5543', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16355', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-23984', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-16116', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-16117', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25834', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-24030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16585', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18345', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2023-25836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25838', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16586', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-25839', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16587', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-18347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16588', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-24074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1659', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25840', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-18348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24089', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24119', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-24130', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-18355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25860', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24137', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25861', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24139', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-5120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-23758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24334', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-25934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23771', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-16659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18449', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24015', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-24016', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16407', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15322', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24040', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-24042', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16150', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16062', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-21056', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-21057', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-21058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25221', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17445', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2402', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-2107', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5019', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2017-5545', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-1871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24166', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-24706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24707', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17183', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24710', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17184', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16878', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5390', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18612', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5391', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24485', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2178', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-21783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5037', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1666', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1845', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-16660', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18450', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-22756', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22757', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16159', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-24056', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2276', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-1616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24057', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24058', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-16162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16163', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-16445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-22762', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16164', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-24068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24069', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3077', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2417', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-17186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17187', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1872', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24172', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-5392', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5393', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23031', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-17446', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2108', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-17449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-2380', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-24339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16669', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24341', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-24342', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18452', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23824', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1667', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24344', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-24345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23827', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24160', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18363', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25867', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24161', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23521', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18365', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-2353', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24165', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-24175', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18366', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24186', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-24187', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25870', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18368', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-24194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24195', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2355', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-24196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18369', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23555', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17624', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24123', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-17625', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-21788', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16084', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-24070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16166', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24346', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24348', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24349', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1668', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24352', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1669', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-23839', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1670', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24353', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18458', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16703', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16704', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18459', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2456', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-23032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2526', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-25260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5020', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1688', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5395', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24566', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5396', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24174', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-17189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-24714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1719', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17190', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24716', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17192', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-24178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17447', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17448', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25025', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18819', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1882', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25026', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18820', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18821', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1796', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23135', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5082', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16711', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5147', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-24359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5151', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-18461', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16713', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5153', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16715', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16717', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18463', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16599', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25876', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-18374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25877', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-25878', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1660', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18375', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-2356', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-18376', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25879', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16600', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18379', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-23566', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16601', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25880', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18380', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25881', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18381', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-23568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15323', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3079', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2414', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-16197', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16198', 3.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-16199', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17631', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-2181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21813', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5038', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-16384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16387', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-1639', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2274', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-16135', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-16136', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-16391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-24006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16143', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-2401', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16395', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1640', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16406', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2275', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-16409', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1641', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16410', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-3073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24032', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25263', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2403', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24030', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-2111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2418', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24188', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-24189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16201', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-24205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2422', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-24230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16207', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3083', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16211', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-16212', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16214', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16215', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2272', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2561', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-22721', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1798', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2273', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-22732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1799', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2314', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-2274', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2562', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5083', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-25964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1745', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17450', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5160', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16723', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5161', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-16725', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16727', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16728', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24368', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23841', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24372', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5168', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16730', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5175', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16741', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16742', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2385', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2017-5179', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17193', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24717', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2418', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17195', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17197', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24721', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-24183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-24568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5397', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16602', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2357', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25882', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25885', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24240', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24241', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16606', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24242', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16607', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25886', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18388', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2359', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-25887', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18389', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25888', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1661', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25889', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16613', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18390', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-23592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23594', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-18391', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16619', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2360', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18393', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16620', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2361', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24129', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-21814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24130', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17634', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-21818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2182', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17636', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-24135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21827', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17637', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-24136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17638', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2019-17639', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24140', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24141', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-21831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25035', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2597', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-25971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25037', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-25972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25039', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-25974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1642', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24039', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22752', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22753', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22754', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-16157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24055', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-22758', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3075', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22760', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22761', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23030', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-24574', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-24575', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23976', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-24576', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23977', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24578', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16883', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24722', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5552', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-17199', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1720', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1875', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24736', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5553', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-24186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24740', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-17200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24187', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17201', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17202', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5556', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-17204', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-24742', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5563', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1876', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-2477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2563', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-2315', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-1800', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2564', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-1805', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23155', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-2565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23157', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2279', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-23159', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16275', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-21120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21122', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24031', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-2113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5021', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-16446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16171', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-16192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15324', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2415', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-3080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-24163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1645', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2458', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-23979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5400', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2184', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-21840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2185', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-21854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5039', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25894', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1663', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5936', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24913', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5937', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-24916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5938', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24917', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2522', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-24464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24918', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24465', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24919', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-5945', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2447', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2493', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-24932', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17475', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-5864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5865', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5866', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24885', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25184', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5867', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5869', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24888', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-23664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1664', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16640', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16641', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16642', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16643', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16644', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2368', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16645', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16646', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24275', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-16648', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2369', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1665', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16650', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18426', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-16651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2398', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-24582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24585', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2186', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-21861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21862', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-16086', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-23032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16200', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16202', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3084', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24586', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23981', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-5403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2316', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-2280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23162', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22809', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2281', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-23165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5183', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5184', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1676', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16761', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5188', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16762', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16764', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5193', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1853', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5195', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16213', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16216', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3085', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-23043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16217', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16218', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3087', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16219', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3088', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16220', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-3089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16221', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16222', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3090', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23055', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-16223', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16224', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3091', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23056', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2426', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-17491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2187', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-17645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-17646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21890', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21896', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2191', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16087', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-16886', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5404', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16887', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-22818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23166', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-16277', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16278', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23167', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-2283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16285', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2284', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-22840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16288', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-16291', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5198', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-5199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24426', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5201', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1854', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1677', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24400', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-2386', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5202', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5203', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24401', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16770', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16772', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16773', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16774', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5205', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24403', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16778', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24404', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1855', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16780', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5208', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5209', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-23861', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-5210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16653', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24307', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16654', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17476', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-5881', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5884', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2443', 5.3, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2017-5886', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24893', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-25201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2459', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-2404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25303', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-17495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25305', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-21174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25307', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5022', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-17647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21913', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-21929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5040', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-16784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1679', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24411', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5219', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5223', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16793', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-24444', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-24446', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2388', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16803', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5228', 5.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2020-24419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16804', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24420', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16807', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5229', 5.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2021-23882', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24423', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23883', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23884', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5232', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24425', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5234', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5235', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16821', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5236', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24330', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24332', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2374', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25930', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25931', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5130', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24491', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5969', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25231', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16888', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16889', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5405', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5406', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24896', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5898', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24897', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17471', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-2377', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17650', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5041', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-25657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25658', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16292', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22842', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2566', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16293', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2285', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2119', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17498', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-2120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17503', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17504', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-2419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17205', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5565', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5566', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5567', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24750', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5571', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5572', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-24773', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-24499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25237', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-24501', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-25239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5974', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5978', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5984', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25244', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5985', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25245', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18932', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2287', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-23169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2317', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-24294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23172', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16294', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5131', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5407', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-24605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24506', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2598', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25044', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-24317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24318', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5715', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-2429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22782', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22783', 4.7, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2022-23064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-23066', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-3099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24308', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16227', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-16454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16228', 5.5, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2023-2431', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-24317', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-24322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3101', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16229', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3102', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2307', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-16225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3093', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15325', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-22775', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22778', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-22779', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-3097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-15326', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22780', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23061', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-2428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22781', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16088', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5573', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17211', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24774', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-5574', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1878', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17215', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24197', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24198', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-24775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17216', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5912', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5916', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5919', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5924', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24905', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24906', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17472', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-25314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2534', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-2123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5023', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-18933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18934', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-24516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25249', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-22875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16295', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-22876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2288', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16296', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23175', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-25666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16297', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23985', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-24607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5408', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1690', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2461', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5409', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-16453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24295', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1722', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-3103', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3104', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3105', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3109', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5717', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24815', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2432', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-2505', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16299', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18580', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-2389', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23890', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-18582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23891', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24461', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24462', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-16841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16842', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-24463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23896', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24430', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2197', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16093', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24613', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17228', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17229', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24807', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24821', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24822', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5578', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24823', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24824', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24825', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5579', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-5580', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-5988', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18943', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5990', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24968', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5993', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5994', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18947', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17480', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23096', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-24381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24383', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24386', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24388', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2022-23100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16234', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23106', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23107', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-24397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16240', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24400', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24401', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-23111', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-1883', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24817', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2491', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5932', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2446', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-25347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25348', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2124', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-17514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-21246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2125', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-17515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16068', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-24614', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24507', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5411', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24615', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24509', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23991', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-1691', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5412', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24347', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18456', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5133', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18782', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24826', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1723', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24827', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17230', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5581', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17231', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24829', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24842', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5586', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5589', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17233', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24847', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-5590', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2434', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-2435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23080', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-3107', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3108', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-3111', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-15327', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23095', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-16457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16845', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2021-2390', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24431', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-23900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23901', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-16847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16849', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1685', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23906', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24469', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-23909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24432', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2447', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23921', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-24433', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1630', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23177', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-22886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16302', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16303', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-5727', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24819', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24618', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23992', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-2462', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-5414', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2279', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23114', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-24405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16247', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-22794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3116', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2280', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-23121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-22802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-22803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23097', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-23098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-24384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-16458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-3113', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16235', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-24392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23105', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-3114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1879', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17234', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17235', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17236', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24207', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5591', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-18790', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-5592', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17237', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24855', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1724', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-5593', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5594', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5595', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17243', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17244', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5596', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5597', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5598', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5599', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24863', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5601', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5940', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-5941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-22805', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-23126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-15328', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22807', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-3118', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-2281', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2023-24424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16255', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2313', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16271', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-25989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24820', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17456', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24328', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2019-18834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24821', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-25992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5736', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-25068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5738', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-24329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24473', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23922', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16852', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24475', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-23923', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5328', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16853', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5330', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24434', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-23926', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-2448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16854', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-25255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6007', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17482', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25256', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17484', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24534', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17487', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17488', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17489', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17490', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-24978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17493', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17495', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17500', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2608', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-25263', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:L'),
('CVE-2021-24543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24986', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26085', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2527', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-24549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25276', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-2499', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24620', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5415', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-24628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1692', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5416', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17517', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5024', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1671', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24356', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16710', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-18460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5152', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18462', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16716', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5155', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-23840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16718', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16719', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24366', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1672', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-24822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24823', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24824', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-18837', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-25070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-16467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23130', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16272', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-23131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-3119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-16469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23132', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-16278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23134', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-24435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24436', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24438', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16470', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17247', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5602', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5603', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5604', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5605', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1725', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5606', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24889', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17256', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24890', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24217', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5607', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-5608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23113', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23115', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-16248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-23116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-22797', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22799', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-23120', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24516', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5417', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-2463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5418', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24435', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16855', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5333', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23928', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16856', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5334', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5335', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16857', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-24436', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2291', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16308', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-22916', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2318', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-2294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2127', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2128', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17518', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17519', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17520', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-17522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21321', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24554', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24555', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18995', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-24562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16720', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16721', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18466', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-24367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16724', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16726', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16729', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24370', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-24371', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-23842', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1673', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16731', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5169', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16732', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1848', 5.8, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-16733', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16737', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16738', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24375', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1674', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16743', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5178', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16744', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16745', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24383', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-5180', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-5182', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1675', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24385', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24825', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18839', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-17457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16250', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-23123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-16463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-22804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-23125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-23127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16251', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-16464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16252', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-22808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16253', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-22809', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-24422', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-23128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-16254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-23129', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-16465', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16293', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16294', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16296', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-3121', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16298', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16299', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16300', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16302', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16303', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16304', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16306', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16307', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16308', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5336', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2393', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5337', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16858', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24437', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24480', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5956', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5957', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24949', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24950', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-24632', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-16315', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-23180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23182', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25673', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-16316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23186', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2017-5090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-16309', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24449', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-3122', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-24450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1533', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-16587', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16588', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16590', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16592', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16599', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-22817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16600', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16602', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24454', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24455', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-23155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16610', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-24456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-5421', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5422', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5962', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5966', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5185', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24386', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5186', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16758', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16759', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1851', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-5189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24392', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24393', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5190', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5191', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1852', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16765', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16768', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5197', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24394', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-17526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16069', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-17542', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18998', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-1755', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6045', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17556', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1756', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19000', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-2501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2457', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17566', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24570', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-19002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6052', 2.5, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-17568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2534', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6053', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2535', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-25023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16269', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-16466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1647', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-16280', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16287', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16288', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16290', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16291', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16292', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5341', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16859', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2450', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-23932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5342', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1686', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5344', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24438', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-5345', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24503', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2021-23934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5347', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-26013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25073', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24827', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1884', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18841', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-25074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26017', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2602', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-26020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-24337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25084', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2021-24338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18849', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5753', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-25674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1632', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16320', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2297', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22983', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-2568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-24646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24647', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-23999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5425', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5426', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-23156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-23157', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24439', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24440', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16295', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24442', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-16297', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-16471', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-16301', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16305', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16310', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24500', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-25238', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5973', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5975', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5977', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5979', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5980', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24504', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18924', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17479', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24000', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-5427', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1694', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24001', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-5428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24548', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-17529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1607', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-21322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5025', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16860', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24506', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-24439', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-16861', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5356', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24440', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5357', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5358', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24441', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5361', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5364', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5367', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24509', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24510', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5368', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24511', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-24444', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-2445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-15329', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-24451', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-16589', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16591', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-16593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-24452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-24453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-16608', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-16632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-24457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-3123', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17904', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2634', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6299', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17905', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17906', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26340', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6300', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25701', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17907', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-26341', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6301', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25276', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17908', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26342', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6302', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17909', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2485', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1791', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2023-26343', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6303', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24850', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26344', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-17910', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6304', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26345', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24851', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25703', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6305', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5432', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-21345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25392', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25394', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17533', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-24052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21353', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21356', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-21357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24055', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-21358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-21359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5026', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-26022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17458', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16324', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16325', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16326', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16775', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16776', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5206', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-16779', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5207', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16781', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16782', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24406', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16786', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5211', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24407', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-5213', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16790', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-5214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1856', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5216', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23872', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23873', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-16792', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-24412', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18567', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-23874', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24413', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18568', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-16794', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-23876', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24414', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5226', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-16797', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23878', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18574', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16802', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18575', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-23880', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16805', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24421', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2199', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16097', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-21990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16098', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1610', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17571', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2458', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-17574', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2537', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2021-24580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6060', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6061', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-2538', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-25380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24583', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17580', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-24584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6067', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17582', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-6068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17584', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17585', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19018', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25399', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6071', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25406', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-24588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-25409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-24458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26346', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-6306', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17912', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25704', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5609', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24900', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24781', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-24901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24782', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5610', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24783', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-24904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1727', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-24784', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2401', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5433', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25085', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2019-1885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2434', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-26032', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26033', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-18856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-17664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5042', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5230', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16808', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5231', 5.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2020-24424', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16809', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5233', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1682', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16820', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23886', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16822', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24426', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-5240', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23887', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1683', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5241', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16831', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23888', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2018-16832', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-5242', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-16833', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5243', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-24427', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-24450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5244', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-16837', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24453', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16839', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5250', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5612', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1728', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17281', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24220', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-17282', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24789', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-17283', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5618', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17287', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17288', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25686', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25687', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16329', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17595', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17596', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2542', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-25422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2543', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-24594', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-25445', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5434', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24558', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-24559', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16948', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24669', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-2467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16949', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1695', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-24670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5435', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24832', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-24056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25399', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16070', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26348', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24853', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-6307', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17913', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26349', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6308', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17917', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6309', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24917', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17289', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5620', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1729', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17292', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5621', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24928', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17293', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24930', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-24932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17294', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24939', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17297', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17298', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5627', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1730', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-24228', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-17300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17301', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17302', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24229', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-2494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24671', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24561', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-24562', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5436', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24563', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24564', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24565', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16953', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16954', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16955', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2416', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25500', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16115', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-21998', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1684', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24456', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24428', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-5998', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2319', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1633', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16330', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16331', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16332', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23191', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16335', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16336', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16337', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-23192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26350', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17919', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-24855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6310', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26351', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26352', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26353', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6312', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1792', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26354', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6313', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-24859', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26355', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6314', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26356', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25711', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-25454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19031', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-2505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25069', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-24599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2507', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5628', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24230', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-18792', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-24231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-18793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17305', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-24940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-18795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1731', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5635', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5637', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17317', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1732', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17320', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24567', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24016', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16958', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-24675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16959', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24017', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-24678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5439', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24679', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16960', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24569', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24680', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16961', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24058', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25403', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-21363', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-24059', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-17537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-17538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-21366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24060', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23037', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-24061', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5027', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-24345', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24837', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25097', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-18858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26038', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-1761', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25465', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17611', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17612', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25473', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-6090', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17613', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17614', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6099', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25487', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2508', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17481', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17321', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5638', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17322', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1733', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5643', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2021-24239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5644', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17333', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17334', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17336', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17338', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24242', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-24243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2479', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-24571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16962', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5441', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16965', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16967', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24021', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-24576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16968', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6316', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26358', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25712', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6317', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-25715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6318', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6319', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26360', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-26361', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25716', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-26366', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-26367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6323', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6324', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-25717', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-16339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2302', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16342', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25695', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2303', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-16343', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23036', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16344', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16345', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16346', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16347', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16348', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16349', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-25510', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-2201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25511', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-22015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5781', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1886', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-2435', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-2510', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5782', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-26039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5783', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25104', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24841', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5784', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-26041', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17460', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17615', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26097', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6100', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6102', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6103', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26099', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2461', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-25089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6128', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25090', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6131', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25101', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1905', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2021-24615', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-19050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16969', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1697', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16970', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16971', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5443', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16976', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5444', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17925', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2017-6325', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26369', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2637', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-6326', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6327', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17927', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25294', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26370', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25295', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-6329', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1793', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26371', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25296', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-24867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6330', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6331', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-26373', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2572', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-21378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25428', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2138', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-25433', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-21386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-21387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25435', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24063', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25438', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24617', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1762', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2550', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-24618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17621', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17502', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6020', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6021', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6022', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26083', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18978', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6025', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6029', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16350', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23039', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23197', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16353', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24301', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-2320', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-23045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16358', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-16977', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16978', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16979', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5445', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1698', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24686', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16980', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26374', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25302', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6335', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6338', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26376', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6339', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26377', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6340', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6344', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2023-26378', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1612', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-25512', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2020-22019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2202', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25513', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2020-22020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16131', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25514', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:L'),
('CVE-2020-22021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-17669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24189', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-22024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16132', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-5785', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-24842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24352', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2021-24353', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2022-24843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2511', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26044', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-5787', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-24845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18865', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5788', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2512', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17461', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24623', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17624', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19057', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-24626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17626', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25559', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2556', 5.3, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:L/I:H/A:L'),
('CVE-2022-25148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17629', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25150', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1763', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6134', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-21394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2544', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-5028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-16981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16982', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24585', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-24027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5447', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-24687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16984', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16985', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5448', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2017-6135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24634', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24635', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-25152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16133', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-22026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16134', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-22028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1614', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16140', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24191', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2203', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-17670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-22030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16142', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25308', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26379', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2638', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-25309', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26380', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25723', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2023-26381', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2531', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25724', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26382', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25725', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25310', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26383', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25727', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25311', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26385', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25312', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18987', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6033', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18988', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6035', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17539', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17540', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6043', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-21400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24069', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-22034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-17671', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-22035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16144', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22039', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16145', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2204', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-2469', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-24029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24690', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-16987', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24691', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-16988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2403', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1699', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24031', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24694', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16999', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24032', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17000', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24695', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5449', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24033', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-17003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24586', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-23049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24302', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16359', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-23052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24303', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-25711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1636', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23205', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-23058', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23206', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2306', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23060', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-23061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23207', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16363', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23064', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16364', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1816', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24308', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2321', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-25123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25125', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26048', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-5792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24359', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5795', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-18869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2436', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-25130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1887', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26049', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24639', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-17634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24641', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2018-17636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17637', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5044', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-25729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24883', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26386', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24884', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-26387', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-17937', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2573', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17938', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-26388', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26389', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2639', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2020-2559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6138', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6139', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24647', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6143', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-24653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6144', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-6145', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-17642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24655', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6147', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17643', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6611', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18242', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18245', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6614', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6617', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-6618', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6625', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-25607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6633', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6635', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6637', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25608', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-25832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6638', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1820', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26433', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-25816', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6512', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6513', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-25577', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-6514', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26434', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-25817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6516', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6518', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26435', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-2558', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19262', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5797', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5798', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2514', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-25140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24850', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25141', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26051', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18873', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-25142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17462', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-25955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25985', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-25986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2599', 3.6, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5450', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24035', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-2470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5451', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1701', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-24702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5452', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24587', 1.4, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-22041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24218', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-22042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-17673', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-22043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16148', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16149', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25515', 6.0, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-17674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23210', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17644', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17647', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2560', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2021-24660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2610', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18206', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18207', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18208', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18209', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26436', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6519', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-6526', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19263', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6527', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6528', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6529', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2582', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-24978', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6533', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6534', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6535', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6536', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6537', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6538', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6539', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25585', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6540', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6541', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6542', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25591', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-25594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25824', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25738', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25739', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6349', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6643', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6644', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6645', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6646', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6647', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6652', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6654', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6655', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6662', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26458', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-1825', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26462', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6673', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6674', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6679', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6681', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18252', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6685', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6686', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6688', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6690', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6691', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18253', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6694', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6695', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6696', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6697', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6698', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-6699', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6701', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6702', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6703', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2021-24999', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6706', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-18254', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26468', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-26469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25615', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-6708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18255', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18257', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2584', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16150', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-22051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25516', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-24229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-17675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22057', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-2206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18364', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6888', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2671', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6894', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18367', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2613', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-26130', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18370', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2614', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-1838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6913', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6916', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-6919', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18392', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18396', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6924', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-18406', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-18409', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18417', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16367', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-16368', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16369', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23211', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16370', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24309', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-16371', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16372', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16373', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16374', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16379', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1638', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16381', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23214', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16382', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18179', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23215', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2308', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16386', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5096', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-24568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25010', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25012', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17562', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24569', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6051', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24572', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-17567', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19004', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-19005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2531', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-24574', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25340', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1757', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6055', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25359', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-24576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2536', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-24578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17573', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2209', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-23045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16165', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25523', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-24247', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-2213', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1821', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-18210', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18211', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26437', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-26438', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18223', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-18224', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-19266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24981', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6543', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26439', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2644', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-19269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6544', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25599', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-25826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26440', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18226', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26441', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2560', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-1927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5453', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5454', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24038', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2404', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-24040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5455', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5800', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18883', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2515', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-18884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5802', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26052', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-2437', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25617', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25845', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-25003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25619', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6711', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-6713', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6714', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6717', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19283', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19284', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18262', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18264', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-25012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25623', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19295', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-19297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25014', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-2674', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6928', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18427', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18430', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18434', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18435', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6930', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18440', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23047', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-16166', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16167', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16168', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24248', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-25524', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16169', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24249', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16170', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-24253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16171', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2216', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-22164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16173', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1773', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5046', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-24588', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-17019', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1930', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18270', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18271', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18276', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25017', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25626', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25627', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25019', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25860', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26480', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18282', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25636', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6555', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6556', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26442', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-25600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6561', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6571', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6572', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6573', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6574', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6576', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6577', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6578', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6589', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1823', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6591', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19277', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26534', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19341', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2574', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18886', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24853', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18887', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5808', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24371', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5809', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26055', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-5811', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5812', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17463', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25374', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-19012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6062', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2019-19014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6066', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17583', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19017', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17586', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6070', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2540', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-19019', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1759', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6072', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2541', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-18802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17341', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17358', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17359', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17360', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5646', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17364', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26840', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-26841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-6961', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6965', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19447', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1702', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-24589', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-24707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2309', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2310', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23109', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-25719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16389', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-24315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2311', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18181', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-23222', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1639', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16391', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2313', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24318', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24319', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23136', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16392', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16393', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25725', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-6594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6596', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6597', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6598', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6600', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6601', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-6602', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-1824', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6604', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-26446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18240', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6612', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-6613', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2021-24991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6621', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6623', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6626', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18246', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-6628', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-6629', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2583', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-24992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6632', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6636', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18247', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18248', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26391', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25318', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-26392', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26393', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17939', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6350', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16178', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16179', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16180', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16182', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5647', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5648', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17368', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5649', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17369', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24797', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-17374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5650', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5652', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24977', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-24978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-25030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18284', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-18285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19308', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19309', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24590', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-18623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24591', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-5456', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24592', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5813', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-24854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24374', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26056', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-5815', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18894', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5816', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2516', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-18895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24377', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5820', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5821', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24379', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-2438', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-5822', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-18898', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24380', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-26062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23139', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2432', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24320', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6639', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6641', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6642', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6651', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6653', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2561', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6656', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6661', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24995', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6667', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6668', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26459', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2023-26460', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6669', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6671', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6672', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24996', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6675', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6678', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18250', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24997', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-25612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6683', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6687', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6689', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6692', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6693', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6700', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26466', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6705', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25614', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-26467', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-25000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2604', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19353', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19355', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26567', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6746', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6748', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6749', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6750', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1833', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26068', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-6753', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6754', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6755', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6758', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6759', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6762', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6763', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6767', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6768', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6769', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6771', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6772', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6773', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6774', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2017-6775', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-6776', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6777', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19364', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26072', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-25089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5458', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24043', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-24593', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17024', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5459', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17025', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17026', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24594', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-5460', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19451', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26916', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-18460', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18461', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18466', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26923', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26930', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26957', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-26961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26974', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26979', 1.4, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-26982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1946', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-27025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1848', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18482', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18484', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18488', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19464', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1947', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-19470', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19479', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25041', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25427', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-25449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25047', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1903', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-2545', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-17605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6076', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19030', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25050', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25051', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19032', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-17608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6078', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19035', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17609', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25467', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17610', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2609', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1829', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26483', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-25037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18309', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18310', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25039', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-2587', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2021-25040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26487', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25319', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-26394', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18256', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18259', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6709', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25846', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2017-6710', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-25004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25620', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-6712', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18260', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18261', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25009', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25010', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-19288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2585', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19296', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18274', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25163', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-24858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18899', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1890', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17464', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-17030', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17031', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17034', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17035', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17039', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1704', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2405', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-24602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17042', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-24604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17043', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2406', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5461', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17044', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24067', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17046', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24612', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24069', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5462', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-22210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18311', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25320', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6355', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6356', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1794', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24895', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2574', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25741', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2023-26395', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25325', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24896', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17946', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25742', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2017-6362', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25326', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17947', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25743', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2017-6363', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-25327', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24898', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6367', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6369', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25328', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6370', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25744', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-6371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6377', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6379', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24671', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25610', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6150', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6151', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6152', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26112', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-1908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17655', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26114', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-17657', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26116', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-24254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5653', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1738', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-24255', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5654', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5655', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17382', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17383', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5656', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5657', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17386', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5658', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5659', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5660', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-2498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24981', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5661', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-24982', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-17391', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5662', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-17393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5663', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5664', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17397', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24985', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5665', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2314', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24322', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-23140', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-2323', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24323', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-23149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-18190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16396', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18193', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-23230', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-25629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26478', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-2586', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2021-25022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25025', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-25635', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-25090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18333', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18334', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26078', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-19370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25094', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25096', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-19372', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18337', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24382', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5825', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24383', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24859', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5827', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2517', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-24386', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24862', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-18900', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5828', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25170', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25171', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5829', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2439', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-25172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25174', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-25624', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-25625', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-26118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-26119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1766', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26121', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18194', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16397', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16398', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24328', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2407', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24714', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-24613', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17049', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1705', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24073', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2017-5463', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-24614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17051', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24615', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-17053', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5464', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17054', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24616', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18286', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25641', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-25034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1931', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18289', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25867', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25645', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18290', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18296', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18307', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26484', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2023-26489', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-19314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19315', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-26490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2590', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-25902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2591', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-2567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25911', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-25912', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-27059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2706', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18494', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-19491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18499', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5666', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24264', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5667', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1740', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17400', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5668', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24995', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17402', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-24996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2500', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-25004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17404', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-25005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6381', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6384', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17949', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1795', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24900', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6386', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-6387', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17950', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6390', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17952', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17953', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17954', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6391', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17955', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2575', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6392', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6393', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6395', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26397', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6396', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17956', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26398', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17957', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2533', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-16403', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16405', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17665', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25632', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17667', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24693', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-26137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25634', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-25635', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1863', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-24617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5465', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-2408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-24719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17056', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5466', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18308', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19312', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-2588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-22274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25544', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17408', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1741', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-19502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25163', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-25164', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-27116', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27119', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18502', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5831', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18905', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24866', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5832', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5833', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5834', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5835', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5837', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24871', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-5840', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18196', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23171', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-18197', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23172', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-23178', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-23239', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16406', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25730', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-24329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-18339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24085', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-24619', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17057', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24087', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1706', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24721', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5467', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26138', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-24694', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17668', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25636', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-26139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6154', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25638', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19086', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26400', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-17958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26401', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6399', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-17960', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24907', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26402', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17961', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-25336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17962', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26403', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24908', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17964', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17965', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17966', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17967', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6400', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24909', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26404', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25338', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6401', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25339', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6402', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1797', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19318', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1932', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2593', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-18315', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18316', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18317', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-26511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19326', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18341', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2409', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-17061', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5468', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-17062', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24723', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18636', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-24625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5469', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24092', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17069', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-24724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17070', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-1864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24725', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5672', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24272', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-17413', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5673', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17415', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26143', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-19089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26144', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-19090', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-26146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26148', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-24705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19092', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-17672', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2564', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19093', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-26149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25640', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19094', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-24708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17674', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19096', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-26150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2471', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-24710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1910', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2324', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-2433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16407', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2318', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16409', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-24331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24332', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16410', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-16413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23253', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25915', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2592', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27163', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-18508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25175', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27169', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-18511', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-27178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18513', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18521', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18524', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27193', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24913', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-24914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17974', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6403', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2534', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17677', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19100', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-2617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1768', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5677', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5681', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5682', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5683', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24276', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24277', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1742', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-2480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5471', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24726', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17074', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17077', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17079', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5472', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-25952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2571', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6104', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25490', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-24610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6130', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-25091', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25098', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-25099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25108', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2511', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25115', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17620', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25502', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5841', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24872', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5842', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5843', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2518', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5844', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5845', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5846', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18313', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-26494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2569', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26495', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18343', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5099', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7010', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18548', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18550', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18553', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24104', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-18643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1708', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17081', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-18644', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5473', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5474', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2411', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-5475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17082', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17085', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17086', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17088', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17090', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5476', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17091', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-5480', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17092', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-5481', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2326', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-23260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24335', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16418', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25734', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-19325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2594', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-25950', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-25055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2596', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2023-26513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25056', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1933', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2021-25057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2597', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-2598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5849', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5851', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17467', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-17622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2513', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25507', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24621', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2553', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-19054', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17625', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2555', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25146', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25147', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-24629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17627', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25561', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18558', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-7019', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2620', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-25220', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-25165', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1911', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-19113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26209', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-19115', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25169', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25170', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17687', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19118', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26210', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19119', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26406', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17975', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6404', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25348', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25349', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-24918', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2535', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25350', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6405', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17976', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24920', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26407', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6406', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24922', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-25355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1798', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6407', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-25356', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26408', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25059', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-23207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-23208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16419', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2321', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2018-16420', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23264', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-18209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2557', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-2515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6798', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25110', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6799', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18345', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17980', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6408', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25358', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17983', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-2536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26411', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17984', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17985', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17986', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6409', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1799', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2576', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-17996', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-25760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17997', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26412', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25762', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-25763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1800', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26413', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6410', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-26414', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17689', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25647', 6.0, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-26216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24730', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-25175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24733', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19127', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24739', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2474', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17698', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1770', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6161', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19335', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26008', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5053', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-24636', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-25576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17632', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17633', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19063', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24638', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-6136', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6137', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5852', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-5853', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5854', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5855', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5856', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5857', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-5858', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25182', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17468', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-23219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23265', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-16421', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25224', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2621', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-25237', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25239', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25240', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25242', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25244', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25246', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-17095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5482', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17096', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5483', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1710', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-24634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5484', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17102', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5485', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17106', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-18655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17108', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17701', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17702', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17703', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25657', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6163', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25658', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25659', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17704', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2566', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-25202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25660', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6412', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6413', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2023-26416', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6414', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-6415', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1801', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-25768', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-24934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18013', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18014', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18016', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18019', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1802', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18020', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-25364', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25770', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25771', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25772', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25773', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25774', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-24937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-22352', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5055', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-24643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6140', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6141', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6142', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-1764', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16422', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23266', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-2434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2323', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16423', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1821', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16424', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16425', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-23240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16426', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25365', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6417', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6418', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6419', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6420', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17705', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1711', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5487', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17110', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18657', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17113', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24122', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1712', 5.3, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:L/A:L'),
('CVE-2019-18658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5488', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25555', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25557', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-2240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25559', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2556', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-5058', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16427', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16429', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-26218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2622', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-25266', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18593', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18599', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26226', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-18621', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19545', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-18623', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25277', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2623', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-19550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18631', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26230', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-25281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26233', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2019-19553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19555', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19556', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18640', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6812', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19379', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1938', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6813', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18348', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-24651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24661', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24736', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19340', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2023-26537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24886', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-24419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2442', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-5870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5871', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-2519', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-5872', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5873', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5875', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5876', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-5877', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24424', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1747', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-24938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18025', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25366', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6427', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24939', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18026', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1803', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6430', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25775', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-25776', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6435', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25777', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-6436', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25778', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-6437', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25779', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6438', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6439', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6440', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6441', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6443', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6446', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6448', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6451', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18035', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24941', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6452', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6455', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1804', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1772', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25665', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1774', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6165', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24757', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-25666', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-17125', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-1866', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-24124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24738', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-5490', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17128', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24739', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17130', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17131', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-25739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18214', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-1643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18215', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16431', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16432', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23275', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16435', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2601', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-25064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2245', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-25563', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25564', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-22453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16190', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-5879', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5880', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24890', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5882', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24892', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5887', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25199', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25200', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25203', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-24435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5896', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17470', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:N/A:H'),
('CVE-2021-25118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1835', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-26107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19391', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-26108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2611', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-18350', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-26031', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26033', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-25072', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-26035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25075', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-18322', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26551', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-26554', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-25078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19346', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6732', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6733', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6735', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-24762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26260', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-24763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17133', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24740', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17134', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17136', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17137', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5491', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24128', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17138', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17139', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17140', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17141', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5492', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16436', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24346', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18218', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-18220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23266', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24348', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-19230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19231', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1805', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18058', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25374', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18059', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-25780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6459', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6460', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6462', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18060', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25781', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18062', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17421', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26241', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2020-26242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19585', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25284', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25287', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-19588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18644', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18645', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-26539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26034', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19344', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18324', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26552', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-26553', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-26555', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6721', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-6722', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6725', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6726', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6727', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-6729', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18328', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19350', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19352', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26065', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25084', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6745', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6747', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18329', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6761', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6766', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18330', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-18331', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6770', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-17142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-24647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5493', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5494', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-24648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-24650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1867', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-24742', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-24651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17144', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23267', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-23269', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23273', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-23277', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-5102', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-6463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-22475', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2557', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-5062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5899', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-24898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25210', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5901', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5902', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24900', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-24445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2017-5905', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N');
INSERT INTO `tpandora_cve` VALUES
('CVE-2022-24901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5906', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24447', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-24902', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-24448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5907', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2445', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-5909', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5911', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-24903', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5913', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5914', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5915', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5918', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24904', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-23282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-23284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23278', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2020-23302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24349', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18222', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6730', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6734', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18327', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6831', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6834', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6835', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6837', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6838', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6840', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6842', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6843', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6845', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6846', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6847', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6848', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6849', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1940', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6850', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18352', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-25298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25311', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-25312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26253', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26254', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-25314', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26255', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-25315', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26258', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-18652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7053', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18654', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25317', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2626', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-26260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-18658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18659', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-23303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-23309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-23312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-23313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1881', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2428', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5688', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24800', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17423', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17425', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17426', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25944', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24801', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5692', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17427', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-24802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24281', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-24803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24282', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-25947', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24804', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-5696', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2252', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-22524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6466', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26420', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1924', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6467', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19240', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6468', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26265', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17781', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17782', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6167', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17783', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26268', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24775', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24776', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-26269', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17785', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17650', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-26049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19348', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19351', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26064', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19354', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-24908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5931', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5933', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24912', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25214', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17473', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-26077', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26080', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2021-25095', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-19371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18336', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18661', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25320', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-18662', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7056', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18669', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7059', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18676', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19610', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-7061', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1743', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17432', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24287', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17434', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17435', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24668', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-25608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2561', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26108', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17654', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6866', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6867', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26117', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-6868', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2612', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-6870', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-18357', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1783', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24782', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17832', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17841', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17843', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19151', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25332', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25333', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25335', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26270', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-18692', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26271', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2539', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25395', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-25396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25788', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19242', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25402', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-25403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25412', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-24955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18069', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18071', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18073', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2019-19246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-25619', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-17656', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24677', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17658', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17660', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26122', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-24683', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-26123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17661', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24685', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-26084', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-25572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2255', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-22550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-22552', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17438', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2429', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25016', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6778', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25092', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2608', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-18335', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25674', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-17849', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6168', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-6169', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-2629', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26138', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-18372', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18382', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6914', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2017-6918', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-18389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6922', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18398', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1840', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18405', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18408', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1841', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6927', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18426', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1843', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18432', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18433', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26775', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18437', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1844', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2017-6932', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5950', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-5951', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24473', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-24474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24936', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-24937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2448', 2.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18915', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-5953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26125', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-17662', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26127', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17663', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2563', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-24686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-26132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17666', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25103', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19374', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-25104', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6781', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-6782', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6783', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6788', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6789', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6790', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-18342', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-23051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-16196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5068', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6471', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18075', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18082', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18083', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6472', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18087', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18088', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18089', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18090', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18091', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2544', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26423', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18093', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18094', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19248', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6473', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2546', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18096', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-1925', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18097', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6474', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26424', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-25099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19373', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26590', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1834', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25102', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18340', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2683', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25154', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6955', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26842', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6962', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26846', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2685', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18449', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18450', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18454', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18455', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18456', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18457', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18459', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1846', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-25772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25471', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-25481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25484', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25485', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25486', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25488', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2549', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18098', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6479', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25497', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6480', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2522', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-22612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6153', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-19084', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17669', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24698', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1767', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19087', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2609', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-25109', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18344', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6785', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6786', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-25106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26085', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-6791', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6794', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19375', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26086', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25108', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2017-6797', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5071', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-24700', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17671', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-26145', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19091', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25639', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26986', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2700', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18481', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19462', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19468', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27043', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-1948', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19481', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19484', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-25505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1812', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26425', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6481', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6483', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1813', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6484', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19254', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6485', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6805', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6807', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6808', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6809', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6810', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6811', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5960', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5961', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5963', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24951', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5965', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17477', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-23054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-25585', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25588', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1786', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16206', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2306', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-5073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26426', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1814', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19255', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2581', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-26427', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2552', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6487', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6492', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6497', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6498', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6499', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6500', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6501', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6502', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-25812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19256', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1815', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-26428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6503', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2553', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-6504', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25813', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6800', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2610', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-6801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6802', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6803', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18346', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17675', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17676', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19257', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26429', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26430', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1817', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6505', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25230', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17852', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26294', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25681', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6186', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17855', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25682', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25683', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6188', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17857', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17858', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6191', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17859', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6192', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24799', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-2480', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-19193', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6194', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25684', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6196', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17478', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6814', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6815', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2307', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2018-16222', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16223', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2308', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-25591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5075', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-24715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19101', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2620', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-19102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17682', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25166', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6156', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-25644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17683', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19108', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2023-26204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6157', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17685', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17686', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-19382', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19386', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18347', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18723', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26294', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19489', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18497', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-27082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18498', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18500', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19194', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24805', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-6200', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19195', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6201', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6209', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-1939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-26105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6816', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2524', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5981', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24725', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-17688', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6817', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6818', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19258', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-25814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6507', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19259', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-24971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1818', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2556', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6509', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1926', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18190', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18192', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26432', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-18194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18195', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6510', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18198', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18349', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-2311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-25593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2312', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-5077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19196', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19197', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19199', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-2481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6213', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1787', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25688', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17872', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6820', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6827', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6828', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6829', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6832', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6833', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18351', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-18935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-18937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1894', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24960', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5987', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18942', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25251', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18944', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5992', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:H'),
('CVE-2019-18945', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18946', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-5997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-5999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-18949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-18952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17690', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26218', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-24731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17691', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26235', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17692', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17693', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24736', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17694', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25595', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-23125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-5079', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-19202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24814', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-25689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17876', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25693', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-17883', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24819', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-17886', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17889', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24823', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-25694', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1952', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18503', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18504', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2715', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2716', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-6511', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18199', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25574', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19260', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-25576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1908', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2686', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-6819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6821', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-24974', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-18954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-6002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6003', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6005', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-2453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-24976', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24531', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17483', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6008', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17485', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17486', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6009', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6010', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6011', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1749', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17491', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24979', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-18957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6015', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17492', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6016', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17494', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17496', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17497', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2454', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17499', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25180', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25650', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17696', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25651', 4.7, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-25182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17697', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6158', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-25652', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25653', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-6159', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6160', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19135', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-17890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24824', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26302', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26303', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17892', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2631', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-26314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17894', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-2483', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-25266', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2632', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-25599', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-23128', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16231', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-25601', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-16232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-23130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16234', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-23131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-23132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1794', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2023-25602', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16235', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-25605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6830', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6836', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6839', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6841', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6844', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1941', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6851', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6865', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-18355', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-25696', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26327', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6250', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-6253', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6254', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26330', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26333', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17901', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2570', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26334', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26337', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25274', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-25700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26338', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26339', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-6298', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25174', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27162', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-26157', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-26158', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-27164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18509', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-18510', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7006', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-27477', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-25762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19083', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19084', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7279', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19085', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19086', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27478', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-19087', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25763', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19089', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7280', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25764', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19090', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19091', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7282', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-26869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19092', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27479', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19093', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2687', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-7283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7284', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1910', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25766', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-24744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24745', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1915', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-25194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24749', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-6162', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2475', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25656', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6852', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-16249', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1625', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16250', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16251', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16252', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-16253', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-16254', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-16255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16256', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2267', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-22673', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-16258', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22674', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-22675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16259', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-22677', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1626', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-22678', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-16261', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-22679', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-25607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1750', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-26077', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1751', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1753', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25262', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-24983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-24984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-24985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-18979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-2455', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-18985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19817', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7327', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27505', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19818', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-19819', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1982', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7335', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27506', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7336', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19820', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7337', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-27509', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1916', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7338', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19322', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7464', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19324', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25955', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-27604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26070', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19334', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-19335', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19340', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19341', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-25960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19342', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-27615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19347', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19348', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19349', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19882', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25767', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27480', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-19105', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7288', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19106', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7293', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25768', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19109', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27481', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1978', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-26877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1911', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19111', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19113', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25771', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27482', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-26165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26172', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-18531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26176', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18541', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18544', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18547', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2618', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-26180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26181', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18551', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6871', 4.7, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-18358', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-25203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17706', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25204', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-24752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17707', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25663', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1771', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25664', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2018-18356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25217', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-18559', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19535', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19115', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2688', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-27483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25772', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-19118', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26880', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19786', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1912', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27485', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19120', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19121', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-7836', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7837', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7838', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7839', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7840', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19703', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-19755', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19756', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19759', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1976', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19767', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19769', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19770', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19771', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19774', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1978', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19786', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19789', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19796', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1980', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19810', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19814', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19819', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19822', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19829', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-27713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19835', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7938', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7940', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7942', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7944', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7946', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7947', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1984', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19840', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19352', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8695', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20240', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8723', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-8724', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-20241', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20242', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8733', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-20244', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2017-8739', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-2744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2746', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-19708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27466', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7844', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-7845', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7848', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6877', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6878', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6880', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1836', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26607', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-19787', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7299', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7300', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7301', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7302', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19122', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-25774', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7303', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7304', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19788', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25775', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-26883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27487', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-19124', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19125', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19792', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26886', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19841', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19842', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7961', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7962', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19845', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19849', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1985', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7967', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7968', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7970', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7971', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7972', 3.4, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-19855', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7975', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7983', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19857', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-7985', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19858', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-19859', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7986', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7987', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7988', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7989', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8000', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19865', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1773', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-25209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24756', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6164', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24759', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2476', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25667', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27347', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27348', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2019-20445', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-20447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7820', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20455', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27358', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7823', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-27383', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25226', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25227', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-25228', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7022', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25236', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26211', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-18569', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-1857', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18572', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18573', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19539', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18583', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19357', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27620', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26933', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-25969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1936', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25971', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-7481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19896', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-19898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2763', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2764', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-27641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7484', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19364', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26943', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-26944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26945', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2768', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2695', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19370', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19908', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6883', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6886', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2662', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18362', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6887', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2663', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18363', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2664', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18365', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6890', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6892', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18366', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-6903', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6906', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26131', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26132', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26133', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6907', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6908', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26137', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-1777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6166', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-24768', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26263', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-17775', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17776', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-2477', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-26264', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-24770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1778', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20628', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19710', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2752', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19869', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19871', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8019', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19876', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19877', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19882', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19886', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19889', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19891', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19894', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19897', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1990', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19902', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19905', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19915', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19917', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8031', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8034', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19924', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8048', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8050', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8053', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1993', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26415', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-18368', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6905', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26129', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-18369', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6909', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18371', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18373', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18374', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6910', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18380', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-18384', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6915', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-18385', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-6920', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6921', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18390', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6926', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-26735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18407', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18416', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1842', 2.5, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-18422', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18438', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6931', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2679', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6949', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26818', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8742', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2025', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-8745', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20251', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8749', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2026', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8753', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26777', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8757', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20300', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20301', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8762', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20302', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8766', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27918', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20310', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18585', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-19542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18586', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18589', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26220', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-1859', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-18591', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25269', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25271', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-26224', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18606', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18607', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19544', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18619', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25275', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18622', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25276', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-7030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18629', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19548', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26229', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2018-18635', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27522', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1918', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19180', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27523', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7357', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19184', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7359', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7362', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19186', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7363', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27527', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19189', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19190', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19191', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19193', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19194', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1920', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2018-19200', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19201', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19202', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2691', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-7376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7377', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-7095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19661', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2740', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-20485', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20491', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-7830', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-7833', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-18379', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6917', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-25147', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18391', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18397', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27700', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-19376', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-27701', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-27703', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1939', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26081', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26086', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19915', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-19916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6953', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6954', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-26839', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-6958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26845', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-26847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6966', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6969', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-26857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6970', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20314', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8780', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8781', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8782', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8783', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8794', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2020-26235', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7038', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19562', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26237', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:H'),
('CVE-2017-7039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2624', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-26240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26244', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25288', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-1959', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27418', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7834', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20494', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2742', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-27423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2627', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17791', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17794', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17797', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-17798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1780', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-1781', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1782', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-17825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17828', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-26272', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-26273', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-26274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24780', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-26278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24781', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17830', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-17831', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17835', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27560', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-27569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27979', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-7870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26336', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7878', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7879', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7882', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7884', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7885', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-7886', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7887', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26344', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27585', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27586', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27983', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-27984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7890', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-19830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19205', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27536', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27537', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7382', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7383', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7386', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19209', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19211', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2754', 5.2, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-19214', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7392', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19216', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27554', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-26051', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19218', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19219', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7394', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1922', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7395', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19220', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19221', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19222', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19223', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19224', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26054', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19226', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-26059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19227', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19228', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19229', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1923', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19937', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8081', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8085', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8086', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-2772', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-26484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8105', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8108', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19921', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-27711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7496', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7497', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-25994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19395', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6950', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1942', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25153', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-1944', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6967', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-26855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2687', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6973', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18443', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-26876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25762', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2023-2694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26965', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26991', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18478', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18483', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18485', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18487', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19463', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-27040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19490', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20339', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20340', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8809', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8811', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26847', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20346', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2743', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-2745', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-27461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2748', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-26320', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-27481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7847', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-7850', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27514', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-7046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2625', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-25294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7049', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18647', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19233', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27558', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19234', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7400', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25905', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-27559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19244', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-19246', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19249', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7401', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1925', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27561', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7407', 1.4, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25917', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1984', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-27576', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25920', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-7414', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19271', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27578', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19275', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7418', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25923', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2758', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-7419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27580', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8115', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26486', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-8136', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-8137', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26491', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26499', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-26024', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-26025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26029', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1845', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-1945', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18458', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18467', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-26919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2019-19454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-26924', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26966', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-26968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26980', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26984', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-18476', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27084', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-19497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1850', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19501', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27114', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27115', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25165', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-27121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27986', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7892', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7894', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26354', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2020-27601', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-18813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2583', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26406', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18815', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25463', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25838', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25839', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-19702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18819', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-25844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1882', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2641', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-25849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18822', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26411', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-18825', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18826', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18828', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18829', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18831', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-18838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18839', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1884', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25495', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18841', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27518', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27519', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20629', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20630', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20631', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20632', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20633', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20634', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27524', 4.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-2753', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27534', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19711', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2754', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-27543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7853', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7854', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7855', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7857', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6178', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25675', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-26290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19163', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24790', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-25226', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-25227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19166', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25676', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27754', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26031', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19458', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-2701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19460', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18480', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18492', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19480', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18496', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27488', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25777', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-19794', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-26032', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19795', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25778', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19128', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19797', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19799', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26034', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-25785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1913', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25786', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-2689', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-1980', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19800', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19131', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25801', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-26891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7421', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7423', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7424', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1928', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19280', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26505', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2018-19954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27725', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-26520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26528', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26530', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-1997', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19974', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-19976', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-19981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18505', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-27610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27611', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-19716', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27612', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26368', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-27613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27614', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26372', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27958', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-8832', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8833', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27969', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-20407', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20408', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20409', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8845', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8846', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8847', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27977', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20418', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8849', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20421', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8853', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20423', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20424', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20425', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8854', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8855', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20430', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20433', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27993', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20448', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20450', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8869', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8870', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2800', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-8874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8879', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20456', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28008', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20460', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18842', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18843', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-18845', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2728', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-27285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1885', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25506', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2643', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-18854', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18856', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2648', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2649', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26506', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26507', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1886', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18862', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19507', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-2711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7858', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7859', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7860', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2755', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-7861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7862', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-27977', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7864', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7865', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27978', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7867', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26037', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-27767', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27768', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27769', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26964', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-27779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-25677', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6184', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-19167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25678', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2568', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-25680', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-25231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-26293', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2018-17854', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-1917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25234', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1919', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-17856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19191', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6189', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18506', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2616', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-26263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18671', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18673', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7060', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25802', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19132', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25803', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19133', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2730', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25522', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27304', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25523', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18869', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7127', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18872', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2731', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2652', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-27311', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27315', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18891', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18892', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18893', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2653', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-25641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19134', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7309', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19801', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7310', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25809', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19135', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19136', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26894', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27491', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7313', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19137', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7314', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19805', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19138', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19139', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1914', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26895', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19141', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19806', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19142', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26896', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2021-25827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2756', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-27568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7868', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7869', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7871', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26337', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7875', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7877', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19713', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7881', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2757', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-27576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2758', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-27131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2714', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2615', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-20462', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8891', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20464', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8892', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8893', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8894', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19192', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6193', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-24800', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-6195', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24801', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-6197', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-6198', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-6199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-17860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24806', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-25244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-25685', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-25245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19718', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27628', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26377', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19719', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27633', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-27636', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-27993', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-27995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19720', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27648', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19721', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-27998', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19143', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19145', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19146', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27493', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-19148', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1981', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-19150', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19810', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-27495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7322', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19813', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18519', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18527', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18529', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2617', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-25210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18530', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26171', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-27205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18540', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-25214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2579', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26178', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18546', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7011', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-25215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18552', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18557', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7013', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19714', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-26348', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25876', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26536', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8897', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28016', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20479', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20481', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20482', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8906', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20484', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1941', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-19416', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7523', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2697', 4.2, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-19418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19424', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1943', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19432', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19434', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19436', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19947', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6210', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-24810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25686', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-17871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-6215', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6216', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6217', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-25687', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2569', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2022-2525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-25690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17874', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-24816', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-19208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1788', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1921', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-24818', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-25251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17884', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-2482', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8177', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1999008', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26538', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27352', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7142', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27353', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2654', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-27354', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2737', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25649', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7147', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27371', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7323', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2690', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-25831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2018-19157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7325', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27500', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-19158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7326', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2800', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7901', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-19722', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27651', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26382', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-27653', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-27654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27655', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19723', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27656', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28005', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27657', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28006', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26384', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-1999010', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999012', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27727', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1999021', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1999025', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1999026', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1999027', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27501', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2019-19816', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27987', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-7893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26355', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2760', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-27602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7896', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7897', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19715', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27606', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27607', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-27608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27609', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-25176', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25177', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25178', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26164', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2619', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-7018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26199', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25790', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26200', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25225', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25229', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25230', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25232', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25234', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25235', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25238', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7023', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25652', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25896', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-25897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7151', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1890', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18908', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2655', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-25903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19221', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25255', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1789', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2017-8920', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8921', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2766', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2801', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28010', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19726', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27661', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-19727', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28015', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27662', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-27665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1999029', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1999033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1999034', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1999036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1999038', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-27737', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-1999040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999043', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999046', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2783', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27830', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-19446', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7526', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-19447', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7528', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19448', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19449', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1945', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19960', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-2611', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-18570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25248', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25249', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18576', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25252', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18578', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18579', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25253', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7025', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18581', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25791', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25264', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18587', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18590', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25270', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18603', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-26225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18605', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19821', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-7339', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2751', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-27510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7340', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26041', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-19160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7341', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7342', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27515', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-27516', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7343', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7344', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7345', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26047', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7902', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2767', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-19728', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1974', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19748', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19749', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19750', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19751', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18909', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7153', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19714', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26552', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18913', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19722', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-19995', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19999', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27746', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20009', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20010', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20011', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27752', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2020-27755', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-17891', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25260', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-24825', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-26311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-17895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-25695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26374', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27618', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19717', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27620', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27621', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27626', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27629', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2638', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-7899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19168', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1917', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19170', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19178', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20768', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-17897', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-24832', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-25269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-6255', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-6256', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-26328', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-17899', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24836', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-26329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-25698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-6272', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-2484', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-25270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-24840', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-24841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-24842', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-26335', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-26336', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-24843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-25273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27759', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-27762', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25792', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26231', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25794', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19557', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25282', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-19560', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7156', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18922', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7157', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26559', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18927', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26560', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18928', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27635', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-27637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2764', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-27649', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-27997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27650', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27652', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-28003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26383', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-26533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27767', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-26546', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20029', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19752', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19758', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19761', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19762', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19763', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19765', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19768', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19772', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19775', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19782', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19784', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19785', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7907', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19787', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2768', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2017-7910', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2769', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-27693', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19790', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19794', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19797', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19799', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19802', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27697', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19812', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19816', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19818', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1982', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28039', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-20786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20492', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2777', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-20030', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2657', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27771', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-27773', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-7352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27525', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7358', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7360', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27526', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19187', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19188', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19195', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19197', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1983', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-27533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25231', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26208', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2020-26210', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2021-25241', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25243', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18571', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-7024', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28008', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-28009', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-27658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-28014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26386', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-28016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26387', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7378', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7379', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7380', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27535', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25863', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7381', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19206', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27538', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7387', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19210', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19212', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19213', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19215', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7390', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7391', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-19733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25916', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19735', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-26564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19736', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2657', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2018-18931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18642', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7041', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20063', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-26612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28040', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-8926', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28042', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-8928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8929', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20792', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8931', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8933', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-18934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18936', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-1974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7165', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7167', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18943', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19746', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2658', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-1895', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25926', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18950', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25929', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-25351', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-18705', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19627', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25804', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25355', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26284', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-7079', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-18711', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18713', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25367', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-26287', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-18714', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26288', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18718', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7534', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19469', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1947', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7536', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19475', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-19988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19489', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1949', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27861', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26118', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19493', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19847', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7436', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7440', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-27596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7960', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19844', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7963', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7976', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-7980', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7982', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7984', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19856', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8935', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28049', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-8936', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8937', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20801', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8939', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8941', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8942', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8943', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8949', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8950', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20805', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28052', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8953', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20498', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26248', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-19596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26249', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2019-1960', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26250', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-25296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26251', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25316', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-18649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18650', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18651', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7052', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19757', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19766', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19773', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19777', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7908', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2017-7911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19791', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19792', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19795', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27696', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19809', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19811', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19815', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19817', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19820', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19821', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19826', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19828', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7929', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-27708', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7930', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-1983', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19836', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19838', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7934', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7939', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7941', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7943', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7948', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7950', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7953', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19843', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2629', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-18721', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26297', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27249', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26299', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-18738', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18739', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1874', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18741', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18742', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25403', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18745', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18749', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1875', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18752', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18753', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18756', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19861', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19862', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7992', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7995', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-7999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8003', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8006', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8012', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-8015', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19887', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19890', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19892', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1991', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19914', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8028', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8032', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19921', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8039', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8052', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2593', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27384', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-18956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19756', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-27385', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27386', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2659', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-19757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1896', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25943', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25946', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-18975', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25949', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18978', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-25959', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2596', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18979', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-25967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25969', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2662', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-2663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25972', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18981', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25973', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26234', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25795', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19561', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19563', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25797', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26238', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8295', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8301', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8302', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8304', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8305', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7543', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7545', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-26259', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-18655', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-18656', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18657', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7055', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26261', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2020-26262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-25321', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25322', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18672', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26266', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-19611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-25331', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26268', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-2627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25341', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-25342', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-7441', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7443', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7448', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2692', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-19311', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7452', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7454', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7455', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7456', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7457', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-19319', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-25944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1932', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-25946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19859', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-25947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7463', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19323', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19327', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7468', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7965', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19853', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8059', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19932', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19936', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8112', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-27720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25918', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1927', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7415', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7416', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25922', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8311', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8312', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-8313', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8314', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-27786', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9292', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9294', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9295', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9296', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9297', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9298', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9299', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9300', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9301', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9302', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9303', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9304', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9305', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9306', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9307', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20774', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9310', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-20775', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26391', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8971', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-8975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8977', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-8978', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-8980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2808', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-8983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8985', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-28087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2809', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8993', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20507', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-20519', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20520', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9002', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20524', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20807', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-18765', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-25418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19647', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18774', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1878', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18781', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7093', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25431', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2638', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2023-27250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19667', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2018-18804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-18805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19676', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-7099', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8118', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8123', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8133', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7185', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2665', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-18985', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26650', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7186', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2666', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-18986', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18987', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27391', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27395', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19863', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7994', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1987', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19872', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8018', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19881', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19888', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8022', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19896', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19901', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19906', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19908', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19911', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19913', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8025', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19919', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8033', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26503', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26509', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26511', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1996', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19961', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19965', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-8153', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19970', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8158', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-1998', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1999001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19278', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19279', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7425', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26061', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7426', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-26062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-19286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7428', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-19287', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27586', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-25931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19288', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7430', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27790', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27794', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-26653', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8341', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8342', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20069', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-20776', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20778', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26392', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20780', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20781', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26393', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20782', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28397', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2840', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20783', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18808', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25823', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25824', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7102', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25445', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25827', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-25828', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25829', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7106', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19693', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-7107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18816', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26408', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8036', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8038', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8047', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8051', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8054', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8057', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8058', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8060', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19933', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18699', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18703', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19624', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-26277', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-1871', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26279', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-19628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25366', 2.5, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-27397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18993', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25674', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18994', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-7192', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7199', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27400', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7200', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-27401', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27402', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26679', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7202', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27404', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7203', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2668', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-7204', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25677', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18999', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-7205', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26683', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-7208', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-7210', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-26693', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25678', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1900', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19001', 3.4, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-26707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19004', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-26999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7572', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7578', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19499', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20043', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19502', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19503', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19506', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19507', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19509', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19511', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-27000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7584', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27903', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-7589', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26125', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7431', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7432', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1929', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19845', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27589', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-25932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19290', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19291', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7434', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19295', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7435', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26265', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25323', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18675', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26267', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19613', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25329', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7064', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20786', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20791', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20792', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20794', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20795', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20796', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20797', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20799', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20800', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9324', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9325', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9326', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9327', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20806', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20807', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20808', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20809', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18820', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18824', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27267', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25492', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-18830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18832', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25494', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18840', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26415', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25497', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25498', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18849', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27594', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-25935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7437', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7438', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19301', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8082', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-26483', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8099', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2017-8100', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8102', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8103', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8104', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8109', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8110', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19946', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8121', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8122', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8125', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8127', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26488', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8138', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7475', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19358', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26932', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-19888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27621', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19894', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25973', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-27627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25976', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-27638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2781', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-8366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8367', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8373', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8374', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26668', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2017-8376', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26671', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-8379', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-26672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8383', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27818', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-26676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8384', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19005', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2674', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-25683', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7223', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7224', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7225', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7226', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-26768', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-26773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7230', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25688', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7233', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7236', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7237', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19018', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7241', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7246', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1902', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7247', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2598', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-18694', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18695', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25343', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-26272', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-26273', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-18696', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25800', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-26274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18700', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-25801', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-25350', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19620', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-18701', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-26275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18702', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18704', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26278', 6.0, 'CVSS:3.1/AV:A/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-25805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25807', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2628', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-26280', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:L'),
('CVE-2020-26281', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:H/A:N'),
('CVE-2020-26282', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-19629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7595', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7598', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7599', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7606', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27909', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7609', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7611', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19518', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26419', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-25866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26421', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-26422', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-2645', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-7120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27295', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-18857', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2650', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-26505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18858', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18859', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18860', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2651', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-18863', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26513', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-18865', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25525', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25526', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26519', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25630', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18886', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18887', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26526', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1889', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18890', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7085', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-27242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18733', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27247', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18737', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2630', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-26300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26302', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2631', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-25400', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18740', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25405', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7089', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2633', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-18759', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1876', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18762', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-18764', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-19643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2634', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-19645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7444', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7447', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7453', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19318', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19320', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19321', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7465', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7466', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7467', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19329', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7470', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1933', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19331', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19332', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19333', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7471', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-19877', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19343', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19344', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19345', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19346', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-19880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1999003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1999006', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9330', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-20810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9331', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20811', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9332', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9333', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20812', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20813', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20814', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9336', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20815', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9337', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20816', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2841', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20819', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20071', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27726', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19960', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19962', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-26527', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26529', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19968', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19975', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-19980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27647', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-25980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19365', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-26941', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1937', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2767', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-25984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7488', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7489', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-19371', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19374', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7490', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7491', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-25986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19386', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19388', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27704', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7493', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1999014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1999016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1999018', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999020', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8186', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1999022', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999024', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-27729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1999031', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1999032', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999035', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-27736', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-26077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1935', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19350', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19351', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27617', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2693', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-25964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7476', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7478', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2762', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-2694', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19900', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19361', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18775', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18777', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18783', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25425', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18797', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25432', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1966', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19664', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2019-19665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19666', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-18802', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18803', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19668', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-25812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2639', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-19677', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18807', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25438', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2640', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-25439', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25441', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27007', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-20056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20057', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27008', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1952', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19520', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19522', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7619', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19523', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19527', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7621', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19530', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7625', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2701', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-20063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27014', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20077', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-27016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19544', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-19547', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20090', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20091', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20093', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7634', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19549', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19550', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18712', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26286', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25373', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18717', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25374', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1872', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18720', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26290', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-18722', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25377', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18725', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18726', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19630', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26296', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2023-27245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26301', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-25398', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2632', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-25402', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18743', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18744', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18748', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19389', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25987', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19390', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27706', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-19917', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19918', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25991', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-19902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7485', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7486', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-25981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27652', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20820', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9339', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20824', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9344', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9345', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20826', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2009', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2783', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-20090', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2018-20091', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-8418', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8421', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8439', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20096', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27740', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1999044', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25825', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19683', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-18810', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-18812', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26405', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2021-25448', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-19692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19694', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25834', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25836', 5.8, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2021-25464', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19696', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19697', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25466', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-1970', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-25842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7109', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18751', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25406', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18758', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18763', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18767', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1877', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-18771', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25421', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2635', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-7092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18776', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18778', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2636', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2018-18782', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18787', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2637', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2017-7639', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19554', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19555', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19556', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-7640', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2703', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-7642', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19564', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19565', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19566', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-19568', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7646', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7649', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19570', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27916', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7653', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27123', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27127', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-27129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2713', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-20104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27148', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2017-9346', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20827', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9347', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9348', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20834', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9349', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9350', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20835', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9351', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9352', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9354', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9355', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2017-9356', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9358', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1999004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-8175', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1999007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20000', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20001', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-27749', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2775', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27751', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-20012', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20015', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27753', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1938', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20535', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20536', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20537', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20539', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20540', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20542', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20547', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-20548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18823', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27265', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18827', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27266', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27268', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27269', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2022-25854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18834', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25493', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-18837', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2727', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-18798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1999013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1999015', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-1999017', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1999019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1999023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1999028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1999030', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-2773', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-27735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1999037', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1999039', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1999041', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27738', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-1999042', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9359', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20836', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26416', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26418', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-2642', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-26420', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-18853', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2644', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2023-27290', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-20106', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20141', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20143', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27845', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20126', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20128', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-20129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2013', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20137', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20144', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20146', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9038', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20565', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9039', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20566', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20567', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-9040', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9041', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9042', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9043', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9044', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9045', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28141', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9046', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20571', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9053', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-28146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27756', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27757', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-2776', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-27760', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-26955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-2772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26023', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19922', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1999045', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-19991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19992', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19993', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27747', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20002', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20005', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27750', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27922', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19575', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7669', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27157', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7670', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-20150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7675', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20160', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20162', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20165', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20168', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20170', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7676', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20837', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20840', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-9363', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20147', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8503', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-8506', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8507', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2015', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20150', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28149', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-9055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9058', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20578', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2815', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20580', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20583', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27763', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-27764', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-9590', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20931', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-28462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9591', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2489', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-9592', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2490', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-9593', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20932', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9594', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9595', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2491', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-9596', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2492', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-9597', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2493', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-9598', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20933', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9599', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9600', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2847', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9601', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2496', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-9602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2497', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2498', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20934', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-2499', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9604', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26622', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-28471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20935', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2500', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-28472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2717', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-7678', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7680', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7683', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7686', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7688', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26216', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-20181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19578', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26220', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-20182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27176', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-20184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19579', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26222', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-27178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2718', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-20200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7701', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7703', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7704', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7716', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27181', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-20202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7719', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20203', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27766', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27768', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-25465', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25837', 5.8, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-18817', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20018', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27754', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-20021', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27758', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-9365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9366', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20848', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20849', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9368', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20850', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-9369', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20851', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9371', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20852', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9372', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20853', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19404', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27734', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19924', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-27744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7507', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7508', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27761', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9374', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26822', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-27452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26823', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-2746', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-26824', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2021-25737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-2600', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-26829', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-27462', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25738', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19039', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2683', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-2601', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-26830', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-27464', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26831', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2018-1904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19040', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26832', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:H'),
('CVE-2020-26834', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-19041', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26017', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19042', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-25741', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-8521', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20152', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8532', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20155', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-8534', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20156', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20159', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20161', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8542', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8545', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-20167', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8550', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-26334', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-27761', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-20025', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27765', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-7722', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-20204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7732', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7738', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7741', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2719', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19584', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7742', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7745', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7746', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27770', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2004', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2005', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-9375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27727', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7500', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7501', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7503', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26028', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7505', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27760', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7509', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7511', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27762', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7513', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-27763', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7514', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7515', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20936', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-25001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28473', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-25002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20937', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-25003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20938', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-28477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-25005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20939', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20587', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28168', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20589', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20591', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20592', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28175', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20593', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9063', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20597', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20598', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7144', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-25888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27355', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25650', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-25894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27769', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-26589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-26592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27774', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-26597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27776', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-19043', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19044', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19045', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25742', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-8555', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-8559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27766', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7517', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-26038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26039', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27772', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-26593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26594', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2006', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27775', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-27765', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27770', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26040', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-26963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-20824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20601', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9067', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20604', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20606', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20607', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9071', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20610', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20612', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20613', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20614', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20615', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28198', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2820', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-20832', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-20617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28200', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-9376', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9378', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20855', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19046', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26022', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26837', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:L/A:L'),
('CVE-2020-26838', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19047', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-7262', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25743', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2018-19048', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7263', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7264', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1905', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2018-19050', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7266', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7269', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25745', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-19051', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7271', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25746', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-19052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7272', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2017-9606', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20940', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20941', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-26635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2848', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9608', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-25009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9609', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9610', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20942', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2501', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-9611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26636', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-25010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28481', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9612', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20943', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9613', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28483', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2021-26644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20944', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26629', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-26631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27777', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8594', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8602', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8603', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20184', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8606', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20187', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8609', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20190', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20196', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20200', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8629', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8630', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2789', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-27890', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-27892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8638', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8640', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8643', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-8646', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20221', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8649', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8651', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27781', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19409', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-19943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19944', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7521', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19413', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19415', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7520', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-27788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-19414', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7522', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19417', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-7524', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19421', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-2609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-26627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8282', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8284', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27779', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-26635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8287', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8288', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8289', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2778', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8290', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8291', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26643', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28203', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20621', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20622', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20623', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20626', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20627', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20835', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-20630', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20631', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28211', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20632', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20633', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20634', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20635', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20636', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19053', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19056', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27469', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-19057', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7274', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7275', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2747', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19059', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-1906', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19060', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27470', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19061', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27471', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-25749', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25755', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2685', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-7276', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26028', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25756', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25758', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19420', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-26067', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19433', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19435', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19437', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19439', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27812', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-1944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2782', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19440', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-1971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19712', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-1972', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18915', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-26555', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-18919', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26556', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26557', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19721', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-1892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18920', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18921', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19727', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19728', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8655', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8657', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20229', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8665', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20233', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-8671', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8676', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20234', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8294', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8296', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27781', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-27782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8297', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20066', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25521', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18867', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-25524', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1887', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18873', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25527', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-18874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27312', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-1888', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26524', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-25634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-26525', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-25636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25872', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25873', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-7134', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7135', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7136', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7137', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-25878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-25644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19597', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19598', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19600', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19607', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26157', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19608', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19609', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1961', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-1962', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19620', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19621', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-27197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19622', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7754', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2720', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-20218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8307', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8308', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8310', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20067', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-9615', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25013', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28487', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2021-26675', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9616', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-25014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9617', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20945', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-9618', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9619', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9620', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26676', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9621', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9622', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2849', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26677', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9623', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9624', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9625', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-9626', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20946', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-25017', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9627', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-28491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20947', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28493', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-25019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25760', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19443', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19444', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19949', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-19950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19445', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20638', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20639', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28219', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2822', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20640', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28220', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20642', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20643', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20644', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20645', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20646', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20647', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2823', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26558', 2.5, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-20219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19623', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26259', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19624', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7755', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19625', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8315', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27787', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8316', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8325', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27788', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8327', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27792', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-26652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8339', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8340', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27797', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2007', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27798', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27799', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8344', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8345', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8346', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8347', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26656', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2017-8348', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8349', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8350', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8351', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8352', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20857', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20858', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20861', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9394', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9403', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9404', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20862', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28494', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-26681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9635', 3.4, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-9636', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9637', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28495', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-9638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20949', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9639', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-25022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25023', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-28496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20950', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25025', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28498', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-26684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9640', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-20951', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25026', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20952', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26685', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-2850', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-25027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20953', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2824', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20651', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20652', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9079', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20657', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9085', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20659', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9091', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9093', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9094', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20663', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9095', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20068', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-20238', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-8696', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8700', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8726', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-2677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8729', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8731', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8734', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8735', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-20245', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-26773', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-25028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26686', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20954', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28500', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-9644', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26697', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28502', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2503', 5.2, 'CVSS:3.1/AV:A/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-26699', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2020-28503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26700', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9646', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2852', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9648', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25031', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-26657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27800', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8355', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27802', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8360', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8361', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8363', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8364', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8365', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27814', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8369', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8370', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8371', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-8372', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8381', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19626', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20252', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8750', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8752', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8754', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-8755', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27917', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8763', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20303', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20304', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8768', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8777', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9405', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9406', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9407', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9408', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9409', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9412', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20864', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-26659', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-8353', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8354', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27801', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8356', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8357', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8358', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8362', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20070', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-18933', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-26570', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18937', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-19740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26571', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-18938', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19741', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18939', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-18940', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26572', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26574', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-2592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9097', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20671', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-20673', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2825', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-27819', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2782', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2017-8385', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-8388', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27822', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8392', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8394', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8395', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8397', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8398', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8399', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8400', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8401', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20073', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20962', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2854', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26705', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20963', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2855', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-25033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2856', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2857', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28572', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28573', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9650', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28575', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20315', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8785', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20316', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8788', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20322', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20330', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8795', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20331', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26839', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9414', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20865', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9415', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9416', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9420', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8387', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27821', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-8391', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27823', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27824', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8393', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27826', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-26691', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27828', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2008', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27829', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19953', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-26102', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-26103', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26104', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19954', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26069', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19451', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-19452', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-26110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19453', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19456', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19457', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7530', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7531', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7532', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26071', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-1946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19461', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20867', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9421', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-20868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28576', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9653', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9654', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20966', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28577', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9656', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-26711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-28578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20967', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2858', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9659', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20969', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9660', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9661', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28583', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20970', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2504', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-25040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9662', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-28587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9663', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-26714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-25041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8802', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8803', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20341', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20345', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8808', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8812', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-8815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20353', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28251', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20847', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2826', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-20848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20849', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28268', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20850', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20676', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2827', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-20851', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-28270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20677', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20869', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9424', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9425', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9426', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20870', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9427', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26072', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19462', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19463', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26073', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-26113', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-19465', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7535', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2698', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-19980', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19981', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2018-18952', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18954', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26583', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8419', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8422', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8440', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8441', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20095', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27833', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27835', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20103', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20105', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19450', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-19962', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19459', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2785', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-26112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19965', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20679', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20680', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9112', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9113', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9114', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20681', 5.2, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-9115', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9116', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20682', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9118', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20683', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19642', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19643', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26273', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19644', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26274', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-19645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7763', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19649', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19650', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27218', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-26275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27219', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26715', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28595', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25043', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-20974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20873', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-9428', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20874', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9431', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20875', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9432', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9433', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20876', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20094', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8442', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20099', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27831', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-20101', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27832', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-8443', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-8444', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8445', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8446', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8447', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8448', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27837', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20106', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2784', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-8450', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20376', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20378', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8826', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8827', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-8830', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7537', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-19982', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-19983', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26075', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19984', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-19478', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-19985', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8449', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2011', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27841', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8452', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20123', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20124', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20684', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9122', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20860', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9123', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9124', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9125', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9126', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9127', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9128', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9129', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9130', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-20863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26076', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-19990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19491', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19492', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-19993', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9434', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9435', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9436', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20877', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9437', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9438', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9440', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20878', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9670', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28596', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20975', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28598', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9674', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20977', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28599', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2860', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28600', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20978', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26720', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18958', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7172', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25942', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-18964', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18965', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18966', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7175', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1897', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-1976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-25948', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-18976', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2595', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-7183', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2661', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-18980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-20864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20685', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-20687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20698', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20699', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20866', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20703', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2830', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-20867', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-20121', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27842', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8453', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27843', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8454', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8455', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-27846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20136', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20140', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20141', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27850', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27855', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9441', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20879', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-9442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9443', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9447', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20880', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-20131', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20133', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20135', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2785', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-26716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27857', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8498', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-27860', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8501', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8502', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-19966', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2799', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-20431', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8857', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20436', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8858', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8868', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20452', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8872', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-20453', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8875', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-20454', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28002', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-20455', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20457', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20458', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20459', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20461', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27856', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2786', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-26717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8504', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-20149', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8518', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20151', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7544', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-7547', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27876', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2017-7549', 4.7, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2019-20013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7553', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-27888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7556', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7557', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-26994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26081', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7566', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-20712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20713', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2831', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20714', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-20715', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20716', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20717', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20869', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9448', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20881', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9449', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20882', 5.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:H/A:H'),
('CVE-2017-9451', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8508', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-26719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8511', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8513', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8514', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8517', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8519', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8522', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8523', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-8524', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8527', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8528', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8531', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-8533', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20154', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8535', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20157', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8537', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8539', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8540', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20166', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8551', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19476', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7538', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19477', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7539', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1948', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-26983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-19487', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19488', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-19989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19490', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-19991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2786', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20000', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27860', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2861', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20980', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-25047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25048', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-28616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20981', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-28617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20982', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20983', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25049', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-20984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26726', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2862', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2018-20985', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9694', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2505', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-28622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20986', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20153', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8536', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8538', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8541', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20164', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-20165', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8547', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8567', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8570', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8571', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8572', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20718', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9140', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20719', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2832', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-20870', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9145', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20872', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9147', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20723', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20725', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9452', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20884', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-26998', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7569', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-7570', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7579', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27392', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-18989', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1899', 1.4, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7188', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18990', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18991', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-18992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27398', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27399', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25673', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2667', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-20006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7546', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2699', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-26119', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19494', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2788', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-26992', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20021', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7554', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26993', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7555', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8558', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20170', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20172', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8585', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20987', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20988', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2863', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2018-20989', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20990', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25056', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2864', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-25057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20992', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-25058', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20993', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25059', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28641', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-26752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2506', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-28642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20994', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26753', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-20171', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2787', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-27871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20174', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20176', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8592', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20178', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8596', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20180', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8598', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20185', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2019', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2017-8613', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8618', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8621', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20197', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20198', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20199', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2722', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-19653', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7765', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26291', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-7766', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28013', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28014', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-28015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8896', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20476', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20477', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20478', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20480', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8899', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8900', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2802', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-20483', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8908', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20485', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8914', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2018-20487', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8915', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8916', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26411', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20885', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-26412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26418', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-9461', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20886', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-26419', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26420', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2018-20726', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20727', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20728', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20729', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28327', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20179', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8595', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8597', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-8599', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-20181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8604', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8605', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20186', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8607', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8608', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8610', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8611', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8617', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8619', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20194', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20195', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8625', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20213', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8632', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8636', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8639', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27895', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-8642', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8647', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8648', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-20211', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20212', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20217', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8635', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8637', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-8641', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8644', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-8645', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20222', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8650', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-8652', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-20227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8654', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8656', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27406', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7206', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-7207', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7209', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2669', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-27411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7214', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2670', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-19000', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26705', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-25680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19002', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7215', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2671', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-26712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2672', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-25682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2673', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2675', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-26759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7222', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7227', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7229', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-26772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25684', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7231', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2678', 4.7, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:L/I:H/A:N'),
('CVE-2018-19013', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7234', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19016', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19017', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7239', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19019', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26800', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7242', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7243', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7244', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-25690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7245', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25692', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28644', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-20995', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-25062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28645', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-25063', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9726', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9727', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20997', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20334', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19661', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19662', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-20337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19664', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27945', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2019-20343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20352', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-7767', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-20354', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20357', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19665', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20358', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27224', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-2622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2700', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-1950', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7581', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7583', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26122', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-27001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27905', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-27002', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-7590', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19517', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27003', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7593', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-7594', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7597', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7601', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7607', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7608', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7612', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7614', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2791', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20053', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27006', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8653', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20228', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8658', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8659', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-8669', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8670', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8672', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8674', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8918', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-28024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20488', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2803', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-28031', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-20489', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-28032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26421', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20887', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9463', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9464', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9465', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-20888', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20889', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-26427', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-9151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20730', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9154', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20731', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20732', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9156', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9157', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9158', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9159', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20875', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2833', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20733', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20735', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20876', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-20736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20737', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9162', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9163', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20877', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9164', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9165', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20742', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9166', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20743', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9167', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20744', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9168', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2834', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9169', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20745', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20878', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9171', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20230', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8660', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8661', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8662', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-8663', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20231', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20232', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9728', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9729', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-21000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2865', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9731', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-21001', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-2507', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9732', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26805', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-21002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26807', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21003', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25072', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9736', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9468', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26428', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20890', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-26430', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9470', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9471', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9472', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20891', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9473', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9474', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20892', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-20893', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-26434', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20894', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26436', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26439', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2386', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20896', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-26461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2389', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20897', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-26807', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-26808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26809', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19020', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-25693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7248', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-25694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2681', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-26810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19021', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-25980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26811', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7249', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26815', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-25698', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-26816', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-26817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-25699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-25986', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-26818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7250', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-25701', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19027', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7256', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-25987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19029', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7258', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2682', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-1903', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2745', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2017-9172', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9173', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9174', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28346', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9176', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20879', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9178', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9179', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9180', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9182', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9184', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9189', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20881', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-20882', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9190', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20883', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-28349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20235', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20236', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2024', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20769', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9499', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2391', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-9500', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9501', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20898', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-26473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9502', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9503', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26528', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-2393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26529', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-2395', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-26530', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-20899', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2396', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-9505', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2397', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-26539', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2398', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9506', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2399', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-2400', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26540', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2401', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-2402', 5.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2019-2403', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-20900', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9507', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2404', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20901', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-26821', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2021-25735', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-27450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-21004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9739', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-21005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9740', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-21006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2866', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9741', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9742', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2867', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2021-26812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9743', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25076', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2020-28672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9744', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9745', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9746', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9747', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9748', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9749', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26824', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-9750', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9751', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26825', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2508', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-28687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9752', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9753', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9754', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2869', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-9755', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9756', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-26995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7561', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27894', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-27896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-27897', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-26996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7563', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27898', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-7564', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-26997', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19496', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27899', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26121', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7568', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19498', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9195', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2835', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9196', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20884', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9198', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2836', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9201', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9202', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28361', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-20886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9203', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9204', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9205', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20751', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9206', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9208', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9209', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-9210', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-28365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20752', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26926', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-28901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26927', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9831', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26928', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-26929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9832', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9834', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9835', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9836', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2531', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-8725', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8728', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8736', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-20247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8737', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8738', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8740', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8743', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8744', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20250', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8747', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20253', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8751', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20298', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-8759', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20306', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26944', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9844', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28914', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-9845', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2534', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-9847', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9848', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27912', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8741', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26774', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8748', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8756', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26779', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8760', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8765', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8769', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20309', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20311', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8778', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8787', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20321', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20323', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8791', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28366', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20753', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20755', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28367', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20756', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20757', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2837', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2804', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20493', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19504', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1951', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-27902', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2405', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2407', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-9509', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26550', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20902', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2408', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-2409', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:H'),
('CVE-2021-26551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9510', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2410', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-20903', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2411', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:H'),
('CVE-2021-26556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2412', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2413', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2414', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2415', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-20904', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9511', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20905', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-2417', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-2418', 3.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-9512', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26560', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20312', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20313', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20318', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8792', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20328', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20329', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-2793', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-26836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26842', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-26843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27932', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27933', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8814', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20348', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2794', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-8816', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26856', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20355', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8932', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8934', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20795', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20798', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-20799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-8938', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8940', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2805', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-20803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28050', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-8944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8945', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8951', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8952', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20497', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-26829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26830', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-26865', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2870', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9758', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-25088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9759', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9761', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26833', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28705', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-9762', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9763', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9764', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2509', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-28707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-21010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9765', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9766', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2871', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-25090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9767', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-21012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26844', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9770', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25091', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2872', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-25092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-21013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19513', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7585', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7586', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-27904', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19516', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26126', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7591', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7592', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7596', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7600', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7602', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26127', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27004', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-7610', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7613', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19519', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-26084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20760', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20890', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9218', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20761', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9219', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20762', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9220', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9221', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9222', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9223', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20763', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20764', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9513', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-20906', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26561', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26562', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2421', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26563', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20907', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9516', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2422', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-2423', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26564', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2019-2424', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-9517', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2425', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-9518', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26565', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20908', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2426', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2427', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26936', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28916', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26939', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28918', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9865', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26945', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2538', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-2696', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28921', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-9868', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9869', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9870', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26948', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9871', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9872', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28922', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-26964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9873', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2539', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9874', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2540', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9876', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26967', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28925', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-20337', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8801', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26841', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8804', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8805', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-8807', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-8810', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26850', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20349', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8818', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20051', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26130', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-26085', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20054', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8820', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20362', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20363', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20365', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20367', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20368', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20371', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20374', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20375', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9520', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2429', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2019-2430', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2431', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2021-26566', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-20909', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-2432', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-2433', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9523', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26567', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20910', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9525', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26569', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9773', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26857', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-21014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9774', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-25094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-21015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-21016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28726', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-25096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9776', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2873', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-21018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9778', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-21020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9779', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2891', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2017-8954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8955', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8956', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-28054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20500', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-8961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8962', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8963', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8967', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8968', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8969', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2806', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8970', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20501', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-28062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2807', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-8972', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-8973', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-28070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8974', 2.5, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-28072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20357', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20358', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20359', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20360', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20361', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8821', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20364', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8822', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20369', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20370', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8823', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2795', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8825', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8829', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8842', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27970', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9881', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2548', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2551', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9884', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26973', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9887', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2552', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-9889', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9890', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9894', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2554', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-26975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2555', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-9902', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2556', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-2557', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-26977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9904', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2558', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-9905', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2561', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-9906', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2564', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2565', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9907', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9908', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9909', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9910', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2567', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20912', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-9526', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2435', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2017-9527', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9528', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9529', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20913', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9530', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2436', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-20914', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-28736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9780', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9781', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2874', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-25102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9782', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-25103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2875', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9783', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28759', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2511', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2512', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-21025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2513', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2020-2876', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25136', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-2877', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9786', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20402', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2796', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20405', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20406', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-8843', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-8844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-8848', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-20410', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20419', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-8852', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20422', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20426', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20427', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20434', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27992', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8859', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20437', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2568', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2022-26980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9912', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2572', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9914', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9916', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9917', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2575', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9918', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2579', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26965', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-9922', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2583', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28942', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9928', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9929', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28944', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9933', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26969', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-9936', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26970', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2588', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26971', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2590', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2591', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9839', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28912', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9843', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-28088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-8989', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-8990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-8991', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20506', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20508', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9001', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20523', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20525', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20526', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20808', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-7620', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7624', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7627', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19532', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27013', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-27015', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26088', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19539', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-19542', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20079', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19545', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-27912', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27018', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20095', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2438', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9531', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2439', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9532', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9533', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2440', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9534', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2441', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9535', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9536', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2442', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9537', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20915', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2443', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26578', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9538', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26579', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2444', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2017-9543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20916', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2445', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9545', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2838', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-28381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28382', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28383', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20899', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-9940', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-9941', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-9942', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2594', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-28949', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9949', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28950', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9953', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2599', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2605', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2017-9958', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9959', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26998', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9960', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2610', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-2896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9961', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9962', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28963', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26999', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2611', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2022-27049', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-28967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9964', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2019-2613', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2022-27050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9968', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2616', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-27089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9978', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2619', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27095', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2535', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2536', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:C/C:N/I:N/A:H'),
('CVE-2022-26950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7623', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7626', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26086', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7633', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19543', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19546', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20092', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-27017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19548', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27019', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7636', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7637', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2702', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-7638', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-19553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19557', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19558', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19559', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7770', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-1968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7771', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-20362', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19692', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2724', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19693', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27248', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27249', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20367', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-26235', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26307', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28385', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28386', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20900', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28387', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-28388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2839', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28390', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9232', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2446', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2447', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2842', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26585', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20917', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2448', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9546', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9547', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20918', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19560', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19562', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2705', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-27914', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1957', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20099', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2017-7647', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20100', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2020-2707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2709', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-7651', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2710', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-27915', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20101', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-27913', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-1956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19561', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7643', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2704', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-19567', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20098', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-26236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20372', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2725', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-27250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2795', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7774', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-27253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26239', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7777', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20382', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-26240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20383', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26247', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-26249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2621', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-9982', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2623', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27108', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27114', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-27115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20528', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2810', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-28102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20530', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20532', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20533', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20534', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20538', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20541', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20543', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20544', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20546', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-2812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20551', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9030', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2813', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20552', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20553', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20555', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20556', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9035', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-20557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20558', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20559', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20560', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20561', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20563', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9036', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20564', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2449', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-28424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20919', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2450', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-28426', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-9548', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2843', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20920', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2451', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-9551', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20384', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-20385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7778', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20386', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-27257', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20390', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-20391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2878', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-21026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9787', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2879', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-25139', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-21028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-21029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9788', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2017-9789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21030', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-21031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2880', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-25140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26888', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2017-9790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2881', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2882', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-26889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9792', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-2883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26905', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-25142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28838', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-9793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25143', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9239', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7656', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26107', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-27131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27133', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-27134', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-2714', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27147', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-20105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2715', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-27918', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20142', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-7659', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7660', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19574', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2452', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2019-2453', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-28433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9552', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9553', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20921', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20922', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26598', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9554', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20923', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26960', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-28923', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9875', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9877', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9878', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2546', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-9879', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2547', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2017-9880', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26971', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-28927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9882', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9883', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2549', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28928', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2550', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-9885', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9886', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9888', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9891', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9892', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2553', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-9893', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28935', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9895', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9896', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9897', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9898', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9899', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9900', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9901', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2894', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-26976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9903', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9244', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9245', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7665', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7666', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27153', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2019-20145', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-26112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7667', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20146', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-27923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9794', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26891', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-28845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-25144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-9795', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-21033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26906', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26894', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-28849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9796', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2885', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-21034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-25147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9797', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-28851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26895', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-26910', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26911', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-9798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-21035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-25148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-26897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-25149', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-21036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-21037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20395', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7780', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27258', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20399', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7781', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26254', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19698', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2017-7782', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7650', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7652', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2712', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2017-7654', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27122', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19571', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-26106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27130', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-27132', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19572', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27525', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29603', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3459', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2844', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9555', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2456', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-2457', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2458', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-28441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2459', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-28442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2460', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-20924', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-9556', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26601', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-2461', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-28443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2462', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2020-28445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9558', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2463', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-28447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9559', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9560', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2464', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-20925', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9561', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9562', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2465', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9563', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2466', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28449', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2021-26606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9564', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9565', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20926', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2467', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2468', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9566', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2845', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2469', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-28450', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2019-2470', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9567', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2471', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9568', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2472', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-28451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20927', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-2473', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2474', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9569', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2475', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2476', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2477', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9570', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2478', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-28453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2479', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2480', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-9571', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2634', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27148', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-28984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27919', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26110', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7661', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20144', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7662', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7663', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7664', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:H/A:H'),
('CVE-2020-28857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26912', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-25151', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-28858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26913', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9802', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-25152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2886', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2017-9803', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2516', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2517', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-26914', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2518', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26900', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-28860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2519', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26901', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28861', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9804', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9805', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2520', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-9806', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26915', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26905', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-26916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26917', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2521', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-26918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9808', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20910', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-9248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9253', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20913', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-9047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9050', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-20570', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9051', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20572', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20573', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20574', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20147', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-27926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7671', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7672', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7674', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-20155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20159', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20161', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20164', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20166', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26118', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7677', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19576', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-26954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-26979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2566', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9911', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2569', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-2570', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2571', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9913', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2573', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-9915', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2574', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-26961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2576', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-26962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2578', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-9919', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9920', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26964', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-26986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9921', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2582', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9254', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9255', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9256', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9257', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9258', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9259', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9260', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9261', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9262', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20915', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2017-9263', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9268', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9270', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-20918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20919', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9272', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9273', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-9274', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20920', 5.3, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:L/A:L'),
('CVE-2017-9275', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9276', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28394', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9277', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-20922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9278', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9279', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9280', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9281', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9282', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9283', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9284', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26908', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-28870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2522', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-28872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26909', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-26919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9809', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2523', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2524', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-9810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-26910', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2638', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2021-27026', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2642', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-27027', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2645', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27034', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2650', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27035', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2651', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-27036', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27037', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26276', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7783', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26280', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-26281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2630', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-26300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20928', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9572', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9573', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9574', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9575', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9576', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-20929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9577', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9578', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9579', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9580', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9581', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28458', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-26615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2482', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9582', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-20930', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-9583', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2484', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2485', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-26618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9584', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2846', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9586', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2486', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28460', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2487', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9587', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9588', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9589', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2488', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27527', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3460', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3461', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29605', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3462', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2525', 4.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-26911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2888', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26912', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-2526', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2017-9812', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26921', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-9813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-28895', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2017-9814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28896', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-2527', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2017-9815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28898', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2017-9816', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20148', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20163', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20167', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20169', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20171', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-26117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2017-7681', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7684', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20586', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-20817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9060', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-20588', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9061', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2817', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9062', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2017-9287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9288', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9289', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27263', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-1970', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-20405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-26305', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20406', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7787', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20407', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2796', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27267', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-2631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7682', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2017-7685', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7687', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-19577', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7696', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26233', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26234', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19580', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2655', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-29006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2657', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2659', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2660', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9995', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2661', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9996', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2663', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2664', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-29011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2666', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-29012', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27170', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2668', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2669', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-2670', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-2671', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-27175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2672', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2673', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-29015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2675', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2676', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-29016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2678', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-27181', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-29019', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-27040', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-2679', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:H'),
('CVE-2020-2961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3466', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27364', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-26924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2528', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9820', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9821', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2890', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-26929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2818', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-20594', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20595', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20596', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20599', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20600', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9066', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-20602', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9068', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20605', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2819', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9070', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-20609', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-20611', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9072', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20208', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19582', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7731', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2727', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-7796', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7690', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7692', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7693', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26221', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2017-7694', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7697', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7698', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26235', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7700', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7702', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26236', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7705', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7718', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7720', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19581', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7721', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26252', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7723', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26253', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7737', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9923', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26966', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-9927', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2586', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-9934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-28945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9937', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-27008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9938', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28948', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-26987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28199', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-27183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2680', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2682', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-27188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2686', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27193', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-2687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27195', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2690', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27041', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7749', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7797', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19701', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27275', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28209', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2821', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-27041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2595', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26990', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2017-9948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-26993', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2597', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-2598', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2017-9954', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-9955', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2600', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2017-9956', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2601', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-28953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2603', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2604', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-26997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-28954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-28955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2608', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2609', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-28960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-28964', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9963', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-2612', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-28969', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9965', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2017-9966', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9967', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27004', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-9969', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27006', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-9970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2614', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2615', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2617', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2618', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2017-9979', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27094', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2622', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-3467', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3474', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3475', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3476', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3477', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3479', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3480', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3481', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-3482', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3483', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3484', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27365', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29041', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29042', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-29045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2703', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-29050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2705', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-2709', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27214', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2719', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2720', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2722', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-29069', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7801', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-27967', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-2728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7802', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19702', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27285', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-27288', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7804', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7747', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7748', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19585', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19586', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-19587', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2017-7750', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-20637', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-2728', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-29072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2733', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2735', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-27227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27043', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2909', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-27046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2910', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-27234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27053', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27054', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2911', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-28972', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27019', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20418', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7808', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2730', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7809', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19601', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-2615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-27235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2739', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-29130', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27239', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27242', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29135', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-27076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1959', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19591', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19595', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19596', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7751', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27195', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-26155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7752', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27127', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-3485', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3489', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-27368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3490', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27374', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3494', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-27375', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-27376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3498', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-27377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3500', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3501', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27380', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3552', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27337', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-20424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27338', 4.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2017-7810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7813', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-20431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-20432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7815', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-27078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2748', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:H/A:N'),
('CVE-2022-27249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2750', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-2752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-29146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2754', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-27262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27098', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-2756', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-29156', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27133', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-28976', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-27135', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28977', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2629', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-28978', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2630', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27024', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-27145', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2632', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27146', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2633', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2020-2899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-28991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9987', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-9988', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-27156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-9989', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2636', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-28994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2637', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2900', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-2639', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2640', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2641', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2643', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-27158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9991', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27028', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27029', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27030', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2647', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2649', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27032', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27033', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7753', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-2616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-27382', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29617', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3554', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3556', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-29618', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3557', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27531', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29619', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27102', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27116', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2761', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-29163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2763', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-2764', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-27131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2767', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-29165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2768', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2770', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-2771', 5.3, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:H/A:L'),
('CVE-2019-2772', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2773', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-29171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:L'),
('CVE-2019-20433', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-20434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7816', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7817', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-2735', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-20446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27350', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2017-7819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3561', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3562', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2652', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-27038', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2653', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2654', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-29005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27039', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-9993', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2656', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2658', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-9994', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2662', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-2901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2665', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-27167', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-27168', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29013', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-27174', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-29014', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2674', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-27176', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2677', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-29017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27182', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-29176', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29177', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-2776', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2019-2777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2920', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2778', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-2921', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2781', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2783', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-2733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2922', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2786', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-27332', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-2787', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-2789', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-27337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2790', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-29230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2791', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-29238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27359', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-29245', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-29247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2800', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-29257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2926', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2804', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27377', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3566', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29623', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-3567', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2902', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2684', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2719', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7822', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27351', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-27359', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20456', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-20474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2738', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27385', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-20478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2739', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2020-27397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7825', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-29288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27189', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2738', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27194', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27195', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-2816', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-2818', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-2931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2821', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-29312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2932', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2824', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-27382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2827', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-2828', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-27197', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-2936', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2021-27198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2831', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2019-2834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27205', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3571', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-3572', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3573', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3574', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3575', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3576', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3577', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3578', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3579', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2964', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-3580', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-20483', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20484', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-19706', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7829', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-27212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2841', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-2843', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-2846', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2847', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-27215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27217', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27455', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-27460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3153', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-3156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27481', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27487', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27490', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3166', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3172', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2692', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27199', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2720', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2696', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2697', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-2698', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2699', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2700', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-27207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2701', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2702', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2022-27209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2905', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-3581', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3582', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3585', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3586', 5.3, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2020-29654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3587', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3588', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3591', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3592', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29657', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-29658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3593', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-2966', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-3595', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27386', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3597', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27387', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3598', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-3599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3602', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3606', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3610', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3612', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2741', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2017-7831', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19707', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7832', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-20493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7835', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-29053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-2706', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2707', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2708', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-27213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2712', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2713', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-2906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27042', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-27216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2721', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27218', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27220', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-2723', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27221', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2907', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-3158', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-27479', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-27480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3160', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-27515', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-27516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3181', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-3723', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-27549', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3724', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2362', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3726', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2365', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2370', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2371', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2372', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2373', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2375', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-27570', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-2377', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3189', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-3730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2384', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3196', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-2431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27614', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-3745', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2726', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-29070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2727', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-29071', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-2729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2730', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2731', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-2732', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2908', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27045', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2738', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27055', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-27059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2855', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2857', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2858', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-27416', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27223', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27224', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27419', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27225', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-27228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2859', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2860', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-20495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20496', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2017-7842', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3163', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3164', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-27493', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-27494', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3171', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27531', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27548', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27550', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3725', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3186', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2363', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2366', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3727', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27568', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3187', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2376', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2378', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2379', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2380', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-27572', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2383', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2386', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27574', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2389', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-27579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27393', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-3613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3615', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3619', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27395', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-3621', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3622', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-3628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29129', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-2913', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27065', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29134', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-2740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2741', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2742', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-2743', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7843', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-20504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7849', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20511', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2633', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-20524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-19709', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-27507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2393', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2397', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27584', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-27585', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2398', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2399', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2402', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-3193', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27589', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2404', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27591', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2406', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-3737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27594', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-27595', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-27596', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-2410', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-2415', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-27599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2417', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-2419', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-27604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2423', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-2425', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27616', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2435', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27620', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2437', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2438', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3751', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-27622', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27623', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27624', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2445', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-2446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27627', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2451', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27634', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27637', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27638', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2869', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2870', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2871', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2872', 2.5, 'CVSS:3.1/AV:P/AC:H/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-2873', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2874', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2875', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2876', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2877', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2878', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-29662', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27399', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29663', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-29666', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29668', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3633', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27401', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3634', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2968', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-27402', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-2969', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-2971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3636', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3638', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-27406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3639', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2020-2975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-2976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2977', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-2978', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2019-3643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2981', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2982', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-3644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2983', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-2984', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-3646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27412', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2744', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2745', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27085', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2914', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2749', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-2751', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2753', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2022-27257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27099', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2464', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2465', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2466', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2473', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2478', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2481', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2485', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2486', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-29157', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29158', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2758', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-27112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2759', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2760', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-27117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2884', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27241', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-27242', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27243', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27244', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-2889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2891', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2766', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-2769', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-2729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2775', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-27299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2779', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-27308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2782', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2732', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2019-2784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27331', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-27333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-27336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2734', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-27341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2792', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-27346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2793', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-2924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27413', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3652', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-27414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27416', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-27417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3653', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3654', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-3660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-27678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2491', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3776', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2492', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-27693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3236', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3238', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-27731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3782', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25007', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-25008', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-25009', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-27737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-25011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3786', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-3245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-3246', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-3788', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-27756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3790', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-27759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-27760', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-3250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25018', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-25019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-3252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2502', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3253', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27765', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3795', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27766', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27767', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3797', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2457', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27639', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27640', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27641', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2460', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2461', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27645', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-3761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2463', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-2468', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3765', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-3766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3767', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2471', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2472', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-2474', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-27659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3777', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2499', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2500', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3778', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-25001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3784', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-27736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-25010', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-3243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25012', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-27741', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-25013', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-27746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27751', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-21232', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-3112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-27419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3667', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-21234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3116', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-21235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2018-21236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21237', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3684', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-21238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3685', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2019-3686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-21239', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3119', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-29243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2794', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27365', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2797', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2799', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2809', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3798', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3691', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3692', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21245', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-3693', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3120', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3696', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-21248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3697', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21249', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2813', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-2814', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-27193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2930', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2817', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-27380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2819', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-29315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2822', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2823', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-2825', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-2933', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-2934', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-2935', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-2829', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27203', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2833', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-29361', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29362', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2835', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2837', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-27211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2839', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2840', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-27214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2842', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2845', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-27386', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27216', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-27803', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27815', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3806', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3809', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27839', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-27845', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27851', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3811', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-25052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27854', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2019-3816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3698', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-21251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21252', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-21253', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-21254', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-21255', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-21256', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-21257', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-2848', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-2739', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2850', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-2852', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2853', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-27219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2937', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-2854', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-27405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27220', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-25023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-25024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-25025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27785', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-25028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2503', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-25030', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-25031', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-3263', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-25033', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-3800', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3283', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-27877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27884', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-25066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-25070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-25071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3824', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3827', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-25081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3829', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-25084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3834', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-25091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25046', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-25050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3812', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3813', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2861', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-27230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2862', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-27231', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-27232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2863', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-27233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2864', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2865', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2866', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2867', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-2868', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-21258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21259', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-21260', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3708', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-27905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3840', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-2564', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2021-27907', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27908', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2569', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2573', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2579', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2580', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3848', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-25054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27862', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-25063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3825', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21261', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-3709', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-21262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-21263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3711', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3712', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3715', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3716', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-21265', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-27430', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3127', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-21268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-21269', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-27434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-21270', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2021-27437', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3130', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-3131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3132', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27924', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2583', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-27927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2585', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27563', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27931', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-27932', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2596', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2018-2598', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3858', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-2600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2601', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27941', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2603', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-27946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2610', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3868', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2612', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-2614', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27962', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-27964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3826', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27893', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27899', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-25082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3832', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3838', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-3841', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-27906', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3842', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2565', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-3134', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-3135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3139', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-3140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27445', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27471', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-27473', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-27474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-26263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2903', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2905', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-2906', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2907', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-2909', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2019-2910', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-26260', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-2721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2883', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-2886', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2888', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2894', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2895', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2896', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-27423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2898', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2899', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-2900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2901', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2902', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-27971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3875', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-27599', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27607', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-28021', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2623', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2022-2761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3882', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2629', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-2630', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-28032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3886', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-28033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2633', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-27618', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-3888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27619', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-3890', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-27620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27621', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-3302', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-3894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28041', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2570', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-2572', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3845', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2574', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2575', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-27913', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-3846', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27475', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-27476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3148', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:L'),
('CVE-2020-3149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3151', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2020-3152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-3155', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27483', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27486', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27488', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27492', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3167', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27506', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2924', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2925', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-2926', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-2940', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-2931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2941', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-2933', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-2942', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-2934', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-2936', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-29437', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-27431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2938', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-2940', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-29441', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-27436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2941', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29443', 2.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2019-2942', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-2943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27544', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2582', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-27925', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2584', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27547', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-27548', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27549', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3850', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2587', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-3852', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-27928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2590', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2593', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2595', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-3857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27578', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3859', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-27580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3860', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-3861', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-3862', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-2602', 3.4, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-3863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2604', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2606', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3866', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2607', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27438', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2944', 5.3, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2019-2945', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-27444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29445', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29446', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2947', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-29447', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-27445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3722', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3182', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2361', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27557', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-27559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2364', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2368', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2369', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27569', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2374', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3729', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-3188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-27571', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2382', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2385', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2387', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2388', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2390', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-2391', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2392', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2394', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27582', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-27583', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3191', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-27586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2400', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3734', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2403', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2405', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27593', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-2408', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-3194', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2409', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27598', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2416', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-3195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27602', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2420', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2421', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2422', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2424', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27608', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3741', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2639', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-27624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27626', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-3900', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2646', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3901', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19627', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19628', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19629', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-26181', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7758', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-26183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7759', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20327', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20329', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-26184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2911', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2913', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-2938', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-2914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2915', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2920', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-29384', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-29385', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-2922', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2939', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-29392', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2923', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29394', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2927', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-2932', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-2943', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-2935', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29436', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-2937', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2949', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-29448', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2951', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2953', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-2954', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2019-2955', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2019-2956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-27448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2958', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-2960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2962', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2963', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2427', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2428', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3197', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3742', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2434', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-27618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2439', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2440', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2441', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-3752', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-2444', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27625', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2447', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27626', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2448', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2449', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2021-27632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2450', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27635', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-2454', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3754', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2455', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27642', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27643', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3759', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-3760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2608', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-2609', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2611', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3870', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-3871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3873', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-27593', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-2618', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2619', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3876', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-27983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3877', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-28000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3878', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3879', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-2625', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3880', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-29457', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-2964', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-27455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2947', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-29472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19636', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7760', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19637', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-27216', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-19638', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19639', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7761', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-19640', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7762', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-2462', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-27647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3763', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2467', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2469', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2470', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-2475', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-2476', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2477', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2479', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2482', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2483', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27668', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3774', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2487', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-27671', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2488', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29489', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2949', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2976', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2020-29490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2977', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-29494', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2020-29495', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-29497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2981', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2987', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-29507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2990', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-29509', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-28026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3881', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2628', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3884', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-27614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27617', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2634', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-2635', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2636', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-3301', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3891', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2637', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-3893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28042', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27623', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2660', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2018-2662', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-28115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3321', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-28116', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3941', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2673', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2674', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2675', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2676', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-3946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2677', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-28129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28130', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3339', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-28131', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2678', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-2679', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-19641', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2619', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-2945', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-29450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29451', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2959', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-27451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29454', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-2965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2946', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-29469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2489', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2490', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2494', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2497', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-3235', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-27722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3237', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2021-27730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3241', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-3242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3785', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-25014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3787', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2951', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-29510', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2994', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-2953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2996', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-2997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29536', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3000', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-3002', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-3003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29547', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29548', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3012', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3015', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27499', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-29553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2680', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2681', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2682', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3344', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2684', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2685', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-3345', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-2686', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-3954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2689', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-3955', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2691', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-3349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-2693', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2694', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-3350', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-3958', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2695', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2696', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3352', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3962', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-2698', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-3354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3963', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2699', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2700', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28154', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2638', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-27625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2642', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-3305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2645', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-28092', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3902', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-28093', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-3309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28094', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2649', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-3905', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-3311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28095', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2652', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3909', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2654', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28096', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-29478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2969', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-2970', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2971', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-27463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2972', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-2973', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-27470', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29555', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-3017', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-29556', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27263', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-27502', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3019', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29561', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27266', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-29565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27268', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27271', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3792', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3794', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-3254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27769', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-27771', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-3256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27773', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-27774', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-25021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-25022', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27779', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27780', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-25027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2703', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3967', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2706', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3969', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2711', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-28161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3971', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3972', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3974', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-2720', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2722', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2723', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2724', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2726', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2727', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2728', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2729', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2730', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-2731', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2738', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-28164', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2746', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-3980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2748', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2749', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2750', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-3314', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2019-3911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2656', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-2764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3315', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-3913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3319', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-28114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2663', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-2664', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-28117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-2667', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2671', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2755', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2756', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2018-2758', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2760', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3996', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-27648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27649', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28169', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28170', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-27651', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-2975', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-27479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2978', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-29493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-2980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27482', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2983', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-27484', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-2984', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-29505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2986', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-29506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2988', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2989', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-27487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-2991', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-2992', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-2993', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3267', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-25032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2504', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3802', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27807', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-25047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3805', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27828', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-27836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-25048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2505', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27276', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-27506', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-27288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3397', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-29579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4013', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2767', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27657', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2769', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27661', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-27662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2771', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27666', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-2773', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29511', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-2952', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-29529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2995', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-27490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-2999', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3001', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27495', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-29539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3005', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-3009', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2955', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-29550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27259', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27260', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-29551', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-29552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2683', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28135', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28136', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2687', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-28139', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3347', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2688', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-3953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2690', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-28145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2692', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3956', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-28147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3957', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-28148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3961', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2697', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3353', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28153', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-3964', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2701', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-2702', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3965', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3966', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2704', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-2705', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2707', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-3968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2708', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2709', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3359', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-2712', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3970', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-2713', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2018-2714', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2715', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-19651', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26276', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2017-7764', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-19655', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-29580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27329', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3402', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-27852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27853', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-3280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3814', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-25055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3815', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-3817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-25059', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-3818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27861', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-25061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-25062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27876', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-25064', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3820', 3.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-27885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-25067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3823', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-25072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-25074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-25075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3828', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27900', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-25083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-25085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-25086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-25087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-3833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-25089', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-3835', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3384', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2018-2775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4039', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2776', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4043', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-4045', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-3389', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4047', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4048', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-2777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3973', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2719', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2721', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2725', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28163', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2733', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2737', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2739', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-2742', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-2747', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2752', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3362', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27262', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-3018', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2956', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-27264', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-27340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2959', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-27347', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-27352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-29593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2752', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29599', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-3990', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4131', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4132', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4140', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2824', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-28419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2827', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:H'),
('CVE-2019-4149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2780', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4151', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2833', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2834', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:H'),
('CVE-2021-28448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28454', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3462', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-4158', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-3463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28456', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-4161', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N');
INSERT INTO `tpandora_cve` VALUES
('CVE-2020-3467', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-4167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-2844', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4176', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4177', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27802', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2850', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-2851', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-4185', 6.0, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27807', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2855', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4202', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2860', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4204', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2862', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-27810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2863', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-4207', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2866', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2869', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4210', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2873', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3485', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-4216', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-2882', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2019-4224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2783', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-29562', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-3020', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2021-27265', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-3021', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-29564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2019-3023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-27267', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3024', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-3025', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-3026', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-3027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-27269', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3028', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27270', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-3031', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-27272', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-27273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27275', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2021-27277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27278', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-28210', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28211', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28245', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28249', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-2784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2785', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-3410', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4061', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4062', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-27780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-3413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2786', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-28271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28275', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-28276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4063', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-28280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2787', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-2789', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-28294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3419', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2791', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-3836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2561', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-27904', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3839', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2562', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-3843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27909', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2571', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-27911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3285', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-2576', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27919', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-27921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2581', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-27523', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-29600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3429', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27524', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-29602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2841', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28457', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27801', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28470', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27803', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4178', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2853', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-3472', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2018-2854', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2857', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-2858', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2781', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2864', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2867', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4208', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-3478', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-4209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27816', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-28483', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-2874', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2876', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2022-27837', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2907', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-28501', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2913', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2923', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2925', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4257', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2934', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4260', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-29572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-29575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-29577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-2958', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-27318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3400', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3401', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27511', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27512', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-3403', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28167', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-3994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28168', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2761', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3370', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-2762', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2765', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3373', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-27650', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3374', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27652', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-28305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2794', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-28307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3427', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2796', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-28308', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-4071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2797', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-2798', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-3430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2799', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-4076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3434', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3435', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-2800', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-2802', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2803', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2804', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2805', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2809', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-3436', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-3851', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2586', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2588', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2589', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2591', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2592', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-3856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2594', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-2597', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-27938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2599', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-2758', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-27947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3867', 3.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-3869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2613', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-27963', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-3872', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-27969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3874', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2620', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2621', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-27984', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2782', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4231', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-2897', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2899', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4236', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2906', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4239', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4244', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4246', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2916', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-2919', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2924', 3.7, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2019-4253', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2936', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2940', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4262', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2942', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2946', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28174', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-27653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4016', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2768', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-27658', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2770', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-4029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27659', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-3380', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4038', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2774', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-3386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-27341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-27345', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-27513', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-2760', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27608', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-28022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27609', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-2624', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-2626', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28025', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-27610', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-27611', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-2627', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-3883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3885', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2631', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27615', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-2632', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7768', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27228', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19666', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-1967', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2723', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-27234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26296', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-26304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-1969', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-2623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27790', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2811', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-3439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2812', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-4090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4093', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-3441', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3442', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-4103', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27792', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2814', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-4109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28359', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2953', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-2956', 6.0, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-2958', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2019-4279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4280', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4284', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4288', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27870', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2970', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2975', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27883', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2978', 5.5, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2022-27886', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2981', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4325', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2992', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2019-4326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2993', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-4327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2994', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2995', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-28544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3007', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-3008', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-27909', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3012', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-35124', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-3014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3017', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-35127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3025', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3027', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-27924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3030', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3033', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3036', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-35137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4395', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3041', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27933', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-3045', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-3048', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3052', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2022-27937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27938', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-28556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27940', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4400', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27944', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35164', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3060', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-2795', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-4420', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4423', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2961', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4291', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4296', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4297', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4298', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4301', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2972', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4304', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-2974', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-2976', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-27887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4309', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2984', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-2986', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35111', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4340', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2018-3003', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-4364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28548', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4377', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3011', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-27910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2778', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3390', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-2772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3393', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4049', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4051', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27772', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4054', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2783', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3404', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-27777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4056', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-27778', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-27779', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2870', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2875', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-3483', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3484', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2880', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4218', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4220', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4222', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4225', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2889', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2895', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2896', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4234', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2905', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4243', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2909', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2912', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-2914', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2921', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-4252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2927', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2932', 5.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:H'),
('CVE-2018-2933', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-2937', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2939', 5.8, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2022-27850', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-4263', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4265', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2951', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28508', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-2954', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2959', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-2960', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27867', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27869', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4286', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2787', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-2962', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27872', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4294', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2964', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2966', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-3501', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2019-4303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2973', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-2977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-4307', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2979', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2789', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-3447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3448', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2021-28361', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2815', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-27794', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2816', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28372', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-4130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27795', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4138', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28382', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27797', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2822', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-27798', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4349', 2.5, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-3005', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-35122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3013', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4382', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3016', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4385', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-3019', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4386', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4391', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-28552', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3037', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-3042', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-3046', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3049', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27939', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4398', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27941', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3058', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-35176', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27963', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3519', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-4441', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-28569', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4442', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28574', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4456', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-28575', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-28016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3520', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4465', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3089', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-27912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4383', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4384', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3018', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-3021', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27920', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3038', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27942', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4419', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-28560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27958', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-27962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4439', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-3070', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-35189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3076', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3059', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4424', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-35175', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-28562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28563', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-3068', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27966', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3071', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2987', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4323', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-27893', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-2990', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-27896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2790', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2019-4335', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2998', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2999', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4338', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27904', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4351', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4352', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28547', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4366', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3015', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3024', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3034', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3035', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-3039', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27930', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3051', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-35141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3055', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:H'),
('CVE-2020-3409', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27783', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2788', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2790', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-4067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28302', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2792', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2793', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2795', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-4070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4145', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28427', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28429', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2826', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2828', 5.3, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2018-2830', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2831', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-3458', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2835', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-4153', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2021-28451', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4156', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28453', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3304', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28070', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-28079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2641', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-2643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-2644', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28090', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-2647', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-27635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2648', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27636', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2650', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-27637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2651', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-3906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2653', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2655', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2657', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-27786', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4072', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-4073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28313', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3433', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27787', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2801', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-27788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28321', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2806', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2018-2807', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28322', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4473', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28587', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-35215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3093', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-28054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2806', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28597', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3103', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2020-3523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28601', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-28070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3111', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2022-28076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35236', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3127', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-3129', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-35240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28090', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-28096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3134', 4.2, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2022-28108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3136', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-28616', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-28618', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-28619', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3139', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4533', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-28623', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4550', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28630', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-3147', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-35296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3148', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3151', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28137', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-35305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28139', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3155', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-28142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4562', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-28634', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-26237', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20373', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-26309', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-27251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26238', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-26310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20374', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-20375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2017-7776', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-27255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20379', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4084', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-27791', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4094', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4095', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-4101', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4102', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2813', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4112', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27960', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-27961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3066', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4433', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-27969', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3072', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3074', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35208', 5.2, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-3088', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-4470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35214', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-35216', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3522', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-28060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3098', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2021-28596', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3101', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3102', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2019-4482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3108', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3110', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-3122', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-28077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3131', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-4495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28458', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2843', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4171', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2845', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-2846', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2848', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28471', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28472', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28473', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2861', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2022-27811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2865', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28478', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-2868', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27814', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27815', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2872', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27818', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-4212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3482', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-28490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2878', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2881', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-4219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2887', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-2888', 6.0, 'CVSS:3.0/AV:P/AC:H/PR:H/UI:R/S:C/C:H/I:H/A:L'),
('CVE-2019-4226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4227', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-3084', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-28579', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3085', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:H'),
('CVE-2022-28023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3087', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-28033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35213', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-28053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28589', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3096', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-28059', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-4481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3104', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-28073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3126', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3130', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-3132', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28610', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28101', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-28106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4513', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-28615', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-35270', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-3138', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-35275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28134', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3152', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3154', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28140', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4563', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4568', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4579', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-28156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3174', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28566', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28568', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4447', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-4454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3082', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3086', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28049', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-28588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3095', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-28058', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-28593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3099', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-28067', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-28071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3115', 5.3, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:L/A:L'),
('CVE-2019-4484', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3123', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3128', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-28081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4505', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4508', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-35273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28114', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-28621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28622', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4539', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-4542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4116', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4118', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4119', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-28363', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28373', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4129', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28374', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4133', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2019-4134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28376', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28377', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4137', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4139', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2820', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28399', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2821', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2823', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4143', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2825', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-4146', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28424', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27799', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2658', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28113', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2018-2659', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2661', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-3923', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2666', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28124', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-2669', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2672', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3334', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-3335', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28128', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2900', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2018-2902', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2904', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-27840', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-27841', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-2915', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-4261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27851', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-2941', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-27854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27855', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-2945', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2950', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4268', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2955', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4275', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27865', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4293', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2963', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3499', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-27875', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-2967', 4.0, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-2968', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-2969', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4299', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2971', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3502', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-27881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4306', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-27884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4308', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2980', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-4311', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2982', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2985', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4322', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2988', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-4324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28545', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-28144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-3533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28147', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3157', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4566', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4569', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28152', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-28636', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3168', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-35364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4583', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4589', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4591', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4593', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4595', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4601', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3541', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3176', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3178', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4616', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-35451', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4619', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3188', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-3191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2829', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-4150', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2832', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-4152', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-28450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2836', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-4155', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2837', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-2838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27800', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3461', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-2840', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2019-4163', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2842', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-4174', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28469', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2847', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2849', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-3470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2852', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-4184', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4194', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-2856', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2859', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28475', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3343', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28133', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-3346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-3951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3146', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-4556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-3529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3149', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-28631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28138', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-4560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28632', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28633', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-28145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3159', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-3160', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-3535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4570', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28151', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3165', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3167', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-28637', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-3170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28655', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-35466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28657', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28658', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3205', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35473', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3215', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-28661', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3218', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2018-3221', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-3222', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2020-35477', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3226', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2019-4667', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3231', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-3232', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-3233', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2020-35483', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28162', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3242', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-4671', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-3244', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-28167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4672', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35491', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3249', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35494', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2020-35495', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4687', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28614', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-35263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4538', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2019-4540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35357', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-3164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3166', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28154', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-28155', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-35373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4594', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4597', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-4606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28640', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3181', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3183', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-3186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4623', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3194', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3195', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-35460', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-35467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4652', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3207', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4654', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-3211', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-4655', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-28641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3180', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-35442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35448', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-28643', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-3184', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-35452', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-35453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-28645', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35456', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3187', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-28648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4636', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4638', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3198', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3202', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3204', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-35470', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3210', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3214', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-3217', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2018-3219', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2019-4666', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3227', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-3228', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2021-28664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3229', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-3230', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2020-35480', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28161', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3235', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-3549', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3001', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3002', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-4342', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27907', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3006', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3009', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2018-3010', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2022-27911', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35125', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3020', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-35129', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-28551', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3029', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3032', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-35136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3040', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3047', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35149', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3056', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27943', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4411', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3064', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-35382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4598', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-35398', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4603', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3175', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3177', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4617', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-3182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3185', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-4620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28646', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-35457', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3189', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-35459', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28650', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4635', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4637', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3196', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-35462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4650', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-3203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3209', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-3213', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3220', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2021-28662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3223', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-3224', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-3225', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2020-35478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2816', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28477', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2871', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-27817', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2022-27819', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2019-4214', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2877', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-2879', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-28492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27820', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-2883', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-2891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2894', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2898', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27839', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2911', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2022-27847', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-2917', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-2918', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-2920', 3.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2019-4256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2935', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2019-4259', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2938', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-27852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4264', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4266', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4267', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-2947', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2949', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3257', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4693', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3258', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3262', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-4698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4699', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4701', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3550', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4702', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4705', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4706', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35504', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-35505', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4726', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-4728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3280', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4730', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2018-3281', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35490', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4679', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3247', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-4681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3253', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-3254', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3255', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4695', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3261', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4704', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4707', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-4716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3276', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4719', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4732', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35509', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-3551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28045', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-35510', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35511', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35512', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4741', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28046', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-3282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35514', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-2952', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-4270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4271', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-27863', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2965', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20400', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26269', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-26279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-26291', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-26293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-2726', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-26296', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20403', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20404', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-19699', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4669', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-3234', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2020-35489', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-3236', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-3237', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3238', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-3239', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3241', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3243', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-28166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3246', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3248', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-35493', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-3250', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35496', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4686', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3252', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3256', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-4692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4703', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35503', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-4718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35507', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-4722', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3278', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4729', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4731', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4736', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-4737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-28047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3283', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4745', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3284', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35517', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-35518', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7789', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26308', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4444', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28570', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-28002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3081', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-28576', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-28020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35207', 5.2, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-28035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28585', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3090', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-3091', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-28591', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3097', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2018-3100', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-28069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3105', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28602', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28072', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3109', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3120', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3125', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-28607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28611', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-28104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4509', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3135', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-35261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28617', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-35272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3140', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4537', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28624', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-26309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20408', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7791', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-26313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-26315', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7793', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3287', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-3552', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-4762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3290', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35530', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-3294', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35534', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35535', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-28181', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-3296', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-28183', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-3299', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:H'),
('CVE-2018-3301', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3303', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-28188', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3312', 4.7, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2018-3314', 5.8, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-3315', 5.8, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2020-3555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-26317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2017-7794', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20411', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-26319', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7799', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4749', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4751', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3288', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-3289', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35521', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35522', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-3291', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35524', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3292', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-3293', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35531', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35532', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35533', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3295', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-35538', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-28182', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-3297', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-28682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-3556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3503', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-4305', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28509', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-27888', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2989', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-2991', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-4329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-4330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-2996', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-2997', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-4336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3000', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-35114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3004', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27906', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-4357', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2791', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-27913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35128', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-3023', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-3026', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3028', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-27925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3031', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-27928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4394', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-2793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-27932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3043', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-35138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3044', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-27934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3050', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-3053', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2021-28555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-20413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27283', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2017-7803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3298', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-28186', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-3305', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-3309', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-28675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-28678', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-28683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3611', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35569', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28192', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20415', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2017-7805', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-2729', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2017-7806', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-27291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27293', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2017-7807', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-35566', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35570', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28191', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3057', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-28557', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-4406', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3062', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-27952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-27964', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-27965', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3069', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-27967', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4437', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4446', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-28008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35199', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28583', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-4460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-27298', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-20421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-2731', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-2733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7812', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-20429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-20430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2017-7814', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-19704', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2820', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-3559', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-35591', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-35592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28201', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-20438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-20444', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2017-7818', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-20452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2017-7821', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-19705', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-27356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-27361', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-27362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-2737', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-27372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3092', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2018-3094', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2019-4477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28595', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28600', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-35234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4485', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28085', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28609', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28612', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-4512', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28613', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:N/I:H/A:H'),
('CVE-2019-4514', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3141', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-3142', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-28120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-4547', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4549', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4551', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3144', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28629', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4558', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3150', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3153', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-4564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3158', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-2815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3163', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-4572', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-4581', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3169', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-4592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3171', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-28639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-4600', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-4613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3179', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2020-35441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28644', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35454', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28647', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3190', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-28649', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3192', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3193', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3206', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3208', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-28222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3639', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28224', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-5008', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-35604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28791', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28214', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35615', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-35616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5007', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-35622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5011', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5013', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28230', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3563', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28818', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35653', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2021-28821', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28822', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35655', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2019-5050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28823', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28825', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5065', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3665', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-3668', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3671', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3679', 6.0, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-5085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2824', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-4715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35506', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-4735', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5098', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28835', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3691', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5108', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3698', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3700', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5124', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28856', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28245', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-35709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-28875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5150', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28231', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28232', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28233', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28819', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28820', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3602', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3605', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3609', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35567', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35568', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3621', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3626', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35581', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28198', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5053', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28824', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-3661', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3662', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3663', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5068', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-28827', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-3667', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5084', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28832', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28242', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3696', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3697', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35681', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5114', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-5119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35686', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28861', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2020-35590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3634', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28790', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28185', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-3300', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-3302', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2018-3304', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-3554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3311', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-35545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35547', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-3316', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-28674', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-28676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28680', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28684', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-28685', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28686', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3601', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3603', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35561', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3606', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3613', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3727', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28918', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28213', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-28792', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2021-28793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28218', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3561', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-28799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5005', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-28225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28876', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5146', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-3718', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35717', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-3721', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-3724', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35726', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35728', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28938', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3573', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35730', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28954', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35738', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2018-3744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28252', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-28958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3557', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-35571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3616', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2819', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5006', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-28228', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-28807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5017', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5020', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5023', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28234', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28235', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5045', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3658', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-28236', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5062', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35662', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-5094', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3688', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28941', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28251', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-28953', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3740', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28253', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3750', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3752', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3754', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3759', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5223', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-35754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35742', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-28963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3756', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35743', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-28965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-28969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3761', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-3762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3705', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28855', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-28860', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-5131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28246', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3572', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-5164', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3726', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3728', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3770', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28259', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3776', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-3777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-5245', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-29029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29039', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3818', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29040', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3828', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3767', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-3769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28258', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3738', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-3739', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-28955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3745', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-3746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3748', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3749', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3753', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-35761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3577', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5263', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3854', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-28268', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-3855', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3857', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3859', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3860', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3887', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28286', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-2826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3778', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3783', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28261', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28263', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28264', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28260', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3781', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5241', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5242', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3809', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3817', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3819', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3824', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29052', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28303', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28305', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3959', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28310', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28312', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28313', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28319', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3978', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35594', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3560', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-35605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35609', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35614', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-28805', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28226', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3562', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-28809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5016', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5018', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3650', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3987', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3988', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2834', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-3995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28353', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28365', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4036', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3836', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3837', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3579', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3886', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28273', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3932', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28265', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28266', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28267', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28269', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-3871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28272', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3888', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28275', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28276', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3922', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3924', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3930', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3936', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3564', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-3565', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2019-5033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35658', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-5061', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5070', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-28238', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28239', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-28830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3956', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-28307', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3961', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28314', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3966', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4055', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4058', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-28391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29102', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-29103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29104', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29112', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3683', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3684', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3687', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5095', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5106', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3693', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-35682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5286', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28306', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28309', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28311', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3963', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3965', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28315', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3968', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28317', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3973', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3989', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3990', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3701', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3704', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28244', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2019-5125', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35685', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-35687', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-5126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3571', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-35710', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5147', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-5152', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-28899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3969', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28320', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4007', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-28366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4035', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4037', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4042', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4043', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4045', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4053', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29099', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2841', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-28411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4087', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29118', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28248', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5158', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3722', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28905', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3723', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28249', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-28927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5183', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-28250', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3747', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3751', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28254', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28255', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4004', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4012', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4034', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4038', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4040', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4051', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5311', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4082', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29115', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29133', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29134', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29136', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4093', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-5342', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5344', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5352', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5348', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5354', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5357', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5358', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5361', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-28462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28464', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-4114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4116', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-5370', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4094', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5341', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5345', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5347', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4109', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5366', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28478', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-5375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5381', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5382', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5383', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3760', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-28967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35749', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-28968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-28970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28256', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-35760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28257', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-35766', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-28979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-3779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3780', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2848', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-28480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29151', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5386', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5392', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4122', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5403', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5425', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-28999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28262', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3825', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3861', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28270', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28271', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3889', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28279', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4121', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28308', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3960', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3967', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5436', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5437', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5440', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5443', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5448', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4146', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5456', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28318', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3975', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3986', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-3998', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28355', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4032', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4033', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4041', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4046', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28379', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4047', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4052', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4054', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5310', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5405', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-4126', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5407', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-4127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28527', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-28528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29253', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5466', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5417', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4129', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4130', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2849', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5426', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-29221', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5435', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-29240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28055', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5438', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5444', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4144', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29113', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-28421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28443', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-4092', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4095', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5340', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5343', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5350', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5353', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5356', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4163', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4164', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4165', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5449', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5461', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-28523', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-28467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5368', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5369', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5371', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4118', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4162', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29323', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29324', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29337', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5483', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29357', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-29358', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4186', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5460', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5496', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28541', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5498', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29418', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4192', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4195', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5513', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5514', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29436', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2019-5387', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5388', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5389', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5390', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5391', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5393', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29157', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5408', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-5413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5416', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5433', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-5447', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29242', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-5451', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5453', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-5455', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5459', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-29249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29361', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29362', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29365', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29366', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5490', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29390', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2021-29396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29398', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4189', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28543', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28544', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5503', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5507', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29425', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-29256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29429', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4198', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-4199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5516', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-29440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29446', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5518', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5519', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29450', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5524', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5525', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-4208', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5530', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4210', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4211', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-5542', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-4214', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5543', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29298', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29487', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-29488', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5589', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5590', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35859', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5625', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-5626', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5627', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5629', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5630', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29518', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29519', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5640', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35871', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5643', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29522', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29523', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29524', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5647', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-35881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28586', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29526', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29527', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35889', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4249', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29531', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5675', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35898', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-5677', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35899', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5681', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35900', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5683', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5685', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5696', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5698', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29538', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35911', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29539', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4266', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5716', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5719', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5720', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29544', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4270', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5727', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35928', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5736', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-5737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35934', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4278', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-3820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29043', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-3826', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3827', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3829', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29056', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-29554', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4279', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-35946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35947', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-35948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29560', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5755', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-3862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3870', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3881', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2018-3921', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3923', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-3933', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-3944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3952', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-28300', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3964', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3970', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3974', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-3976', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-3982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-3993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28352', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-4000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4006', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4008', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4022', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29084', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4031', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-4039', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4044', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-2838', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29096', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28394', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4086', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2844', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4090', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29140', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-29141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29549', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29550', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4274', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-35931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5748', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4277', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29553', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-35939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29557', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29559', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-35951', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2020-35963', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5349', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5351', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5355', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5362', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5363', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4117', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29567', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3600', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36006', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-36007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36008', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-28614', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29572', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4307', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-29573', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29575', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5759', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-36012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36024', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5758', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5394', 4.7, 'CVSS:3.0/AV:L/AC:H/PR:H/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2021-29156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5402', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2019-5404', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5414', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5418', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5423', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29218', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4133', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5431', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-4137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28506', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5434', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29239', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29484', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-4220', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4222', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5585', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-4225', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5475', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29279', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5480', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29297', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29325', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29327', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29338', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29343', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-5484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5511', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-4197', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5515', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5517', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-29444', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29445', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4205', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-5596', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-29509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5632', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5634', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5638', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5641', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5520', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5522', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-29456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5531', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-29465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5535', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2019-5537', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29471', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-5538', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29473', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-5541', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-29476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5450', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5452', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29581', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29583', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29584', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29585', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29589', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36160', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-36162', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-4329', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36165', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-29591', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5463', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-35875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4243', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35883', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-35885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29528', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35892', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-35894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-35897', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5682', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5686', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35903', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35904', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29536', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5692', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5693', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4262', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29582', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-4318', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5491', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29394', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29395', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5492', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-5495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4188', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5697', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-3591', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-35910', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29328', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-5485', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-29364', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5487', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36170', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-28621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-28625', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29598', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36179', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29599', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29451', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-29453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5521', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2019-5526', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5527', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-4209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5533', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5534', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-29466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29600', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29601', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-36180', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29602', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36181', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29513', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5618', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5624', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29516', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4235', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29517', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5540', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-29475', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-29477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29492', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-29499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-35843', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5592', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5594', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5595', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29512', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28542', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4190', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4191', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29428', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5512', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-29432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29433', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-29434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29443', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5754', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4347', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29521', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5642', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35874', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35882', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4247', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5672', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-5673', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-5674', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5679', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29533', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-5684', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-29534', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5687', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5688', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5689', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5691', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35905', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29537', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29448', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2018-4204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4206', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29457', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29458', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5532', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-29463', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5539', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4232', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-4233', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5633', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-29520', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35908', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29541', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5715', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4267', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5717', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35920', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5718', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35921', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5721', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5722', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35922', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5723', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5725', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29545', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35924', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35925', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4271', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29480', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-4218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29490', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2018-4223', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4224', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29504', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-4226', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29565', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35990', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-4300', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5757', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4241', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5767', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29508', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-2857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29548', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4273', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-35932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-36112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36125', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-36126', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-29579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4316', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36128', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-36129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4317', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-36142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28679', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2868', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-28680', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36188', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4374', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29525', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35884', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-35886', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29532', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5678', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4260', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4323', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29590', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-36161', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-36163', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-36164', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-5762', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5690', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35907', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35912', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35914', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35915', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29540', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35916', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35918', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29542', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29543', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5729', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29552', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29555', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29556', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4284', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5700', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35913', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35917', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35919', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4269', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-29547', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35927', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4272', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29551', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28685', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28686', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-4377', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29561', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3597', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2020-35971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-35973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29563', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3598', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-4293', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-35981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29564', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4298', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4299', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-35944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29558', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3595', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-35965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29562', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-35972', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-35980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-35992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29570', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-36011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29571', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28615', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-36034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29576', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29568', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36005', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-29569', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-36009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4306', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29595', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36175', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29596', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29597', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5764', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29580', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36144', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-4319', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-29586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4309', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4311', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-36073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28696', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28697', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36198', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4382', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5774', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36166', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-29592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36167', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-36168', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-36169', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-29593', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29578', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29751', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29753', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-36285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4441', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4443', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36289', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5761', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36208', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36209', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4392', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36210', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36214', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36216', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5776', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29766', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29767', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29769', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-29771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29773', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-36290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4345', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29604', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5766', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5763', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36224', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4409', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29645', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5779', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-29809', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29819', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4358', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29615', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36185', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28671', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29621', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29623', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-28673', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28674', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5765', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28677', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29642', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5770', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4357', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29613', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-28661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29614', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5768', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36232', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-2806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36233', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4414', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36235', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36189', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28687', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-28688', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36192', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2869', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-28690', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4416', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36238', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-28734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36322', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29672', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29678', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-29679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29682', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29687', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29692', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29693', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36240', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36241', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36242', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-36243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29700', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29701', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36245', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28678', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36187', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29605', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28643', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28644', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36182', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28647', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29609', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29610', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29611', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36197', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5773', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29707', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29708', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36252', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29719', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36254', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29727', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29738', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-29739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29741', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29935', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-36334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29939', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-36370', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36372', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36374', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36383', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5797', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36183', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29612', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28651', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36184', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28666', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29616', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29617', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28668', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28669', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29618', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4361', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2867', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-4362', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29619', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28672', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36186', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-5769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29742', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29752', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29758', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-4444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29763', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4445', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29774', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29780', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-29785', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29804', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28702', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28708', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28712', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-28713', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28714', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-29957', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-29959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-29962', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-29963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-29964', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-29967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4386', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36203', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28718', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-28719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36204', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36205', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36206', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36207', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28681', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2022-28683', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36211', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4394', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36217', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36218', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4397', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36219', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36220', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4398', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29842', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5777', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29969', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2874', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29863', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29868', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28730', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28733', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29873', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-28750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28752', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28758', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-36422', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28762', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36424', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36425', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36427', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5778', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-36326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36330', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-28778', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-5804', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-36231', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4412', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5780', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30014', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36461', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36463', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4844', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-36470', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29941', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-36365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29942', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-36366', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36367', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5796', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5781', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29948', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29949', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29955', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29958', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-29960', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-29961', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-30081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28819', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30108', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-36493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29681', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36248', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36250', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29715', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-36251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28749', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28830', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28832', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28833', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28835', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4884', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36523', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29740', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4437', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4439', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-5785', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28754', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-29980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36421', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36429', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28764', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28766', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2877', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28775', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-28776', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36438', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29996', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-36445', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28791', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-36449', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36450', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36453', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36455', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28805', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-30004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-4835', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36459', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30015', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30019', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36460', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30020', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30027', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3003', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30039', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36462', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36465', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3005', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30056', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36471', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28815', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36477', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4868', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-28816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30158', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4886', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28842', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28846', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28849', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4889', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28850', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4890', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-29775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29776', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36308', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29779', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36309', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29784', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4872', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-4873', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-36505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-4877', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28822', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28823', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28827', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29801', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29806', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29838', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36565', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28873', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-28062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4899', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4900', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4901', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4903', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4905', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28072', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4916', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36314', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-29849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36315', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36316', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29853', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-36317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28837', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36521', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-36525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-28843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4887', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30219', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2894', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28964', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-36695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36696', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36323', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-28736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29883', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-28737', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29904', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29906', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29913', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-5794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-36551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28853', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28855', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2898', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4941', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28998', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-4943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2900', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-4944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28870', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36569', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-28872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4897', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28886', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36611', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-36628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4908', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-28065', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4909', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28071', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-4911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-36658', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36659', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30187', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-36661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30194', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-30195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30199', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36667', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-4917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4956', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36737', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36738', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29047', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36742', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28080', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36744', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-4960', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36746', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-4962', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36668', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36670', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-4918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28918', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-4919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3024', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4921', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4923', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-4924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36756', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36757', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36760', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29934', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-29936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36364', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-36368', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36369', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29661', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36237', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29667', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36436', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36437', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29991', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-4969', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4972', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29072', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28110', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-28111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5840', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-29951', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-29952', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36385', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29671', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5782', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4949', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29031', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29033', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4955', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36440', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36444', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29965', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-4982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30478', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-30479', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28131', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-2814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4986', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30500', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-28161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36730', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:H'),
('CVE-2022-29044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36739', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-4958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5783', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28741', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29974', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-28751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28753', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-36413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28807', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30048', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28809', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36466', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36467', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2881', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2021-30057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36468', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36469', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4849', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-36472', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36473', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5010', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5011', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5850', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-28756', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28757', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28759', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-28761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-28101', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29058', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-30359', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29071', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4973', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3041', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29726', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5784', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30110', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-2882', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-30119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30126', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-28824', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28825', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4880', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30137', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-4881', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-29743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36280', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29749', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-29750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4440', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-29754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36287', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29759', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29760', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36430', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36431', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36435', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28777', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-29993', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-36439', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28779', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36446', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36447', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4925', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4926', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4928', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36699', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28990', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28834', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4882', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28836', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30144', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30152', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-30153', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28838', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28839', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4885', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30155', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-30156', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-4898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4902', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28144', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30498', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30501', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-3745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29017', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29028', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2901', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2020-36712', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-36715', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-4947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36716', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-29029', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-36720', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-29030', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29032', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36721', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-36722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36725', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29095', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-28175', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-29097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4912', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36660', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4913', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4914', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2889', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4464', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-29824', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-29825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29831', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-29832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28861', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36561', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-36564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28867', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36566', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-4895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36749', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29051', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-28093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-36762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4970', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4875', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4876', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-30123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36747', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29052', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3034', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-4964', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36605', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-36609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3039', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-28112', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-28113', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28114', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-3702', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28118', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28123', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5032', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29188', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-5033', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2884', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-36552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-3042', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4981', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30470', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30472', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29851', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29859', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29860', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29861', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29862', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29867', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-4904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-36641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36650', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29195', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29197', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29200', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29203', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3810', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-28129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30490', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29085', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-28739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29922', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-36328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-29931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-29933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36331', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-36332', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36333', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-29943', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-36371', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-29947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3051', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29154', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-3767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5019', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3782', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-3785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29177', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30494', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28153', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5000', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5001', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29110', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29206', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2891', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29178', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-29179', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-5854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28860', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4894', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-28869', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4896', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28877', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2888', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-28880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36604', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4906', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36636', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5823', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-28966', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-4934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29146', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-3763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28203', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5017', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5053', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5054', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-5008', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36389', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-29968', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-36396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36401', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36402', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36404', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-28999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5833', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-5825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29191', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5036', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3803', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29196', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29198', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5038', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29199', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30218', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29234', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29235', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3867', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28263', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29238', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36697', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-28979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4938', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-36416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-3765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29164', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29165', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-3781', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-3783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30511', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-28978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36702', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-4936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28987', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-28991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5079', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5087', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5088', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5090', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2827', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5094', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29253', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36732', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29048', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28079', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2808', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28084', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28086', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36748', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28089', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-28090', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4963', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36752', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-30525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4950', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36736', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-5835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29193', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29194', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29054', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-36761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-4966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28100', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-28102', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-29060', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28103', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-28105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-29985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28763', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-29986', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5046', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29224', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29226', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36723', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36729', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36735', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29202', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3809', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5839', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28768', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28774', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-29990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-29994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36441', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36442', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-36448', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36451', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28802', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-36454', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36456', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36457', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36458', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29181', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-3794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5030', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5056', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5058', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36741', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-4961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36750', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-5837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5112', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5034', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5035', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-28087', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28091', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4965', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29056', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-4967', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4975', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3711', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3712', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3713', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28124', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5861', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-3805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28299', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3038', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2908', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-30454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28122', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28126', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30469', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30477', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-4985', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30481', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-28141', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-28143', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30493', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29082', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-30455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3714', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28125', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28140', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30483', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28142', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30487', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3049', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4987', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4989', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29094', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-29096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29205', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29208', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-2921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-4992', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4993', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3744', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4994', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4995', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29092', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4997', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29093', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-3748', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-4862', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4863', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-30070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-36485', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4871', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-36501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28821', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4879', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5147', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5148', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5153', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5864', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-5048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28262', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29237', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-5870', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-2818', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5849', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-29107', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29111', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5012', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29149', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5159', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5164', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2941', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5167', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29414', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-5169', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-5062', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28828', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-28829', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36516', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2022-29415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29109', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3753', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2913', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29143', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29144', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5264', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29965', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29131', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-5272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5274', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-2914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6492', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5279', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-6493', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5848', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29163', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5099', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5884', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5885', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-28340', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-28342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3951', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2022-29443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28347', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-28348', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28352', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-29446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5197', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3791', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-5027', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5015', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5016', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3771', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-29160', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5018', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29174', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5026', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5029', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-3799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-5856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6108', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29245', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5089', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29248', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-29249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5093', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5105', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5108', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-5110', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5111', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-30141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5201', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3958', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5204', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3962', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-5221', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5933', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5935', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-28366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3964', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5936', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-5937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5821', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5823', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5824', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29401', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-6111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5299', 3.7, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2019-6530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6534', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5313', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2022-2998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29254', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-29256', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3878', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29192', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29201', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30860', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6624', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5764', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5783', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-5837', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5101', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29270', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5106', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-5113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5114', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2929', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29296', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2930', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28311', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29316', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-30663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6039', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29209', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29210', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5044', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29212', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29213', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-28852', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28854', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4891', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28856', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4892', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28857', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-4893', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-28863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5819', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3808', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5798', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5803', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-6625', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6109', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3976', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-5246', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3991', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-5269', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-3994', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5276', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5290', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5294', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5298', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5299', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5308', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5310', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5314', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29489', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-5316', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5331', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28290', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-28291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3894', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-5115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28292', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5123', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-2922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29216', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30321', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2021-30682', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6045', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29286', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3812', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5041', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29207', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29211', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5860', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5161', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-29408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29412', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2018-5168', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5173', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5129', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-29281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5131', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5828', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6112', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-36629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-36630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36634', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4907', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-28068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36647', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-4910', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-36652', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-36665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4915', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5336', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28430', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5344', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28303', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-5134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29305', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3833', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-5862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6048', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-30519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6116', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5177', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5178', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5180', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3941', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5367', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28440', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-30541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5158', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-30531', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2824', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5057', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3852', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5060', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29333', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28322', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28325', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-30530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29435', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2022-29437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29441', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28351', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28353', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5196', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5912', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5913', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5918', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-5919', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-5920', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5925', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5207', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29454', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-5214', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5215', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3963', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5938', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28369', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-5226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5227', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28372', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-5943', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5229', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3967', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-6118', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2942', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5855', 3.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-29423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29424', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29186', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-30052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30059', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-30062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6564', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29202', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-30115', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5061', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-5946', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3968', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-5956', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-30536', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-5182', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3944', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-5886', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5887', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29439', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-5187', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28349', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28920', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-28923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30246', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4927', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-28948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4930', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4931', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-28960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-28965', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6633', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5063', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5868', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4049', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28488', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4072', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5166', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5170', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29424', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5176', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5881', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-29210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30127', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-30616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2922', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29261', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29273', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29277', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6582', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2023-29288', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-6588', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6592', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-5328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5332', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29290', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3016', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5068', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28261', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-29236', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29240', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5080', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5082', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5085', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5086', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29243', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-29434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30522', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30524', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6121', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5203', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5206', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3961', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5926', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5208', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5211', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5213', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5927', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5928', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5217', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5930', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-5931', 5.8, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2018-5219', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29458', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-28360', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5277', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29470', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5291', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5295', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29479', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-5301', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29484', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-4005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29487', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5313', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5326', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4016', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4017', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2842', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-5987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5334', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-28422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5081', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5083', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5190', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5195', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5915', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2945', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28359', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-3959', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-5216', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5218', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5932', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2945', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-29450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6127', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-29004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-4946', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5102', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5942', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5228', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5944', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-5945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28382', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-5955', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-5231', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5958', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3970', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2018-5233', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3972', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-5965', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5236', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5969', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5977', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-3986', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-29502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5335', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-28425', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4023', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-5337', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5342', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28436', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4030', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-4032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5373', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5375', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5378', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-5379', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5521', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5523', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-6062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28365', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-5225', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-3966', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-2838', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-5230', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28387', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5961', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-3973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5966', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-5968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5241', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5242', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5243', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30537', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5107', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6123', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29035', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29039', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-36727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-2829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5117', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5122', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28295', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3988', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2018-5263', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2946', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2952', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29522', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4042', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-29526', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29531', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-28467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29537', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4047', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-29556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5412', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4160', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29513', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-28285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5116', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5118', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5119', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5121', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5124', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4050', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-28493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4059', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-29578', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4062', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-28503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4077', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-4082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28514', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4097', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2946', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-30934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29464', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-29465', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6130', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5306', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4008', 2.5, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-30539', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-4163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4167', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-5430', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4224', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4230', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5462', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4243', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5464', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4246', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-29598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28603', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-4249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5468', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5470', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4258', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4262', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5476', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28617', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5100', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5555', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5563', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5565', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-5566', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-5570', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30408', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-5580', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5590', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-5989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28428', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-29506', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2951', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5345', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5349', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5357', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4026', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5358', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5359', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5361', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5362', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5368', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5369', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4033', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2018-5377', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4040', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28458', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5389', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2953', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29555', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5390', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-5875', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-36745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28085', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5965', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5985', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29301', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29303', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6002', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6004', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30245', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6013', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6015', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6016', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6599', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6019', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6024', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30633', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-29498', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6637', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3053', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-5991', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-5993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5340', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29507', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4027', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-4031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5374', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29518', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4038', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2023-2845', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5386', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3885', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-5873', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-29522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28312', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29609', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4270', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29538', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28470', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29550', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5142', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5144', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-28313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28296', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2928', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4054', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-28501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4071', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5138', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5143', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5145', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29320', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3911', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4289', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4290', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-28637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4292', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4294', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-29648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4309', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28656', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-6031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4315', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-28659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4319', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30554', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5160', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-3925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5162', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5165', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5172', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-3933', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5174', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3030', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-4186', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4197', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5437', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28596', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28599', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5152', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29358', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29359', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5155', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5407', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4164', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4166', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4171', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4175', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5432', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29368', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-6603', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29321', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6040', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-5175', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5179', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3940', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3947', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-5889', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3948', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28344', 4.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-29442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5892', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28345', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28346', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5188', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6139', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30952', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30954', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5156', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4239', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5663', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-6084', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5198', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5205', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3960', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:H'),
('CVE-2018-5212', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5220', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5223', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5939', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3969', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-28705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28711', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28713', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28714', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4408', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4409', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-28725', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5508', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4413', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5510', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4184', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-4212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-30549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3033', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-30332', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5364', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6047', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-28331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5838', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4170', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4191', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5438', 5.2, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4229', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-4232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4235', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-5957', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3971', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5964', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5967', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5239', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5247', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3982', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2019-5978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3987', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2018-5256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-5983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3990', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-5262', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5272', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5274', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5278', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3996', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3997', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5282', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5286', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5287', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5292', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5296', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-2948', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4004', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-4006', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-5309', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5312', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29488', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28406', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-5512', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4433', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-28759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4434', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28764', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4435', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5513', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4463', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2021-30561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6141', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28632', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29619', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-6016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4284', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28635', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-6018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4286', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-28636', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2965', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29654', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4311', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-29681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5501', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29431', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2019-5883', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5189', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5911', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5917', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5202', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5463', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4245', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28602', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-5466', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5472', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4260', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4265', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4266', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5477', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-29438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5185', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-4976', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-4977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-4979', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30465', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-30471', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28133', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29692', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4327', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28682', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-4352', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28683', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-4354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6122', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-6126', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6130', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6138', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4365', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4371', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4375', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6147', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-28707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4382', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28708', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-4387', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4395', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-29780', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4397', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4410', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4421', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-5509', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4432', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30547', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-30548', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5479', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5482', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28620', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5486', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28623', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5488', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5489', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5490', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4274', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-2863', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4276', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29613', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5498', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29623', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4288', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4291', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-29633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4297', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5500', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4300', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-6025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28647', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4307', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2950', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28427', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2018-5341', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4028', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4035', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-4037', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-2959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6143', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5397', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-5398', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3965', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2837', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-5940', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5941', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-28371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28373', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-28380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5947', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5954', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5232', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3974', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5237', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28399', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5238', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5240', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3980', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3981', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-5971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5248', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5251', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5252', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5253', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5982', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5261', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3993', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29532', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29533', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-28444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29527', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4322', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4324', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28671', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-5503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28673', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4344', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-2973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5505', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2975', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6116', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4353', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-28685', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-4358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4361', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28686', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2019-6131', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6133', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6143', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4369', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-28758', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-28761', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-28763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4436', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5514', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5515', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6163', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2980', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29344', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3037', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3100', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-5875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29656', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2023-29659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6646', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5270', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5273', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3995', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29467', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5279', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30538', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4483', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29816', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-4487', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29819', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-4491', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5517', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2870', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6149', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2871', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4396', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29784', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2872', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4411', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-28724', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-30558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3101', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-2973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6648', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5876', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5870', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-6138', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-28500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4107', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28534', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4126', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-4128', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29735', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6149', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29505', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5363', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5364', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5365', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5366', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5370', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4029', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28442', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28443', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5380', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-5381', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5382', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-29548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6091', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-4459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4465', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29810', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29523', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5384', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29524', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5388', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29757', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29759', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29761', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6152', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-2955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30984', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4129', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4138', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5409', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4152', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4187', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-4511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4526', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-2880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4534', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-4536', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4551', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4555', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-30565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29819', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29838', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5880', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2023-29850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5003', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5005', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29119', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5006', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29147', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-3757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3766', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3768', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28473', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-29557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-5997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-28483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-28486', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28487', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6651', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3114', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-31154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29921', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6654', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-6181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-29712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-4253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5485', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4271', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-4273', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28633', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-28634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31177', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31178', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31179', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29932', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29933', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29934', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3778', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-29168', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29170', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2018-5023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5025', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29182', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-29184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29185', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5501', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-5502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5512', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-5514', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-5519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29350', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4568', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28819', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31997', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6961', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6962', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6963', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31998', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5947', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6965', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6966', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3200', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-31079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6970', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6973', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29737', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29743', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6150', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4528', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4548', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4550', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4552', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4553', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4569', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29821', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-28821', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-4589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4604', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5521', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29830', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29835', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5408', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-6163', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-4597', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-4598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4600', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-2972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5504', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6117', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6121', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2869', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29779', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28693', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4377', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-30557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2976', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-29791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29818', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29820', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29354', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2023-29357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5031', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5411', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5413', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4146', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-30547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-4661', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4669', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4642', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29849', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4649', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4665', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-4667', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4674', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4708', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5528', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5039', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4740', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4756', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-29852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28864', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6070', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6622', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2938', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-6652', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-2986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6157', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6228', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4774', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4783', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29869', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4799', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4811', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4816', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28730', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2875', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28756', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-4445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4446', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6158', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4462', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-6167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4467', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31255', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31256', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6169', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-6616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6075', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5050', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5052', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4749', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-28859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5530', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4763', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-4764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-28877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4768', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28885', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4772', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-4778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2892', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29868', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4791', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4794', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-29918', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29922', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29923', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29927', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31171', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6160', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-4213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5443', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5445', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5454', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5457', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31294', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6663', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-31318', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-4475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5516', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29812', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29814', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-4484', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29815', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29818', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-6175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4496', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6189', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32006', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32008', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-3109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7115', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-7116', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5948', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-4877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6267', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4885', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4886', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4887', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4889', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4897', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5617', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6080', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-4795', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2018-5531', 4.0, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-28933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28938', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28956', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6241', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6242', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4841', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6243', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6244', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6247', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4626', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4635', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4646', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6194', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-4650', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4651', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-4654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4660', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4670', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-28834', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4673', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4686', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4688', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5780', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-5781', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-5782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5794', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6655', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-2998', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31198', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31206', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31211', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4527', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4529', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-4531', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5519', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4561', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-4566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4573', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5520', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28818', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29820', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4591', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4599', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4602', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4606', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-4607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4610', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28823', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2937', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-31083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32013', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31084', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7122', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7123', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31087', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32014', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31088', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32017', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-7125', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-31089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32023', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6974', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3110', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7118', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31081', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-31082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32012', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7119', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7121', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32021', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31090', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-3111', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4908', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28998', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-4927', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-29003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5536', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4932', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4945', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-29008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4949', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-4951', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4954', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-29011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4957', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4969', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4974', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-5538', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-5539', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29032', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4980', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6257', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-6259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6261', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6262', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4864', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4865', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6263', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6264', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4312', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4328', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-28667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-2971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-28672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4338', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28675', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-30555', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28828', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4617', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-4621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4623', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4627', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-4628', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4629', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4631', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4640', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-29846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6191', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4644', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-4645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6195', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30571', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-31213', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31217', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-3122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31220', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31221', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31222', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31223', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31224', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-31225', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-31226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31231', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30577', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-5884', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5888', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-3007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30084', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30618', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31346', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-3013', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-31347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-30130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5890', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28841', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-28843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5525', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3861', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-30521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6285', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6286', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5533', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6290', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6293', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4893', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4895', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4901', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-28993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4909', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28997', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4913', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4919', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31091', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-6975', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5950', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-6976', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-31123', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31092', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31124', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31126', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-31094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6981', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6982', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31130', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6983', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6984', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6985', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6986', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32036', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-4981', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-4985', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5003', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-5004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5013', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-5014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5019', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-5020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5021', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-5543', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5544', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5547', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5548', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5032', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-5550', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5551', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-5650', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5652', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5664', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5667', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5671', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5682', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30578', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-31232', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30579', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2021-31233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31245', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6168', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31352', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6182', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6183', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6188', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6189', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6202', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6206', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6207', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6208', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5953', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-6977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6979', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31097', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2021-32029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31131', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-7159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31132', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6988', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32039', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6990', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5070', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5084', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6089', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5690', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5691', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5693', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5131', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5695', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5697', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28842', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-4703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28845', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-4706', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5527', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4726', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5529', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4729', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28858', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5959', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31136', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7169', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4386', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4388', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2023-28716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5507', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29799', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4414', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-28728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4428', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-2873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4430', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2874', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5008', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5017', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5542', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5545', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5549', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5651', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5653', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5658', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5660', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5661', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5670', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5677', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6328', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5680', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31258', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6171', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6221', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30647', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5898', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6232', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30650', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6233', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30216', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-29856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4771', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29858', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6229', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4779', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4780', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4788', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2893', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4803', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4815', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6236', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28936', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4826', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-6237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6093', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6236', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6237', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31380', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-31381', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-30253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6257', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6263', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3027', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6292', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30666', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-28950', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4829', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4843', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2896', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-6248', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6250', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4851', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6256', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5686', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30587', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-6095', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5886', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-30580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6172', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-4828', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4832', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4848', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6251', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-5532', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-6260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2897', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6265', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4876', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-6266', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6992', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31135', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4468', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4471', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-29813', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4481', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-4486', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-4490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4492', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4497', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2878', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4510', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2023-28785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5518', 4.0, 'CVSS:3.0/AV:A/AC:H/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-4512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4866', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4884', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6292', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4899', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4900', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4903', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-4905', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4906', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4907', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5534', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28999', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2022-31103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32052', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31104', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-31139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7170', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31105', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-31141', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31142', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-7173', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31107', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7174', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32061', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-7175', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7176', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7177', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30667', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6304', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31408', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-30674', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3141', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30676', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6330', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6331', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6097', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-6278', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6287', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-6289', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4890', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4891', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6291', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3037', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-31419', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-30683', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31424', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-3038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31429', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-31431', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-6670', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31433', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-30690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30691', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31439', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6346', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30428', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-30429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30433', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-30434', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31315', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5887', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-31317', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4918', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29000', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4926', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5535', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29019', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-2902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4976', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5540', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2904', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-5541', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4989', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-29053', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4995', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4996', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4997', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5727', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29905', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-29909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30836', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6099', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5109', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-28288', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-5874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7178', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7179', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32062', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7183', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32067', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-7006', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7007', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-32069', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-32070', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-31147', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-32072', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32076', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5964', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32095', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-32096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7188', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7019', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31441', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3044', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-6671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30700', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30702', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6359', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30703', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30019', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-31330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3060', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-31339', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3134', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4955', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4956', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4964', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4966', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-29017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4970', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-2903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4609', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5522', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3057', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6196', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5524', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-4671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30515', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6117', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5210', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-29918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5744', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6338', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-5223', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6378', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6381', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31450', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6396', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31454', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31456', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3210', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-32100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32101', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-31112', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-32102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3115', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5966', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32053', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-3114', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-6996', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-31140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32055', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-7171', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7172', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6997', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-31143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32056', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-7180', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7003', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2018-7182', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32066', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7184', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32068', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31146', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-32071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5665', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5666', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5668', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5669', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5672', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5674', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5676', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28840', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2020-4695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5526', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-28846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6215', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28848', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-6216', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4721', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4723', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4725', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5130', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5140', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5141', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-6101', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29414', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29418', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5854', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5756', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-29933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5763', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29950', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-5234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6454', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30602', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-30604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30083', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30085', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30086', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30087', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30088', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30613', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31345', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-30123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6178', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-5145', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-5147', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-5741', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31463', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-30491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6119', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-28855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-28856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2891', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4786', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6232', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4787', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4790', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6233', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28310', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-3909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5146', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28320', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28321', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6103', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-5779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6455', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6458', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5784', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5654', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5656', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5657', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5659', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5662', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5663', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5675', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5683', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-5688', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5711', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5712', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5715', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5716', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5718', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-2990', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29903', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-5698', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5701', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5705', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2989', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5710', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5737', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5738', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5194', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-2943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5150', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5157', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30861', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6106', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4805', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4809', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6234', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6235', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-29871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4827', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-2894', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-2895', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-2939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5163', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5880', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2023-29439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2944', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-29441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6240', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5216', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2022-2992', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-5220', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29059', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5759', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6442', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5229', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6445', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6446', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2995', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-6447', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5776', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6453', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6457', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30593', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-5731', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30589', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-5197', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29915', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-32718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31390', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31393', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7600', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3272', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31394', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31703', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-32720', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7603', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3140', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-31400', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31708', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-31405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7635', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5804', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-5805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6626', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6627', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6628', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5822', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29400', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-32156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7023', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7201', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7202', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31117', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7192', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7021', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7193', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32132', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7194', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32134', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32135', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7195', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32136', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32137', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7196', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32138', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32139', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32142', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32157', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-7197', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7198', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7203', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30629', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-6180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6184', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3017', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6185', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-30172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6187', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6191', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-30184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6194', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6197', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6198', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6200', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5893', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5894', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-30191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30640', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6205', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-5882', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-2943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29434', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-2834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5184', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28341', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-3950', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5909', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-5910', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5200', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3957', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-30591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31476', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30518', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6678', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-6474', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6475', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30747', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30527', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30529', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-30749', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31498', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-31499', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-30533', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31508', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6499', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5827', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5829', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5830', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5831', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5832', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5833', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5834', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30503', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30508', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-5836', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5842', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5851', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6114', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-29454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7637', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32724', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-31415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7638', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7201', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7639', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3143', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-31722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7640', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7641', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32725', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7211', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7642', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31723', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7643', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6396', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-5968', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5969', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-7204', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31120', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7205', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5970', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-7208', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31122', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7209', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7025', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32238', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5206', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2020-5209', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5217', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-5749', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6340', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5752', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6223', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6226', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6227', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30207', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-30210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6234', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3024', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6258', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3139', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-30262', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6265', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5249', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-5981', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-3989', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-5258', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5268', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5271', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5275', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29471', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-3998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-3999', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-5283', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5284', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5288', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5289', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5293', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29480', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-29483', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5307', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5311', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2949', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4014', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-29491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6635', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5761', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29934', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6443', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-5762', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6444', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-5231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5778', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6459', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5782', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5786', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5250', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2023-29084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5258', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2018-5803', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31123', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7211', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7213', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5973', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7026', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32268', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7226', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32275', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7029', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5989', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32285', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5990', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5991', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32288', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7032', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31519', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31520', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6514', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6517', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3055', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-30551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6524', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6679', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-30763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30768', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30571', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-30576', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6532', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6535', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31553', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-30517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2941', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-6294', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6295', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6296', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4896', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-28986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4914', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4920', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4925', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29002', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-29004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4934', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4941', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4944', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2950', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-6128', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6323', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6324', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6328', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31411', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6332', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6334', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6335', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31417', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-6336', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31420', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-6337', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31432', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-30394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30687', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-31435', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31436', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31725', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31726', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7212', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-7644', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7649', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32727', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7213', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7650', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7214', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7651', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5254', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5255', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-5256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5257', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-29094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5804', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6472', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6473', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5259', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2018-5806', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5261', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-5811', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29109', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-5813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29111', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5268', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-5815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29130', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-5816', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5817', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29132', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-5818', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5327', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5329', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4015', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5992', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31131', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-32294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7033', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32299', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7034', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7035', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6015', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5799', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2909', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-29093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6540', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-30607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6543', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6020', 5.5, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2019-7040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6021', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32419', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-29509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2951', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-30533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-30431', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30437', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6357', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6358', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31444', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-6360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6362', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31445', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-6365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31446', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-6372', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6673', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31748', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3146', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7653', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7654', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32729', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-31753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7658', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7659', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7660', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7662', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7663', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-7665', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31466', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32731', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7666', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-31467', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7215', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-7667', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7216', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7668', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7217', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7669', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6474', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29101', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6481', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29108', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30597', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7210', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7212', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5972', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-32263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5974', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7219', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32269', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7225', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32270', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31128', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-5977', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32271', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32272', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32273', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5978', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5982', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32276', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5983', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-32277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5985', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-32280', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5986', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5987', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32282', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5988', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-32283', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7030', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6486', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-5265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5275', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-29140', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5280', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5283', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-6501', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6507', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29973', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2915', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-29977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30538', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6380', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6389', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6392', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6502', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5284', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29151', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2916', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29160', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5293', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-5295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5297', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-5300', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5303', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-5307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7218', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7673', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7219', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7674', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7675', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7220', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7676', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30626', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5916', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-30780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30783', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30786', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6557', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30630', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-6558', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-30631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30787', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6560', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6563', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3064', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6577', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31597', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2018-6587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6609', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6498', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6499', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6500', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6508', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5288', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-6510', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6512', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-6514', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29158', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-5291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6523', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5302', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-5305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6539', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5323', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-29999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6544', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-30003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30017', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30034', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2019-6554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6556', 4.7, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2022-30045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29192', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-30065', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30076', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29203', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29207', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-5552', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5559', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6058', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-6060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32434', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32435', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32437', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31149', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-6071', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32441', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32457', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32458', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7044', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-32459', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-31171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-6089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32460', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7045', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32461', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31172', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2020-6096', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6101', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-7046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6131', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6521', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-5301', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5321', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:L/A:H'),
('CVE-2019-6541', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30028', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6555', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29189', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-29193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-30067', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30117', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-30121', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30123', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-29532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28469', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28472', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6012', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6536', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6537', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6610', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3066', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5917', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6626', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6629', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6631', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6644', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6656', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-30677', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30678', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6667', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30842', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30852', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-30612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-29240', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-6575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29282', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29286', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5860', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6640', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2850', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2020-4060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2020-4061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4076', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2020-4079', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-4081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4083', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-4092', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4095', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-5392', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-28522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28529', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4100', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4102', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5403', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4125', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-30546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29198', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-29199', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-30110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30111', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29201', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-30604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5702', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5704', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-5706', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29891', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5714', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5730', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-29907', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5196', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31457', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5911', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-30471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31461', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31469', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-30124', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-29214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29245', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-29246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6576', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29275', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6590', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6591', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30540', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29529', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7221', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31801', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7677', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7678', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31804', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31806', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7223', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7680', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31472', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31473', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-7681', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-31820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6634', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30527', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30731', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31472', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6459', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-31478', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31479', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30519', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-30740', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30742', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6472', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30745', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6476', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31488', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31489', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30748', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31500', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6494', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-6496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31506', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-30535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6506', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-30545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30547', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30548', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30552', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6521', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6674', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6686', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-31684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31693', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2018-6705', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6707', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6759', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6765', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6766', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6768', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6770', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6773', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6782', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6785', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29471', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29479', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-2948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29534', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7682', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7683', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31476', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7685', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32741', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-31842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7686', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32742', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-7687', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30171', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30172', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5926', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6791', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6796', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6799', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6824', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6829', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5342', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5345', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-29293', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-29294', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-29295', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-29296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-29297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29299', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30174', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5358', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6595', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5359', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2018-5927', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-4172', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5434', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4190', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5435', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5436', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4199', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-2858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4205', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-4206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4209', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-28597', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-4241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28600', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-4244', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31540', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-30557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6525', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31545', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30562', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-30563', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-3076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30564', 4.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-30760', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30565', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30769', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-30575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3155', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6533', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6534', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-30591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7688', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-31848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7689', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7690', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7691', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32744', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6116', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7048', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31192', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30744', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-30745', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30749', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-30751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3092', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30757', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31804', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29276', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5867', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29537', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5869', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-29538', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-29539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31140', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-6023', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7041', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6024', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31143', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6059', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-6061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32436', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32438', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32439', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32440', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-31169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-3246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6092', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6093', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6100', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-6102', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-32466', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6103', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-6104', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6105', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5205', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-29914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5743', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4257', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4264', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29603', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5481', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5487', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5492', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6008', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29612', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5497', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28630', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29614', 4.7, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2022-29615', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-4278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6017', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4283', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-29627', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-4285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-2963', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28638', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28640', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30181', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-6536', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31554', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-6541', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6545', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6546', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30609', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-31559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6547', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-30610', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30611', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6548', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30613', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-30614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6552', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30618', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6636', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-29501', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-29503', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30531', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6129', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5218', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29925', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5751', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6341', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5753', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6439', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5754', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5225', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-5755', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5758', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29944', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-29067', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5772', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5773', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6456', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-29959', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-2996', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-29960', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6596', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30187', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5954', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5957', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5962', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6597', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5993', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5996', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6001', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29308', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31812', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6716', 5.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2022-30957', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31828', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-30961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30975', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6834', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31842', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6849', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-6852', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6856', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31199', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7053', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6150', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31163', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6155', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6162', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-31213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32498', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-7055', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6165', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-31220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6166', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-31221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7057', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31175', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6168', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-6171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6106', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-31178', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-7047', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31150', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-6107', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32472', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-31151', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-3118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6112', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6113', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32473', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6115', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31186', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31154', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31155', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-29542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31567', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-30622', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-29650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4301', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-28646', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30239', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6006', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6008', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6010', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6598', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-30257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H');
INSERT INTO `tpandora_cve` VALUES
('CVE-2018-6029', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6754', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6757', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6876', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6758', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6882', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5929', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6900', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6905', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31876', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2020-5247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2908', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5798', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5252', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30596', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-3119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31156', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31194', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32477', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7051', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31197', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7052', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32483', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31178', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6175', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-31179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6178', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-7058', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31239', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31182', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-6188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31241', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-32519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31244', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31185', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31186', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6203', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-6204', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6206', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-31187', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6212', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-6213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-30951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6910', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6767', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6771', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6774', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7692', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32745', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7698', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7700', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32746', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7229', 6.0, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-31862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3187', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-31871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32748', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3188', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-3189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7233', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7234', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-7235', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3190', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-32749', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7236', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7237', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-29298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6149', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32489', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32490', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31207', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32493', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32495', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-32497', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-6157', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-31167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-31218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7056', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30630', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-30788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31581', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6574', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6576', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6579', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6580', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6581', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6584', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6586', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6592', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6594', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6606', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31609', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6622', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-6625', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6627', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30804', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-31618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6654', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6655', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30676', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6660', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6678', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-31674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6683', 6.0, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-31678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6687', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5920', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6690', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-31682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6132', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-29310', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-29311', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30288', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29312', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29314', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30292', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-29315', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6034', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-7239', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7063', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6224', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2020-6226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7251', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7254', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6232', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-31195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6238', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7265', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7268', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31290', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6244', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7271', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7711', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7238', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32751', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7712', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7713', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31913', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31914', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7714', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32753', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-7715', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7716', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31916', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32754', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31918', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31919', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7717', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7718', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7249', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3192', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-7250', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31920', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7719', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31921', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7251', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7721', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7722', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7723', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7724', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-31172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-31222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31176', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-6173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-31228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6181', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-6183', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-31180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7059', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-6191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6197', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6199', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-31246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29528', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-30545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-29711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6109', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-29720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6110', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-4346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4347', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-6111', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-28681', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-6114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6755', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6757', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6758', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31739', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6776', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6777', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31747', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-6786', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6790', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6795', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2018-6806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6822', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30736', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-30737', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30740', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-31794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31798', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6256', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7068', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32553', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6260', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6261', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7069', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7279', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6268', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-6269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-32556', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6271', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-7281', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31406', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7070', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6276', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32557', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-6281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6287', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-32558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6488', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29137', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5276', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5277', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6491', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6494', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6497', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5287', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-29975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3060', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6513', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-6515', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6516', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-6519', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6208', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-6209', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6214', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-6215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6218', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-31190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6220', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7247', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7253', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7259', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7064', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7260', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7261', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32537', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-6235', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-7262', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5963', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5863', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-5864', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5865', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-5866', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6290', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-32559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7285', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6293', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-6295', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7286', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7289', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-6298', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7290', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7073', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6301', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-6302', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7074', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6306', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7302', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7303', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-29750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-30556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30763', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30935', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5923', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-30943', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31810', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2018-7263', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6239', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7066', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7269', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6245', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7272', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3131', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6250', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6252', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6033', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7725', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7726', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7727', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7728', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7729', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32760', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-7730', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7731', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7732', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32761', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7733', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7737', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-31941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7738', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7739', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32764', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-29541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30552', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29544', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31815', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30949', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31818', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-6719', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31822', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29569', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29570', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29571', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29580', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29582', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29583', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2961', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-2962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29623', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6144', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29317', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29318', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-29319', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30295', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-6602', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30298', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6035', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30802', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6961', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6964', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6965', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-3101', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6966', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-30837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6967', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-30838', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-31013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31014', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-7304', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6314', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-31410', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7305', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6315', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-31411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7075', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6317', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31216', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6320', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7307', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7313', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6331', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6332', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6335', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-31218', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7077', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-31219', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6345', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-32575', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-32577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6140', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6042', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-4381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30973', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30974', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30976', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-6738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3098', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-30981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31836', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-31837', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31838', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30774', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30775', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-30776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6746', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6846', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6851', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5928', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2018-6862', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6863', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6867', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6869', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-30789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31853', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6601', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29313', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29316', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30297', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30302', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-30303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6037', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3195', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32766', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-29984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29167', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-29986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6350', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-7323', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7324', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7325', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6359', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6360', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6361', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-32581', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-6362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6363', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-32582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7328', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32585', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6369', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6376', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7331', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32587', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7333', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31015', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3084', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-6971', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30841', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6790', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6974', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6976', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6978', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5377', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-30349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5386', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6644', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2023-29573', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29574', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29575', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29576', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29579', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6145', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31857', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6872', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31859', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6879', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6880', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31865', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-6760', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31866', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6889', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31868', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-6762', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6892', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6763', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31972', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31973', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31974', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31975', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6547', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29175', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-29178', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-29187', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29188', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30058', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29194', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-30603', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29581', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29596', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6041', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-29731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29738', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2974', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-29742', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29749', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-2975', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-29753', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29766', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29767', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2977', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-29774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6649', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-6650', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-6153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6904', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6765', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6912', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6914', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6769', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30322', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-6043', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7740', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-30857', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-31032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6795', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-31035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31036', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6797', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28729', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5511', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6572', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-30621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29260', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-2927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29287', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6589', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6267', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-31404', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2018-7280', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6273', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6280', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-6284', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-7071', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6288', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-7284', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6046', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6799', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31039', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6803', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-30877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7032', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7035', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31906', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31907', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-7047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31908', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7049', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7741', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3198', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-31981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32768', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7747', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7748', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3199', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-32769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7749', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7272', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7751', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7752', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6147', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6294', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-32560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7287', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6297', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7295', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31214', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6308', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6310', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3141', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-5390', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-29333', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-5399', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-30698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5401', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-31045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6827', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31046', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7064', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7065', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7066', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-7067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5404', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-5405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5411', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6610', 4.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-5414', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2018-6054', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7753', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7276', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7277', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7278', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-32776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7279', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-31488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32777', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-31493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-3146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31461', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32594', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-7405', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7089', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7407', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7090', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-7409', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7091', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7092', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7093', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7417', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7418', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7419', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32598', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7095', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7420', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7421', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7422', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7097', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7098', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29722', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-29723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29725', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29726', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6647', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-29732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29745', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-29751', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29752', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29756', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29758', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-28776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4498', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4509', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-6187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30367', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-5392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29335', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6594', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30184', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5956', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30192', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-30193', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5961', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5964', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5968', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29857', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-2987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2989', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-2990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2991', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3115', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31153', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31155', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6159', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-4546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4556', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-4562', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4565', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4572', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5403', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6052', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-6321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32568', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31413', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7308', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6322', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-7311', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7312', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6327', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6328', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-7076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31217', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7316', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7317', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-7318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6338', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-7319', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6339', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-31423', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7320', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6342', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-7321', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-7078', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7322', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32576', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6347', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6349', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-32578', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7079', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-32580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6352', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6353', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6354', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6356', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-6358', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-7326', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3143', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7327', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7080', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6364', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-31433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6366', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-31435', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7329', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7081', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30943', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-30945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-30952', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-31059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31937', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-3097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30985', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30986', 0, ''),
('CVE-2023-30988', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7092', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-30991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31948', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-30993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31949', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2023-30994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-31950', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-3100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7282', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32779', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-31497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29835', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6608', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5987', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5428', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2019-6611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5520', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5522', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-30734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6613', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5526', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6055', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5425', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:H/A:H'),
('CVE-2020-5426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30720', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-6057', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2995', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29950', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-2996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31207', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31209', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-3121', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2018-6164', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-30635', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-30637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30277', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-30279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30640', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2018-6032', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6371', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7330', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6373', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6374', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7082', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7332', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7083', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31437', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31438', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31439', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7334', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31441', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7084', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7335', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7336', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7337', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31445', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31448', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-32591', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31449', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-32780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7283', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-32781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32782', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32783', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:H'),
('CVE-2022-31500', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31060', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31062', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31957', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31014', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-31065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31066', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-31068', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3102', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7108', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31963', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2021-31964', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-31038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-7110', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7111', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5944', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-31043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32610', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7432', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29353', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5529', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29356', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6158', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31450', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-31452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7365', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32593', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-31457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31468', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7408', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31978', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6956', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-31056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30293', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30654', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30381', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-30384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6061', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6166', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30757', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-30758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7448', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7449', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7453', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7456', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7463', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7465', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32624', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7466', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7469', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7470', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7113', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7471', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7472', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7474', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7114', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7477', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32628', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7479', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32629', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-7485', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7116', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4687', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-28838', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-4696', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4699', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-28849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-4722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28850', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-28851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6217', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4739', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6221', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31259', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31260', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31261', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31262', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5885', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31172', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2021-31173', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31174', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31175', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31176', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29935', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29939', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29941', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29942', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6162', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5538', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5539', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-5540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6614', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-6063', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29320', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29323', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5574', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-30400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31502', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32787', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31503', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32788', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6066', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5554', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-5558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32632', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-7486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7487', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32635', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-7489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7117', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7490', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3124', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-32637', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-7491', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32638', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31243', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31244', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32639', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-3264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7118', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32640', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-7119', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31246', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4765', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-28879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6227', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-28892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7099', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7100', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7101', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7429', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7102', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7103', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7431', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7104', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7105', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7106', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32612', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7434', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7435', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32613', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32614', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-7436', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7437', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7109', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-31504', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2018-7763', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-31505', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2018-7764', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-7765', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31506', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2020-6402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6067', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31071', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-31072', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5945', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-31073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6069', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31214', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6658', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-7438', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32617', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7439', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7440', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7110', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-3262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7441', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7442', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7443', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7111', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7447', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7452', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7454', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7455', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32622', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7112', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-5586', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5593', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6954', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6957', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6958', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31006', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6963', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5585', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6071', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6958', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31989', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31065', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31066', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-31076', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7495', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32647', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-7496', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7121', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32648', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-32649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31253', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7122', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7123', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32653', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31507', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2018-7768', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7290', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-7769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7770', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-31509', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2018-7771', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7773', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-7774', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3151', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-31510', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2018-7776', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-7777', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31511', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31512', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7295', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31513', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31514', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7296', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31515', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31516', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31517', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7299', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31518', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7300', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31519', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7301', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31520', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31521', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6167', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-6787', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31889', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-5931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4871', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-4873', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4875', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-4882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6076', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-7125', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32654', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31260', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-31261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31262', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7501', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32655', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-30840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31522', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31523', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31524', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2020-6403', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-31257', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6170', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31263', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-7502', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5604', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6979', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-3085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31025', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-30850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6981', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30851', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6983', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-31028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6665', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2021-31320', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-30597', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29986', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-2999', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31321', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-30598', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31322', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-29995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29998', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31323', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6175', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5614', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6078', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-5628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6618', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6082', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-30585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3130', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6173', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-30339', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5383', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-5384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5385', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6606', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-7476', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32627', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31233', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7482', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7484', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5610', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-5934', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31030', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30856', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31034', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6800', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6802', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6804', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31900', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-30876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7033', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7046', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32657', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-7503', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3127', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-32658', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31282', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31285', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31287', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-4967', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-4968', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5537', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-4979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2905', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-4994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2988', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-31338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6176', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29337', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29338', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-6050', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-31525', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7307', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31526', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31527', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32791', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31528', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31529', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32794', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32795', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32796', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-5639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31319', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6177', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-5625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5632', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6193', 2.7, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6201', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6204', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6209', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30643', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6217', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6218', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30645', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6224', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30649', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6231', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6085', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7493', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32642', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2022-31247', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-32643', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-32644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7494', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7120', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31306', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31307', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7505', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7506', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6090', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6179', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6235', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30659', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30259', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3066', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-6261', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6262', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6266', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6269', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30269', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-6288', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6289', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6290', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6291', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6293', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6305', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30321', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-6307', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6308', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30671', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6315', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6318', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6320', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6329', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6609', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5415', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2020-5418', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-29340', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29341', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5420', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-29343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5679', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5681', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6331', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-5685', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5689', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5692', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5694', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5696', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29886', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5709', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5713', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5729', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-29906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5734', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-5736', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5144', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5739', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5148', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2018-5740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5681', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30835', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30375', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-30376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29347', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-6056', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32651', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7497', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31255', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32652', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7124', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31258', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7500', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32797', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-7309', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7310', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32798', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-7312', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32800', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-7313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7314', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7316', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5730', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-32666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7509', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-31327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7511', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-3133', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7515', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-7517', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-7140', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7521', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-7141', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7523', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-32676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6192', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-30186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6203', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30644', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6219', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-30199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6220', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6222', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6225', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6333', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31421', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-31422', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-6339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31427', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-31428', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-3039', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30688', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30402', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6347', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7050', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-31909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30902', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7052', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6822', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30904', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7053', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31910', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6825', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7060', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3091', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7063', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6834', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7068', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7070', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7073', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5202', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-29917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32677', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-7525', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-32678', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7142', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7527', 3.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-7529', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6350', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5905', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-31443', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6361', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30450', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-6368', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6370', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30458', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6377', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30707', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6390', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31453', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6228', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6229', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6230', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5901', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-3065', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30226', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6239', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6259', 1.4, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31403', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30669', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30300', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31404', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7075', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7076', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32801', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7783', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7785', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32803', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2018-7786', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7787', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7317', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31484', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31485', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32680', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31486', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32656', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-31266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31268', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7127', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6397', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5908', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31458', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30483', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31466', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30319', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-30320', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-6306', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31406', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6313', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30672', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6316', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6317', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-30330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6319', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30673', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6321', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6322', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31418', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-31423', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-31425', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-31426', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6340', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31430', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-6341', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31434', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6343', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31437', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6344', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31438', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30693', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7144', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6392', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-30501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6443', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31471', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30733', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5912', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-30516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30517', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-30739', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6465', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6469', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30521', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-6471', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30522', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31482', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30523', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31484', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31485', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31487', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6480', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6484', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31490', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31493', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31495', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3144', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-6352', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6353', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6354', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30696', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30697', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31442', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5569', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6068', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-7504', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3128', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-32660', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-31290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-32661', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-31295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7128', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7129', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7130', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5674', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6094', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32804', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-7319', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2019-7321', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7323', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32806', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7324', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7793', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:L'),
('CVE-2019-7325', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7326', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7327', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7328', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7329', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32809', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7330', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7331', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7332', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3281', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7333', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7334', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7335', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7336', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-5747', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6339', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5750', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-29939', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5777', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5780', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-5781', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6460', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-5783', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5240', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:H/A:N'),
('CVE-2019-6465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30594', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5753', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5774', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-2939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7546', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32696', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7548', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32697', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7155', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30530', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6485', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6488', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6490', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31501', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-31503', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31504', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30536', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-31509', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6501', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-31510', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6502', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6505', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6508', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6511', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5913', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-6096', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6098', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6516', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6518', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6519', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-31539', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6522', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6523', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31542', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6526', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31546', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31547', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31549', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5684', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-6100', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-7549', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7550', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-7551', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7156', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7553', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7554', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32699', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-7158', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32700', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-32701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31597', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-7556', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-31606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7159', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7161', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7162', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-7559', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7507', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31321', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-32665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7508', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31322', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-30846', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7337', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7338', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7339', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32813', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32814', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-7340', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32815', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7796', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-7797', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7341', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7798', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2019-7342', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7799', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7343', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7344', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32817', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-7803', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7345', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7346', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7347', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7348', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7349', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7813', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32820', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-7814', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7815', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7350', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-32821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7351', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-7352', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32823', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-31606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7578', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-6413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6364', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6367', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6374', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-30455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31447', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-5906', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-31448', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-30465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6379', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6382', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6384', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31451', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30849', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29383', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-29385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-31552', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-6537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6542', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6544', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6550', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-31562', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-3062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6471', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-5809', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-5810', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-5812', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5262', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-2912', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6102', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-7134', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7135', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7136', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7137', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7138', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7513', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-31335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7139', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32671', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-32672', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-7519', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-32674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6391', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-6394', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6398', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6400', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6406', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6409', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6410', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6411', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5909', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-30469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5910', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31459', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3146', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31460', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31462', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-30487', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31464', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31467', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-31468', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31470', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6444', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6445', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30510', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31473', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30736', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6458', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30737', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6461', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30738', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-6462', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5740', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5744', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5745', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-6104', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-30851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5749', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5752', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7165', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32703', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7566', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7353', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-7356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7358', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7580', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32938', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-7581', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7587', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7588', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32940', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-7589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7590', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32942', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7593', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-7594', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31609', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32944', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7609', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3161', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7610', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-7611', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-30797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6081', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5835', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-29407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29409', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-5841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-2997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6503', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6504', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6506', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29972', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6585', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6591', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6596', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-31604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6608', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-31608', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-6683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5754', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-6105', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-3052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6466', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6467', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6468', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30741', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6470', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31480', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31481', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31483', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6473', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30524', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31486', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30526', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-31492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31494', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3053', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31497', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30531', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6487', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6489', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6491', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6492', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31502', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30534', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31507', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6498', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6500', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31511', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31512', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31513', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31516', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30540', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-30541', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-3152', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-6512', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6513', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31525', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-31530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6515', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6520', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3075', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-31053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30956', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6854', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3096', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30960', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31936', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2019-6855', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-3048', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6115', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-7359', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7360', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7361', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7362', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7363', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7364', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32827', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-7365', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7366', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32829', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3153', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6083', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32946', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31610', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32948', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7614', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7615', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-32949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7617', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-7618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32950', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-7619', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31612', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-32951', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6628', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6630', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6632', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6653', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6659', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6669', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6671', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6672', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6677', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-5918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7170', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7567', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7568', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7569', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7570', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3134', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7530', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7531', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7533', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31489', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7534', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7535', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31497', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32684', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7536', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-32685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32686', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31518', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7146', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32687', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7537', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-7147', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7148', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7149', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7150', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7538', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5775', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-5777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6107', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-5304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-29982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5318', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-29995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5322', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-30000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5667', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6620', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6088', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6689', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6695', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6756', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3087', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3172', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-6769', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31727', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6772', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31731', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-6774', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6778', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6780', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6783', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3072', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-6787', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31761', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-31762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31776', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6797', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6686', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-6687', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-3073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5809', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6110', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-6092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3153', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-32689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32690', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-7153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-31541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32692', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-32693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32694', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7544', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-32695', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-31568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-30730', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-29376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6621', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32952', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7621', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7628', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7629', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7634', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31613', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-31614', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7635', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-32958', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7636', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-32960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31615', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5825', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5826', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6630', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-30611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30126', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-29211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30128', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-30130', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-29218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29241', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29242', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30159', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-29259', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5806', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5820', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-2940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-7562', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7167', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7563', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7168', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6394', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-6577', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29279', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-29280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-29283', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6593', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5331', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5333', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-2929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32963', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32964', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-31999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32965', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7639', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3200', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-32000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31616', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-7646', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32969', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7648', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7649', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7651', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32005', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7652', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-7653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32972', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-7655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32975', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7659', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7660', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31617', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5915', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30773', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30774', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30775', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6556', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6395', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7171', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31342', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-32707', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-31343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7572', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7573', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7172', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7173', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32708', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7575', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-31620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7576', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31530', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31531', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31532', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31533', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31534', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31535', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32833', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-6407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6561', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30790', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31583', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31585', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6578', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6583', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3065', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6593', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31600', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6605', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6612', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-31607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6616', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6617', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6618', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6619', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6632', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7661', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31618', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7663', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7664', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7665', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7668', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7589', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7590', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3168', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31386', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-31698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-5958', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31615', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6633', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6634', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6635', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6643', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30672', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30673', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-30825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6664', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6668', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3084', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6670', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3085', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31358', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-7577', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-31624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-7579', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7581', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7582', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31363', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31364', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7583', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32712', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-31631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-31655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7176', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-31536', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7392', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31537', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7393', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32836', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31538', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31539', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3154', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:L'),
('CVE-2019-7395', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31540', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31541', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31542', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2018-7817', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-29305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29309', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6005', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6693', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2021-3169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30703', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-30704', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30705', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6764', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6767', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6771', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6775', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6779', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6781', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6784', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6788', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6794', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-6685', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7858', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8371', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7859', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8372', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8373', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31543', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31544', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31545', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32841', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-7821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31546', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2018-7822', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32842', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-32843', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7823', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-32844', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31547', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32846', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31548', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32847', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-31549', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31621', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7671', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-7832', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7835', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31372', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31669', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32714', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-3167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7584', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-31671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7181', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7586', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7587', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32715', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-31672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7588', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-31677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-31678', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3285', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3155', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7400', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31550', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32850', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31551', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7401', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7870', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8428', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8429', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8432', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7873', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-32162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32163', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7874', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-8447', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8448', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-8452', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-7875', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33430', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8819', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33436', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8820', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7986', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33438', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7987', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7988', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7990', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7991', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33441', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7993', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33443', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7994', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7995', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33445', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7981', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8802', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30734', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3090', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-30904', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31795', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31797', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31799', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30754', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-6689', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30944', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30945', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-30946', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-30947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-30641', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-30642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30286', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-2931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33005', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-8518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6529', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-31805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3301', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-31813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3182', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8374', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7860', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8375', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8376', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8378', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8379', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8380', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7836', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7676', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31622', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7837', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7677', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7678', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3201', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-7684', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31623', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7690', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7692', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7861', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8381', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8382', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7862', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8385', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7863', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8389', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8456', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7876', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8457', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-31830', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34429', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6531', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-6699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31814', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2019-6702', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6703', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6708', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6713', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6714', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6724', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6726', 4.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2022-30958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7693', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7697', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7698', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31624', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7699', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7839', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31625', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7840', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7841', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8000', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8825', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8001', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33459', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33460', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33468', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8832', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8837', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32852', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-7402', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31552', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7403', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7409', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32853', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-7410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31553', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7411', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31554', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7413', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7416', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7417', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31555', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31556', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7422', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7423', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7424', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31557', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7426', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7427', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31558', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7429', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7430', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-31559', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7431', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7432', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7433', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7434', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7435', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7436', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-3181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-5924', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-6690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-6691', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6692', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31811', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-6695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6707', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33462', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33464', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33465', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33467', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8834', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8835', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8390', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7864', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7865', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33135', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8403', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7866', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7867', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8412', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8415', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8416', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8421', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7869', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6444', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2018-8479', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-7886', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33184', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2018-8488', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7887', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-8491', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7888', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-6533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9192', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9193', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3501', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-6715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-31820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31821', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-30971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31833', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6744', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31839', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6842', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6748', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31850', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-30785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6868', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6870', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31854', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6756', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6843', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6844', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6749', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6853', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6854', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6855', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6857', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6752', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-6859', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30782', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6753', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6604', 4.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-33479', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33480', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33481', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33483', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7896', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8518', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8527', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8529', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3218', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8531', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33197', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-32181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8532', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8533', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7437', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31560', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31561', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31562', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-3287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31563', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7441', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7442', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7443', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31565', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31566', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-7476', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31567', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31568', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6878', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6883', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6888', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6761', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6890', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6902', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31874', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-6766', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6913', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6768', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8873', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8874', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8875', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8876', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-29328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30323', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2019-6605', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-30333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5367', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-30689', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3034', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-3502', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34339', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9194', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3434', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-34340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9196', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-34341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34342', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-34343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9199', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9200', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9208', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9209', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9210', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9211', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9212', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34355', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34357', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31864', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-6881', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31628', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-8427', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8430', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8431', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7872', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-3216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33144', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-33150', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-33152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-33156', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33158', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33161', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33122', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3190', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33128', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3313', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33133', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6770', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6772', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-6773', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-31884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30791', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-6775', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6776', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32265', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3349', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-8881', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8889', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33497', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-32270', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32273', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32275', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8896', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33501', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-32281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8897', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8899', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32303', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8918', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32310', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-33516', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2018-8922', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32313', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7718', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7719', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7720', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31630', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2019-7721', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7722', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7858', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7727', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7728', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7729', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7730', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-7731', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7732', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7733', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3503', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3436', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-9214', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9217', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5389', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-29330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6607', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-29334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-6049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-30990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6777', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6778', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6779', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-30795', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6927', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6928', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6780', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-6930', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-30993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6781', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-6934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6935', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-30994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6940', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-30995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-6942', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-6943', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33505', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8900', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8901', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8902', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8904', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8908', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8909', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8910', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8911', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8912', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8913', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8915', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8916', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8917', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8539', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8540', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7898', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8546', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8552', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8558', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7899', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7904', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8567', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-8568', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7908', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8570', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8572', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33214', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:H'),
('CVE-2018-8573', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8574', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7909', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8575', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8576', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8577', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8578', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8579', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7911', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8580', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-8581', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-8582', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7912', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8924', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8925', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32318', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8942', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8949', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-32323', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-6464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31571', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7487', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7488', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31572', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31573', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31574', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7524', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7535', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31575', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7537', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31576', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31577', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31578', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7539', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7541', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7543', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31579', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-3158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7544', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31580', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7545', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7546', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7547', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7548', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31582', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2020-6411', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-3451', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34518', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6051', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34553', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8587', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8597', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7913', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8598', 3.6, 'CVSS:3.0/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-33220', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8599', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8602', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8606', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8607', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7921', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32201', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8608', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8919', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32311', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-8920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8928', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34532', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-34539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6053', 1.4, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-32917', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-31583', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2022-31584', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31585', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2021-32919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31586', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7549', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31587', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:L'),
('CVE-2019-7550', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32921', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7551', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-3159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32923', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31591', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31592', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-32925', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-31593', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7554', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7559', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31596', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2022-31597', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-7560', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7566', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7567', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7568', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7569', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7570', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-32929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3293', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3160', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6412', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-34362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9218', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9219', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31966', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-6539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5421', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:H/A:N'),
('CVE-2021-33256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7926', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8625', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8627', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8628', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7927', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8631', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8635', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8636', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7928', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7929', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8643', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8650', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8651', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7931', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8652', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8653', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8710', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7932', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34965', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35309', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7231', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3531', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-35312', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3532', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-35323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-34967', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-7737', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7738', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-7866', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-32985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7867', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7739', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7868', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7869', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7870', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7740', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7741', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7871', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7872', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7742', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7873', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7743', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7874', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7875', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8995', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8997', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9007', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9014', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9017', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9025', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32351', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9034', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9040', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9043', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9047', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9049', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9005', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-9021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9024', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-9026', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-9027', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9028', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9029', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9031', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32353', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9035', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-9036', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9037', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-9039', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9041', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9042', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9044', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9045', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9046', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9048', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5513', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-2935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9220', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3438', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7876', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7744', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7877', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-7884', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7747', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-7886', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7748', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7889', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7753', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7890', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-32990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-6944', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6782', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-30998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6947', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-30999', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3100', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-6948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-31886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6952', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31000', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-3080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-6953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33181', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33182', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-8596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33184', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-33185', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-33186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33188', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8598', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31973', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-31974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7877', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8459', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8460', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8461', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7880', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7881', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8465', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7882', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8466', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8470', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8474', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33181', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-33182', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7889', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8498', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7890', 3.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-8501', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8502', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7892', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8504', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9221', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34394', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34395', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9222', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-9518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3533', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-35344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7251', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9050', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9051', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9052', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9053', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9054', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9055', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9057', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9058', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8052', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-30804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6962', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3083', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2022-31011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9223', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34410', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-34411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9224', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8602', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33200', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33201', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8608', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2019-7758', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-32991', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-7891', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7893', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7894', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7759', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-32995', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33195', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2018-8517', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8522', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7897', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8524', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9063', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8053', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-32370', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8058', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-6470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8056', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6969', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31890', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-5932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31891', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6970', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6789', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31017', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-6973', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-30843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-32930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-32935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32936', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-5572', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-5573', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-6615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8711', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8712', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8714', 4.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2018-8715', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8716', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3221', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8717', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8718', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8719', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8721', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7934', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3328', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-35037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7004', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-7252', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-35361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7253', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9543', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9544', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7255', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-9545', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3537', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7257', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-35377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9546', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9547', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7259', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7261', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-35380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9548', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-7262', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7264', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2019-9549', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9550', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7265', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2019-9551', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9552', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7266', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2020-7267', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2021-35393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7268', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7269', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7270', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9557', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7273', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9558', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7275', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-9563', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7276', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7277', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-35413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-35414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7279', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7281', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-9565', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-8063', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6975', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-6977', 4.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-30847', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2023-30848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-6792', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-6793', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2018-6982', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-31029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3086', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-33213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3322', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-33224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35936', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35937', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9847', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35938', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7570', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9849', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7936', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32212', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-8729', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-32999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7761', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33003', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33004', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3504', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2019-9225', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9226', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9227', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34414', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2018-8732', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8733', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8734', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8735', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7938', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8736', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8737', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7939', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-6796', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-31897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5935', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9101', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9104', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9105', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9106', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9107', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7282', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-35415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3497', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8740', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8741', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3332', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33320', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-32221', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7940', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7941', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8754', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8761', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8763', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33324', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7573', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-35939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3594', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-35940', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-9852', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35942', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-9853', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31905', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7762', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8072', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-9108', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34418', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3505', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7016', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-35052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7017', 5.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2023-3442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7903', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3457', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-3329', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-33290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33291', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-8638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34572', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-33298', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34574', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-35943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7579', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9854', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35944', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3531', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34421', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-34422', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-7019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7020', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34432', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7030', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7763', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7764', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35947', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7583', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7585', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35948', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-6073', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9118', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9121', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9123', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9128', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-32402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-9113', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9116', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-9117', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-9130', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9133', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9135', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9136', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9137', 4.0, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2018-9138', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9144', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-9145', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32409', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2019-8096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7058', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-5938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7069', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7071', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-31918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7072', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7074', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7077', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7079', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-30944', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-31050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-5939', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7931', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-7765', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7932', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9566', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7283', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-34970', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3543', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9570', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9572', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3544', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-9573', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7288', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9574', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9575', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9576', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7290', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35449', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9578', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9579', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-34976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3545', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-9580', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7292', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-9581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7293', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-35451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7294', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-35456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9587', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9588', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32231', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-33330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-32232', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-7947', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-7950', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8778', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7951', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7953', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-33335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-6617', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-8604', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7915', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35062', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7032', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-3444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35065', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7037', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-7038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7039', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-34442', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7040', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7041', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-34449', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9163', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9173', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9174', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9205', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33563', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-31923', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-31924', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7083', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-30961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-30963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-31939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31940', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-31941', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-30987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-30989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7090', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3099', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-7091', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35949', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-5620', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-5623', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-5626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-33311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7767', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3202', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-33022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7768', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7769', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9161', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9165', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9169', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9182', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9183', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9186', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-6079', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8609', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33235', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7925', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8619', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-7930', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7295', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-9589', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3546', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-35463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7296', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9594', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35469', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7297', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9595', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3547', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-3499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7298', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2021-35472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-34992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7299', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9598', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-34993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9599', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34994', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7300', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-34998', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7301', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-9600', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9601', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9603', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-9604', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9605', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2019-9606', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9607', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9608', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7303', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-3500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33570', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9230', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9233', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9238', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-9245', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3595', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-7587', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2019-9864', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32027', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7770', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32028', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33031', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-32029', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7771', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6425', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-32236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7956', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8780', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-33348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7960', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33351', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-33352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33354', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-7963', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7588', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-9866', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9867', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9868', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9870', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7042', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3507', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-7043', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-34450', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34451', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-7045', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7048', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-34455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33593', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9251', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9252', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9259', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33602', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-9260', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9263', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8113', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9264', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9265', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9269', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9270', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7592', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9872', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35958', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-9873', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9874', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9875', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7598', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-7599', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9877', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9878', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9879', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7600', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9880', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-7601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9881', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31064', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7109', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-31966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-31042', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-8105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9243', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32427', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-9250', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33596', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2019-8110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9261', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9262', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33604', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-33605', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-33609', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-3203', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-32030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7772', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32032', 5.5, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2019-7773', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9609', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9610', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-35002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9611', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-35005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7304', 5.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2023-35009', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35011', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-9612', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7306', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2019-9613', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35013', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9614', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9615', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7307', 2.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2023-35018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9616', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35024', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2019-9617', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7308', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-7051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34458', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-34459', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3446', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-34460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3508', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34463', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-33371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33387', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-33388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8796', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3339', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7976', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8798', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33394', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-33396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-7978', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8799', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7983', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8809', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7984', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8810', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8811', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8813', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8814', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-8815', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-7985', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33437', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8821', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33439', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7989', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33440', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7992', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33442', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33444', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7996', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33446', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9271', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9272', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9274', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9283', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3244', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9302', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-33625', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-8122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9303', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9304', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9305', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2018-9309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9310', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-9266', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33615', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9268', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33617', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9273', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9275', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-9282', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3342', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-3343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34595', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-33438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34599', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-6552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34465', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-7052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34466', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33642', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33643', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-32448', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33644', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-33645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9325', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9328', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32450', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9333', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-8833', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6457', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-7602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35962', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9882', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9883', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8722', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-8725', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7935', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8726', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8727', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33293', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-33294', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8728', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7055', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-3509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35967', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9885', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7608', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-35969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9889', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3597', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33518', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34613', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-34616', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-33551', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3356', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-33560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3462', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34626', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34627', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8843', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9336', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7059', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-34474', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7613', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9890', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9891', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7615', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7616', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7774', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7956', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9618', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3548', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-7311', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7312', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35482', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7314', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9621', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7315', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9622', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9623', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35036', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9624', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3549', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-9625', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9626', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7317', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35491', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-35038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7318', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9627', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7319', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-35042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9629', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7320', 5.3, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:H/A:L'),
('CVE-2023-35044', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-7322', 3.7, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2023-35047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7323', 6.0, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:L'),
('CVE-2019-9630', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9631', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7324', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-9632', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9633', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7325', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35494', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33368', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7775', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33667', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33678', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-33681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33682', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7060', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-34475', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9893', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9894', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-35977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7618', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9895', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9897', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9898', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9900', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2020-7624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7327', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9635', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-35054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7330', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-35065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7332', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35496', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35497', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9637', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8739', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8753', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8116', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-8118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-8120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8121', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8122', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-33484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33669', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-33690', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-33692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33694', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33705', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-33706', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-33707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33709', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33726', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8162', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8124', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-8129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36216', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8130', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-8131', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8133', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36221', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9901', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-9903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9908', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35979', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9909', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9910', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3598', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7061', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-34476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34488', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7063', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3213', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33604', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-34660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-33466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3347', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9913', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32458', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8163', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-33733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6490', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-33491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8882', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8885', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8888', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7334', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-3507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7335', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-35070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7336', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-35072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7337', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3550', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7339', 3.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-36166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8764', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7944', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8765', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8766', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8767', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8768', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33327', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8769', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8770', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7945', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7776', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9839', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33738', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9842', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33741', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2018-9843', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9844', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9845', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9847', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9849', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9851', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9857', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9859', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33767', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9862', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33775', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9864', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7064', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2023-3453', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-34537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7066', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7068', 2.5, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-7069', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-33515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36233', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36234', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32739', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3624', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8140', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3274', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-8141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35838', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3626', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8142', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32740', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8143', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3584', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32741', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8144', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-35840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8146', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32742', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-35843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32743', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-35845', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32745', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-35849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32746', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2018-8777', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33333', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-33334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8779', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7954', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32233', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7637', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-35981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9914', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9915', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7638', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9917', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35500', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7343', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7346', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7350', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8903', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33509', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-8906', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32296', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33510', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32300', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32301', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-32305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8914', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6462', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-7070', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-34561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7071', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-7079', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7080', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7084', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9919', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9921', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6492', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-8017', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-35789', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36167', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35796', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-36168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35798', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32583', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-35799', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8021', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3580', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32587', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-32588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35800', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3259', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36170', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-32590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35801', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-32592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36171', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33776', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33777', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33778', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9918', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9924', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9928', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33792', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9935', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9936', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33796', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9938', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34692', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33658', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8725', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33661', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32168', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32169', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32170', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7639', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9918', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9923', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9924', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9925', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7643', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-7644', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33035', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7777', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-7976', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7955', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33338', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7957', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7961', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7085', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7104', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9927', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8152', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32747', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-8153', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-32748', 6.0, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-36277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8154', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-3551', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35512', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-9642', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7352', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-35081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9644', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-7354', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-35513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9646', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9647', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9648', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9649', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9650', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7358', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9651', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9652', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7363', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-35088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9658', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-9660', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9661', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9662', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-35516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7369', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-35090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7370', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9669', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7371', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9670', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7778', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33037', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7779', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8022', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36172', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-3261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8023', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8024', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2023-35809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3581', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3262', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-8027', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2021-36176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36177', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8028', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8029', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8030', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-36179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8032', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3618', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-33813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32476', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32477', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9947', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9948', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-3384', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-33840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33834', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-8180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-9928', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9929', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7647', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8790', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3336', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8791', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8792', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33361', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33362', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33363', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-33364', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-33365', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-7973', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33366', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33367', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34700', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32174', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-34701', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32176', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-33716', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32199', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-8735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8739', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33754', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32208', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8156', 4.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-3628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32755', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-3586', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-32757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35866', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32764', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3587', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-35870', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-8162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32768', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-35873', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-35874', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-32769', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-35878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32774', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7651', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-35335', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2020-7652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35985', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35986', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-32125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32128', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33595', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3361', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33613', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34661', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-3214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3467', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34682', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34683', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32151', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-34685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-34617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32324', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2018-8960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8961', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8963', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8964', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32338', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8970', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-8035', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-32346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8972', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8973', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8974', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2018-8975', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8978', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8988', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8989', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8991', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6465', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-9949', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9952', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-35092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7374', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9673', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7377', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7378', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-35096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9675', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3552', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7382', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7383', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-35110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35987', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7660', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35988', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7664', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-34687', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32154', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-34689', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3365', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-34690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32156', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33656', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3366', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-33660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32488', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33880', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32489', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9959', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8166', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-35892', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-35893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-35898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8173', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8175', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-35924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35925', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36181', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-8086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-8088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36183', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8095', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8096', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-36186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8099', 5.5, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2021-36188', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9482', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3462', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7120', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-34620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34626', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3516', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33684', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6561', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-35116', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35124', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7387', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3513', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35525', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-35131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35132', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-35527', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35528', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-35133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35134', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-35529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7672', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2020-7673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35926', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8181', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-35927', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-8183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36286', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-35931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36288', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-35933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-34634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9485', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3517', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-7123', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7780', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7781', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7782', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-9974', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9975', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3253', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9977', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32538', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33911', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32541', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32543', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32548', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32552', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9986', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3393', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33897', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7686', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7688', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8051', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-9064', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35934', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2023-35937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35939', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36293', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36297', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3630', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-35944', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-35945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35946', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7980', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8805', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8806', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8807', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8808', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32210', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-33777', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32212', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34706', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-34707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32213', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-7690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7692', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-7693', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7695', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-7696', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9486', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9489', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9490', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-34647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9492', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34658', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-34659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7131', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:H/A:H'),
('CVE-2020-7132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9494', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9495', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9496', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3467', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9497', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9498', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9993', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3256', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-32561', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9999', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33970', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-33971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33972', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-33973', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33975', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-32570', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3398', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2019-8206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3402', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-32575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3404', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34068', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3407', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34070', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34083', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7705', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-7706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7710', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9065', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9066', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9067', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8054', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-6469', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-35947', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36311', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32214', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-32215', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-8750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32217', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8103', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-36190', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-35142', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35143', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35536', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-35145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7463', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35538', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7720', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-7721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32226', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9499', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35196', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9501', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9502', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9505', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36316', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36317', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3632', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8200', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8202', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-8203', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-8205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8213', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7729', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-7996', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-7997', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7783', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-7998', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-7999', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7997', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33447', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7998', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33448', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33449', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33450', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33451', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33452', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33453', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33454', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33455', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33456', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33457', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33458', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33461', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33463', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33466', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8831', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8107', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36192', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-8109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3266', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3620', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7734', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2020-7735', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7738', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2020-7739', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-7740', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-7741', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:H'),
('CVE-2022-32229', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32238', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32240', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32243', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32244', 4.2, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-32245', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-32246', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2019-8764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-35198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35199', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3470', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-35201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-7156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35202', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-35203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-7157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3471', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3472', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34733', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3521', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8220', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-8221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8224', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8226', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-8227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8228', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-8229', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7743', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-7745', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:H/A:N'),
('CVE-2021-35990', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35991', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-35992', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7747', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2021-35993', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32222', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8066', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9070', 5.9, 'CVSS:3.0/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9072', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8000', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8001', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8003', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-7784', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8005', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-7785', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-35146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-35149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3554', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-3515', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35540', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35542', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35543', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35545', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:H'),
('CVE-2020-8230', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8235', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8236', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-32571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7748', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3536', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7749', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2021-35994', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7750', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-35995', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35997', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7753', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7754', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3413', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-3414', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-32607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32609', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6505', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-8006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7786', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8007', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35211', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-35212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34758', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35214', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34761', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34795', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34797', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-7176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3522', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35221', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-7178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35222', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-3482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-33470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33473', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-33477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8838', 5.5, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2018-8840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8841', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8241', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9687', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9688', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35154', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-9689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35550', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9692', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-35551', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-35155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7474', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35552', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-35553', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2023-35156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9693', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35554', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9694', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35556', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36001', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8008', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-8009', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7787', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36000', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8248', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8249', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3601', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8252', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36003', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-36004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33857', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32266', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6569', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-7179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34823', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-35225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-7180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34824', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-35226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35227', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35228', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9506', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-35229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3523', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-34836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35230', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35231', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35232', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-7187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35235', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34259', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32623', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-32624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34260', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-6507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32241', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32242', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32252', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3472', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32255', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33832', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34110', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34119', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3412', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-34121', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34122', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34129', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-32603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6504', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-7476', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35557', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-35558', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-9696', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9697', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-9698', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9699', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35560', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35561', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7479', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9700', 3.6, 'CVSS:3.0/AV:P/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-35161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35562', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9701', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35563', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9702', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8076', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9109', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-9110', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-8077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-3604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3605', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-8253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-36088', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8261', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33490', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8883', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33493', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-33494', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8891', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-8892', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-33499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8894', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8895', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32276', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-32284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32288', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6461', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-32666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36006', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7765', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36007', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7767', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-36008', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-7768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36010', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8010', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8011', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7788', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7789', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8013', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3305', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32259', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-3384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33842', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33846', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33847', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-33849', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-7484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35564', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9703', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35163', 4.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2019-9704', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35565', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-35164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9705', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35566', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-7489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35567', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2019-9706', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7490', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9708', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35167', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-9709', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35570', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-35168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36013', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36014', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-7777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36016', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7778', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-9511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35236', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35237', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-34844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35238', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2020-7193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3485', 2.5, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2019-9512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7790', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8014', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8015', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33057', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7791', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33058', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8016', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33059', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8017', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32289', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32293', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35571', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-35572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9710', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9711', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35576', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-7492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-35577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9712', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7493', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35578', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-9713', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7494', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9714', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35172', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-35580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35581', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2023-35173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7495', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-9717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-35582', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-7496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-35174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35584', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-35585', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-35586', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-35587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9723', 4.2, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-35588', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2019-9724', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35590', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36017', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36018', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36019', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7787', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-7788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3425', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34261', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34262', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34267', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35245', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2023-34868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35246', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-7203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34872', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35249', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3488', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-34880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7205', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3491', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34917', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8097', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9159', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9160', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9172', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9175', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9177', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9190', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9191', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9193', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9195', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8027', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-33515', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-8921', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32312', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3352', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2018-8923', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32314', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2018-8926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8927', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-8929', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8938', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8944', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8945', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8947', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8948', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8957', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34322', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36123', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3613', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-35591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9729', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9730', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-35592', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35593', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35594', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35595', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9732', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9733', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9734', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35598', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35599', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-9735', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9736', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3560', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35601', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9738', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35602', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-35603', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7514', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7516', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9742', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7517', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9746', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35604', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2020-7519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35606', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7520', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9747', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7789', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-3602', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7790', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32498', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3250', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9207', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9208', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9209', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3242', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9234', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9236', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32273', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32274', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32277', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32283', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32334', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8962', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8971', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8977', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8990', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8037', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-8992', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8993', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8994', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34923', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-35265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35266', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7210', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-7211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35267', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35268', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7213', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35269', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7215', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3527', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3529', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2021-35290', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35297', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35368', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35371', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35373', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7807', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-9748', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-35608', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35609', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3561', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2019-9749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35610', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-9750', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-35611', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-35612', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2019-9751', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35613', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-35616', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-7527', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35618', 1.4, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-35619', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7529', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-9753', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7531', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9754', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9755', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35621', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9756', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35623', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9759', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9760', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9761', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9762', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9763', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35625', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9764', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9765', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9766', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9767', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9768', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9769', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3563', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-36131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-36133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3614', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-36141', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8278', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3615', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6570', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-8018', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8019', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-7792', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8020', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-33062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7793', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8023', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8024', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7794', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8996', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8998', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8999', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9000', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9001', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9002', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9003', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9004', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9006', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9015', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9018', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9020', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6466', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-7218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34958', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35300', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-7219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35301', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7221', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7222', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34962', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-35302', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7809', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7811', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-36183', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32833', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8284', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3620', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32694', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-32696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8286', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-32698', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-34355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34733', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6571', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-8025', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8026', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8027', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8028', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7795', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9774', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-9775', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-35631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35632', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9785', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-35634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9787', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34292', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32639', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34293', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34294', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34295', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8243', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-34296', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6510', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3267', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-36200', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36203', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8119', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3603', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7818', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32528', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-7820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33071', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8029', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33073', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8030', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8031', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-33929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32317', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33934', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-6572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8287', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-8289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7822', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7823', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32531', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8123', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-9307', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33627', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-33629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8252', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34320', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34324', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34325', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-34326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9789', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9790', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9936', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7827', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9937', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7828', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9938', 3.6, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9939', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7829', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32540', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32543', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9942', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-7836', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9944', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9945', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32714', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-31682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31683', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-32721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31684', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36266', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36287', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32332', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33945', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33946', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32339', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33947', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6573', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-7797', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8280', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8285', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8308', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-34359', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32700', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8320', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-8321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32710', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6516', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-32846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8297', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36301', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8299', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36319', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8316', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3633', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36344', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8319', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36039', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7798', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8033', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7799', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8034', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8035', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32061', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-7801', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8037', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6432', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-8132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8342', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8343', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8345', 2.5, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-31693', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8346', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31696', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-3275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8354', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8355', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31699', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8360', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31705', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-31707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8372', 5.9, 'CVSS:3.0/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8376', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8378', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8379', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8382', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8383', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8059', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-3238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8062', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33542', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8064', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-6471', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-36364', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36377', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36382', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32861', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36385', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36388', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-32868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33672', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-33680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33683', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-33684', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-33685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33686', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33693', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33695', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-33699', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33700', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33701', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-8153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33717', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33718', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6489', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-36040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32547', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3641', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36420', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3288', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7850', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7851', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8800', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8801', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3232', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-33937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33939', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3394', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-32320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32323', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2022-32324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32328', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-33941', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8385', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8395', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8397', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8398', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32801', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8400', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32812', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8410', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32813', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8411', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32815', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6575', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-8038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7802', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8039', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8040', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35640', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-7538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9793', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-35643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9794', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35649', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-9795', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3565', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35650', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2023-35179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9796', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9102', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-9103', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8737', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7852', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9948', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-7853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36043', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7858', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-3518', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-9797', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-35651', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:L/A:N'),
('CVE-2019-9798', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-35652', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-9799', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35653', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-9800', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9801', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-35655', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9802', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-35656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3520', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-35658', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33943', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-32330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8806', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7803', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8041', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8042', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8134', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3623', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2020-8138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36235', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33762', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32766', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8377', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9115', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-8079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9120', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9122', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9127', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9132', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-9134', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36045', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7860', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3605', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7867', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3656', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-36560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8741', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8418', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8422', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8427', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32071', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-36435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-33965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35388', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36051', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36052', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7872', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35389', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-7873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36053', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-3539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36054', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2020-7875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36055', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9956', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36056', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9957', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36057', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36058', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7882', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-7883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36059', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9960', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7904', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36060', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-7905', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9961', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-9147', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9151', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9153', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9154', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9155', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6477', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9803', 5.2, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-3521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9804', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3566', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-9805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3523', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-35660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9806', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9807', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-3525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9808', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-35665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-35666', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9809', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-35683', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-35686', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-35687', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3569', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9811', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2018-9937', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9939', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9940', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9941', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9943', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32470', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9946', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32807', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32810', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-31739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31743', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8443', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36460', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-36461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36462', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-36465', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2023-36466', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8425', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8428', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8429', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8432', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8434', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8440', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31744', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-32072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7805', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32075', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2018-8045', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8046', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32076', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6433', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-8813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6586', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8827', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-32349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8150', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3585', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-35850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9962', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35392', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-7907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9963', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36061', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2023-3540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9964', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9965', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9966', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9967', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7908', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9968', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9969', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36065', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3550', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-32549', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-7911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9970', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-36066', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3255', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-32960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8445', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8446', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3175', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8451', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-8452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34398', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8453', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8455', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-8456', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8447', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-8181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-33844', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33845', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-9954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32487', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9958', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32490', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32492', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-33889', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9961', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9962', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9812', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:H'),
('CVE-2021-3570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3571', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2018-9235', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9237', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33577', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-33581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33586', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9244', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9246', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9247', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33594', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-33595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-9256', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9257', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9258', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-36480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36484', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3649', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-36492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35863', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2022-32763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8161', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-35871', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2023-35872', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2020-8163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3589', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35890', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35900', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-35901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-35906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-35908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3591', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2019-8458', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34401', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8459', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34408', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9963', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-33898', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9965', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9968', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32511', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9970', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32521', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-33909', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36067', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9978', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36069', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7918', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-3557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3607', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-3559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32550', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-36070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36071', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36072', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36073', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7921', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36074', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-7922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36075', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36076', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36077', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-7924', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-36078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34745', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-34746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33982', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33983', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-33984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34749', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2020-6610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6612', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-6614', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-6615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33990', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-33992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34754', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33993', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33997', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7806', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8047', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8048', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8050', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8056', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8057', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7807', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8058', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8059', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8060', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32081', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-7808', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8061', 5.2, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-32082', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8069', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7809', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8070', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8071', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9813', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-9815', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8342', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36537', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36538', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36539', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8172', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-35912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35918', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8174', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8177', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8179', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2020-8180', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3278', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6641', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-34416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31775', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-34417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34419', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34420', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2021-34421', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-34422', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-32994', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3178', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6527', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-36079', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3608', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-3566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36081', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32554', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32555', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36083', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32559', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-7931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-7934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3609', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32993', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-31779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32996', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-31780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-31783', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8357', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36551', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36559', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-3656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36562', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2023-33953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33955', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33968', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-33969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32531', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32545', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32553', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32555', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9987', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32556', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9988', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9992', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-31784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3300', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34426', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9816', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9817', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-33971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6579', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-6583', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7810', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8073', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8074', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8076', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-7811', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8078', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33003', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-33004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-33006', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-6528', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-33961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32565', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-32566', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2018-9998', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33981', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-33982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34055', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34067', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34069', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34071', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34075', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6648', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3476', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-34017', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6653', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-3403', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34428', 2.5, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-3443', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32954', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-36327', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32955', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36333', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-36334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3658', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7812', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3209', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-32090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9326', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9327', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9330', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8128', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33653', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8129', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34035', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3477', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3235', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3234', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36584', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-8427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36338', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32595', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3409', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-3410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-33657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33659', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33660', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33661', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-33662', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34434', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8542', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7813', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8090', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8092', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7814', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8096', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8097', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6435', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-3685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3659', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9818', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-3574', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-3575', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7544', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3576', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9819', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3303', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-3304', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-3446', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7944', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-36091', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7945', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7949', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7950', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36093', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7951', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7952', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7954', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36095', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7955', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36097', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-7957', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-7959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36340', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36341', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8450', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-7547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9820', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3445', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34468', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33121', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34475', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-34477', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34478', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3448', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2020-8461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8469', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8471', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8472', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8473', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8474', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34141', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-8219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34185', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32611', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34193', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34471', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33123', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34485', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3191', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31911', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31945', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-31946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3578', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9821', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9823', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8482', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8484', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8485', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8486', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8487', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8488', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8489', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7962', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7964', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35719', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3611', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2020-7966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7967', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7815', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7816', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8100', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8101', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2018-8102', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7817', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8103', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8104', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-32105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8105', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8106', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-7818', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8107', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7819', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8113', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-32111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8114', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32112', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8115', 6.0, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-32113', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2023-32114', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-7820', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32115', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-6436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32960', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8497', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32961', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32962', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32963', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8506', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32615', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-3420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3421', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-3422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3424', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3426', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32627', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34268', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8232', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6509', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-33710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6488', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-36853', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3660', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-36601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36858', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-33124', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31902', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31906', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33126', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33127', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33130', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-33132', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2023-33134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33137', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8562', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-8563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3475', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-6613', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-33986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33987', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2023-33989', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-33991', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2023-34004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34756', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6624', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-6625', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-6628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6630', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6631', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6644', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34758', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-34015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34759', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8834', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9824', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9825', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9826', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3582', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-9827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9829', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7550', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9831', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7551', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3583', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9832', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7552', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9833', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7553', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9834', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3406', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3407', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-32373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32389', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33139', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-33141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3449', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33143', 5.3, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2023-33145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-33146', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6536', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-35936', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:N/I:H/A:L'),
('CVE-2021-3629', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36290', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8516', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8518', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33149', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3315', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36865', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36621', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36868', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8743', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6750', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34094', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33162', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-31951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34517', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34519', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-34522', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8582', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8544', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3585', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7555', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9837', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9838', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3588', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-7557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9839', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3589', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-9841', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7558', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-7559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9842', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7560', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-6649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6650', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34761', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-34022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34023', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34762', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-34028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34765', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34036', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-34037', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-34038', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-33724', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-33725', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-33727', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9838', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9840', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3374', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9841', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9846', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9848', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36872', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8557', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8558', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8561', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-9843', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9844', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3592', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2019-9845', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3593', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2020-7969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3574', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-7971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3612', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3631', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36312', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-36313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36318', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-34774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34040', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34041', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32365', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34043', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34047', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-32368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8564', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8565', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8568', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-32970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32972', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8570', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-32973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8118', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8119', 3.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-32118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8122', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7821', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8126', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8128', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8130', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8133', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7822', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8137', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8139', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7823', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8145', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9850', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-9853', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9856', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9860', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-33768', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9861', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9866', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8172', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-9920', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-8173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-9922', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-9925', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9926', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9927', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9934', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33794', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-34529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8201', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8206', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8214', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8216', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34546', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34547', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-34548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34302', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34303', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-34304', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8249', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34306', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34307', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32665', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32669', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-3267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34310', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32672', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34313', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34314', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32675', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-32676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34315', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3660', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-8575', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8576', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-8577', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8578', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8222', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-8225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34092', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34093', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-32391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6752', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-32394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33795', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-6493', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-31965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34557', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3456', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-33176', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-6540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34105', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32434', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3411', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-34111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34118', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8902', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-34120', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8903', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34098', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34099', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32406', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32414', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32425', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3244', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-32441', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32450', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-34109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32453', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-6768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34110', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3478', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-34114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6769', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-34117', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33183', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-33189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33193', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-8898', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-34119', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8904', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8905', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-34121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8906', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2019-8907', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-9951', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-9953', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32483', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9955', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33850', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32486', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9956', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8187', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-33194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34122', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6781', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-34123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-34782', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8908', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8909', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8910', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8911', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6786', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32469', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6787', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8917', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3413', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8921', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8922', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8923', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8924', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32471', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34327', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32681', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-34328', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32682', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-8264', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8265', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34330', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32684', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8266', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34333', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34335', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8270', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34337', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-34339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-9957', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-32494', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-32495', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33896', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-32498', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9964', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9966', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9967', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33199', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-3320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9969', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3252', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2018-9972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32522', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-32523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32526', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3391', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32534', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-33910', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32539', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-9979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-32542', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3392', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:L'),
('CVE-2023-32546', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2018-9981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32457', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8919', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8920', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6789', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6790', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32470', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34131', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6792', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-34133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8925', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8926', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8927', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8928', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32473', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8929', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8931', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8932', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32474', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8933', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32475', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6797', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-6798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-33204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8244', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-35998', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-3600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36002', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36873', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3664', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36647', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35759', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3576', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-35763', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3577', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36127', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8588', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8590', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8594', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8595', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-8596', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32990', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-8605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-36617', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-36619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36627', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-36628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8617', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8147', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8148', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7824', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6437', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-34361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31647', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-31648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32712', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-31678', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-32716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6517', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9982', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32550', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2018-9984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-9985', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32554', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9990', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-9991', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32559', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9996', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-9997', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-31982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33229', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-31983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3323', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-31984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-33240', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33243', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33244', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2020-6800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34790', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34791', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8948', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3607', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8259', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8264', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36668', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36689', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8745', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34787', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8934', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8935', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34788', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32476', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3479', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8937', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32477', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8938', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8939', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3702', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8952', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6808', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8954', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8955', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33251', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33255', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33283', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33285', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-33287', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8149', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8150', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-3213', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8151', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2018-8152', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-8153', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-8154', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8155', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7825', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8156', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8157', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8158', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8159', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-8160', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8161', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8162', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7826', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8163', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8168', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7827', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8171', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8172', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8173', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8176', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7828', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8177', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8178', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6438', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-8619', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36635', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-33024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36638', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33033', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8265', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8268', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6812', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36883', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-3669', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36884', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36886', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36887', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36888', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-36697', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36701', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-36702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8751', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8350', 5.9, 'CVSS:3.0/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31697', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31698', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-8356', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8357', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31701', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8362', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8363', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32762', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8375', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8380', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3280', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8942', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32478', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8944', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37036', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3256', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8979', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34801', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-34802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34807', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6819', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34571', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34573', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33303', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33034', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33035', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-33036', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33037', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8625', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8631', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8632', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7829', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8202', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7830', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7831', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7832', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8227', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3309', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-36894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-36718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6804', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32481', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8951', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34587', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-33315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33355', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8986', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-34811', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8989', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8990', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6824', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-6825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33316', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8433', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8435', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8436', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8437', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8438', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8439', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32955', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31745', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-32961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8229', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8232', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7833', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8238', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8242', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7834', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8244', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2018-8245', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8246', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8247', 2.5, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-6439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34793', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2019-8953', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6810', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-34797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8963', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8978', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6813', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-36678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-34150', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-6829', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34151', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33359', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-33361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33369', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-33370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3201', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-34803', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8981', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8982', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-8983', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34808', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8984', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3481', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-6820', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8988', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-6822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8248', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8249', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8252', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8254', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8256', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33097', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8260', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7835', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8265', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8266', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33461', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8454', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34402', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34404', 6.0, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-8461', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34405', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34406', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32978', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-32979', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34411', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34412', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-31774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32985', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32988', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6526', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-6823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34143', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34144', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3482', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-34145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34146', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6827', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2023-34148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34823', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-34149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8648', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-6838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8995', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8276', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8279', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-36163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3416', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-3261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3418', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-33495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8753', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3672', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-36720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36721', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8754', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36724', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3673', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8755', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33158', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34838', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6857', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34839', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6859', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-6861', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34842', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34195', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34849', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34852', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34854', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34855', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2019-9013', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6832', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8994', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-34153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32999', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-31782', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-31788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33008', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-31801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31803', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2019-8523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3461', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-32055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3206', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-33544', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34612', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-33546', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34614', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-32081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34615', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2019-8686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32084', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6555', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:L'),
('CVE-2020-9055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9056', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:L'),
('CVE-2023-37280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9062', 4.0, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2023-37286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37287', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37288', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6554', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-6840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8997', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-6843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8998', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8999', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34832', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9002', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9004', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-34170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34833', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9005', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34834', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34835', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6850', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34836', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34837', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6854', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9015', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-34859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6917', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6919', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6920', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6921', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6922', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9021', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6933', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34867', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-34868', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-9023', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31827', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-6530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32634', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3429', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32635', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-34291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8241', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8242', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-8244', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-34297', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34298', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34299', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-34300', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32643', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34305', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32657', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34308', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34309', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32671', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34311', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34312', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8251', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-33104', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2018-8267', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8275', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7836', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8279', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7837', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8280', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7838', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8281', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7839', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7840', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-33107', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8283', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8284', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8286', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-33108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8287', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36193', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36217', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-3622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8286', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-36234', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8756', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36739', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3674', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36740', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-36741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36742', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-34185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-34187', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34192', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-34844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6867', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6869', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-34846', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9011', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34197', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-3485', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34850', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34851', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34853', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34856', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-34857', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-34858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9016', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34864', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-6918', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9020', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3331', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33311', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33315', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33316', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33317', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33319', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-36745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8761', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34629', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32088', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-36258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8292', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-36272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32677', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-34317', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-32679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34318', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34319', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8253', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34321', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-34323', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8261', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32680', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-34329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8263', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32683', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2019-8267', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34332', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34334', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34338', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-32689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34872', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34874', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34205', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9024', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34875', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9025', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34876', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9026', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34209', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34877', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9027', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9028', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-9029', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34878', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9030', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-9031', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34879', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9032', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-9033', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-9034', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-34880', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9035', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2019-9036', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9037', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-6956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6958', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-34881', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9038', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9039', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9040', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34882', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9041', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8664', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3671', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9022', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34869', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-3487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7841', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8288', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7842', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6440', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-31860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36129', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-35773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-35775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7974', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-35776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36130', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-7976', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32561', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32117', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34648', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32691', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-32692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32693', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8278', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8279', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8282', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-8289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8292', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33320', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9079', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9090', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3675', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-36750', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8765', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36751', 3.6, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8766', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9042', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9047', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9048', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34883', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9049', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-9050', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9051', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-9052', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-34884', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9053', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34885', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34886', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9055', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9056', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34887', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-34888', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9059', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9062', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9064', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9066', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9071', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9074', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-34891', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9076', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9077', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9078', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9083', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9086', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9087', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9093', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6972', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9094', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34897', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34898', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-6978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2023-36298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8296', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36307', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-36308', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-36310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8315', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8318', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36351', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7977', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-35780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-32563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36134', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-35781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-35782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7979', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-35783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34469', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-3447', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34470', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34479', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-31897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36753', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36754', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36756', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-8772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36758', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-8773', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:L'),
('CVE-2021-36760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-32139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3362', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8710', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3363', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-34675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3468', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-32152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32153', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34688', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36368', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-36383', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36387', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-32707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34363', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-31649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31650', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31651', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32709', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6980', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34901', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-6982', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34902', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-34218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34903', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-34904', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34905', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34909', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34910', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-34911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34912', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34913', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9105', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9106', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9107', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34914', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9108', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9109', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34915', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9110', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34916', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9113', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9114', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34917', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9115', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9116', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34919', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9133', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34921', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7843', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8290', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8291', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8292', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7844', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8294', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8296', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8298', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8299', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8300', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8302', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8310', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-7846', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8312', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7847', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-7848', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8315', 2.5, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2018-8316', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8319', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2018-8323', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8326', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2018-8327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6441', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7982', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32570', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-7993', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32575', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36151', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-7994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32576', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7996', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-7998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-7999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-35785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-34371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31674', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31675', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32713', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-31676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31677', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-32715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31679', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31680', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-31681', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-32717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-32723', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-32731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-31688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8334', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32732', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-36433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3364', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3469', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-3450', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-34501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36156', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8002', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36157', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-35786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8003', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36158', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3258', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8016', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8335', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-31690', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8336', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8337', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-8338', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8339', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8347', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8349', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8351', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-32749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8358', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-32158', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-33668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32891', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36456', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-36457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32892', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2023-33157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-32171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3470', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-33693', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33695', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-32175', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-34702', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32177', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-3218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33717', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33719', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33736', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-6562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33161', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8774', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:L'),
('CVE-2022-33163', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8775', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:L'),
('CVE-2022-33164', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34889', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9063', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-9065', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-34890', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2019-9072', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9073', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-9075', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9080', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9084', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34894', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9085', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3709', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9114', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3710', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36464', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-36467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8324', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-36471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8327', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8331', 5.9, 'CVSS:3.0/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7849', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8332', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7850', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-7851', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2019-7852', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32200', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32201', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32202', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8738', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-33751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-33762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6563', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-31711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-32792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8389', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-8390', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8391', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8393', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31733', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-8394', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-31735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-8396', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-31736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8404', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-32802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32806', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8407', 5.2, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-8408', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-32811', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8412', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8419', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-32820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8421', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9128', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36769', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-36476', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32906', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36479', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3648', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36494', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36770', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34551', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33170', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36728', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33070', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-33075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8792', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8793', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3292', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32920', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-36514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-36730', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8346', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36536', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3293', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36779', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3678', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-36735', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-36736', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-36737', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36739', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3674', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-36740', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36741', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36742', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34918', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9132', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34920', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9136', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9137', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34922', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7853', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7854', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-33119', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8351', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2018-8353', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2018-8354', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2018-8355', 5.9, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-7855', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2018-8356', 3.6, 'CVSS:3.0/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2018-8357', 6.0, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-6442', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-3654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36540', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8355', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2021-36780', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-36922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36923', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-36925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:L'),
('CVE-2023-36926', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3317', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-37300', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37301', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36349', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-6541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32235', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32239', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-6566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-8749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32218', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3222', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9200', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9202', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37305', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-37307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32223', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32228', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36565', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36568', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36569', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32953', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8423', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8424', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32828', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32829', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8426', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3291', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-6522', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-3712', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-37124', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9229', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9233', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-3713', 6.0, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-37131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-32237', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2019-8762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33795', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33796', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-33797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-7857', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2018-8360', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3633', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32959', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8422', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36782', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33172', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36783', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-36932', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8807', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8809', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8810', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8811', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36934', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36939', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36941', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8817', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-36942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8818', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8819', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3324', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9140', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-34923', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34924', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9142', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9143', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34925', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9144', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9145', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9146', 5.9, 'CVSS:3.0/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34926', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9147', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-34223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9148', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-34224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9149', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-34225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9150', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2019-9151', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9152', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34930', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9153', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-34227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9154', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-34228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37144', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-37146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36337', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8435', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-8436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8437', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36339', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8448', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3297', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8449', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32980', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-31768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-31769', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34413', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-32982', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-31770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-8505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33264', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-8625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9155', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34932', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9156', 5.9, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34933', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9157', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9158', 3.6, 'CVSS:3.0/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34934', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34935', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34936', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34937', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34234', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-8825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-36968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8446', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8448', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-33802', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3382', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34938', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-9165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3494', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9166', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34940', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34238', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34941', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34239', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2019-9168', 2.7, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34942', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34943', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-3424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-32983', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-32984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8478', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-8479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33833', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-32256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33834', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-6568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N');
INSERT INTO `tpandora_cve` VALUES
('CVE-2021-37148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-8493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8495', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3296', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-33848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32265', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-33850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33852', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-3386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32267', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33865', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32271', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-3387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37151', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37159', 5.9, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3337', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:L'),
('CVE-2021-3716', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-3338', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-3339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3341', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-3343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-32001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9575', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37468', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37447', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-37448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3745', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37452', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9581', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37484', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33887', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37490', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-37469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33888', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37512', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3748', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-3752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3754', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37543', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9589', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3750', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2019-9169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34944', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-34241', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-34945', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34946', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34242', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34243', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2019-9170', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32275', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34726', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3636', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-36363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36365', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36367', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-36368', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-33092', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36371', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-33093', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36791', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2023-36980', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8838', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36995', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36795', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3700', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36800', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8843', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36801', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36804', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-37049', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-8845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8670', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-33387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33405', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-32010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-8673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9248', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3717', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2019-8790', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32290', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-36756', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36757', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36374', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36376', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36377', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-36759', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36760', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36761', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3638', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-36762', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:L'),
('CVE-2021-36380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36381', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-36764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36382', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36766', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-36767', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-36383', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36386', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-34597', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32028', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3348', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-33493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34246', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-34247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-3497', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-6988', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3425', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3498', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-9171', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37500', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-3389', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37504', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33890', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3752', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34984', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-34250', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-34251', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34985', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2019-9172', 3.6, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-34986', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34987', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-34252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3499', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-34253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9174', 6.0, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-36805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8846', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36808', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3706', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3681', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37064', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3318', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-3310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-32297', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-33925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-33926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33883', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-37421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9175', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-33552', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2019-8687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-33568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2019-8688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3463', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37530', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33905', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-33906', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37534', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33907', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9598', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-33908', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3754', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-37540', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-33909', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37549', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34287', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-9858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34288', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38163', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34291', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-36786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-36788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36794', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36400', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-36796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-32114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-37065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3682', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-8849', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8850', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3707', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8851', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36823', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2023-3709', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8852', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-8853', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37547', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-33915', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9602', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-33920', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33921', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33922', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-33924', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-37422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37425', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-3743', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-9548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9551', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9552', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9553', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-9554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9555', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9557', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-9558', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-9559', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9560', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9982', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37973', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2019-9176', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-34257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3426', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3427', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2019-9178', 1.4, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40391', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3483', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-34835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36401', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36402', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36403', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36408', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3641', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-36410', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8551', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8552', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-34992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-6990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3428', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8854', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8855', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-37132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37552', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9608', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-3757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9609', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37176', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-37177', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9264', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9265', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2020-9266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9268', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9280', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37181', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-9287', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3733', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-32141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-32142', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-32148', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-32149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-34679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36411', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36412', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36414', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3642', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9561', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37455', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-9562', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9563', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9564', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9565', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9567', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37460', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3744', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9611', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38201', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2020-9873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9874', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8553', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8554', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-8555', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-37135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8856', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33190', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8857', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3684', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36844', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33198', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36846', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40417', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-34851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36425', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-36426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8562', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8563', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3818', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-39654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38185', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39700', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38210', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38211', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38212', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38213', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9876', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9879', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37588', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37593', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-37594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33955', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9615', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9622', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37600', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9624', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37605', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37606', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9179', 1.4, 'CVSS:3.0/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-34995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9181', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-34997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9182', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-34998', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34312', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3500', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-34316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-6992', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34318', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9184', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-35005', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2019-9185', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8566', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3297', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8865', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-33201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33202', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-8869', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37174', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36850', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-8870', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8872', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8874', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8875', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-36854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8876', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8877', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-36857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8879', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-37198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36861', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-37199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9568', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9569', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9570', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37442', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9571', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9572', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37443', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-37466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9573', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33885', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37446', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3747', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37476', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33886', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3436', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34366', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9626', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-3761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9629', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37613', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37615', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37616', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37617', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33963', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3756', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33967', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37619', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37622', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37625', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9640', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37626', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3763', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3432', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2023-3433', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2019-9186', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-34335', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2019-9187', 3.6, 'CVSS:3.0/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-34336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2019-9189', 5.9, 'CVSS:3.0/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38231', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38232', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37938', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37941', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-9895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37487', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37489', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37468', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37491', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37511', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37513', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37498', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-9588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33889', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37519', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-33891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37200', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-8883', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-36864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36865', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36866', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36867', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37631', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37632', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37633', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37596', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-9656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-37599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9659', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37623', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9667', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9668', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37645', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3765', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-9673', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9674', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3766', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38241', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9290', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37183', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38487', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2021-37979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9594', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37529', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-33900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9595', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-9299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9306', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3352', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4046', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-34870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40530', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-34881', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38542', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40537', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8889', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8890', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-37204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-36871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8891', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8892', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37640', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9679', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-37677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37641', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-37684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37685', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37642', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9681', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37689', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37643', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-9683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37644', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33973', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9686', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37646', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9688', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37732', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-37733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37650', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9690', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-37744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37745', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-36872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-36873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-8894', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-37207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-33902', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9596', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38567', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38570', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-38571', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9692', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37653', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33982', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37654', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-33983', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9693', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37655', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2022-33984', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33985', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33986', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33987', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-37659', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9696', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-33992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-33993', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-33994', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-37660', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9698', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38524', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39910', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39912', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39915', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39918', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8895', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8896', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37208', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8897', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37959', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33911', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33912', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37546', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9601', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37549', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33917', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33918', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33919', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37551', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9603', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37554', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8902', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8903', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8904', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-37210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-36878', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-33208', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8905', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3688', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-37211', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33927', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-37557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9610', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38586', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-40558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40570', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34889', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3489', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34890', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-34891', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34901', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34902', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-40581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38608', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3321', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2023-37212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8908', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8910', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38344', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34013', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37666', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9702', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37667', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9703', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34029', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-37669', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3779', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3767', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33937', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-37554', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33942', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33943', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33946', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9614', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33953', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33959', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-37598', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9616', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9617', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-33960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39939', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-34484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41846', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41867', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4187', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4188', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-41880', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-41881', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41882', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41885', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41888', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-41889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-4189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-41892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4190', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-38569', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35913', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-41915', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35915', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-41931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35916', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-35917', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-41933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-41934', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40589', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40596', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-38650', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-38652', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-38653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40604', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40611', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-40617', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40622', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-40623', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-40624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40625', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-38678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34910', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38681', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-38682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-8583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32983', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-32984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8585', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8587', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8589', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36071', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36072', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3941', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-39411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9618', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-33961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37670', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34043', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37672', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3405', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37673', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3782', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37674', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9707', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37849', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37677', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37678', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-9710', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-34110', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3768', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37681', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35919', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3592', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-35920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35921', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-35922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35924', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35928', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34487', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-39945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39948', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39950', 4.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2023-39951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41900', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41902', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41904', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-41908', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3591', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38403', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37964', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34992', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40682', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34998', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34999', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3500', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35000', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35003', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35004', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35014', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35015', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35017', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35018', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35019', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35020', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35039', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35056', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35065', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35081', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35092', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35094', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35096', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35097', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35099', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-38723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38725', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8911', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-36887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8912', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8916', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8918', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36890', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-36891', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-8919', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36895', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36896', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8920', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37684', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37687', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37688', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37692', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37558', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37618', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-32991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8608', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-8611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8612', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-32997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-32999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8616', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-36630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3301', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-8618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35120', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-35121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35131', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-35132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-35137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4070', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-4277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-36096', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-36099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36101', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42795', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-42805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42806', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-42807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36112', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-36113', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-36116', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-42811', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36117', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-42817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36120', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36122', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42820', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2023-4283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9725', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9726', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:L'),
('CVE-2020-9727', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9729', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37895', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9731', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9732', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-37901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37902', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-9734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37903', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-9735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9736', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37906', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-37907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9739', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-37914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36899', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9945', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-9947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37967', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-35936', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-35937', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-41962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35938', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-35939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35942', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-35943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35946', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35948', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-35949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37620', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37621', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37623', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9643', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37627', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37629', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9649', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-9650', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37630', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37581', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39958', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39961', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-38265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39962', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-38267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38268', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-39963', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39965', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3827', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-39966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37224', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8927', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-38611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3862', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38632', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38633', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38640', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-38641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38665', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38666', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38667', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38679', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38680', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38681', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38683', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38685', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37917', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34151', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37919', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-9742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34156', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-37920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37700', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34157', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9744', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-37701', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-9745', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-37702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37703', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-38687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38695', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38697', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38700', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37996', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-37597', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-33969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37635', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-37602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37636', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37637', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9665', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9666', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-37630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3764', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-9669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9672', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8929', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-8933', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8934', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8935', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8936', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36909', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-36143', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43069', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36150', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36151', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43073', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36155', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36168', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36171', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-3943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36174', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36180', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-43124', 4.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-36182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43125', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-36191', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43132', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36243', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39523', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9961', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34160', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-34161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37939', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37704', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34164', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9746', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37941', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37705', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2020-9747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9748', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37943', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9749', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34165', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-34166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37944', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37945', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9753', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-34169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-39978', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-3999', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34502', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38305', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3451', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34520', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38314', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40715', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40717', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3882', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-38822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38859', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38862', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38863', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-38869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38874', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38879', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3888', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-38882', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38883', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3889', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-3520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8937', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8938', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8939', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8940', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-37248', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8941', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8942', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37250', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8943', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9320', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3360', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9323', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3361', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9327', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3363', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9329', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-33631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33632', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-33633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33636', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-33638', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-33639', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-3364', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36671', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-36672', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-8634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36673', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-8635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36674', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-8644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-36689', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3669', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-36690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3596', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3597', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37647', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37649', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9689', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9691', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-37651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4000', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-38317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34556', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40014', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40015', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-40017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40022', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40025', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-38338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38342', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-38343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34612', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34618', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34623', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38353', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40040', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36247', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36249', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-43226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36261', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-39534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39539', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39542', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39543', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39544', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4327', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37949', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-3795', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37950', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9758', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-37712', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-37954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-9760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34181', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-34182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37965', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-38711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38728', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38732', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38733', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38745', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-38746', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38748', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37999', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33640', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37190', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37191', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37192', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37193', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-9335', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33646', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33649', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-3735', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-4211', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35977', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42132', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-42147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3598', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4216', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-42178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-42180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35985', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42298', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-42331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-42335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8944', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36915', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-36916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8945', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37255', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8948', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8950', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36920', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34188', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34189', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34204', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9783', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38359', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3836', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-40045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38362', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38364', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-40047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-38366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40049', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38372', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-4007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38376', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38379', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39564', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39569', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3957', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39575', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43361', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36315', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-43377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39583', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39585', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39587', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43456', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39590', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3632', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-36320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-41940', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41941', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41942', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-35932', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41943', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3930', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-41944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41946', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-35935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41947', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9697', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-33995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37661', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37765', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-37766', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-37767', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9700', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34008', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34009', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34011', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37664', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-3402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34206', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-37720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9784', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-37995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37997', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-37998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3800', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-37722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-42362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4242', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-42441', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-42442', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8660', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36922', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37259', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8954', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-36923', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36924', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8956', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36925', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8959', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36929', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-37262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37263', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8968', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-3693', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-37264', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36930', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40166', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-40167', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-40170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38401', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34666', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4018', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-40181', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-38418', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40188', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-4019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38424', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38425', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-34672', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34673', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2023-40198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-40201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40210', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38434', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38436', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34678', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34679', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42449', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-4245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-42450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-42451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42454', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-42455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38850', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38857', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3886', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38872', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38888', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-38889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38894', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38896', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38898', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38905', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38906', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38908', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38909', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3891', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3892', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38002', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-40729', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38926', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-35220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35221', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-35222', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38928', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-35223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38941', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35234', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-38944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38949', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38950', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40732', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-38951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40735', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38955', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38958', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38972', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-35238', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38973', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38977', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-40743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38978', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37725', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2020-9789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34216', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38039', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34217', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37729', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-38056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34219', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9794', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-42460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-42461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42467', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36007', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-42469', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42503', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-42508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37200', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-9347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37202', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37203', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2020-9353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9359', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2020-9361', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9362', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9368', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-37267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-8986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8988', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3694', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-8989', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-36940', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-36941', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8991', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-36943', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36949', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3695', 3.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-36950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36952', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36956', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38453', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38461', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2021-38463', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-3469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-42520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42523', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-42524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-42525', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-36024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36025', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-36026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34220', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39591', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39592', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39595', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39598', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3960', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36338', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36348', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2022-35956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35957', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-35962', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38980', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35242', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38981', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38985', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38986', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-38988', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35243', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-35245', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36035', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36036', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36037', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36040', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3932', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39327', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36048', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3933', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39333', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-36051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39335', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37671', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9706', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-37675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-37837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34101', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34108', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-34109', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-37679', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9712', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37680', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9714', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3736', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-38065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34221', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37731', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38068', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2020-9800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9801', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-34222', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38071', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38990', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38991', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-38992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38996', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38998', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39005', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38989', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38990', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38991', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38993', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-8674', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-8678', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8679', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35963', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35970', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4209', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43498', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36367', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36369', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3637', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36383', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43502', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-40272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34748', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34755', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-8680', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8681', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8682', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8683', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8684', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8685', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-8689', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38074', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38075', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38076', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34226', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34227', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37682', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-37683', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9715', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34133', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37685', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37686', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37689', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37690', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2020-9718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37691', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35978', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-42138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35979', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-42261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-42268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42280', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35986', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35988', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3696', 3.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-3324', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3935', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-42398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42399', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-42405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42443', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36404', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-36405', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36413', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33067', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-33068', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3844', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9721', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37894', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9730', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42445', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-42446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-42447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42448', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-42453', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42456', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-42457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39358', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39359', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39360', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39361', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36065', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39365', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39367', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-39368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36067', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-39369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39373', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36068', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37900', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-9733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37904', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-9737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37915', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9741', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3792', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-3770', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9813', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34232', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34233', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-36414', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36416', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36422', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3850', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38496', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-38497', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38499', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38508', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36437', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36438', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36439', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-3644', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36442', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34237', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37786', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37788', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-37789', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-3779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37791', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34238', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37794', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37803', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37806', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37808', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3781', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-33069', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-8701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39112', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-39113', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39114', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39128', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39129', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39130', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39136', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39137', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3914', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-39143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39144', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36069', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3607', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-42459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42462', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-36006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42468', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-42470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42472', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-42473', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-42475', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-42477', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-42486', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39026', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35272', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35278', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35279', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35282', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35292', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35298', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3903', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38510', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-38512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-37360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9382', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-37361', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37364', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-37365', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-33676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42522', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-42526', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39313', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36021', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-42656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-42657', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2022-36027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36082', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36088', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36090', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36093', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-36094', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-42768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34239', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-3782', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2021-37823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38506', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34785', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38508', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-8703', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8704', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8705', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36032', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-42663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4269', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4270', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36039', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36041', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36042', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36043', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36046', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37369', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9386', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9387', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33680', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-9388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9389', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33681', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9392', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-33682', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33683', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33684', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3369', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9399', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-37207', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3721', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9403', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37212', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-37213', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9404', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-37214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9405', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-9406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42782', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36105', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-42794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36109', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-42808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4281', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-42812', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-42818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38557', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38558', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39153', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-39154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39155', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-39156', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-39159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-39162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37845', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34244', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34245', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36127', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36129', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-4294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4296', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36130', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-36131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4299', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4301', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-43013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4302', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4304', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36140', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36141', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36142', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36144', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36148', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36153', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43090', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43114', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9407', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3722', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37220', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3737', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-40307', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40337', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-40339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34800', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40342', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40343', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34808', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34812', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-40354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34817', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36056', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39339', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-36057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36059', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-39340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39341', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-39342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39347', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-39348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9754', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37948', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-37711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37953', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-8995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-8996', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9002', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39046', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39051', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37990', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-3973', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36173', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39434', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3944', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-36186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3947', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3948', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-39480', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-43148', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-39503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4318', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37851', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39181', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39182', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39183', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39185', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9843', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2022-34256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37852', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34826', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34836', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-34837', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-34838', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2022-34841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36062', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-36244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36271', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39540', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39541', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4328', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-40781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40788', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39077', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39080', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-3537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39086', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3538', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-40828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3910', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35403', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-37713', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-9767', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37963', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-37716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34187', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36744', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36745', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3308', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-34854', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34259', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2020-9849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3815', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34261', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-9850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34266', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3697', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9009', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-9012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9013', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3325', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-9014', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36978', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9018', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37231', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-37373', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37234', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-37374', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37375', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37376', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37378', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-37262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37379', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-3727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9413', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2020-9414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37304', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4045', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34867', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-34868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34873', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-4051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39554', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39556', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36296', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-39558', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4333', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39562', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36313', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36314', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-38617', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38670', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38672', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37976', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3772', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-34875', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-34876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4054', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-3856', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38562', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38583', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35406', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9019', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36979', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39394', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-39402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36075', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36076', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36077', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36078', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3608', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-36080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36083', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-34275', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34276', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34279', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34282', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34283', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34290', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34292', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-34293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9860', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-34296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3817', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-38170', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38012', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38176', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38187', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-3819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9872', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38206', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38207', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36318', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-36321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39596', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39602', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36336', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38589', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-40560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38590', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34909', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-40587', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35409', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-4092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39119', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39121', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39122', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34215', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3803', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38701', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-38702', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43485', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43494', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-37865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34312', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37867', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34313', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-34315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38216', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38217', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34325', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-34328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37909', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34338', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38223', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38642', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-38646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38651', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-40599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40621', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-38675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36092', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36095', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36098', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-42780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-42787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-42792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-42793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36106', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-36107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39125', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39127', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-4100', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2021-39131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39134', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39135', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38058', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38059', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-39212', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38224', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34346', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34354', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38227', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34355', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9883', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34361', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38228', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41032', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39138', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41033', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35452', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39140', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-36108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-42798', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-36110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36111', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-42809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36115', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-42810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36118', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36121', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4282', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-42822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4284', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4292', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9427', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-3731', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-37311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33705', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33706', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33707', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33708', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9432', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33709', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9433', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-9434', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43566', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3974', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38751', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3800', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38752', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38766', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38840', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38853', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38871', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-38875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36980', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-37271', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3326', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-9036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37922', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34368', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38230', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34372', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-34374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34375', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38234', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38235', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38069', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34223', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38072', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37735', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-34224', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38073', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9805', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2020-9806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36351', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36354', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36358', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-43497', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41037', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-35458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41039', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-35459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35461', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39144', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-41040', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-39145', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-35467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39146', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39150', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39151', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-41048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39153', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-41049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35501', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35507', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2022-35508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41050', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-35513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41053', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37940', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2020-9894', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-38238', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33712', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3738', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-37273', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-36982', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37275', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-9040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-37276', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37277', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-37741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3775', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-37750', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3776', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-37760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34228', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37764', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-3813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41057', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-41058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4106', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33103', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-3979', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-3980', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3981', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36533', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39816', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39818', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34432', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2023-39347', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-39349', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38958', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3897', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38974', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38988', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38989', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-39819', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39820', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39821', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39822', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36539', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39823', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39824', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39825', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39826', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-39827', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39828', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39829', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35002', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35016', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3506', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35066', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35069', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35080', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35623', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35624', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39185', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35629', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39197', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39199', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39200', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37278', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-37279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9044', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2020-9045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3700', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34229', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34230', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9814', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36777', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36778', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36395', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-36789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36397', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-36792', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38248', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38249', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38250', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-38251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-38252', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9912', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38253', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9915', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-36145', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36146', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36149', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43072', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36152', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43079', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34380', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-34382', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35645', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39204', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39206', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-39209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39211', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39212', 2.5, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-34234', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34235', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-3778', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39418', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-39419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3444', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-9047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9048', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-3701', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2020-9049', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37322', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37326', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9442', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9443', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37331', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9450', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9451', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9453', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9455', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-9456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39044', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39049', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39056', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3906', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-39061', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-39062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39063', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39070', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39076', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39107', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-39108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36423', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-36424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3626', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39538', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36277', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39545', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39546', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39547', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39548', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39549', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39550', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39551', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39552', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39553', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43297', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-36289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39555', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4332', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39557', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39559', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43323', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-43325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39561', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39563', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4335', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35156', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35171', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3875', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39842', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9465', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9468', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-37343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9470', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9479', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-37347', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9480', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9482', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2020-9483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3735', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3739', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-3958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39582', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39584', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39588', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39589', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39594', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43484', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39597', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3804', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3806', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2023-39456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38084', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3947', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3950', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-38086', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38351', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38352', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38353', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34392', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38354', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38355', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38356', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-3837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9926', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37963', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-38008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3647', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-3311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-43610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39854', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36561', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-36564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-39857', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-39858', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-39859', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-39860', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-43611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37839', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38895', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35205', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38899', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38915', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40724', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2023-40725', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40727', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9937', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9938', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37965', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3964', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36341', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3969', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38123', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38126', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38129', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-39525', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-38130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39528', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-38144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38149', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-39530', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-39531', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38153', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39559', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-39560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39562', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3957', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38162', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2021-38163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38165', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-39584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34467', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-37391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2020-9484', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3643', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-36431', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36432', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36433', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36434', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-36436', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3644', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-36440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36450', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36454', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36455', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36460', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34241', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39873', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34469', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-39640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38175', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-39646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41235', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41237', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35693', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39256', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39257', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39258', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3570', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41256', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35700', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41261', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41263', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35703', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41266', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-35705', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35706', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35710', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38948', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-4073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3650', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38419', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-36471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36806', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-36483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36809', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3649', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36811', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-36493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3652', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-36814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36520', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36817', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-36818', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-36819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3312', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34242', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34243', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38191', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-3820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39741', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39742', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-34472', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36397', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36398', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34247', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37850', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34248', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34249', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34250', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34251', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34252', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3842', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9952', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2022-35717', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41319', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35720', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33733', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33734', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-33737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9488', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9489', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2020-9490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37969', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-39213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39214', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-39215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39217', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3922', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2023-3977', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-39776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-3980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39801', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39810', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38994', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35246', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38995', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38996', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34262', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38158', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-34264', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34272', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34273', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37374', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-4453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-37376', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-40369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-4456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-37377', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37378', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-37379', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-4469', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43620', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43621', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39874', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-43625', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39876', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39879', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-38015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36441', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36443', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36448', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-36449', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-36450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38997', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-40758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38999', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35249', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-39000', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39006', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35250', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39009', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34285', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2020-9861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34297', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34298', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34299', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-38173', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-38178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38182', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39016', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-39017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39021', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2022-35256', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-35260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37364', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9497', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9498', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33121', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-33122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33124', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39882', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39884', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39885', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-36532', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36820', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-36535', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-36538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36539', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36822', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-36823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-36824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36542', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-36826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36543', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-36827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36544', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-36545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-36828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-36547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-36548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-36829', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-3683', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-36830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34306', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-38203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34308', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37862', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2020-9875', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40375', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40376', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37380', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-44766', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4478', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-37382', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-4480', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-40385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37383', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-40386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40388', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-40389', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-39887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3660', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-39227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39250', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39264', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34428', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-34429', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-39285', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-39286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-39287', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2023-39290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39314', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34314', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34322', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-34324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38219', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2023-38220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38221', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9877', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38222', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34334', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37914', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-34348', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2023-38226', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34356', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34362', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-34364', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39953', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39954', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-39955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39956', 4.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2023-39957', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-39040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39041', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-39045', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39048', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3905', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39055', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39057', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-39058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39063', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-39064', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44821', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37385', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44824', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40396', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-37386', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-40397', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40398', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40399', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37387', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4040', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-40400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40401', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-37388', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40402', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40403', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-37389', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44848', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-37391', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4487', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4041', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37392', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37393', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4491', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37394', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-40417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40424', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-40425', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-37398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44962', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4043', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9981', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3740', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-38229', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3437', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37930', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43645', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39897', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39898', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-39900', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38233', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37939', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2020-9893', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38237', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38239', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38240', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-39323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34431', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-34434', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-3802', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39353', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-39354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39356', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-39357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39370', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39374', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-39378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-38242', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38243', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38244', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-38245', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37918', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40729', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4636', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4073', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4646', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40730', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-37922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4647', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4649', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-37923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4650', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-4651', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-40731', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40732', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2021-40733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40734', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4654', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-4655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40737', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40738', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3976', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-3977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44981', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-40438', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-37401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-44984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40442', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37404', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40448', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37409', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44994', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44995', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40454', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39421', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-39423', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-39901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39902', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-39903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36621', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3663', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4365', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39833', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-39835', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35412', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-40931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35414', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-40934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4095', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39124', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-40968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-40984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-40997', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41000', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9993', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2020-9999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38246', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9910', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38247', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-37958', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-39976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41327', 2.5, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-41329', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41332', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-37404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9501', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40739', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40740', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40741', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40742', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40750', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4678', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40752', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40753', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40754', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3793', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4680', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4681', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40756', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4682', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40757', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4683', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40758', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4685', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40759', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37931', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4688', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40760', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40761', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40457', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45003', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40471', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40472', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40473', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40474', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4504', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40479', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4048', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-45052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40480', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40481', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-40482', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40483', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-40484', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-40485', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40486', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40487', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4506', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41333', 5.8, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-41335', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-41336', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-41338', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4135', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-39437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34449', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-39438', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-39439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39440', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-39441', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39447', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-40762', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4695', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40763', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40765', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40766', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-40767', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40768', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40769', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-40770', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40772', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40773', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40774', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37935', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40775', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40776', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40777', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40778', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40779', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-4718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4720', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4721', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4722', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37962', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37963', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37966', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37968', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-4078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39844', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-4360', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-41358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41359', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-35737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4136', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35739', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41360', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-3574', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41363', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-41364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35740', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41365', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41368', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-35742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41369', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-45060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4508', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3375', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37424', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-33752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3376', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2020-9514', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9518', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41045', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-35486', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4105', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41051', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39162', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-39164', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3796', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:H'),
('CVE-2020-9916', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38283', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38286', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9919', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34384', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-3833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34385', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38335', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38340', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38341', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40034', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34624', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39511', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34450', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34452', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38096', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38098', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39514', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38099', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39515', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38100', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38101', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38102', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38103', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38104', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-39516', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38105', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38106', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38107', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34457', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39518', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38108', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38109', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-39519', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34458', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38110', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39520', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34459', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38114', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39522', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38127', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39832', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39834', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-39836', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36542', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39837', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39838', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39839', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3984', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4359', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-36714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39913', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3917', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3560', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-35606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35611', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39184', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-4005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38370', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-40150', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4016', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40164', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-40174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38402', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38404', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34668', 0, ''),
('CVE-2021-38413', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40183', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38421', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-40195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40217', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2023-45107', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-45108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40492', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40495', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-4512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40496', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-45128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40497', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40498', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40501', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40503', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-45131', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40780', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37971', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-40781', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40782', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38136', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38137', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38138', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38143', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39529', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-3953', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2021-38147', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39533', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39549', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39553', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3958', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-38161', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38164', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34462', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39612', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-39615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34464', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-39616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35631', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35637', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39198', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-3920', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35643', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35646', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-3921', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39210', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39215', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39216', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-38502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37981', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-39285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38332', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34386', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34387', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38334', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-38335', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34388', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-38336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34389', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38384', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3377', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3378', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9519', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3379', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-37427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37429', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-9523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37430', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-9525', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36745', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36752', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3676', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39918', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36773', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-3992', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36774', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39927', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38438', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3844', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-38441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38442', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34680', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34681', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34682', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38454', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-34683', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38467', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-38469', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2023-40251', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-3848', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45138', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-40511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45143', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-37421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45144', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-37422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45148', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-37425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45149', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-37426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-45150', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-37428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4516', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4517', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45176', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9526', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37431', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37432', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37433', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9540', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3387', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-37434', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2020-9543', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2022-33870', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-37435', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37403', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-37436', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-37437', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37438', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-33873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-37440', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-33875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3745', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39218', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39219', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-3922', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39220', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-41085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35656', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-39222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41373', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-4139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38397', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38401', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38402', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2020-9932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34397', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2020-9936', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39845', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2021-39846', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:H'),
('CVE-2021-39847', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39849', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3985', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-39850', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39851', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39852', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39853', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4361', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-38530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38531', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38532', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-38537', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-38538', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2023-3854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36793', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-36794', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41444', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41484', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-4150', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-4152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41539', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4156', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-4052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39867', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-39869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-39223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39224', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39226', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-35666', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41100', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-39229', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41104', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-41105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-41107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-41131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41152', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41155', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39233', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-41158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41159', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39234', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-41163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35673', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39934', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39935', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36798', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41578', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41593', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41616', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41627', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-41628', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41629', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41633', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39871', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36583', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-33877', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-33878', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2020-9546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37414', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-37450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-33879', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-3388', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-33881', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40783', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40785', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40786', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40787', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40788', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40789', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38001', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38012', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-38013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38023', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-37987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2020-9942', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-39660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3447', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-41179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35675', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39241', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-35677', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3569', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35691', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39252', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39259', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39262', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41253', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41646', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-41653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45205', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40525', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-40527', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40528', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40529', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34771', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36800', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36801', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39938', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36837', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39944', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-36851', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39945', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-41681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35790', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35798', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35799', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41717', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35801', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37966', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-4126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39268', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41265', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-35704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41267', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4127', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35707', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35708', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35709', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-35712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35713', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41317', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35719', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3572', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36857', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36859', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36865', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3997', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43726', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4374', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36874', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36877', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43746', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2023-4376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36879', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-3860', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-38507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-35802', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35807', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35808', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3581', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35810', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41736', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35811', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41737', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35813', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35814', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35815', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41739', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35817', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35818', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35819', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35821', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41745', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41750', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41751', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40303', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38509', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34795', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34796', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34797', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34798', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-40313', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40338', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34801', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34813', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34814', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40790', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40791', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40792', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38056', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-40793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38058', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-38059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40794', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-40795', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40796', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38064', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38067', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-40814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40818', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4082', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-38070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40823', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40824', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37991', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2020-9950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39861', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-36577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36579', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43616', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-39862', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-43617', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43618', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43619', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39863', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-39865', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-39866', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-40530', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37430', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40537', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45219', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41763', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3585', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-35858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3979', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-3983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39903', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4036', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40360', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-40367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4037', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40372', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3482', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4039', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-34824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39870', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3658', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-41321', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41323', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39272', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41328', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35729', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3573', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-35734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40826', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40827', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38076', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40828', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41135', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41136', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-3860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38600', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41138', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-38606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38611', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41140', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36899', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2022-36900', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2023-43804', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-43805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4381', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36904', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4382', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4383', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-36909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-43838', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4384', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-36912', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36917', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-40046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43856', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36919', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4005', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36921', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36924', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36929', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4008', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40086', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-37993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4040', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4042', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34857', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4522', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-45226', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45240', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45241', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37436', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-37437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45242', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45243', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45244', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-45245', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37438', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-4054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-37971', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-34482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43623', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39875', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39877', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36593', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-39881', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39886', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39888', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35861', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35867', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41149', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-4115', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4764', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-41367', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40093', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36949', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4010', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40102', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-40103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40435', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-34866', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35868', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35870', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35871', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35872', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3589', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39883', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4363', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-35896', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-41836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35900', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-35901', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-35902', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-41838', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-4184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35904', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-4049', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34874', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-34879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-40534', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38554', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43640', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39896', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39899', 3.6, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44083', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36969', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-44086', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44087', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36972', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40118', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36995', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44152', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-44155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45246', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-45247', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37439', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45248', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45269', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2023-4527', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2023-45270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4528', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3661', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-40542', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38597', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4981', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41617', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41619', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4162', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-4986', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4987', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41634', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4991', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41637', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-41638', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41639', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-39154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4995', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41641', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-41643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41646', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41647', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-5002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39155', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41652', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39157', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3916', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-5021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39161', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5023', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39164', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39165', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39167', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3989', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39892', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39894', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-41150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41152', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-4772', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4773', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-41153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4774', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4777', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41156', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41157', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4778', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41160', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3863', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:N/I:N/A:H'),
('CVE-2022-39806', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39807', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39809', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-5353', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41942', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41943', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41945', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-5366', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41950', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-44156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-44161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-44163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-44170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40155', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40157', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34894', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34903', 4.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-40583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38615', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38618', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38621', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4059', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-40591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38641', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-38644', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40597', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-38654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-39282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39283', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43656', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-36672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3822', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3824', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3825', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-38258', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38264', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9987', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-3843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2020-9991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2020-9992', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-37974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-5373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4197', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40559', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-45322', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45348', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-45349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5027', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5029', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5030', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39176', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5045', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39177', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39178', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-5046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5054', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2022-39180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5057', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39187', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5060', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5072', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-5084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5089', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4166', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-40829', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38081', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-38085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38086', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-37023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3703', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-37034', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-37035', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44217', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36713', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36733', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36734', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39915', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36736', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39916', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41973', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-39837', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-5422', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-41975', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-41989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39844', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-41992', 4.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-41993', 4.0, 'CVSS:3.1/AV:P/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-39845', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-39846', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41994', 4.0, 'CVSS:3.1/AV:P/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-3985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4200', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-42000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39857', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42001', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39858', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3986', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39860', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-39861', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39863', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-39864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39867', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39868', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38633', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38638', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-41164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38648', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38649', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41166', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38650', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-38651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38652', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-38653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38654', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38655', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2022-38656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38658', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4117', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38659', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3866', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38661', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-38662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41176', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-3929', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-41374', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41375', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4138', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2023-41387', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-36617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36622', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39904', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-36636', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36638', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39905', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4083', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38290', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3997', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39972', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39973', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-39974', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38295', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39980', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-39981', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39982', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39983', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-39987', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44264', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3706', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38696', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34964', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4068', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-36647', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-43650', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36648', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36659', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3666', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43651', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-36660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39906', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43652', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-36664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43654', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-36667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36671', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39907', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-36676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36687', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-36688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39909', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4427', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-38667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38668', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41177', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-3867', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4118', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41181', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41182', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40562', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40563', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45369', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40564', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40565', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45370', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-40566', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40567', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40568', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40569', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45372', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39889', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40830', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38089', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40834', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-40835', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-38095', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-40836', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40837', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-4141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41419', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41508', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45374', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-45375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4543', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34526', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34529', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34530', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-39999', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4002', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40021', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34594', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40026', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42024', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39909', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-42026', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42027', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-39910', 3.6, 'CVSS:3.1/AV:P/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42029', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5450', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39911', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5460', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5461', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4203', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-41537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39296', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-41595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41599', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4161', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-41614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41626', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-41638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41661', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3669', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-36690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39910', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39911', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36708', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36712', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36727', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36728', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36729', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39914', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-39932', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-39936', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38699', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-3870', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38700', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38701', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38704', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-38705', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38707', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37183', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37189', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37197', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37209', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3721', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-37223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35091', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35093', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35095', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35098', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3872', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38097', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40841', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40843', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40846', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38101', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38103', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40848', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38107', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-38110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40854', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38112', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38113', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38115', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38117', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-38118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4734', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34404', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-34405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38708', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-41186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41188', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38710', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4781', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3675', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-43660', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43662', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-39917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43664', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36760', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-36768', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-43668', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-43669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39919', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36775', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36788', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3993', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-39930', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-4003', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3461', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-34613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40032', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38347', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40033', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-34619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40036', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38373', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38378', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-34655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-41675', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-41679', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2023-4168', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35775', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35776', 4.0, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-35777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35780', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35781', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41682', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35782', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35783', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35784', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35785', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35786', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35788', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35789', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-41697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4171', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35791', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35796', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35809', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-35816', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-4174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41740', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3582', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-41742', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41743', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41764', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-35843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4544', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40570', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4545', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40571', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40572', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40573', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40575', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40576', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45511', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-45540', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-45542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4556', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4557', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3846', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-3848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38488', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38489', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-3849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3798', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38490', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2023-38491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-38494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37980', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-3993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42041', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3994', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-42042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39945', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-42045', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3466', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-40163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34661', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34662', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34665', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-38406', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40178', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-40179', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34667', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-38409', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34669', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40182', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3514', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-35850', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4177', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39948', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-42056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39949', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3995', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42059', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4206', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42060', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42062', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39953', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42066', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42067', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42068', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-42069', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-39954', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-4207', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42070', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-39955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42073', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-40589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39947', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-43711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3995', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3686', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-43713', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3996', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43719', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43723', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36866', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43732', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36875', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3999', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43766', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-43771', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36881', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36884', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4378', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41661', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4782', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:N'),
('CVE-2023-4783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38712', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41192', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-38716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4792', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3872', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2023-4795', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38723', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-4798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41195', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4801', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4802', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4803', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38525', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38527', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38528', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-38529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38416', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40185', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-38419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3842', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38420', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38426', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38427', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34674', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-34676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38430', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38433', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34677', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-38435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38440', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-38443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38448', 6.0, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-3845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38452', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-38455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34684', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38465', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38471', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-38120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38121', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38133', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38135', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-38136', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3814', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36804', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39939', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-3994', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-36831', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36832', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36833', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36835', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39941', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39943', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42074', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35165', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35166', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35169', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-35170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35174', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35196', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38751', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-38758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36885', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38148', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3815', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40870', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38153', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41196', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4805', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3873', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41197', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4806', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38730', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-4807', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41198', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34716', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34717', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38483', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-40260', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-40267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38487', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-38490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-38494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40592', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40604', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-40606', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37450', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40607', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40608', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40609', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37290', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-37988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38731', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41199', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4811', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4120', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38733', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2023-4813', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41200', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41672', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-41674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5106', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39189', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41683', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35873', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35883', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36897', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43799', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43810', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36903', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43814', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43825', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36906', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-43830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-43835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36910', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-36913', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36914', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36915', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42091', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-40023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40034', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-38890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38894', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35204', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-38896', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35206', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-38900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38901', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-38905', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38909', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38910', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-38911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4814', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-38734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41201', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3874', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-41202', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4819', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4820', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38743', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38745', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38749', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4828', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-41205', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-41775', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-35893', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-4178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41797', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35894', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2023-41800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4182', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35895', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-41834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3590', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35903', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-35905', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-35906', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-45612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40612', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-45613', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-40617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45641', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45647', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45648', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-45650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5125', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5133', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-4169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5134', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41694', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5135', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43730', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36873', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36876', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36878', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-43770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-43782', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36886', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-43784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-43785', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36890', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43786', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36891', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43787', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36892', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43788', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36893', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-43789', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-36895', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-43793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38750', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41206', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38752', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41207', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4834', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38753', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-4835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41208', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38754', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38755', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41209', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38756', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-4840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41210', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-4844', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41211', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-38765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4845', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41212', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-38768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38770', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41213', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-37992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36922', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43884', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36930', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4392', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40087', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40089', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-43944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4395', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-43976', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36898', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4380', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-3690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4002', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-41214', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4853', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41215', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38774', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38775', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41216', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38777', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41217', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41218', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38779', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41219', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38499', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34769', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41696', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39193', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39199', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41729', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-3920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39200', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39201', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39202', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-39203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39205', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39206', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4122', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-41220', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41221', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41222', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41223', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-41224', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-41225', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41226', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-41227', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41228', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41229', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-41230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36918', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-36925', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36928', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-3693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4388', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40066', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40067', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-4007', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-43898', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40083', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36943', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-40088', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-34773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38502', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34774', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34775', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38503', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-34778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34779', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-45655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45660', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-45669', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-45674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41239', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-38959', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38967', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44075', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36963', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36964', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44082', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-36967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44084', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44085', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36975', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36980', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36984', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36987', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-44154', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-44157', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-37010', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4015', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-39209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39210', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39211', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-5156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39212', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40091', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42121', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-40093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42122', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42133', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-40117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40126', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4431', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-4124', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38791', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41241', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3478', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-34781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40291', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34782', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40292', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40293', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-34784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40299', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40305', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-40306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3851', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38511', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-40311', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-40312', 2.7, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34799', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40315', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38686', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-37995', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-40129', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40130', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42137', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4216', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39213', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39214', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-39216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3922', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-39224', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39225', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39226', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-42853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42855', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38163', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-40873', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38170', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38171', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38176', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40884', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-40886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-38177', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38178', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4089', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40892', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3818', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-40158', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4568', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-40636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45685', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-3747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-45686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3750', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-3751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4570', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4571', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-3754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3758', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-3759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4033', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34802', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N');
INSERT INTO `tpandora_cve` VALUES
('CVE-2022-34803', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34804', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40349', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-34809', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34811', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-34815', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-40359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34818', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-40368', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40370', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-40371', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40373', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40374', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34830', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36955', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36956', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-36958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2023-44080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44081', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36966', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-36968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-36970', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36985', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36991', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-36993', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40124', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-36994', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-36998', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37000', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42857', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4217', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-42171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4219', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42195', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42196', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42197', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42198', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42199', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42200', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42201', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42202', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42203', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4221', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-38706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38710', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38718', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-38719', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3872', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-38737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-37998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4286', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42866', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42867', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42868', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42869', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-42870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40160', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37030', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4434', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2023-4435', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-4436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44378', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44384', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2023-44386', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-39227', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-39228', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-4173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37009', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40143', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-37011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37013', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4417', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44171', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40153', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-40156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-44205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-37049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44208', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-44210', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44211', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-44212', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-44213', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44214', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44218', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37051', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37059', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40163', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35252', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-35254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39018', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35255', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-39020', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39025', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35257', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35259', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35288', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35291', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35293', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35297', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39032', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-34864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34865', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4048', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-3881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-3883', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-38836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4016', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-37021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40642', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-40643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40645', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40647', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40648', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40649', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-37603', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37623', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3763', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-3765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3766', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3768', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44387', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-40239', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4024', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2023-44388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40247', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4026', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-44389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4439', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-40261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-44390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37302', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40264', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-44391', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44392', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-4864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38795', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-4865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41242', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-38796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-4869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38801', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38802', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-41245', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-38803', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2021-41246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41247', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-4875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41248', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38813', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4876', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41249', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4878', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-4879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4125', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41250', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41251', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4882', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42218', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42235', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4225', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-42917', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-4292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42923', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4293', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4294', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42940', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42943', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4055', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2021-42946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42948', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42952', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42954', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42955', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4057', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42972', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42973', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42976', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42977', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-4058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42979', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-4298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42980', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42983', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42986', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42987', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-4059', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42988', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-4299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42990', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-37022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37032', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-37033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40161', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38183', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38188', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44394', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37308', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44399', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40285', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-37309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37111', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3715', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4428', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-37042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-37044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44206', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44209', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3705', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41253', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3884', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4885', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41256', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-38843', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4886', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41258', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4887', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4890', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38846', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4892', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2023-4893', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-4126', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-41260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41261', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-41268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42993', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42994', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42996', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-4060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43000', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43002', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43003', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43006', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43009', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43013', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43015', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43016', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40604', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43017', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43018', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40607', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-43019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43021', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43022', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43023', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40616', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-43024', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43025', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43026', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43027', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43028', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43029', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43030', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-40624', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43034', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43037', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43039', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-4304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-3894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-38941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-38949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-38950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38553', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38555', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-38559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38561', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38564', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-38565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-38568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38575', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38578', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-42254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42257', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-42258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-40289', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44400', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40292', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37311', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-4444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37312', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-40309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37313', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44463', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-40900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3819', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-40905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40906', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38190', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40909', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-38192', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38193', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-38194', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40910', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4092', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-38196', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-40921', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40922', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38199', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40923', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3820', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-38200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40925', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40926', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38202', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38204', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43045', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43047', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-43048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43050', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40632', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2021-43052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43053', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40636', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4064', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40640', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40642', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40643', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40644', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40645', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40647', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40649', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40650', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40651', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43062', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43063', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40659', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4066', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-43064', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38588', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38598', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-34892', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40575', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-34893', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40166', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40167', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40188', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3723', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37703', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-37704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4065', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39006', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39007', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-39008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39016', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39022', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39023', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39039', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39040', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39041', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39043', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39045', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39046', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39052', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-39058', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-38006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39072', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39078', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-3908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41271', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41273', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-41274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41277', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-41279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42295', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-42300', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-42306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-42308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-42309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4231', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42316', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42319', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-42321', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42322', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-40662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43065', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43066', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43067', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43068', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-4307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4067', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40671', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43070', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40673', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40674', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40675', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-43072', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43074', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40678', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-40679', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40682', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40683', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43081', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43084', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43086', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4309', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-38623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-40594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-40598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3866', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-40612', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4065', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4066', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3493', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-38695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-34963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-34968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43091', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43099', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-40694', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43103', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43105', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43106', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40703', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-40704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40707', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40708', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43114', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40709', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4312', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43129', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-4313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4314', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39229', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-41732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3923', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5160', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39231', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39232', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2023-5165', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-5166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-41749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39233', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-4175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-40875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-40876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35404', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-44467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44469', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-40323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-44471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-44473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40326', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-40327', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-44476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40331', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40337', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40338', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40339', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4034', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40341', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40346', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40347', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-40348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40349', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-44270', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-44272', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-44275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-44276', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3708', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-40164', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37108', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37112', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37146', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-37150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37172', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37173', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40165', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43141', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43145', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-40721', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-43157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40722', 4.0, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2021-43158', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-40723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-40724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40738', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40739', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40742', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-4316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-37705', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40650', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-40651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37706', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37709', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37718', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40656', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37720', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-37721', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-4574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-39158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-3917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39236', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-41752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41754', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5169', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40942', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40943', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40944', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3821', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38211', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38221', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38222', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38223', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38227', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38228', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38229', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38230', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38231', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38233', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37186', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-37191', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37193', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39116', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4090', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35408', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-40918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39118', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-35411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-3912', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4094', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2023-40944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-40946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38850', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38851', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38853', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38855', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38856', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38858', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4900', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-40353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40354', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-40355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40356', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40357', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40358', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-40359', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-40360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40364', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37335', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37340', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37342', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37347', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37348', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37350', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37351', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37352', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37353', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37354', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37355', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37356', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37357', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37358', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37359', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3736', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37360', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37361', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37362', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37364', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37365', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37238', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37240', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37245', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37246', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37257', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3726', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-37264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42331', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-42332', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42335', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42336', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4234', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-37724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37730', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3774', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2023-45749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3775', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-3776', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37767', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-37772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37774', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-45753', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-45757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4096', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:N'),
('CVE-2023-40969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5170', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-3924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38234', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38235', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38236', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38237', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38238', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3824', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40961', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-3825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38251', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40966', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38254', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4097', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-40970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38285', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38299', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38306', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38307', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4098', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-37366', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37367', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40746', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40747', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-40748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40751', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40752', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40754', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40755', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40757', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40759', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40760', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41765', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39242', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-41766', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39245', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39246', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-5174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35455', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39141', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-4104', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39143', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35464', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35465', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35466', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41041', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-35470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35473', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39147', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-35474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-39148', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-41043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35478', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-41044', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-39149', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-35482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-3915', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-35484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41046', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-35490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39152', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-5175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-5176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39251', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-5177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-5182', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39175', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39186', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-38011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4130', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39154', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-39156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41052', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-41054', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-3552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39163', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-39166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35569', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40662', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4576', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-40663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37781', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40668', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37783', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40669', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37785', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37786', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-37787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-5185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39253', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-4177', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39257', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40985', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38334', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-40986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38335', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38336', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38337', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2023-4738', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37796', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-4578', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3780', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4579', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-4580', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-40761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43172', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-40764', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40765', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43177', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39258', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-39259', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-4178', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41780', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41781', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41782', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41783', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39263', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39264', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40140', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40141', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40142', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40143', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40146', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42374', 4.2, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-40151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42376', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5485', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3781', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45807', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-3782', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4581', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-3920', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-39208', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-39209', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39210', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39211', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38013', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2023-5186', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-35585', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39176', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3563', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35630', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-3919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39195', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37368', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37369', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-44488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3737', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4449', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37370', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-37371', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4450', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-4451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40670', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3785', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37864', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37865', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-37866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-35664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4109', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39225', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-41094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41098', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35667', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35669', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-39230', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-39231', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-41154', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35670', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-41160', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41161', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41162', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35671', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-4117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41173', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-35672', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-3924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43180', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40774', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40775', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43184', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40778', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43185', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43186', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43187', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43188', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-43189', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-40805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40811', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38860', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41309', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-38861', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38863', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38864', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-4131', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38865', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38866', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-4901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-39267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4179', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39268', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-39269', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39271', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41792', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39272', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-39273', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39274', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-41798', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-45831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37877', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4068', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-39252', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-39265', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-34426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-38017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40816', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40817', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40825', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40826', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40827', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4319', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43449', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-41155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4345', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41158', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43454', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43456', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43457', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43458', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41166', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41167', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41168', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41169', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-4346', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43460', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41170', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41171', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41172', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41173', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41174', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41175', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41176', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-4347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41177', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41178', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41179', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43478', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-43479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41181', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41182', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41183', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41184', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41185', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41186', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43496', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-4350', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41189', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43505', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41190', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41191', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43510', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43512', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41193', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41194', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41195', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43518', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41196', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43519', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41197', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41198', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4352', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41199', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43522', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41200', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41201', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4238', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-40159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-42381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42387', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-4017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42388', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-42389', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42390', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41391', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43775', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-43778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43779', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43783', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:L'),
('CVE-2021-43786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43793', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43798', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43801', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43804', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-43807', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-43809', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43811', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4123', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41230', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43545', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45336', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-45340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45343', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42476', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-45380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39275', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39276', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4180', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39277', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41800', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-39278', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41801', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3928', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39280', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41802', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-39281', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39282', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41803', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-39283', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4248', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5486', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41233', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43547', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2021-43548', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41235', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4355', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41239', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4124', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43555', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43556', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41243', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41244', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41246', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43560', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43562', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41252', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41254', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41259', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43569', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4357', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41261', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41262', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41263', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43574', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41268', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43576', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43578', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-43579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-41175', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-35674', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-41180', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-35676', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-35678', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3568', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-39246', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-35689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-35690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-39250', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-39251', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-41241', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-35692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-39253', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-39255', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-35694', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-41249', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41412', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-43814', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41414', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41417', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41420', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-4382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41424', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41427', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43822', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4143', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43825', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43826', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43831', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-41471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41477', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-41479', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4149', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41498', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43840', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41513', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4152', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43190', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40830', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43191', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40831', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43192', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40832', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43194', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40842', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-43199', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40870', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43523', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-41202', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41203', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41205', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2022-41206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41209', 4.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-41210', 4.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-43529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41211', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41212', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41214', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2021-43530', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41215', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-41216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43531', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-41312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41313', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41318', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41320', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-39341', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2023-39342', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2023-39344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3443', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-5187', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40680', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45855', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-45856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40683', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4586', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40684', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-37884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43846', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43852', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41547', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43856', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41552', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41553', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41554', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43860', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-41556', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43863', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43877', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43890', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43892', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-41565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41566', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43896', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43905', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-4391', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43932', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43533', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46398', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46433', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-46434', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-46436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46440', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46447', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46451', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46463', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46474', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46475', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46477', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46478', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46480', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46481', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46482', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46483', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46484', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46485', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46486', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46487', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46488', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46489', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46491', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46492', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46494', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46495', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46496', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46497', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46498', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46499', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46500', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46501', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46502', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46503', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46504', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46505', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46506', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46507', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46508', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46509', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46510', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46511', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46512', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46513', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46514', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46515', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46516', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46517', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46518', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46519', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46520', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46521', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46522', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46523', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46524', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46525', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46527', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46528', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46529', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46530', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46531', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46532', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46534', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46535', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46537', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46538', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46539', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4254', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4256', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45466', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45471', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-45473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4270', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-4252', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42521', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42522', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42523', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42524', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42525', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4018', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-42526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42527', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42528', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42531', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42533', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42535', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42537', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40186', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-42543', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-4134', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41344', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-4902', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-4362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43630', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43635', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43637', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43638', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41286', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41287', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-4366', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41288', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-4129', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41290', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43667', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41291', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41301', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41303', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41307', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41308', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41309', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41310', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43701', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43708', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4371', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41315', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43725', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41318', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-43735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43736', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43738', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4374', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41322', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43748', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43749', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4375', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43933', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4159', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41604', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41607', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41611', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43949', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41620', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41621', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43954', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-46540', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46541', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46542', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46543', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46544', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46545', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46546', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46547', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46548', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46549', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46550', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46553', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46554', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46556', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46562', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46563', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46564', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46565', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46566', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46567', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46568', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46569', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46570', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46571', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46572', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43201', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40879', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40884', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-40885', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40895', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-40896', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40897', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43206', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-40912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40923', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40924', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40931', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4321', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-41805', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5192', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2022-39284', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5193', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5194', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-4181', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5195', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-41810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39288', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-5196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3929', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-41817', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5198', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43750', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43751', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-43752', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43756', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43758', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43759', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43760', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43762', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-43764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43766', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43767', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4134', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43772', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4135', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-46573', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46574', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46575', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46576', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46578', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46580', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46581', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46582', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46583', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46584', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46585', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46588', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46589', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46590', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46591', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46592', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46593', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46594', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46595', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4396', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43963', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-4397', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43974', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4122', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43538', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41220', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41221', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-43539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-39363', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-39365', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2023-3937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-39371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-38020', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40988', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38339', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40989', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4743', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-38340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38341', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2023-4747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38342', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38355', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38367', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-38368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42704', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42705', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46596', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46597', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4381', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46598', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43831', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46599', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46600', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-43848', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43849', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4385', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-46601', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46602', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4386', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-46603', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43864', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43866', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46604', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43867', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-46605', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43869', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46606', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43872', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43874', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46607', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-43875', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46608', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-43877', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46609', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-46610', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43887', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43889', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-46611', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43891', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43892', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-46612', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43893', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43900', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-43901', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46614', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43903', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43904', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46615', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-4354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41222', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41223', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-42545', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-42546', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42548', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40191', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42549', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40193', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40194', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42550', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40196', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40198', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-5497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40199', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-5498', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-40200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42554', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-40201', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42555', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42556', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-5520', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2021-42557', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42559', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40206', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-40207', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5531', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-42560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42562', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-4021', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-42563', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43990', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4164', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4400', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41642', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41644', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41649', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-41651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44004', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44005', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41655', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44008', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44009', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44011', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44013', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44015', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44017', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44023', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-44025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41666', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41667', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4404', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41670', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44044', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44048', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44049', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44050', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41684', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41686', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-44051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4169', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44052', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-41693', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44055', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43906', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43909', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46616', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46617', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43914', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46618', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43919', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46619', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4392', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46620', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46621', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43927', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43928', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46622', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4393', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46623', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43931', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-46624', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46625', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46626', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4394', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43940', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46627', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46628', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46629', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46630', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46631', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46632', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46633', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42732', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42743', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-42745', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42750', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43542', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41231', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43546', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2023-4588', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4069', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40210', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42566', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-42567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42568', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4022', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42574', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-42575', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40223', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42577', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42581', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-42583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-34440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34443', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-34444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34445', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-34446', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2023-39436', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-34447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40990', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40991', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40992', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40993', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-38375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40994', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-40995', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-38376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40997', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38377', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-40998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38378', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-38379', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38385', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-38387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38388', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38389', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-3839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38395', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38398', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38400', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4407', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4408', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44082', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-44088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4409', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44094', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41701', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41704', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41713', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41717', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-44140', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-44141', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41724', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41733', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-44151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40954', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43550', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43552', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43553', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43554', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41240', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41241', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-41242', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-43558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41247', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41248', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4125', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41251', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41258', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2021-43566', 1.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43575', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43577', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2021-4358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43582', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43587', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41271', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2022-41272', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-41273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43589', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41274', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41275', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4359', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43590', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-41278', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-4360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41279', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-4361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43610', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43784', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-43785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43788', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2021-43790', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43792', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43799', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43803', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43810', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4141', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-4322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46635', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43946', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46636', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46637', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43948', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46640', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43950', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-46642', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46643', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46644', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46645', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43953', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43954', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46646', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46647', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43958', 5.5, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2021-46648', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46649', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43967', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46650', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46651', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46654', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-46655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46657', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46658', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46659', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46661', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46662', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46663', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46664', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46665', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39291', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-39292', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41819', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39294', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4182', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41824', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41825', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5217', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4259', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42612', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42614', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42631', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42633', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42635', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42638', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42639', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42640', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-42641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42642', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42645', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42646', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-40228', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-42648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-42650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40233', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42654', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40234', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41348', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41349', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41280', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-43615', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43616', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41282', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43618', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43619', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43620', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43628', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41283', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43631', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43633', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41285', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-4365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43659', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43666', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41294', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-4367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43674', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4130', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-43678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41302', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41305', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41306', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4369', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4131', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-44167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42663', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-40237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42666', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42667', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-5535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41827', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39299', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41829', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39300', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4183', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41831', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39302', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-39303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39304', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39306', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-41834', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39308', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46666', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46667', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46668', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43978', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-43979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46669', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4398', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46671', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43982', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43983', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-46677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43984', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-46678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46680', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46681', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46687', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41314', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43712', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4373', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43737', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4132', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43745', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43746', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41325', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41327', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43754', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43757', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4376', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43763', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-43765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41335', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-41339', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4377', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41347', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41351', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41354', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41376', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41377', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4138', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-41350', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-41352', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41353', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41355', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2023-4903', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4285', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43995', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-43996', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43997', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46701', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-43999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46702', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44000', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44001', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46704', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44004', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44005', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-46705', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-44006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44007', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44008', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46709', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44009', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46743', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-44013', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-44014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44015', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41837', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41838', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39311', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41839', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-4184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41840', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-5218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42894', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42901', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42903', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42906', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42915', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42919', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4292', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44016', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44017', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44020', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-44022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-44023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-44024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44031', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41398', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41401', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4378', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43781', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4493', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44937', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-44938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44940', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-44942', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-44944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4495', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44955', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44956', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44959', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4496', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44961', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44962', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45004', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45008', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45017', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45020', 5.3, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2022-45025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45027', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45033', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45036', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45037', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45040', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45041', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4505', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43791', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43794', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-43795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-4380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43805', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43808', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46780', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46782', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40691', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-37897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-37898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43220', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-40959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43221', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-4096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-45050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45051', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45060', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45061', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45064', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-45065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45069', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4507', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45072', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-45073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45077', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43813', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43815', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43816', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43818', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2021-43819', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43820', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43821', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-43823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4144', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-4267', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5554', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42681', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42682', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-5557', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-42683', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42685', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42686', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42687', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-42688', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-4269', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42692', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42694', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-42697', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5561', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42698', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42699', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42700', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-5564', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42701', 5.2, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2023-5571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42702', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-5572', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42703', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4176', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39314', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-5223', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-5227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39315', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-5230', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-39317', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2023-5232', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39318', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41841', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-5233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39319', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2022-39320', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2023-5240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5244', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5255', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39321', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41845', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5256', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5257', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5260', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39324', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4151', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43849', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43862', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4508', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4510', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45103', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45104', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45113', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-45115', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45118', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4512', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45121', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-45122', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45126', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45127', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-45128', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45129', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4513', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45142', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45143', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45146', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45149', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-4515', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38401', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4025', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-42947', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42961', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42967', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-4297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42973', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42982', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42989', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-4299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42990', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42992', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43014', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43035', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43038', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43043', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43044', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43046', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43058', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43063', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4307', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43084', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4309', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-43117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4312', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43142', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43151', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43163', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43166', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43169', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4318', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43213', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4322', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43238', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43241', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43248', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43255', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4326', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-43262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40962', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40964', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4323', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43827', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-41445', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4145', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-4383', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4147', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-43833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4148', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43837', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41495', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43838', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41500', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4384', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41512', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43842', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43845', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-43848', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41532', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4385', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41559', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2022-41560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43875', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4388', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41563', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43891', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41570', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4392', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-43943', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46784', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46790', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-45903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-45907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40695', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-37900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40697', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-4596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40698', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-37901', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2021-40699', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-4070', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-37902', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40700', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4600', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45152', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-45153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45154', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45164', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45166', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45167', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45184', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4519', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45195', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45196', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45198', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45199', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4520', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45202', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45204', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-45205', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45206', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45207', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45208', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4521', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45210', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45213', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45218', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4522', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45221', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45223', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45269', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45280', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45283', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45287', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45290', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-45292', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-5261', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4186', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41861', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-5263', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5264', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5266', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5267', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39328', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5270', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5273', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39329', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-5279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43280', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-43282', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-43284', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43290', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4330', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43306', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43357', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4336', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4338', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43403', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-43405', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-43406', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-43409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43410', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-37903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37904', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40703', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40708', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40709', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37905', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-46066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37906', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-40711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-46087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-40713', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-37908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-40715', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40716', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-40719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4613', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4614', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4615', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-37909', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4616', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-40720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43850', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-41542', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-41544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4155', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41551', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4386', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4156', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41561', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41562', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-41564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4389', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43950', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4162', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43953', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2021-43958', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-4390', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4157', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41575', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4158', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4393', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4160', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43940', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45301', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45304', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45305', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45306', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45307', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45326', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45329', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45331', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45353', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-45355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4620', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-40722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37910', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-37911', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:H'),
('CVE-2021-40723', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-40724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43960', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41622', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43977', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43978', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-43979', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-4398', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43980', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43983', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43985', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43986', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46816', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44053', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46818', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44054', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46820', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-44069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46822', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46824', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44079', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46825', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-4408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44081', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46828', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46829', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46830', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4410', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46837', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46841', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44137', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43416', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43421', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-43430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43433', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43435', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43440', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43474', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43475', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43480', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43481', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-43482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4324', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43948', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4395', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41618', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43951', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43952', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43955', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45369', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4537', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-45371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45376', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45379', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45381', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-45382', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45384', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45386', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-45387', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45389', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45390', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45393', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-45394', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45398', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-45399', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45401', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45402', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45403', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-45404', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-38402', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38404', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38406', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38407', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38408', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38409', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3841', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38410', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38411', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38412', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38413', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38414', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38416', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42705', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42706', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40257', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5579', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42707', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5581', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42711', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5585', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42712', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5586', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40264', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-42713', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42714', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42715', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-5591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42716', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2023-5595', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42719', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42720', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42721', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42722', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42723', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42724', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42725', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42726', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42727', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42729', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42730', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42731', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42732', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40268', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-42733', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40269', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-42734', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42735', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42737', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42738', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44140', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46848', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-4415', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46850', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44151', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44153', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46853', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-46871', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46872', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46873', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-46877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46878', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46879', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44211', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-46888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44212', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3933', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41865', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41866', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5287', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41867', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39330', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-41868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41869', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39332', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39333', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5291', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39334', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43961', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-43969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43976', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43988', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41628', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41629', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-43989', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41636', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43998', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44000', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44001', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41646', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4165', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41654', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44007', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44010', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44012', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44016', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44018', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4402', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44020', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44032', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-44035', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41669', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-44040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-44041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41671', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44045', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4136', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44280', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44299', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44312', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44321', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-44334', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44339', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44342', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44343', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41784', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41787', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44421', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44425', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43488', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-43490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43497', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39335', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-39338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39339', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-5293', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39340', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-5296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2023-5297', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5298', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5302', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5303', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5304', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5305', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5313', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39346', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5316', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39347', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-44216', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-44232', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44235', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44236', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44244', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44263', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44264', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44267', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44268', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44280', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-44283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44289', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4429', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44290', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44295', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44311', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-44312', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44313', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44314', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44315', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44316', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44317', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44318', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44319', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44320', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44321', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44345', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-45406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4163', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41643', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41645', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44002', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44003', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41652', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44006', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44014', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44021', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44024', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-44028', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4403', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44031', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44033', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41668', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44038', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4167', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44043', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41672', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44047', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40725', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4624', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-37913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-40726', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-40727', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4630', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-4325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43255', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-43256', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43257', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43258', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43264', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43265', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43266', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43269', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4097', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-43270', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40971', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43271', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40972', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43272', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40974', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43273', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-43274', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43275', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40976', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-43276', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43279', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40978', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40979', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41687', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41703', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-44111', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41709', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4171', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-44117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41711', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41714', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44138', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4172', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-4414', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41722', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5318', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39349', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5319', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3935', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5321', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39351', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-40276', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-40277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4028', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40284', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40287', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-40288', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-42739', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45407', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-45409', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44144', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-41727', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44145', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41731', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41732', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44147', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4415', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44150', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41739', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-44154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41740', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44176', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41741', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44179', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44181', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41744', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44182', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44183', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-41748', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44186', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44188', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44189', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44191', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44192', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44193', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44194', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5330', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2023-5331', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41013', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41014', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41015', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41018', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3842', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43286', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43287', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43289', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-4329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43290', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43293', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40980', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-43294', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43295', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43296', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40981', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43297', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41691', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44078', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-44081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41696', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41697', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41699', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44095', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44096', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41702', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4410', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41706', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-4411', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41710', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-4412', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44139', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4173', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41736', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44153', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44155', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44161', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44166', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2021-44169', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-44170', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44172', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41742', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-44180', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-45411', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40289', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-4029', 2.7, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40290', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40291', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42743', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40292', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40293', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40295', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40296', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42748', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40299', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4030', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-42750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40302', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42753', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-42754', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-40303', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42755', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-40304', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3936', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4187', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43299', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43300', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43302', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-43303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43306', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43307', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4101', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-43310', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43313', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43314', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43316', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4102', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-43521', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43528', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-4353', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-43531', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43533', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43539', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43540', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43548', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43549', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43552', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4356', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43563', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43568', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43571', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43573', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43589', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43590', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43592', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43593', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43594', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43595', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43596', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43597', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43599', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43601', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43603', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43606', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43607', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43609', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4420', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44201', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44203', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44206', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-37915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4631', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-37916', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-40728', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-37917', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-45412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45414', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-41743', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41745', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41746', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44185', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-41749', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44187', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-4419', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44190', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44195', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44198', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44199', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44202', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44204', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44205', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44207', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4421', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44215', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44216', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44219', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4422', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44222', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44224', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-44225', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-44226', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41765', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43317', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43319', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4332', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4103', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43323', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43325', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41032', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4333', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41034', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43331', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43332', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41035', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45416', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-45417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43610', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43611', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43612', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43613', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43614', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43615', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43616', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43617', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43618', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43634', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43638', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43640', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43641', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43649', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4365', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45419', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-43333', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-41037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43334', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4104', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-43336', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43337', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41043', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4105', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43358', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41060', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41061', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41063', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41064', 4.0, 'CVSS:3.1/AV:A/AC:H/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-41066', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41076', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41078', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41079', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4108', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4338', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41085', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43388', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4109', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43389', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41766', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41767', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41769', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42756', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40306', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43650', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-43660', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43665', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43667', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43671', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43672', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43673', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43677', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43679', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45424', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45425', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45426', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45428', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45430', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45431', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45432', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45433', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45434', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45435', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45438', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45444', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46449', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46456', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2022-46457', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4646', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-46463', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4647', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4648', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46489', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46490', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-46496', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4650', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46501', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46502', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46503', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4651', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4652', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4653', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4654', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4655', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4656', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4657', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4658', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4545', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45451', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45452', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45454', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45458', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4546', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45468', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45473', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45474', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-45476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45478', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45479', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4548', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-45480', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45481', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45482', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45483', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45484', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-4549', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-45491', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45493', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45494', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45496', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4550', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4551', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4552', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45527', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45529', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4553', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-45535', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45536', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45537', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45538', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45539', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45540', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45541', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45542', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45546', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4555', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4368', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43684', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43686', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43687', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-43688', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43689', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43690', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-43691', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43694', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43696', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43698', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43699', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4370', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43703', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41878', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39360', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-4188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4190', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4191', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41917', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39364', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41368', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41372', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-41373', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41374', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4904', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-43705', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-43706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43707', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43708', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43710', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43711', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4372', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43720', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-43721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4373', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40308', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40309', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4031', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-40310', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42757', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40311', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40313', 3.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:L'),
('CVE-2021-4276', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40315', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40316', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42761', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40318', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42762', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-40319', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4032', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40320', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42764', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-40322', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40323', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42766', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-40324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4033', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44228', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-4423', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44232', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-44233', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44234', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44235', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4424', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44244', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38420', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38422', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38423', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38425', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38426', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41918', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39365', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39367', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39368', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-39369', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3937', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39370', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39371', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39374', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39375', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39376', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39377', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39378', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4558', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45586', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-45587', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-45589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4559', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4560', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45608', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4561', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4562', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4563', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45634', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45635', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45636', 5.2, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-45637', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45639', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4564', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4565', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4567', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-4568', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45685', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45689', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4374', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43740', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43747', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43748', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43749', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4375', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45680', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45681', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45683', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44349', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41781', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44420', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2021-44422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44423', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41793', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41796', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44454', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44462', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2021-44464', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44465', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44466', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44476', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2021-44478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44484', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44485', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41800', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2022-44361', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44368', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44369', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4339', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41103', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43390', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41104', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43391', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41105', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41106', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41107', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4111', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-43396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-43397', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41115', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43398', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-43399', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43400', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-41119', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43403', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41121', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41122', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-43405', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41123', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41127', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-43408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43409', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41131', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44477', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44486', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44487', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41801', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44488', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-41802', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-44489', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41805', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41806', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41808', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44502', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44504', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44506', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44507', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44509', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44510', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44512', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44513', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4181', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46623', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4663', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46639', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4664', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46645', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4665', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46651', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4666', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46660', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-46662', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46663', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46664', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-4667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46675', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46676', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46677', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46678', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4668', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46683', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46684', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46685', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46686', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46687', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46688', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-46689', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42767', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-40337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4034', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4277', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40347', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42770', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42771', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40354', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40357', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40358', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40359', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4036', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42775', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-42776', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-40365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42777', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42778', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-42779', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-4278', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45690', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45693', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4570', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45703', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4571', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4572', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-45722', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45728', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45729', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45730', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45748', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45755', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45766', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-45769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4577', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45770', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45771', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4578', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45782', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45783', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45786', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45787', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39380', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-39381', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-39382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39383', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39384', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-39385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39386', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39387', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39388', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39389', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-39392', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-39393', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-39394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39395', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39397', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39398', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39399', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39400', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4425', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4426', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41771', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41772', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44263', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44266', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44269', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-4427', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41777', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41778', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44273', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44277', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44279', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42780', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-4037', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-45685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45687', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43753', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-45689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43754', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45692', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43755', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45694', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45695', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45697', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45698', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43758', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45699', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45700', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45703', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4376', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43410', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41133', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41135', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41139', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43420', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41141', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41143', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41144', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-43432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41145', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41146', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-43438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4344', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-41148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43441', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41149', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41150', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41151', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43446', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-43447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41376', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4138', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41380', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41381', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41382', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41388', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4139', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-41390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45797', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-45798', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4580', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45801', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-45802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45804', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2022-45807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45812', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45816', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45821', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45822', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45824', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-45825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45828', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45829', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-4583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39402', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:C/C:L/I:N/A:N'),
('CVE-2022-39403', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-39404', 3.4, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-39405', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2023-5344', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4428', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44331', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44335', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44348', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44351', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44494', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44503', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44505', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44521', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44524', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44526', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44531', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-41152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-43448', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41153', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-44370', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44371', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44378', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H');
INSERT INTO `tpandora_cve` VALUES
('CVE-2022-44379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45842', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45846', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45849', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45857', 5.3, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:L/I:L/A:H'),
('CVE-2022-45858', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-45859', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45866', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-45867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4182', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44568', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44584', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44585', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44590', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44591', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44593', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44599', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44600', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44617', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44618', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44647', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44648', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41833', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44650', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41837', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44655', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44664', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44667', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44679', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44683', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2021-44692', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4184', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4669', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46691', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46692', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-46693', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42781', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-40402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42782', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-40403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4042', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42787', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42791', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-40429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40430', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40431', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42808', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40432', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42809', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40434', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40438', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42810', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4044', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4282', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40440', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40443', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40444', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4283', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42833', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-4046', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42835', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40468', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42839', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4284', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45704', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43760', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-45705', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-45706', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43763', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45707', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45709', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43765', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45710', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45711', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45712', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45714', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45715', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4377', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45718', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43770', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-43771', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45719', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43772', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45720', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43773', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43775', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45721', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45729', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-43776', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45730', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-45744', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45745', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45760', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45761', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45762', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45763', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45764', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45767', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38890', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41392', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3890', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-38900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41394', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3891', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41395', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-38916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41396', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3892', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38928', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4140', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-41402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3893', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41413', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41797', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41799', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44453', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44458', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-44461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44463', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44380', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44381', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-44384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44389', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4439', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46696', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46698', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45769', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45786', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45788', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45789', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45791', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45802', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45806', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45807', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45811', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45818', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45819', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45821', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45829', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45830', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45831', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45832', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45833', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45834', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45844', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45845', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45846', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45847', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45851', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45852', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-45860', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45861', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45863', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45864', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45866', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38427', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38428', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38429', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41832', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44649', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41836', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44651', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44653', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41839', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44657', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44659', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44662', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44663', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44665', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44673', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44674', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44675', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44676', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44677', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44678', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46699', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4670', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46705', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-39406', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-4192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45886', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45890', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45892', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45894', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45895', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45897', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45899', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45901', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-45903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45907', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45909', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45912', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45913', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45919', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45926', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45927', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45928', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45929', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45930', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45932', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45933', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45934', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45935', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45936', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45937', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45938', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45939', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45941', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45942', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45943', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45944', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45946', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45947', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45948', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45949', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45957', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45958', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45960', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44522', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41813', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44523', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44525', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44528', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44529', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41828', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44533', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44537', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4671', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4672', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44390', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41851', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41858', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2021-45967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45968', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45969', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-45970', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-45971', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-45972', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-45975', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45978', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45979', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45980', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45985', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46019', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46021', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46022', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46028', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-46030', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46037', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-46038', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46039', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46040', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46041', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46042', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46043', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46044', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46045', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46046', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46047', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46048', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46049', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46050', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46051', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46052', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46053', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46054', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46055', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46061', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46062', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-46063', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-46064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46065', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46067', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46068', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46070', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46072', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46074', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46076', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46085', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-46086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-46087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-46102', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46104', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46107', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44682', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44685', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44686', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41840', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41841', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41843', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41844', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41845', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41846', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4673', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46733', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-4674', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46741', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-46742', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4675', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46751', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:L'),
('CVE-2022-46754', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-46755', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4676', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46764', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46768', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46769', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4677', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46770', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46771', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-46773', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-46774', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4678', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46781', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46782', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46783', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4679', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46792', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46793', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38430', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41021', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38431', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41022', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41023', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38432', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41024', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38433', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41025', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38434', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41026', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38435', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41027', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38436', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38437', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41028', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3844', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38440', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38441', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38442', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4103', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38443', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-38444', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41030', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-38445', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38446', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38447', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41031', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38448', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38449', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3845', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41033', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41034', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41035', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38450', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41038', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41039', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38454', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44540', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44542', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44543', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44544', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44547', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-44548', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44549', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44554', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4183', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-38936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3894', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-41418', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3895', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3896', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38970', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-4142', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4905', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-39407', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39409', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2021-41924', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39412', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39419', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39420', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-39421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39422', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39423', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-39424', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39425', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48161', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4817', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48177', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48178', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4818', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-48191', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48195', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48217', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4823', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4824', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4825', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48256', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-48257', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-48258', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-46110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46115', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46141', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46142', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46143', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46148', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46149', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46797', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-46798', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2022-46799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4680', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46800', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46805', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2022-46806', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4681', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46810', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46812', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46813', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46814', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46816', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46817', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46819', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46822', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46823', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46824', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46825', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46826', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46827', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46828', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46829', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4683', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46830', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46831', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46835', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46836', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4684', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44400', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44401', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44402', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44403', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44415', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4442', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4443', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4445', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44451', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44457', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4186', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4048', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-40482', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40484', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40485', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40487', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40488', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-40489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4285', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40494', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45873', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45876', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-45877', 3.6, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4588', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46150', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46151', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46152', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46153', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46154', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46155', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46156', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46157', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46158', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46159', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46160', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46161', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46162', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46163', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46165', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46166', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46168', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46169', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46170', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46171', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46174', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46179', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46195', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46200', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46204', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46225', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46234', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46236', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46237', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46238', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46239', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46240', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46243', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-46253', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46255', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-46270', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4104', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41041', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-3846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41042', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41043', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38461', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41054', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4752', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4448', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44498', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-44499', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4450', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44500', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-44502', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4451', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44510', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4452', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46841', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46842', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46843', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46844', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46848', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46850', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-46851', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46852', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46853', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46857', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46858', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4686', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46861', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46863', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46868', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46869', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4687', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-46870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46872', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-4826', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4827', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48279', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4828', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48281', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-48282', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48283', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48284', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48285', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-4829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4830', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48303', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-48307', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-48308', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-48309', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4831', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48310', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-48317', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48318', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-48319', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4832', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48320', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-48321', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48324', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48326', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48327', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41859', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41860', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41874', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:N/A:N'),
('CVE-2022-41875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41876', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41877', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2022-41878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39426', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39427', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-39428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39429', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-3945', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-3946', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3949', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3952', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-3956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-3958', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-3960', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-3961', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3962', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3964', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-3965', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-3966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3967', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3969', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3971', 3.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-3974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3976', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38971', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38972', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38974', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-4143', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38975', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41432', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-41433', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39013', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:L'),
('CVE-2022-39014', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4906', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4833', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48332', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48334', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48335', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48336', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-48339', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-48341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48343', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48344', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4835', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4836', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48364', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-48365', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48366', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-48367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4837', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4838', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41842', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41847', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46308', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46309', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46310', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46311', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46312', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46313', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46320', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-46322', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46326', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46327', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46328', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46329', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46330', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46331', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46332', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46333', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46334', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46335', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46336', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46337', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46338', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46339', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46340', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46342', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46343', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46344', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46345', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46346', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46347', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46348', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46349', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46350', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46351', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-46354', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-46355', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-46359', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-46360', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46361', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46362', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46363', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46364', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46365', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-46367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46368', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-46371', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44696', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44697', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44699', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44701', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44702', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44703', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41880', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-41881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41882', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41883', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44698', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44700', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4188', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3978', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-3979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3980', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39800', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39801', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5346', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4841', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48422', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4453', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44532', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44533', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44534', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44535', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44544', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4455', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44566', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44572', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44574', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-44575', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44576', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44582', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44583', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44584', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-44705', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41889', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44709', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44711', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41890', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4185', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44712', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41894', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44714', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-41897', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46875', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-44585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44586', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4459', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44594', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44608', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44610', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44612', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44617', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44619', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4462', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-44621', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44622', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-44623', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44624', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44627', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:L'),
('CVE-2022-44628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44715', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44726', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44731', 6.0, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-46877', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-46878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46879', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-48426', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48427', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48428', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48429', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4843', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-48430', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-48431', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48432', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-48433', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-48434', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48435', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-48437', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4844', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4845', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4846', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-48468', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4847', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-48474', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-48475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-48476', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39802', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39803', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39804', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39805', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5350', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-4193', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-39018', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39019', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3902', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-39020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39021', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39022', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4145', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2022-39024', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39025', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39027', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41456', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39028', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41458', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41459', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39029', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39030', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39031', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-4146', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-39032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39033', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41460', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39035', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44713', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41898', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44716', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44717', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-44718', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44719', 5.8, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:N'),
('CVE-2021-44720', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44725', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44730', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-41862', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4187', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4688', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46880', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-46881', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-48477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4848', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-48481', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-48483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4849', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4850', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-41902', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-41903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41906', 5.8, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:N'),
('CVE-2022-41908', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4191', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4190', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44631', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44634', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44638', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44640', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44641', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44644', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44645', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44646', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-44647', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44648', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44649', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44650', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44651', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44652', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44654', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44688', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4469', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46882', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46884', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39040', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39043', 1.4, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41464', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41465', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4147', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-41471', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41472', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4907', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-46885', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46886', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46887', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46888', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46889', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4689', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46890', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-46891', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46898', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4690', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46900', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-46901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-46902', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46903', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46904', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46906', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46907', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46908', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2022-4691', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4692', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46934', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4694', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46945', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46946', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4695', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46951', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46952', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46953', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46954', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46956', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46957', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46959', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4697', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46973', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4698', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44690', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44691', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44692', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44693', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44694', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44696', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44702', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44704', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44708', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-4471', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44713', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-44715', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44717', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-44718', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-4472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44724', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44725', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44726', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44729', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-4473', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44730', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-44731', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-44732', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44733', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44734', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44735', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44736', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44741', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44742', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44743', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44744', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44745', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44746', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44747', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44748', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44749', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4475', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39811', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-39812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39813', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41947', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39814', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39815', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41948', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39817', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39819', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41952', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39821', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41965', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39823', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39824', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:H'),
('CVE-2023-5377', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-3983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5399', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39832', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39834', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39835', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41972', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39836', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-5421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:C/C:L/I:L/A:N'),
('CVE-2022-39839', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3984', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39840', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41976', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-4198', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2021-41988', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4199', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45909', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-4591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45910', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-45911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45917', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45918', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-48503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4851', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-48521', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-48522', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48538', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-48541', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-48545', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-48547', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4855', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48554', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4856', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-48560', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-48564', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-48565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4753', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41057', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-4106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4754', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4755', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4756', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41065', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41066', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4758', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41067', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4759', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4107', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4760', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41072', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-41075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41077', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38467', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-44750', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44751', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44752', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44753', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44754', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44755', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44756', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44757', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-44758', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4476', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4477', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4478', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44784', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44785', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44786', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44788', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-44789', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4479', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44790', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44792', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44793', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44794', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44795', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-44796', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44797', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4480', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4482', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44820', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4483', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44830', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44838', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4484', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44840', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-44849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4485', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4486', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4487', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44874', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-44875', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44877', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4699', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46998', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46999', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4700', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47002', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47007', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-47008', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4701', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47010', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-47011', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-47012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47015', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4702', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47021', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47022', 3.6, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47024', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41886', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41887', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44706', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44707', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44708', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44710', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4189', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41921', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-41922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41924', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-41925', 6.0, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-41926', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41927', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:H/A:N'),
('CVE-2022-41928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4488', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4489', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44898', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-44900', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-4491', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-44910', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4492', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-38468', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-38469', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4108', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3847', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38470', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41080', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38472', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-41082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4193', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47027', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47028', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-47029', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4703', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-47034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4704', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-47042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4705', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-47053', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4706', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47069', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-47073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47075', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4708', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-47083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47086', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-47087', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47088', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47089', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4709', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-47091', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47092', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-47093', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47094', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47095', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4710', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47102', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47105', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4711', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-47129', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47130', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-47131', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47132', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47134', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47137', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47138', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47139', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4714', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47140', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47141', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47144', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47145', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47146', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47147', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47148', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-41930', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:L'),
('CVE-2022-41931', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41932', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41935', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41936', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41938', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41939', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:N/A:N'),
('CVE-2022-41940', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41941', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41942', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38473', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-41083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38475', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-41084', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:N/I:L/A:N'),
('CVE-2022-45920', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-45921', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45922', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45924', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-45925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45927', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45930', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45931', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-45933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47152', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47155', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47157', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47158', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47159', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4716', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47163', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47165', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4717', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47171', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47172', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47173', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47174', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47177', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47179', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4718', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47180', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47184', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47185', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-38476', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41087', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-38477', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41088', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41089', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2021-41487', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42009', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-4201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39870', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39871', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39872', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42011', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39873', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-42012', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39874', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39875', 2.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-42013', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42015', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39877', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39878', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5441', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-41943', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41944', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41946', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41947', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41949', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4195', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-48566', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4857', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-48570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-48571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-48579', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-48580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48582', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48584', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48585', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48587', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48588', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4859', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48590', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48592', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48593', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48595', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48596', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48600', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48601', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48602', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4861', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-48612', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4862', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:L/A:N'),
('CVE-2022-4863', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-4864', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4865', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-4866', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-4867', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4868', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4870', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4719', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47194', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47195', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4720', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4721', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-4722', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4723', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4724', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4725', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4726', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4727', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4731', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47317', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47318', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4732', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4733', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4761', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-45935', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45936', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-45938', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-45939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-45942', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45956', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45962', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-45966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45969', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4597', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45982', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-45988', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4599', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-45990', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4601', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46020', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4603', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46047', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4605', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46058', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4606', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46061', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46062', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4607', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46071', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46072', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46073', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46081', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4609', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46093', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:L/A:N'),
('CVE-2022-46095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4610', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46101', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4611', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46117', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46118', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46119', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4612', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46123', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46124', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46128', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4613', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-46135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46137', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4614', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41490', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39046', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41495', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39047', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41496', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41497', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41498', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41499', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39049', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39052', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-4908', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4734', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4737', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47372', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47373', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47376', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:L'),
('CVE-2022-47378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4738', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47380', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47381', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47384', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4871', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4872', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-4876', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4878', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4879', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4880', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4881', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4882', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4883', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4884', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4885', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4888', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46145', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46146', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46148', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46149', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:L'),
('CVE-2022-4615', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46150', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46151', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46153', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46154', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-46155', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46156', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46157', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47385', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47386', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47388', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4739', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47390', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47391', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47392', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47393', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47395', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-47406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47407', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-47408', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-47409', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4741', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-47410', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47411', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47412', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47413', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47414', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47415', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47417', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47418', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47419', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47421', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47422', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47423', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4743', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47431', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47433', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47434', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47435', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47436', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47437', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47439', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47440', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47441', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47444', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47446', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47448', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47449', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4745', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:L/A:N'),
('CVE-2022-46158', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46159', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-46160', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46161', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46164', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46166', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46167', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46168', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4895', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4896', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4897', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4898', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4899', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4901', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4903', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4904', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:H'),
('CVE-2022-4905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46169', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4617', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46170', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46171', 4.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:N/A:N'),
('CVE-2022-46172', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:N/I:L/A:L'),
('CVE-2022-46173', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-46174', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-46175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46176', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-46177', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-46178', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46179', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46180', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46181', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4619', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4622', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4623', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4624', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4625', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4746', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4749', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4750', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47501', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47502', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47503', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47504', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47505', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47506', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47508', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47509', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4751', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47512', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47515', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47516', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47517', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41950', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41952', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-41953', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41954', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41955', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41958', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4196', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41960', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-41961', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41962', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41900', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41901', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41904', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-41905', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41909', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41910', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-3848', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41091', 3.7, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:L/I:L/A:L'),
('CVE-2022-38481', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41092', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38482', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-41093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38488', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38489', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41094', 3.6, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41096', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3849', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38490', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41097', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-38491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38493', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38495', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38496', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41099', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38497', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-4110', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41100', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3850', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-38509', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41101', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-41103', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41998', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42003', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4201', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4203', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41913', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-41914', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41915', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-41916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41917', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41918', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:L'),
('CVE-2022-41919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4192', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46257', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46258', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4626', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46265', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-4627', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4628', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46280', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46282', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46286', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-46287', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46288', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46289', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4629', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46290', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46291', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46292', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46293', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46294', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46295', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46300', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-46302', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-46303', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46309', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4632', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46329', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4633', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46330', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46331', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-46332', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-46333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46334', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46338', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4634', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46340', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46342', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46345', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46346', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46347', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46348', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46349', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46356', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-46357', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-46358', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-46359', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-46360', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46363', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38512', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-3852', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-38527', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38528', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41105', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-3853', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38530', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41106', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-38532', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38533', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41109', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-38537', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4111', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-38539', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3854', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41110', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4762', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41963', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-41964', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41967', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-41968', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-41969', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:L'),
('CVE-2022-4197', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41970', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-41971', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41973', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41974', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41975', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41977', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-41979', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41982', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41985', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-41987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41988', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-41989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4199', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41992', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41994', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41996', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-41999', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42004', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4752', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4907', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42010', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42011', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42012', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4202', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42034', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42039', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42045', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4205', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-46364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46365', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-46366', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46367', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46368', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46369', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4637', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46370', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-46377', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46378', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4638', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46382', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46383', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46387', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46389', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4639', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46391', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46392', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-46393', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46395', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46396', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-46397', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4640', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46404', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46405', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-46407', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46408', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-46410', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46412', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46413', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4642', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46421', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4643', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46438', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4644', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42067', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4207', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4208', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4209', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42096', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4210', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4211', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42128', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42130', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42136', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4217', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42176', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42183', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-42189', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42197', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4220', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-42229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4223', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42242', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42243', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42247', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42249', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42252', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-47522', 5.9, 'CVSS:3.1/AV:A/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47524', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-47529', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4754', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47547', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-47551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4756', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4757', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47577', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47578', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4758', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47581', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47586', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47587', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47589', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47590', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47591', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47592', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47593', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39055', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39056', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39057', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41500', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39058', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41502', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39059', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3906', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41511', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39060', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41524', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39061', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:L'),
('CVE-2021-41525', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-39062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39063', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41526', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41530', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41531', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41532', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39069', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41533', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-3907', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41534', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-41535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41536', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41537', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41538', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2023-4909', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44739', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-44741', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44742', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44746', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44748', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44757', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44758', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42260', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42261', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44829', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42265', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44832', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44839', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-46440', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-46442', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-46443', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-41937', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-4194', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42100', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42114', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42126', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42129', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42132', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42143', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42149', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4218', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-42187', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4219', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-42199', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42201', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42205', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42218', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42236', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38540', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41111', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-38541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41112', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-38542', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41113', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-38545', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-41114', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41117', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-41118', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41119', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4112', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-41120', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41121', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41122', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41123', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41125', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3855', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41126', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38550', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38553', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41127', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2021-41128', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3856', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41129', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41130', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-3857', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41131', 5.8, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:N/I:H/A:H'),
('CVE-2022-38573', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38576', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41132', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47595', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47596', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47598', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4760', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47600', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47602', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47603', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47605', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47606', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47607', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47608', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47609', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4761', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47610', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47611', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47612', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-47613', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47614', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47615', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4762', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47629', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4763', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47630', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-47631', 5.9, 'CVSS:3.1/AV:L/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47632', 5.9, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47633', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47634', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-47635', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4908', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-47636', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47637', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4764', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4765', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47653', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47654', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47655', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47656', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47657', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47658', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47659', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4766', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-47660', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47661', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47662', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-47663', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47664', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47665', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4767', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-47673', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4769', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-47695', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47696', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4770', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-47703', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4771', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47714', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47715', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-47717', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4772', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4774', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47740', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47745', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47757', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4776', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47762', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47766', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47768', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47769', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4777', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47770', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4778', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47780', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4781', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4782', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4783', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4784', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4785', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47854', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47859', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4786', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47860', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47861', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47862', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47864', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47865', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47866', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4787', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47870', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47872', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47873', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47874', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47875', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47876', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47877', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47878', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47879', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4788', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47880', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47881', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4789', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47895', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47896', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42264', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44833', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44835', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44838', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44848', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44852', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44854', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44858', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44868', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44875', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44877', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42292', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42299', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42301', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42302', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44903', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44906', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42305', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42306', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44911', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42307', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4231', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-44916', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44917', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-38577', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4763', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44857', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-44862', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44866', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44876', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42291', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-44886', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44892', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44896', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42300', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-44900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44901', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42303', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44908', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42308', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-44912', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44918', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44919', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44920', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44924', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44937', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44942', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44961', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44964', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:C/C:N/I:N/A:H'),
('CVE-2021-44967', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44969', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44974', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44975', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44977', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44981', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44983', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44992', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44921', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44922', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44923', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44925', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44926', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44927', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44935', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-44957', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44960', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44962', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44965', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44968', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44970', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44993', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45003', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4233', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45005', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45007', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2021-45008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45010', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45014', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45015', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-45017', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45018', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45024', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45025', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45026', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42339', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45029', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42340', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42341', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42342', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42344', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42345', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45041', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4235', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45042', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42351', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42356', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45046', 6.0, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-4790', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47908', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47909', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4791', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47911', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47917', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-4792', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47926', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47927', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47928', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4909', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-41978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4198', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-41981', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-41983', 1.4, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42002', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-42009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42036', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42038', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42042', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42044', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42046', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42054', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42055', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4206', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42064', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42066', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42069', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42070', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42073', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42075', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42095', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42099', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5468', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39915', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-5470', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5471', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41539', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4911', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4913', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4914', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-4154', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2023-4915', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41540', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4917', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3858', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41133', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38580', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-38582', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-38583', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3859', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41134', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-38594', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42364', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45056', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45058', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4237', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42374', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42377', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42378', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42382', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42384', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42387', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42388', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42392', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45067', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42398', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45071', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42402', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42403', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45079', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-42406', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42113', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42116', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42119', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4212', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42124', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42127', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4213', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42131', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-4214', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42142', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42147', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4215', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42154', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4216', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42175', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42182', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42188', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42198', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42200', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42206', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42227', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42235', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42238', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42241', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42245', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42246', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42248', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42250', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42254', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42255', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42256', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44740', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42257', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2021-44743', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42258', 5.5, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:L/A:H'),
('CVE-2021-44747', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-44749', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-44751', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-42259', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4226', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44759', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44768', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-44775', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-44777', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-44779', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44790', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45083', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-42409', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45086', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42416', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42423', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45096', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2021-45097', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45098', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42425', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45100', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42426', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45101', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-45103', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-42048', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42050', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5473', 3.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-4793', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47932', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42428', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4243', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42438', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42442', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42444', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4245', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42452', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42453', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-45105', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42455', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42458', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42460', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45222', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42461', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45225', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45227', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42464', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45231', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45253', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45256', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45257', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45259', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45262', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45263', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45268', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45286', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-45289', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45291', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45297', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42472', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-45328', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45335', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-45338', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45341', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45345', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45348', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45364', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42262', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44828', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42263', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-42266', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42267', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44836', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44837', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-44840', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44847', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44856', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-44859', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44860', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4228', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-44874', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44878', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-3908', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-4928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41547', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3909', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45035', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45036', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-45038', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-45040', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42346', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42348', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42349', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45043', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42352', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42354', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42360', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45051', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45052', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42362', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42365', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42366', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42367', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45059', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4910', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-42370', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42372', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45060', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42376', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42379', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42380', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42383', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42385', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42386', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45063', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42390', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45064', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42393', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42395', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42397', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45074', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-45078', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47933', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45386', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45389', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42488', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42494', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-42497', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45408', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45414', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45416', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45081', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42407', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45087', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42418', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45092', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45094', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42419', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4242', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42420', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42421', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42424', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42427', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45102', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45104', 5.2, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-42429', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-44988', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-44994', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42436', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42439', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42446', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-42451', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42454', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45111', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-45115', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45116', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45117', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45224', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45226', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-42462', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45229', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42466', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45252', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45255', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45258', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45260', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42470', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45281', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45290', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45293', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45310', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-45326', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42474', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-45339', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45342', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-45357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45379', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45385', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42478', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45406', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45442', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-45444', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45445', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45446', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45447', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45448', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45449', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4255', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-47934', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-41550', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41553', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41554', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41555', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41556', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2021-41557', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-3911', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41558', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41559', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-4156', 4.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:H'),
('CVE-2021-41560', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41561', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41562', 4.2, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:H'),
('CVE-2022-3912', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41564', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2021-41565', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41567', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41568', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2021-41569', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-3913', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4911', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-39135', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4157', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41570', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39136', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41571', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41573', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39137', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41578', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47935', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47936', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4794', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47945', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4795', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-47951', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-47952', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4796', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-47966', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39958', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42076', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-39959', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3996', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39960', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39974', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42079', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39975', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39976', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39977', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4208', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39978', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42080', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42081', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42082', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42083', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39987', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39988', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39989', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-3999', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2021-42084', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40000', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40001', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40002', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40004', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-42088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42089', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40009', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40011', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42092', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40026', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40029', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40032', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42094', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40036', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42095', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-40037', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4004', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-42096', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-40043', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42097', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-40044', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42098', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40047', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42099', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40048', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40049', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42101', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42102', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42103', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42104', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4005', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40050', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42105', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42106', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42107', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42108', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4260', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45462', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45467', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45470', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45472', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45474', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4262', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45053', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45054', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45055', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45057', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42369', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42371', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42373', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42375', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45061', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42381', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45062', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42389', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42391', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42394', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42396', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45068', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42399', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42400', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41579', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39138', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-4158', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:N/I:N/A:H'),
('CVE-2021-41580', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41581', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-39139', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41583', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41584', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39140', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41585', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-41586', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41587', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-39141', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41588', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-41589', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39142', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39143', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4933', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4936', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39144', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42401', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42404', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42405', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45082', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42408', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42410', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42411', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42412', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42413', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-42414', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-45089', 3.6, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42415', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-45090', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45091', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42109', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42110', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42111', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42112', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42113', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-4008', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-40082', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-40083', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-42115', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-40084', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42116', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42117', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40087', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40088', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-40089', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2023-5476', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47967', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-47968', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4797', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-47977', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4798', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-47983', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-47984', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-47986', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4799', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:L'),
('CVE-2022-47990', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4800', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-48006', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48007', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48008', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4801', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-48010', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48011', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48012', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48013', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48019', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4802', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-48020', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48021', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48022', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-48023', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4803', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4804', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4805', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4806', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-48063', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-48064', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-48065', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4807', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-48074', 3.4, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:L'),
('CVE-2022-48077', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-48078', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48079', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4808', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48082', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48085', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4809', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48090', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-48091', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48093', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48094', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4810', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4811', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-48110', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48111', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48114', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48115', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-48116', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-48118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4812', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-48120', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4813', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4814', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-42463', 5.9, 'CVSS:3.1/AV:A/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45228', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42465', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45230', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42467', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42468', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45261', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45266', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-45267', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42471', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2021-45288', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45292', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42473', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45325', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45337', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-42475', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42477', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45387', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45394', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42496', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45411', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45417', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45422', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45423', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45429', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45435', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45440', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45441', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45451', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45452', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4258', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45456', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45457', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45459', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2021-41590', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-41591', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2023-4944', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41592', 5.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:H'),
('CVE-2022-39145', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4945', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41593', 4.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:H/A:L'),
('CVE-2023-4948', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2021-41594', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4950', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39146', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4951', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41595', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4959', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2023-4963', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41596', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2023-4965', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39147', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41597', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-41598', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-39148', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4966', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-41599', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4973', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-4160', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4974', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-39149', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-3915', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-4977', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2023-4978', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4912', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42706', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42707', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4271', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-45486', 1.4, 'CVSS:3.1/AV:A/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-39150', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-4979', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-41611', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2023-4980', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-39151', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42724', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42731', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42734', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42746', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42749', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42753', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45482', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-45483', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4913', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-40122', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-40123', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42135', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2022-40128', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-42136', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-40131', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-40132', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-4214', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2023-5477', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-42715', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42716', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42717', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42718', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-45490', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:N'),
('CVE-2021-45491', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-45492', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42824', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-4283', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4273', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42733', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42735', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42744', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42747', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42751', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4914', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42797', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42799', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4281', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42823', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4286', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42867', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42878', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42888', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42889', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4289', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-42891', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42892', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2021-42216', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42219', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-4222', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42220', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42224', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2023-5478', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-42863', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42880', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42885', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42893', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-4915', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-42899', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42900', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42905', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:H'),
('CVE-2022-4291', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-42916', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42920', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42923', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42924', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42925', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42927', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-42928', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42930', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42931', 1.4, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4916', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42260', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42261', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2021-42262', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2021-42263', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42264', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42265', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2021-42266', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42267', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42268', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42269', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42270', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42271', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42272', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42277', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42292', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42294', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42296', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42298', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2023-5481', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-42932', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42933', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42934', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42935', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42936', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42937', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42938', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42939', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4294', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42940', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42941', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42942', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42943', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42944', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42929', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4293', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-42945', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-42946', 5.2, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:H'),
('CVE-2022-42948', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42949', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42950', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42951', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42954', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42956', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-42960', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-42968', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42969', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-42970', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42971', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42972', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42975', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-42978', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-4298', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42983', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-42985', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42991', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-42993', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4301', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43019', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43021', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43030', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43033', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4304', 3.6, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43045', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43052', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4306', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43062', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43068', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43074', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43078', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43079', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43082', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43085', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4310', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43118', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43120', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43140', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43143', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-4917', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2021-42325', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-42326', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43152', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43162', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43165', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43168', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43170', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43179', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43192', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43212', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43214', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43222', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43223', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43227', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43229', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43230', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43231', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43234', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43237', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4324', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43245', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4325', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43253', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43272', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43279', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43283', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43285', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43288', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4329', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43292', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43293', 5.2, 'CVSS:3.1/AV:P/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:H'),
('CVE-2022-43295', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43305', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43329', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43331', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43343', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43350', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43351', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-43352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43353', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43355', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43363', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4337', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43380', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43381', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43382', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:H/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4918', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43402', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-43407', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43415', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43417', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43420', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43422', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43424', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43426', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43428', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4343', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43436', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43441', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43455', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-43458', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4919', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4920', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2021-42343', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2021-4235', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2021-42357', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2021-42358', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2021-42359', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-4921', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43016', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43017', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43020', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43023', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43034', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43037', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43039', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43040', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43042', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43049', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43051', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43066', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43071', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43076', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4308', 6.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-43083', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43086', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43097', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4311', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43121', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43125', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43127', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4313', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4314', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43144', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43148', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-4315', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43164', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43167', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4317', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43183', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43185', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43196', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:H'),
('CVE-2022-4321', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43215', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43221', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43226', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43228', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43232', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43235', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43236', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43239', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43240', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43242', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43244', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43249', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43250', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43254', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:H'),
('CVE-2022-43256', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43265', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4327', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43275', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43277', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43278', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43281', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4922', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-43304', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4331', 5.2, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:N'),
('CVE-2022-43310', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43320', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43323', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43328', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43330', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43333', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43342', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4335', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43396', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43397', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43401', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-4923', 2.5, 'CVSS:3.1/AV:N/AC:H/PR:H/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-4924', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-43404', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:C/C:H/I:H/A:H'),
('CVE-2022-43408', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43411', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43413', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43414', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43418', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:N/A:N'),
('CVE-2022-4342', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-43423', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43425', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43427', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43429', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43431', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43432', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43434', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43437', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4344', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:N/A:L'),
('CVE-2022-43447', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43449', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43451', 4.0, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:C/C:N/I:H/A:N'),
('CVE-2022-43456', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4346', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-43461', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43462', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43463', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43465', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43467', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43469', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43473', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-4925', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-43483', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43484', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43487', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43491', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:L/A:N'),
('CVE-2022-43492', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43495', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-43499', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4350', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43500', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43504', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4926', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-43506', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43507', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43508', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43509', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4351', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43512', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:N/UI:R/S:U/C:H/I:N/A:N'),
('CVE-2022-43513', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:H/A:N'),
('CVE-2022-43514', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43515', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43516', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43517', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43518', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43519', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4352', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43520', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43523', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43524', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43525', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43526', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43529', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-43530', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43532', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43534', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43535', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43536', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43538', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4354', 6.0, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:H/I:H/A:H'),
('CVE-2022-43541', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43543', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:L/I:L/A:N'),
('CVE-2022-43551', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43556', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43565', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43566', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43567', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43569', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43570', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:N/A:N'),
('CVE-2022-43579', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-43581', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43588', 3.6, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4359', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43591', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-43598', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43600', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43602', 5.9, 'CVSS:3.1/AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-43604', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4927', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4928', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4929', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4930', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4931', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4932', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:L/I:N/A:N'),
('CVE-2022-4933', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4934', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:H/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4935', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4936', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4937', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4938', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4939', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4940', 2.5, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:L/I:L/A:N'),
('CVE-2022-4941', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4942', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4944', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:H/I:H/A:H'),
('CVE-2022-4946', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4948', 1.4, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:N/I:L/A:N'),
('CVE-2022-4949', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4950', 5.9, 'CVSS:3.1/AV:N/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H'),
('CVE-2022-4952', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:N/I:N/A:H'),
('CVE-2022-4953', 2.7, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:C/C:L/I:L/A:N'),
('CVE-2022-4955', 3.6, 'CVSS:3.1/AV:N/AC:L/PR:N/UI:R/S:U/C:N/I:H/A:N'),
('CVE-2022-4956', 5.9, 'CVSS:3.1/AV:L/AC:L/PR:L/UI:N/S:U/C:H/I:H/A:H');

INSERT INTO tmodule_group (name) SELECT ('Security') WHERE NOT EXISTS (SELECT name FROM tmodule_group WHERE LOWER(name) = 'security');

SET @tmodule_name = 'CPU';
SET @tmodule_description = 'CPU';
SET @id_os = 2;

INSERT INTO tmodule_inventory (`id_os`, `name`, `description`, `interpreter`, `data_format`, `code`, `block_mode`,`script_mode`) 
SELECT * FROM (SELECT @id_os id_os, @tmodule_name name, @tmodule_description description, '' interpreter, 'Brand;Clock;Model' data_format, '' code, '0' block_mode, 2 script_mode) AS tmp 
WHERE NOT EXISTS (SELECT name, description FROM tmodule_inventory WHERE name = @tmodule_name and description = @tmodule_description and id_os = @id_os);

SET @tmodule_name = 'RAM';
SET @tmodule_description = 'RAM';
SET @id_os = 2;

INSERT INTO tmodule_inventory (`id_os`, `name`, `description`, `interpreter`, `data_format`, `code`, `block_mode`,`script_mode`) 
SELECT * FROM (SELECT @id_os id_os, @tmodule_name name, @tmodule_description description, '' interpreter, 'Size' data_format, '' code, '0' block_mode, 2 script_mode) AS tmp 
WHERE NOT EXISTS (SELECT name, description FROM tmodule_inventory WHERE name = @tmodule_name and description = @tmodule_description and id_os = @id_os);

SET @tmodule_name = 'NIC';
SET @tmodule_description = 'NIC';
SET @id_os = 2;

INSERT INTO tmodule_inventory (`id_os`, `name`, `description`, `interpreter`, `data_format`, `code`, `block_mode`,`script_mode`) 
SELECT * FROM (SELECT @id_os id_os, @tmodule_name name, @tmodule_description description, '' interpreter, 'NIC;Mac;Speed' data_format, '' code, '0' block_mode, 2 script_mode) AS tmp 
WHERE NOT EXISTS (SELECT name, description FROM tmodule_inventory WHERE name = @tmodule_name and description = @tmodule_description and id_os = @id_os);

SET @tmodule_name = 'Software';
SET @tmodule_description = 'Software';
SET @id_os = 2;

INSERT INTO tmodule_inventory (`id_os`, `name`, `description`, `interpreter`, `data_format`, `code`, `block_mode`,`script_mode`) 
SELECT * FROM (SELECT @id_os id_os, @tmodule_name name, @tmodule_description description, '' interpreter, 'PKGINST;VERSION;NAME' data_format, '' code, '0' block_mode, 2 script_mode) AS tmp 
WHERE NOT EXISTS (SELECT name, description FROM tmodule_inventory WHERE name = @tmodule_name and description = @tmodule_description and id_os = @id_os);

SET @tmodule_name = 'Security';
SET @tmodule_description = 'Hardening&#x20;plugin&#x20;for&#x20;security&#x20;compliance&#x20;analysis';
SET @id_os = 1;

INSERT INTO tmodule_inventory (`id_os`, `name`, `description`, `interpreter`, `data_format`, `code`, `block_mode`,`script_mode`)
SELECT * FROM (SELECT @id_os id_os, @tmodule_name name, @tmodule_description description, '' interpreter, 'ID:STATUS' data_format, '' code, '0' block_mode, 2 script_mode) AS tmp 
WHERE NOT EXISTS (SELECT name, description FROM tmodule_inventory WHERE name = @tmodule_name and description = @tmodule_description and id_os = @id_os);

SET @tmodule_name = 'Security';
SET @tmodule_description = 'Hardening&#x20;plugin&#x20;for&#x20;security&#x20;compliance&#x20;analysis';
SET @id_os = 9;

INSERT INTO tmodule_inventory (`id_os`, `name`, `description`, `interpreter`, `data_format`, `code`, `block_mode`,`script_mode`)
SELECT * FROM (SELECT @id_os id_os, @tmodule_name name, @tmodule_description description, '' interpreter, 'ID:STATUS' data_format, '' code, '0' block_mode, 2 script_mode) AS tmp 
WHERE NOT EXISTS (SELECT name, description FROM tmodule_inventory WHERE name = @tmodule_name and description = @tmodule_description and id_os = @id_os);
INSERT INTO tmodule_group (name) SELECT ('Security') WHERE NOT EXISTS (SELECT name FROM tmodule_group WHERE LOWER(name) = 'security');

ALTER TABLE tagente_modulo ADD COLUMN `last_compact` TIMESTAMP NOT NULL DEFAULT 0;

UPDATE `tevent_alert` ea INNER JOIN `tevent_rule` er ON ea.id = er.id_event_alert SET disabled=1 WHERE er.log_agent IS NOT NULL OR er.log_content IS NOT NULL OR er.log_source IS NOT NULL;

ALTER TABLE `tnetwork_explorer_filter`
MODIFY COLUMN `id` INT NOT NULL AUTO_INCREMENT;

-- Add messaging alerts

SET @command_name = 'Pandora&#x20;Google&#x20;chat';
SET @action_name = 'Pandora&#x20;Google&#x20;chat';

-- Get command ID in case it exists
SET @id_command = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
INSERT IGNORE INTO `talert_commands` (`id`, `name`, `command`, `description`, `internal`, `fields_descriptions`, `fields_values`) VALUES (@id_command, @command_name, '/usr/share/pandora_server/util/plugin/pandora-gchat-cli&#x20;-u&#x20;&quot;_field1_&quot;&#x20;-d&#x20;&quot;_field2_&quot;&#x20;-t&#x20;&quot;_field3_&quot;&#x20;-D&#x20;&quot;_field4_&quot;', 'Send&#x20;messages&#x20;using&#x20;Google&#x20;chat&#x20;API', 0, '["Google&#x20;chat&#x20;webhook&#x20;URL","Data&#x20;in&#x20;coma&#x20;separate&#x20;keypairs","Title","Description"]', '["","","",""]');

-- Get command ID again in case it has been created
SET @id_command = NULL;
SET @id_action = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
SELECT @id_action := `id` FROM `talert_actions` WHERE `name` = @action_name;
INSERT IGNORE INTO `talert_actions` (`id`, `name`, `id_alert_command`, `field1`, `field2`, `field3`, `field4`, `field5`, `field6`, `field7`, `field8`, `field9`, `field10`, `id_group`, `action_threshold`, `field1_recovery`, `field2_recovery`, `field3_recovery`, `field4_recovery`, `field5_recovery`, `field6_recovery`, `field7_recovery`, `field8_recovery`, `field9_recovery`, `field10_recovery`) VALUES (@id_action, @action_name, @id_command, "", "data=_data_", "[PANDORA] Alert FIRED on _agent_ / _module_", "_agent_ | _module_ | _data_ | _timestamp_", "", "", "", "", "", "", 0, 0, "", "data=_data_", "[PANDORA] Alert RECOVERED on _agent_ / _module_", "_agent_ | _module_ | _data_ | _timestamp_", "", "", "", "", "", "");

SET @command_name = 'Pandora&#x20;Slack';
SET @action_name = 'Pandora&#x20;Slack';

-- Get command ID in case it exists
SET @id_command = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
INSERT IGNORE INTO `talert_commands` (`id`, `name`, `command`, `description`, `internal`, `fields_descriptions`, `fields_values`) VALUES (@id_command, @command_name, '/usr/share/pandora_server/util/plugin/pandora-slack-cli&#x20;-t&#x20;&quot;TOKEN&quot;&#x20;-d&#x20;&quot;_field1_&quot;&#x20;-c&#x20;&quot;_field2_&quot;&#x20;-e&#x20;&quot;_field3_&quot;&#x20;-T&#x20;&quot;_field4_&quot;&#x20;-D&#x20;&quot;_field5_&quot;', 'Send&#x20;messages&#x20;using&#x20;Slack&#x20;API', 0, '["Data&#x20;in&#x20;coma&#x20;separate&#x20;keypairs","Slack&#x20;channel&#x20;id/name","Title&#x20;emoji","Title","Description"]', '["","",":red_circle:,Red&#x20;circle;:green_circle:,Green&#x20;circle","",""]');

-- Get command ID again in case it has been created
SET @id_command = NULL;
SET @id_action = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
SELECT @id_action := `id` FROM `talert_actions` WHERE `name` = @action_name;
INSERT IGNORE INTO `talert_actions` (`id`, `name`, `id_alert_command`, `field1`, `field2`, `field3`, `field4`, `field5`, `field6`, `field7`, `field8`, `field9`, `field10`, `id_group`, `action_threshold`, `field1_recovery`, `field2_recovery`, `field3_recovery`, `field4_recovery`, `field5_recovery`, `field6_recovery`, `field7_recovery`, `field8_recovery`, `field9_recovery`, `field10_recovery`) VALUES (@id_action, @action_name, @id_command, "data=_data_", "", ":red_circle:", "[PANDORA] Alert FIRED on _agent_ / _module_", "_agent_ | _module_ | _data_ | _timestamp_", "", "", "", "", "", 0, 0, "data=_data_", "", ":green_circle:", "[PANDORA] Alert RECOVERED on _agent_ / _module_", "_agent_ | _module_ | _data_ | _timestamp_", "", "", "", "", "");

SET @command_name = 'Pandora&#x20;Telegram';
SET @action_name = 'Pandora&#x20;Telegram';

-- Get command ID in case it exists
SET @id_command = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
INSERT IGNORE INTO `talert_commands` (`id`, `name`, `command`, `description`, `internal`, `fields_descriptions`, `fields_values`) VALUES (@id_command, @command_name, '/usr/share/pandora_server/util/plugin/pandora-telegram-cli&#x20;-t&#x20;&quot;TOKEN&quot;&#x20;-c&#x20;&quot;_field1_&quot;&#x20;-m&#x20;&quot;_field2_&quot;', 'Send&#x20;messages&#x20;using&#x20;Telegram&#x20;API', 0, '["Chat&#x20;ID","Message"]', '["",""]');

-- Get command ID again in case it has been created
SET @id_command = NULL;
SET @id_action = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
SELECT @id_action := `id` FROM `talert_actions` WHERE `name` = @action_name;
INSERT IGNORE INTO `talert_actions` (`id`, `name`, `id_alert_command`, `field1`, `field2`, `field3`, `field4`, `field5`, `field6`, `field7`, `field8`, `field9`, `field10`, `id_group`, `action_threshold`, `field1_recovery`, `field2_recovery`, `field3_recovery`, `field4_recovery`, `field5_recovery`, `field6_recovery`, `field7_recovery`, `field8_recovery`, `field9_recovery`, `field10_recovery`) VALUES (@id_action, @action_name, @id_command, "", "[PANDORA] Alert FIRED on _agent_ / _module_ / _tiemstamp_ / _data_", "", "", "", "", "", "", "", "", 0, 0, "", "[PANDORA] Alert RECOVERED on _agent_ / _module_ / _tiemstamp_ / _data_", "", "", "", "", "", "", "", "");

SET @command_name = 'Pandora&#x20;ilert';
SET @action_name = 'Pandora&#x20;ilert';

-- Get command ID in case it exists
SET @id_command = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
INSERT IGNORE INTO `talert_commands` (`id`, `name`, `command`, `description`, `internal`, `fields_descriptions`, `fields_values`) VALUES (@id_command, @command_name, '/usr/share/pandora_server/util/plugin/pandora_ilert&#x20;-a&#x20;&quot;API_KEY&quot;&#x20;-t&#x20;&quot;_field1_&quot;&#x20;-k&#x20;&quot;_field2_&quot;&#x20;-T&#x20;&quot;_field3_&quot;&#x20;-d&#x20;&quot;_field4_&quot;&#x20;-A&#x20;&quot;_agentname_&quot;&#x20;-m&#x20;&quot;_module_&quot;&#x20;-p&#x20;&quot;_alert_text_severity_&quot;&#x20;-D&#x20;&quot;_data_&quot;&#x20;-C&#x20;&quot;_timestamp_&quot;', 'Send&#x20;SMS&#x20;using&#x20;ilert&#x20;API:&#x20;https://docs.ilert.com/integrations/pandorafms/', 0, '["Event&#x20;type","Event&#x20;title","Title","Description"]', '["alert,Alert;resolved,Resolved","","",""]');

-- Get command ID again in case it has been created
SET @id_command = NULL;
SET @id_action = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
SELECT @id_action := `id` FROM `talert_actions` WHERE `name` = @action_name;
INSERT IGNORE INTO `talert_actions` (`id`, `name`, `id_alert_command`, `field1`, `field2`, `field3`, `field4`, `field5`, `field6`, `field7`, `field8`, `field9`, `field10`, `id_group`, `action_threshold`, `field1_recovery`, `field2_recovery`, `field3_recovery`, `field4_recovery`, `field5_recovery`, `field6_recovery`, `field7_recovery`, `field8_recovery`, `field9_recovery`, `field10_recovery`) VALUES (@id_action, @action_name, @id_command, "alert", "", "[PANDORA] Alert FIRED on _agent_ / _module_", "_agent_ | _module_ | _data_ | _timestamp_", "", "", "", "", "", "", 0, 0, "resolved", "", "[PANDORA] Alert RECOVERED on _agent_ / _module_", "_agent_ | _module_ | _data_ | _timestamp_", "", "", "", "", "", "");

SET @command_name = 'Pandora&#x20;Vonage';
SET @action_name = 'Pandora&#x20;Vonage';

-- Get command ID in case it exists
SET @id_command = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
INSERT IGNORE INTO `talert_commands` (`id`, `name`, `command`, `description`, `internal`, `fields_descriptions`, `fields_values`) VALUES (@id_command, @command_name, '/usr/share/pandora_server/util/plugin/pandora_vonage&#x20;-a&#x20;&quot;API_KEY&quot;&#x20;-s&#x20;&quot;SECRET&quot;&#x20;-f&#x20;&quot;FROM_ALIAS&quot;&#x20;-n&#x20;&quot;_field1_&quot;&#x20;-m&#x20;&quot;_field2_&quot;', 'Send&#x20;SMS&#x20;using&#x20;Vonage&#x20;API:&#x20;https://www.vonage.com/communications-apis/sms/', 0, '["Phone&#x20;number","Message"]', '["",""]');

-- Get command ID again in case it has been created
SET @id_command = NULL;
SET @id_action = NULL;
SELECT @id_command := `id` FROM `talert_commands` WHERE `name` = @command_name;
SELECT @id_action := `id` FROM `talert_actions` WHERE `name` = @action_name;
INSERT IGNORE INTO `talert_actions` (`id`, `name`, `id_alert_command`, `field1`, `field2`, `field3`, `field4`, `field5`, `field6`, `field7`, `field8`, `field9`, `field10`, `id_group`, `action_threshold`, `field1_recovery`, `field2_recovery`, `field3_recovery`, `field4_recovery`, `field5_recovery`, `field6_recovery`, `field7_recovery`, `field8_recovery`, `field9_recovery`, `field10_recovery`) VALUES (@id_action, @action_name, @id_command, "", "[PANDORA] Alert FIRED on _agent_ / _module_ / _tiemstamp_ / _data_", "", "", "", "", "", "", "", "", 0, 0, "", "[PANDORA] Alert RECOVERED on _agent_ / _module_ / _tiemstamp_ / _data_", "", "", "", "", "", "", "", "");

-- Insert new Pandora vulscan APP
SET @short_name = 'pandorafms.vulnscan';
SET @name = 'Vulnerability&#x20;Scanner';
SET @section = 'app';
SET @description = 'Pandora&#x20;FMS&#x20;Vulnerability&#x20;Scanner.&#x20;Scans&#x20;the&#x20;network&#x20;looking&#x20;for&#x20;known&#x20;software&#x20;vulnerabilities.';

SET @version = '1.0';
INSERT IGNORE INTO tdiscovery_apps (id_app, short_name, name, section, description, version) VALUES ('', @short_name, @name, @section, @description, @version);
SELECT @id_app := id_app FROM tdiscovery_apps WHERE short_name = @short_name;

-- Insert into tdiscovery_apps_scripts
INSERT IGNORE INTO tdiscovery_apps_scripts (id_app, macro, value) VALUES (@id_app, '_exec1_', 'bin/pandora_vulnscan');

-- Insert into tdiscovery_apps_executions
INSERT IGNORE INTO tdiscovery_apps_executions (id_app, execution) VALUES (@id_app, '&#039;_exec1_&#039;&#x20;&#039;__pandoraServerConf__&#039;&#x20;&#039;_agentGroups_&#039;&#x20;-t&#x20;_numThreads_');

COMMIT;
